<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<%@ page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page language="java"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ page import ="com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>

			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.9.3/dijit/themes/dijit.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.9.3/dijit/themes/dijit_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.9.3/dijit/themes/claro/claro.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.9.3/dijit/themes/claro/claro_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.9.3/dojox/grid/resources/Grid.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.9.3/dojox/grid/resources/Grid_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.9.3/dojox/grid/resources/claroGrid.css"/>
			<link rel="stylesheet" href="/expensemap/css/spendGridPageStyle.css"/>
			
			<style type="text/css">
				body {
					font-size: 11px !important;
					font-family: Arial, Helvetica, sans-serif !important;
					font-weight: normal !important;
				}
			</style>
			
	<script type="text/javascript">
		dojoConfig = {
			baseUrl : "/expensemap/jsp/javascript/idx/dojo_1.9.3/dojo/"
				
		};
	</script>

	<script type="text/javascript" src="${pageContext.servletContext.contextPath}/js/jquery-1.4.2.min.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/idx/dojo_1.9.3.3/dojo/dojo.js" data-dojo-config="parseOnLoad: true" ></script>

	<script type="text/javascript">
	
			// List to store available users 
			var availableUsers = [];
			// List to store available bookmarks 
			var availableBookmarks = [];
										
			dojo.require("dojo/domReady");
			dojo.require("dojo/store/Memory");
			dojo.require("dojo/data/ObjectStore");
			dojo.require("dojox/grid/DataGrid");
			dojo.require("dojo/_base/xhr");			
			dojo.require("dijit/form/Button");
			dojo.require("dijit/form/Select");		
			dojo.require("dijit/form/TextBox");		
			dojo.require("dijit/form/DateTextBox");
			dojo.require("dijit/form/ValidationTextBox");
			dojo.require("dijit/form/FilteringSelect");
			
			dojo.ready(function(){
				//alert('hello');
				initialization();
				//dojo.connect(dijit.byId("bookmarkSelection"), "onChange", populateBookmarks);
				//dojo.connect(dijit.byId("userSelection"), "onChange", populateUsers);

			});
			
			function initialization(){		
								
				<c:if test="${!empty availableBookmarks}">
				<c:forEach items="${availableBookmarks}" var="bookmark">
					addOptionToList('${bookmark.id}', '${bookmark.name}', "bookmarkSelection", availableBookmarks);
				</c:forEach>
				</c:if>
				
				<c:if test="${!empty availableUsers}">
				<c:forEach items="${availableUsers}" var="user">
					//addOptionToList('${user.id}', '${user.name}', "userInput", availableUsers);
					console.log('${user.id}' + ": " + '${user.name}');
				</c:forEach>
				</c:if>			
				
			}	
			
			function addOptionToList(id, name, target, list) {
				var option = dojo.doc.createElement('option');
				option.value = id;
				option.label = name;
				option.innerHTML = name;
				dojo.byId(target).appendChild(option);
				list.push(option);
			}
			
	</script>		
	
<html>
<head>

<%
		ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);	
		
%>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />


<TITLE><spring:message code="ui.label.create.PGMRequest"/></TITLE>

<LINK REL="stylesheet" TYPE="text/css" 	HREF="/expensemap/jsp/stylesheets/popupStyle.css">
	

<script language="javascript">

function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

function validateString(){	
	var name = document.getElementById("name").value;
	var description = document.getElementById("description").value;
	var objectToSetFocus;
	if(trim(name)=='' ||trim(description)==''){		
		msg = '&nbsp;&nbsp;<spring:message code="ui.message.Please.fill.in.the.following.field.s.." />&nbsp;';
		firstFieldName = '<spring:message code="ui.label.Name"/>';
		secondFieldName = '<spring:message code="ui.label.Description"/>';
		errorText = "<table border=0 cellpadding=0 cellspacing=0><tr  class=ft12px><td align=left class=error>"+msg;
		isNameEmpty =false;
		if(trim(name)==''){
			errorText = errorText + firstFieldName;
			isNameEmpty = true;
			objectToSetFocus = document.getElementById("name");
		}
		if(trim(description)==''){
			if(isNameEmpty){
				errorText = errorText + ", ";
				objectToSetFocus = document.getElementById("name");
			}else{
				objectToSetFocus = document.getElementById("description");
			}
			errorText = errorText + secondFieldName;		
		}
		errorText=errorText+"</td></tr></table>";	
		displayErrorText(objectToSetFocus,errorText);
		return false;
	}

	encodeDesc = encode(trim(description));
	encodeName = encode(trim(name));
	
	if(encodeDesc.length >255||encodeName.length >255){			
			errorText = "<table border=0 cellpadding=0 cellspacing=0><tr  class=ft12px><td align=left class=error>";			
			if(encodeDesc.length >255){
				msg = '&nbsp;&nbsp;<spring:message code="ui.message.description.is.too.long.please.enter.maximum.255.characters.in.description.field"/>';
				objectToSetFocus = document.getElementById("description");
				errorText = errorText +msg;
			}else{
				msg = '&nbsp;&nbsp;<spring:message code="ui.message.name.is.too.long.please.enter.maximum.255.characters.in.name.field"/>';
				objectToSetFocus = document.getElementById("name");
				errorText = errorText +msg;
			}
			errorText=errorText+".</td></tr></table>";	
			displayErrorText(objectToSetFocus,errorText);
			return false;
	}
      return true;
}

function  encode( value) {
	if (value.length == 0) {
		return value;
	}
	value = value.replace(/</gi,'&lt;');
	value = value.replace(/>/gi,'&gt;');
	value = value.replace(/\"/gi,'&quot;');
	value = value.replace(/\'/gi,'&#39;');
	value = value.replace(/!/gi,'&#33;');		
	value = value.replace(/\[/gi,'&#91;');
	value = value.replace(/\]/gi,'&#93;');
	value = value.replace(/\{/gi,'&#123;');
	value = value.replace(/\}/gi,'&#125;');
	value = value.replace(/\(/gi,'&#40;');
	value = value.replace(/\)/gi,'&#41;');

	return value;
}

function displayErrorText(objectToSetFocus,errorText){	
		objectToSetFocus.focus();
		document.getElementById("validateMessageDiv").innerHTML=errorText;
		document.getElementById("serverValidateMessageTr").style.display='none';
		document.getElementById("validateMessageTr").style.display='block';
}

function save(){

	if(validateString()){
	
			
		if(document.getElementById("saveTypeNew") != null && 
			         document.getElementById("saveTypeNew").checked == true){

			document.pgmRequestBean.action='save.shtm?action=save';
		    document.pgmRequestBean.submit();		

		}else if(document.getElementById("saveTypeOld") != null && 
							document.getElementById("saveTypeOld").checked == true)  {

			  	document.pgmRequestBean.action='save.shtm?action=update';
			    document.pgmRequestBean.submit();	
		}
		else
		{
			 document.pgmRequestBean.action='save.shtm?action=rename';	 
			 document.pgmRequestBean.submit();
		}

	}
	return false;
}

function onload () {
  document.pgmRequestBean.name.focus();
  refreshListPageForRename();
  document.getElementById("serverValidateMessageTr").style.display='block';
}

function refreshListPageForRename() {
		
	if (${pgmRequestBean.message.messageValue  == 'SUCESSFULLY_RENAMED'}) {
		if (window.opener.document.forms["bookMarkListForm"] != null) {
			window.opener.document.forms["bookMarkListForm"].action="/expensemap/showBookmarkListPage.xhtm";
			window.opener.document.forms["bookMarkListForm"].submit();
		}
		else if (window.opener.document.forms["allDataViewsForm"] != null) {
			window.opener.document.forms["allDataViewsForm"].submit();				
		}	
		window.close();
	}
}

</script>

</head>

<body class="claro">

<jsp:include page="/jsp/includes/simplePageHeader.jsp" />

<form:form commandName="pgmRequestBean" cssClass="form"
	name="pgmRequestBean" id="pgmRequestBean">
	<form:errors cssClass="errorBox" />

	<table border=0 cellpadding=2 align="center" cellspacing=0>
		<tr id="validateMessageTr" style="display: none">
			<td align="left" class="error">
			<div id="validateMessageDiv"></div>
			</td>
		</tr>

		<c:if test='${pgmRequestBean.message.messageType eq "Message"}'>
			<script language="javascript">
				window.close();
				window.opener.showBKConfirmation('${pgmRequestBean.message.messageValue}');
			</script>
		</c:if>

		<tr class="ft12px" id="serverValidateMessageTr" style="display: none">
			<jsp:include page="../message.jsp">
				 	<jsp:param name="messageType" value='${pgmRequestBean.message.messageType}'/>	
				 	<jsp:param name="messageValue" value='${pgmRequestBean.message.messageValue}'/>	
			</jsp:include>
	    </tr>


	</table>

	<table border=0 class="popupTable" align="center">
		
		<tr>
			<td width="20%" class="reportTitle" align="left" nowrap><spring:message code="ui.label.create.PGMRequest" /></td>
			<td width="80%" align="right"><A TARGET="_blank" HREF='${helpURL}'><IMG 
				SRC="/expensemap/jsp/images/help.gif" WIDTH="16" HEIGHT="16"
				BORDER="0" title="<spring:message	code='ui.label.Help' />" /></a></td>
		</tr>
	
		<tr>
			<td colspan="2">
			<hr noshade size="1">
			</td>
		</tr>

		<tr>
			<td width="20%" class="labelStyle"><b><spring:message code="ui.label.PGM.Request.Type" /></b></td>
			<td width="80%" class="labelStyle"><b><spring:message code="ui.label.PGM.Request.Type.Spend.Opportunity" /></b></td>
		</tr>	

		<tr>
			<td width="20%" class="labelStyle"><b><spring:message code="ui.label.Name" /></b></td>
			<td width="80%" class="labelStyle"><form:input path="name" size="30" /></td>
		</tr>		
		
		<tr>
			<td width="20%" class="labelStyle"><b><spring:message code="ui.label.PGM.Requested.Due.date" /></b></td>
			<td width="80%">
				<input type="text" name="requestDueDate" id="search_FromDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>
			</td>
		</tr>	
		
		<tr>
			<td width="20%" class="labelStyle"><b><spring:message code="Select.Bookmark" /></b></td>
			<td width="80%" class="labelStyle">
			<select  name="bookmarkId" id="bookmarkId" data-dojo-type="dijit.form.FilteringSelect">  
					<c:forEach items="${availableBookmarks}" var="bookmark">
						<option value="${bookmark.id}">${bookmark.name}</option>
					</c:forEach>
			</select >
		</tr>
		
		<tr>
			<td class="labelStyle"><b><spring:message code="ui.label.Description" />:</b></td>		
			<td align="left"><form:textarea path="description"  rows="5" id="description" cols="50" /></td>
		</tr>
		

		
		<tr>
			<td class="labelStyle"><b><spring:message code="ui.label.PGM.Assigned.User" /></b></td>		
			<td align="left">
				<select  name="assignedUserSSOId" id="assignedUserSSOId" data-dojo-type="dijit.form.FilteringSelect">  
					<c:forEach items="${availableUsers}" var="user">
						<option value="${user.ssoId}">${user.name}</option>
					</c:forEach>
				</select >			
			</td>
		</tr>

		<tr>
			<td colspan="2">
			<hr noshade size="1">
			</td>
		</tr>
		

		<tr>
			<td colspan="2" align="center"><input type="submit" name='submit' value='<spring:message code="button.submit" />' onclick="return save();">
			<input type="button" name='cancel' value='<spring:message code="ui.label.Cancel"/>' onclick="self.close()">&nbsp;&nbsp;
			</td>
		</tr>
		
	</table>
	
	<form:hidden path="message" id="message"/>
	
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>

</form:form>
</body>
</html>
