<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@ page import="com.zeborg.expensemap.web.*"%>
<%@ page import="com.zeborg.util.EncodeUtil" %>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import ="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil" %>
<%@ page import="com.zeborg.expensemap.view.*, com.emptoris.viewer.util.CSRFHelper" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%//No client side caching
    WebUtil.addNoCache(response);
%>

<%	
	ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);	
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("PrefsTransactionContainerFormProcessor",zs.getUser().getLocale());  	
%>
<HTML>
<HEAD>
	<fmt:setBundle basename="ExpensemapMessagesBundle" />
	<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>
	<TITLE><%= ExpenseMapAppProperties.getExpensemapTitle()%> <fmt:message key="ui.label.transaction.preferences"/></TITLE>
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/preferences.css"> 
	<link rel='shortcut icon' href='/expensemap/jsp/images/favicon.ico' type='image/x-icon'>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/ibmjs/idx/themes/oneui/oneui.css"/>
	<style type="text/css">
		.dp { width: 250px; height: 170px; }
|		#datasetSelection .dijitButtonNode, #dimensionSelection .dijitButtonNode {
			width: 200px;
		}
		.oneui .dijitButton .dijitButtonNode { min-width: 50px; }
		body { border: 1px solid #ccc; margin: 0 5px; }
		#availableMeasures option,  #viewableFields option { font-family: Arial,Helvetica,sans-serif !important; font-size: 11px !important; }
		#mainContentDiv { width: 800px }
		#hoursTD { padding-left: 3px; } 
		.tableTRFirstTD { width: 10%; white-space: nowrap; }
		#titleGroupA, #viewableFields { height: 300px; width: 300px; overflow: auto; }
		select, input, textarea, button {font: 99% arial,helvetica,clean,sans-serif;}
		body, table { font-family: Arial, Helvetica, sans-serif !important; font-size: 11px !important; }
}
	</style>
	<script src='/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js' data-dojo-config='parseOnLoad: true'></script>
	<script type="text/javascript">
	dojo.require("dojox.widget.TitleGroup");
	dojo.require("dijit.TitlePane");
	dojo.require("dijit.form.Button");
	require(["dojo/ready",
			 "dojo/parser", 
			 "dijit/form/MultiSelect"], function(ready) {
			ready(function() {
			populateAttributes();
		});
	});
	
	function moveup(source){
		var i;
		for (i=0; i<source.options.length; i++) {
			if (source.options[i].selected) {
				var sc=i;
				if(sc>=1){
					var text1=source.options[sc].text;
					var value1=source.options[sc].value;
					var text2=source.options[sc-1].text;
					var value2=source.options[sc-1].value;
					source.options[sc].text=text2;
					source.options[sc].value=value2;
					source.options[sc].label=text2;
					source.options[sc-1].text=text1;
					source.options[sc-1].value=value1;
					source.options[sc-1].label=text1;
					source.options[sc-1].selected=true;
					source.options[sc].selected=false;
				}
			}
		}
	}

	function movedown(source){
		var i,sc=0;
		for (i=source.options.length-1; i>=0; i--) {
			if (source.options[i].selected) {
				sc=i;
				if(sc<(source.options.length-1)){
					var text1=source.options[sc].text;
					var value1=source.options[sc].value;
					var text2=source.options[sc+1].text;
					var value2=source.options[sc+1].value;
					source.options[sc].text=text2;
					source.options[sc].value=value2;
					source.options[sc].label=text2;
					source.options[sc+1].text=text1;
					source.options[sc+1].value=value1;
					source.options[sc+1].label=text1;
					source.options[sc+1].selected = true;
					source.options[sc].selected = false;
				}
			}
		}
	}

	function movetopbottom(source, action) { 
		
		var elements = new Array();
		for (var i=0; i<source.length; i++) {
			if(action == "top"){
				if (source[i].selected) {
					elements[elements.length] = new Array(source[i].text, source[i].value, source[i].selected);
				}
			}else if(action == "bottom"){
				if (!source[i].selected) {
					elements[elements.length] = new Array(source[i].text, source[i].value, source[i].selected);
				}
			}
		}
		for (i=0; i<source.length; i++) {
			if(action == "top"){
				if (!source[i].selected) {
					elements[elements.length] = new Array(source[i].text, source[i].value, source[i].selected);
				}
			}else if(action == "bottom"){
				if (source[i].selected) {
					elements[elements.length] = new Array(source[i].text, source[i].value, source[i].selected);
				}
			}		
			
		}
		if(action == "top"){
			for (i=0; i<source.length; i++) {
				source[i].text = elements[i][0];
				source[i].value = elements[i][1];
				source[i].label = elements[i][0];
				source[i].selected = elements[i][2];
			}
		}else if(action == "bottom"){
			for (i=source.length-1; i>-1; i--) {
				source[i].text = elements[i][0];
				source[i].value = elements[i][1];
				source[i].label = elements[i][0];
				source[i].selected = elements[i][2];
			}
		}
	}
	
	var dimensions;
	var dimensionsLabels = new Array();
	var key;
	function populateAttributes() {
			// Ajax call to get available attributes for all dimensions and fact
			 jQuery.ajax({
			        url:"/expensemap/showTranAttributeList.jxhtm",
					type: "POST",
			        dataType:"json",
			        success: function(data) { 
			        	dimensions = data.availableAttributes;
						var size = getMapSize(dimensions);
					  	//Dynamically add Pane to group
						for(var i=0; i< size;i++) {
							var group = dijit.byId("titleGroupA");
						  	id = "group" + i;
							var tp = new dijit.TitlePane({ open:false, title:dimensionsLabels[i], id: id});
						  	group.addChild(tp);
						 	selectboxId = "selectbox" + i;
						  	var selectbox = new dijit.form.MultiSelect({ id: selectboxId });
							selectbox.placeAt(tp.containerNode);
							dojo.attr(dojo.byId(selectboxId), "class", "dp");
							key	= dimensionsLabels[i];
							var availableDim = dimensions[key]; 
						  	for(var j in availableDim) {
								var option = dojo.doc.createElement('option');
								if (availableDim[j].value == undefined){
									continue;
							}
							option.value = availableDim[j].value;
							option.label = availableDim[j].label;
							option.innerHTML = availableDim[j].label;
							option.setAttribute("pid",i);
							dojo.byId(selectboxId).appendChild(option);
							}
						}
						
						var viewableFields = data.viewableAttributes.viewableAttributes;
						for(var i in viewableFields) {
			            	var option = dojo.doc.createElement('option');
							if (viewableFields[i].value == undefined){
									continue;
							}
			            	option.value = viewableFields[i].value;
							option.label = viewableFields[i].label;
							option.innerHTML = viewableFields[i].label;
							var j= getPid(option.label,dimensionsLabels);
							option.setAttribute("pid",j);
			            	dojo.byId("viewableFields").appendChild(option);
			            }
					}
			    });
		}
		
		function getPid(label,obj){
		label= label.substring(0, label.lastIndexOf("."));
			for (i in obj) {
				if(obj[i] == label)
					return i;
			}
			
		}
		
		function getMapSize(obj) {
			var size = 0, key;
			for (key in obj) {
				if (obj.hasOwnProperty(key)) size++;
					dimensionsLabels.push(key);
				}
			return size;
		};
		
		function moveItemsToRight() {
			require(["dojo/query"], function(query){
				query(".dp > option").forEach(function(option) {
					if (option.selected) {
						i = option.getAttribute("pid");
						selectboxId = "selectbox" + i;
						dijit.byId("viewableFields").addSelected(dijit.byId(selectboxId));
					}
				});
			
			});
		}
		
		function moveItemsToLeft() {
			require(["dojo/query"], function(query){
				query("#viewableFields > option").forEach(function(option) {
					if (option.selected) {
						var i = option.getAttribute("pid");
						var viewOption = dojo.doc.createElement('option');
						viewOption.label = option.label;
						viewOption.innerHTML = option.label;
						viewOption.value = option.value;
						selectboxId = "selectbox" + i;
						viewOption.setAttribute("pid",i);
						dojo.byId(selectboxId).appendChild(viewOption);
						dijit.byId("dynamic").addSelected(dijit.byId("viewableFields"));
					}
				});
			});
		}
		
		function saveAttributes() {
			var callFrom = '${ param.source }';
			var source =dojo.byId('viewableFields');
			if(source.options.length == 0){
				restoreAttributes();
				return;
			}
			for (var i =0;i<source.options.length;i++) {
				source.options[i].selected = true;
			}
			form = dojo.byId("transactionPreferencesForm");
			form.action = "/expensemap/saveTransactionAttributeList.xhtm";
			if(callFrom == "transaction"){
				document.getElementById('source').value= "transaction";
				document.getElementById('actionSave').value= "save";
			}
			form.submit();
			
		}
		
		function windowStatus() {
			var action='${ param.actionSave }';
			if(action == "save"){
				windowreload();
				window.close();
			}
		} 
		
		function windowreload(){
			var parentHref;
			var frm = window.opener.document.getElementById("transactionReportForm");
			var dimension = frm.dimension.value;
			var includeConstraints = frm.includeConstraints.value;
			var selectedNodeId = frm.selectedNodeId.value;
			parentHref = window.opener.document.location.href.replace('#','');;
			if(parentHref.indexOf("?") > 0) {
				parentHref= parentHref.substring(0, parentHref.lastIndexOf("?"));
			}
			window.opener.document.location=parentHref+"?dimension="+dimension+"&includeConstraints="+includeConstraints+"&selectedNodeId="+selectedNodeId;
		}
		
		function restoreAttributes() {
			form = dojo.byId("transactionPreferencesForm");
			form.action = "/expensemap/restoreDefaultAttributeList.xhtm";
			if('${ param.source }' == "transaction"){
				document.getElementById('source').value= "transaction";
				document.getElementById('actionSave').value= "save";
			}
			form.submit();
		} 
		
</script>
</HEAD>
<BODY  class="claro" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="windowStatus();" >

<form:form id="transactionPreferencesForm" commandName="transactionPreferencesForm"  action="/expensemap/showTransAttributePage.xhtm" method="post">

<%-- build the masthead --%>
<c:if test="${param.source != 'transaction'}">
	<% 
		CubeUtil.buildExpMapMastHead(out,"preferences_main_frame.jsp",zs,true,null,zs.getUser().getLocale(),null);
	%>
	<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
	<jsp:include page="/jsp/topMenu.jsp">
		<jsp:param name="helpUrl" value="<%=helpURL%>"/>
	</jsp:include>	
</c:if>

<c:if test='${param.source eq "transaction"}'>
	<jsp:include page="/jsp/includes/simplePageHeader.jsp" />
</c:if>


<TABLE width="100%" border="0" cellspacing="0" cellpadding="0" class="popformTable" style="{width:100%;margin-top:0px;margin-bottom:0px;}">
  <TR>
    <TD valign="middle" class="TableHdr"><fmt:message  key="ui.label.transaction.preferences"/></TD>
 </TR>
</TABLE>
<table align="center" width="800"  border="0" class="multiselectContainer">
		<tr >
			<td align="center" class="tabledata" style="font-weight:bold;font-size:12px;  "><fmt:message key='ui.label.Available'/></td>
			<td >&nbsp;</td>
			<td align="center" class="tabledata" style="font-weight:bold;font-size:12px;"><fmt:message  key='ui.label.In.Use'/></td>
            <td>&nbsp;</td>
		</tr>
		<tr >
			<td width=40%>
				<div id="titleGroupA" data-dojo-type="dojox.widget.TitleGroup"/>
			</td>
			<td width=10% align="middle" valign="middle">
				<button id="moveToRight" class="switch" data-dojo-type="dijit.form.Button" data-dojo-props="enabled : true" type="button" onClick="moveItemsToRight">&gt;&gt;</button> <br />
				<button id="moveToLeft" class="switch" data-dojo-type="dijit.form.Button" data-dojo-props="enabled : true" type="button" onClick="moveItemsToLeft">&lt;&lt;</button>
	      	</td>
	      	<td width=40%>
	      		<div class="topMargin"></div>
	     			<select data-dojo-type="dijit.form.MultiSelect" id="viewableFields" name="viewableFields">
			</td>
			<td width=10%>
				<table border=1 cellspacing=1 cellpadding=1>
					<tr>
						<td><IMG src=/expensemap/jsp/nav_images/ex_arrowtop_up.gif onclick="movetopbottom(dojo.byId('viewableFields'), 'top')"></td>
					</tr>
					<tr>
						<td><IMG src=/expensemap/jsp/nav_images/ex_arrowup_up.gif onclick="moveup(dojo.byId('viewableFields'))"></td>
					</tr>
					<tr>
						<td><IMG src=/expensemap/jsp/nav_images/ex_arrowdown_up.gif onclick="movedown(dojo.byId('viewableFields'))"></td>
					</tr>
					<tr>
						<td><IMG src=/expensemap/jsp/nav_images/ex_arrowbottom_up.gif onclick="movetopbottom(dojo.byId('viewableFields'), 'bottom')"></td>
					</tr>
				</table>
			</td>	
		</tr>
	</table>
<TABLE width="100%" border="0" cellspacing="0" cellpadding="0">
<TR align="center" style="width:100%">
  <TD colspan="2" class="popformBot" >
		<button id="saveAttributes" data-dojo-type="dijit.form.Button" type="button" onClick="saveAttributes()"><fmt:message key='ui.label.Save'/></button>
		<button id="restoreAttributes" data-dojo-type="dijit.form.Button" type="button" onClick="restoreAttributes()"><fmt:message key='ui.label.Restore.Defaults'/></button>
	</TD>
</TR>
</TABLE>
<span style="display: none" ><select data-dojo-type="dijit.form.MultiSelect" id="dynamic"></select></span>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>	
<input type ='hidden' name="actionSave" id="actionSave" value=''/>	
<input type ='hidden' name="source" id="source" value='${ param.source }'/>
</form:form>
</BODY>
</HTML>
