<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@include file="../includes/tlib.jspf"%>
<%@ page import="java.util.*" %>
<%@ page import="com.zeborg.util.*,com.zeborg.web.*"%>
<%@ page import="com.zeborg.expensemap.view.*,com.zeborg.expensemap.view2.*"%>
<%@ page import="com.zeborg.web.util.WrapPageContext"%>
<%@ page import="com.zeborg.expensemap.web.*,com.zeborg.expensemap.model3.ExpensemapACLUtil"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.emptoris.viewer.admin.AppEventConstants"%>
<%@ page import="com.emptoris.service.cube.cache.PermissionCacheImpl"%>
<%@ include file="../begin_page.jspf"
%>
<c:if test="<%= !ExpensemapACLUtil.hasViewAdminPermission(ZSessionUtil.getFromSession(pageContext).getUser())%>" >
<jsp:forward page="/jsp/admin/common/noPerm.jsp"/>
</c:if>
<%

	WrapPageContext pageWrap = new WrapPageContext(pageContext);
	PageContext orgPageContext = pageContext;
	pageContext = pageWrap;
	// This wraps the original request with a new one that handles mutli-part messages.
	request=(HttpServletRequest)pageWrap.getRequest();
	response =(HttpServletResponse)pageWrap.getResponse();
	out = pageWrap.getOut();

	//AdminSession   adminSession  = null;
	HashMap		   adminAttrs	 = new HashMap();
	String		   selectAction	 = null;
	String		   selectedNode  = null;
	String		   selectedType  = null;	// User Management or System Management or Server Management
	ZSession	   zSession		 = ZSessionUtil.getFromSession(pageContext);

	EMFormUtil.getUtil().processTriggeredForm(pageContext,false);

	AdminNodeForm  nodeForm	     =  (AdminNodeForm)EMFormUtil.getUtil().defaultProcess(AdminNodeForm.FORM_NAME,pageContext,null);

    selectedType =  nodeForm.getAdminView().findFirstSelected().getName();	
	// 41586 localize help icon
    EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_SRC_RESOURCE_BUNDLE,zs.getUser().getLocale());
    String localizedSelectedType = selectedType;
    if(selectedType!=null && !selectedType.equals("")){    
		localizedSelectedType = selectedType.trim();
		localizedSelectedType = localizedSelectedType.replace(" ",".");
		localizedSelectedType = "ui.help.label." + localizedSelectedType;
		localizedSelectedType = bundle.getValue(localizedSelectedType);
    }
	
	
    String action="this.form."+nodeForm.getSelectAction().getEncodeName()+".click()";
    adminAttrs.put("onSelect",action);
    adminAttrs.put("onChange",action);
	adminAttrs.put("class","MAIN_FONT");    
    String helpPage ="";
    ACSession acSession = (ACSession) session.getAttribute(ACSessionUtil.AC_SESSION_ATTRIBUTE_NAME);
    ClickTrace.doTrace( AppEventConstants.VIEW, request, zSession);


%>


<HTML>
<HEAD>
<fmt:setBundle basename="ExpensemapMessagesBundle" />
<TITLE><%= ExpenseMapAppProperties.getExpensemapTitle()%> <fmt:message key='ui.label.Admin' />
</TITLE>
    <link rel="stylesheet" type="text/css" href="../stylesheets/login.css">
<LINK REL="stylesheet" TYPE="text/css" HREF="../stylesheets/macromap.css">
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/admin.css">
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/adminTableData.css">
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/topmenu.css">
<link rel='shortcut icon' href='/expensemap/jsp/images/favicon.ico' type='image/x-icon'>
<STYLE TYPE="text/css">
<!--
.warning{font-family:'verdana';font-size:'10pt';font-weight:'bold';color: Red;background-color : transparent;}
.spacer { font-family:Arial,Helvetica,sans-serif; font-size:3px; color:#FFFFFF; }
.smallwhite { font-family:Arial,Helvetica,sans-serif; font-size:12px; color:#FFFFFF; text-decoration:none; }

A:link{ FONT-WEIGHT: normal; FONT-SIZE: 11px; COLOR: #0C209B; FONT-FAMILY: verdana; TEXT-DECORATION: none; }



.LIST_SORT_HEAD { FONT-WEIGHT: normal; FONT-SIZE: 11px; COLOR: #FFFFFF; FONT-FAMILY: verdana;

					TEXT-ALIGN: left; TEXT-DECORATION: none }

.HeaderLink { font-size:13px; font-weight:bold; COLOR: #FFFFFF; FONT-FAMILY: verdana;}

.pageHeader	{ font-family:verdana; font-size:18px; font-weight:bold; color:#336699; text-decoration:none; }

.tableDataBold 	{ font-size:11px; font-weight:bold; background-color:#333366; }

.TREENODE  { font-family:verdana; font-size:11px; font-weight:regular; color:#31659C; text-decoration:none; }

class B { font-family:verdana; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:none; }
B:TEXT { font-family:verdana; font-size:12px; font-weight:bold; color:#336699; text-decoration:none; }

.TAB{   FONT-SIZE: 11px;    COLOR: #333366;    FONT-FAMILY: verdana;    TEXT-DECORATION: none}

TD{
	font-family:verdana;
}

#navigationLogoTd { width: 1%; white-space: nowrap; display: none; }
#navigationLinks { vertical-align: middle !important; }
-->
</STYLE>
<SCRIPT LANGUAGE="javascript" SRC="../javascript/header.js"></SCRIPT>
 <script>
function selectRoot() {
	numberOfForms = document.forms.length;
  	if(numberOfForms >= 1)
  	{
     	for(index = 0; index < numberOfForms; index++)
     	{
	        checkBoxes = document.getElementsByTagName("INPUT");
	        elementsLength = checkBoxes.length;
	        
			// get the root elements in array.
			var rootElements = new Array();
	        for(arrIndex=0, elementIndex = 0; elementIndex < elementsLength; elementIndex++)
	        {
	           if(checkBoxes[elementIndex].type == 'checkbox' && checkBoxes[elementIndex].id.indexOf('root') != -1) {
	       	       val = checkBoxes[elementIndex].id;
	       	       index = val.indexOf("-");
		       roleId  = val.substring(index + 1, val.length);
	       	       
	       	       rootElements[arrIndex] = roleId;
	       	       arrIndex++;
	           } // end if
	        } // end for

	        for(arrIndex=0; arrIndex < rootElements.length; arrIndex++) {
	            var root;
	            for(elementIndex = 0; elementIndex < elementsLength; elementIndex++) {
	        		if (checkBoxes[elementIndex].type == 'checkbox' ) {
	
	        	    	if (checkBoxes[elementIndex].id == 'root-' + rootElements[arrIndex]) {
			        		root = checkBoxes[elementIndex];
			    		} else {
					        val = checkBoxes[elementIndex].value;
					      	ind = val.indexOf("-");
					      	acObjectId = val.substring(0, ind);
					      	tempRoleId = val.lastIndexOf("-");
					      	if ( tempRoleId > ind)
					      	    roleId  = val.substring(ind+1, tempRoleId);
					      	else
					      	    roleId  = val.substring(ind+1, ind+ind+1);
					      				    	
					      	if (roleId == rootElements[arrIndex] ) {
					      	    if (checkBoxes[elementIndex].checked == true) {
					      			flag = true;
					      	    } else {
					      			flag = false;
					      			break;
					      	    }
					      	}
	  		    		} // end else
	        		} // end if checkbox
	            } // inner for
	            root.checked = flag;
	        } // outer for
	    }
	}
}
</script>
</HEAD>
<BODY LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onLoad="selectRoot()">
<%@ include file="../includes/mainPageHeader.jsp"%>
<FORM id="mainform" name="mainform" method="POST" enctype="multipart/form-data">
<%
	String returnTo=(String)pageContext.getAttribute("returnToURL", PageContext.SESSION_SCOPE);
	CubeUtil.buildExpMapMastHead(out,"admin/main_frame.jsp",zSession,false,returnTo,zSession.getUser().getLocale(),null);
%>

<%--NOTE: There should only be one FORM TAG for the whole series of pages --%>
<div id="menubarPlaceholder">
	<table width="100%" height="100%" border="0" cellspacing="0" cellpadding="1">
		<TR>
	<%-- start hidden form buttons that are used for onChange event of dropdowns --%>
		<TD id="navigationLogoTd"><img src="/expensemap/jsp/images/customization/logos/left_logo_3.gif"></TD>
		<TD style="display:none;">	
			<span id="hideMe">
				<INPUT type="submit" name="<%=nodeForm.getSelectAction().getEncodeName()%>" value="<%=nodeForm.getSelectAction().getDisplayName()%>">
			</span>
		</TD>
	<%-- end hidden form buttons that are used for onChange event of dropdowns --%>
		<TD NoWRAP class="tableData" id="navigationLinks"> <fmt:message key='ui.label.admin.area' /> : <% DefaultFormRenderer.renderProperty(nodeForm,nodeForm.getAdminViewMeta(),adminAttrs,out); %>
		</TD>
		<TD valign="middle" align="right" COLSPAN="49">
			<A HREF="javascript:doHelp();"><IMG SRC="../images/help.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<%=localizedSelectedType%>" ></A>
		</td>
		</tr>
	</table>
</div>

<TABLE WIDTH="100%" BORDER="0" CELLSPACING="0" CELLPADDING="1">
			<TR>
				<TD valign="top"  COLSPAN="51">
					<!-- Here goes the combo to select system or user management.-->
                    <%
                        if (selectedType.equals("User Management"))
                        {
                            //to start we'll do user management.
							//Handled BugNo: 22702
							helpPage="help.url.admin.user.management.page";
							if(PermissionCacheImpl.getInstance().hasApplicationPermission(ZSessionUtil.getFromSession(pageContext).getUser(),GlobalPermissions.ViewUserManagement)){
								com.zeborg.acl.web.WebPageUtil.includeAdminUI(pageContext,
                                    EMPermissionEditorModel.class.getName(),
                                    com.zeborg.expensemap.util.EMHelpUtil.class.getName(),
									ExpensemapACLUtil.ViewUserManagement_Companies,
									ExpensemapACLUtil.ViewUserManagement_Users,
									ExpensemapACLUtil.ViewUserManagement_Roles,
									ExpensemapACLUtil.ViewUserManagement_UserRoleManagement,
									ExpensemapACLUtil.ViewUserManagement_Permissions);
							}else {
								%>
									<iframe src="../admin/common/noPerm.jsp" name="dataSet" width="100%" height="470px" frameborder="0"> </iframe>
								<%
							}                            
                        }
                        else if(selectedType.equals("System Management"))
                        {
                        	helpPage="help.url.admin.system.management.page";
							if(PermissionCacheImpl.getInstance().hasApplicationPermission(ZSessionUtil.getFromSession(pageContext).getUser(),GlobalPermissions.ViewSystemManagement)){
									com.zeborg.expensemap.web.WebPageUtil.includeSystemAdminUI(pageContext,com.zeborg.expensemap.util.EMHelpUtil.class.getName());
							}else{
								%>
									<iframe src="../admin/common/noPerm.jsp" name="dataSet" width="100%" height="470px" frameborder="0"></iframe>
								<%
							}
                        }
                        else if(selectedType.equals("Server Management"))
                        {
                        	helpPage="help.url.admin.server.management.page";
							if(PermissionCacheImpl.getInstance().hasApplicationPermission(ZSessionUtil.getFromSession(pageContext).getUser(),GlobalPermissions.ViewServerManagement)){
									com.zeborg.expensemap.web.WebPageUtil.includeServerAdminUI(pageContext,
											com.zeborg.expensemap.util.EMHelpUtil.class.getName());
							}else{
								%>
									<iframe src="../admin/common/noPerm.jsp" name="dataSet" width="100%" height="470px" frameborder="0"></iframe>
								<%
							}
                        }
                    	//44974 
                        else if(selectedType.equals("Admin UsageReports"))
                        {
                        	helpPage="help.url.admin.UsageReports.page";	
                        %>
                        	
                        	<iframe src="../../admin/showAllUsageReports.shtm" name="dataSet" width="100%" height="470px" frameborder="0" scrolling="auto" ></iframe>	
                        <%}   

                        else if(selectedType.equalsIgnoreCase("SEM Job Management"))
                        {
                        	helpPage="help.url.admin.sem.job.management.page";
                        	%>
                         		<iframe src="../../jobcontroller/JobListAction.do?operation=loadJobList&isSysAdminRequest=true&clearSearch=true" name="dataSet"	width="100%" height="600px" frameborder="0" border="0"></iframe>
                       	 	<%
                        }
						
						else if (selectedType.equalsIgnoreCase("Integration Settings")) {
							helpPage="help.url.admin.integration.management.page";
							%>
                         		<iframe src="/expensemap/admin/integration/integrationSettings.xhtm" id="integrationSettingsFrame" name="integrationSettingsFrame" 
								width="100%" height="600px" frameborder="0" border="0"></iframe>
                       	 	<%
						}
						
                        else
                        {
                  		%> 
                        	  <fmt:message key='ui.label.UnderConstruction'/>
                   		<%
                   		}

                    %>
				</TD>

			</TR>
</TR>

</TABLE>

<script language="javascript">
function doHelp()
{
    
    open( "<%=emHelp.getHelpURLString(helpPage,locale)%>", "_blank" );
}
</script>


</FORM>
</BODY>
</HTML>

<%@ include file="../end_page.jspf"%>