<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.zeborg.expensemap.model3.Model3Util"%>
<%@page import="com.zeborg.expensemap.model3.SecurityFilter"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.acl.util.ACUtil, com.emptoris.viewer.util.RenderUtil"%>
<%@page import="com.zeborg.acl.util.ACManager"%>
<%@ page import="com.zeborg.web.*,com.zeborg.util.*,com.zeborg.acl.web.*,
                 com.zeborg.expensemap.il8n.EmLocalizationManager,com.zeborg.expensemap.il8n.EmResourceBundle,
                 com.zeborg.expensemap.web.EMFormUtil,
                 com.zeborg.expensemap.model3.ExpensemapACLUtil,
                 com.zeborg.expensemap.web.*"
%>
<%@ include file="../begin_page.jspf"%>
<%
	ACManager.getManager().checkPermission(pageContext,
										  new String[]{ExpensemapACLUtil.ViewSystemManagement_SecurityFilters},
										  ACUtil.getGlobalObject(),true); 
    // Begin securityfilters_general.jsp

	EditorParameters params1 = new EditorParameters();
	params1.setMode(EditorParameters.MODE_EDIT);

    ParamsAllSecurityFilters params = com.zeborg.expensemap.web.WebPageUtil.getParamsForAllSecurityFilters(pageContext);
    SecurityFilterCollectionForm f = (SecurityFilterCollectionForm) EMFormUtil.getUtil().defaultProcess(
            SecurityFilterCollectionForm.FORM_NAME,pageContext,params);
            FormPropertyMetadata meta = null;
    meta = f.getMetadata().getPropertyMetaAt(0);
            DefaultFormRenderer.renderFormCollectionMarker(out,meta, f.getFilterItems());
	EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_ADMIN_RESOURCE_BUNDLE,zs.getUser().getLocale());
	 if (ACLWebUtil.EXPORT_MODE.equals(f.getFormSelected())) {
		DataSet ds = Model3Util.getDataSetHome().findByCubeMetaID(f.getCubeMetaID());
		String dsId= ds.getId();                    
	 %>            
		<jsp:include page="export_cognosquery.jsp">
			<jsp:param name="dsId" value="<%=dsId%>"/>
		</jsp:include>     
		<%     
    } else if (ACLWebUtil.SINGLE_MODE.equals(f.getFormSelected())) {
		FormCollection filtersCollection = f.getFilterItems();
		SecurityFilterForm filterForm = (SecurityFilterForm)filtersCollection.getAt(0);

		if ( f.getIdSelected() != null ) {
			// com.zeborg.cubem.model.Filter filter = com.zeborg.cubem.model.ModelUtil.getFilterHome().findByPrimaryKey(f.getIdSelected());
			SecurityFilter sf = Model3Util.getSecurityFilterHome().findByPrimaryKey(f.getIdSelected());
			ACManager.getManager().checkPermission(pageContext,
											  new String[]{com.zeborg.cubem.model.Filter.PERM_EDIT,
														   com.zeborg.cubem.model.Filter.PERM_VIEW},
									          sf.getACObject(),true);
		}
		filterForm.getFilterMeta().setEditable(false);

		String editString=DefaultFormRenderer.modeToString(params1.modeToString(), filterForm, com.zeborg.cubem.model.Filter.PROP_Name,bundle.getValue("ui.label.Security.Filters"),bundle);
        FormCollectionTableRenderer.renderItemForm(pageContext, f, filterForm, editString, bundle.getValue("ui.label.All.Security.Filters"));
        FormCollectionTableRenderer.renderAllSingleViewScripts(pageContext,f);
        RenderUtil.renderHiddenSecurityToken(pageContext, "CreateEditSF");
    } else {
        FormCollectionTableRenderer tableRenderer=new FormCollectionTableRenderer(f.getFilterItems());
        FormCollectionTableRenderer.renderToolBar(pageContext, f, true);
        tableRenderer.render(pageContext);
        tableRenderer.renderHiddenFields(pageContext, f);
        DefaultFormRenderer.renderAction(f.getEditAction(),out,zs.getUser().getLocale());
        tableRenderer.renderAllListViewScripts(pageContext, f);
        RenderUtil.renderHiddenSecurityToken(pageContext, null);
    }%>
<!-- End securityfilters_general.jsp-->
<%@ include file="../end_page.jspf"%>
