<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="java.util.*,java.text.*"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import ="com.zeborg.util.WebUtil, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import ="org.apache.struts.Globals,com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>

<%
		String rowStyle="";
		List bookMarkList = (List)request.getAttribute("bookMarkList");
		ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);		
		Locale locale =zs.getUser().getLocale();		
		String cubeName = zs.getDataSet().getDisplayName();
		int noOfRows= bookMarkList.size();		   
		EmResourceBundle bundle=EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE, locale);		
		String  helpURL = HelpUtil.getHelpUtil().getHelpURLString("view_alertList", locale);
		pageContext.setAttribute("returnToURL","../bookmark/viewAllAlerts.do", PageContext.SESSION_SCOPE);	
		EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_SRC_RESOURCE_BUNDLE, locale);
		String title = ExpenseMapAppProperties.getExpensemapTitle()+ " - "+ baseBundle.getValue("ui.label.existing.alerts");	        
		CubeUtil.buildExpMapMastHead(out,"viewFrame_attachment.jsp",zs,true,null,locale,null);
%>
<html:html>
<bean:define id="sortOrderObj" name="bookmarkForm" property="bookmarkPagination.listSortOrder"/>
<bean:define id="sortColObj" name="bookmarkForm" property="bookmarkPagination.listSortColumnName"/>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	
	
<head>
<title><%=title%></title>
<style>
	a, A:link, a:visited, a:active, A:hover
	{color: #330099;}
</style>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css">
<script language="JavaScript" src="/expensemap/jsp/analytics/scripts/commons.js"></script>
<script language="javascript">



/**
 * This JS function performs Select/Deselect ALL.
 */
function selectAll(selectAllControl) {
	var theForm =  document.getElementById("bookmarkForm");
   	if ( theForm.bookmarkIds == null ) {
   	  return false;	
   	} 
   	
   	if ( theForm.bookmarkIds.length ) {
   		// There are more than one rows on this form.
		for( var i=0; i< theForm.bookmarkIds.length; i++ ) {
			theForm.bookmarkIds[i].checked = selectAllControl.checked;
		}
		if (selectAllControl.checked) {
 			document.getElementById("delete").disabled=false;
 		}else{
			document.getElementById("delete").disabled=true;
		}
		return true;
   	}
   	// There is just a single row on this form.
   	theForm.bookmarkIds.checked = selectAllControl.checked;
	if (selectAllControl.checked) {
 		document.getElementById("delete").disabled=false;
 	}else{
		document.getElementById("delete").disabled=true;
	}
}
/**
 * This JS function updates the selectAll check-box based on user's selection.
 * i.e. when user selects each-and-every checkbox manually, the selectAll check-box gets selected too.
 *
 */
function updateSelectAll(checkboxSelected) {
	var theForm = document.getElementById("bookmarkForm");
	var selectAllControl = document.getElementById("selectallrows");
	var allSelected = true;

	if ( ! theForm.bookmarkIds.length ) {
		allSelected = checkboxSelected.checked;
	} else {
		for( var i=0; i< theForm.bookmarkIds.length; i++ ) {
			if ( theForm.bookmarkIds[i].checked == false ) {
				allSelected = false;
				break;
			}
		}
	}
	selectAllControl.checked = allSelected;
	if (checkAtLeastOneSelected()) {
 		document.getElementById("delete").disabled=false;
 	}else{
		document.getElementById("delete").disabled=true;
	}
	
}


function viewBookMark(bkid){
	open('/expensemap/getDimensionalView.do?viewSelected=dimension&bkid=' + bkid, '_self', 'resizable=yes,width=1000,height=470' );
}
function showAllBookmark(){
	var frm = document.getElementById("bookmarkForm");
	frm.method="post";
	document.getElementById("search.name").value="";
	document.getElementById("search.toDate").value="";
	document.getElementById("search.fromDate").value="";
	document.getElementById("search.createdBy").value="";
	document.getElementById("theAction").value = "showAll";
	frm.action="/expensemap/bookmark/viewAllAlerts.do";
	frm.submit();
}
function deleteBookmarks(){
	var frm = document.getElementById("bookmarkForm");
	
	
	var isSelected = checkAtLeastOneSelected();
	if (frm.bookmarkIds.length > 0 && isSelected||frm.bookmarkIds.value && isSelected) {
		if (confirmDelete()) {
			frm.method="post";
			document.getElementById("theAction").value="deleteBookmarks";
			frm.action="/expensemap/bookmark/deleteBookmarkAction.do?isAlertPage=true";
			frm.submit();
		}
	}
	
}
//Confirm delete action
function confirmDelete(){
	var confirmDelete ="<bean:message key='ui.delete.alertmsg' bundle='emMessages'/>";
	//Are you sure you want to Delete';
	if (confirm(confirmDelete)) {
 		return true;
	} else {
		return false;
	}
}
function paginate(action){
	var frm = document.getElementById("bookmarkForm");
	frm.method="post";
	document.getElementById("theAction").value=action;
	frm.action="/expensemap/bookmark/viewAllAlerts.do";
	frm.submit();
}

function submitFormForSorting(columnName){
    var order = '<c:out value="${ bookmarkForm.bookmarkPagination.listSortOrder }" />';

	if(order=='' || order==null || order=='null'){
		order = 'asc';
	}

	var frm = document.getElementById("bookmarkForm");
	frm.method="post";
	document.getElementById("bookmarkPagination.listSortOrder").value=order;
	document.getElementById("bookmarkPagination.listSortColumnName").value=columnName;
	document.getElementById("theAction").value="";
	frm.action="/expensemap/bookmark/viewAllAlerts.do";
	
	if(order=='asc'){
			order='desc';
		}else if(order=='desc'){
			order='asc';
	}
	
	document.getElementById("bookmarkPagination.listSortOrder").value=order;
	document.getElementById("bookmarkPagination.listSortColumnName").value=columnName;
	frm.submit();
}

function checkSelectAll() {
	var selectAllControl = document.getElementById("selectallrows");
	var theForm = document.getElementById("bookmarkForm");
	if ( theForm.bookmarkIds == null ) {
		selectAllControl.disabled = true;
		return;
	}
}
//Validate if at least one bookmark is selected.
function checkAtLeastOneSelected() {
	var frm = document.getElementById("bookmarkForm");
	
   if (frm.bookmarkIds.length) { // if the checkbox group is an array (one check box is not an array)
	var noOfRows = frm.bookmarkIds.length;
	
	for (i = 0; i < noOfRows; i++) {
	if (frm.bookmarkIds[i].checked == true) {			
			return true;
		}
	}
	}
	else { // There is only one check box (it's not an array)
	 if (frm.bookmarkIds.checked) { // if the one check box is checked
	         return true;
	      }
	      
	      }

	return false;
}
function openHelp(){
	open( "<%=helpURL%>", "_blank" );	
}
</script> 
</head>
<body onload="checkSelectAll();" >
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="bookmarkForm"/>
</jsp:include>
<i18n:bundle baseName="<%=EmLocalizationManager.EXPENSEMAP_MESSAGE_BUNDLE%>" locale="<%= locale %>" />
<% 
	String sortOrder = (String)sortOrderObj;
   	String sortCol =  (String)sortColObj; 
	if(sortCol == null || sortCol.equals("null") || sortCol.equals(""))
	{
		sortCol="1";
	} 
%>
<html:form  action="/viewAllAlerts.do?theAction=getCurrent"  styleId="bookmarkForm">

<logic:messagesPresent message="true" property="org.apache.struts.action.GLOBAL_MESSAGE" >
	<center>
	<font color=#ff0000>
		<b>
		<html:messages id="msg" message="true" bundle="emMessages"> 
		      <bean:write name="msg" bundle="emMessages"/> 
		</html:messages> 
		</b>
	</font></center>
</centre>
</logic:messagesPresent>
<logic:messagesPresent message="true" property="emSrcMessages" >
	<center>
	<font color=#ff0000>
		<b>
		<html:messages id="msg" message="true" property="emSrcMessages" bundle="emSrcMessages">
			<bean:write name="msg"/>
		</html:messages>
		</b>
	</font></center>
</logic:messagesPresent>
<table class="tableWithBorder">
 	 <tr>
       	<td class="reportTitle" align="left"><bean:message key="ui.label.existing.alerts" bundle="emSrcMessages" /></td>
		<td align="center"><b><bean:message key="ui.label.Dataset" bundle="emSrcMessages" />&nbsp;<bean:message key="ui.label.Name" bundle="emSrcMessages" /><b>:&nbsp;<%=cubeName.toUpperCase()%></b></td>			
		<td align=right><A onclick=openHelp(); href="#"><IMG title=<bean:message  key='ui.label.Help' bundle='dashboard'/> src="/expensemap/jsp/images/help.gif" border=0></A></td>	
	</tr>
</table>
<table class="InnerTableWithBorder" width="100%">
		<tr width=100%>
		<td  class="thead" align="center" width="17%"><a href="#" onclick="submitFormForSorting('byName');"><bean:message key="ui.label.Name" bundle='emMessages'/></a><%if((sortOrder != null && sortOrder.equals("desc")) && (sortCol != null && sortCol.equals("byName"))){%>
			<img src="/expensemap/jsp/images/up.gif" border="0">
			<%}else if((sortOrder != null && sortOrder.equals("asc")) && (sortCol != null && sortCol.equals("byName"))){%>
			<img src="/expensemap/jsp/images/down.gif" border="0"/><%}%>
		</td>	
		<td nowrap class="thead" align="center" width="5%">
			&nbsp;<bean:message key="ui.label.Ownership"  bundle="emSrcMessages" />&nbsp;			
		</td>
		<td nowrap class="thead" align="center" width="10%">
			&nbsp;<bean:message key="ui.label.Shared.By"  bundle="dashboard" />&nbsp;
		</td>
		<td nowrap class="thead" align="center" width="38%">
			<bean:message key="ui.label.Description" bundle='emMessages'/>
		</td>
		<td NOWRAP class="thead" align="center" width="10%"><a href="#" onclick="submitFormForSorting('dateCreated');"><bean:message key="ui.label.Date.Created" bundle='emSrcMessages'/></a><%if((sortOrder != null && sortOrder.equals("desc")) && (sortCol != null && sortCol.equals("dateCreated"))){%>
			<img src="/expensemap/jsp/images/up.gif" border="0">
			<%}else if((sortOrder != null && sortOrder.equals("asc")) && (sortCol != null && sortCol.equals("dateCreated"))){%>
			<img src="/expensemap/jsp/images/down.gif" border="0"><%}%></td>			    	
		<td nowrap class="thead" align="center" width="5%">
			<input id="selectallrows" type="checkbox" onclick="selectAll(this);">
		</td>
		</tr>
		<logic:iterate name="bookMarkList" type="com.emptoris.viewer.bookmark.model.BookmarkViewBean" id="currentViewVO" indexId="ctr" >
		
		<tr class='<%=(ctr.intValue() % 2 == 0) ? "trEven" : "trOdd"%>' width="100%">
			<td  class=".tdStyle" align="left" >
				<a href="#" onclick="viewBookMark('<bean:write name='currentViewVO' property='id'/>');" title='<%=currentViewVO.getName()%>'><bean:write name="currentViewVO" property="name"  filter="false"/></a>					
			</td>
			<td class=".tdStyle" align="center" >
				<c:choose>
					<c:when test="${currentViewVO.owner}" >
						<img src="/expensemap/jsp/images/nonshared.gif" />
					</c:when>
					<c:otherwise>
						<img src="/expensemap/jsp/images/shared.gif" />
					</c:otherwise>
				</c:choose>
			</td>
			<td class=".tdStyle" align="center" >
				<c:if test="${ ! currentViewVO.owner}">
					<bean:write name="currentViewVO" property="sharedBy" filter="false" />
				</c:if>
			</td>
			<td class=".tdStyle" align="left" ><%=currentViewVO.getDescription()%></td>
			<td nowrap class=".tdStyle" align="center" >
       			&nbsp;<fmt:formatDate  value="${ currentViewVO.dateCreated }" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" />&nbsp;       			
       		</td>

	 		<td class=".tdStyle" align="center" >
	 			<c:choose>
					<c:when test="${currentViewVO.deleteEnabled}" >
						<input type="checkbox" name="bookmarkIds" value="${currentViewVO.id}"  onclick="updateSelectAll(this);" />
					</c:when>
					<c:otherwise>
						<input disabled="disabled" type="checkbox" />
					</c:otherwise>
				</c:choose>
	 			
	 		</td>
		</tr>    	
  </logic:iterate>	
  
</table>

<table class="tableWithoutBorder" width="98%" >
	<tr>
		<td>
	<bean:define id="pageSizeValue" name="bookmarkForm" property="bookmarkPagination.pageSize"/>
	<bean:define id="totalRecValue" name="bookmarkForm" property="bookmarkPagination.totalRec"/>
	<bean:define id="startRecValue" name="bookmarkForm" property="bookmarkPagination.startRec"/>
	<bean:define id="limitRec" name="bookmarkForm" property="bookmarkPagination.limitRec"/>
		<c:if test="${  ! empty bookMarkList }" >
			<jsp:include flush="true" page="pagination.jsp"/>							
			
		</c:if>
		</td>
	</tr>
</table>

<table class="tableWithoutBorder" width="35%">
<TBODY>
	<tr>
	<td>
		<INPUT style="font-size:10pt" onclick="callOpenBookmarkSearchDialog();" type="button" value="<bean:message key='ui.label.Search' bundle='emMessages' />" name=search>&nbsp;
		<INPUT style="font-size:10pt" onclick="showAllBookmark();" type="button" value="<bean:message key='ui.label.ShowAll' bundle='emMessages' />" name=showall>&nbsp;
		<INPUT style="font-size:10pt" onclick="deleteBookmarks();"type="button" value="<bean:message key='ui.label.Delete' bundle='emMessages' />" name=delete id=delete disabled=true></td>    
	</TR>
</TBODY>
</TABLE>
<script>
function callOpenBookmarkSearchDialog() {
	var startRec = '<c:out value="${ bookmarkForm.bookmarkPagination.startRec }" />';
	var pageSize = '<c:out value="${ bookmarkForm.bookmarkPagination.pageSize }" />';
	var limitRec = '<c:out value="${ bookmarkForm.bookmarkPagination.limitRec }" />';
	var sortColumn = '<c:out value="${ bookmarkForm.bookmarkPagination.listSortColumnName }" />';
	var sortOrder = '<c:out value="${ bookmarkForm.bookmarkPagination.listSortOrder }" />';
	searchAlerts(startRec,pageSize,limitRec,sortColumn,sortOrder);
}

</script>
<html:hidden name="bookmarkForm" styleId="bookmarkPagination.listSortColumnName" property="bookmarkPagination.listSortColumnName"/>
<html:hidden name="bookmarkForm" styleId="bookmarkPagination.listSortOrder" property="bookmarkPagination.listSortOrder"/>
<html:hidden name="bookmarkForm" styleId="bookmarkPagination.startRec" property="bookmarkPagination.startRec"/>
<html:hidden name="bookmarkForm" styleId="bookmarkPagination.pageSize" property="bookmarkPagination.pageSize"/>
<html:hidden name="bookmarkForm" styleId="bookmarkPagination.limitRec" property="bookmarkPagination.limitRec"/>
<html:hidden name="bookmarkForm" styleId="bookmarkPagination.totalRec" property="bookmarkPagination.totalRec"/>
<html:hidden name="bookmarkForm" styleId="search.name" property="search.name"/>
<html:hidden name="bookmarkForm" property="toDate" styleId="search.toDate"/>
<html:hidden name="bookmarkForm" property="fromDate" styleId="search.fromDate" />
<html:hidden name="bookmarkForm" styleId="search.createdBy" property="search.createdBy"/>
<input type ='hidden' name="theAction" id="theAction" value='showAll'/>
<input type ='hidden' name="AuthCode" id="AuthCode" value="<c:out value='${sessionScope.hma_code_allActions}'/>"/>

</html:form>
</body>
</html:html>