<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager,com.zeborg.expensemap.util.HelpLocaleUtil,java.util.*,
com.zeborg.expensemap.util.ExpenseMapAppProperties,com.zeborg.util.WebUtil"
%>
<%@ page import="com.zeborg.expensemap.view2.ZSession, com.emptoris.viewer.util.CSRFHelper" %>
<%@ page import="com.zeborg.expensemap.view.CubeUtil,com.zeborg.expensemap.view.HelpUtil" %>
<%@ page import="org.owasp.esapi.ESAPI"%>

<%
ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);
Locale locale = zs.getUser().getLocale();	
EmResourceBundle bundle=EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE, locale);
String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.creating.analytic.help.page", locale);

CubeUtil.buildExpMapMastHead(out,"viewFrame_analytic.jsp",zs,true,null,locale,null);
String title = ExpenseMapAppProperties.getExpensemapTitle()+ " - "+ bundle.getValue("ui.title.create.new.analytic.report");

%>
<html:html>
<head>
<title><%=title%></title>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css" />

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>	
<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>


<STYLE>
.yui-skin-sam .yui-panel {
position: absolute;
}

.yui-skin-sam .yui-calcontainer{
font-family: Arial, Helvetica, sans-serif;
font: 100%;
	width:160px;
	width:180px !ie;
}
.yui-skin-sam .yui-panel .bd {
	display:block;
	overflow:hidden;
	
	width:180px;
	width:200px !ie;
}

.hEffect {
	cursor:hand;
	color:#0000FF;
	font-size: 11px;
	text-decoration : NONE;
	FONT-FAMILY: Arial;
}

.hEffect:hover {
	color:red;
}
</STYLE>

<script language="JavaScript">
var topReportSelected = false;
window.select_current = new Array(); 

function setPrevSelectValue(obj){
	 window.select_current[obj.id] = obj.selectedIndex;
}

function enableTopReportCategories(isTopReport) {
	topReportSelected=isTopReport;
	if( isTopReport ) {
		document.getElementById("topReportCategory").disabled = false;
	} else {
		document.getElementById("topReportCategory").disabled = true;
	}
}

function selectDimension(selectedDimension) {
	var frm = document.getElementById("createNewRuleForm");
	if ( selectedDimension.value != '' ) {
		frm.action = "/expensemap/analytic/ProcessDimensionSelectAction.do";
		frm.submit();
	} else {
		alert("<bean:message key='ui.alertmsg.category.select' bundle='analytic'/>");
		frm.submit();
	}
}

function selectAttribute(selectedAttribute) {	
	if (selectedAttribute.options[selectedAttribute.selectedIndex].disabled) { 
		selectedAttribute.selectedIndex = window.select_current[selectedAttribute.id]; 
	    }else{
	    	window.select_current[selectedAttribute.id] = selectedAttribute.selectedIndex;
	    	if ( selectedAttribute.value == '' || selectedAttribute.value == '--' ) {
	    		alert("<bean:message key='ui.alertmsg.attribute.select' bundle='analytic'/>");
	    	} else {
	    		var frm = document.getElementById("createNewRuleForm");
	    		frm.action = "/expensemap/analytic/ProcessAttributeSelectAction.do";
	    		frm.submit();
	    	}
	    }	
}

function addNewCondition() {
	var frm = document.getElementById("createNewRuleForm");
	if ( validateNewCondition() ) {
		frm.action = "/expensemap/analytic/AddNewConditionAction.do";
		frm.submit();
	}
}

function deleteCondition() {
	var frm = document.getElementById("createNewRuleForm");
	frm.action = "/expensemap/analytic/DeleteConditionAction.do";
	frm.submit();
}

function cancelAnalyticForm() {
	var frm = document.getElementById("createNewRuleForm");
	frm.action = "/expensemap/showAnalyticPage.xhtm";
	frm.submit();
}

function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

function saveTemplate(createNew) {
	
	var frm = document.getElementById("createNewRuleForm");
 	var returnValue = validateNewRuleForm();
 	
 	//Assign "null" to "SortColumn" and "SortOrder", to get the default sort column 
	//and sort order after report submitted.
	document.getElementById("listSortColumn").value = "null";
	document.getElementById("listSortOrder").value = "null";
	
 	if (returnValue ) {
 		if(topReportSelected)
		{
			alert("<bean:message key='ui.alertmsg.Top.Reports.option.is.not.applicable.for.Templates' bundle='analytic'/>");
			return false;
		}
 		document.getElementById("createNew").value = createNew;
 		frm.method = "post";
 		frm.action = "/expensemap/analytic/saveTemplate.do";
 		frm.submit();
 	}
}

/**
 * process operator selection.
 * @param operator - operator selected
 */
function processOperator(operator) {
	enableCumulative(operator);
	enableLimitTextFields(operator);
}

/**
 * Enables cumulative check-box is greater than operator is selected.
 * @param operator - operator selected
 */
function enableCumulative(operator) {
	if ( operator.value == '&gt;' ) {
		document.getElementById("currentCondition.cumulative").disabled = false;
	} else {
		document.getElementById("currentCondition.cumulative").checked = false;
		document.getElementById("currentCondition.cumulative").disabled = true;
	}
}

/**
 * Enables high limit text box when Between is selected.
 * @param operator - operator selected
 */
function enableLimitTextFields(operator) {
	if ( operator.value == 'Between' ) {
		document.getElementById("highLimitSpan").style.visibility = 'visible';
		document.getElementById("currentCondition.highLimit").disabled = false;
	} else {
		document.getElementById("highLimitSpan").style.visibility = 'hidden';
		document.getElementById("currentCondition.highLimit").disabled = true;
	}
}

function validateNewCondition() {
	var isValid=true;
	var msg='';
	var attrValue=trim(document.getElementById("currentCondition.attribute").value) ; 
	var catValue= trim(document.getElementById("currentCondition.category").value) ;
	var opValue=trim(document.getElementById("currentCondition.operator").value);
	var loLimitValue=trim(document.getElementById("currentCondition.lowLimit").value);
	var highLimitValue=trim(document.getElementById("currentCondition.highLimit").value);
	// Tells us datatype for attribute currently selected.
	// Empty if no attribute is selected so far.
	var attributeType = '${ createNewRuleForm.currentCondition.selectedAttributeType }';
	
	if( opValue != "Between" ) {
		highLimitValue="N.A";
	}
	
    if( isEmpty(catValue) ) {
    	msg=msg+"<bean:message key='ui.alertmsg.category.select' bundle='analytic'/>"+ ";" ;    
    	isValid=false;
    }
		
    if (isEmpty(attrValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.attribute.select' bundle='analytic'/>"+ ";" ;    
		isValid=false;
    }
    
    if ( ! (document.getElementById("currentCondition.level").disabled) ) { 
	    var lvlValue = trim(document.getElementById("currentCondition.level").value); 
	    if (isEmpty(lvlValue)) {
			msg=msg+"<bean:message key='ui.alertmsg.level.select' bundle='analytic'/>"+ ";";    
			isValid=false;
        }
    }  
    
    if ( isEmpty(opValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.Opertator.select' bundle='analytic'/>"+ ";" ;    
		isValid=false;
	}

   	if (isEmpty(loLimitValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.lowLimit.select' bundle='analytic'/>"+ ";" ;    
		isValid=false;
	}
                 
   	if ( ! (document.getElementById("currentCondition.highLimit").disabled) ) { 
		if ( isEmpty(highLimitValue) ) {
			msg=msg+"<bean:message key='ui.alertmsg.lowLimit.select' bundle='analytic'/>"+ ";" ;    
			isValid=false;
       	}  
   	} 

	if(!validateMaxLen()){
    	msg = msg + "<bean:message key='ui.desc.maxLength.alertmsg' bundle='analytic'/>"+ ";" ;
    	isValid=false;
    }
	
	if (!isEmpty(trim(msg))) {
		var msgArray = new Array();			
		msgArray = msg.split(";");		
		alert(msgArray[0]);
		
	}

	return isValid;
}

// A common resuable JS function to test empty fields.
function isEmpty(fieldVal) {
	if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
   		return true;
	}
}

function validateNewRuleForm(){
	var isValid=true;
	var nameValue = trim(document.getElementById("reportName").value);
 	if(isEmpty(nameValue)){
		alert("<bean:message key='ui.validate.required.reportName.msg' bundle='analytic'/>") ;   
		isValid=false;
    }
    if(!validateMaxLen()){
    	alert("<bean:message key='ui.desc.maxLength.alertmsg' bundle='analytic'/>");
    	isValid=false;
    }
	return isValid;
}

function submitAnalyticForm() {
 	var frm = document.getElementById("createNewRuleForm");
 	var returnValue = validateNewRuleForm();
	
	//Assign "null" to "SortColumn" and "SortOrder", to get the default sort column 
	//and sort order after report submitted.
 	document.getElementById("listSortColumn").value = "null";
	document.getElementById("listSortOrder").value = "null";
	 	
 	// set the cumulative & 
 	if(returnValue ){
 		frm.action = "/expensemap/analytic/SubmitAnalyticAction.do";
 		frm.submit();
 	}
}

/*
 * Sets the value for include context filter hidden field.
 * @param - includeContextFiltersCheckBox - the check box control
 */
function includeContextFiltersSelected(includeContextFiltersCheckBox) {
	document.getElementById("includeContextFilters").value = includeContextFiltersCheckBox.checked;
	var radioEnabled = document.getElementById("radioEnabled").value;
	
	if(radioEnabled=='true'){
		if ( includeContextFiltersCheckBox.checked == false ) {	
			if( document.getElementById("PERCENT_OF_DRILL_POINT").checked==true || 
			    document.getElementById("PERCENT_OF_NODE_TOTAL").checked==true  ) {
				document.getElementById("NONE").checked=true;
			}
			document.getElementById("PERCENT_OF_DRILL_POINT").disabled=true;
			document.getElementById("PERCENT_OF_NODE_TOTAL").disabled=true;			
		}else if(includeContextFiltersCheckBox.checked==true){
			document.getElementById("PERCENT_OF_DRILL_POINT").disabled=false;
			setPercentNodeTotalOption();
		}
	}
}

/*
 * Sets the value for include session filter hidden field.
 * @param - includeSessionFiltersCheckBox - the check box control
 */
function includeSessionFiltersSelected(includeSessionFiltersCheckBox) {
	document.getElementById("includeSessionFilters").value = includeSessionFiltersCheckBox.checked;
}

function init() {
	// set the "include context filter check-box" if present
	if ( document.getElementById("includeContextFilters") ) {
		if ( document.getElementById("includeContextFilters").value == 'true' ) {
			document.getElementById("includeContextFiltersCheckBox").checked = true;
		} else {
			document.getElementById("includeContextFiltersCheckBox").checked = false;			
		}
	}
	if ( document.getElementById("includeSessionFilters") ) {
		if ( document.getElementById("includeSessionFilters").value == 'true' ) {
			document.getElementById("includeSessionFiltersCheckBox").checked = true;
		} else {
			document.getElementById("includeSessionFiltersCheckBox").checked = false;
		}
	}	
	if ( document.getElementById("includeContextFilters") ) {
		if( document.getElementById("includeContextFiltersCheckBox").checked==false 
		     && document.getElementById("PERCENT_OF_DRILL_POINT").disabled==false) {
			document.getElementById("PERCENT_OF_DRILL_POINT").disabled=true;
		}
	}else{
		document.getElementById("PERCENT_OF_DRILL_POINT").disabled=true;
	}
	
	// % of Node Total option is available only when
	//    a. Selected attribute is of type 'Dimension Measue'
	//    b. User has chosen to use context filters
	var conditionType = '${ createNewRuleForm.currentCondition.type }';
	
	if ( document.getElementById("includeContextFilters") && conditionType == 'DIMENSION_MEASURE' ) {
		if ( document.getElementById("includeContextFiltersCheckBox").checked==false 
			 && document.getElementById("PERCENT_OF_NODE_TOTAL").disabled==false ) {
			document.getElementById("PERCENT_OF_NODE_TOTAL").disabled=true;
		}
	}else{
		document.getElementById("PERCENT_OF_NODE_TOTAL").disabled=true;
	}
	// PR 44120
	// If user has selected dimension count based condition,
	// disable all radio buttons pertaining to %age.
	if ( conditionType == 'DIMENSION_COUNT' ) {
		document.getElementById("NONE").disabled = true;
		document.getElementById("PERCENT_OF_CUBE_TOTAL").disabled = true;
		document.getElementById("PERCENT_OF_DRILL_POINT").disabled = true;
		document.getElementById("PERCENT_OF_NODE_TOTAL").disabled = true;
	}
	var isTopReport = ${ createNewRuleForm.topReport};
	if(isTopReport){
		topReportSelected =true;
	}
	if ( document.getElementById("currentCondition.operator").value == '&gt;' ) {

		document.getElementById("currentCondition.cumulative").disabled = false;
	} 
	document.getElementById("reportName").focus();
}

/*
 * Controls PercentNodeTotalOption enbling
 */
function setPercentNodeTotalOption() {
	if ( document.getElementById("currentCondition.cumulative").checked == true ) {
		if ( document.getElementById("PERCENT_OF_NODE_TOTAL").disabled == false ) {
			document.getElementById("NONE").checked=true;
			document.getElementById("PERCENT_OF_NODE_TOTAL").disabled=true;
		}
	} else {
		// % of Node Total option is available only when
		//    a. Selected attribute is of type 'Dimension Measue'
		//    b. User has chosen to use context filters
		var conditionType = '${ createNewRuleForm.currentCondition.type }';
	
		if ( document.getElementById("includeContextFilters") && 
				conditionType == 'DIMENSION_MEASURE' &&
				document.getElementById("includeContextFiltersCheckBox").checked==true ) {
			document.getElementById("PERCENT_OF_NODE_TOTAL").disabled = false;
		}
	}
}

function validateMaxLen(){
	var maxlen = document.getElementById("desc").value.length;				
	if(maxlen>255){
		return false;
	}
	else{
		return true;
	}
}
function openHelp(){
	open( "<%=helpURL%>", "_blank" );	
}
</script>
</head>
<body class="yui-skin-sam" onload="init();" >
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="createNewRuleForm"/>
</jsp:include>

<logic:messagesPresent message="true">
	<br>
	<font color="red" face="Verdana" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="analytic">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
</logic:messagesPresent>

<br>
<html:form method="post" action="/CreateNewAnalyticAction.do" styleId="createNewRuleForm" onsubmit="return validateCreateNewRuleForm(this);" >
<center>
<!-- show filters applied -->

	<table class="testTable" width="98%">
		<tr>
			<td align="left" colspan="1"><b> <bean:message key="display.filters.CurrentFilters" bundle= "analytic"/>:  </b>	
				<c:if test="${ empty SESSION_FILTERS && empty CONTEXT_FILTERS }">
					<b><bean:message key="ui.label.None" bundle= "analytic"/></b>
				</c:if>	
				<c:if test="${ ! empty SESSION_FILTERS }">	
					<input type="checkbox" id="includeSessionFiltersCheckBox" onclick="includeSessionFiltersSelected(this);" />
					<a class="hEffect" href="javascript:void();" onclick="return false" title="${ SESSION_FILTERS }">
					<bean:message key='ui.ruleform.include.session.filters.label' bundle="analytic"/></a>
					<html:hidden property="includeSessionFilters" styleId="includeSessionFilters" />
				</c:if>		
				<c:if test="${ ! empty SESSION_FILTERS && ! empty CONTEXT_FILTERS }">
					<b>|</b>
				</c:if>
				<c:if test="${ ! empty CONTEXT_FILTERS }">	
					<input type="checkbox" id="includeContextFiltersCheckBox" onclick="includeContextFiltersSelected(this);" />
					<a class="hEffect" href="javascript:void();" onclick="return false" title="${ CONTEXT_FILTERS }"><bean:message key='ui.ruleform.include.context.filters.label' bundle="analytic"/></a>
					<html:hidden property="includeContextFilters" styleId="includeContextFilters" />
				</c:if>	
			</td>
			<td align="right" ><a href="#" onclick="openHelp();"><img  src="/expensemap/jsp/images/help.gif" border="0" title="<bean:message  key='ui.label.Help' bundle='analytic'/>"/></a></td>	
		</tr>
		<tr>
			<td colspan="2"><hr></td>
		</tr>
		<c:if test="${ createNewRuleForm.definedAsTemplate == true && ! empty TEMPLATE_FILTERS }">
			<tr>
				<td align="left" colspan="2">
					<c:if test="${ ! empty TEMPLATE_FILTERS }">
						<b><bean:message key='display.filters.TemplateFilters' bundle="analytic"/> : </b>
						<a title="${ TEMPLATE_FILTERS }"><img src="/expensemap/jsp/images/filter.gif" border="0"></a>
					</c:if>		
				</td>	
			</tr>
			<tr>
				<td colspan="2"><hr></td>
			</tr>
		</c:if>
		<tr>
			<td>
				<table class="tableWithoutBorder" width="70%">
					<tr>
						<td><b><bean:message key='ui.label.Name'
								bundle="analytic" /></b></td>
						<td><html:text property="reportName" styleId="reportName" styleClass="inputStyle" size="60" maxlength="255" /></td>
					</tr>
					<tr>
						<td valign="top"><b><bean:message key='ui.label.Description'
								bundle="analytic" /></b></td>
						<td><html:textarea property="desc" styleId="desc" cols="60" rows="3" styleClass="inputStyle" style="width:320px;"/></td>
					</tr>
				</table>
			</td>
			<td>
				<c:if test="${ createNewRuleForm.canCreateTopReports == true }">
					<table class="tableWithoutBorder" width="70%">	
						<tr>
							<td colspan="2" align="left">
								<b><bean:message key="rpt.listing.column.report.type" bundle="analytic" /></b>
							</td>
						</tr>
						<tr>
							<td>
								<html:radio property="topReport" value="false" styleId="" onclick="enableTopReportCategories(this.checked == false)" >
	        						<b><bean:message key="ui.label.Original" bundle="analytic"/></b>
	        					</html:radio>
	        				</td>
	        			</tr>
	        			<tr>
	        				<td>
	        					<html:radio  property="topReport" value="true" styleId="" onclick="enableTopReportCategories(this.checked == true)">
									<b><bean:message key="ui.label.TopReports" bundle="analytic"/></b>
								</html:radio>&nbsp;
			        			<html:select property="topReportCategory" size="1" styleId="topReportCategory" 
			        				disabled="${ createNewRuleForm.topReport == false }" styleClass="selectStyle" >
			        				<html:optionsCollection name="createNewRuleForm" property="topReportCategoriesList" value="value" label="label" />		
								</html:select>
							</td>
						</tr>
					</table>
				</c:if>
			</td>
		</tr>
		<tr>
			<td colspan="2"><hr></td>
		</tr>
		<tr>
			<td colspan="2">
				<table class="tableWithoutBorder" align="left" width="75%">
					<tr>
						<td align="left" height="9" width="15%"><b><bean:message key="ui.label.ShowAll" bundle="analytic" /></b></td>
						<td align=left height="9">
							<html:select name="createNewRuleForm" property="currentCondition.category" size="1"
								onchange="selectDimension(this.options[selectedIndex]);" styleClass="selectStyle" 
								styleId="currentCondition.category" disabled="${! createNewRuleForm.currentCondition.categoryEnabled }" >
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createNewRuleForm.currentCondition.dimensionList }">
									<html:optionsCollection name="createNewRuleForm" property="currentCondition.dimensionList" label="label" value="value"/>
								</c:if>
							</html:select>
						</td>
					</tr>
					<tr>						
						<td align="left" height="9"><b><bean:message
							key="ui.ruleform.whose.label" bundle="analytic" /></b></td>
						<td align="left">
							<html:select name="createNewRuleForm" property="currentCondition.attribute" size="1" styleClass="selectStyle"
								styleId="currentCondition.attribute" onchange="selectAttribute(this);" onfocus="setPrevSelectValue(this)" 
								disabled="${ empty createNewRuleForm.currentCondition.attributeList }">
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createNewRuleForm.currentCondition.attributeList }">
					            <logic:iterate name="createNewRuleForm" property="currentCondition.attributeList" id="attributeObject" type="com.emptoris.analytics.controllers.actionforms.AttributeHolder">
					            	<logic:equal name="attributeObject" property="disabled" value ="true">
					            		<option value="<%=attributeObject.getName()%>" disabled style="color:graytext"><%=attributeObject.getDisplayName()%></option>						
					            	</logic:equal>
					            	<logic:equal name="attributeObject" property="disabled" value ="false">
										<logic:equal name="createNewRuleForm" property="currentCondition.attribute" value ="<%=attributeObject.getName()%>">
				            				<option value="<%=attributeObject.getName()%>" selected ><%=attributeObject.getDisplayName()%></option>
										</logic:equal>
										<logic:notEqual name="createNewRuleForm" property="currentCondition.attribute" value ="<%=attributeObject.getName()%>">
				            				<option value="<%=attributeObject.getName()%>"><%=attributeObject.getDisplayName()%></option>
										</logic:notEqual>
				            		</logic:equal>
			            		</logic:iterate>
								</c:if>
							</html:select>
						</td>
					</tr>
					<tr>							
						<td align="left" height="9">
							<b><bean:message key="ui.label.level" bundle="analytic" /></b></td>
						<td align="left" height="9">
							<html:select name="createNewRuleForm" property="currentCondition.level" styleId="currentCondition.level" size="1" styleClass="selectStyle"
								disabled="${ empty createNewRuleForm.currentCondition.levelList }" >
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createNewRuleForm.currentCondition.levelList }" >
									<html:optionsCollection name="createNewRuleForm" property="currentCondition.levelList" label="label" value="value" />
								</c:if>
							</html:select>
						</td>
					</tr>
					<tr>
						<td align="left" height="9"><b><bean:message
							key="ui.ruleform.cri.label" bundle="analytic" /></b></td>
						<td align="left" height="9">
							<html:select name="createNewRuleForm" property="currentCondition.operator" size="1" styleClass="selectStyle"  styleId="currentCondition.operator"
								disabled="${ empty createNewRuleForm.currentCondition.operatorList }" onchange="processOperator(this.options[selectedIndex])">
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createNewRuleForm.currentCondition.operatorList }">
									<html:optionsCollection name="createNewRuleForm" property="currentCondition.operatorList" label="label" value="value" />
								</c:if>
							</html:select>
							&nbsp;
							<c:choose>	
								<c:when test="${ !empty createNewRuleForm.currentCondition.selectedAttributeType }" >
									<input type="text" name="currentCondition.lowLimit" id="currentCondition.lowLimit"  size="25"
										 class="inputStyle" maxlength="255" value='<bean:write name="createNewRuleForm" property="currentCondition.lowLimit" filter="false"/>'>
								</c:when>
								<c:otherwise>				
									<input type="text" name="currentCondition.lowLimit" id="currentCondition.lowLimit"  size="25"
										 class="inputStyle" maxlength="255" value='<bean:write name="createNewRuleForm" property="currentCondition.lowLimit" filter="false"/>' disabled>
								</c:otherwise>
							</c:choose>	
																
							<c:choose>
								<c:when test="${ ! empty createNewRuleForm.currentCondition.highLimit }">
									<span id="highLimitSpan" style="visibility:visible;">
									<c:choose>	
										<c:when test="${! empty createNewRuleForm.currentCondition.selectedAttributeType }" >
											<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25" class="inputStyle" maxlength="255" value='<bean:write name="createNewRuleForm" property="currentCondition.highLimit" filter="false"/>'>
										</c:when>
										<c:otherwise>				
											<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25" class="inputStyle" maxlength="255" value='<bean:write name="createNewRuleForm" property="currentCondition.highLimit" filter="false"/>' disabled>
										</c:otherwise>
									</c:choose>
									</span>
								</c:when>
								<c:otherwise>
									<span id="highLimitSpan" style="visibility:hidden;">
									<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25"
											disabled="true"  class="inputStyle" maxlength="50" value='<bean:write name="createNewRuleForm" property="currentCondition.highLimit" filter="false"/>'>
									</span>
								</c:otherwise>
							</c:choose>	
												
						</td>
					</tr>
					<tr>
						<td align="left" height="9"></td>
						<td align="left" height="9">
								<font size="1" color="red"><bean:message key="ui.message.Note.Cumulative.option.supported" bundle='analytic'/></font>
						</td>
					</tr>
					<tr>
						<td height="9">&nbsp;</td>
						<td align="left" height="9">
							<html:checkbox name="createNewRuleForm" property="currentCondition.cumulative" 
								value="true" styleId="currentCondition.cumulative" onclick="setPercentNodeTotalOption();"
								disabled="${! createNewRuleForm.currentCondition.cumulative }">
								<bean:message key='ui.ruleform.cumulative.label' bundle="analytic"/>
							</html:checkbox>
							&nbsp;
							<c:forEach items="${ createNewRuleForm.percentTotalOptions }" var="percentTotalOption" >
								<html:radio property="currentCondition.percentTotalOption" 
									value="${ percentTotalOption.name }" 
									styleId="${ percentTotalOption.name }" 
									disabled="${! createNewRuleForm.currentCondition.percentEnabled }">
									<bean:message key='${ percentTotalOption.resourceKey }' bundle="analytic"/>
								</html:radio>																
							</c:forEach>
							<input type="hidden" id="radioEnabled" name="radioEnabled" value="${createNewRuleForm.currentCondition.percentEnabled }">
						</td>
					</tr>
					<tr>
						<td style="font-size:10pt" align="left" height="9" colspan="2">
							<html:button property="add" onclick="addNewCondition();" 
								disabled="${ createNewRuleForm.canAddMoreConditions == false }">
								<bean:message key='button.add.criteria' bundle='analytic'/>
							</html:button>
						</td>
					</tr>
				</table>
			</td>
		</tr>
		<c:if test="${ not empty createNewRuleForm.savedConditions }">
		<tr>
			<td valign="top" colspan="2"><hr></td>
		</tr>
		<tr>
			<td colspan="2">
				<table class="tableWithoutBorder" align=center width="100%">
					<c:forEach items="${ createNewRuleForm.savedConditions }" var="condition" varStatus="count" >
						<tr>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.categoryDisplayName }</option>
								</select>
							</td>
							<td align="left" height="9">
								<c:choose>
									<c:when test="${ condition.cumulative }">
										<input type="checkbox" disabled="disabled" checked >
									</c:when>
									<c:otherwise>
										<input type="checkbox" disabled="disabled" >
									</c:otherwise>
								</c:choose>
								<bean:message key='ui.ruleform.cumulative.label' bundle="analytic"/>
							</td>
							<td>
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.attributeDisplayName }</option>
								</select>
							</td>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<c:choose>
										<c:when test="${ ! empty condition.level && condition.level != -1 }">
											<option>${ condition.level - 1 }</option>
										</c:when>
										<c:when test="${ ! empty condition.level && condition.level == -1 }">
											<option><bean:message key='ui.options.all.leaf.nodes' bundle="analytic"/></option>
										</c:when>
										<c:otherwise>
											<option><bean:message key='ui.options.please.select' bundle="analytic" /></option>
										</c:otherwise>
									</c:choose>
								</select>
							</td>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.operator }</option>
								</select>
							</td>
							<td align="left" height="9">
								<input type="text" disabled="disabled" class="inputStyle" size="10" value="${ condition.lowLimit }" title="${ condition.lowLimit }">
								<c:choose>
									<c:when test="${ ! empty condition.highLimit }">
										<span style="visibility:visible;">
											<input type="text" disabled="disabled" size="10" class="inputStyle" value="${ condition.highLimit }" title="${ condition.highLimit }">
										</span>
									</c:when>
									<c:otherwise>
										<span style="visibility:hidden;">
											<input type="text" disabled="disabled" size="10" class="inputStyle" value="" >
										</span>
									</c:otherwise>
								</c:choose>
								<input type="radio" disabled="disabled" checked="checked" /><bean:message key='${ condition.percentTotalOption.resourceKey }' bundle="analytic"/>
							</td>
							<td style="font-size:10pt" align="left" height="9">
								<html:button property="delete" onclick="deleteCondition(${ count.index });" 
									disabled="${ createNewRuleForm.savedConditionCount != count.count }">
									<bean:message key='ui.search.button.remove' bundle='analytic'/>
								</html:button>
							</td>
						</tr>
					</c:forEach>
				</table>
			</td>
		</tr>
		</c:if>
		<tr>
			<td valign="top" align="center" colspan="2"><hr></td>
		</tr>				
		<tr>
			<td align="center" colspan="2">
				<table>
					<tr>
						<c:choose>
							<c:when test="${ createNewRuleForm.definedAsTemplate }">
								<td style="font-size:10pt">					
									<html:button property="createTemplate" onclick="saveTemplate(true);"
										disabled="${ createNewRuleForm.savedConditionCount == 0 }" >
										<bean:message key='button.create.new.template' bundle="analytic" />
									</html:button>
								</td>
								<c:if test="${ createNewRuleForm.templateUpdateAllowed }">
								<td style="font-size:10pt">							
									<html:button property="updateTemplate" onclick="saveTemplate(false);"
										disabled="${ createNewRuleForm.savedConditionCount == 0 }" >
										<bean:message key='button.update.template' bundle="analytic" />
									</html:button>
								</td>
								</c:if>
							</c:when>
							<c:otherwise>
								<td style="font-size:10pt">
									<html:button property="saveBtn" onclick="saveTemplate(true);" 
										disabled="${ createNewRuleForm.savedConditionCount == 0 }">
										<bean:message key='button.saveAsTemplate' bundle="analytic" />
									</html:button>
								</td>
							</c:otherwise>
						</c:choose>
						<td style="font-size:10pt">
							<html:button property="submitBtn" onclick="submitAnalyticForm();"
								disabled="${ createNewRuleForm.savedConditionCount == 0 }" >
								<bean:message key='button.submit' bundle="analytic" />
							</html:button>
						</td>
						<td style="font-size:10pt">
							<html:button property="cancelBtn" onclick="cancelAnalyticForm();">
								<bean:message key='ui.label.Cancel' bundle="analytic" />
							</html:button>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
	<input type="hidden" name="createNew" id="createNew" value="${ createNewRuleForm.definedAsTemplate == false }" />
	<c:if test="${ createNewRuleForm.definedAsTemplate == true }">
		<input type="hidden" name="templateId" id="templateId" value="${ createNewRuleForm.templateId }" />
	</c:if>
	<input type="hidden" name="listSortColumn" id="listSortColumn" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortColumn"))%>">
	<input type="hidden" name="listSortOrder"    id="listSortOrder"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortOrder"))%>">
	<input type="hidden" name="listLimitRec"    id="listLimitRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listLimitRec"))%>">
	<input type="hidden" name="listStartRec"    id="listStartRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listStartRec"))%>">
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</center>
</html:form>

<script language="JavaScript">

YAHOO.namespace('emptoris.analytics.search.UI');
(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.emptoris.analytics.search.UI = {
		init: function() {
			var self = YAHOO.emptoris.analytics.search.UI;
			var fromDateField = document.getElementById("currentCondition.lowLimit");
			var toDateField = document.getElementById("currentCondition.highLimit");
			var attributeType = '${ createNewRuleForm.currentCondition.selectedAttributeType }';
			if ( attributeType == 'DATE' ) {
				Event.on(fromDateField, "focus", self.openCalendar, [fromDateField, fromDateField]);
				Event.on(toDateField, "focus", self.openCalendar, [toDateField, toDateField]);
			}
		},

		openCalendar: function(e, args) {	
    		YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
		}
	}

	Event.onDOMReady(YAHOO.emptoris.analytics.search.UI.init, YAHOO.emptoris.analytics.search.UI, true);
})();
</script>


</body>
</html:html>