﻿<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.emptoris.analytics.common.util.AnalyticUtility"%>
<%@include file="../includes/tlib.jspf"%>
<%@ page import="java.io.PrintWriter"%>
<%@ page import="java.util.*"%>
<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.List,java.util.ArrayList"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticReportVO"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticColumnMetaData"%>
<%@page import="com.emptoris.analytics.common.valueobjects.AnalyticRequestContext"%>
<%@page import="com.zeborg.expensemap.analytic.ColumnType"%>
<%@page import="com.zeborg.expensemap.analytic.AnalyticCondition"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.ColumnVO"%>
<%@ page import="com.zeborg.expensemap.analytic.ReportType"%>
<%@ page import="com.zeborg.expensemap.view.TableViewUtil" %>
<%@ page import="com.zeborg.util.WebUtil" %>
<%@ page import="com.zeborg.util.EncodeUtil" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.zeborg.expensemap.analytic.TrendAnalyticCondition,com.zeborg.expensemap.analytic.TopnAnalyticCondition" %>
<%
	PrintWriter op = new PrintWriter(out, true);
	//String reportName = ((AnalyticRequestContext) request.getAttribute("exportReportContext")).getReportName();
	String reportName = request.getParameter("reportName");
	AnalyticRequestContext context= (AnalyticRequestContext) request.getAttribute("exportReportContext");
	boolean isTransactionReport = context.getReportType().equals(ReportType.TRANSACTION);
	ColumnVO[] prefs = context.getUserPreferences();
	response.reset();
	String encoding = WebUtil.getEncoding();
	String charSet = "charset="+ ((null == encoding) ? "UTF-8" : encoding);
                      response.setContentType("application/vnd.ms-excel;" + charSet);
	String dateToday = new SimpleDateFormat("MM_dd_yyyy").format(new Date());
	// 42718 use underscore instead of problematic characters in filename.
	String formattedFilename = URLEncoder.encode(EncodeUtil.specialcharToUnderscore(TableViewUtil.decode(reportName))+ ".csv","UTF-8").replace("+","");
	response.setHeader("Content-Disposition", "attachment; filename="+formattedFilename+ "; filename*=UTF-8''"+formattedFilename);
	response.setHeader("Content-Type", "application/octetstream;" + "UTF-8");
	AnalyticReportVO rptVO = (AnalyticReportVO) request.getAttribute("exportToExcel");
	List data = null;
	List columnLabels = ((AnalyticRequestContext) request.getAttribute("exportReportContext")).getColumnLabels();
	data = rptVO.getData();
	String reportType = ((AnalyticRequestContext) request.getAttribute("exportReportContext")).getReportType().toString();
	List analyticConditions = ((AnalyticRequestContext) request.getAttribute("exportReportContext")).getAnalyticConditions();
	TrendAnalyticCondition trendCondition = ((AnalyticRequestContext) request.getAttribute("exportReportContext")).getTrendAnalyticCondition();
	TopnAnalyticCondition topnCondition = ((AnalyticRequestContext) request.getAttribute("exportReportContext")).getTopnAnalyticCondition();
%>
<%@page import="com.zeborg.expensemap.analytic.PercentTotalOptions"%>
<bean:message key="rpt.cubeName" bundle="analytic" />:${ cube }
<bean:message key="ui.label.User" bundle="analytic" />:${ exportReportContext.user }
<bean:message key="ui.report.table.header.name" bundle="analytic" />:<%=TableViewUtil.decode(context.getReportName()) %>

<bean:message key="ui.analyticsReport.criteria" bundle="analytic" />:
<%
	for(int i=0;i<analyticConditions.size();i++){
		AnalyticCondition acVO = (AnalyticCondition)analyticConditions.get(i);
		if(i==0){ 	
%><%if(topnCondition==null){%><bean:message key="ui.label.ShowAll" bundle= "analytic"/><%}else{%><bean:message key="button.show" bundle= "analytic"/><%}%> <%=TableViewUtil.decode(acVO.getCategoryDisplayName())%><%=" "%><%if(topnCondition!=null){%> <bean:message key="ui.ruleform.by.label" bundle="analytic" /> <%=TableViewUtil.decode(topnCondition.getSortByDisplayName())%> <%if(analyticConditions.size()>1){%><bean:message key="ui.ruleform.whose.label" bundle="analytic" /><%}}else{%><bean:message key="ui.ruleform.whose.label" bundle= "analytic"/><%}} if(!acVO.isHiddenRule()){if(acVO.isCumulative() == true){%> <bean:message key="ui.ruleform.cumulative.label" bundle= "analytic"/><%}	if(acVO.getLevel()!=null && !"".equals(acVO.getLevel()) && !"-1".equals(acVO.getLevel())){%> <bean:message key="ui.label.level" bundle= "analytic"/><%= " " + (Integer.parseInt(acVO.getLevel()) -1)%><%} %> 
<%if(acVO.getLevel() != null && !"".equals(acVO.getLevel()) && "-1".equals(acVO.getLevel())){%> 
<bean:message key="ui.label.leaf.level.node" bundle= "analytic"/><%=" "%>
<%} %>
<%=  TableViewUtil.decode(acVO.getAttributeDisplayName())%> <%=  TableViewUtil.decode(acVO.getOperatorDisplayName())%><%	if( ! acVO.getPercentTotalOption().equals(PercentTotalOptions.NONE) ){%><%= acVO.getVirtualLowLimit()%><bean:message key="<%=acVO.getPercentTotalOption().getResourceKey()%>" bundle= "analytic"/><%} else {%> <%=TableViewUtil.decode(acVO.getVirtualLowLimit())%><%	if( "between".equalsIgnoreCase(acVO.getOperatorDisplayName())){%><%=" "%><bean:message key="ui.ruleform.label.and" bundle= "analytic"/><%=" "%><%= acVO.getVirtualHighLimit()%><%	}	}	}}%>
<%if(trendCondition != null){ %>
<bean:message key="ui.ruleform.for.label" bundle="analytic"/><%=" "%><%=trendCondition.getTimeDimensionDisplayName()%><% if(trendCondition.getTrendType().equalsIgnoreCase("discrete")){ %><%=" "%><bean:message key="ui.operator.Between" bundle="analytic"/><%=" "%><%=trendCondition.getStartPeriodHierarchyStr()%> <bean:message key="ui.ruleform.label.and" bundle="analytic"/><%=" "%><%=trendCondition.getEndPeriodHierarchyStr()%><% }else if(trendCondition.getTrendType().equalsIgnoreCase("continuous")){ %>	<%if(trendCondition.getTimeDimension().equalsIgnoreCase("dimtime")){%><%=" "%><bean:message key="ui.ruleform.for.label" bundle="analytic"/><%=" "%><bean:message key="<%=AnalyticUtility.getAllTimePeriodDisplayName(trendCondition.getTimePointLevel())%>" bundle="analytic" /><%}else{Integer level = new Integer(trendCondition.getTimePointLevel());%><%=" "%><bean:message key="ui.ruleform.all.label" bundle="analytic"/><%=" "%><bean:message key="ui.label.level" bundle="analytic"/><%=" "%><%=level.intValue()-1%><%	}}}// end if null%>
<%if(topnCondition!=null && topnCondition.getTopNLimitValue()!=null){%>
<% String resourceKeyId = "ui.options."+topnCondition.getTopNLimitClause().toLowerCase();%>
<bean:message key="ui.label.display" bundle="analytic" /> <bean:message key="<%=resourceKeyId%>" bundle="analytic" /> <c:out value="${ reportContext.topnAnalyticCondition.topNLimitValue }" /><c:choose><c:when test="${reportContext.topnAnalyticCondition.reportOnPercentMeasure}"><bean:message key="ui.label.percent.of" bundle="analytic" /> <%=TableViewUtil.decode(topnCondition.getSortByDisplayName())%></c:when><c:otherwise> <bean:message key="ui.label.export.to.excel.rows" bundle="analytic" /></c:otherwise></c:choose>
<%}%>
<bean:message key="display.filters.AdditionalFilters" bundle= "analytic"/>:<%if(context.getSessionFilters().isEmpty()&& context.getContextFilters().isEmpty()) {%><bean:message key="ui.label.None" bundle= "analytic"/><%}%>
<% if(!context.getSessionFilters().isEmpty()){%>
<bean:message key="display.filters.SessionFilters"  bundle="analytic"/>:
<%=TableViewUtil.decode(context.getFormattedSessionFilters().replaceAll("&#10;","\n"))%>
<%}%>


<%if(!context.getContextFilters().isEmpty()){%>
<bean:message key="display.filters.ContextFilters"  bundle="analytic"/>:
<%=TableViewUtil.decode(context.getFormattedContextFilters().replaceAll("&#10;","\n"))%>
<%}%> 


<%
	StringBuffer sb = new StringBuffer();
	AnalyticColumnMetaData columnMetaData = null;
	int start =0;
	if("DIMENSION".equalsIgnoreCase(reportType)||"TREND".equalsIgnoreCase(reportType)||"TOPN".equalsIgnoreCase(reportType)){
		start=1;
	}
	
	for (int i = start; i < columnLabels.size(); i++) {
	if(isTransactionReport){
	if(!prefs[i].isHidden() ){
		columnMetaData = (AnalyticColumnMetaData) columnLabels.get(i);
		if ( columnMetaData.getType().equals(ColumnType.AMOUNT) ) {
			sb.append(TableViewUtil.decode(columnMetaData.getDisplayName())).append("(").append(TableViewUtil.decode(columnMetaData.getCurrencySymbol())).append("),");
		} else {
			sb.append(TableViewUtil.decode(columnMetaData.getDisplayName())).append(",");
		}
	}
	}else{
	
	        columnMetaData = (AnalyticColumnMetaData) columnLabels.get(i);
			if ( columnMetaData.getPercentageOfMeasure() == 1 ||  columnMetaData.getPercentageOfMeasure() == 2) {
				sb.append(TableViewUtil.decode(columnMetaData.getDisplayName())).append("(%),");
			}else if ( columnMetaData.getType().equals(ColumnType.AMOUNT) ) {
				sb.append(TableViewUtil.decode(columnMetaData.getDisplayName())).append("(").append(TableViewUtil.decode(columnMetaData.getCurrencySymbol())).append("),");
			} else {
				sb.append(TableViewUtil.decode(columnMetaData.getDisplayName())).append(",");
		}
	
	}
	
	
		
	}
	sb.deleteCharAt(sb.length() - 1);
	op.println(sb.toString());
	Object val = "";
	for (int j = 0; j < data.size(); j++) {
		sb.setLength(0);
		List analyticDataValues = (ArrayList) data.get(j);
		for (int k = start; k < analyticDataValues.size(); k++) {
		if(isTransactionReport){
		if(!prefs[k].isHidden() ){
			val = analyticDataValues.get(k);
			sb.append("\"").append(val).append("\"").append(",");
		  }
		 }else{	// 43728 if column is level num subtract 1 as level display should start from 0 
			 if(k==1){		 		
			     	int levelVal = Integer.parseInt(analyticDataValues.get(k).toString());
			     	levelVal--;
			     	val = levelVal;		     	
			 	}
			 	else{
			 		val = analyticDataValues.get(k);
			 	}
		     sb.append("\"").append(val).append("\"").append(",");
		 } 
		  
		  
		}
		sb.deleteCharAt(sb.length() - 1);
		op.println(sb.toString());
	}//end of for i	
%>
