<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticRequestContext"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%
	String dashboardPanelId = request.getParameter("dashboardPanelId");
	AnalyticRequestContext context = (AnalyticRequestContext) session.getAttribute("reportContext"+dashboardPanelId);
	
	pageContext.setAttribute("dashboardPanelId",dashboardPanelId);
	pageContext.setAttribute("reportContext",context);
%>
<html>
<head>
<style>
			a, A:link, a:visited, a:active, A:hover
				{color: #330099;}
		</style>
<link rel="stylesheet" type="text/css"
	href="/expensemap/jsp/analytics/scripts/analyticscss.css">
<script language="javascript">
		<!-- 
		var buttonSelected = false;
		
		function selectCheckBox(checkBox, flag) {
			if ( checkBox.disabled == false ) {
				checkBox.checked = flag ;
			}
		}


	function printReport(action){
		var isEmpty='${ empty reportVO.data }';
		if(isEmpty=='true')	{
			alert("<bean:message key='errors.noprintdata'  bundle ='analytic'/>");
			return false;
		} else {	
			var frm = document.getElementById("reportRenderForm");
			frm.method="post";
			frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction="+action+"&pageType=_pf"
			+"&dashboardPanelId="+'${dashboardPanelId}';
			frm.target='_new';
			frm.submit();
			frm.target='_self';
		}
	}
		   
		      
	function selectAll(){
		alert("<bean:message key='ui.label.Select.All'  bundle='analytic'/>");
	}
	
	function submitFormForSorting(columnId) {
	    var order = document.getElementById("sortOrder").value;
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do?dashboardPanelId=" + '${dashboardPanelId}';
		if(order=='ASC'){
			order='DESC';
		}else if(order=='DESC'){
			order='ASC';
		}
		document.getElementById("sortOrder").value=order;
		document.getElementById("sortColumn").value=columnId;
		frm.submit();

	}
	function paginate(action){
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction="+action+"&dashboardPanelId=" + '${dashboardPanelId}';;
		frm.submit();
	}
	
   	function setArraow() {

	}
		
	// A JS function to request data for a specific level.
	function getDataForLevel(selectedLevel) {
		var frm = document.getElementById("reportRenderForm");
		document.getElementById("Level").value = selectedLevel.value;
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do?dashboardPanelId=" + '${dashboardPanelId}';
		frm.submit();
	}
	function openHelp(){
    	open( "${helpURL}", "_blank" );
    }
    //These void implementations are mandatory ,please do not remove these methods
    function updateOnDrill(nodeId, nodeName, dimensionName, bookMarkId ) {}
    function reset(bookMarkId){}
    
</script>
</head>
<body onload="setArraow();">
<form name="reportRenderForm" id="reportRenderForm">
<c:if test="${ empty reportVO.data }" >
	<br>
	<font color="red" face="Verdana" size="2"><b><bean:message
		key="error.com.emptoris.analytics.noDataFound" bundle="analytic" /></b></font>
</c:if>
<br>
<table class="tableWithBorderAna" align="center">
	<tr>
		<td align="left"><b><bean:message key="ui.analytics.Title" bundle= "analytic"/></b></td>
		<td align="center"><b><bean:message key="rpt.cubeName" bundle= "analytic"/>: ${cube}</b></td>			
		<td align="right">
			<a href="#" onclick="printReport('getCurrent');">
				<img src="/expensemap/jsp/images/print.gif"
					title="<bean:message key='ui.print.image.tooltip'  bundle= "analytic" />"
					border="0"></a>&nbsp;
			<a href="#" onclick="openHelp();">
				<img src="/expensemap/jsp/images/help.gif"
					title="<bean:message key='ui.label.Help'  bundle= "analytic"/>"
					border="0"></a>&nbsp;
		</td>
	</tr>
</table>
<table class="InnerTableWithBorderAna" align="center">
	<tr>
		<td><b><bean:message key="ui.report.table.header.name"
			bundle="analytic" /> : <c:out value="${ reportContext.reportName }"/> </b></td>
	</tr>		
		
	<tr>
		<td><b><bean:message key="ui.analyticsReport.criteria"	bundle="analytic" />:</b>
			<c:forEach items="${ reportContext.analyticConditions }"	var="condition" varStatus="status">
				<c:if test="${ status.count == 1 }">			
					<bean:message key="ui.label.ShowAll" bundle= "analytic"/>&nbsp;${ condition.categoryDisplayName }
					&nbsp;<bean:message key="ui.ruleform.whose.label" bundle= "analytic"/>				
				</c:if>
				<tr>
				<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		
				<c:if test="${ condition.category != 'Transactions' }">
							${ condition.categoryDisplayName }&nbsp;
				</c:if>
			   				${ condition.attributeDisplayName }&nbsp;
							${ condition.operatorDisplayName }&nbsp;
							${ condition.lowLimit }&nbsp;
				<c:if test="${ ! empty condition.highLimit }">
					<bean:message key="ui.ruleform.label.and" bundle= "analytic"/>&nbsp;${ condition.highLimit }
				</c:if>
				</td>
				</tr>	
			</c:forEach>
		</td>		
	</tr>
	<tr>
		<td align="left" colspan="2"><b> <bean:message key="display.filters.AdditionalFilters" bundle= "analytic"/>:  </b>	
			<c:if test="${ empty reportContext.sessionFilters && empty reportContext.contextFilters }">
				<b><bean:message key="ui.label.None" bundle= "analytic"/></b>
			</c:if>
			<c:if test="${ ! empty reportContext.sessionFilters }">	
				<a title="${ reportContext.formattedSessionFilters }"><b><bean:message key="display.filters.SessionFilters"  bundle="analytic"/></b></a>&nbsp;<img src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;		
			</c:if>		
			<c:if test="${ ! empty reportContext.contextFilters }">	
				<a title="${ reportContext.formattedContextFilters }"><b><bean:message key="display.filters.ContextFilters"  bundle="analytic"/></b></a>&nbsp;<img src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;		
			</c:if>	
		</td>	
	</tr>
</table>
<br>
<table class="tableWithBorderAna" align="center">
<tr>
	<c:forEach items="${ reportContext.columnLabels }" var="column" varStatus="columnCount" >
	    <c:if test="${ !reportContext.userPreferences[columnCount.count-1].hidden }" >
		<td NOWRAP class="thead" align="center">
			<a href="#" onclick="submitFormForSorting('${ columnCount.count }')" >
			<c:choose>
				<c:when test="${ column.type == 'AMOUNT' }">
					${ column.displayName }(${ column.currencySymbol })
				</c:when>
				<c:otherwise>
					${ column.displayName }					
				</c:otherwise>
			</c:choose>
			
			<c:if test="${ columnCount.count == reportContext.sortColumn }">
				<c:choose>
					<c:when test="${ 'ASC' == reportContext.sortOrder }">
						<img src="/expensemap/jsp/images/up.gif" border="0">
					</c:when>
					<c:otherwise>
						<img src="/expensemap/jsp/images/down.gif" border="0">
					</c:otherwise>
				</c:choose>			
              </c:if>
		    </a>
        </td>                          
	</c:if>  
  </c:forEach>
</tr>

<c:forEach items="${ reportVO.data }" var="row" varStatus="rowNum">
 
	<c:choose>
		<c:when test="${ rowNum.count % 2 == 0 }">
			<tr class="trEven">
		</c:when>
		<c:otherwise>
			<tr class="trOdd">
		</c:otherwise>
	</c:choose>
	
	<c:forEach items="${ row }" var="column" varStatus="colNum" >
	 <c:if test="${ !reportContext.userPreferences[colNum.index].hidden }" >
		<td align="${ reportContext.columnLabels[colNum.index].type.alignment }">${ column }</td>
	  </c:if> 	
	</c:forEach>
	</tr>
  
</c:forEach>

</table>
<c:if test="${ ! empty reportVO.data }" >
	<br>
	<table width="98%" align="center" >
		<tr align="center">			
			<td colspan="3">
				<jsp:include flush="true" page="pagination.jsp">
					<jsp:param name="isDataPresent"	value="${ ! empty reportVO.data }" />
					<jsp:param name="pageSize" value="${reportContext.pageSize }" />
					<jsp:param name="totalRec" value="${reportContext.totalRec }" />
					<jsp:param name="startRec" value="${reportContext.startRec }" />
					<jsp:param name="limitRec" value="${reportContext.limitRec }" />
					<jsp:param name="maxRecordPerPage" value="${reportContext.pageSize }" />
				</jsp:include>
			</td>
		</tr>
	</table>
</c:if>
<br>

<input type="hidden" name="sortOrder" id="sortOrder" value="${ reportContext.sortOrder }" />
<input type="hidden" name="sortColumn" id="sortColumn"	value="${ reportContext.sortColumn }" />
<input type="hidden" name="reportId" id="reportId" value="${ reportContext.reportId }" />
<input type="hidden" name="eriId" id="eriId" value="${ reportContext.eriId }" />
<input type="hidden" name="reportName" id="reportName" value="${ reportContext.reportName }" />
<input type="hidden" name="reportType" id="reportType" value="${ reportContext.reportType }" />
<input type="hidden" name="listSortColumn" id="listSortColumn" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortColumn"))%>">
<input type="hidden" name="listSortOrder"    id="listSortOrder"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortOrder"))%>">
<input type="hidden" name="listLimitRec"    id="listLimitRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listLimitRec"))%>">
<input type="hidden" name="listStartRec"    id="listStartRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listStartRec"))%>">
<c:if test="${ ! empty reportContext.baseDimensionLevels }">
	<input type="hidden" name="Level" id="Level" value="${ reportContext.level }" />
</c:if>
</form>
</body>
</html>
