<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf"%>
<%@ page import="java.util.*, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticRequestContext"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession, java.util.Date,java.text.SimpleDateFormat" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil,com.zeborg.expensemap.view.HelpUtil,com.zeborg.util.WebUtil" %>
<%@ page import="com.emptoris.analytics.common.valueobjects.*,org.apache.struts.util.LabelValueBean" %>
<%@ page import="com.zeborg.expensemap.util.AnalyticsQueryBuilder,java.util.Map"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,
com.zeborg.expensemap.il8n.EmLocalizationManager,com.zeborg.acl.util.LocaleUtil,
com.zeborg.expensemap.util.ExpenseMapAppProperties, com.zeborg.expensemap.view.CubeUtil"
%>
<%@page import="com.zeborg.expensemap.analytic.AnalyticCondition"%>
<%@ page import="com.zeborg.expensemap.model3.ExpensemapACLUtil"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%
boolean checkAll = false;
ZSession zs = ZSessionUtil.getFromSession(pageContext);
String expFrame = zs.getExpensemapFrame();
StringBuffer sbuf = new StringBuffer();
AnalyticRequestContext context = (AnalyticRequestContext) session.getAttribute("reportContext");
Set<String> multikeeps = new HashSet<String>();
if(context.getMultiKeeps() != null){
	multikeeps = context.getMultiKeeps();
}
int currentLevel = context.getLevel();
Map<String,Set<String>> nodesPerLevel = context.getNodesPerLevel();
Set<String> nodeSet = nodesPerLevel.get(String.valueOf(currentLevel));
if(multikeeps.containsAll(nodeSet)){
	checkAll = true;
}
if(nodeSet.isEmpty()){
	checkAll = false;
}
AnalyticReportVO reportData = (AnalyticReportVO)request.getAttribute("reportVO");
List<List<Object>> data = reportData.getData();
if (multikeeps != null) {
	sbuf.append("[");
	for(int i=0;i<data.size();i++){
		List<Object> list = (List<Object>)data.get(i);
		
		String id = list.get(0).toString();
		if(multikeeps.contains(id)){
			sbuf.append("\"");
			sbuf.append(id);
			sbuf.append("\"");
			sbuf.append(",");
		}
	}
	if (sbuf.indexOf(",") > 0) {
		sbuf = new StringBuffer(sbuf.substring(0, sbuf.lastIndexOf(",")));
	}
	sbuf.append("]");
}
	EmResourceBundle bundle=EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE, zs.getUser().getLocale());
	Locale locale = zs.getUser().getLocale();	
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.view.analytic.report.help.page", locale);
	int warnLimit = ExpenseMapAppProperties.getEmMaxNodeApplyLimitWarning();
	String maxLimit = String.valueOf(ExpenseMapAppProperties.getEmMaxNodeApplyLimit());
	CubeUtil.buildExpMapMastHead(out,"viewFrame_analytic.jsp",zs,true,null,zs.getUser().getLocale(),null);
	EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, zs.getUser().getLocale());
	String title = ExpenseMapAppProperties.getExpensemapTitle();
	title = title + " - " + baseBundle.getValue("ui.analytics.Title");
	
%>

<html>
<head>
<title><%=title%></title>
<style>
a, A:link, a:visited, a:active, A:hover	{color: #330099;}
</style>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css">
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/export.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />

<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>

<style type="text/css">
<!--
	.popupMenu {
		position: absolute;
		width:200px;
		background-color: #D9E2EB;
		border:1px solid black;
		font: normal 8px Arial;
		line-height: 10px;
		z-index: 100;
		visibility: hidden;
	}
	.buttonStyle{
		font: 10px arial;
	}
	#popupMenu a{
		text-decoration: none;
		padding-left: 6px;
		color: black;
		display: block;
	}
-->
</style>
</head>

<body class="yui-skin-sam">
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="reportRenderForm"/>
</jsp:include>

<form name="reportRenderForm" id="reportRenderForm">
<jsp:include page="/jsp/includes/commonExportUI.jsp"/>
<c:if
	test="${ empty reportVO.data }">
	<br>
	<font color="red" face="Verdana" size="2"> <b><bean:message
		key="error.com.emptoris.analytics.noDataFound" bundle="analytic" /></b>
	</font>
</c:if> <br>
<table class="tableWithBorderAna" align="center">
	<tr>
		<td align="left"><b><bean:message key="ui.analytics.Title"
			bundle="analytic" /></b></td>
		<td align="center"><b><bean:message
			key="rpt.cubeName" bundle="analytic" />: ${cube}</b></td>
		<td align="right">
		<c:choose>	
				<c:when  test="${ !empty reportVO.data || !empty reportVO.chartData}">
		<%if(ExpensemapACLUtil.hasViewDimensionalExplorerPermission(zs.getUser(), zs.getDataSet())){ %>
			<a onclick="processMultikeepRequest(document.reportRenderForm.ids,'${ reportVO.size }', event);"
				href="#" ><img src="/expensemap/jsp/images/keeponly.gif"
					title="<bean:message key='ui.keeponly.image.tooltip'  bundle= "analytic" />"
				border="0"></a>
			&nbsp;
		<%}%>	
			<c:if test="${ canExportAnalyticReport == 'true'  }">
				<a href="#" onclick="openExportBox('<esapi:html><c:out value="${reportContext.reportName}" /></esapi:html>');">
					<img src="/expensemap/jsp/images/excel.gif"
						title="<bean:message key='ui.label.export.to.excel' bundle= "analytic" />"	border="0"></a>
				&nbsp;
			</c:if>
			<a href="#" id="print">
				<img src="/expensemap/jsp/images/print.gif"
					title="<bean:message key='ui.print.image.tooltip'  bundle= "analytic" />"
					border="0"></a>
			&nbsp;
				</c:when>
			</c:choose>	
			<a href="#" onclick="openHelp();">
				<img src="/expensemap/jsp/images/help.gif"
					title="<bean:message key='ui.label.Help'  bundle= "analytic"/>"
					border="0"></a>
		</td>
	</tr>
</table>
<table class="InnerTableWithBorderAna" align="center">
	<tr>
		<td><b><bean:message key="ui.report.table.header.name"
			bundle="analytic" /> <esapi:html>: ${ reportContext.reportName }</esapi:html></b></td>		
	</tr>
	<tr>
		<td><b><bean:message key="ui.analyticsReport.criteria"
			bundle="analytic" />:</b> 
			<%
				//PR-44080
				String conditionalFlag = "";
				List  reportList = context.getAnalyticConditions();
				Iterator iterator = reportList.iterator();
			%>
			<c:forEach items="${ reportContext.analyticConditions }" var="condition"
				varStatus="status">				
				<%	
					//pr-44080 if the language is japanese,then query is retrived from property file
					//by passing placehoders .
					if(zs.getUser().getLocale().getLanguage()=="ja"){
						AnalyticCondition vo = (AnalyticCondition)iterator.next();			
				%>				
							<tr> <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
								&nbsp;
								<c:if test="${ condition.cumulative == true }">
									<%conditionalFlag += "Cumulative";%>					
								</c:if>
								<c:if test="${ ! empty condition.level }">
									<%conditionalFlag += "Level";%>
								</c:if>
								<c:if test="${ ! empty condition.highLimit }">
									<%conditionalFlag += "HighLimit";%>
								</c:if>
								<c:if test="${ condition.percentTotalOption.name != 'NONE' }">
									<%conditionalFlag += "NotNone";%>		
								</c:if>
								<%=AnalyticsQueryBuilder.getQuery(vo,bundle,conditionalFlag)%>
								<%conditionalFlag= "";%>							
							</td></tr>			
					<%}else {%>
						<c:if test="${ status.count == 1 }">
							<bean:message key="ui.label.ShowAll" bundle="analytic" />&nbsp;${ condition.categoryDisplayName }
						&nbsp;<bean:message key="ui.ruleform.whose.label" bundle="analytic" />
						</c:if>
						<tr>
							<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							<c:if test="${ condition.cumulative == true }">
								<bean:message key="ui.ruleform.cumulative.label" bundle="analytic" />&nbsp;
							</c:if>
							<c:if test="${ ! empty condition.level && condition.level != -1}">
								<bean:message key="ui.label.level" bundle="analytic" />&nbsp;${ condition.level -1}&nbsp;
							</c:if>
							<c:if test="${ ! empty condition.level && condition.level == -1}">
								<bean:message key="ui.label.leaf.level.node" bundle="analytic" />&nbsp;
							</c:if>
							${ condition.attributeDisplayName }&nbsp; ${ condition.operatorDisplayName }&nbsp;${ condition.virtualLowLimit}&nbsp;
							<c:if test="${ ! empty condition.virtualHighLimit }">
										<bean:message key="ui.ruleform.label.and" bundle="analytic" />&nbsp;${ condition.virtualHighLimit }
							</c:if>
							<c:if test="${ condition.percentTotalOption.name != 'NONE' }">
								<bean:message key="${ condition.percentTotalOption.resourceKey }" bundle="analytic" />&nbsp;
							</c:if>
							</td>
						</tr>
					<%}%>

			</c:forEach>
		</td>
	</tr>
	<tr>
		<td align="left"><b> <bean:message
			key="display.filters.AdditionalFilters" bundle="analytic" />: </b> <c:if
			test="${ empty reportContext.sessionFilters && empty reportContext.contextFilters }">
			<b><bean:message key="ui.label.None" bundle="analytic" /></b>
		</c:if> <c:if test="${ ! empty reportContext.sessionFilters }">
			<a title="${ reportContext.formattedSessionFilters }"><b><bean:message
				key="display.filters.SessionFilters" bundle="analytic" /></b></a>&nbsp;<img
				src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;	
			</c:if> <c:if test="${ ! empty reportContext.contextFilters }">
			<a title="${ reportContext.formattedContextFilters }"><b><bean:message
				key="display.filters.ContextFilters" bundle="analytic" /></b></a>&nbsp;<img
				src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;	
			</c:if></td>
		<td style="font-size:10pt" align="right"><select
			onchange="getDataForLevel(this.options[selectedIndex]);">
			<option value="-1"><bean:message key="ui.options.all.levels"
				bundle="analytic" /></option>
			<c:forEach begin="1" end="${ reportContext.baseDimensionLevels }"
				var="level">
				<c:choose>
					<c:when test="${ level == reportContext.level }">
						<option value="${ level }" selected>${ level -1 }</option>
					</c:when>
					<c:otherwise>
						<option value="${ level }">${ level -1}</option>
					</c:otherwise>
				</c:choose>
			</c:forEach>
		</select></td>
	</tr>
</table>
<table width="98%">
<tr><td align="right">
	<b><font face="Verdana" size="2"><bean:message key="ui.search.selectall.across.page.label" bundle="search" arg0="${reportContext.totalRec}"/></font></b>
	<input type="checkbox"  name="checkAllPg" id="checkAllPg"  onclick="checkAllPage(this);">&nbsp;</td></tr>
</table>
<table class="tableWithBorderAna" align="center">
	<tr>
		<c:forEach items="${ reportContext.columnLabels }" var="column"
			varStatus="columnCount" begin="1">
			<td NOWRAP class="thead" align="center"><a href="#"
				onclick="submitFormForSorting('${ columnCount.count + 1 }')"> ${column.displayName } <c:if
				test="${ (columnCount.count + 1) == reportContext.sortColumn }">
				<c:choose>
					<c:when test="${ 'ASC' == reportContext.sortOrder }">
						<img src="/expensemap/jsp/images/up.gif" border="0">
					</c:when>
					<c:otherwise>
						<img src="/expensemap/jsp/images/down.gif" border="0">					
					</c:otherwise>
				</c:choose> </c:if></a></td>
		</c:forEach>
		<td NOWRAP class="thead" align="center">
			<input type="checkbox" name="checkAll" onClick="checkAllBoxes(this.form);" title="<bean:message key='ui.search.selectall.label' bundle='search'/>">
		</td>
	</tr>
	<c:forEach items="${ reportVO.data }" var="row" varStatus="rowNum">
		<c:set var="rowClass" value="trOdd"/>
		<c:if test="${ rowNum.count % 2 == 0 }">
			<c:set var="rowClass" value="trEven"/>
		</c:if>
		<tr class="${rowClass}">
		<c:forEach items="${ row }" var="column" varStatus="colNum" begin="1">
			<c:choose>
				<c:when test="${ colNum.count == 1 }">
					<td align="center">${ column -1}</td>
				</c:when>
				<c:otherwise>
					<td align="${ reportContext.columnLabels[colNum.index].type.alignment }"><c:out value="${ column }" /></td>
				</c:otherwise>
			</c:choose>
		</c:forEach>
		<td align="center"><INPUT type="checkbox" name="ids"
			value="${ row[0] }" id="${ row[0] }" onClick="setUnchecked(this)" /></td>
		</tr>
	</c:forEach>
</table>
<c:if test="${ ! empty reportVO.data }">
	<br>
	<table width="98%" align="center">
		<tr align="center">

			<td colspan="3"><jsp:include flush="true" page="pagination.jsp">
				<jsp:param name="isDataPresent" value="${ ! empty reportVO.data }" />
				<jsp:param name="pageSize" value="${reportContext.pageSize }" />
				<jsp:param name="totalRec" value="${reportContext.totalRec }" />
				<jsp:param name="startRec" value="${reportContext.startRec }" />
				<jsp:param name="limitRec" value="${reportContext.limitRec }" />
				<jsp:param name="maxRecordPerPage"
					value="${reportContext.pageSize }" />
			</jsp:include></td>
		</tr>
	</table>
</c:if> <br>
<center><input id="backBtn" type="button" value="<bean:message key='button.back' />" /></center>

<input type="hidden" name="sortOrder" id="sortOrder" 	value="${ reportContext.sortOrder }" /> 
<input type="hidden" name="sortColumn" id="sortColumn" value="${ reportContext.sortColumn }" />
<input type="hidden" name="reportId" id="reportId" 	value="${ reportContext.reportId }" /> 
<input type="hidden" name="eriId" id="eriId"  value="${ reportContext.eriId }" /> 
<input type="hidden" name="reportName" id="reportName"  value='<c:out value="${ reportContext.reportName }" />' /> 
<input type="hidden" name="reportType" id="reportType" value="${ reportContext.reportType }" />
<input type="hidden" name="Level" id="Level"  value="${ reportContext.level }" /> 
<input type="hidden" name="dimensionName" id="dimensionName"	value="${ reportContext.baseDimension }" />
<input type="hidden" name="UncheckedList" id="UncheckedList" value="" />
<input type="hidden" name="listSortColumn" id="listSortColumn" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortColumn"))%>">
<input type="hidden" name="listSortOrder"    id="listSortOrder"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortOrder"))%>">
<input type="hidden" name="listLimitRec"    id="listLimitRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listLimitRec"))%>">
<input type="hidden" name="listStartRec"    id="listStartRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listStartRec"))%>">
<input type="hidden" name="listPageSize"    id="listPageSize"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listPageSize"))%>">
<input type="hidden" name="numberFormat" value="" />
<input type="hidden" name="selectAllAcrossPage" id="selectAllAcrossPage" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("selectAllAcrossPage"))%>">
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
<c:if test="${ DIMENSION_NODE_FILTER_APPLIED == 'true' }">
	<div id="popupMenu" class="popupMenu" >
		<table border="0" cellspacing="0" cellpadding="0" align="right" width="100%">
			<tr><td align="left"><font size="1" face="arial"><bean:message key="ui.label.apply.analytic.filters" bundle="analytic" /></font></td></tr>
			<tr><td align="right"><hr/></td></tr>
			<tr>
				<td><font size="1" face="arial"><bean:message key="ui.label.keep.current.filters" bundle="analytic" /><input type="checkbox" id="keepCurrentFilters" name="keepCurrentFilters" value="true" /></font>
					&nbsp;
					<html:button property="applyFilters" onclick="checkIntersectionBeforeMultikeepRequest();" styleClass="buttonStyle">
						<bean:message key="button.apply" bundle="analytic" />
					</html:button>
				</td>
			</tr>
			<tr><td align="right"><font size="1" face="arial"><a href="#" onclick="closeMe();">&nbsp;x&nbsp;</a></font></td></tr>
		</table>
	</div>
</c:if>
</form>

<script src="/expensemap/jsp/javascript/stringbuffer.js"></script>
<script language="javascript">

	// export report to xls/csv.
	function exportReport() {
		if(isEmpty=='true')	{
			alert("<bean:message key='errors.noexportdata'  bundle ='analytic'/>");
			return false;
		} else {
			
			if(document.getElementById("fileTypeXls").checked && 
					parseInt('${reportContext.totalRec }')>parseInt('<%=ExpenseMapAppProperties.getMaxRecordsForExcel()%>')){
				alert("<bean:message key='ui.alertmsg.records.exceed.excel.limit' bundle ='analytic'/>");
				return false;
			} else {
				var frm = document.getElementById("reportRenderForm");
				var displayModeCsv = document.getElementById("fileTypeCsv");
    			var displayModeXls = document.getElementById("fileTypeXls");
				var fileName = document.getElementById("fileName");
				var fName = trim(fileName.value);
				//method in commons.js
				if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
					
					var numFormatObject = document.getElementById("exportNumberFormat");
					var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
					frm.numberFormat.value = numFormat;					
					var reportId = document.getElementById("reportId").value;
					frm.reportName.value = fName;
					frm.method="post";
					var url='';
					if ( displayModeCsv.checked == true ) {
						url = "/expensemap/analytic/analyticsExportExcelCSV.do?level="+${ reportContext.level };
					} else if ( displayModeXls.checked == true ) {
						url = "/expensemap/analytic/analyticsExportExcel.do?level="+${ reportContext.level };
					}
					frm.action= url;
					frm.submit();
					closeExportBox();
				}
			}
		}
	}
	
	// Returns the function name and its params as a string for calling export functionality from common export UI in commonExportUI.jsp
	function getParamString(name, id, status) {
		return "javascript:exportReport()";
	}
	
	// Returns header string for export ui called from commonExportUI.jsp. It depends upon module its called for.
	function getHeader() {
		return "<bean:message key='ui.title.exporting.Analyitc'/>";
	}
	
	// Show/hide divs upon selection of csv/excel type. called from commonExportUI.jsp
	function toggleOptionDiv(fileType) {
	}
	
	// Initialize the export UI. show/hide divs. It depends upon each module which div to show/hide. called from commonExportUI.jsp
	function initDiv() {
		var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
		var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
		dimensionOptionsDiv.style.visibility = 'hidden';
		dimensionNoOfRowsOptionsDiv.style.visibility = 'hidden';
	}

	// Returns level by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0. 
	function getLevelsBydimId(dimId) {
		return 0;
	}

	//Returns no of rows by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
	function getNoOfRowsBydimId(dimId) {
		return 0;
	}

	function checkAllBoxes(formObj){
	    var checkboxes = document.reportRenderForm.ids;
	    var ids = new StringBuffer();
	    var checkAllVal = formObj.checkAll.checked;
	    if (checkboxes) {
		   	if (!checkboxes[0] ) { 
				checkboxes.checked = checkAllVal;
				ids.append(',');ids.append(checkboxes.id);							
		     }else{
		     	var chkLen = checkboxes.length;
			    for( var index=0; index < chkLen; index++ ) {
					var checkboxObj = checkboxes[index];
					checkboxObj.checked = checkAllVal;
					ids.append(',');ids.append(checkboxObj.id);			
				}// end for
			 }
	     }
	     sendPostRequest('updateSelectedAllNodes'+","+checkAllVal+ids.toString());
 	}
		   
		      
	function processMultikeepRequest(checkList,noOfRows, event) {
		if ( checkForMultikeep(checkList,noOfRows) == false ) {
			return false;
		}
		
		var currentFiltersApplied = "${ DIMENSION_NODE_FILTER_APPLIED }";
		if ( currentFiltersApplied == "false" ) {
			submitFormForMultiKeep(checkList, noOfRows);
		} else {
			// show popup
			showPopupMenu(event);
		}
		
	}

	function showPopupMenu(event) {

		if ( !document.all && !document.getElementById ) {
			return;
		}
		var menuobj= document.getElementById("popupMenu");
		menuobj.contentwidth=menuobj.offsetWidth;
		menuobj.contentheight=menuobj.offsetHeight;
		var eventX= event.clientX;
		var eventY= event.clientY;
		//Find out how close the mouse is to the corner of the window
		var rightedge= document.body.clientWidth-eventX;
		var bottomedge= document.body.clientHeight-eventY;
		//if the horizontal distance isn't enough to accomodate the width of the context menu
		if (rightedge<menuobj.contentwidth) {
			//move the horizontal position of the menu to the left by it's width
			menuobj.style.left= document.body.scrollLeft+eventX-menuobj.contentwidth+"px";
		} else {
			//position the horizontal position of the menu where the mouse was clicked
			menuobj.style.left= document.body.scrollLeft+eventX+"px";
		}
		//same concept with the vertical position
		if (bottomedge<menuobj.contentheight) {
			menuobj.style.top= document.body.scrollTop+eventY-menuobj.contentheight+"px";
		} else {
			menuobj.style.top= document.body.scrollTop+event.clientY+"px";
		}
		menuobj.style.visibility="visible";

		return false;
	}

	function closeMe(){
		var menuobj= document.getElementById("popupMenu");
		menuobj.style.visibility="hidden";
	}
	
	function checkForMultikeep(checkList,noOfRows) {
		var checkFlag = false;
		
		if ( noOfRows == 0 ) {
			alert("<bean:message key='ui.alertmsg.multikeep' bundle='analytic'/>");
			return false;
		}
		    
		for(i=0; i < noOfRows; i++) {
			if ( noOfRows == 1 && checkList.checked == true ) {
				checkFlag = true;
				break;  
			} else if (noOfRows == 1 && checkList.checked == false ) {
				checkFlag = false;
				break;  
			} else if (checkList[i].checked == true) {
				checkFlag = true;
				break;  
			}
		}
		if(!isMultiKeep() && checkFlag == false ) {
			alert("<bean:message key='ui.alertmsg.multikeep.select' bundle='analytic'/>");
			return false;
		}
		return true;
	}
	
	
	function submitFormForMultiKeep(checkList,noOfRows) {
		if ( checkForMultikeep(checkList,noOfRows) == false ) {
			return false;
		}
		var keepCurFilter = 'false';
		var chk = document.getElementById("keepCurrentFilters");
		if(chk){
			keepCurFilter = chk.checked;
		}
		var dimName = document.getElementById('dimensionName').value;
		sendRequest('maxNodeValidation,'+dimName+','+keepCurFilter);		
	}
		
	function submitFormForSorting(columnId) {
	    var order = document.getElementById("sortOrder").value;
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do" ;
		if(order=='ASC'){
			order='DESC';
		}else if(order=='DESC'){
			order='ASC';
		}
		document.getElementById("sortOrder").value=order;
		document.getElementById("sortColumn").value=columnId;
		frm.submit();

	}
	function paginate(action){
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction="+action;
		frm.submit();
	}
		
	// A JS function to request data for a specific level.
	function getDataForLevel(selectedLevel) {
		var frm = document.getElementById("reportRenderForm");
		document.getElementById("Level").value = selectedLevel.value;
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do";
		frm.submit();
	}
	
	function openHelp(){
    	open( "<%=helpURL%>", "_blank" );
    }
    
	function setCheckBox() {
    	var chkBox = eval(<%=sbuf.toString()%>);
    	if(chkBox!=null){
    		for(var i=0;i<chkBox.length;i++){    			
    			var ch = document.getElementById(chkBox[i]);
    			if(ch!=null){
    				ch.checked = true;
    			}
    		}    		
       }
       
       var doCheck = "<%=checkAll%>";
       if(doCheck == 'true'){
       		document.getElementById("checkAllPg").checked = true;
       }else{
       		document.getElementById("checkAllPg").checked = false;
       }
	   updateCheckboxesOnCurrentPage();	
 	}
    
    function isEmpty(fieldVal) {
    	if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
       		return true;
    	}
	}
    
    function setUnchecked(checkbox){
	    var unckecked = document.getElementById("UncheckedList");	    
	    if(!checkbox.checked) {
	        if(isEmpty(trim(unckecked.value))){
				unckecked.value =checkbox.value;
			}else{
				unckecked.value = unckecked.value+','+checkbox.value;
			}
		}
		updateSelectedNodes(checkbox);
    }  
    
    function checkIntersectionBeforeMultikeepRequest() {
    	if ( document.getElementById("keepCurrentFilters").checked == true ) {
    		sendAjaxPostRequest();
    	} else {
    		submitFormForMultiKeep(document.reportRenderForm.ids,'${ reportVO.size }');
    	}
    }
    // Used for AJAX
   // var	xmlHttp = false;
    // A JS to submit AJAX POST to check intersection of filters being applied
    function sendAjaxPostRequest() {
		var params = "dimensionName=" + '${ reportContext.baseDimension }'
					+ "&ids=" + getSelectedIds()
					+ "&UncheckedList=" + document.getElementById('UncheckedList').value;
	
		jQuery.ajax({
			url: "/expensemap/analytic/AnalyticsMultiKeepCheckIntersection.do",
			type: "POST",
			data: params,
			success: receiveResponse,
			error: function(xhr, status, error) {
				alert("<bean:message key='ui.message.There.was.a.problem.retrieving.data.from.server' bundle ='emMessages'/> "  + xhr.statusText);
			}
		});
	}
	
	function getSelectedIds() {
		var selectedIds = "";
		var checkboxes = document.reportRenderForm.ids;
		if ( ! checkboxes[0] ) {
			// There is only one checkbox
			if ( checkboxes.checked ) {
				return checkboxes.value;
			}
		}
		for( var index=0; index < checkboxes.length; index++ ) {
			var checkboxObj = checkboxes[index];
			if ( checkboxObj.checked )	{
				if ( selectedIds.length > 0 ) {
					selectedIds = selectedIds + ",";
				}
				selectedIds = selectedIds + checkboxObj.value;
			}
		}
		return selectedIds;
	}
	
	function receiveResponse(response) {
		var data = eval(response);
		if (data == 'true') {
			submitFormForMultiKeep(document.reportRenderForm.ids,'${ reportVO.size }');
		} else {
			closeMe();
			document.getElementById("keepCurrentFilters").checked = false;
			if ( confirm("<bean:message key='ui.alertmsg.multikeep.no.intersection' bundle='analytic'/>") ) {
				submitFormForMultiKeep(document.reportRenderForm.ids,'${ reportVO.size }');
			}
			return false;
		}
	}
	
	function updateCheckboxesOnCurrentPage(){
		var formObj = document.getElementById("reportRenderForm");	
		var checkboxes = document.reportRenderForm.ids;
		var allChecked = true;
		if(checkboxes){
			if (!checkboxes[0] ) { 
				allChecked = checkboxes.checked;
			}else{
				for( var index=0; index < checkboxes.length; index++ ) {
					var checkboxObj = checkboxes[index];
					   if(!checkboxObj.checked){
							allChecked = false;
							break;
					   }
				}//end for
			}//end else
		formObj.checkAll.checked = allChecked;
		}
	}
	
	function checkAllPage(chkBox){
		var checkVal = chkBox.checked;
		document.getElementById("selectAllAcrossPage").value = checkVal;	
		var formObj = document.getElementById("reportRenderForm");	
		formObj.checkAll.checked = checkVal;
		//select all checkboxes on page
		var checkboxes = document.reportRenderForm.ids;
	    if(checkboxes){
		   	if (!checkboxes[0] ) { 
				checkboxes.checked = checkVal;
		     }else{
		     	var chkLen = checkboxes.length;
			    for( var index=0; index < chkLen; index++ ) {
					var checkboxObj = checkboxes[index];
					checkboxObj.checked = checkVal;
				} 
			 }
	     }
		 var currentLevel = document.getElementById("Level").value;
		 sendRequest('selectAcrossPage'+','+checkVal+','+currentLevel);
	}	

	function updateSelectedNodes(chkBox){
		/*request format : 'updateSelectedNodes',<CHECKBOX_ID>,<CHECKED_VALUE>*/
		if(!chkBox.checked){
			// checkbox is unchecked, so set selectAllAcrossPage flag to false
			document.getElementById("selectAllAcrossPage").value = false;
		}
		updateCheckboxesOnCurrentPage();		
		sendRequest('updateSelectedNodes'+","+chkBox.id+","+chkBox.checked);
	}

var xmlHttp2;
function ResetHttpRequest() {
	xmlHttp2 = false;
    // branch for native XMLHttpRequest object
    if(window.XMLHttpRequest) {
		try {
			xmlHttp2 = new XMLHttpRequest();
	    } catch(e) {
			xmlHttp2 = false;
		}
    // branch for IE/Windows ActiveX version
    } else if(window.ActiveXObject) {
	    try {
	    	xmlHttp2 = new ActiveXObject("Msxml2.XMLHTTP");
	    } catch(e) {
		    try {
				xmlHttp2 = new ActiveXObject("Microsoft.XMLHTTP");
		    } catch(e) {
		          xmlHttp2 = false;
		    }
	    }
    }

   if (!xmlHttp2) alert("<bean:message key='ui.message.Browser.does.not.support.AJAX.type.request' bundle ='emMessages'/>");
}

function sendRequest(argStr){
	try {
	    ResetHttpRequest();
		xmlHttp2.open("GET", "/expensemap/jsp/analytics/analyticsAjaxProcessor.jsp?" + argStr, true);
		xmlHttp2.send(null);
		xmlHttp2.onreadystatechange = responseHandler;
	} catch(e) {
		 alert(e);
	}
}
//This function checks if any node selected across the pages
function isMultiKeep() {
	try {
		ResetHttpRequest();
		xmlHttp2.open("GET", "/expensemap/jsp/analytics/analyticsAjaxProcessor.jsp?checkMultikeep", false);
		xmlHttp2.send(null);
		var data = eval(xmlHttp2.responseText);
		return data[1];
	} catch(e) {
		 alert(e);
	}
}
function sendPostRequest(argStr){
	try {
	    ResetHttpRequest();
		xmlHttp2.open("POST", "/expensemap/jsp/analytics/analyticsAjaxProcessor.jsp", true);
		xmlHttp2.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		var param = 'var='+argStr;
		xmlHttp2.send(param);
		xmlHttp2.onreadystatechange = responseHandler;
	} catch(e) {
		 alert(e);
	}
}

function responseHandler(){
	if (xmlHttp2.readyState == 4){
	    if (xmlHttp2.status != 200) {
            alert("<bean:message key='ui.message.There.was.a.problem.retrieving.data.from.server' bundle ='emMessages'/>");
            return false;
        }
		var response = xmlHttp2.responseText;
		var data = eval(response);
		// If there is no data in the response, ignore this
		if (data == null) {
		   return;
		}
		if (data[0] == "Error"){
		    var errorCode = data[1];
		    if(errorCode == "session.timeout")
		    {
		       var timeoutURL = data[3];
		       parent.location.href=timeoutURL;
		       return;
		    }
		    if(errorCode == "validation.error"){
			    alert("<bean:message bundle='search' key='ui.error.message.em.max.node.apply.limit' arg0='<%=maxLimit%>' />");
		    	return;
		    }
		}else{ 
			if(data[0] == "Success"){
				if(data[1] == "submitFormForMultiKeep"){
					var warnLmt = <%=warnLimit%>;
					var nodeListSize = data[2];
					if(nodeListSize > warnLmt){
						if(confirm("<bean:message bundle='search' key='ui.message.em.max.node.apply.limit.warning'/>")){
							var expenFrame = '<%=expFrame%>';
							var frm = document.getElementById("reportRenderForm");
							frm.method="post";
							frm.action="/expensemap/analytic/AnalyticsMultiKeep.do";
							frm.target = expenFrame;
							frm.submit();
						}else{
							return;
						}
					}else{
							var expenFrame = '<%=expFrame%>';
							var frm = document.getElementById("reportRenderForm");
							frm.method="post";
							frm.action="/expensemap/analytic/AnalyticsMultiKeep.do";
							frm.target = expenFrame;
							frm.submit();										
					}	
				}
			} 
			else if(data[0] == "TOTAL_SELECTED_NODE_COUNT") {
				var TOTAL_NODES_COUNT = <%= context.getTotalRec() %>;
				var TOTAL_SELECTED_NODE_COUNT = data[1];
				
				if(TOTAL_NODES_COUNT == TOTAL_SELECTED_NODE_COUNT){
					document.getElementById("checkAllPg").checked=true;
				}else{
					document.getElementById("checkAllPg").checked=false;
				}
			}
			
		}
	}
}

	(function() {
		var Event = YAHOO.util.Event;
		YAHOO.util.Event.onDOMReady(function() {
			setCheckBox();
			
			Event.on("backBtn", "click", function() {
				var frm = document.getElementById("reportRenderForm");
				frm.method="post";
				frm.action="/expensemap/showAnalyticPage.xhtm";
				frm.submit();
			});
			var isEmpty='${ empty reportVO.data }';
			var printReport = function() {
				if(isEmpty=='true')	{
					alert("<bean:message key='errors.noprintdata' bundle ='analytic'/>");
					return false;
				} else {
					var frm = document.getElementById("reportRenderForm");
					frm.method="post";
					frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction=getCurrent&pageType=_pf";
					frm.target='_new';
					frm.submit();
					frm.target='_self';
				}
			}
			Event.on("print", "click", printReport);
		});
	})();
</script>

</body>
</html>