/** 
 * (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */ 

<!-- Function to check all the reports. -->

var buttonSelected = false;

function selectCheckBox(checkBox, flag) {
	if ( checkBox.disabled == false ) {
		checkBox.checked = flag ;
	}
}

function checkAll(obj,checkList,noOfRows) {
       if(buttonSelected) {
	        for (i = 0; i < noOfRows; i++) {
	             if(noOfRows == 1) {
	                selectCheckBox(checkList, false);
	             } else {
	             	selectCheckBox(checkList[i], false);
	        	 }
	        }
	        obj.src="jsp/images/chkbxs_select.gif";
	        buttonSelected=false;
       } else {
	        for (i = 0; i < noOfRows; i++) {
	             if(noOfRows == 1)
	        	    selectCheckBox(checkList, true);
	        	 else
	        	    selectCheckBox(checkList[i], true);
            }
            obj.src="jsp/images/chkbxs_deselect.gif";
	        buttonSelected=true;
       }
} 
function submitFormForDelete(checkList,noOfRows,message)
{
    var checkFlag = false;
    var reportTypeObj = document.getElementById("reportType");
    var reportAreaObj = document.getElementById("reportArea");
    var reportCategoryObj = document.getElementById("reportCategory");
    var reportType = reportTypeObj.value;
    var reportArea = reportAreaObj.value;
    var reportCategory = reportCategoryObj.value;
 	
 	if(noOfRows==0){
 		alert("No Reports to Delete");
 		return false;
 	}
 
	for(i=0; i < noOfRows; i++)
    {
           if(noOfRows == 1 && checkList.checked == true)
           {
              checkFlag = true;
              break;  
           }
		     else if(noOfRows == 1 && checkList.checked == false)
           {
              checkFlag = false;
              break;  
           }
           else if(checkList[i].checked == true)
           {
			  checkFlag = true;
              break;  
           } 
    }
    if(checkFlag == false)
    {
        alert("Please select at least one report to delete");
        return false;
    }
    else 
    { 
	    var confirmDelete = message;
	    if (confirm(confirmDelete))
		{
			document.listForm.method="post";
			if(reportType != null)
      			document.listForm.action="/expensemap/deleteReportRecord.do?reportCategory="+reportCategory+"&reportType="+reportType+"&reportArea="+reportArea;
      	    else
      	        document.listForm.action="/expensemap/deleteReportRecord.do?reportCategory="+reportCategory+"&reportArea="+reportArea;
			document.listForm.submit();		
		}
	    else
		{
			return false;
		}
    }	
}


/* This function will trim the given string and return.*/
function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

/* This function will validate if given string is valid number or not.*/
function IsNumeric(strString){
   var strValidChars = "0123456789-";
   var strChar;
   var blnResult = true;
   var strLen = strString.length;
   if (strLen == 0){
   	return false;
   }
   //  test strString consists of valid characters listed above
   for (i = 0; i < strLen && blnResult == true; i++){
      strChar = strString.charAt(i);
      if (strValidChars.indexOf(strChar) == -1){
         blnResult = false;
      }
   }
   return blnResult;
}

/* This function will check if the given value is within min and max range.*/
function isWithinRange(val, min, max){
	if (val >= min && val <= max){
		return true;
	}else{
		return false;
	} 
}



//Generic function : returns true if number is valid  
//var tests = [1, '89 768', 1099511627776,20000000, 0, 1, "0", 0x0, 0x000, "0000", "0x89f", 8e5, 0x23, -0, 0.0, "1.0", 1.0, -1.5, 0.42, '075', "01", '-01', "0.", ".0", "a", "a2", true, false, "#000", '1.2.3', '#abcdef', '', "", "\n", "\t", '-', null, undefined];
function isNumber(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}

function isDecimal(n) {
	return isNumber(n)
}