<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.emptoris.analytics.common.util.AnalyticUtility"%>
<%@page import="com.emptoris.viewer.ReportViewType"%>
<%@include file="../../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil, com.emptoris.viewer.util.CSRFHelper" %>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticRequestContext"%>
<%@ page import="com.emptoris.analytics.common.util.AnalyticActionsConstants"%>

<%@ page import="com.zeborg.expensemap.analytic.TrendAnalyticCondition,ilog.views.chart.data.IlvDefaultDataSource"%>
<%@ page import="com.zeborg.expensemap.analytic.AnalyticsTrendPreferences"%>
<%
AnalyticRequestContext context = (AnalyticRequestContext)session.getAttribute("reportContext");

%>
<html>
<head>
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key='ui.topn.chart.title'  bundle ='analytic'/> </title>
<style>a, A:link, a:visited, a:active, A:hover{color: #330099;}</style>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css">
<script language="javascript">		

	/*
		As per display type, this function will return true/false whether data is present or not.
	*/	
	function isDataPresent() {		
		<c:choose>
		<c:when test="${ empty reportVO.data && empty reportVO.chartData }">return false;</c:when>
		<c:otherwise>return true;</c:otherwise>
		</c:choose>
	}
	
	function printReport(action){
		var isEmpty = isDataPresent();
		if(isEmpty=='true')	{
			alert("<bean:message key='errors.noprintdata'  bundle ='analytic'/>");
			return false;
		} else {	
			var frm = document.getElementById("reportRenderForm");
			frm.method="post";
			frm.action="/expensemap/analytic/topReportAnaExportHtml.do?theAction="+action+"&pageType=_pf";
			frm.target='_new';
			frm.submit();
			frm.target='_self';
		}
	}
		   
	function getReportList() {
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/showAnalyticPage.xhtm";
		frm.submit();
	}
		      
	function submitFormForSorting(columnId) {
	    var order = document.getElementById("sortOrder").value;
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/topReportAnaExportHtml.do" ;
		if(order=='ASC'){
			order='DESC';
		}else if(order=='DESC'){
			order='ASC';
		}
		document.getElementById("sortOrder").value=order;
		document.getElementById("sortColumn").value=columnId;
		frm.submit();

	}
	function paginate(action){
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/topReportAnaExportHtml.do?theAction="+action;
		frm.submit();
	}
	
	// A JS function to request data for a specific level.
	function getDataForLevel(selectedLevel) {
		var frm = document.getElementById("reportRenderForm");
		document.getElementById("Level").value = selectedLevel.value;
		frm.method="post";
		frm.action="/expensemap/analytic/topReportAnaExportHtml.do";
		frm.submit();
	}
</script>
</head>
<body>
<form name="reportRenderForm" id="reportRenderForm">
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

<br>
<c:if test="${ empty reportVO.data && empty reportVO.chartData }">
<br>
	<font color="red" face="Verdana" size="2"> <b><bean:message key="error.com.emptoris.analytics.noDataFound" bundle="analytic" /></b></font>
</c:if> 

	
<table class="tableWithBorderAna" align="center">
	<tr>
		<td align="left"><b><bean:message key="ui.analytics.Title" bundle= "analytic"/></b></td>
		<td align="center"><b><bean:message key="rpt.cubeName" bundle= "analytic"/>: ${cube}</b></td>			
		<c:if test="${ !empty reportVO.data || !empty reportVO.chartData}">
		<td align="right"><a href="#" onclick="printReport('getCurrent');"><img	src="/expensemap/jsp/images/print.gif"	title="<bean:message key='ui.print.image.tooltip'  bundle= "analytic" />"	border="0"></a></td>
		</c:if>
	</tr>
</table>		

<table class="InnerTableWithBorderAna" align="center">
	<tr>
		<td><b><bean:message key="ui.report.table.header.name" bundle="analytic" /> :  <c:out value="${ reportContext.reportName }"/></b></td>		
	</tr>
	<tr>
		<td><b><bean:message key="ui.analyticsReport.criteria"	bundle="analytic" />:</b>
			<c:forEach items="${ reportContext.analyticConditions }" var="condition" varStatus="status">
				<c:if test="${ status.count == 1 }">			
					<bean:message key="ui.label.ShowAll" bundle= "analytic"/>&nbsp;${ condition.categoryDisplayName }
					&nbsp;<bean:message key="ui.ruleform.whose.label" bundle= "analytic"/>			
				</c:if>
			<tr>
				<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		
					<c:if test="${ condition.cumulative == true }">
						<bean:message key="ui.ruleform.cumulative.label" bundle= "analytic"/>&nbsp;
					</c:if>
					<c:if test="${ ! empty condition.level && condition.level != -1}">
						<bean:message key="ui.label.level" bundle= "analytic"/>&nbsp;${ condition.level -1}&nbsp;
					</c:if>
					<c:if test="${ ! empty condition.level && condition.level == -1}">
						<bean:message key="ui.label.leaf.level.node" bundle="analytic" />&nbsp;
					</c:if>
				    ${ condition.attributeDisplayName }&nbsp;
					${ condition.operatorDisplayName }&nbsp;
					${ condition.virtualLowLimit }&nbsp;
					<c:if test="${ ! empty condition.virtualHighLimit }">
						<bean:message key="ui.ruleform.label.and" bundle= "analytic"/>&nbsp;${ condition.virtualHighLimit }
					</c:if>
					<c:if test="${ condition.percentTotalOption.name != 'NONE' }">
						<bean:message key="${ condition.percentTotalOption.resourceKey }" bundle="analytic" />&nbsp;
					</c:if>
				</td>
			</tr>
			</c:forEach>
				<!-- displaying trend condition -->	
		<% TrendAnalyticCondition trendCondition = context.getTrendAnalyticCondition();%>	
		<tr>
			<td>
			<%if(trendCondition != null){ %>
				<bean:message key="ui.ruleform.for.label" bundle="analytic"/> <%=trendCondition.getTimeDimensionDisplayName()%>
				<% if(trendCondition.getTrendType().equalsIgnoreCase("discrete")){ %>
					<bean:message key="ui.operator.Between" bundle="analytic"/> <%=trendCondition.getStartPeriodHierarchyStr()%> &nbsp;<bean:message key="ui.ruleform.label.and" bundle="analytic"/>&nbsp; <%=trendCondition.getEndPeriodHierarchyStr()%>
				<% }else if(trendCondition.getTrendType().equalsIgnoreCase("continuous")){ %>
					
				<% 		if(trendCondition.getTimeDimension().equalsIgnoreCase("dimtime")){%>
							<bean:message key="ui.ruleform.for.label" bundle="analytic"/> &nbsp; <bean:message key="<%=AnalyticUtility.getAllTimePeriodDisplayName(trendCondition.getTimePointLevel())%>" bundle="analytic" />
					<% 	}else { 
						Integer level = new Integer(trendCondition.getTimePointLevel());
					%>	
						<bean:message key="ui.ruleform.all.label" bundle="analytic"/>&nbsp; <bean:message key="ui.label.level" bundle="analytic"/>&nbsp;<%=level.intValue()-1%>
					<%	}
					}	//if dim = DIMTIME
				}// end if null%>
			</td>
		</tr>
		<!-- end //display trend condition -->
	</td>
	</tr>
	<tr>
		<td align="left"><b> <bean:message key="display.filters.AdditionalFilters" bundle= "analytic"/>: </b>
			<c:if test="${ empty reportContext.sessionFilters && empty reportContext.contextFilters }">
				<b><bean:message key="ui.label.None" bundle= "analytic"/></b>
			</c:if>		
			<c:if test="${ ! empty reportContext.sessionFilters }">
				<a title="${ reportContext.formattedSessionFilters }"><b><bean:message key="display.filters.SessionFilters"  bundle="analytic"/></b></a>&nbsp;<img src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;		
			</c:if>			
			<c:if test="${ ! empty reportContext.contextFilters }">
				<a title="${ reportContext.formattedContextFilters }"><b><bean:message key="display.filters.ContextFilters"  bundle="analytic"/></b></a>&nbsp;<img src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;		
			</c:if>	
		</td>
		<td align="right" >
				<select onchange="getDataForLevel(this.options[selectedIndex]);">
				<!-- show all level option only for table. -->
			<% if( ReportViewType.TABLE.equals(context.getViewType())){ %>
			<option value="-1"><bean:message key="ui.options.all.levels" bundle="analytic" /></option>
			<%} %>
					
					<c:forEach begin="1" end="${ reportContext.baseDimensionLevels }" var="level">
						<c:choose>
							<c:when test="${ level == reportContext.level }">
								<option value="${ level }" selected>${ level -1}</option>
							</c:when>
							<c:otherwise>
								<option value="${ level }">${ level -1}</option>
							</c:otherwise>
						</c:choose>
					</c:forEach>
				</select>
			</td>
		</tr>	
</table>
<br>
<% if( ReportViewType.TABLE.equals(context.getViewType())){ %>
<table class="tableWithBorder">
<tr>
	<c:forEach items="${ reportContext.columnLabels }" var="column" varStatus="columnCount" >
		<c:choose>
			<c:when test="${ columnCount.count == 1 }"></c:when>
			<c:otherwise>
			<td NOWRAP class="thead" align="center">
				<a href="#" onclick="submitFormForSorting('${ columnCount.count }')" >
					${ column.displayName }
				<c:if test="${ columnCount.count == reportContext.sortColumn }">
					<c:choose>
						<c:when test="${ 'ASC' == reportContext.sortOrder }">
							<img src="/expensemap/jsp/images/up.gif" border="0">
						</c:when>
						<c:otherwise>
							<img src="/expensemap/jsp/images/down.gif" border="0">
						</c:otherwise>
					</c:choose>
				</c:if>
				</a>
			  </td>	
			</c:otherwise>
		</c:choose>
	</c:forEach>
</tr>
	<c:forEach items="${ reportVO.data }" var="row" varStatus="rowNum">
		<c:choose>
			<c:when test="${ rowNum.count % 2 == 0 }">
				<tr class="trEven">
			</c:when>
			<c:otherwise>
				<tr class="trOdd">
			</c:otherwise>
		</c:choose>
		<c:forEach items="${ row }" var="column" varStatus="colNum" >
			<c:choose>
				<c:when test="${ colNum.count == 1 }">										
				</c:when>
				<c:when test="${ colNum.count == 2 }">	
					<td align="center">${ column -1}</td>								
				</c:when>
				<c:otherwise>
					<td align="${ reportContext.columnLabels[colNum.index].type.alignment }"><c:out value="${ column }" /></td>
				</c:otherwise>
			</c:choose>
		</c:forEach>
		</tr>
	</c:forEach>
</table>
<% } else { 
	AnalyticsTrendPreferences pref = (AnalyticsTrendPreferences)request.getAttribute("chartPreferences");
	IlvDefaultDataSource dataSource = (IlvDefaultDataSource)request.getAttribute("dataSource");
	int width = pref.getWidth();
	int height = pref.getHeight();
	StringBuffer imageSrc = new StringBuffer("/expensemap/jsp/analytics/trend/imageGen.jsp?request=image&width=");
	imageSrc.append(width).append("&height=").append(height);
	session.setAttribute("dataSource",dataSource);	
	session.setAttribute("chartPreferences",pref);
%>
<br>
<c:if test="${ ! empty reportVO.chartData }">
<center>
<div id="ImageDiv">  
	<jsp:include page="/analyticsTrendChartServlet" flush="true">  
  		<jsp:param name="request" value="imagemap"/>
  		<jsp:param name="image" value="<%=imageSrc%>"/>
  		<jsp:param name="width" value="<%=width%>"/>
  		<jsp:param name="height" value="<%=height%>"/>
  	</jsp:include>																		
</div>  
<center>
</c:if>	
<% } %>
<% if( ReportViewType.TABLE.equals(context.getViewType())){ %>
<c:if test="${ ! empty reportVO.data }">
	<table width="98%" align="center">
		<tr align="center"><td colspan="3">&nbsp;</td></tr>
		<tr align="center">		
			<td colspan="3">
				<jsp:include flush="true" page="../pagination.jsp">
					<jsp:param name="isDataPresent"	value="${ ! empty reportVO.data }" />
					<jsp:param name="pageSize" value="${reportContext.pageSize }" />
					<jsp:param name="totalRec" value="${reportContext.totalRec }" />
					<jsp:param name="startRec" value="${reportContext.startRec }" />
					<jsp:param name="limitRec" value="${reportContext.limitRec }" />
					<jsp:param name="maxRecordPerPage" value="${reportContext.pageSize }" />
				</jsp:include>
			</td>
		</tr>
		<tr><td align="left" width="20%">&nbsp;</td></tr>		
	</table>
</c:if>
<%}else{ %>
<c:if test="${ ! empty reportVO.chartData }">
	<table width="98%" align="center">
		<tr align="center"><td colspan="3">&nbsp;</td></tr>
		<tr align="center">		
			<td colspan="3">
				<jsp:include flush="true" page="../pagination.jsp">
					<jsp:param name="isDataPresent"	value="${ ! empty reportVO.chartData }" />
					<jsp:param name="pageSize" value="${reportContext.pageSize }" />
					<jsp:param name="totalRec" value="${reportContext.totalRec }" />
					<jsp:param name="startRec" value="${reportContext.startRec }" />
					<jsp:param name="limitRec" value="${reportContext.limitRec }" />
					<jsp:param name="maxRecordPerPage" value="${reportContext.pageSize }" />
				</jsp:include>
			</td>
		</tr>
		<tr><td align="left" width="20%">&nbsp;</td></tr>		
	</table>
</c:if>
<%}%>
<br>
<table align="center">
	<tr>
		<td colspan="4">
			<html:button property="closeButton" onclick="javascript:return window.close();"><bean:message key='ui.topn.button.Close.Window' bundle='analytic'/></html:button>
		</td>
	</tr>
</table>	
<input type="hidden" name="sortOrder" 	  id="sortOrder" 	  value="${ reportContext.sortOrder }" />
<input type="hidden" name="sortColumn" 	  id="sortColumn"	  value="${ reportContext.sortColumn }" />
<input type="hidden" name="reportId" 	  id="reportId" 	  value="${ reportContext.reportId }" />
<input type="hidden" name="eriId" 		  id="eriId" 		  value="${ reportContext.eriId }" />
<input type="hidden" name="reportType" 	  id="reportType" 	  value="${ reportContext.reportType }" />
<input type="hidden" name="Level" 		  id="Level"          value="${ reportContext.level }" />
<input type="hidden" name="dimensionName" id="dimensionName"  value="${ reportContext.baseDimension }" />
<input type="hidden" name="viewType" 	  id="viewType" 	  value="${ reportContext.viewType }" />
<input type="hidden" name="bkmrkId" 	  id="bkmrkId" 	      value="${ bkmrkId }" />
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form>
</body>
</html>