<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager,java.util.*,
com.zeborg.expensemap.util.ExpenseMapAppProperties,com.zeborg.util.WebUtil"
%>
<%@ page import="com.zeborg.expensemap.view2.ZSession, com.emptoris.viewer.util.CSRFHelper" %>
<%@ page import="com.zeborg.expensemap.view.CubeUtil,com.zeborg.expensemap.view.HelpUtil" %>
<%@ page import="org.owasp.esapi.ESAPI"%>

<%
ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);
Locale locale = zs.getUser().getLocale();	
EmResourceBundle bundle=EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE, locale);
String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.creating.trendAnalytic.help.page", locale);
CubeUtil.buildExpMapMastHead(out,"viewFrame_analytic.jsp",zs,true,null,locale,null);
String title = ExpenseMapAppProperties.getExpensemapTitle()+ " - "+ bundle.getValue("ui.title.create.new.analytic.report");

%>
<html:html>
<head>
<title><%=title%></title>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css" />
<style>
.yui-skin-sam .yui-panel {
position: absolute;
}

.yui-skin-sam .yui-calendar {
font-family: Arial, Helvetica, sans-serif;
font: 60%;
}

.yui-skin-sam .yui-calcontainer{
font-family: Arial, Helvetica, sans-serif;
font: 100%;
	width:160px;
	width:180px !ie;
}
.yui-skin-sam .yui-panel .bd {
	display:block;
	overflow:hidden;	
	width:180px;
	width:200px !ie;
}

.hEffect {
	cursor:hand;
	color:#0000FF;
	font-size: 11px;
	text-decoration : NONE;
	FONT-FAMILY: Arial;
}

.hEffect:hover {
	color:red;
}
</style>

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>	
<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>

<SCRIPT language="JavaScript" src="/expensemap/jsp/js/util/htmlDecodeUtil.js" type=text/javascript></SCRIPT>
</head>
<body class="yui-skin-sam" onload="init();" >
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="createTrendRuleForm"/>
</jsp:include>

<script language="JavaScript">
var topReportSelected = false;
window.select_current = new Array(); 
var allTimePoints=${ createTrendRuleForm.allTimePeriods }; 

function setPrevSelectValue(obj){
	 window.select_current[obj.id] = obj.selectedIndex;
}

function setOperation(operation){
	document.getElementById('operation').value=operation;
    return true;
}
function addPleaseSelectOption(selectObject){
	selectObject.options[0] = new Option("<bean:message key='ui.options.please.select' bundle='analytic' />","");
}
function isAllOptionSelected(){
	selectedStartTimeObj =  document.getElementById("startPeriod");
	return isItAllOptionValue(selectedStartTimeObj.value);
}
function isItAllOptionValue(value){
	for(i=0;i<allTimePoints.length;i++){
		if(value == allTimePoints[i]){
			return true;
		}
	}
	return false;
}
function resetAttribute(oldValue,newValue){
	if(isItAllOptionValue(oldValue)){
		if(!isItAllOptionValue(newValue)){
			resetAttributes();
		}
	}else{
		if(isItAllOptionValue(newValue)){
			resetAttributes();
		}
	}
}
/**
 * Reset All Attributes
 */
function resetAttributes(){		
		var att = document.getElementById("currentCondition.attribute");
		var operator = document.getElementById("currentCondition.operator");
		att.selectedIndex=0;
		operator.selectedIndex=0;
		for( i=operator.options.length; i >0 ;i--){
				operator.remove(i);
		}
		var lowLimit = document.getElementById("currentCondition.lowLimit");
		var highLimit = document.getElementById("currentCondition.highLimit");
		lowLimit.value ="";
		highLimit.value= "";
		document.getElementById("highLimitTD").style.visibility = 'hidden';
}
//validation script on select start period
function selectStartTime(operation, selectTag,index){
	if (selectTag.options[selectTag.selectedIndex].disabled) { 
       selectTag.selectedIndex = window.select_current[selectTag.id]; 
    }else{
		oldStartTimeIndex =  window.select_current[selectTag.id];
		resetAttribute(selectTag.options[window.select_current[selectTag.id]].value,selectTag.value);
		window.select_current[selectTag.id] = selectTag.selectedIndex;
		if(selectTag.value != ''){				
			if(selectTag.name =='startPeriod'){
				increasedByOrDecresedByAdded =document.getElementById("increasedByOrDecresedByAdded");
				if(increasedByOrDecresedByAdded.value=="true"){
					if(isAllOptionSelected()){
						alert("<bean:message key='ui.alertmsg.donot.select.all.condition' bundle='analytic' />" );
						selectTag.selectedIndex = oldStartTimeIndex;
						return false;
					}
				}
				selectedEndTimeObj =  document.getElementById("endPeriod");
				var category = document.getElementById("currentCondition.category");
				var att = document.getElementById("currentCondition.attribute");
				if(isAllOptionSelected()){
					selectedEndTimeObj.selectedIndex=0;
					selectedEndTimeObj.disabled=true;
					selectedEndTimeObj.value="";
					if("${createTrendRuleForm.savedConditionCount}"=="0"){							
						category.disabled=false;
						submitRequest("getCategory", selectTag);
					}else{
						submitRequest("updateEndPeriodForAllSelection", selectTag);
					}
				}else{					
					submitRequest(operation, selectTag);
					selectedEndTimeObj.selectedIndex=0;
					selectedEndTimeObj.disabled=false;

					//category.disabled=true;
				}
			}
		}
	}		
}
function selectEndTime(operation, selectTag){
	if (selectTag.options[selectTag.selectedIndex].disabled) { 
       selectTag.selectedIndex = window.select_current[selectTag.id]; 
    }else{
		window.select_current[selectTag.id] = selectTag.selectedIndex;
		selectedEndTime =  document.getElementById("endPeriod");
		var category = document.getElementById("currentCondition.category");
		if(category.value=='' || category.value=='--'){
			submitRequest(operation, selectTag);
		}
	}
}
function selectTimeDimension(operation, selectTag){
		var startPeriod = document.getElementById("startPeriod") ;
		var endPeriod=document.getElementById("endPeriod");
		var cat = document.getElementById("currentCondition.category");
		var att = document.getElementById("currentCondition.attribute");
		var operator = document.getElementById("currentCondition.operator");
		var lowLimit = document.getElementById("currentCondition.lowLimit");
		var highLimit = document.getElementById("currentCondition.highLimit")
		if(selectTag.value!=''&&selectTag.value!='--'){
			submitRequest(operation, selectTag);
		}else{
			alert("<bean:message key='ui.alertmsg.time.dimension.select' bundle='analytic'/>") ; 
			startPeriod.selectedIndex=0;
		}
		endPeriod.selectedIndex=0;
		cat.selectedIndex=0;
		att.selectedIndex=0;
		operator.selectedIndex=0;
		startPeriod.disabled=true;
		endPeriod.disabled=true;
		cat.disabled=true;
		att.disabled=true;
		operator.disabled=true;

}
//submit the ajax request
function submitRequest(operation, selectTag){	
	if (selectTag.options[selectTag.selectedIndex].disabled) { 
	       selectTag.selectedIndex = window.select_current[selectTag.id]; 
	}
	else {
		window.select_current[selectTag.id] = selectTag.selectedIndex;
		if(selectTag.value!='' && selectTag.value!='--'){	
			try {				
				var argStr = "operation=" + operation + "&" + selectTag.name + "=" + selectTag.value;		
				var url = "/expensemap/analytic/trendAnalyticActionForAjaxRequest.do?" + argStr;
				jQuery.ajax({
					url: url,
					type: "GET",
					success: responseHandler,
					error: function(xhr, status, error) {
						alert("<bean:message bundle='emMessages' key='ui.message.There.was.a.problem.retrieving.data.from.server'/> " + xhr.statusText);
					}
				});
			} catch(e) {
				 alert(e);
			}	
		}
	}
}

//handle the ajax response
function responseHandler(response) {
	var data = eval(response);
	// If there is no data in the response, ignore this
	if (data == null) {
	   return;
	}
	
	if (data[0] == "Error") {
		var errorCode = data[1];
		if(errorCode == "session.timeout")
		{
		   var timeoutURL = data[3];
		   parent.location.href=timeoutURL;
		   return;
		}else{
			//alert the error
			alert(data[2]);
		}
	} else if( data[0]=="getStartPeriod") {			
		var selectedStartTime = document.getElementById("startPeriod");
		var selectedEndTime = document.getElementById("endPeriod");
		for(  i=selectedStartTime.options.length; i >0 ;i--){
			selectedStartTime.remove(i);
		}
		addPleaseSelectOption(selectedStartTime);
		for(i=1 ; i<data.length-1 ; i=i+3){
			var opt = new Option(data[i], data[i+1]);
			if(data[i+2]=="true"){
				opt.disabled=true;	
				opt.style.color = "graytext"; 
			}
			selectedStartTime.options[selectedStartTime.options.length] =opt; 
		}			
		allTimePoints = data[data.length-1];
		if(selectedStartTime.options.length > 0){
			selectedStartTime.options[0].selected=true	;
			selectedStartTime.disabled =false;					
		}
		selectedEndTime.disabled = true;
	} else if( data[0]=="getEndPeriod") {
		var endPeriod = document.getElementById("endPeriod");
		for(  i=endPeriod.options.length; i >0 ;i--){
			endPeriod.remove(i);
		}
		addPleaseSelectOption(endPeriod);
		for(i=1 ; i<data.length ; i=i+3){
			var opt = new Option(data[i], data[i+1]);			

			if(data[i+2]=="true"){
				opt.disabled=true;	
				opt.style.color = "graytext"; 
			}
			endPeriod.options[endPeriod.options.length] =opt; 
		}
		if(endPeriod.options.length > 0){
			endPeriod.options[0].selected=true;
			endPeriod.disabled =false;
		}
	} else if( data[0]=="getCategory") {
		var category = document.getElementById("currentCondition.category");			
		for( i=category.options.length; i >0 ;i--){				
			category.remove(i);
		}
		addPleaseSelectOption(category);
		for(i=1 ; i<data.length ; i=i+2){
			category.options[category.options.length] = new Option(getHtmlDecodedValue(data[i]), data[i+1]);
		}
		if(category.options.length > 0){
			category.options[0].selected=true;
			category.disabled =false;
		}
	} else if( data[0]=="getAttribute") {
		
		var attribute = document.getElementById("currentCondition.attribute");
		for( i=attribute.options.length; i >0 ;i--){
			attribute.remove(i);
		}
		attribute.options[0]=null;
		addPleaseSelectOption(attribute);
		for(i=1 ; i<data.length ; i=i+3){		
			var opt = new Option(getHtmlDecodedValue(data[i]), data[i+1]);
			if(data[i+2]=="true"){
				opt.disabled=true;	
				opt.style.color = "graytext"; 
			}
			attribute.options[attribute.options.length] = opt;
		}
		if(attribute.options.length > 0){
			attribute.options[0].selected=true;
			attribute.disabled =false;
		}
	} else if( data[0]=="processAttribute") {						
		var operator = document.getElementById("currentCondition.operator");
		var level = document.getElementById("currentCondition.level");
		var lowLimit = document.getElementById("currentCondition.lowLimit");
		var highLimit = document.getElementById("currentCondition.highLimit");
		totalNoOfOperatorOption = data[1];
		totalNoOfLavelOption = data[2];			
		for( i=operator.options.length; i >0 ;i--){
			operator.remove(i);
		}

		maxIndex = parseInt(totalNoOfOperatorOption)*2+3
		addPleaseSelectOption(operator);
		for(i=3 ; i< maxIndex; i=i+2){				
			operator.options[operator.options.length] = new Option(data[i], data[i+1]);
		}

		if(operator.options.length > 0){
			operator.options[0].selected=true;
			operator.disabled =false;
			lowLimit.disabled =false;
			highLimitdisabled =false;
		}

		if(parseInt(totalNoOfLavelOption)>0){
			for( i=level.options.length; i >0 ;i--){
				level.remove(i);
			}
			addPleaseSelectOption(level);
			for(i=maxIndex ; i<data.length-2 ; i=i+2){
				level.options[level.options.length] = new Option(data[i], data[i+1]);
			}
			if(level.options.length > 0){
				level.options[0].selected=true;
				level.disabled =false;
			}

		}else{
			level.options[0].selected=true;
			level.disabled =true;
		}			
		if(data[data.length-2] == "true"){
			enableDisableOptionButton("${ createTrendRuleForm.trendPercentTotalOptions[0].name }",false);
			enableDisableOptionButton("${ createTrendRuleForm.trendPercentTotalOptions[1].name }",true);				
		}else{
			enableDisableOptionButton("${ createTrendRuleForm.trendPercentTotalOptions[0].name }",true);
			enableDisableOptionButton("${ createTrendRuleForm.trendPercentTotalOptions[1].name }",true);
		}
		//Check and set attribute type
		attributeType = data[data.length-1];
		document.getElementById("selectedAttributeType").value=attributeType;
		var fromDateField = document.getElementById("currentCondition.lowLimit");
		var toDateField = document.getElementById("currentCondition.highLimit");

		if(attributeType=='DATE'){
			YAHOO.util.Event.on(fromDateField, "focus", showCalendar, [fromDateField, fromDateField]);
			YAHOO.util.Event.on(toDateField, "focus", showCalendar, [toDateField, toDateField]);
		}else{
			YAHOO.util.Event.removeListener ( fromDateField, "focus" , showCalendar );
			YAHOO.util.Event.removeListener ( toDateField, "focus" , showCalendar );
			YAHOO.util.Event.removeListener ( fromDateField, "focus" , self.openCalendar );
			YAHOO.util.Event.removeListener ( toDateField, "focus" , self.openCalendar );

		}
		//Reset Limit
		var lowLimit = document.getElementById("currentCondition.lowLimit");
		var highLimit = document.getElementById("currentCondition.highLimit");
		lowLimit.value="";
		highLimit.value="";
		document.getElementById("highLimitTD").style.visibility = 'hidden';
	}
}

function enableDisableOptionButton(optionName,isDisabled){
	var option = document.getElementById(optionName);
	option.disabled =isDisabled;
}


function enableTopReportCategories(isTopReport) {
	topReportSelected=isTopReport;
	if( isTopReport ) {
		document.getElementById("topReportCategory").disabled = false;
	} else {
		document.getElementById("topReportCategory").disabled = true;
	}
}

function addNewCondition() {
	if(validateNewCondition()){	
		var frm = document.getElementById("createTrendRuleForm");
	operation =  document.getElementById("operation");
		operation.value="addCondition"
		frm.action = "/expensemap/analytic/trendAnalyticAction.do";
		frm.method = "post";
		frm.submit();
	}
}

function deleteCondition(index) {
	var frm = document.getElementById("createTrendRuleForm");
	operation = document.getElementById("operation");
	selectedIndex =document.getElementById("selectedIndex");
	selectedIndex.value=index;
	operation.value = 'removeCondition';
	frm.action = "/expensemap/analytic/trendAnalyticAction.do";
	frm.submit();
}

function cancelAnalyticForm() {
	var frm = document.getElementById("createTrendRuleForm");
	frm.action = "/expensemap/showAnalyticPage.xhtm";
	frm.submit();
}

function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

function saveTemplate(createNew) {

	var frm = document.getElementById("createTrendRuleForm");
 	var returnValue = validateNewRuleForm();
 	
 	//Assign "null" to "SortColumn" and "SortOrder", to get the default sort column 
	//and sort order after report submitted.
	document.getElementById("listSortColumn").value = "null";
	document.getElementById("listSortOrder").value = "null";
	
 	if (returnValue ) {
 		if(topReportSelected)
		{
			alert("<bean:message key='ui.alertmsg.Top.Reports.option.is.not.applicable.for.Templates' bundle='analytic'/>");
			return false;
		}
 		document.getElementById("createNew").value = createNew;		
		operation = document.getElementById("operation");
		operation.value = 'saveTemplate';
		frm.action = "/expensemap/analytic/trendAnalyticAction.do";
		frm.submit();
 	}
}

/**
 * process operator selection.
 * @param operator - operator selected
 */
function processOperator(operator) {	
	if(operator.value=="Increased By" ||operator.value=="Decreased By"){
		defaultSelectedObj = document.getElementById("${ createTrendRuleForm.trendPercentTotalOptions[0].name }");		
		defaultSelectedObj.disabled=false;
		defaultSelectedObj.checked=false;
		defaultSelectedObj = document.getElementById("${ createTrendRuleForm.trendPercentTotalOptions[1].name }");
		defaultSelectedObj.disabled=false;
		defaultSelectedObj.checked=true;		
	}else{
		defaultSelectedObj = document.getElementById("${ createTrendRuleForm.trendPercentTotalOptions[0].name }");
		defaultSelectedObj.disabled=false;
		defaultSelectedObj.checked=true;
		defaultSelectedObj = document.getElementById("${ createTrendRuleForm.trendPercentTotalOptions[1].name }");
		defaultSelectedObj.disabled=false;
		defaultSelectedObj.checked=false;
		defaultSelectedObj.disabled=true;
	}
	enableLimitTextFields(operator);
}

/**
 * Enables high limit text box when Between is selected.
 * @param operator - operator selected
 */
function enableLimitTextFields(operator) {
	
	if ( operator.value == 'Between' ) {
		document.getElementById("highLimitTD").style.visibility = 'visible';
		document.getElementById("currentCondition.highLimit").disabled = false;
	} else {
		document.getElementById("highLimitTD").style.visibility = 'hidden';
		document.getElementById("currentCondition.highLimit").disabled = true;
	}
}

function validateNewCondition() {
	var isValid=true;
	var msg='';
	
	var timeDim = document.getElementById("timeDimension");
	var startPeriod = document.getElementById("startPeriod") ;
	var endPeriod=document.getElementById("endPeriod");
	var cat = document.getElementById("currentCondition.category");
	var att = document.getElementById("currentCondition.attribute");
	var operator = document.getElementById("currentCondition.operator");
	var lowLimit = document.getElementById("currentCondition.lowLimit");
	var highLimit = document.getElementById("currentCondition.highLimit")
	var timeDimValue=trim(timeDim.value) ; 
	var startPeriodValue=trim(startPeriod.value) ;
	var endPeriodValue=trim(endPeriod.value);
	var attrValue=trim(att.value) ; 
	var catValue= trim(cat.value) ;
	var opValue=trim(operator.value);
	var loLimitValue=trim(lowLimit.value);
	var highLimitValue=trim(highLimit.value);
	// Tells us datatype for attribute currently selected.
	// Empty if no attribute is selected so far.

	var attributeType = document.getElementById("selectedAttributeType").value;	
	if( opValue != "Between" ) {
		highLimitValue="N.A";
	}
	if(isEmpty(timeDimValue)){
		msg=msg+"<bean:message key='ui.alertmsg.time.dimension.select' bundle='analytic'/>"+ ";"+"timeDimension"+";" ;    
    	isValid=false;		
	}
	if(isEmpty(startPeriodValue)){
		msg=msg+"<bean:message key='ui.alertmsg.start.timepoint.select' bundle='analytic'/>"+ ";" +"startPeriod"+";";    
    	isValid=false;		
	}
	if(!isEmpty(startPeriodValue)){
		if(!(isAllOptionSelected()) ) {
			if(isEmpty(endPeriodValue)){
			msg=msg+"<bean:message key='ui.alertmsg.start.timepoint.select' bundle='analytic'/>"+ ";"+"endPeriod"+";" ;    
			isValid=false;			
			}
		}				
	}
    if( isEmpty(catValue) ) {
    	msg=msg+"<bean:message key='ui.alertmsg.trend.category.select' bundle='analytic'/>"+ ";"+"currentCondition.category"+";" ;    
    	isValid=false;		
    }		
    if (isEmpty(attrValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.attribute.select' bundle='analytic'/>"+ ";"+"currentCondition.attribute"+";" ;    
		isValid=false;		
    }    
    if ( ! (document.getElementById("currentCondition.level").disabled) ) { 
	    var lvlValue = trim(document.getElementById("currentCondition.level").value); 
	    if (isEmpty(lvlValue)) {
			msg=msg+"<bean:message key='ui.alertmsg.level.select' bundle='analytic'/>"+ ";"+"currentCondition.level"+";";    
			isValid=false;			
        }
    }      
    if ( isEmpty(opValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.Opertator.select' bundle='analytic'/>"+ ";"+"currentCondition.operator"+";" ;    
		isValid=false;		
	}	
	if((opValue =="Increased By" || opValue=="Decreased By") && (isAllOptionSelected())){
			msg=msg+"<bean:message key='ui.alertmsg.donot.select.all.condition' bundle='analytic'/>"+ ";"+"endPeriod"+";" ;    
			isValid=false;			
	}
   	if (isEmpty(loLimitValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.lowLimit.select' bundle='analytic'/>"+ ";"+"currentCondition.lowLimit"+";" ;    
		isValid=false;		
	}                 
   	if ( ! (document.getElementById("currentCondition.highLimit").disabled) ) { 
		if ( isEmpty(highLimitValue) ) {
			msg=msg+"<bean:message key='ui.alertmsg.lowLimit.select' bundle='analytic'/>"+ ";"+"currentCondition.highLimit"+";" ;    
			isValid=false;			
       	}  
   	} 
	
	if(!validateMaxLen()){
    	msg = msg + "<bean:message key='ui.desc.maxLength.alertmsg' bundle='analytic'/>"+ ";" ;
    	isValid=false;
    }
	if (!isEmpty(trim(msg))) {
		var msgArray = new Array();
		msgArray = msg.split(";");		
		alert(msgArray[0]);
		setFocus(msgArray[1]);
	}
	return isValid;
}
function setFocus(objNane){
	obj = document.getElementById(objNane);
	if(!obj.disabled){
		obj.focus();
	}
}

// A common resuable JS function to test empty fields.
function isEmpty(fieldVal) {
	if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
   		return true;
	}
}

function validateNewRuleForm(){	
	var isValid=true;
	var nameValue = trim(document.getElementById("reportName").value);
 	if(isEmpty(nameValue)){
		alert("<bean:message key='ui.validate.required.reportName.msg' bundle='analytic'/>") ;   
		return false;
    }
    if(!validateMaxLen()){
    	alert("<bean:message key='ui.desc.maxLength.alertmsg' bundle='analytic'/>");
    	return false;
    }
	 
	increasedByOrDecresedByAdded =document.getElementById("increasedByOrDecresedByAdded");
	startPoint =document.getElementById("startPeriod");	
	endPoint =document.getElementById("endPeriod");	
	if(isEmpty(trim(startPoint.value))) {
		alert("<bean:message key='ui.alertmsg.start.timepoint.select' bundle='analytic'/>");
		startPoint.focus();
    	return false;
	}
		if(!(isAllOptionSelected())) { if(increasedByOrDecresedByAdded.value=="false"){
			alert("<bean:message key='ui.alertmsg.trend.condition.select' bundle='analytic'/>");
			return false;
		}else if(isEmpty(trim(endPoint.value))){
			alert("<bean:message key='ui.alertmsg.start.timepoint.select' bundle='analytic'/>");
			endPoint.focus();
			return false;
		}
	}
	return isValid;
}

function submitAnalyticForm() {
 	var frm = document.getElementById("createTrendRuleForm");
 	var returnValue = validateNewRuleForm();	
	//Assign "null" to "SortColumn" and "SortOrder", to get the default sort column 
	//and sort order after report submitted.
 	document.getElementById("listSortColumn").value = "null";
	document.getElementById("listSortOrder").value = "null";	 	
 	// set the cumulative & 
 	if(returnValue ){
 		var frm = document.getElementById("createTrendRuleForm");
		operation = document.getElementById("operation");
		operation.value = 'submitReport';
		frm.action = "/expensemap/analytic/trendAnalyticAction.do";
		frm.submit();
 	}
}

/*
 * Sets the value for include context filter hidden field.
 * @param - includeContextFiltersCheckBox - the check box control
 */
function includeContextFiltersSelected(includeContextFiltersCheckBox) {
	document.getElementById("includeContextFilters").value = includeContextFiltersCheckBox.checked;
}

/*
 * Sets the value for include session filter hidden field.
 * @param - includeSessionFiltersCheckBox - the check box control
 */
function includeSessionFiltersSelected(includeSessionFiltersCheckBox) {
	document.getElementById("includeSessionFilters").value = includeSessionFiltersCheckBox.checked;
}

function init() {
	// set the "include context filter check-box" if present
	if ( document.getElementById("includeContextFilters") ) {
		if ( document.getElementById("includeContextFilters").value == 'true' ) {
			document.getElementById("includeContextFiltersCheckBox").checked = true;
		} else {
			document.getElementById("includeContextFiltersCheckBox").checked = false;			
		}
	}
	if ( document.getElementById("includeSessionFilters") ) {
		if ( document.getElementById("includeSessionFilters").value == 'true' ) {
			document.getElementById("includeSessionFiltersCheckBox").checked = true;
		} else {
			document.getElementById("includeSessionFiltersCheckBox").checked = false;
		}
	}		
	
	// % of Node Total option is available only when
	//    a. Selected attribute is of type 'Dimension Measue'
	//    b. User has chosen to use context filters
	var conditionType = '${ createTrendRuleForm.currentCondition.type }';
	
	if ( document.getElementById("includeContextFilters") && conditionType == 'DIMENSION_MEASURE' ) {
		if ( document.getElementById("includeContextFiltersCheckBox").checked==false 
			 && document.getElementById("PERCENT_OF_NODE_TOTAL").disabled==false ) {
			document.getElementById("PERCENT_OF_NODE_TOTAL").disabled=true;
		}
	}else{
		document.getElementById("PERCENT_OF_NODE_TOTAL").disabled=true;
	}
	// PR 44120
	// If user has selected dimension count based condition,
	// disable all radio buttons pertaining to %age.
	if ( conditionType == 'DIMENSION_COUNT' ) {
		document.getElementById("NONE").disabled = true;		
		document.getElementById("PERCENT_OF_NODE_TOTAL").disabled = true;
	}
	//Enable radio button
	var radioEnabled = ${ createTrendRuleForm.currentCondition.percentEnabled };	
	if(radioEnabled){
		document.getElementById("NONE").disabled = false;		
		document.getElementById("PERCENT_OF_NODE_TOTAL").disabled = false;
	}else{
		document.getElementById("NONE").disabled = true;		
		document.getElementById("PERCENT_OF_NODE_TOTAL").disabled = true;
	}
	var isTopReport = ${ createTrendRuleForm.topReport};
	if(isTopReport){
		topReportSelected =true;
	}
	document.getElementById("reportName").focus();
}

/*
 * Controls PercentNodeTotalOption enbling
 */
function setPercentNodeTotalOption() {
	if ( document.getElementById("currentCondition.cumulative").checked == true ) {
		if ( document.getElementById("PERCENT_OF_NODE_TOTAL").disabled == false ) {
			document.getElementById("NONE").checked=true;
			document.getElementById("PERCENT_OF_NODE_TOTAL").disabled=true;
		}
	} else {
		// % of Node Total option is available only when
		//    a. Selected attribute is of type 'Dimension Measue'
		//    b. User has chosen to use context filters
		var conditionType = '${ createTrendRuleForm.currentCondition.type }';
	
		if ( document.getElementById("includeContextFilters") && 
				conditionType == 'DIMENSION_MEASURE' &&
				document.getElementById("includeContextFiltersCheckBox").checked==true ) {
			document.getElementById("PERCENT_OF_NODE_TOTAL").disabled = false;
		}
	}
}

function validateMaxLen(){
	var maxlen = document.getElementById("desc").value.length;
	if(maxlen>255){
		return false;
	}
	else{
		return true;
	}
}
function openHelp(){
	open( "<%=helpURL%>", "_blank" );	
}
</script>
</head>
<body class="yui-skin-sam" onload="init();" >
<logic:messagesPresent message="true"  >
	<center>
	<font color=#ff0000>
		<b>
		<html:messages id="msg" message="true" bundle="analytic">
			<bean:write name="msg" bundle="analytic" filter="false"/>
		</html:messages>
		</b>
	</font></center>
</logic:messagesPresent>


<br>
<html:form method="post" action="/trendAnalyticAction.do?operation=''" styleId="createTrendRuleForm" onsubmit="return validateNewRuleForm();" >
<center>
<!-- show filters applied -->

	<table class="testTable" width="98%">
		<tr>
			<td align="left" colspan="1"><b> <bean:message key="display.filters.CurrentFilters" bundle= "analytic"/>:  </b>	
				<c:if test="${ empty SESSION_FILTERS && empty CONTEXT_FILTERS }">
					<b><bean:message key="ui.label.None" bundle= "analytic"/></b>
				</c:if>	
				<c:if test="${ ! empty SESSION_FILTERS }">	
					<input type="checkbox" id="includeSessionFiltersCheckBox" onclick="includeSessionFiltersSelected(this);" />
					<a class="hEffect" href="javascript:void();" onclick="return false" title="${ SESSION_FILTERS }">
					<bean:message key='ui.ruleform.include.session.filters.label' bundle="analytic"/></a>
					<html:hidden property="includeSessionFilters" styleId="includeSessionFilters" />
				</c:if>		
				<c:if test="${ ! empty SESSION_FILTERS && ! empty CONTEXT_FILTERS }">
					<b>|</b>
				</c:if>
				<c:if test="${ ! empty CONTEXT_FILTERS }">	
					<input type="checkbox" id="includeContextFiltersCheckBox" onclick="includeContextFiltersSelected(this);" />
					<a class="hEffect" href="javascript:void();" onclick="return false" title="${ CONTEXT_FILTERS }"><bean:message key='ui.ruleform.include.context.filters.label' bundle="analytic"/></a>
					<html:hidden property="includeContextFilters" styleId="includeContextFilters" />
				</c:if>	
			</td>
			<td align="right" ><a href="#" onclick="openHelp();"><img  src="/expensemap/jsp/images/help.gif" border="0" title="<bean:message  key='ui.label.Help' bundle='analytic'/>"/></a></td>	
		</tr>
		<tr>
			<td colspan="2"><hr></td>
		</tr>
		<c:if test="${ createTrendRuleForm.definedAsTemplate == true && ! empty TEMPLATE_FILTERS }">
			<tr>
				<td align="left" colspan="2">
					<c:if test="${ ! empty TEMPLATE_FILTERS }">
						<b><bean:message key='display.filters.TemplateFilters' bundle="analytic"/> : </b>
						<a title="${ TEMPLATE_FILTERS }"><img src="/expensemap/jsp/images/filter.gif" border="0"></a>
					</c:if>		
				</td>	
			</tr>
			<tr>
				<td colspan="2"><hr></td>
			</tr>
		</c:if>
		<tr>
			<td>
				<table class="tableWithoutBorder" width="70%">
					<tr>
						<td><b><bean:message key='ui.label.Name'
								bundle="analytic" /></b></td>
						<td><html:text property="reportName" styleId="reportName" styleClass="inputStyle" size="60" maxlength="255" /></td>
					</tr>
					<tr>
						<td valign="top"><b><bean:message key='ui.label.Description'
								bundle="analytic" /></b></td>
						<td><html:textarea property="desc" styleId="desc" cols="60" rows="3" styleClass="inputStyle" style="width:320px;"/></td>
					</tr>
				</table>
			</td>
			<td>
				<c:if test="${ createTrendRuleForm.canCreateTopReports == true }">
					<table class="tableWithoutBorder" width="75%" >	
						<tr>
							<td colspan="2" align="left">
								<b><bean:message key="rpt.listing.column.report.type" bundle="analytic" /></b>
							</td>
						</tr>
						<tr>
							<td>
								<html:radio property="topReport" value="false" styleId="" onclick="enableTopReportCategories(this.checked == false)" >
	        						<b><bean:message key="ui.label.Original" bundle="analytic"/></b>
	        					</html:radio>
	        				</td>
	        			</tr>
	        			<tr>
	        				<td nowrap>
	        					<html:radio  property="topReport" value="true" styleId="" onclick="enableTopReportCategories(this.checked == true)">
									<b><bean:message key="ui.label.TopReports" bundle="analytic"/></b>
								</html:radio>&nbsp;
			        			<html:select property="topReportCategory" size="1" styleId="topReportCategory" 
			        				disabled="${ createTrendRuleForm.topReport == false }" styleClass="selectStyle" >
			        				<html:optionsCollection name="createTrendRuleForm" property="topReportCategoriesList" value="value" label="label" />		
								</html:select>
							</td>
						</tr>
					</table>
				</c:if>
			</td>
		</tr>
		<tr>
			<td colspan="2"><hr></td>
		</tr>
		<tr>
			<td colspan="1">
				<table class="tableWithoutBorder" align="left" width="100%"  border=0>
					<tr>
						<td align="left" height="9" width="12.5%" nowrap><b><bean:message key="ui.ruleform.selectTime.label" bundle="analytic" /></b></td>
						<td align="left" height="9" width="87.5%">
						<html:select name="createTrendRuleForm" property="timeDimension" size="1" styleId="timeDimension"
								onchange="selectTimeDimension('getStartPeriod',this);" styleClass="selectStyle" 
								 disabled="${createTrendRuleForm.trendConditionAdded}">
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTrendRuleForm.timeDimensionList }">
									<html:optionsCollection name="createTrendRuleForm" property="timeDimensionList" label="label" value="value"/>
								</c:if>
							</html:select>&nbsp;
							<html:select name="createTrendRuleForm" property="startPeriod" size="1" styleId="startPeriod"
									onchange="selectStartTime('getEndPeriod',this,selectedIndex);" onfocus="setPrevSelectValue(this)" styleClass="selectStyle" 
									 disabled="${!createTrendRuleForm.startPeriodEnabled}">
						            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
						            <c:if test="${ ! empty createTrendRuleForm.startPeriodList }">			           
										<logic:iterate name="createTrendRuleForm" property="startPeriodList" id="startPeriodObject" type="com.emptoris.analytics.model.AnalyticsViewBean">
							            	<logic:equal name="startPeriodObject" property="disabled" value ="true">
							            		<option value="<%=startPeriodObject.getValue()%>" disabled style="color:graytext"><%=startPeriodObject.getLabel()%></option>						
							            	</logic:equal>
							            	<logic:equal name="startPeriodObject" property="disabled" value ="false">
												<logic:equal name="createTrendRuleForm" property="startPeriod" value ="<%=startPeriodObject.getValue()%>">
						            				<option value="<%=startPeriodObject.getValue()%>" selected ><%=startPeriodObject.getLabel()%></option>
												</logic:equal>
												<logic:notEqual name="createTrendRuleForm" property="startPeriod" value ="<%=startPeriodObject.getValue()%>">
						            				<option value="<%=startPeriodObject.getValue()%>"><%=startPeriodObject.getLabel()%></option>
												</logic:notEqual>
						            		</logic:equal>
						            	</logic:iterate>									            							
									</c:if>
								</html:select>
							&nbsp;<b><bean:message key="ui.ruleform.label.and" bundle="analytic" /></b>&nbsp;
								<html:select name="createTrendRuleForm" property="endPeriod" size="1" styleId="endPeriod"
									onchange="selectEndTime('getCategory',this);" onfocus="setPrevSelectValue(this)" styleClass="selectStyle" 
									 disabled="${!createTrendRuleForm.endPeriodEnabled}">
						            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
						           
						            <c:if test="${ ! empty createTrendRuleForm.endPeriodList }">
						            <logic:iterate name="createTrendRuleForm" property="endPeriodList" id="endPeriodObject" type="com.emptoris.analytics.model.AnalyticsViewBean">
						            	<logic:equal name="endPeriodObject" property="disabled" value ="true">
						            		<option value="<%=endPeriodObject.getValue()%>" disabled style="color:graytext"><%=endPeriodObject.getLabel()%></option>						
						            	</logic:equal>
						            	<logic:equal name="endPeriodObject" property="disabled" value ="false">
											<logic:equal name="createTrendRuleForm" property="endPeriod" value ="<%=endPeriodObject.getValue()%>">
					            				<option value="<%=endPeriodObject.getValue()%>" selected ><%=endPeriodObject.getLabel()%></option>
											</logic:equal>
											<logic:notEqual name="createTrendRuleForm" property="endPeriod" value ="<%=endPeriodObject.getValue()%>">
					            				<option value="<%=endPeriodObject.getValue()%>"><%=endPeriodObject.getLabel()%></option>
											</logic:notEqual>
					            		</logic:equal>
					            	</logic:iterate>						            							
					            	</c:if>
								</html:select>							
						</td>
					</tr>
					</table>
				</td>
		</tr>
		<tr>
			<td colspan="2"><hr></td>
		</tr>
		<tr>
			<td colspan="1">
				<table class="tableWithoutBorder" align="left" width="70%" border=0  CELLSPACING="0">
					<tr>
						<td align="left" height="9" width="15%"><b><bean:message key="ui.label.ShowAll" bundle="analytic" /></b></td>
						<td align=left height="9"  width="25%" >
							<html:select name="createTrendRuleForm" property="currentCondition.category" size="1"
								onchange="submitRequest('getAttribute',this);" onfocus="setPrevSelectValue(this)" styleClass="selectStyle" 
								styleId="currentCondition.category" disabled="${! createTrendRuleForm.categoryEnabled }" >
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTrendRuleForm.currentCondition.dimensionList }">
									<html:optionsCollection name="createTrendRuleForm" property="currentCondition.dimensionList" label="label" value="value"/>
								</c:if>
							</html:select>
						</td>
						<td align=left height="9"  width="20%" >&nbsp;</td>
						<td align=left height="9"   width="20%">&nbsp;</td>
						<td align=left height="9"   width="20%">&nbsp;</td>
					</tr>
					<tr>						
						<td align="left" height="9"><b><bean:message
							key="ui.ruleform.whose.label" bundle="analytic" /></b></td>
						<td align="left"  colspan="3">
							<html:select name="createTrendRuleForm" property="currentCondition.attribute" size="1" styleClass="selectStyle"
								styleId="currentCondition.attribute" onchange="submitRequest('processAttribute',this);" onfocus="setPrevSelectValue(this)" 
									disabled="${empty createTrendRuleForm.currentCondition.attributeList}">
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTrendRuleForm.currentCondition.attributeList }">									
									<logic:iterate name="createTrendRuleForm" property="currentCondition.attributeList" id="attributeObject"  type="com.emptoris.analytics.controllers.actionforms.AttributeHolder">
						            	<logic:equal name="attributeObject" property="disabled" value ="true">
						            		<option value="<%=attributeObject.getName()%>" disabled style="color:graytext"><%=attributeObject.getDisplayName()%></option>						
						            	</logic:equal>
						            	<logic:equal name="attributeObject" property="disabled" value ="false">
											<logic:equal name="createTrendRuleForm" property="currentCondition.attribute" value ="<%=attributeObject.getName()%>">
					            				<option value="<%=attributeObject.getName()%>" selected ><%=attributeObject.getDisplayName()%></option>
											</logic:equal>
											<logic:notEqual name="createTrendRuleForm" property="currentCondition.attribute" value ="<%=attributeObject.getName()%>">
					            				<option value="<%=attributeObject.getName()%>"><%=attributeObject.getDisplayName()%></option>
											</logic:notEqual>
					            		</logic:equal>
					            	</logic:iterate>
								</c:if>
							</html:select>
						</td>
					</tr>
					<tr>							
						<td align="left" height="9">
							<b><bean:message key="ui.label.level" bundle="analytic" /></b></td>
						<td align="left" height="9"  colspan="3">
							<html:select name="createTrendRuleForm" property="currentCondition.level"  styleId="currentCondition.level" size="1" styleClass="selectStyle"
								disabled="${ empty createTrendRuleForm.currentCondition.levelList }" >
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTrendRuleForm.currentCondition.levelList }" >
									<html:optionsCollection name="createTrendRuleForm" property="currentCondition.levelList" label="label" value="value" />
								</c:if>
							</html:select>
						</td>
					</tr>
					<tr>
						<td align="left" height="9" nowrap><b><bean:message
							key="ui.ruleform.cri.label" bundle="analytic" /></b></td>
						<td align="left" height="9" width="25%" nowrap>
							<html:select name="createTrendRuleForm" property="currentCondition.operator"  styleId="currentCondition.operator" size="1" styleClass="selectStyle" 
								disabled="${ empty createTrendRuleForm.currentCondition.operatorList }" onchange="processOperator(this.options[selectedIndex])">
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTrendRuleForm.currentCondition.operatorList }">
									<html:optionsCollection name="createTrendRuleForm" property="currentCondition.operatorList" label="label" value="value" />
								</c:if>
							</html:select>
							&nbsp;
							<c:choose>	
								<c:when test="${ !empty createTrendRuleForm.currentCondition.selectedAttributeType }" >
									<input type="text" name="currentCondition.lowLimit" id="currentCondition.lowLimit"  size="25"
										 class="inputStyle" maxlength="255" value='<bean:write name="createTrendRuleForm" property="currentCondition.lowLimit" filter="false"/>'>
								</c:when>
								<c:otherwise>				
									<input type="text" name="currentCondition.lowLimit" id="currentCondition.lowLimit"  size="25"
										 class="inputStyle" maxlength="255" value='<bean:write name="createTrendRuleForm" property="currentCondition.lowLimit" filter="false"/>' disabled>
								</c:otherwise>
							</c:choose>
						</td>					
							<c:choose>
								<c:when test="${ ! empty createTrendRuleForm.currentCondition.highLimit }">
									<td id="highLimitTD" style="visibility:visible;" align="left" nowrap>
										<c:choose>	
											<c:when test="${! empty createTrendRuleForm.currentCondition.selectedAttributeType }" >
												&nbsp;&nbsp;<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25" class="inputStyle" maxlength="255"											value='<bean:write name="createTrendRuleForm" property="currentCondition.highLimit" filter="false"/>'>
											</c:when>
											<c:otherwise>				
												&nbsp;&nbsp;<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25" class="inputStyle" maxlength="255"											value='<bean:write name="createTrendRuleForm" property="currentCondition.highLimit" filter="false"/>' disabled>											
											</c:otherwise>
										</c:choose>																					
									</td>
								</c:when>
								<c:otherwise>
									<td id="highLimitTD" style="visibility:hidden;" align="left" nowrap>
									&nbsp;&nbsp;<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25"
											disabled="true"  class="inputStyle" maxlength="50" value='<bean:write name="createTrendRuleForm" property="currentCondition.highLimit" filter="false"/>'/>
									
									</td>
								</c:otherwise>
							</c:choose>	

						</td>
					</tr>
					<tr>
						<td align="left" height="9"></td>						
					</tr>
					<tr>
						<td height="9">&nbsp;</td>
						<td align="left" height="9"  nowrap>						
							<c:forEach items="${ createTrendRuleForm.trendPercentTotalOptions }" var="percentTotalOption" >
								<html:radio property="currentCondition.percentTotalOption" value="${ percentTotalOption.name }" styleId="${ percentTotalOption.name }" disabled="${ !createTrendRuleForm.currentCondition.percentEnabled }"><bean:message key='${ percentTotalOption.resourceKey }' bundle="analytic"/>
								</html:radio>
							</c:forEach>
						
							<input type="hidden" name="radioEnabled" value="${createTrendRuleForm.currentCondition.percentEnabled }">
							
							
						</td>
					</tr>
					<tr>
						<td align="left" height="9" colspan="2"  style="font-size:10pt">
							<html:button property="add" onclick="addNewCondition();" 
								disabled="${ createTrendRuleForm.canAddMoreConditions == false }">
								<bean:message key='button.add.criteria' bundle='analytic'/>
							</html:button>
						</td>
					</tr>
				</table>
			</td>
		</tr>
		
		<c:if test="${ not empty createTrendRuleForm.savedConditions }">
		<tr>
			<td valign="top" colspan="2"><hr></td>
		</tr>
		<tr>
			<td colspan="2">
				<table class="tableWithoutBorder" align=center width="100%">
					<c:forEach items="${ createTrendRuleForm.savedConditions }" var="condition" varStatus="count" >
						<tr>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.categoryDisplayName }</option>
								</select>
							</td>							
							<td>
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.attributeDisplayName }</option>
								</select>
							</td>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<c:choose>
										<c:when test="${ ! empty condition.level && condition.level != -1 }">
											<option>${ condition.level - 1 }</option>
										</c:when>
										<c:when test="${ ! empty condition.level && condition.level == -1 }">
											<option><bean:message key='ui.options.all.leaf.nodes' bundle="analytic"/></option>
										</c:when>
										<c:otherwise>
											<option><bean:message key='ui.options.please.select' bundle="analytic" /></option>
										</c:otherwise>
									</c:choose>
								</select>
							</td>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.operator }</option>
								</select>
							</td>
							<td align="left" height="9">
								<input type="text" disabled="disabled" class="inputStyle" size="10" value="${ condition.lowLimit }" title="${ condition.lowLimit }">
								<c:choose>
									<c:when test="${ ! empty condition.highLimit }">
										<span style="visibility:visible;">
											<input type="text" disabled="disabled" size="10" class="inputStyle" value="${ condition.highLimit }" title="${ condition.highLimit }">
										</span>
									</c:when>
									<c:otherwise>
										<span style="visibility:hidden;">
											<input type="text" disabled="disabled" size="10" class="inputStyle" value="" >
										</span>
									</c:otherwise>
								</c:choose>
								<input type="radio" disabled="disabled" checked="checked" /><bean:message key='${ condition.percentTotalOption.resourceKey }' bundle="analytic"/>
							</td>
							<td align="left" height="9"  style="font-size:10pt">
								<html:button property="delete" onclick="deleteCondition(${ count.index });" 
									disabled="${ createTrendRuleForm.savedConditionCount != count.count }">
									<bean:message key='ui.search.button.remove' bundle='analytic'/>
								</html:button>
							</td>
						</tr>
					</c:forEach>
				</table>
			</td>
		</tr>
		</c:if>
		<tr>
			<td valign="top" align="center" colspan="2"><hr></td>
		</tr>				
		<tr>
			<td align="center" colspan="2">
				<table>
					<tr>
						<c:choose>
							<c:when test="${ createTrendRuleForm.definedAsTemplate }">
								<td  style="font-size:10pt">					
									<html:button property="createTemplate" onclick="saveTemplate(true);"
										disabled="${ createTrendRuleForm.savedConditionCount == 0 }" >
										<bean:message key='button.create.new.template' bundle="analytic" />
									</html:button>
								</td>
								<c:if test="${ createTrendRuleForm.templateUpdateAllowed }">
								<td  style="font-size:10pt">							
									<html:button property="updateTemplate" onclick="saveTemplate(false);"
										disabled="${ createTrendRuleForm.savedConditionCount == 0 }" >
										<bean:message key='button.update.template' bundle="analytic" />
									</html:button>
								</td>
								</c:if>
							</c:when>
							<c:otherwise>
								<td  style="font-size:10pt">
									<html:button property="saveBtn" onclick="saveTemplate(true);" 
										disabled="${ createTrendRuleForm.savedConditionCount == 0 }">
										<bean:message key='button.saveAsTemplate' bundle="analytic" />
									</html:button>
								</td>
							</c:otherwise>
						</c:choose>
						<td  style="font-size:10pt">
							<html:button property="submitBtn" onclick="submitAnalyticForm();"
								disabled="${ createTrendRuleForm.savedConditionCount == 0 }" >
								<bean:message key='button.submit' bundle="analytic" />
							</html:button>
						</td>
						<td  style="font-size:10pt">
							<html:button property="cancelBtn" onclick="cancelAnalyticForm();">
								<bean:message key='ui.label.Cancel' bundle="analytic" />
							</html:button>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
	<input type="hidden" name="createNew" id="createNew" value="${ createTrendRuleForm.definedAsTemplate == false }" />
	<c:if test="${ createTrendRuleForm.definedAsTemplate == true }">
		<input type="hidden" name="templateId" id="templateId" value="${ createTrendRuleForm.templateId }" />
	</c:if>
	<input type="hidden" name="listSortColumn" id="listSortColumn" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortColumn"))%>">
	<input type="hidden" name="listSortOrder"    id="listSortOrder"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortOrder"))%>">
	<input type="hidden" name="listLimitRec"    id="listLimitRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listLimitRec"))%>">
	<input type="hidden" name="listStartRec"    id="listStartRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listStartRec"))%>">
	<input type="hidden" name="operation" id="operation" value="">
	<input type="hidden" name="selectedIndex" id="selectedIndex" value="">
	<html:hidden name="createTrendRuleForm" property="trendConditionAdded" styleId="trendConditionAdded" />
	<html:hidden name="createTrendRuleForm" property="increasedByOrDecresedByAdded"  styleId="increasedByOrDecresedByAdded" />
	<input type="hidden" name="selectedAttributeType" id="selectedAttributeType" value='<bean:write name="createTrendRuleForm" property="currentCondition.selectedAttributeType"/>'>	
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</center>
</html:form>

<script language="JavaScript">

YAHOO.namespace('emptoris.analytics.search.UI');
(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.emptoris.analytics.search.UI = {
		init: function() {
			var self = YAHOO.emptoris.analytics.search.UI;
			var fromDateField = document.getElementById("currentCondition.lowLimit");
			var toDateField = document.getElementById("currentCondition.highLimit");
			var attributeType = '${ createTrendRuleForm.currentCondition.selectedAttributeType }';
			if ( attributeType == 'DATE' ) {
				Event.on(fromDateField, "focus", self.openCalendar, [fromDateField, fromDateField]);
				Event.on(toDateField, "focus", self.openCalendar, [toDateField, toDateField]);
			}else {
				Event.removeListener ( fromDateField, "focus" , self.openCalendar );
				Event.removeListener ( toDateField, "focus" , self.openCalendar );
			}
		},

		openCalendar: function(e, args) {	
    		YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
		}
	}

	Event.onDOMReady(YAHOO.emptoris.analytics.search.UI.init, YAHOO.emptoris.analytics.search.UI, true);
})();

function showCalendar(e, args) {
    	YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
}
</script>

</body>
</html:html>