<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.report.model.StaticReport"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager,com.zeborg.expensemap.il8n.EmResourceBundle"%>
<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="com.emptoris.viewer.reports.Category"%>
<%@ page import="com.zeborg.acl.util.ACManager"%>
<%@ page import="com.emptoris.viewer.reports.logic.TopnReportsLogic"%>
<%@ page import="java.util.*,java.text.*"%>
<%@ page import="com.emptoris.analytics.common.util.AnalyticsConstants"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import ="org.apache.struts.Globals,com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="java.net.URLEncoder"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="org.owasp.esapi.ESAPI"%>

<%
	ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);
 	Locale locale =zs.getUser().getLocale();
 	String reportId ="";
 	//If attachment is set as default initial page
 	if(request.getAttribute("reportid")!=null){
		reportId = (String)request.getAttribute("reportid");
	} else if(request.getParameter("reportid")!=null){  //If attachment is opened from list page
		reportId = request.getParameter("reportid");
	}
 	
	WebUtil.addNoCache(response);
	CubeUtil.buildExpMapMastHead(out,"viewFrame_attachment.jsp",zs,true,null,locale,null);
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("help.url.attachment.list.page", locale);
	EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, locale);
	String title = ExpenseMapAppProperties.getExpensemapTitle();
	title = title + " - " + "";
 %>
<html:html>
<head>
<title></title>
<style>
	a, A:link, a:visited, a:active, A:hover
	{color: #330099;}
</style>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css">
</head>
<body>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/> 
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="helpUrl" value="<%=helpURL%>"/>
</jsp:include>
<fmt:setBundle basename="ExpensemapMessagesBundle" />

<table width="100%" border="0" cellpadding="0" cellspacing="0">	
<tr>
<td style="FONT-FAMILY : Arial, Helvetica, sans-serif;FONT-SIZE: 11px;FONT-WEIGHT:normal; color: #030063">
	&nbsp;&nbsp;<B><bean:message key="ui.lable.current.attachment"  bundle="emMessages" />:&nbsp;<font color='#0000FF'>
		 <bean:write name="attachmentForm" property="reportName" />&nbsp;</B>&nbsp;&nbsp;&nbsp;|&nbsp;&nbsp;&nbsp;
		 <A HREF="/expensemap/attachment/AttachmentListAction.do?clearSearch=true">
	     <bean:message key='ui.label.Show.All.Reports' bundle="emMessages" /></A></font>
</td></tr></table>	     
<logic:messagesPresent message="true" property="org.apache.struts.action.GLOBAL_MESSAGE" >
<center>
<font color=#ff0000>
	<b>
	<html:messages id="msg" message="true" bundle="emMessages"> 
	      <bean:write name="msg" bundle="emMessages"/> 
	</html:messages> 
	</b>
</font></center>
</centre>
</logic:messagesPresent>
<logic:messagesPresent message="true" property="emSrcMessages" >
<center>
<font color=#ff0000>
	<b>
	<html:messages id="msg" message="true" property="emSrcMessages" bundle="emSrcMessages">
		<bean:write name="msg"/>
	</html:messages>
	</b>
</font></center>
</logic:messagesPresent>
<logic:messagesNotPresent message="true" property="emSrcMessages" >
<logic:messagesNotPresent message="true" property="org.apache.struts.action.GLOBAL_MESSAGE" >
<IFRAME ID = "displayFrame" HEIGHT = "100%" WIDTH = "100%" FRAMEBORDER = "0" SRC = "/expensemap/attachment/openAttachment.do?reportid=<%=ESAPI.encoder().encodeForHTML(reportId)%>"></IFRAME>
</logic:messagesNotPresent>
</logic:messagesNotPresent>
</body>
</html:html>