<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<%@ page import ="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import ="com.zeborg.expensemap.view2.ZSession"%>

<%@ page import="com.emptoris.spendmanager.components.cube.spi.cuberegistry.CubeRegistryService"%>
<%@ page import="com.emptoris.spendmanager.components.cube.spi.cuberegistry.CubeRegistryServiceProvider"%>
<%@ page import="com.emptoris.spendmanager.components.cube.spi.cuberegistry.CubeConfiguration"%>

<%@ page import="com.emptoris.spendmanager.cubemanagementui.service.CubeManagementUIService"%>
<%@ page import="com.emptoris.spendmanager.cubemanagementui.common.CubeManagementUIConstants"%>
<%@ page import="com.emptoris.spendmanager.cubemanagementui.meta.CubeMeta"%>
<%@ page import="com.emptoris.spendmanager.cubemanagementui.util.DataManagerMenuBuilder"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/animation/animation.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/utilities/utilities.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo/yahoo.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dom/dom-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/event/event-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/menu/menu.js"></script>

<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/menu/assets/skins/sam/menu.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/yui-menu-override.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/fonts/fonts.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/topmenu.css">
<link rel='stylesheet' type='text/css' href='/expensemap/jsp/css/customization.css' />

<style type="text/css">
	li.menuIcon {
		width: 28px;
		height: 24px;
		margin: 0px;
		padding: 0px;				
		border: 0px;
		float: right;				
		overflow: hidden;
	}
	
	.helpMenuIcon a {
		background: url('/expensemap/jsp/cap_area/btn_help_up.gif') center center no-repeat;				
	}
	
	li.printIcon {
		width: 28px;
		height: 24px;
		margin: 0px;
		padding: 0px;				
		border: 0px;
		float: right;				
		overflow: hidden;
	}
	
	.printMenuIcon a {
		background: url('/expensemap/jsp/images/sdm/btn_print_up.gif') center center no-repeat;				
	}
	
	.yui-skin-sam .yuimenubarnav .yuimenubaritemlabel, .bd li {
		color: white !important;
	}

	.yui-skin-sam .yuimenubaritem-selected {
		background: url('/expensemap/jsp/images/menubar/menubar_highlight.png') !important;
	}

	.yui-skin-sam .yuimenubarnav .yuimenubaritemlabel-hassubmenu {
		background: url('/expensemap/jsp/images/menubar/menubaritem_submenuindicator_white.png') right center no-repeat;
	}
	
	.yui-skin-sam .yuimenubarnav .yuimenubaritem {
		border-right: none;
	}
	
	.yui-skin-sam .yuimenubar {
		font: 12px Myriad,Helvetica,Tahoma,Arial,clean,sans-serif;
		line-height: 26px;
	}

	.yuimenubaritem {
		font-weight: bold;
	}

	.yuimenuitem {
		font-weight: normal;
	}

</style>
<%	
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, zs.getUser().getLocale());
	String cubeId = (String)request.getSession().getAttribute(CubeManagementUIConstants.CUBE_ID);
	String cubeStatus = new CubeMeta().getCubeStatus(cubeId);
	pageContext.setAttribute("cubeStatus", cubeStatus, PageContext.PAGE_SCOPE);
	boolean pollingEnabled = request.getSession().getAttribute("pollingEnabled")!=null? (Boolean)request.getSession().getAttribute("pollingEnabled"):false;
	//default polling interval is 10 sec. 1000 ms = 1 sec
	long pollingInterval = 10000L;
	if(ExpenseMapAppProperties.getServerPollingRequestTimeInSecond()>0){
		pollingInterval = 1000 *  ExpenseMapAppProperties.getServerPollingRequestTimeInSecond();
	}	
 	DataManagerMenuBuilder mBuilder = new DataManagerMenuBuilder();
%>

<script type="text/javascript" src="/expensemap/jsp/javascript/stringbuffer.js" ></script>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<script type="text/javascript">

//menu bar code starts
YAHOO.util.Event.onContentReady("topMenu", function () {

	var aSubmenuData =  <%= mBuilder.buildMenu(request, response) %>;
	var oMenuBar = new YAHOO.widget.MenuBar("topMenu", {lazyload: true , position : "static"});
	oMenuBar.addItems(aSubmenuData);
	oMenuBar.clickEvent.subscribe(bringMenuToTop);
	oMenuBar.render();
	var contextHelp = document.getElementById("contextHelp");
	if ( contextHelp != null ) {
		contextHelp.title = '<%=bundle.getValue("ui.label.Help")%>';
	}
	var printMenu = document.getElementById("printMenu");
	if ( printMenu != null ) {
		printMenu.title = '<%=bundle.getValue("ui.print.image.tooltip")%>';
	}
	topMenuReference = oMenuBar;
	
	// remove null href attribute for logo added in YUI menubar
	jQuery("#topMenu #navigationLogo a").attr("href", "#");
});

	/* Function to set top menu to higher zindex */
	function bringMenuToTop(menu){
		topMenuReference.bringToTop();
		var topZindex = topMenuReference.cfg.getProperty("zindex");
		var subMenus = topMenuReference.getSubmenus();
		for (var i = 0; i < subMenus.length; i++) {
			subMenus[i].cfg.setProperty("zindex", topZindex);
		}
	}
	
	function alertUnderConstruction(){
		alert('Under Construction');	
	}
	
	function MM_swapImgRestore() { //v3.0
		var i,x,a=document.MM_sr; for(i=0;a&&i<a.length&&(x=a[i])&&x.oSrc;i++) x.src=x.oSrc;
	}
	
	function MM_swapImage() { //v3.0
		  var i,j=0,x,a=MM_swapImage.arguments; document.MM_sr=new Array; for(i=0;i<(a.length-2);i+=3)
		   if ((x=MM_findObj(a[i]))!=null){document.MM_sr[j++]=x; if(!x.oSrc) x.oSrc=x.src; x.src=a[i+2];}
	}

	// TODO move methods getEpensemapFrame & getTarget to common JS file
	// This function recursively traverse through frame tree structure 
	// and returns instance of expensemapFrame if found else null
	function getEpensemapFrame(fr){
		if( fr.name == "expensemapFrame"){
			return fr;
		} else if(fr.length > 0){
			for( var i=0; i<fr.length; i++){
				var currFr = getEpensemapFrame(fr[i]);
				if( currFr != null ){
					return currFr;
				}
			}
		}
	}

	function getTarget(defaultTarget) {
		if ( top.frames != null && top.frames.length > 0 ) {
			for(var i=0; i<top.frames.length; i++){
				var currFr = getEpensemapFrame(top.frames[i]);
				if(currFr != null){
					return currFr ;
				}
			}
		}
		return defaultTarget;
	}
	
	function exportCmdd(){
		if(scanForVirus()){
			getTarget(parent).location.href = "/expensemap/datamanager/ExportCmddAction.do?operation=exportCmdd&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		}
	}
	
	function importCmdd(){
		var url = '/expensemap/datamanager/CreateNewCubeAction.do?isFromTopMenu=true&AuthCode=' + encodeURIComponent(document.getElementById('AuthCode').value);
		window.open(url, "Import_Window",'resizable=no,width=650,height=300');	
	}

	function processCube(token, jobId){
		getTarget(parent).location.href = "/expensemap/datamanager/ProcessCubeAction.do?operation=executeJob&token="+token+"&jobToClose="+jobId + "&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
	}
	
	function publishInputSet(){
		var url = "/expensemap/datamanager/PrePublishInputSetJobAction.do?AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		window.open(url, "Import_Window",'resizable=no,width=650,height=370');			
	}

	function dimensionalClassificationwrtED(){
		var url = '/expensemap/dataenrichment/DimensionalClassificationwrtEDAction.do?operation=openDimClassificationForm';
		var ht = 650;
        var wt = 700;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);      

		window.open(url, 'Dimension_Classification_WRT_Dimension_Window','resizable=no,width='+wt+',height='+ht+',left='+left+',top='+top);	
	}
	
	function dimensionalClustering(){
		var url = '/expensemap/dataenrichment/DimensionClusteringAction.do?operation=openDimClusteringForm';
		var ht = 660;
        var wt = 700;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);      

		window.open(url, 'Dimension_Clustering_Window','resizable=no,width='+wt+',height='+ht+',left='+left+',top='+top);	
	}

	function transactionalClassification(){
		var url = '/expensemap/dataenrichment/TransactionalClassificationAction.do?method=openTransactionalClassificationForm';
		var ht = 660;
        var wt = 700;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);      
		window.open(url, 'Transactional_Classification_Window', 'resizable=no, scrollbars=yes,width='+wt+', height='+ht+', left='+left+', top='+top);
	}
	
	function uploadSqlQueries(){
		var url = '/expensemap/dataenrichment/ExecuteCustomSqlAction.do';
		window.open(url, "Upload_Sql",'resizable=no,width=650,height=250');	
	}

	function submitCyclicRefCheckJob (){		
		var url = "/expensemap/datamanager/CheckCubeJobsAction.do?method=fetchCyclicRefDimensions&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		window.open(url, "Import_Window",'resizable=no,width=650,height=370,scrollbars=yes');	
		
	}
	
	
	function applyRules(){
		
		var url = "/expensemap/rulemanagement/BulkImportRuleListAction.do?method=listRulesToApply&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		var ht = 660;
        var wt = 700;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);      

		window.open(url, 'ApllyRules_Window','resizable=yes,scrollbars=yes,width='+wt+',height='+ht+',left='+left+',top='+top);
	}

	function submitDataIntegrityJob (){		
		var url = "/expensemap/datamanager/DataIntegirtyJobAction.do?operation=load&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		var ht = 660;
        var wt = 850;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);      

		window.open(url, 'Data_Integrity_Job_Window','resizable=no,scrollbars=yes,width='+wt+',height='+ht+',left='+left+',top='+top);	
	
		
	}
	
	function submitIdSyncJob (){		
		var url = "/expensemap/datamanager/CheckCubeJobsAction.do?method=fetchSyncIdDimension&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		var ht = 660;
        var wt = 850;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);   
		window.open(url, "Id_Sync_Window",'resizable=no,scrollbars=yes,width='+wt+',height='+ht+',left='+left+',top='+top);
		
	}
	
	function showAll(){
		getTarget(parent).location.href = "/expensemap/jobcontroller/JobListAction.do?operation=loadJobList&isSysAdminRequest=false&clearSearch=true";		
	}

	function dimensionalClassificationWithKB(){
		var url = '/expensemap/dataenrichment/DimensionClassificationWithKbAction.do?operation=openDimClassificationWithKbForm';
		var ht = 660;
        var wt = 700;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);      

		window.open(url, 'Dimension_Classification_Window','resizable=no,scrollbars=yes,width='+wt+',height='+ht+',left='+left+',top='+top);	
	}
	
	function trainKnowledgeBase(){
		var url = '/expensemap/dataenrichment/TrainKnowledgeBaseAction.do?operation=openTrainKnowledgeBaseForm';
		var ht = 460;
        var wt = 700;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);      

		window.open(url, 'Dimension_Classification_Window','resizable=no,scrollbars=yes,width='+wt+',height='+ht+',left='+left+',top='+top);	
	}
	/*Import manually wizard action*/
	function importManually(){
		var url = "/expensemap/datamanager/BasicInputInfoAction.do?operation=loadPage&isNewCube=true&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		window.location.href=url;
	}
	/*Edit cube*/
	function editCube(){
		var url = "/expensemap/datamanager/BasicInputInfoAction.do?operation=loadPage&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		window.location.href=url;
	}
	
	/*
		Remove cube 
	*/
	
	function deleteCube(){
		var confirmMsg = "<bean:message key='cube.delete.confirm.message' bundle='sdmMessages'/>";
		if(confirm(confirmMsg)){
			getTarget(parent).location.href = "/expensemap/datamanager/DeleteCubeAction.do?AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		}		
	}

	//Ajax call to check CMDD  infected with virus on not
	function scanForVirus(){
		try {
			var authCode = encodeURIComponent(document.getElementById('AuthCode').value);
			var url = "/expensemap/datamanager/ExportCmddAction.do?AuthCode=" + authCode;
			var ajaxResponse = jQuery.ajax({
				url: url,
				type: "POST",
				data: {
					operation: "scanForVirus"
				},
				async: false
			}).responseText;
			
			var data = eval(ajaxResponse); 
			// If there is no data in the response, ignore this
			if(data[0]=="ERROR"){
				if(data[1]=="ui.error.occured.while.scanning"){
					alert("<bean:message key='ui.error.occured.while.scanning' bundle='sdmMessages'/>") ;
					return false;
				}else if(data[1]=="ui.error.file.inefcted.with.virus"){
					var errorMsg = "<bean:message key='ui.error.file.infected.with.virus.download' arg0='" + data[2]+"' bundle='sdmMessages'/>";
					alert(errorMsg);
					return false;
				}else if(data[1]=="you.do.not.have.permission.to.export.cmdd"){
					alert("<bean:message key='you.do.not.have.permission.to.export.cmdd' bundle='sdmMessages'/>") ;
					return false;
				}else if(data[1]=="ui.error.antivirus.scanner.notavailable"){
					alert("<bean:message key='ui.error.antivirus.scanner.notavailable' bundle='sdmMessages'/>") ;
					return false;
				}
			}
			return true;
		} catch(e) {
			alert(e);
		}
	}
	
	function processCubeConfirmation(ajaxResponse){
		var data = eval(ajaxResponse);
		
		// If there is no data in the response, ignore this
		if( data[0]=="checkJobLock") {
			if(data[1] == "LockWithCurrentUser" ){
				if(confirm(data[3])){
					processCube(data[1],data[2]);
				}
			}else if(data[1]== "LockWithAnotherUser"){
				if(confirm(data[3])){
					processCube(data[1],data[2]);
				}
			}else{
				var msg = "<bean:message key='cube.job.process.confirm.message' bundle='sdmMessages' />";
				var isConfirm = confirm(msg);
				if(isConfirm==true){
					processCube(null,null);
				}
			}
		}
	}
	
	function submitProcessCube(){
		try {
				// Validate cube meta.
				var url = "/expensemap/datamanager/ProcessCubeAction.do?operation=validateCube&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
				var ajaxResponse = eval(jQuery.ajax({
					url: url,
					type: "GET",
					async: false
				}).responseText);
				// If there is no data in the response, ignore this
				if(ajaxResponse[0]=="validateCubeMeta"){
					if(ajaxResponse[2] == "false"){
						// There is no any measure.
						alert("<bean:message key='cube.job.process.measure.not.exists' bundle='sdmMessages' />");
						return false;
					}
					if(ajaxResponse[4]=="false"){
						// default measure not exists.
						alert("<bean:message key='cube.job.process.default.measure.not.exists' bundle='sdmMessages' />");
						return false;
					}
					if(ajaxResponse[6]=="false"){
						// user defined dimension not exists
						alert("<bean:message key='cube.job.process.user.define.dimension.not.exists' bundle='sdmMessages' />");
						return false;
					}
				}

				var url = "/expensemap/datamanager/ProcessCubeAction.do?operation=checkJobLock&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
				var ajaxResponse = jQuery.ajax({
					url: url,
					type: "GET",
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
						return false;
					},
					async: false
				}).responseText;
				return processCubeConfirmation(ajaxResponse);
			} catch(e) {
				alert(e);
			}
	}
	
	function manageRules(){
		var url = "/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&ruleType=1&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		window.location.href=url;
	}

	if (<%=pollingEnabled%>) {
		setInterval(pollOnlineFeedbackJob, <%=pollingInterval%>);
	}

/**
* Polls for the submission of OLF
*/

function pollOnlineFeedbackJob(){ 
  try {        
		var url = "/expensemap/PollOnlineFeedbackJob.do";
        var ajaxResponse = eval(jQuery.ajax({
			url: url,
			type: "POST",
			async: false
		}).responseText);
        
         //session handling 
        if ( checkIfSessionActive(ajaxResponse) == false ) {
			return;
		}	 
		//Notification of OLF job submission
        if(ajaxResponse[1]=='true' && ajaxResponse[2]=='false'){        
			alert(ajaxResponse[3]);
        }
	} catch(e) { 
		//alert(e);
	}	   
}


/** 
* Checks if session is  active
*/

function checkIfSessionActive(data) {
	if (data[0] == "Error"){
		var errorCode = data[1];
		var isForceLogOut = false;
		var jobStartTime = "";
		if(errorCode == "force.timeout"){
			isForceLogOut = true;
			jobStartTime = data[4];			
		}
		
		if(errorCode == "session.timeout" || errorCode == "force.timeout") {

			var timeoutURL = data[3];
			var submitForm = createNewSubmitForm();
				
			if(isForceLogOut){				
				createNewFormElementWithTime(submitForm, "forceLogout", isForceLogOut, "jobStartTime", jobStartTime );
			}else{				
				createNewFormElement(submitForm, "forceLogout", isForceLogOut);
			}
				
			submitForm.action = timeoutURL;
			submitForm.submit();
			return false;
				 
		}
	}
	return true;
}

function createNewSubmitForm(){
	var submitForm = document.createElement("FORM");
	document.body.appendChild(submitForm);
	submitForm.method = "POST";
	return submitForm;
}

function createNewFormElement(inputForm, forceLogoutElementName, forceLogoutElementValue){
	var forceLogoutElement = document.createElement("input");
	forceLogoutElement.setAttribute('name', forceLogoutElementName);
	forceLogoutElement.setAttribute('type', 'hidden');
	inputForm.appendChild(forceLogoutElement);
	forceLogoutElement.value = forceLogoutElementValue;
	
	return forceLogoutElement;
}

function createNewFormElementWithTime(inputForm, forceLogoutElementName, forceLogoutElementValue, jobStartTimeElementName, jobStartTimeElementValue ){
	var forceLogoutElement = document.createElement('input');
	forceLogoutElement.setAttribute('name', forceLogoutElementName);
	forceLogoutElement.setAttribute('type', 'hidden');
	
	var jobStartTimeElement = document.createElement('input');
	jobStartTimeElement.setAttribute('name', jobStartTimeElementName);
	jobStartTimeElement.setAttribute('type', 'hidden');
	
	inputForm.appendChild(forceLogoutElement);
	inputForm.appendChild(jobStartTimeElement);
	forceLogoutElement.value = forceLogoutElementValue;
	jobStartTimeElement.value = jobStartTimeElementValue;
	
	return forceLogoutElement;
}
/**
* End - polling online feedback job
*/
</script>

<div class="yui-skin-sam">
	<div id="topMenu" class="yuimenubar yuimenubarnav">
		
	</div>
</div>