<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/css/dataenrichmentui.css">

<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/dataenrichment.js"></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/DateValidation.js"></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/FormChangeValidation.js"></SCRIPT>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>

<SCRIPT TYPE="text/javascript">
	<c:if test="${ requestScope.cubeDatasetType == 'dimension' }">  
		function onClickClose(){
			window.close();
		}
	</c:if>

	

	function frameOnLoad(){
		//document.getElementById('PREVIEWSECTION_TR').style.display = 'none';		
	}

	// A call back method to validate form data
	function validateFormFields(targetWindow, actionValue){			
		var isFixedWidth = document.getElementById('fixedWidth').value;
		if('false'==isFixedWidth){
			if( ! ( validateFieldDelimiter() && validateDecimalSymbol() ) ) {
				return false;
			}
		}else{
			if( ! ( validateFieldInfo() && validateDecimalSymbol() ) ) {
				return false;
			}
		}
		if( typeof document.fileImportForm.NO_OF_ROWS != 'undefined' && typeof document.fileImportForm.CURRENT_SELECT_COLUMN != 'undefined'){
			if( document.fileImportForm.NO_OF_FIELD_COLUMNS ){
				for(var colindex = 0; colindex < document.fileImportForm.NO_OF_FIELD_COLUMNS.value; colindex++){

					if( !validateRequiredFieldData(colindex) ){
						return false;
					}
/*
					if( !validateSystemDefinedColumns(colindex) ){
						return false;
					}
*/
					if( !validateDefaultTableFields(colindex) ){
						return false;
					}	
					
					if( !validateDefaultFieldOnCheck(colindex) ){
						return false;
					}				
				}
			}
			if( !validateRecordSize()) {
				return false;
			}
		}
		document.fileImportForm.formChanged.value = formChanged(document.fileImportForm);
		document.fileImportForm.operation.value = actionValue;
		document.fileImportForm.target = '_self';
		document.fileImportForm.submit();
		
		return false;
	}
	
	function validateFieldInfo(){
		var totalRowsInTable = document.getElementById("fieldDetails").rows.length;
		var flag = true;
		for(i=0; i<document.fileImportForm.elements.length; i++){
			 if('text'==document.fileImportForm.elements[i].type && 
				 document.fileImportForm.elements[i].name.search('fixedWidthDimensionField') > -1 && 
				 ""==document.fileImportForm.elements[i].value){
				alert("<bean:message key='ui.import.wizard.all.field.required.msg' bundle='sdmMessages'/>");				
				flag = false;
				break;					
			 }
		}
		return flag;
	}
	
	function deleteRow(Obj){
		var rowIndex=Obj.parentNode.parentNode.rowIndex;
		document.getElementById('fieldDetails').deleteRow(rowIndex);				
		
		var totalRowsInTable = document.getElementById("fieldDetails").rows.length;
		var tableObj = document.getElementById("fieldDetails");	
		for(var index = 1 ; index < totalRowsInTable ; index++ ){	
			
			tableObj.rows[index].cells[0].childNodes[0].name = 'fixedWidthDimensionField['+(index-1)+'].fieldName';
			tableObj.rows[index].cells[0].childNodes[0].id = 'fixedWidthDimensionField['+(index-1)+'].fieldName';

			tableObj.rows[index].cells[1].childNodes[0].name = 'fixedWidthDimensionField['+(index-1)+'].startIndex';
			tableObj.rows[index].cells[1].childNodes[0].id = 'fixedWidthDimensionField['+(index-1)+'].startIndex';
			
			tableObj.rows[index].cells[2].childNodes[0].name = 'fixedWidthDimensionField['+(index-1)+'].endIndex';
			tableObj.rows[index].cells[2].childNodes[0].id = 'fixedWidthDimensionField['+(index-1)+'].endIndex';

		}				
	}

	function addRow(){
		var tableObj = document.getElementById("fieldDetails");
		var newRow = tableObj.insertRow(tableObj.rows.length);
		var newFiledNameCell = newRow.insertCell(0);
		var newStartIndexCell = newRow.insertCell(1);
		var newWidthCell = newRow.insertCell(2);
		var newdeleteButtonCell = newRow.insertCell(3);
		var index = document.getElementById("fieldDetails").rows.length;
		
		newFiledNameCell.innerHTML = '<input type="text" id="fixedWidthDimensionField['+(index-2)+'].fieldName" name="fixedWidthDimensionField['+(index-2)+'].fieldName" maxlength="50" size="10"/>';
		newFiledNameCell.setAttribute("align","center");

		newStartIndexCell.innerHTML = '<input type="text" id="fixedWidthDimensionField['+(index-2)+'].startIndex" name="fixedWidthDimensionField['+(index-2)+'].startIndex" maxlength="50" size="10"/>';
		newStartIndexCell.setAttribute("align","center");

		newWidthCell.innerHTML = '<input type="text" id="fixedWidthDimensionField['+(index-2)+'].endIndex" name="fixedWidthDimensionField['+(index-2)+'].endIndex" maxlength="50" size="10"/>';
		newWidthCell.setAttribute("align","center");

		newdeleteButtonCell.innerHTML= '<IMG name="removeIcon" SRC="/expensemap/jsp/images/sdm/btn_delete_up.gif" title="'  + "<bean:message key='ui.datamanager.menu.create.delete' bundle='sdmMessages'/>" + '" onclick="deleteRow(this);"border="0" />';				
		newdeleteButtonCell.setAttribute("align","center");										
	}		
	
	
	
	
	
	// check for forbiden char as field Delimeter
    function checkForForbidenDelimeter(){
        var otherValue = document.fileImportForm.otherdelimiter.value;
		//1. Forward slash(/)
		//2. Backward Slash(\)
		//3. Hyphen(-)
		//4. Colon(:)
		//5. Dot(.)
		var ret = false;
		if ((otherValue=='/') ||(otherValue=='-') ||(otherValue=='\\')
	    	||(otherValue==':') ||(otherValue=='.')){
       	   ret=true;
       	}
       	return ret;
    }

	

	function validateFieldDelimiter(){
		
		var fieldDelimiterObj = document.fileImportForm.fieldDelimiter;
		var delimiterVal = getFieldDelimiterRadioValue();
		if( delimiterVal == 'other' ){
			var otherValue = document.fileImportForm.otherdelimiter.value;
			if( checkForForbidenDelimeter() ){			
				alert("<bean:message key='ui.fact.import.data.file.delimeter.invalid' bundle='sdmMessages'/>"+delimiterVal);
			    return false;
			}
			
			if( otherValue.length > 1 ){
				alert("<bean:message key='ui.fact.import.data.file.delimeter.single.char.required' bundle='sdmMessages'/>");
			    return false;
			}
			
			if(isEmpty(otherValue)){
				alert("<bean:message key='ui.fact.import.data.file.delimeter.required' bundle='sdmMessages'/>");
			    return false;
			}
			otherValue = otherValue.replace(/^\s*|\s*$/g,"");
			if( otherValue == ''){
				alert("<bean:message key='ui.fact.import.data.file.delimeter.required' bundle='sdmMessages'/>");
				document.fileImportForm.otherdelimiter.value= '';
				return false;
			}			
		}
		return true;
	}
	
	function validateDecimalSymbol(){
		
		var decimalSymbolObj = document.fileImportForm.decimalSymbol;
		if(decimalSymbolObj.value.length != 1 ){
			alert("<bean:message key='ui.fact.import.data.file.decimal.symbol.single.char.required' bundle='sdmMessages'/>");
			document.fileImportForm.decimalSymbol.value= '';
			return false;
		}
		return true;
	}


	
    function onClickFieldDelimterOptionShowOtherControl(fieldDelimiterObj) {
        var delimiterValue = fieldDelimiterObj.value;
        if ( delimiterValue == 'other' ){
            document.fileImportForm.otherdelimiter.readOnly =false;
        }
        else {
            document.fileImportForm.otherdelimiter.readOnly =true;
            document.fileImportForm.otherdelimiter.value='';
        }
    }
    
    function getFieldDelimiterRadioValue(){    
    	var val = '';
    	for( i = 0; i < document.fileImportForm.fieldDelimiter.length; i++ )
		{
			if( document.fileImportForm.fieldDelimiter[i].checked ){
				val = document.fileImportForm.fieldDelimiter[i].value;
				break;
			}
		}
		return val;
    }
    
    function getFieldDelimiterValue(){
    	var val = getFieldDelimiterRadioValue();		
		
		if(val == 'other'){
			val = document.fileImportForm.otherdelimiter.value;
		}
		return val;
    }
    
    
		
</SCRIPT>

<SCRIPT TYPE="text/javascript" >

	function submitPreview(){
		var isFixedWidth = document.getElementById('fixedWidth').value;
		if('false'==isFixedWidth){
			if( ! ( validateFieldDelimiter() && validateDecimalSymbol() ) ) {
					return false;	
			}
		}else{
			if( ! ( validateFieldInfo() && validateDecimalSymbol() ) ) {
				return false;
			}		
		}
		document.fileImportForm.formChanged.value = formChanged(document.fileImportForm);
		document.fileImportForm.operation.value = 'preview';
		document.fileImportForm.preview.value = 'true';
		document.fileImportForm.target = '_self';
		document.fileImportForm.submit();		
    }
    
   
    
</SCRIPT>



<SCRIPT TYPE="text/javascript" >

	function setCurrentColumn(currentColumn){
		document.fileImportForm.CURRENT_SELECT_COLUMN.value = currentColumn;
	}

	function enableFailedColumn(currentColumn){
		var currentSelectColumn = document.fileImportForm.CURRENT_SELECT_COLUMN.value;

		if( currentSelectColumn != currentColumn ){
			changeColor(currentColumn);
			enableFieldMeta(currentColumn);
			//enableDateOrder(currentColumn);
			setCurrentColumn(currentColumn);
		}
	}
	
	function changeColor(currentColumn){
		var id = null;
		var header = null;
		var cell = null;
		var currentSelect = null;

		if( document.fileImportForm.NO_OF_ROWS && document.fileImportForm.CURRENT_SELECT_COLUMN ){
			// reset the previouse header
			currentSelect = document.fileImportForm.CURRENT_SELECT_COLUMN.value;
			id = 'DATA_HEADER_' + currentSelect;
			header = document.getElementById(id);
			if (header) {
				header.style.backgroundColor = '#b3bcdf';
			}
			// Set new color to selected header
			id = 'DATA_HEADER_' + currentColumn;
			header = document.getElementById(id);
			if (header) {
				header.style.backgroundColor = '#bfbfff';
			}

			// reset the table data
			for(var colindex = 0; colindex < document.fileImportForm.NO_OF_ROWS.value; colindex++){
				id = 'CELL_DATA_' + colindex + '_' + currentSelect ;
				cell = document.getElementById(id);
				if (cell) {
					cell.style.backgroundColor = '#DCDCDC';
				}
			}
			// set the data to specified color
			for(var colindex = 0; colindex < document.fileImportForm.NO_OF_ROWS.value; colindex++){				
				id = 'CELL_DATA_' + colindex + '_' + currentColumn ;
				cell = document.getElementById(id);
				if (cell) {
					cell.style.backgroundColor = '#C0C0C0';
				}
			}
			document.fileImportForm.CURRENT_SELECT_COLUMN.value = currentColumn;
		}
	}

	function validateDataType(currentColumn){
	
		var fromDataType = new String (document.getElementById('defaultDataType_'+currentColumn).value).toLowerCase();	
		var toDataType =  new String (document.getElementById('dataType_'+currentColumn).value).toLowerCase();	
		var roleForCurrentCol = document.getElementById('role_'+currentColumn).value;
		var processedField = document.getElementById('processedField_'+currentColumn).value;
		if(fromDataType=='numeric'){
			var roleForMeasure = document.fileImportForm.usedInMeasure.value; 
			if(!roleForMeasure == ''){
				var roleForMeasureArr=roleForMeasure.split(',');
					for(var i=0;i<roleForMeasureArr.length;i++){
						if(document.getElementById('name_'+currentColumn).value == roleForMeasureArr[i]){
							roleForCurrentCol='true';
							break;
						}
					}
			}
		}
	//skipping validation for unprocessed and unused fields
		if(processedField == 'false' && roleForCurrentCol == ''){
			return true;
		}
		if(fromDataType=='datetime'){
			if(toDataType=='boolean'){
				alert("<bean:message key='ui.cubedataset.preview.datatype.err.msg.datetime.to.boolean' bundle='sdmMessages'/>");
				document.getElementById('dataType_'+currentColumn).value = fromDataType;
				return false;
			}else if(toDataType =='numeric'){
				alert("<bean:message key='ui.cubedataset.preview.datatype.err.msg.datetime.to.numeric' bundle='sdmMessages'/>");
				document.getElementById('dataType_'+currentColumn).value = fromDataType;
				return false;
			}
			else if(toDataType =='string'){
			alert("<bean:message key='ui.cubedataset.preview.datatype.err.msg.datetime.to.string' bundle='sdmMessages'/>");
				alert('string is not allowed');
				document.getElementById('dataType_'+currentColumn).value = fromDataType;
				return false;
			}
		}else if(fromDataType=='numeric'){
			if(toDataType =='boolean'){
				alert("<bean:message key='ui.cubedataset.preview.datatype.err.msg.numeric.to.boolean' bundle='sdmMessages'/>");
				document.getElementById('dataType_'+currentColumn).value = fromDataType;
				return false;
			}else if(toDataType=='datetime'){
				alert("<bean:message key='ui.cubedataset.preview.datatype.err.msg.numeric.to.datetime' bundle='sdmMessages'/>");
				document.getElementById('dataType_'+currentColumn).value = fromDataType;
				return false;
			}
			else if(toDataType=='string'){
				alert("<bean:message key='ui.cubedataset.preview.datatype.err.msg.numeric.to.string' bundle='sdmMessages'/>");
				document.getElementById('dataType_'+currentColumn).value = fromDataType;
				return false;
			}	
		}
		return true;
		
	}
	

	function enableDateOrder(currentColumn){
		
		
		if(validateDataType(currentColumn)){

			var datePatternObj = document.getElementById('pattern_'+currentColumn);

			var dataTypeObj = document.getElementById('dataType_'+currentColumn);

			if(dataTypeObj.options[dataTypeObj.selectedIndex].value == 'datetime'){
				datePatternObj.disabled=false;
			}else {
				datePatternObj.disabled=true;
			}

			if(dataTypeObj.options[dataTypeObj.selectedIndex].value == 'numeric'){
				var sizeObj = document.getElementById('size_'+currentColumn);
				if( sizeObj.value > 38 ){
					sizeObj.value = 38;
				}
			}
		}
	}

	function enableFieldMeta(currentColumn){
		var id = null;
		var tableObj = null;
		if( document.fileImportForm.NO_OF_FIELD_COLUMNS ){
			// hide all current field meta data
			for(var colindex = 0; colindex < document.fileImportForm.NO_OF_FIELD_COLUMNS.value; colindex++){
				id = 'TABLE_ID_' + colindex ;
				tableObj = document.getElementById(id);
				if(tableObj){
					tableObj.style.display = 'none';
				}
			}

			// show the selected field meta data
			id = 'TABLE_ID_' + currentColumn ;
			tableObj = document.getElementById(id);
			if(tableObj){
				tableObj.style.display = 'block';
				var nullableObj = document.getElementById('nullable_'+currentColumn);
				if(nullableObj.checked){
					var defaultValueObj = document.getElementById('defaultValue_'+currentColumn);
					defaultValueObj.value = "";
					defaultValueObj.disabled=true;
				}
			}
		}		
	}

	function validateDefaultDateValue(dateString, datePattern, delimiter){
		var partOne = datePattern.substr(0, 2);
		var partTwo = datePattern.substr(2, 2);
		var partThree = datePattern.substr(4, 2);
	}

	function validateDefaultFieldOnCheck(currentColumn){
		var nullableObj = document.getElementById('nullable_'+currentColumn);
		var defaultValueObj = document.getElementById('defaultValue_'+currentColumn);

		if(nullableObj.checked){
			defaultValueObj.value = "";
			defaultValueObj.disabled=true;
		}else {
			var dataTypeObj = document.getElementById('dataType_'+currentColumn);
			if( dataTypeObj.options[dataTypeObj.selectedIndex].value == 'datetime' && defaultValueObj.value.length == 0 ){
				alert("<bean:message key='ui.fact.import.data.file.field.not.nullable.defaultvalue.required' bundle='sdmMessages'/>");
				enableFieldMeta(currentColumn);							
				defaultValueObj.disabled=false;
				defaultValueObj.focus();
				return false;
			}
			defaultValueObj.disabled=false;
		}
		return true;
     }

	function validateRecordSize(){
		var ignoreColumnSizeCheckFlag = eval(document.fileImportForm.ignoreColumnSizeCheck);
		if(ignoreColumnSizeCheckFlag.value=='true'){
			return true;
		}
		if( document.fileImportForm.NO_OF_FIELD_COLUMNS ){
			var currentRecordSize = 0;

			for(var colindex = 0; colindex < document.fileImportForm.NO_OF_FIELD_COLUMNS.value; colindex++){
				var dataType = document.getElementById('dataType_'+colindex).value;
				var dataSize = document.getElementById('size_'+colindex).value;

				if( dataType == 'numeric' ){
					// maximum BIGINT=8 or DOUBLE = 8 bytes
					currentRecordSize += 8;
				} else if ( dataType == 'boolean') {

				} else if ( dataType == 'datetime'){
					// maximum 8 bytes required to store DATETIME
					currentRecordSize += 8;
				} else if ( dataType == 'string'){
					// assuming utf-8 character set with each charater requires 3 bytes
					currentRecordSize += ( parseInt (dataSize) * 3 );
				}
			}

			if( currentRecordSize > 65535 ){
				alert("<bean:message key='ui.fact.import.data.file.maximum.record.size.exceed.error.message' bundle='sdmMessages'/>");
				return false;
			}
		}
		return true;
	}

	function validateRequiredFieldData(currentColumn){
		
		var fieldNameObj = document.getElementById('name_'+currentColumn);
		var currentSelectColumn = document.fileImportForm.CURRENT_SELECT_COLUMN.value;

		if( fieldNameObj.value == ''){
			alert("<bean:message key='ui.fact.import.data.file.field.name.required' bundle='sdmMessages'/>");
			enableFailedColumn(currentColumn);
			fieldNameObj.focus();
			return false;
		}
				
		if(typeof fieldNameObj != "undefined"  && ''!= fieldNameObj) {
			// Check special char in field name.
			var fieldValue = fieldNameObj.value;
			var allowedChar = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_0123456789";
			for (var i = 0; i < fieldValue.length; i++) {
				if (allowedChar.indexOf(fieldValue.charAt(i)) == -1){
					alert("<bean:message key='ui.fact.import.data.file.field.name.no.special.char' bundle='sdmMessages' />");
					enableFailedColumn(currentColumn);
					return false;
				}
			}
				
			// Field name should start with alphabet .
			var pattern = new RegExp("^[A-Za-z]");
			if( !pattern.test(fieldValue)){
				alert("<bean:message key='ui.fact.import.data.file.field.name.no.special.char' bundle='sdmMessages' />");
				enableFailedColumn(currentColumn);
				return false;
			}
		}

		// data type assigned by user
		var dataType = document.getElementById('dataType_'+currentColumn).value;
		var dateDelimiterObj = document.getElementById('dateDelimiter_'+currentColumn);

		if( dataType == 'datetime' ){
			if( dateDelimiterObj.value == ''){
				alert("<bean:message key='ui.fact.import.data.file.field.date.delimiter.required' bundle='sdmMessages'/>");
				enableFailedColumn(currentColumn);
				dateDelimiterObj.focus();
				return false;
			}else if (dateDelimiterObj.value.length > 1){
				alert("<bean:message key='ui.fact.import.data.file.field.date.delimiter.invalid' bundle='sdmMessages'/>");
				enableFailedColumn(currentColumn);
				dateDelimiterObj.focus();
				return false;
			}
		}

		return true;
	}

	function validateSystemDefinedColumns(currentColumn){
		
		// Name of the fields
		var fieldNameObj = document.getElementById('name_'+currentColumn);
		var systemDefinedColumns = document.fileImportForm.systemDefinedColumns.value; 

		
		if(!isEmpty(systemDefinedColumns)){
			if( systemDefinedColumns.substr(0,1) == '['){
				systemDefinedColumns = systemDefinedColumns.substring(1, systemDefinedColumns.length);
			}

			if(systemDefinedColumns.substr(systemDefinedColumns.length-1,1) == ']'){
				systemDefinedColumns = systemDefinedColumns.substring(0,systemDefinedColumns.length-1);
			}

			var systemDefinedColumnsArr = systemDefinedColumns.split(",");

			for(var i=0; i<systemDefinedColumnsArr.length; i++){
			
				if( fieldNameObj.value == trim(systemDefinedColumnsArr[i])){
					alert(systemDefinedColumnsArr[i] + ' is system field name, please provide another name');
					enableFailedColumn(currentColumn);
					fieldNameObj.value='';
					fieldNameObj.focus();
					return false;
				}
			}
		}
		return true;
	}
	function isNotEmpty(elem) { 
		var str = elem.value;		
		if(str == null || str.length == 0 || str== 0 || str.indexOf("-")>-1) { 			 
			return false;  
		} else {  
			return true;  
		}  
	}  

	function validateDefaultTableFields(currentColumn) {

		// Default value assigned by user
		var defaultObj = document.getElementById('defaultValue_'+currentColumn);
		 // data type assigned by user
		var dataType = document.getElementById('dataType_'+currentColumn).value;

		//
		var sizeObj = document.getElementById('size_'+currentColumn);
		sizeObj.value=trim(sizeObj.value);
		var currentSelectColumn = document.fileImportForm.CURRENT_SELECT_COLUMN.value;

		if( dataType == 'numeric' ){
			if(!validateNotNumber(defaultObj, "<bean:message key='ui.fact.import.data.file.field.default.value.numeric.required' bundle='sdmMessages'/>")) {
				enableFailedColumn(currentColumn);
				defaultObj.focus();
				return false;
		   }
		   else if( parseInt ( sizeObj.value ) > 38 ){
				alert("<bean:message key='ui.fact.import.data.file.field.maximum.size.limit.for.numeric' bundle='sdmMessages'/>");// 
				enableFailedColumn(currentColumn);
				sizeObj.focus();
				return false;
		   }
		}

		if( dataType == 'boolean'){
			if(!isBoolean(defaultObj, "<bean:message key='ui.fact.import.data.file.field.default.value.boolean.required' bundle='sdmMessages'/>")) {
				enableFailedColumn(currentColumn);
				defaultObj.focus();
				return false;
		   }
		}

		// check for default date
		if( dataType == 'datetime' ){
			var dateDelimiterObj = document.getElementById('dateDelimiter_'+currentColumn);
			var datePatternObj = document.getElementById('pattern_'+currentColumn);
			var nullableObj = document.getElementById('nullable_'+currentColumn);

			if( defaultObj.value != '' && ! validateDate(defaultObj.value, datePatternObj.value, dateDelimiterObj.value)){
				alert("<bean:message key='ui.fact.import.data.file.field.default.date.invalid' bundle='sdmMessages'/>");
				enableFailedColumn(currentColumn);
				defaultObj.value='';
				defaultObj.focus();
				return false;
			}
		}
		var iChars = "\"\'%_\\";
		if(! validateSpecialChars(defaultObj, "<bean:message key='ui.fact.import.data.file.field.no.special.char.defaultvalue.message' arg0="\\\\" arg1="\'" arg2="\\\"" arg3="%" arg4="_"  bundle='sdmMessages' />",  iChars ) ){
				 return false;
		 }

		//check for size value is not a number		
		if(!validateNotNumber(sizeObj , "<bean:message key='ui.cubedataset.preview.valid.maximum.size.err.msg' bundle='sdmMessages'/>")) {			
			enableFailedColumn(currentColumn);
			sizeObj.focus();
			return false;
        }
		if(!isNotEmpty(sizeObj)){
			alert("<bean:message key='ui.cubedataset.preview.valid.maximum.size.err.msg' bundle='sdmMessages'/>"); 
			enableFailedColumn(currentColumn);
			sizeObj.focus();
			return false;
		}
		// check for null
		/*if( document.getElementById('nullable_'+currentColumn).checked && defaultObj.value.length > 0){
			alert('<bean:message key="ui.fact.import.data.file.field.default.value.null.checked" bundle="sdmMessages"/>');
			enableFailedColumn(currentColumn);
			document.getElementById('nullable_'+currentColumn).checked=false;
			return false;
		}*/

		return true;

	}

</SCRIPT>

<TR>
	<TD>
	<html:form styleId="fileImportForm" target="_top" action="${actionName}" method="post">
		<TABLE class="POPFORMBORDER" cellSpacing="1" cellPadding="0" width="100%" border="0">
			<TR class="POPFORMBODY">
				<TD>					
					<TABLE class="POPFORMBODY" cellSpacing="0" cellPadding="0" width="100%" border="0">
						<logic:messagesPresent message="true">
							<TR>
								<TD colspan="2" CLASS="POPFORMTITLE" STYLE="padding-left:5px">
									<FONT COLOR="red" FACE="Arial, Helvetica, sans-serif" SIZE="2">
										<b><html:messages id="msg" message="true" bundle="sdmMessages">
											&nbsp;&nbsp;&nbsp;<%=pageContext.findAttribute("msg")%>
										</html:messages></b>
									</FONT>
								</TD>
							</TR>
						</logic:messagesPresent>
						<logic:messagesPresent name="importWizardPreviewSaveFailed">
							<TR>
								<TD colspan="2" CLASS="POPFORMTITLE" STYLE="padding-left:5px">
									<FONT COLOR="red" FACE="Arial, Helvetica, sans-serif" SIZE="2">
										<html:messages name="importWizardPreviewSaveFailed" id="errorMessage" bundle="sdmMessages">
											<%=pageContext.findAttribute("errorMessage")%>
										</html:messages>
									</FONT>
								</TD>
							</TR>
						</logic:messagesPresent>
						
						<TR>
							<TD colspan="2" CLASS="POPFORMTITLE" STYLE="padding-left:5px">
								<bean:message key="ui.fact.import.data.file.header" bundle="sdmMessages" />
							</TD>
						</TR>

						<TR>
							<TD colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
						</TR>

						<TR>
							<TD class="POPFORMTITLE" STYLE="padding-left:5px; padding-right:5px" width="20%">
								<DIV class="DIVLABELSTYLE">
									<bean:message key="ui.fact.import.data.file.delimeter.selection.lable" bundle="sdmMessages" />
								</DIV>
							</TD>

							<TD class="POPFORMFIELD" STYLE="padding-left:5px" height="20%">
								<TABLE cellSpacing="0" cellPadding="0" border="0">
									<TR>	
										<TD CLASS="POPFORMFIELD" colspan="4">
											<c:choose>
												<c:when test="${!fileImportForm.fixedWidth}">
													<c:forEach items="${ requestScope.fieldDelimiterTypes }" var="fieldDelimiterType" >
															<html:radio property="fieldDelimiter" 
																   value="${fieldDelimiterType.type}" 
																   styleId="${fieldDelimiterType.type}" onclick="onClickFieldDelimterOptionShowOtherControl(this)"/>
															<bean:message key="${fieldDelimiterType.key}" bundle="sdmMessages" />&nbsp;&nbsp;
													</c:forEach>																									<c:choose>
													<c:when test="${fileImportForm.fieldDelimiter == 'other'}" >
														<html:text maxlength="5" size="10" property="otherdelimiter" />
													</c:when>
													<c:otherwise>
														<html:text maxlength="5" size="10" property="otherdelimiter" readonly="true"/>		
													</c:otherwise>
													</c:choose>
												</c:when>
												<c:otherwise>
													&nbsp;
												</c:otherwise>
											</c:choose>
										</TD>
									</TR>
									
									<c:if test="${!fileImportForm.fixedWidth}">
										<TR>
											<TD CLASS="POPFORMFIELD" STYLE="padding-left:5px">
												<bean:message key="ui.fact.import.data.file.text.qualifier.lable" bundle="sdmMessages" />
											</TD>
											<TD class="POPFORMFIELD" STYLE="padding-left:5px" >
												<html:select styleId="textQualifier" property="textQualifier" >
													<c:forEach items="${ requestScope.textQualifierTypes }" var="textQualifierType" >
														<html:option value="${textQualifierType.type}">
															<bean:message key="${textQualifierType.key}" bundle="sdmMessages"/>
														</html:option>
													</c:forEach>
												</html:select>
											</TD>
											<TD class="POPFORMFIELD" STYLE="padding-left:5px" >
												<bean:message key="ui.fact.import.data.file.escape.character.lable" bundle="sdmMessages" />												
											</TD>
											<TD class="POPFORMFIELD" STYLE="padding-left:5px" >
												<bean:write name="fileImportForm" property="escapeCharacter" />
												<html:hidden name="fileImportForm" property="escapeCharacter" />
											</TD>
										</TR>
									</c:if>

									<TR>
										<TD CLASS="POPFORMFIELD" STYLE="padding-left:5px">
											<bean:message key="ui.fact.import.data.file.end.of.line.character.lable" bundle="sdmMessages" />
										</TD>
										<TD class="POPFORMFIELD" STYLE="padding-left:5px" >
											<html:select styleId="endOfLineChar" property="endOfLineChar" >
												<c:forEach items="${ requestScope.endOfLineCharTypes }" var="endOfLineCharType" >
													<html:option value="${endOfLineCharType.type}">
														<bean:message key="${endOfLineCharType.key}" bundle="sdmMessages"/>
													</html:option>
												</c:forEach>
											</html:select>
										</TD>
										<TD CLASS="POPFORMFIELD" STYLE="padding-left:5px">
											<bean:message key="ui.fact.import.data.file.encoding.format.lable" bundle="sdmMessages" />
										</TD>
										<TD class="POPFORMFIELD" STYLE="padding-left:5px" >
											<html:select styleId="encodingFormat" property="encodingFormat" >
												<c:forEach items="${ requestScope.fileEncodingTypes }" var="fileEncodingType" >
													<html:option value="${fileEncodingType.type}">
														<bean:message key="${fileEncodingType.key}" bundle="sdmMessages"/>
													</html:option>
												</c:forEach>
											</html:select>
										</TD>											
									</TR>
								</TABLE>
							</TD>							
						</TR>
						<TR>
							<TD colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
						</TR>
						
						<TR>
							<TD CLASS="POPFORMTITLE" STYLE="padding-left:5px">
								<DIV class="DIVLABELSTYLE">
									<bean:message key="ui.fact.import.data.file.numbers.lable" bundle="sdmMessages" />
								</DIV>
							</TD>
							<TD class="POPFORMFIELD" STYLE="padding-left:5px">
								<bean:message key="ui.fact.import.data.file.decimal.symbol.lable" bundle="sdmMessages" />
								<html:text maxlength="5" size="10" property="decimalSymbol" />
							</TD>
						</TR>

						<TR>
							<TD colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
						</TR>
						
						<c:if test="${fileImportForm.fixedWidth}">
							<TR>
								<TD CLASS="POPFORMTITLE" >
									<DIV class="DIVLABELSTYLE">								
										<bean:message key="ui.label.import.wizard.field.information" bundle="sdmMessages"/>										
									</DIV>
								</TD>
								<TD class="POPFORMFIELD">
									<DIV STYLE="width:400px;height:145px;overflow:auto;">
									<table id="fieldDetails" cellSpacing="1" cellPadding="1" border="0">
										<TR>
											<TD CLASS="POPFORMLABELCENTER" WIDTH="30%"><bean:message key="ui.label.import.wizard.field.name" bundle="sdmMessages"/></TD> 
											<TD CLASS="POPFORMLABELCENTER" WIDTH="30%"><bean:message key="ui.label.import.wizard.start.position" bundle="sdmMessages"/></TD>
											<TD CLASS="POPFORMLABELCENTER" WIDTH="30%" ><bean:message key="ui.label.import.wizard.length" bundle="sdmMessages"/></TD>
											<TD><html:button property="add" onclick="addRow();"><bean:message key="ui.import.wizard.add.button" bundle="sdmMessages"/></html:button>
										</TR>
										<logic:iterate id="fixedWidthDimensionField" name="fileImportForm" property="fixedWidthDimensionFields" scope="request" indexId="ctr">
											<TR>
												<TD align="center"><html:text name="fixedWidthDimensionField" styleId="fixedWidthDimensionField[${ctr}].fieldName" property='fieldName' indexed='true' maxlength="50" size="10" /></TD>
												<TD align="center"><html:text name="fixedWidthDimensionField" styleId="fixedWidthDimensionField[${ctr}].startIndex" property='startIndex' indexed='true' maxlength="50" size="10"/></TD>
												<TD align="center"><html:text name="fixedWidthDimensionField" styleId="fixedWidthDimensionField[${ctr}].endIndex" property='endIndex' indexed='true' maxlength="50" size="10"/></TD>
												<c:if test="${ctr > 0}">
													<TD align="center">
														<IMG name="removeIcon" SRC="/expensemap/jsp/images/sdm/btn_delete_up.gif" title="<bean:message key='ui.datamanager.menu.create.delete' bundle='sdmMessages'/>" onclick="deleteRow(this)"border="0"/>
													</TD>
												</c:if>
											</TR>
										</logic:iterate>
									</table>
									</DIV>
								</TD>
							</TR>
							<TR>
								<TD colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
							</TR>
						</c:if>


						<TR>
							<TD CLASS="POPFORMTITLE">
							</TD>
							<TD align="center" class="POPFORMFIELD" height='30px' >
								<html:button property="submitBtn" onclick="return submitPreview();"><bean:message key="ui.import.preview.button"  bundle="sdmMessages" /></html:button>
							</TD>
						</TR>

						<TR>
							<TD colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
						</TR>

						<TR ID="PREVIEWSECTION_TR">
							<TD COLSPAN="2" ID="PREVIEWSECTION_TD">
								<c:if test="${ empty importWizardPreviewFailed && param.preview == 'true' }">  
									
									<INPUT TYPE="hidden" NAME="systemDefinedColumns" id="systemDefinedColumns" VALUE="<c:out value='${requestScope.SystemDefinedColumns}'/>"/>
									<INPUT TYPE="hidden" NAME="usedInMeasure" id="usedInMeasure" VALUE="<c:out value='${requestScope.usedInMeasure}'/>"/>
									<TABLE width="100%" cellSpacing="0" cellPadding="0" border="0">
										<TR height="50px">
											<TD CLASS="POPFORMTITLE" STYLE="padding-left:5px" width="20%">
												<DIV class="DIVLABELSTYLE">
													<bean:message key="ui.fact.import.data.file.field.options.lable" bundle="sdmMessages" />
												</DIV>
											</TD>
											<TD class="POPFORMFIELD" STYLE="padding-left:5px">
												<logic:iterate id="fieldMetaDetail" name="fileImportForm" property="fieldMetaDetails" scope="request" indexId="index">
													<c:choose>
														<c:when test="${index == 0}" >
															<TABLE ID='TABLE_ID_${index}' STYLE="display:block" width="100%" border="0" cellpadding="2" cellspacing="0">
														</c:when>
														<c:otherwise>
															<TABLE ID='TABLE_ID_${index}' STYLE="display:none" width="100%" border="0" cellpadding="2" cellspacing="0">
														</c:otherwise>
													</c:choose>

														<TR height="30px">
															<TD NOWRAP>
																<bean:message key="ui.fact.import.data.file.field.date.order.lable" bundle="sdmMessages" />
															</TD>
															<TD NOWRAP>
																<c:choose>
																	<c:when test="${ fieldMetaDetail.modifiable }">
																		<c:choose>
																			<c:when test="${ fieldMetaDetail.dataType == 'datetime' }">
																				<html:select name="fieldMetaDetail" property="pattern" styleId="pattern_${index}" indexed="true" >
																					<c:forEach items="${ dateOrderTypes }" var="dateOrderType" >
																						<html:option value="${dateOrderType.type}">
																							<bean:message key="${dateOrderType.key}" bundle="sdmMessages"/>
																						</html:option>
																					</c:forEach>
																				</html:select>
																			</c:when>
																			<c:otherwise>
																				<html:select name="fieldMetaDetail" property="pattern" styleId="pattern_${index}" indexed="true" disabled="true" >
																					<c:forEach items="${ dateOrderTypes }" var="dateOrderType" >
																						<html:option value="${dateOrderType.type}">
																							<bean:message key="${dateOrderType.key}" bundle="sdmMessages"/>
																						</html:option>
																					</c:forEach>
																				</html:select>
																			</c:otherwise>
																		</c:choose>
																	</c:when>
																	<c:otherwise>
																		<span style="color:gray;font-size:9pt;" align="left">
																			<bean:write name="fieldMetaDetail" property="pattern"/>
																		</span>
																		<span style="visibility: hidden">
																			<html:select name="fieldMetaDetail" property="pattern" styleId="pattern_${index}" indexed="true" >
																				<c:forEach items="${ dateOrderTypes }" var="dateOrderType" >
																					<html:option value="${dateOrderType.type}">
																						<bean:message key="${dateOrderType.key}" bundle="sdmMessages"/>
																					</html:option>
																				</c:forEach>
																			</html:select>
																		</span>
																	</c:otherwise>
																</c:choose>
															</TD>
															<TD NOWRAP>
																<bean:message key="ui.fact.import.data.file.field.date.delimiter.lable" bundle="sdmMessages" />
															</TD>
															<TD NOWRAP>
																<c:choose>
																	<c:when test="${ fieldMetaDetail.modifiable }">
																		<html:text name="fieldMetaDetail" property="dateDelimiter" styleId="dateDelimiter_${index}" indexed="true" maxlength="10" size="5" />
																	</c:when>
																	<c:otherwise>
																		<span style="color:gray;font-size:9pt" align="left"><bean:write name="fieldMetaDetail" property="dateDelimiter"/></span>
																		<span style="visibility: hidden">
																			<html:text name="fieldMetaDetail" property="dateDelimiter" styleId="dateDelimiter_${index}" indexed="true" maxlength="10" size="5" />
																		</span>

																	</c:otherwise>
																</c:choose>
															</TD>
															<TD NOWRAP>
																<bean:message key="ui.fact.import.data.file.field.null.value.lable" bundle="sdmMessages" />
															</TD>
															<TD NOWRAP>
																<c:choose>
																	<c:when test="${ fieldMetaDetail.modifiable }">
																		<html:checkbox name="fieldMetaDetail" property="nullable" styleId="nullable_${index}" indexed="true" value="true" onclick="validateDefaultFieldOnCheck('${index}')"/>
																	</c:when>
																	<c:otherwise>
																		<span style="color:gray;font-size:9pt"  align="left"><bean:write name="fieldMetaDetail" property="nullable"/></span>
																		<span style="visibility: hidden">
																			<html:checkbox name="fieldMetaDetail" property="nullable" styleId="nullable_${index}" indexed="true" value="true" onclick="validateDefaultFieldOnCheck('${index}')"/>
																		</span>
																	</c:otherwise>
																</c:choose>

															</TD>
															<TD NOWRAP>
																<bean:message key="ui.fact.import.data.file.field.time.delimiters.lable" bundle="sdmMessages" />
															</TD>
															<TD NOWRAP>
																
															</TD>
														</TR>
														<TR height="30px">
															<TD NOWRAP>
																<bean:message key="ui.fact.import.data.file.field.name.lable" bundle="sdmMessages" />
															</TD>
															<TD NOWRAP>
																<c:choose>
																	<c:when test="${ !fieldMetaDetail.processedField }">																		
																		<html:text name="fieldMetaDetail" property="name" styleId="name_${index}" indexed="true" maxlength="50" size="5" />
																	</c:when>
																	<c:otherwise>
																		<span style="color:gray;font-size:9pt"  align="left"><bean:write name="fieldMetaDetail" property="name"/></span>
																		<span style="visibility: hidden">
																			<html:text name="fieldMetaDetail" property="name" styleId="name_${index}" indexed="true" maxlength="50" size="5" />
																		</span>
																	</c:otherwise>
																</c:choose>

																<html:hidden name="fieldMetaDetail" property="fileFieldId" styleId="fileFieldId_${index}" indexed="true"/>
																<html:hidden name="fieldMetaDetail" property="cubeDatasetFieldId" styleId="cubeDatasetFieldId_${index}" indexed="true"/>
																<html:hidden name="fieldMetaDetail" property="role" styleId="role_${index}" indexed="true"/>
																<html:hidden name="fieldMetaDetail" property="newFileField" styleId="newFileField_${index}" indexed="true"/>
																<html:hidden name="fieldMetaDetail" property="processedField" styleId="processedField_${index}" indexed="true"/>
																<html:hidden name="fieldMetaDetail" property="modifiable" styleId="modifiable_${index}" indexed="true"/>
																<html:hidden name="fieldMetaDetail" property="fileFieldName" styleId="fileFieldName_${index}" indexed="true"/>
																<input type="hidden" name="defaultDataType_${index}" id="defaultDataType_${index}" value="<c:out value='${fieldMetaDetail.dataType}'/>"/>
																
															</TD>
															<TD NOWRAP>
																<bean:message key="ui.fact.import.data.file.field.data.type.lable" bundle="sdmMessages" />
															</TD>
															<TD NOWRAP>
																<c:choose>
																	<c:when test="${ fieldMetaDetail.modifiable }">
																		<html:select name="fieldMetaDetail" property="dataType" styleId="dataType_${index}" indexed="true" onchange="enableDateOrder('${index}');" >
																			<c:forEach items="${ dataTypes }" var="dataType" >
																				<html:option value="${dataType.type}">
																					<bean:message key="${dataType.key}" bundle="sdmMessages"/>
																				</html:option>
																			</c:forEach>
																		</html:select>
																	</c:when>
																	<c:otherwise>
																		<span style="color:gray;font-size:9pt"><c:out value="${fieldMetaDetail.dataType}"/></span>
																		<span style="visibility: hidden">
																			<html:select name="fieldMetaDetail" property="dataType" styleId="dataType_${index}" indexed="true" >
																				<c:forEach items="${ dataTypes }" var="dataType" >
																					<html:option value="${dataType.type}">
																						<bean:message key="${dataType.key}" bundle="sdmMessages"/>
																					</html:option>
																				</c:forEach>
																			</html:select>
																		</span>
																	</c:otherwise>
																</c:choose>
															</TD>
															<TD NOWRAP>
																<bean:message key="ui.fact.import.data.file.field.default.value.lable" bundle="sdmMessages" />
															</TD>
															<TD NOWRAP>
																<c:choose>
																	<c:when test="${ fieldMetaDetail.modifiable }">
																		<html:text name="fieldMetaDetail" property="defaultValue" styleId="defaultValue_${index}" indexed="true" maxlength="1000" size="5" onchange="validateDefaultTableFields('${index}')"/>
																	</c:when>
																	<c:otherwise>
																		<span style="color:gray;font-size:9pt"  align="left">
																			<bean:write name="fieldMetaDetail" property="defaultValue"/>
																		</span>
																		<span style="visibility: hidden">
																			<html:text name="fieldMetaDetail" property="defaultValue" styleId="defaultValue_${index}" indexed="true" maxlength="1000" size="5" onchange="validateDefaultTableFields('${index}')"/>
																		</span>
																	</c:otherwise>
																</c:choose>
															</TD>
															<TD NOWRAP>
																<bean:message key="ui.fact.import.data.file.field.maximum.size.lable" bundle="sdmMessages" />
															</TD>
															<TD NOWRAP>
																<c:choose>
																	<c:when test="${ fieldMetaDetail.modifiable }">
																		<html:text name="fieldMetaDetail" property="size" onchange="validateDefaultTableFields('${index}')" styleId="size_${index}" indexed="true" maxlength="10" size="3" />
																	</c:when>
																	<c:otherwise>
																	<span style="color:gray;font-size:9pt"  align="left">
																			<bean:write name="fieldMetaDetail" property="size"/>
																		</span>
																		<span style="visibility: hidden">
																			<html:text name="fieldMetaDetail" property="size" styleId="size_${index}" indexed="true" maxlength="10" size="3" />
																		</span>
																	</c:otherwise>
																</c:choose>
															</TD>
														</TR>
													</TABLE>
												</logic:iterate>
											</TD>
										</TR>
										<TR>
											<TD colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
										</TR>
										<TR>
											<TD CLASS="POPFORMTITLE" STYLE="padding-left:5px">
												<DIV class="DIVLABELSTYLE">
													<bean:message key="ui.fact.import.data.file.preview.table.lable" bundle="sdmMessages" />
												</DIV>
											</TD>
											<TD class="POPFORMFIELD" STYLE="padding-left:5px">
												<DIV STYLE="width:575px;height:145px;overflow:auto;">
													<TABLE id="headertable" cellpadding="2" cellspacing="0" BORDERCOLOR="white" border="1">
														<TR bgcolor="#b3bcdf">
															<c:forEach  items="${ fileImportForm.fieldMetaDetails }" var="fieldMetaDetail" varStatus="count" >
																<c:choose>
																	<c:when test="${count.index == 0}" >
																		<TD ID="DATA_HEADER_${ count.index }" STYLE="padding-left:3px; padding-right:3px; backgroundColor:#bfbfff">
																	</c:when>
																	<c:otherwise>
																		<TD ID="DATA_HEADER_${ count.index }" STYLE="padding-left:3px; padding-right:3px; backgroundColor:#b3bcdf">
																	</c:otherwise>
																</c:choose>							
																	<a href="#" onClick="changeColor('${count.index}');enableFieldMeta('${count.index}');" >
																	<c:out value='${fieldMetaDetail.fileFieldName}'/>
																	</a>
																</TD>
															</c:forEach>
														</TR>

														<c:forEach items="${ requestScope.fileData }" var="fileRow" varStatus="countRow" >
															<TR bgcolor="#DCDCDC">
																<c:forEach items="${ fileRow }" var="fileRowCell" varStatus="countCol" >
																	<c:choose>
																		<c:when test="${countCol.index == 0}" >
																			<TD ID="CELL_DATA_${countRow.index}_${countCol.index}" bgcolor="#C0C0C0"> 
																		</c:when>
																		<c:otherwise>
																			<TD ID="CELL_DATA_${countRow.index}_${countCol.index}" bgcolor="#DCDCDC">
																		</c:otherwise>
																	</c:choose>								
																		<c:out value='${fileRowCell}'/>
																	</TD>
																</c:forEach>
															</TR>
														</c:forEach>
													</TABLE>
												</DIV>
											</TD>
										</TR>
										<TR>
											<TD colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
										</TR>
									</TABLE>
									<INPUT TYPE="hidden" NAME="CURRENT_SELECT_COLUMN" id="CURRENT_SELECT_COLUMN" VALUE="1"/>
									<INPUT TYPE="hidden" NAME="NO_OF_ROWS" id="NO_OF_ROWS" VALUE="<c:out value='${requestScope.fileDataCount}'/>"/>
									<INPUT TYPE="hidden" NAME="NO_OF_FIELD_COLUMNS" id="NO_OF_FIELD_COLUMNS" VALUE="<c:out value='${requestScope.fieldMetaDetailCount}'/>"/>

								</c:if>
							</TD>
						</TR>

						<TR>
							<TD CLASS="POPFORMTITLE">
							</TD>
							<TD align="center" class="POPFORMFIELD" height='25'>&nbsp;									
							</TD>
						</TR>

						<TR>
							<TD colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
						</TR>

						<TR>
							<TD CLASS="POPFORMFIELD" colspan="2" height='30px'>
								<c:if test="${ requestScope.cubeDatasetType == 'dimension' }">  
									<div class="POPFORMBUTTONS"><input onclick="onClickClose()" type="button" value="<bean:message key="button.close" bundle="sdmMessages" />" name="close"></div>
								</c:if>
							</TD>
						</TR>
						
					</TABLE>
				</TD>
			</TR>
		</TABLE>
		<input type="hidden" name="operation" id="operation" value="save"/>
		<INPUT TYPE="hidden" NAME="preview" id="preview" VALUE="<c:out value='${param.preview}'/>"/>
		<input type="hidden" name="formChanged" id="formChanged" value="<c:out value='${param.formChanged}'/>"/>
		<html:hidden property="stepId" styleId="stepId" />
		<html:hidden property="fixedWidth" styleId="fixedWidth" />
		<input type="hidden" name="stepLink" id="stepLink" value="<c:out value='${currentStep.loadStepLink}'/>"/>
		<input type ="hidden" name="AuthCode" id="AuthCode" value="<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>"/>
		<input type ="hidden" name="ignoreColumnSizeCheck" value="<c:out value='${param.ignoreColumnSizeCheck}'/>"/>
		<c:choose>
			<c:when test="${not empty requestScope.dimId}" >
				<INPUT type="hidden" name="dimId" id="dimId" value="<c:out value='${requestScope.dimId}'/>"/>
			</c:when>
			<c:otherwise>
				<INPUT type="hidden" name="dimId" id="dimId" value="<c:out value='${param.dimId}'/>"/>
			</c:otherwise>
		</c:choose>

		</html:form>
	</TD>
</TR>
<TR >
	<TD>
		<P class="DIRECTIONS">
			<img src="/expensemap/jsp/images/happy_help_icon.gif" border="0" width="11" height="13">&nbsp;&nbsp;&nbsp;<bean:message key="ui.fact.import.data.file.help" bundle="sdmMessages" />
		</P>			    
	</TD>
</TR>