<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.emptoris.analytics.common.util.AnalyticUtility"%>
<%@page import="com.emptoris.viewer.ReportViewType"%>
<%@include file="../includes/tlib.jspf"%>
<%@ page import="java.util.Set,java.util.List,java.util.Locale,java.util.Iterator,com.zeborg.expensemap.analytic.TrendAnalyticCondition"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticRequestContext,com.emptoris.analytics.common.util.AnalyticActionsConstants"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession,com.zeborg.expensemap.view.ZSessionUtil,com.zeborg.util.WebUtil,com.zeborg.expensemap.view.HelpUtil,ilog.views.chart.data.IlvDefaultDataSource" %>
<%@ page import="com.zeborg.expensemap.util.AnalyticsQueryBuilder,com.zeborg.expensemap.analytic.AnalyticCondition"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.util.ExpenseMapAppProperties,com.zeborg.expensemap.dashboard.model.DashboardPanelPreferences"%>
<%@ page import="org.owasp.esapi.ESAPI"%>

<%
ZSession zs = ZSessionUtil.getFromSession(pageContext);
String dashboardPanelId = (String)request.getAttribute("dashboardPanelId");
AnalyticRequestContext context = (AnalyticRequestContext) session.getAttribute("reportContext"+dashboardPanelId);

pageContext.setAttribute("dashboardPanelId",dashboardPanelId);
pageContext.setAttribute("reportContext", context);
Locale locale =zs.getUser().getLocale();
EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE,locale );
String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.view.analytic.report.help.page", locale);

String newDisplayType = "";String altText = "";
if ( ReportViewType.TABLE.equals(context.getViewType())) {
	newDisplayType = ReportViewType.GRAPH.name();
	altText = "ui.label.toggle.chart";
} else {
	newDisplayType = ReportViewType.TABLE.name();
	altText = "ui.label.toggle.table";
}
%>

<html>
<head>
<style type="text/css">
.dashboardPanelContextMenu{	
 font-family: Arial, Helvetica, sans-serif;
 font-weight:normal;
 font-size: 13px; 
 color: #3A2278; 
 text-align: left;
 padding-right: 5px;
 padding-left: 5px; 
 }
 a, A:link, a:visited, a:active, A:hover	{color: #330099;}
 </style>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css">
<script  type="text/javascript"  src="/expensemap/jsp/javascript/yui/build/yahoo/yahoo-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container_core-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/menu/assets/skins/sam/menu.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/button/assets/skins/sam/button.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/dashboards/panelRenderer.css" />

<script language="javascript">

//Instantiate context menu
var oContextMenu = new YAHOO.widget.ContextMenu("mycontextmenu", { trigger: document} );
var spendLinkToolTip = "<bean:message key='tooltip.for.measure' bundle='emMessages' arg0="m_name" arg1="n_name" />";
//Creating menu items array
var aItems= [
	{ 
		text: "<bean:message key='ui.label.context' bundle='dashboard' />",    
		submenu: { id: "<bean:message key='ui.label.context' bundle='dashboard' />",
		itemdata: 
		 [
			[
				  <%if ( ReportViewType.GRAPH.equals(context.getViewType())) {%>
				  { text: "<bean:message key='button.tableView' bundle='dashboard' />", onclick: { fn: toggleDisplayType}},
				  { text: "<bean:message key='ui.label.fit.to.window' bundle='dashboard' />", onclick: { fn: submitForm}},
				  <%} else {%>
				  { text: "<bean:message key='button.chartView' bundle='dashboard' />", onclick: { fn: toggleDisplayType}},
				  <%}%>    		 		  
			 ],
			 [
				<% if (Boolean.TRUE.equals(request.getAttribute("ExportToPdfForNewDashboard"))) { %>
				  { text: "<bean:message key='ui.dashboard.menu.export.to.pdf.link' bundle='dashboard' />",onclick: { fn: exportToPDF }},
				<% } %>
				
				<% if (Boolean.TRUE.equals(request.getAttribute("exportPermission"))) { %>
				  { text: "<bean:message key='ui.dashboard.menu.export.to.excel.link' bundle='dashboard' />",onclick: { fn: openExportBox }},
				<% } %>
				
				<% if ( ReportViewType.GRAPH.equals(context.getViewType())) { %>
				  { text: "<bean:message key='ui.dashboard.menu.preferences' bundle='dashboard' />", onclick: { fn: getChartPreferencesWindow }}
				<% } %>
			  ]
		 ]
	  }
	},
    { 
   		text: "<bean:message key='ui.label.dashboard' bundle='dashboard' />",    
     	submenu: { id: "<bean:message key='ui.label.dashboard' bundle='dashboard' />",
    	itemdata: 
    		[
    			[
     				 { text: "<bean:message key='ui.dashboard.menu.show.context' bundle='dashboard' />", onclick: { fn: parent.openContextPanel } },
    			],
    			[
   					 { text: "<bean:message key='ui.dashboard.menu.snap.to.grid' bundle='dashboard' />", onclick: { fn: parent.snapToGrid } },
    				 { text: "<bean:message key='ui.dashboard.menu.hide.all.panels' bundle='dashboard' />", onclick: { fn: parent.hideAllPanels } }
   				],
   				[
      		    <% if(Boolean.TRUE.equals(request.getAttribute("CreateNewDashboard"))){
					if("true".equals(request.getParameter("owner"))){ %> 
   					 { text: "<bean:message key='ui.label.Edit' bundle='dashboard' />", onclick: { fn: editDashboard } },
	     	 	<%  
      		    	}
	      		   } %>
  				     { text: "<bean:message key='ui.label.Save' bundle='dashboard' />", onclick: { fn: saveDashboard } },
      		    <% if(Boolean.TRUE.equals(request.getAttribute("CreateNewDashboard"))){ %>
  				     { text: "<bean:message key='ui.dashboard.menu.saveas' bundle='dashboard' />", onclick: { fn: saveDashboardAs } },
     		    <% }
      		       if(Boolean.TRUE.equals(request.getAttribute("ExportToPdfForNewDashboard"))) { %> 
   					 { text: "<bean:message key='ui.dashboard.menu.export.to.pdf.link' bundle='dashboard' />", onclick: { fn: exportDashboardAsPDF } },
     		    <% } %>
   					 { text: "<bean:message key='ui.label.ShowAll' bundle='dashboard' />", onclick: { fn: showAllDashboards } }
   				 ]
  			 ]
  		  }
      }
   ];
//Add menu items and subscribe to the menu item on click event 
oContextMenu.addItems(aItems);
//refresh view
function resetAll(p_sType, p_aArgs, p_oValue){
	refresh(p_oValue[0]);
}

//when dom is ready do the following
YAHOO.util.Event.onDOMReady(function () {
    oContextMenu.render(document.body);
    //setting style to context menu items
    var contextMenuStyle='dashboardPanelContextMenu';
	oContextMenu.getItem(0).cfg.setProperty("classname",contextMenuStyle);
	oContextMenu.getItem(1).cfg.setProperty("classname",contextMenuStyle);
});

// shows list of all dashboards
function showAllDashboards(){
	parent.showAllDashboards();
}

//renders to the edit page
function editDashboard(){
	parent.editDashboard();
}

// Save a copy of the current dashboard.
function saveDashboardAs(){
	parent.openSaveAsBox ();
}

// Save current state of the dashboard.
function saveDashboard() {
	parent.saveDashboard();
}

/**
 * Use this function to invoke dashboard export dialog.
 */
function exportDashboardAsPDF() {
	parent.exportToPDF();
}

// Show export dialog
function openExportBox() {
	var dashboardPanelId = '<%=ESAPI.encoder().encodeForJavaScript(dashboardPanelId)%>';
    	var level = document.getElementById("Level").value ;
        var reportId = document.getElementById("reportId").value;
    	var dbId=document.getElementById("dashboardId").value;
	parent.openExportBox('Analytics', dbId, dashboardPanelId, reportId, level );
}

function exportToPDF(){
	var ht = 500;
	var wt = 750;
	var left = (screen.width/2)-(wt/2);
	var top = (screen.height/2)-(ht/2);
	var dashboardid = document.getElementById("dashboardId").value;
	var panelId = document.getElementById("dashboardPanelId").value;
	window.open("/expensemap/dashboards/getPDFExportDialog.do?exportType=dashboardPanel&dashboardId="+dashboardid+"&panelId="+panelId,"_blank","scrollbars=yes,resizable=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
}

function submitFormForSorting(columnId) {
    var order = document.getElementById("sortOrder").value;
	var frm = document.getElementById("reportRenderForm");
	frm.method="post";
	frm.action='/expensemap/analytic/renderAnalyticsAction.do?owner='+'<%=ESAPI.encoder().encodeForJavaScript(request.getParameter("owner"))%>'+'&pWidth='+YAHOO.util.Dom.getViewportWidth()+'&pHeight='+YAHOO.util.Dom.getViewportHeight();
	if(order=='ASC'){
		order='DESC';
	}else if(order=='DESC'){
		order='ASC';
	}
	document.getElementById("sortOrder").value=order;
	document.getElementById("sortColumn").value=columnId;
	frm.submit();

}
function paginate(action){
	var frm = document.getElementById("reportRenderForm");
	frm.method="post";
	frm.action='/expensemap/analytic/renderAnalyticsAction.do?theAction='+action + '&owner='+'<c:out value="${param.owner}"/>'+'&pWidth='+YAHOO.util.Dom.getViewportWidth()+'&pHeight='+YAHOO.util.Dom.getViewportHeight();
	frm.submit();
}
	
// A JS function to request data for a specific level.
function getDataForLevel(selectedLevel) {
	var frm = document.getElementById("reportRenderForm");
	document.getElementById("Level").value = selectedLevel.value;
	frm.method="post";
	frm.action='/expensemap/analytic/renderAnalyticsAction.do?owner='+'<c:out value="${param.owner}"/>'+'&pWidth='+YAHOO.util.Dom.getViewportWidth()+'&pHeight='+YAHOO.util.Dom.getViewportHeight();
	frm.submit();
}

function getChartPreferencesWindow(){
	var ht = 320;
	var wt = 650;
	var left = (screen.width/2)-(wt/2);
	var top = (screen.height/2)-(ht/2);
	var dbId=document.getElementById("dashboardId").value;
	var dbPanelId=document.getElementById("dashboardPanelId").value;
	window.open("/expensemap/dashboards/showAnalyticsChartPanelPreferences.do?dashboardId="+dbId+"&dashboardPanelId="+dbPanelId, "Chart_Preferences", "width="+wt+",height="+ht+",left="+left+",top="+top+",scrollbars=no,status=yes,resizable=no");
}

function submitForm(){
	var frm = document.getElementById("reportRenderForm");
	frm.method="post";
	frm.action='/expensemap/analytic/renderAnalyticsAction.do?theAction=getCurrent&owner='+'<c:out value="${param.owner}"/>'+'&pWidth='+YAHOO.util.Dom.getViewportWidth()+'&pHeight='+YAHOO.util.Dom.getViewportHeight();
	frm.submit();
}

function toggleDisplayType(){
	var newType = '<%=newDisplayType%>';
	var frm = document.getElementById("reportRenderForm");
	frm.method="post";
	frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction=getCurrent&displayType="+newType+"&pWidth="+YAHOO.util.Dom.getViewportWidth()+"&pHeight="+YAHOO.util.Dom.getViewportHeight();
	frm.submit();
}

function init(){
	var expandDetail = document.getElementById("expandDetail").value;	
	if(expandDetail=='true'){
		document.getElementById('detailImage').src="/expensemap/jsp/images/btn_arrow_up.gif";
		document.getElementById('detailImage').title="<bean:message key='ui.analytic.hide.detail.alt' bundle='analytic' />";
		document.getElementById('optionalDetail').style.display="block";

	}else{
		document.getElementById('detailImage').src="/expensemap/jsp/images/btn_arrow_down.gif";
		document.getElementById('detailImage').title="<bean:message key='ui.analytic.show.detail.alt' bundle='analytic' />";
		document.getElementById('optionalDetail').style.display="none";
	}
}

function showHide(){
	var expandDetail = document.getElementById("expandDetail").value;
	if(expandDetail=='true'){			
		document.getElementById('detailImage').src="/expensemap/jsp/images/btn_arrow_down.gif";
		document.getElementById('detailImage').title="<bean:message key='ui.analytic.show.detail.alt' bundle='analytic' />";
		document.getElementById('optionalDetail').style.display="none";
		document.getElementById("expandDetail").value=false;
	}else{			
		document.getElementById('detailImage').src="/expensemap/jsp/images/btn_arrow_up.gif";	
		document.getElementById('detailImage').title="<bean:message key='ui.analytic.hide.detail.alt' bundle='analytic' />";
		document.getElementById('optionalDetail').style.display="block";
		document.getElementById("expandDetail").value=true;
	}
}


//These void implementations are mandatory ,please do not remove these methods
function updateOnDrill(nodeId, dimensionName, bookMarkId ) {}
function reset(bookMarkId){}
function updateOnFilterRemoval(dimensionName, bookMarkId){}
</script>
</head>
<body class="yui-skin-sam" onload="init();">
<table style=" top:-14px;" WIDTH="100%">
<tr>
<td>
<logic:messagesPresent message="true">
	<br>
	<font color="red" face="Verdana" size="2">
		<html:messages id="msg" message="true" bundle="dashboard">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
	</font>
</logic:messagesPresent>
<logic:messagesNotPresent message="true">

<form name="reportRenderForm" id="reportRenderForm" action="/expensemap/analytic/renderAnalyticsAction.do">

<c:if test="${ empty reportVO.data && empty reportVO.chartData }">
<br>
	<font color="red" face="Verdana" size="2"> <b><bean:message key="error.com.emptoris.analytics.noDataFound" bundle="analytic" /></b></font>
</c:if> 

<br>

<table class="tableWithBorderAna" align="center">
	<tr><td align="left"><b><bean:message key="ui.trendnanalytics.Title" bundle="analytic" /></b></td>
	</td>
		<td align="right">
			<a href="#" onclick="showHide();">
				<IMG id="detailImage" name="detailImage" SRC="/expensemap/jsp/images/btn_arrow_down.gif"  BORDER="0"/>
			</a>
		</td>
	</tr>
</table>
<table  id="optionalDetail" name="optionalDetail" style="display:block"  class="InnerTableWithBorderAna" align="center">
	<tr>
		<td><b><bean:message key="ui.report.table.header.name"	bundle="analytic" /> : <c:out value="<%=context.getReportName()%>"/></b></td>		
	</tr>
	<tr>
		<td><b><bean:message key="ui.analyticsReport.criteria"	bundle="analytic" />:</b> 
			<%
				//PR-44080
				String conditionalFlag = "";
				List  reportList = context.getAnalyticConditions();
				Iterator iterator = reportList.iterator();
				TrendAnalyticCondition trendCondition = context.getTrendAnalyticCondition();
			%>
			<c:forEach items="${ reportContext.analyticConditions }" var="condition" varStatus="status">				
				<%	
					//pr-44080 if the language is japanese,then query is retrived from property file
					//by passing placehoders .
					if(zs.getUser().getLocale().getLanguage()=="ja"){
						AnalyticCondition vo = (AnalyticCondition)iterator.next();			
				%>				
							<tr> <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
								&nbsp;
								<c:if test="${ condition.cumulative == true }">
									<%conditionalFlag += "Cumulative";%>					
								</c:if>
								<c:if test="${ ! empty condition.level }">
									<%conditionalFlag += "Level";%>
								</c:if>
								<c:if test="${ ! empty condition.highLimit }">
									<%conditionalFlag += "HighLimit";%>
								</c:if>
								<c:if test="${ condition.percentTotalOption.name != 'NONE' }">
									<%conditionalFlag += "NotNone";%>		
								</c:if>
								<%=AnalyticsQueryBuilder.getQuery(vo,bundle,conditionalFlag)%>
								<%conditionalFlag= "";%>							
							</td></tr>			
					<%}else {%>
						<c:if test="${ status.count == 1 }">
							<bean:message key="ui.label.ShowAll" bundle="analytic" />&nbsp;${ condition.categoryDisplayName }
						&nbsp;<bean:message key="ui.ruleform.whose.label" bundle="analytic" />
						</c:if>
						<tr>
							<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							<c:if test="${ condition.cumulative == true }">
								<bean:message key="ui.ruleform.cumulative.label" bundle="analytic" />&nbsp;
							</c:if>
							<c:if test="${ ! empty condition.level && condition.level != -1}">
								<bean:message key="ui.label.level" bundle="analytic" />&nbsp;${ condition.level -1}&nbsp;
							</c:if>
							<c:if test="${ ! empty condition.level && condition.level == -1}">
								<bean:message key="ui.label.leaf.level.node" bundle="analytic" />&nbsp;
							</c:if>
							${ condition.attributeDisplayName }&nbsp; ${ condition.operatorDisplayName }&nbsp;${ condition.virtualLowLimit}&nbsp;
							<c:if test="${ ! empty condition.virtualHighLimit }">
										<bean:message key="ui.ruleform.label.and" bundle="analytic" />&nbsp;${ condition.virtualHighLimit }
							</c:if>
							<c:if test="${ condition.percentTotalOption.name != 'NONE' }">
								<bean:message key="${ condition.percentTotalOption.resourceKey }" bundle="analytic" />&nbsp;
							</c:if>
							</td>
						</tr>
					<%}%>
			</c:forEach>
		</td>
	</tr>
	<!-- displaying trend condition -->		
	<tr>
		<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<%if(trendCondition != null){ %>
			<bean:message key="ui.ruleform.for.label" bundle="analytic"/> <%=trendCondition.getTimeDimensionDisplayName()%>
			<% if(trendCondition.getTrendType().equalsIgnoreCase("discrete")){ %>
				<bean:message key="ui.operator.Between" bundle="analytic"/> <%=trendCondition.getStartPeriodHierarchyStr()%> &nbsp;<bean:message key="ui.ruleform.label.and" bundle="analytic"/>&nbsp; <%=trendCondition.getEndPeriodHierarchyStr()%>
			<% }else if(trendCondition.getTrendType().equalsIgnoreCase("continuous")){ %>
				
			<% 		if(trendCondition.getTimeDimension().equalsIgnoreCase("dimtime")){%>
						<bean:message key="ui.ruleform.for.label" bundle="analytic"/> &nbsp; <bean:message key="<%=AnalyticUtility.getAllTimePeriodDisplayName(trendCondition.getTimePointLevel())%>" bundle="analytic" />
				<% 	}else { 
					Integer level = new Integer(trendCondition.getTimePointLevel());
				%>	
					<bean:message key="ui.ruleform.all.label" bundle="analytic"/>&nbsp; <bean:message key="ui.label.level" bundle="analytic"/>&nbsp;<%=level.intValue()-1%>
				<%	}
				}	//if dim = DIMTIME
			}// end if null%>
		</td>
	</tr>
	<!-- end //display trend condition -->
	<tr>
		<td align="left"><b> <bean:message
			key="display.filters.AdditionalFilters" bundle="analytic" />: </b> <c:if
			test="${ empty reportContext.sessionFilters && empty reportContext.contextFilters }">
			<b><bean:message key="ui.label.None" bundle="analytic" /></b>
		</c:if> <c:if test="${ ! empty reportContext.sessionFilters }">
			<a title="${ reportContext.formattedSessionFilters }"><b><bean:message
				key="display.filters.SessionFilters" bundle="analytic" /></b></a>&nbsp;<img
				src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;	
			</c:if> <c:if test="${ ! empty reportContext.contextFilters }">
			<a title="${ reportContext.formattedContextFilters }"><b><bean:message
				key="display.filters.ContextFilters" bundle="analytic" /></b></a>&nbsp;<img
				src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;	
			</c:if></td>
		<td align="right"><b><bean:message key="ui.label.level" bundle="analytic" /></b>&nbsp;
		<select onchange="getDataForLevel(this.options[selectedIndex]);">
			<!-- show all level option only for table. -->
			<%if ( ReportViewType.TABLE.equals(context.getViewType())) {%>
			<option value="-1"><bean:message key="ui.options.all.levels" bundle="analytic" /></option>
			<%} %>
			<c:forEach begin="1" end="${ reportContext.baseDimensionLevels }"
				var="level">
				<c:choose>
					<c:when test="${ level == reportContext.level }">
						<option value="${ level }" selected>${ level -1 }</option>
					</c:when>
					<c:otherwise>
						<option value="${ level }">${ level -1}</option>
					</c:otherwise>
				</c:choose>
			</c:forEach>
		</select></td>
	</tr>
</table>
<br>
<% if ( ReportViewType.TABLE.equals(context.getViewType())) { %>

<table class="tableWithBorderAna" align="center">
	<tr>
		<c:forEach items="${ reportContext.columnLabels }" var="column"
			varStatus="columnCount" begin="1">
			<td NOWRAP class="thead" align="center"><a href="#"
				onclick="submitFormForSorting('${ columnCount.count + 1 }')"> ${column.displayName } <c:if test="${ (columnCount.count + 1) == reportContext.sortColumn }">
				<c:choose>
					<c:when test="${ 'ASC' == reportContext.sortOrder }">
						<img src="/expensemap/jsp/images/up.gif" border="0">
					</c:when>
					<c:otherwise>
						<img src="/expensemap/jsp/images/down.gif" border="0">					
					</c:otherwise>
				</c:choose></c:if></a></td>
		</c:forEach>
	</tr>
	<c:forEach items="${ reportVO.data }" var="row" varStatus="rowNum">	
		<c:choose>
			<c:when test="${ rowNum.count % 2 == 0 }">
				<tr class="trEven">
			</c:when>
			<c:otherwise>
				<tr class="trOdd">
			</c:otherwise>
		</c:choose>
		<c:forEach items="${ row }" var="column" varStatus="colNum" begin="1">
			<c:choose>
				<c:when test="${ colNum.count == 1 }">
					<td align="center">${ column -1}</td>
				</c:when>
				<c:otherwise>
					<td align="${ reportContext.columnLabels[colNum.index].type.alignment }">${column }</td>
				</c:otherwise>
			</c:choose>
		</c:forEach>
	</c:forEach>
</table>
<% } else { 
	DashboardPanelPreferences pref = (DashboardPanelPreferences)request.getAttribute("chartPreferences"+dashboardPanelId);
	IlvDefaultDataSource dataSource = (IlvDefaultDataSource)request.getAttribute("dataSource"+dashboardPanelId);
	String pWidth=request.getParameter("pWidth");
	if(pWidth==null){
		pWidth="300";
	}

	String pHeight=request.getParameter("pHeight");
	if(pHeight==null){
		pHeight="300";
	}
	int height = 0;
	int width = 0;
	int wMargin = 20;
	int hMargin = 55;
	width = Integer.parseInt(pWidth)-wMargin;
	height = Integer.parseInt(pHeight)-hMargin;
	StringBuffer imageSrc = new StringBuffer("/expensemap/jsp/analytics/trend/imageGen.jsp?request=image&width=");
	imageSrc.append(width).append("&height=").append(height).append("&dashboardPanelId=").append(dashboardPanelId);
	session.setAttribute("dataSource"+dashboardPanelId, dataSource);
	session.setAttribute("chartPreferences"+dashboardPanelId,pref);
%>
<br>
<c:if test="${ ! empty reportVO.chartData }">
<center>
<div id="ImageDiv">  
	<jsp:include page="/analyticsTrendChartServlet" flush="true">  
  		<jsp:param name="request" value="imagemap"/>
  		<jsp:param name="image" value="<%=imageSrc%>"/>
  		<jsp:param name="width" value="<%=width%>"/>
  		<jsp:param name="height" value="<%=height%>"/>
  		<jsp:param name="dashboardPanelId" value="<%=dashboardPanelId%>"/>
  	</jsp:include>																		
</div>  
<center>
</c:if>	
<% } %>
<br>

<% if ( ReportViewType.TABLE.equals(context.getViewType())) { %>
<c:if test="${ ! empty reportVO.data }">
	<table width="98%" align="center">
		<tr align="center">
			<td colspan="3"><jsp:include flush="true" page="../analytics/pagination.jsp">
				<jsp:param name="isDataPresent" value="${ ! empty reportVO.data }" />
				<jsp:param name="pageSize" value="<%=context.getPageSize()%>" />
				<jsp:param name="totalRec" value="<%=context.getTotalRec()%>" />
				<jsp:param name="startRec" value="<%=context.getStartRec()%>" />
				<jsp:param name="limitRec" value="<%=context.getLimitRec()%>" />
				<jsp:param name="maxRecordPerPage"	value="<%=context.getPageSize()%>" />
			</jsp:include></td>
		</tr>
	</table>	
</c:if> 
<%} else { %>
<c:if test="${ ! empty reportVO.chartData }">
	<table width="98%" align="center">
		<tr align="center">
			<td colspan="3"><jsp:include flush="true" page="../analytics/pagination.jsp">
				<jsp:param name="isDataPresent" value="${ ! empty reportVO.chartData }" />
				<jsp:param name="pageSize" value="<%=context.getPageSize()%>" />
				<jsp:param name="totalRec" value="<%=context.getTotalRec()%>" />
				<jsp:param name="startRec" value="<%=context.getStartRec()%>" />
				<jsp:param name="limitRec" value="<%=context.getLimitRec()%>" />
				<jsp:param name="maxRecordPerPage"	value="<%=context.getPageSize()%>" />
			</jsp:include></td>
		</tr>
	</table>	
</c:if> 
<%}%> 
<br>

<input type="hidden" name="sortOrder" 	   id="sortOrder" 		value="<c:out value='${ reportContext.sortOrder }'/>" /> 
<input type="hidden" name="sortColumn" 	   id="sortColumn" 		value="<c:out value='${ reportContext.sortColumn }'/>" />
<input type="hidden" name="reportId" 	   id="reportId" 		value="<c:out value='${ reportContext.reportId }'/>" /> 
<input type="hidden" name="eriId" 	       id="eriId"  			value="<c:out value='${ reportContext.eriId }'/>" /> 
<input type="hidden" name="reportType" 	   id="reportType"      value="<c:out value='${ reportContext.reportType }'/>" />
<input type="hidden" name="Level"          id="Level"           value="<c:out value='${ reportContext.level }'/>" /> 
<input type="hidden" name="dimensionName"  id="dimensionName"	value="<c:out value='${ reportContext.baseDimension }'/>" />
<input type="hidden" name="dashboardId"  id="dashboardId"	    value="<c:out value='${param.dashboardId}'/>" />
<input type="hidden" name="dashboardPanelId"  id="dashboardPanelId"  value="<c:out value='${param.dashboardPanelId}'/>" />
<input type="hidden" name="viewType" 		 id="viewType"  	    value="<c:out value='${ reportContext.viewType }'/>" />
<input type="hidden" id="expandDetail" name="expandDetail" value="<c:out value='${reportContext.expandDetail }'/>"/>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form>
</logic:messagesNotPresent>
</td>
</tr>
</table>
</body>
</html>