<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@page import="com.emptoris.viewer.core.ViewerTreeNode" %>
<%@page import="com.emptoris.viewer.dashboards.DimensionViewFormatter" %>
<% response.setHeader("Pragma", "no-cache");%>
<% response.setHeader("Cache-Control", "no-cache");%>
<% response.setDateHeader("Expires", -1); %>
<%@ include file="dashboardPanelMenu.jspf" %>

<%@page import="com.zeborg.expensemap.view2.ZSession" %>
<%@page import="java.util.List" %>
<%@page import="com.emptoris.viewer.core.PropertyHeading" %>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle" %>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@ page import="org.owasp.esapi.ESAPI"%>
<html>
<head>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo/yahoo-min.js"></script>
<!-- Dependencies -->
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container_core-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/stringbuffer.js"></script>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>

<!-- Source File -->
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>

<!-- Core + Skin CSS -->
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/menu/assets/skins/sam/menu.css">
<link rel="stylesheet" type="text/css"
      href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css"/>
<link rel="stylesheet" type="text/css"
      href="/expensemap/jsp/css/yui-tooltip-override.css"/>
      
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/button/assets/skins/sam/button.css"/>


<!-- panel renderer css -->
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/dashboards/panelRenderer.css"/>
<style type="text/css">
    .dashboardPanelContextMenu {
        font-family: Arial, Helvetica, sans-serif;
        font-weight: normal;
        font-size: 13px;
        color: #3A2278;
        text-align: left;
        padding-right: 5px;
        padding-left: 5px;

    }
</style>

<script type="text/javascript">


//Instantiate context menu
var oContextMenu = new YAHOO.widget.ContextMenu("mycontextmenu", { trigger: document});
var spendLinkToolTip = "<bean:message key='tooltip.for.measure' bundle='emMessages' arg0="m_name" arg1="n_name" />";
//Creating menu items array
var aItems = [
    {
        text: "<bean:message key='ui.label.context' bundle='dashboard' />",
        submenu: { id: "<bean:message key='ui.label.context' bundle='dashboard' />",
            itemdata:
                    [
                        [
                            { text: "<bean:message key='button.chartView' bundle='dashboard' />", onclick: { fn: renderView , obj: ["GRAPH"]} }
                        ],
                        [
                            { text: "<bean:message key='ui.remove.filter' bundle='dashboard' />", onclick: { fn: removeFilter } },
                            { text: "<bean:message key='ui.dashboard.menu.zoom.out' bundle='dashboard' />", onclick: { fn: levelUp } },
                            { text: "<bean:message key='ui.dashboard.menu.static.window' bundle='dashboard' />", onclick: { fn: setStaticval } }
                        ],
                        [
                          <% if (request.getAttribute("exportPermission") != null && Boolean.TRUE.equals(request.getAttribute("exportPermission"))){ %>
                            {
                                text: "<bean:message key='ui.dashboard.menu.export' bundle='dashboard'/>",
                                submenu: { id: "<bean:message key='ui.dashboard.menu.export' bundle='dashboard'/>",
                                    itemdata:
                                    [
                                        { text: "<bean:message key='ui.dashboard.menu.export.panel' bundle='dashboard' />", onclick: { fn: openPanelExportBox } },
                                        { text: "<bean:message key='ui.dashboard.menu.export.alllabel' bundle='dashboard' />" , onclick: { fn: openAllExportBox } }
                                    ]
                                }
                            },
                          <% }
                           if(Boolean.TRUE.equals(request.getAttribute("ExportToPdfForNewDashboard"))) { %>
                               { text: "<bean:message key='ui.dashboard.menu.export.to.pdf.link' bundle='dashboard' />",onclick: { fn: exportToPDF }},
                           <% } %>
                           { text: "<bean:message key='ui.dashboard.menu.preferences' bundle='dashboard' />", onclick: { fn: openPrefsWindow }}
                        ]
                    ]
        }
    },

    {
        text: "<bean:message key='ui.label.dashboard' bundle='dashboard' />",
        submenu: { id: "<bean:message key='ui.label.dashboard' bundle='dashboard' />",
            itemdata:
                    [
                        [
                            { text: "<bean:message key='ui.dashboard.menu.show.context' bundle='dashboard' />", onclick: { fn: parent.openContextPanel } },
                        ],
                        [
                            { text: "<bean:message key='ui.dashboard.menu.snap.to.grid' bundle='dashboard' />", onclick: { fn: parent.snapToGrid } },
                            { text: "<bean:message key='ui.dashboard.menu.allreset' bundle='dashboard' />", onclick: { fn: resetAll , obj: ["TABLE"]} },
                            { text: "<bean:message key='ui.dashboard.menu.hide.all.panels' bundle='dashboard' />", onclick: { fn: parent.hideAllPanels } }
                        ],
                        [
                            <% if(Boolean.TRUE.equals(request.getAttribute("CreateNewDashboard"))){
                              if("true".equals(request.getParameter("owner"))){%>
                            { text: "<bean:message key='ui.label.Edit' bundle='dashboard' />", onclick: { fn: editDashboard } },
                            <%  }
                             } %>
                            { text: "<bean:message key='ui.label.Save' bundle='dashboard' />", onclick: { fn: saveDashboard } },
                            <% if(Boolean.TRUE.equals(request.getAttribute("CreateNewDashboard"))){ %>
                            { text: "<bean:message key='ui.dashboard.menu.saveas' bundle='dashboard' />", onclick: { fn: saveDashboardAs } },
                            <% }
                                if(Boolean.TRUE.equals(request.getAttribute("ExportToPdfForNewDashboard"))){%>
                            { text: "<bean:message key='ui.dashboard.menu.export.to.pdf.link' bundle='dashboard' />", onclick: { fn: exportDashboardAsPDF } },
                            <% } %>
                            { text: "<bean:message key='ui.label.ShowAll' bundle='dashboard' />", onclick: { fn: showAllDashboards } }
                        ]
                    ]
        }
    }
];
//Add menu items and subscribe to the menu item on click event
oContextMenu.addItems(aItems);

//getting submenu items for context menu Panel
var panelSubMenuItems = oContextMenu.getItem(0).cfg.getProperty("submenu");
var arrGroup = panelSubMenuItems.getItemGroups();
//getting static submenu item
var nonInteractiveSubMenuItem = arrGroup[1][2];


//refresh view
function resetAll(p_sType, p_aArgs, p_oValue) {
    refresh(p_oValue[0]);
}

//refresh view
function refresh(viewType) {
    if (nonInteractiveSubMenuItem.cfg.getProperty("checked")) {
        alert("<bean:message key='ui.static.window' bundle='dashboard' />");
        return;
    }
    var bookMarkId = document.getElementById("bookMarkId").value;
    parent.resetAll(bookMarkId);
}

//function for submitting form on onclick event on menu item
function renderView(p_sType, p_aArgs, p_oValue) {
    changeView(p_oValue[0]);
}

//display under constuction
function alertUnderConstruction() {
    alert('Under Construction');
}

// Show export dialog for panel
function openPanelExportBox() {
	var dashboardPanelId = document.getElementById("dashboardPanelId").value;
	var dbId=document.getElementById("dashboardId").value;
	var dimensionName = document.getElementById("dimensionName").value;
	var beginIndex = document.getElementById("beginIndex").value;
	parent.openExportBox('DimensionPanel', dbId, dashboardPanelId, dimensionName, null, beginIndex );
}

// Show export dialog for All option
function openAllExportBox() {
	var dashboardPanelId = document.getElementById("dashboardPanelId").value;
	var dbId=document.getElementById("dashboardId").value;
	var dimensionName = document.getElementById("dimensionName").value;
	var beginIndex = document.getElementById("beginIndex").value;
	parent.openExportBox('DimensionAll', dbId, dashboardPanelId, dimensionName, null, beginIndex );
}

// Save a copy of the current dashboard.
function saveDashboardAs() {
    parent.openSaveAsBox();
}

// Save current state of the dashboard.
function saveDashboard() {
    parent.saveDashboard();
}
/**
 * Event handler function to handle user click on expand-collapse link.
 */
function expandCollapse(linkElement, dimId, nodeId) {
    if (linkElement.getAttribute("refExpanded") == "true") {
        collapseNode(linkElement, dimId, nodeId);
        alternate('breadCrumbTable');
    } else {
        expandNode(linkElement, dimId, nodeId);
    }
}

// collapses the specified node.
function collapseNode(linkElement, dimId, nodeId) {
    removeChildrenNodes(dimId, nodeId);
    var tooltip = "<bean:message key='ui.label.Expand' bundle='emMessages' />";
    linkElement.innerHTML = '<IMG SRC="/expensemap/jsp/images/expand_small.gif" ALIGN="bottom" WIDTH="9" HEIGHT="9" BORDER="0" title="' + tooltip + '">';
    linkElement.setAttribute("refExpanded", "false");

    try {
        var url = "/expensemap/dashboards/GetDimensionNode.do";
        var bookmarkId = document.getElementById("bookMarkId").value;
        var dashboardId = document.getElementById("dashboardId").value;
        var panelId = document.getElementById("dashboardPanelId").value;
        var filterStr = parent.getFilters(panelId);

        var params = {};
        params['action'] = 'collapseNode';
        params['dimension'] = dimId;
        params['nodeId'] = nodeId;
        params['drillDim'] = filterStr;
        params['bkId'] = bookmarkId;
        params['dashboardId'] = dashboardId;
        params['dashboardPanelId'] = panelId;
		jQuery.ajax({
			url: url,
			type: "GET",
			data: params
		});
    } catch(e) {
        alert(e);
    }
}

/**
 * Removes all children for the specified node from the UI table.
 */
function removeChildrenNodes(dimId, nodeId) {
    var rowNode = document.getElementById(dimId + "" + nodeId);
    var level = parseInt(rowNode.getAttribute("refNodeLevel")) + 1; // For children, level is this plus 1
    var rowParent = rowNode.parentNode;
    var nextSiblingNode = rowNode.nextSibling;
    // Remove everything below this level
    while (nextSiblingNode != null && parseInt(nextSiblingNode.getAttribute("refNodeLevel")) >= level) {
        var n = nextSiblingNode.nextSibling;
        rowParent.removeChild(nextSiblingNode);
        nextSiblingNode = n;
    }
}

// collapses the specified node.
function expandNode(linkElement, dimId, nodeId) {
    try {
        var url = "/expensemap/dashboards/GetDimensionNode.do";
        var bookmarkId = document.getElementById("bookMarkId").value;
        var dashboardId = document.getElementById("dashboardId").value;
        var panelId = document.getElementById("dashboardPanelId").value;
        var filterStr = parent.getFilters(panelId);

        var params = {};
        params['action'] = 'expandNode';
        params['dimension'] = dimId;
        params['nodeId'] = nodeId;
        params['drillDim'] = filterStr;
        params['bkId'] = bookmarkId;
        params['dashboardId'] = dashboardId;
        params['dashboardPanelId'] = panelId;
		jQuery.ajax({
			url: url,
			type: "GET",
			data: params,
			success: renderExpandedNode
		});

    } catch(e) {
        alert(e);
    }
}

function checkIfSessionActive(data) {
    if (data[0] == "Error") {
        var errorCode = data[1];
        if (errorCode == "session.timeout") {
            var timeoutURL = data[3];
            //for intg environment the location should be expensemap frame
            parent.location.href = timeoutURL;
            return false;
        }
    }
    return true;
}

function renderExpandedNode(response) {
    // try to parse the response into a JS array. We may get outofmemory error when the
    // array contains more than 65535 elements. In that case, we trap the error and show
    // an error message.
    var data = null;
    try {
        data = eval(response);
    } catch (e) {
        alert(e);
        return;
    }
    // check if session is still active.
    if (checkIfSessionActive(data) == false) {
        return;
    }
    var dimId = data[1];
    var treeNodeId = data[2];
    var rowSnapShot = data[3];
    removeChildrenNodes(dimId, treeNodeId);
    // Read heading properties metadata
    // [[prop1_name,prop1_linkType,prop1_isSortable],[prop2_name,prop2_linkType,prop2_isSortable],....]
    var properties = data[8];
    columnHeadingLinkTypes = new Array();//store link type for columns
    columnSortableInformation = new Array(); //is column sortable?
    columnDisplayName = new Array(); // column display name
    var propLen = properties.length;
    for (p = 0; p < propLen; p++) {
        var propHeadings = properties[p];
        columnHeadingLinkTypes[p] = propHeadings[1]; //link type
        columnSortableInformation[p] = propHeadings[2]; // sortable
        columnDisplayName[p] = propHeadings[0]; // display name
    }
    expandNodeCommon(dimId, treeNodeId, data, rowSnapShot);
    var tooltip = "<bean:message key='ui.label.Collapse' bundle='emMessages' />";
    var linkElement = document.getElementById(dimId + treeNodeId + 'LinkElement');
    linkElement.innerHTML = '<IMG SRC="/expensemap/jsp/images/collapse_small.gif" ALIGN="bottom" WIDTH="9" HEIGHT="9" BORDER="0" title="' + tooltip + '">';
    linkElement.setAttribute("refExpanded", "true");
    alternate('breadCrumbTable');
}

function expandNodeCommon(dimId, treeNodeId, data, rowSnapShot) {
    // TODO processPaging(data);
    var rowDocFragment = document.createDocumentFragment();
    var rowNode = document.getElementById(dimId + "" + treeNodeId);
    var bgColor = rowNode.style.backgroundColor;

    var level = parseInt(rowNode.getAttribute("refNodeLevel")) + 1; // For children, level is this plus 1
    var rowParent = rowNode.parentNode;
    // Skip the request id info and the current node info, get right to the kids
    var t = 12 + 1 + 1 + 1 + 3; // Normal 12 for moving past expanded treenode info and 1 for extra dimId/nodeId info
    var nextTraversal = null;
    var parentsIdStack = new Array();

    while (t < data.length) { // t + 1 for -1 at end of array
        // If this is the first treenode in the dimension
        if (nextTraversal == null) {
            parentsIdStack.push(treeNodeId);
        }
        if (nextTraversal == null) {
            if (data[t + 2] == -1) {
                parentsIdStack.push(data[t + 1])
            }
            t = createDynamicTreeNodes(data, t, rowDocFragment, level, dimId, rowSnapShot, treeNodeId);
        } else {
            // Next node is child
            if (nextTraversal == 1) {
                level++;
                parentsId = parentsIdStack[parentsIdStack.length - 1];
                if (data[t + 6] == -1) {
                    parentsIdStack.push(data[t + 5])
                }
                t = createDynamicTreeNodes(data, t + 1 + 3, rowDocFragment, level, dimId, rowSnapShot, parentsId);
            } // Next node is peer
            else if (nextTraversal == 0) { // Jump 1 to actual treenode info
                parentsId = parentsIdStack[parentsIdStack.length - 1];
                if (data[t + 3] == -1) {
                    parentsIdStack.push(data[t + 2])
                }
                t = createDynamicTreeNodes(data, t + 1, rowDocFragment, level, dimId, rowSnapShot, parentsId);
            } // Traverse up the tree one level
            else if (nextTraversal == -1) {
                parentsIdStack.pop();
                level--;
                // In this case, scan for further traversal info, add 1 for next element of info, subtract 1 from level
                // Short circuit evaluation, scan for any more -1s
                while (t + 1 < data.length && data[t + 1] == -1) {
                    level--;
                    parentsIdStack.pop()
                    t++;
                }
                // Now we're at the last -1 in this sequence of -1s, take it from here, and let the loop continue
                // Advance 1 more, since -1 tells us nothing, we need the next info
                t++;
            }
        }
        nextTraversal = data[t];
    }
    rowParent.insertBefore(rowDocFragment, rowNode.nextSibling);
}

/**
 * Creates a dynamic row in the table for a node.
 */
function createDynamicTreeNodes(data, i, rowDocFragment, level, dimId, rowSnapShot, parentNodeId) {
    // Render name, props
    var treeName = data[i];
    var treeId = data[i + 1];
    var treeChildrenStatus = data[i + 2];
    var nodeType = data[i + 3];
    var checked = false;
    //to avoid adding this in multikeep
    if (parentNodeId == -1) {
        parentNodeId = -2;
    }

    var propValues = data[i + 4];
    var propLen = propValues.length;
    /*propValues[]'s last element will be checked node id*/
    var checkedNodeId = propValues[propLen - 1];
    if (checkedNodeId != '') {
        checked = true;
    }

    var tr = document.createElement('TR');
    tr.setAttribute("id", dimId + "" + treeId);
    tr.setAttribute("refNodeLevel", level);
    // Checkboxes for multiple keep
    var td = document.createElement('TD');
    td.className = "checkStyle";
    td.setAttribute("valign", "middle");
    td.setAttribute("nowarp", "true");
    var htmlStrBuf = new StringBuffer();


    /*propValues[]'s last element will be checked node id*/

    for (var p = 0; p < propLen - 1; p++) {
        //SORTABLE COLUMN = 1
        var sortable = columnSortableInformation[p];
        //URL_LINK_NONE = 0;
        //URL_LINK_TRANSACTION = 1;
        //URL_LINK_DRILLDOWN = 2;
        //URL_LINK_TOTALSPEND_DRILLDOWN=3
        //URL_LINK_TOTAL_TRANSACTION=4;
        var linkType = columnHeadingLinkTypes[p];
        var propertyDisplayName = columnDisplayName[p];
        var tdp = document.createElement('TD');
        tdp.className = (linkType == 0) ? "columnDataStyle" : "cellStyle";


        htmlStrBuf = new StringBuffer();
        // Identify as child at given level
        if (p == 0) {
            for (var s = 0; s < level; s++) {
                htmlStrBuf.append("&nbsp;&nbsp;&nbsp;&nbsp;");
            }
            if (treeId != 0) {
                htmlStrBuf.append("&nbsp;&nbsp;&nbsp;&nbsp");
            }
            if (treeChildrenStatus == 1) {
                renderExpandLink(false, htmlStrBuf, dimId, treeId);
            } else if (treeChildrenStatus == -1) {
                renderExpandLink(true, htmlStrBuf, dimId, treeId);
            } else {
                if (level > 1 && nodeType != 4 && nodeType != 5) {
                    htmlStrBuf.append("&nbsp;----");
                } else if (nodeType == 4 || nodeType == 5) {
                    htmlStrBuf.append("&nbsp;");
                }
                htmlStrBuf.append('<IMG SRC="/expensemap/jsp/images/place_holder.gif" ALIGN="bottom" WIDTH="9" HEIGHT="9" BORDER="0">');
                if (level == 1 && nodeType != 4 && nodeType != 5) {
                    htmlStrBuf.append("&nbsp;");
                }
            }
            if (treeId != 0) {
                htmlStrBuf.append("&nbsp;");
            }
        }

        if ((linkType == 2) && ((nodeType == 1) || (nodeType == 2))) {
            // Standard single node filter link
            htmlStrBuf.append('<A HREF="#"');
            htmlStrBuf.append(' onclick="reRender(\'' + treeId);
            htmlStrBuf.append('\'');
            htmlStrBuf.append(');" ');
            htmlStrBuf.append('title="' + getMeasureTooltip(propertyDisplayName, treeName));
            htmlStrBuf.append('">&nbsp;');
            htmlStrBuf.append(propValues[p]);
            htmlStrBuf.append('</A>');
        } else {
            htmlStrBuf.append('<span title="')
            htmlStrBuf.append(propValues[p]);
            htmlStrBuf.append('" >');
            appendShortenText(htmlStrBuf, propValues[p], dimId);
            htmlStrBuf.append('&nbsp;&nbsp;');
            if (parentNodeId > 0 && nodeType == 5 && p == 0) {
                var pageInfo = treeName.split(":");
                renderPagingForNode(pageInfo, htmlStrBuf, dimId, parentNodeId);
            }
        }
        tdp.innerHTML = htmlStrBuf.toString();
        tr.appendChild(tdp);
    }
    rowDocFragment.appendChild(tr);
    return i + 5; // Add 5 here to get to next traversal info and return that index
}

function getMeasureTooltip(measureName, nodeName) {
    return spendLinkToolTip.replace(/m_name/gi, measureName).replace(/n_name/gi, nodeName);
}
/**
 * Renders expand-collapse link based on node state (whether it is expanded or not).
 */
function renderExpandLink(expanded, htmlStrBuf, dimId, nodeId) {
    //if node is zero ie top level node, do not allow to collapse it. disable the hyper link
    if (nodeId != '0') {
        htmlStrBuf.append('<A refExpanded = "');
        htmlStrBuf.append(expanded);
        htmlStrBuf.append('" HREF = "javascript:void(0)" ID = "');
        htmlStrBuf.append(dimId);
        htmlStrBuf.append(nodeId);
        htmlStrBuf.append('LinkElement');
        htmlStrBuf.append('" onClick = "expandCollapse(this, \'');
        htmlStrBuf.append(dimId);
        htmlStrBuf.append('\',\'');
        htmlStrBuf.append(nodeId);
        htmlStrBuf.append('\')" >');
    }
    if (expanded) {
        var tooltip = "<bean:message key='ui.label.Collapse' bundle='emMessages' />";
        htmlStrBuf.append('<IMG SRC="/expensemap/jsp/images/collapse_small.gif" ALIGN="bottom" WIDTH="9" HEIGHT="9" BORDER="0" title="' + tooltip + '">');
    } else {
        var tooltip = "<bean:message key='ui.label.Expand' bundle='emMessages' />";
        htmlStrBuf.append('<IMG SRC="/expensemap/jsp/images/expand_small.gif" ALIGN="bottom" WIDTH="9" HEIGHT="9" BORDER="0" title="' + tooltip + '">');
    }
    if (nodeId != '0') {
        htmlStrBuf.append("</A>");
    }
    htmlStrBuf.append("&nbsp;");
}

/**
 * Renders paging icons against virtutal node representing sum-of-visible nodes.
 */
function renderPagingForNode(pageInfo, htmlStrBuf, dimId, nodeId) {
    var beginIndex = parseInt(pageInfo[0]);
    var pageSize = parseInt(pageInfo[1]);
    var nodeTotal = parseInt(pageInfo[2]);
    var toolTip = '';
    if (beginIndex == 1) {
        tooltip = "<bean:message key='tooltip.you.are.at.top' bundle='emMessages' />";
        // we're on the first page, so disable the first/prev page.
        htmlStrBuf.append('<img style="border: 0" title="');
        htmlStrBuf.append(toolTip);
        htmlStrBuf.append('" src="/expensemap/jsp/images/first_page_list_ovr.gif"  >&nbsp;');
        htmlStrBuf.append('<img style="border: 0" title="');
        htmlStrBuf.append(toolTip);
        htmlStrBuf.append('" src="/expensemap/jsp/images/previous_page_list_ovr.gif" >&nbsp;');
    } else {
        toolTip = "<bean:message key='tooltip.go.top' bundle='emMessages' />";
        htmlStrBuf.append('<a href="javascript:void(0)" onClick="scrollWithinNode(\'');
        htmlStrBuf.append(dimId);
        htmlStrBuf.append('\',');
        htmlStrBuf.append(nodeId);
        htmlStrBuf.append(',1);" ><img style="border: 0" title="');
        htmlStrBuf.append(toolTip);
        htmlStrBuf.append('" src="/expensemap/jsp/images/first_page_list_up.gif"></a>&nbsp;');
        htmlStrBuf.append('<a href="javascript:void(0)" onClick="scrollWithinNode(\'');
        htmlStrBuf.append(dimId);
        htmlStrBuf.append('\',');
        htmlStrBuf.append(nodeId);
        // calculate beginIndex for the prev page
        var prevPageIndex = beginIndex - pageSize;
        htmlStrBuf.append(',');
        htmlStrBuf.append(prevPageIndex);
        toolTip = "<bean:message key='tooltip.go.previous' bundle='emMessages' />";
        htmlStrBuf.append(');" ><img style="border: 0" title="');
        htmlStrBuf.append(toolTip);
        htmlStrBuf.append('" src="/expensemap/jsp/images/previous_page_list_up.gif"></a>&nbsp;');
    }

    if ((beginIndex + pageSize) > nodeTotal) {
        // we're on the last page, so disable the next/last page.
        toolTip = "<bean:message key='tooltip.you.are.at.bottom' bundle='emMessages' />";
        htmlStrBuf.append('<img style="border: 0" title="' + toolTip + '" src="/expensemap/jsp/images/next_page_list_ovr.gif">&nbsp;');
        htmlStrBuf.append('<img style="border: 0" title="' + toolTip + '" src="/expensemap/jsp/images/last_page_list_ovr.gif">&nbsp;');
    } else {
        htmlStrBuf.append('<a href="javascript:void(0)" onClick="scrollWithinNode(\'');
        htmlStrBuf.append(dimId);
        htmlStrBuf.append('\',');
        htmlStrBuf.append(nodeId);
        // calculate beginIndex for the next page
        var nextPageIndex = beginIndex + pageSize;
        htmlStrBuf.append(',');
        htmlStrBuf.append(nextPageIndex);
        toolTip = "<bean:message key='tooltip.go.next' bundle='emMessages' />";
        htmlStrBuf.append(');" ><img style="border: 0" title="' + toolTip + '" src="/expensemap/jsp/images/next_page_list_up.gif"></a>&nbsp;');
        htmlStrBuf.append('<a href="javascript:void(0)" onClick="scrollWithinNode(\'');
        htmlStrBuf.append(dimId);
        htmlStrBuf.append('\',');
        htmlStrBuf.append(nodeId);
        // calculate beginIndex for the last page
        var numPages = Math.ceil(nodeTotal / pageSize);
        var lastPageIndex = ((numPages - 1) * pageSize) + 1;
        htmlStrBuf.append(',');
        htmlStrBuf.append(lastPageIndex);
        toolTip = "<bean:message key='tooltip.go.bottom' bundle='emMessages' />";
        htmlStrBuf.append(');" ><img style="border: 0" title="' + toolTip + '" src="/expensemap/jsp/images/last_page_list_up.gif"></a>&nbsp;');
    }
    return htmlStrBuf.toString();
}

function scrollWithinNode(dimId, nodeId, beginIndex) {
    try {
        var url = "/expensemap/dashboards/GetDimensionNode.do";
        var bookmarkId = document.getElementById("bookMarkId").value;
        var dashboardId = document.getElementById("dashboardId").value;
        var panelId = document.getElementById("dashboardPanelId").value;
        var filterStr = parent.getFilters(panelId);

        var params = {};
        params['action'] = 'scrollWithinNode';
        params['dimension'] = dimId;
        params['nodeId'] = nodeId;
        params['drillDim'] = filterStr;
        params['bkId'] = bookmarkId;
        params['beginIndex'] = beginIndex;
        params['dashboardId'] = dashboardId;
        params['dashboardPanelId'] = panelId;

		jQuery.ajax({
			url: url,
			type: "GET",
			data: params,
			success: renderExpandedNode
		});
    } catch(e) {
        alert(e);
    }
}


//remove filter
function removeFilter() {
    var dimensionName = document.getElementById("dimensionName").value;
    var bookMarkId = document.getElementById("bookMarkId").value;
    var panId = document.getElementById("dashboardPanelId").value;
    var isThisStatic = nonInteractiveSubMenuItem.cfg.getProperty("checked");
    if (typeof  parent.getContextFiltersForPanel(panId)[dimensionName] == 'undefined') {
        alert("<bean:message key='ui.dashboard.renderBookmarkchartpage.noFiltermsg' bundle='dashboard' />");
        return;
    }
    parent.removeBookmarkFilterForDimension(bookMarkId, dimensionName);
    parent.notifyAllPanelsOnFilterRemoval(panId, dimensionName, bookMarkId);
    if (! isThisStatic) {
        delete parent.getContextFiltersForPanel(panId)[dimensionName];
        submitForm();
    }
}

//go one level up
function levelUp() {
    var isThisStatic = nonInteractiveSubMenuItem.cfg.getProperty("checked");
    if (! isThisStatic) {
        var dimensionName = document.getElementById("dimensionName").value;
        var panelId = document.getElementById("dashboardPanelId").value;
        var nodeId = parent.getContextFiltersForPanel(panelId)[dimensionName];
        if (typeof nodeId == "undefined" || nodeId == 0) {
            alert("<bean:message	key='ui.message.top.level' bundle='dashboard' />");
            return;
        }
		var ajaxResponse = "";
        try {
            var url = "/expensemap/dashboards/GetParentNode.do";
            var params = {};
            params['nodeId'] = nodeId;
            params['dimensionName'] = dimensionName;
			ajaxResponse = eval(jQuery.ajax({
										url: url,
										type: "POST",
										data: params,
										async: false
									}).responseText);
            if (checkIfSessionActive(ajaxResponse) == false) {
                return;
            }

        } catch(e) {
            alert(e);
        }
		
        if (ajaxResponse[1] == 0) {
            removeFilter();
            return;
        }
        reRender(ajaxResponse[1]);
    } else {
        alert("<bean:message	key='ui.static.window' bundle='dashboard' />");
        return;
    }
}

//updates panel
function updateOnDrill(nodeId, dimensionName, bookMarkId) {
    var bkid = document.getElementById("bookMarkId").value;
    if (bkid == bookMarkId) {
        if (! nonInteractiveSubMenuItem.cfg.getProperty("checked")) {
            // Update the map of local context filters with the nodeId
            var panelId = document.getElementById("dashboardPanelId").value;
            parent.getContextFiltersForPanel(panelId)[dimensionName] = nodeId;
            submitForm();
        }
    }
}
//update on filter removal
function updateOnFilterRemoval(dimensionName, bookMarkId) {
    var bkid = document.getElementById("bookMarkId").value;
    var panId = document.getElementById("dashboardPanelId").value;
    if (bkid == bookMarkId) {
        if (! nonInteractiveSubMenuItem.cfg.getProperty("checked")) {
            delete parent.getContextFiltersForPanel(panId)[dimensionName];
            submitForm();
        }
    }
}

//submit form
function changeView(viewType) {
    var frm = document.getElementById("frm1");
    var panelId = document.getElementById("dashboardPanelId").value;
    var filterNodes = parent.getFilters(panelId);
    frm.method = "post";
    frm.action = "/expensemap/dashboards/changeView.do?viewType=" + viewType + "&pWidth=" + YAHOO.util.Dom.getViewportWidth() + "&pHeight=" + YAHOO.util.Dom.getViewportHeight() + "&drillDim=" + filterNodes;
    frm.submit();
}

//submit form
function doPaging(beginIndex) {
    var frm = document.getElementById("frm1");
    document.getElementById("beginIndex").value = beginIndex;
    var panelId = document.getElementById("dashboardPanelId").value;
    parent.panelPageMap[panelId] = beginIndex;
    var tempContextFilters = parent.getFilters(panelId);
    var filterStr = parent.getFilters(panelId);
    frm.method = "post";
    frm.action = "/expensemap/dashboards/renderDashboardPanel.do?viewType=table" + "&pWidth=" + YAHOO.util.Dom.getViewportWidth() + "&pHeight=" + YAHOO.util.Dom.getViewportHeight() + "&requestType=doPaging" + "&drillDim=" + filterStr;
    frm.submit();
}

//reset view
function reset(bookMarkId) {
    document.getElementById("beginIndex").value = '1';
    parent.panelPageMap[panelId] = '1';
    var bkid = document.getElementById("bookMarkId").value;
    if (bkid == bookMarkId) {
        if (! nonInteractiveSubMenuItem.cfg.getProperty("checked")) {
            var panelId = document.getElementById("dashboardPanelId").value;
            parent.panelContextFilters[panelId] = {};
            parent.panelContextFilterNames[panelId] = {};
            submitForm();
        }
    }
}

//opens preference window
function openPrefsWindow() {
    var dbId = document.getElementById("dashboardId").value;
    var dimensionName = document.getElementById("dimensionName").value;
    var dbPanelId = document.getElementById("dashboardPanelId").value;
    window.open("/expensemap/dashboards/showPanelPreferences.do?dbId=" + dbId + "&dbPanelId=" + dbPanelId, "Dashboard_Preferences", "width=650,height=380,scrollbars=yes,toolbar=no,status=no,resizable=no");
}

//renders view for this node
function reRender(nodeId) {
    document.getElementById("beginIndex").value = '1';
    var isThisStatic = nonInteractiveSubMenuItem.cfg.getProperty("checked");
    var panId = document.getElementById("dashboardPanelId").value;

    var dimensionName = document.getElementById("dimensionName").value;
    var bookMarkId = document.getElementById("bookMarkId").value;

    parent.getBookmarkContextFilters(bookMarkId)[dimensionName] = nodeId;
    //	parent.getBookmarkContextFilterNames(bookMarkId)[dimensionName]=nodeName;
    parent.notifyAllPanels(panId, dimensionName, nodeId, bookMarkId, isThisStatic);
    if (! isThisStatic) {
        parent.panelPageMap[panId] = '1';
        var panelId = document.getElementById("dashboardPanelId").value;
        parent.getContextFiltersForPanel(panelId)[dimensionName] = nodeId;
        submitForm();
    }
}

//update view
function updateOnDrill(nodeId, dimensionName, bookMarkId) {
    var bkid = document.getElementById("bookMarkId").value;
    if (bkid == bookMarkId) {
        if (!nonInteractiveSubMenuItem.cfg.getProperty("checked")) {
            // Update the map of local context filters with the nodeId
            var panelId = document.getElementById("dashboardPanelId").value;
            parent.getContextFiltersForPanel(panelId)[dimensionName] = nodeId;
            submitForm();
        }
    }
}

function submitForm() {
    var frm = document.getElementById("frm1");
    var panelId = document.getElementById("dashboardPanelId").value;
    var contextFilters = parent.getFilters(panelId);
    frm.method = "post";
    frm.action = "/expensemap/dashboards/renderDashboardPanel.do?viewType=table&pWidth=" + YAHOO.util.Dom.getViewportWidth() + "&pHeight=" + YAHOO.util.Dom.getViewportHeight() + "&drillDim=" + contextFilters;
    frm.submit();
}

//set panel static
function setStaticval() {

    var panelId = document.getElementById("dashboardPanelId").value;
    var bookmarkId = document.getElementById("bookMarkId").value;

    if (nonInteractiveSubMenuItem.cfg.getProperty("checked") == true) {
        nonInteractiveSubMenuItem.cfg.setProperty("checked", false);
        document.getElementById("glow").bgColor = '';
        parent.synchronizeFilters(bookmarkId, panelId);
    } else {
        nonInteractiveSubMenuItem.cfg.setProperty("checked", true);
        document.getElementById("glow").bgColor = '#E0E0E0';
    }
    document.getElementById("staticVal").value = nonInteractiveSubMenuItem.cfg.getProperty("checked");
    parent.panelStaticMap[panelId] = document.getElementById("staticVal").value;
}

//when dom is ready do the following
YAHOO.util.Event.onDOMReady(function () {
    //rendering menu inside DOMready so that
    //It should render in a proper way
    oContextMenu.render(document.body);
    var statVal = '<%=ESAPI.encoder().encodeForJavaScript(request.getParameter("staticVal"))%>';
    var contextMenuStyle = 'dashboardPanelContextMenu';
    if (statVal == 'null') {
        statVal = false;
        document.getElementById("glow").bgColor = '';
    }
    if (statVal == 'false') {
        statVal = false;
        document.getElementById("glow").bgColor = '';
    }
    if (statVal == 'true') {
        statVal = true;
        document.getElementById("glow").bgColor = '#E0E0E0';
    }
    nonInteractiveSubMenuItem.cfg.setProperty("checked", statVal);
    //setting style to context menu items
    oContextMenu.getItem(0).cfg.setProperty("classname", contextMenuStyle);
    oContextMenu.getItem(1).cfg.setProperty("classname", contextMenuStyle);
});


function appendShortenText(strBuf, str, dimId) {
    var maxNoOfCharsToDisplay = parseInt('${maxNoOfCharsToDisplay}');

    var string = unEscapeQuots(str);
    if (string.length > maxNoOfCharsToDisplay) {
        strBuf.append(string.substring(0, maxNoOfCharsToDisplay));
        strBuf.append('...');
    } else {
        strBuf.append(str);
    }
}

function unEscapeQuots(str) {
    var from = "&quot;";
    var to = "\"";
    var idx = str.indexOf(from);
    while (idx > -1) {
        str = str.replace(from, to);
        idx = str.indexOf(from);
    }
    return str;
}

// shows list of all dashboards
function showAllDashboards() {
    parent.showAllDashboards();
}

//renders to the edit page
function editDashboard() {
    parent.editDashboard();
}

function exportToPDF() {
    parent.setValuesForPDFExport();
    var ht = 500;
    var wt = 750;
    var left = (screen.width / 2) - (wt / 2);
    var top = (screen.height / 2) - (ht / 2);

    var dashboardid = document.getElementById("dashboardId").value;
    var panelId = document.getElementById("dashboardPanelId").value;
    window.open("/expensemap/dashboards/getPDFExportDialog.do?exportType=dashboardPanel&dashboardId=" + dashboardid + "&panelId=" + panelId, "_blank", "scrollbars=yes,resizable=yes,height=" + ht + ",width=" + wt + ",menubar=no,toolbar=no,left=" + left + ",top=" + top);
}

/**
 * Use this function to invoke dashboard export dialog.
 */
function exportDashboardAsPDF() {
    parent.exportToPDF();
}

/* for alernate shaded rows*/
function alternate(dashTableId) {
    if (document.getElementsByTagName) {
        var table = document.getElementById(dashTableId);
        if (table != null) {
            var rows = table.getElementsByTagName("tr");
            for (i = 0; i < rows.length; i++) {
                //manipulate rows
                if (i % 2 == 0) {
                    rows[i].style.backgroundColor = "#e3e3e3";
                } else {
                    rows[i].style.backgroundColor = "#eeeeee";
                }
            }
        }
    }
}

</script>

</head>

<body TOPMARGIN="0" class="yui-skin-sam" onload="alternate('breadCrumbTable')">
<table style="top: 25px;" WIDTH="100%">
    <tr>
        <td>
            <logic:messagesPresent message="true">
                <br>
                <font color="red" face="Verdana" size="2">
                    <html:messages id="msg" message="true" bundle="dashboard">
                        <%=pageContext.findAttribute("msg")%>
                    </html:messages>
                </font>
            </logic:messagesPresent>
            <logic:messagesNotPresent message="true">
                <%
                    ZSession zs = (ZSession) request.getAttribute("workingZS");
                    String dimName = request.getParameter("dimensionName");
                    ViewerTreeNode rootNode = (ViewerTreeNode) request.getAttribute("rootNode");
                    List<PropertyHeading> propertyHeadings = (List<PropertyHeading>) request.getAttribute("propertyHeadings");
                    DimensionViewFormatter dimensionViewFormatter = new DimensionViewFormatter();
                    out.print(dimensionViewFormatter.format(zs, propertyHeadings, dimName, rootNode));
                %>
            </logic:messagesNotPresent>
        </td>
    </tr>
</table>
</body>
</html>