<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import ="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="java.util.Locale"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.text.SimpleDateFormat"%>

<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext); 
	Locale locale = WebUtil.getAppLocale(pageContext);
	//make url for help page    
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = "To be done";
	String date = new SimpleDateFormat("EEE MMM d HH:mm:ss z Z yyyy").format(new Date());
%>


<html:html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/css/dataenrichmentui.css"/>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>
<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>
<script LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/dataenrichment.js"></script>

<script type="text/javascript" ><!--
	
		
		function initTransactionalClassificationForm(){
			createDateColumnChange(document.transactionalClassificationForm.createDateColumn);
		}
			
		function createDateColumnChange(createDateColumn){
			var createDateColumnValue = createDateColumn.options[createDateColumn.selectedIndex].value;
			if(createDateColumnValue==''){
				document.transactionalClassificationForm.nodeCreationDate.value = '';
				document.transactionalClassificationForm.nodeCreationDate.disabled = true;
				document.transactionalClassificationForm.nodeCreationDateHourMinute.value = '0:00';
				document.transactionalClassificationForm.nodeCreationDateHourMinute.disabled = true;
			}else{
				document.transactionalClassificationForm.nodeCreationDate.disabled = false;
				document.transactionalClassificationForm.nodeCreationDateHourMinute.disabled = false;				
			}
		}

		function showHideAssociatedRules(flag){
			var obj = document.getElementById("associationRuleId");
			var dimensionToEnrich = document.getElementById("dimensionToEnrich").value;
			if(flag.checked){
				if(dimensionToEnrich!=""){			
					submitRequestForAssociatedIds("getAssociatedIds");			
					submitRequestForiegnKeys("getforiegnKeyList");											
				}
				obj.style.display="table-row-group";
			}else{
				obj.style.display="none";
			}
		}

		function showHideDateFilterGroup(parentId, childrenGroupId, expandIconSrc, collapseIconSrc){
		
			var childGroupObj = document.getElementById(childrenGroupId);
			var show = false;
			if(childGroupObj != null && typeof childGroupObj != 'undefined'){
				show = childGroupObj.style.display == 'none';
			}
			if(show){
				childGroupObj.style.display = 'table-row';
				parentId.src = collapseIconSrc;
			}else{
				childGroupObj.style.display = 'none';
				parentId.src = expandIconSrc;
			}
		}
		
		function showHideKbOption(flag)	{	
			var obj = document.getElementById("specifyKnowledgeBase");		
			var dimensionToEnrich = document.getElementById("dimensionToEnrich").value;
			if(flag.checked){
				var kbType = document.getElementById('kbType');
				obj.style.display="table-row-group";
			}else{
				obj.style.display="none";
			}
		}

		function validateJobName(){
			var iChars = "*|,\":<>[]{}`\';()@&$#%";			
			var jobNameObj = document.transactionalClassificationForm.jobName;
			return validateRequired(jobNameObj, "<bean:message key='ui.job.dimension.clustering.jobName.required' bundle='dataEnrichmentMessages'/>") && validateSpecialChars(jobNameObj, "<bean:message key='ui.job.dimension.clustering.jobName.no.special.char' bundle='dataEnrichmentMessages'/>",  iChars );			
		}

		function validateCreateDateColumn(){
			var createDateColumn = document.transactionalClassificationForm.createDateColumn;
			var createDateColumnValue = createDateColumn.options[createDateColumn.selectedIndex].value;
			if(!isEmpty(createDateColumnValue)){
				var nodeCreationDate = document.transactionalClassificationForm.nodeCreationDate.value;			

				if (isEmpty(nodeCreationDate)) {
					alert("<bean:message key='ui.job.dimension.clustering.date.attribute.filter.required' bundle='dataEnrichmentMessages'/>");
					checkIfdateFilterGroupObjExpanded();
					document.transactionalClassificationForm.nodeCreationDate.focus();
					return false;
				}
				var nodeCreationDateHourMinuteObj = document.transactionalClassificationForm.nodeCreationDateHourMinute;	
				if(!validateHourMinute(nodeCreationDateHourMinuteObj.value)){						
					checkIfdateFilterGroupObjExpanded();
					nodeCreationDateHourMinuteObj.value = '';	
					nodeCreationDateHourMinuteObj.focus();
					alert("<bean:message key='ui.job.dimension.clustering.time.format' bundle='dataEnrichmentMessages'/>");
					return false;
				}else {
					var tmArr = nodeCreationDateHourMinuteObj.value.split(":");

					if( checkWithCurrentDate(nodeCreationDate, tmArr[0]  , tmArr[1] )){
						checkIfdateFilterGroupObjExpanded();
						alert("<bean:message key='ui.job.dimension.clustering.date.attribute.filter.isgreater' bundle='dataEnrichmentMessages'/>");
						return false;
					}
				}
			}
			return true;
		}

		function checkIfdateFilterGroupObjExpanded(){
			var dateFilterGroupObj = document.getElementById('dateFilterGroup');
			if( dateFilterGroupObj.style.display == 'none' ){
				dateFilterGroupObj.style.display = 'table-row';
				document.getElementById('DateFilterGroup_Image').src = '/expensemap/jsp/images/sdm/arrow_expanded_icon.gif';
			}
		}


		function validateJobExpirationDate(){
			var jobExpirationDateObj = document.transactionalClassificationForm.jobExpirationDate;	

			if ( isValidDate(jobExpirationDateObj.value) == false ) {
				alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.format' bundle='dataEnrichmentMessages'/>");
				return false;
			}

			if(!isEmpty(jobExpirationDateObj.value)){
				if(isValidDate(jobExpirationDateObj.value)){
					var jobExpirationDateHourMinuteObj = document.transactionalClassificationForm.jobExpirationDateHourMinute;	
					if(!validateHourMinute(jobExpirationDateHourMinuteObj.value)){						
						jobExpirationDateHourMinuteObj.value = '';	
						alert("<bean:message key='ui.job.dimension.clustering.time.format' bundle='dataEnrichmentMessages'/>");
						return false;
					}else {
						var tmArr = jobExpirationDateHourMinuteObj.value.split(":");
						if( !checkWithCurrentDate(jobExpirationDateObj.value, tmArr[0]  , tmArr[1] )){
							alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.is.less' bundle='dataEnrichmentMessages'/>");
							return false;
						}
					}
				}
			}else{
				alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.required' bundle='dataEnrichmentMessages'/>");
				jobExpirationDateObj.value="";
				jobExpirationDateObj.focus();
				return false;
			}
			return true;
		}


		function validateDimensionToEnrich(){
			var dimensionToEnrichObj = document.transactionalClassificationForm.dimensionToEnrich;
			return validateRequired(dimensionToEnrichObj, "<bean:message key='ui.job.dimension.clustering.dimension.to.enrich.required' bundle='dataEnrichmentMessages'/>" );
        }

		function validateDescription(){
			var descriptionObj = document.transactionalClassificationForm.description;			
			if(descriptionObj.value.length > 255){
				alert("<bean:message key='ui.job.dimension.clustering.description.validation' bundle='dataEnrichmentMessages'/>" );
				return false;
			}else{
				return true;
			}
		}
		
		function validateFactFieldToEnrich(){			
			var enrichTransactionalFieldObj = document.transactionalClassificationForm.enrichTransactionalField;
			return validateRequired(enrichTransactionalFieldObj, "<bean:message key='ui.job.transactional.classification.msg.enrich.fact.field' bundle='dataEnrichmentMessages'/>" );
		}

		function validateAssociatedId(){
			var associatedIdObj = document.transactionalClassificationForm.associatedId;
			return validateRequired(associatedIdObj ,"<bean:message key='ui.job.transactional.classification.msg.associated.id' bundle='dataEnrichmentMessages'/>");
		}

		function validateForeignKey(){
			var foreignKeyIddObj = document.transactionalClassificationForm.foreignKeyId;
			return validateRequired(foreignKeyIddObj, "<bean:message key='ui.job.transactional.classification.msg.foreign.key' bundle='dataEnrichmentMessages' />");
		}

		function validateKBType(){
			var kbTypeObj = document.transactionalClassificationForm.kbType;
			return validateRequired(kbTypeObj, "<bean:message key='ui.job.transactional.classification.msg.kbtype' bundle='dataEnrichmentMessages'/>");
		}

		function validateKBVersion(){
			var kbVersionObj = document.transactionalClassificationForm.kbVersion;
			return validateRequired(kbVersionObj, "<bean:message key='ui.job.transactional.classification.msg.kbversion' bundle='dataEnrichmentMessages'/>");
		}

		function validateData(){
					
			if(!validateJobName()){
				return false;
			}

			if(!validateDescription()){
						return false;
			}

			if(!validateJobExpirationDate()){
				return false;
			}

			if(!validateDimensionToEnrich()){
				return false;
			}

			if(!validateFactFieldToEnrich()){
				return false;
			}

			if(document.getElementById("applyAssociationRule").checked && !validateAssociatedId()){
				return false;
			}
			
			if(document.getElementById("applyAssociationRule").checked && !validateForeignKey()){
				return false;
			}

			if(document.getElementById("specifyKB").checked && !validateKBType()){
				return false;
			}

			if(document.getElementById("specifyKB").checked && !validateKBVersion()){
				return false;
			}
			
			if(!validateCreateDateColumn()){
				return false;
			}
						
			return true;

		}
		
		/*
		 * Java script function for Begin Transactional Classification
		 */
		function onClickSaveForm() {
			if (validateData()){				
				var confirmMessage = '<bean:message key="ui.job.dimension.clustering.submission.confirmation" bundle="dataEnrichmentMessages" arg0="[JOB_NAME]" arg1="<%=zs.getUser().getName()%>" arg2="<%=date%>"/>';
				confirmMessage = confirmMessage.replace('[JOB_NAME]', document.transactionalClassificationForm.jobName.value);
				if (confirm(confirmMessage)) {
					return true;
				}				
			}
			return false;
		}



				

--></script>

	<SCRIPT>
		
		function setOperation(operation){
			document.getElementById('operation').value=operation;
			return true;
		}
		//submit the ajax request
		function submitRequest(operation, selectTag){
			try {
				var dimensionToEnrich = selectTag.options[selectTag.selectedIndex].value;
				if(dimensionToEnrich == ""){
					var minmatchscore = document.getElementById("minmatchscore");
					minmatchscore.value = '';
					var createDateColumn = document.getElementById("createDateColumn");
					for( i=1; i < createDateColumn.options.length;){
						createDateColumn.options[i]=null;
					}
					return false;
				}
				
				var argStr = "method=" + operation + "&" +"dimensionToEnrich=" + dimensionToEnrich;
				var url = "/expensemap/dataenrichment/TransactionalClassificationAction.do?" + argStr;
				jQuery.ajax({
					url: url,
					type: "GET",
					success: responseHandler,
					async: false,
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
						return false;
					}
				});
			} catch(e) {
				alert(e);
			}	
		}

		//handle the ajax response
		function responseHandler(ajaxResponse) {    
			var data = eval(ajaxResponse);

			// If there is no data in the response, ignore this
			if (data == null) {
				return;
			} else if( data[0]=="getDimensionDateFields") {

				var minmatchscore = document.getElementById("minmatchscore");
				if(typeof data[1] != "undefined" ){
					minmatchscore.value = data[1];
				}else
				{
					minmatchscore.value = '';
				}

				var createDateColumn = document.getElementById("createDateColumn");
				for( i=0; i < createDateColumn.options.length;){
					createDateColumn.options[i]=null;
				}

				for(i=2 ; i<data.length ; i=i+2){
					createDateColumn.options[createDateColumn.options.length] = new Option(data[i], data[i+1]);
				}
				if(createDateColumn.options.length > 0){
					createDateColumn.options[0].selected=true;
				}
			}
		}


		function submitRequestForAssociatedIds(operation){
			

			if(!(document.getElementById("applyAssociationRule").checked)){
				return;
			}

			try {											
				var dimensionToEnrich = document.getElementById("dimensionToEnrich").value;
				
				var argStr = "method=" + operation + "&" + "dimensionToEnrich=" + dimensionToEnrich;
				var url = "/expensemap/dataenrichment/TransactionalClassificationAction.do?" + argStr;				
				jQuery.ajax({
					url: url,
					type: "GET",
					success: associatedIdsResponseHandler,
					async: false,
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
						return false;
					}
				});
			} catch(e) {
				 alert(e);
			}	
		}

		function associatedIdsResponseHandler(ajaxResponse) {  
			var data = eval(ajaxResponse);				

			// If there is no data in the response, ignore this
			if (data == null) {
				return;
			} else if( data[0]=="getAssociatedIds") {
				var associatedId = document.getElementById("associatedId");
				for( i=0; i < associatedId.options.length;){
					associatedId.options[i]=null;
				}

				for(i=1 ; i<data.length ; i=i+2){
					associatedId.options[associatedId.options.length] = new Option(data[i], data[i+1]);
				}
				if(associatedId.options.length > 0){
					associatedId.options[0].selected=true;
				}
			}
		}

		
		function submitRequestForiegnKeys(operation){

			if(!(document.getElementById("applyAssociationRule").checked)){
				return;
			}
			try {							
				var dimensionToEnrich = document.getElementById("dimensionToEnrich").value;
				var argStr = "method=" + operation + "&" + "dimensionToEnrich=" + dimensionToEnrich;
				var url = "/expensemap/dataenrichment/TransactionalClassificationAction.do?" + argStr;
				jQuery.ajax({
					url: url,
					type: "GET",
					success: foriegnKeyResponseHandler,
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
						return false;
					},
					async: false
				});
				} catch(e) {
					 alert(e);
				}	
			}

		
		function foriegnKeyResponseHandler(ajaxResponse) {  		  
			var data = eval(ajaxResponse);				
			// If there is no data in the response, ignore this
			if (data == null) {
				return;
			} else if( data[0]=="foriegnKeys") {
				var foreignKeyId = document.getElementById("foreignKeyId");
				for( i=0; i < foreignKeyId.options.length;){
					foreignKeyId.options[i]=null;
				}

				for(i=1 ; i<data.length ; i=i+2){
					foreignKeyId.options[foreignKeyId.options.length] = new Option(data[i], data[i+1]);
				}
				if(foreignKeyId.options.length > 0){
					foreignKeyId.options[0].selected=true;
				}
			}
		}
		


		
		// onchange populate the version list of KB type
		function submitRequestForKbVersion(operation, selectTag){
			try {
				var kbType = selectTag.options[selectTag.selectedIndex].value;
				var argStr = "method=" + operation + "&" +"kbType=" + kbType;
				var url = "/expensemap/dataenrichment/TransactionalClassificationAction.do?" + argStr;
				jQuery.ajax({
					url: url,
					type: "GET",
					success: kbTypeResponseHandler,
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
						return false;
					},
					async: false
				});
				
			} catch(e) {
				 alert(e);
			}	
		}


		//handle the ajax response
		function kbTypeResponseHandler(ajaxResponse) {    
			var data = eval(ajaxResponse);

			// If there is no data in the response, ignore this
			if (data == null) {
				return;
			} else if( data[0]=="getKbVersions") {
				var kbVersion = document.getElementById("kbVersion");
				for( i=0; i < kbVersion.options.length;){
					kbVersion.options[i]=null;
				}

				for(i=1 ; i<data.length ; i=i+2){
					kbVersion.options[kbVersion.options.length] = new Option(data[i], data[i+1]);
				}
				if(kbVersion.options.length > 0){
					kbVersion.options[0].selected=true;
				}
			}
		}
YAHOO.util.Event.onDOMReady(initTransactionalClassificationForm);
</SCRIPT>




<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.job.transactional.classification.title" bundle="dataEnrichmentMessages" /></title>
</head>

<body class="yui-skin-sam" leftmargin="2" topmargin="2" marginwidth="1" marginheight="1" >
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

<html:form method="post" styleId="transactionalClassificationForm" action="/TransactionalClassificationAction.do?method=submitTransactionalClassificationJob">

<TABLE WIDTH="90%" CELLPADDING="0" CELLSPACING="0" BORDER="0" align="center">
	<TR CLASS="POPFORMBODY">
		<TD>
			<TABLE CLASS="POPFORMBORDER" CELLPADDING="0" CELLSPACING="1" BORDER="0" WIDTH="100%"><TR CLASS="POPFORMBODY"><TD>			
				<TABLE width="100%" cellspacing="0" cellpadding="0" border="0" CLASS="POPFORMBODY">
					<TR>
						<TD CLASS="POPFORMTITLE" STYLE="padding-left:3px">
								<bean:message key="ui.job.transactional.classification.title" bundle="dataEnrichmentMessages" />
						</TD>
						<TD align="left" CLASS="POPFORMTITLE">
							<IMG  src="/expensemap/jsp/images/help.gif" border="0" title="Help"  onClick="window.open('<%=helpURL%>','help','')" align="right" style="cursor: pointer">
						</TD>
					</TR>

					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>

					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style ="text-decoration:none;font-weight:bold;font-size:11;color:black" >
								<bean:message key="ui.job.dimension.clustering.jobName" bundle="dataEnrichmentMessages" />
								<span style = "color:red;font-size:18px">*</span>&nbsp;&nbsp;
							</div>
						</TD>
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:text property="jobName" styleId="jobName" styleClass="inputStyle" size="20" maxlength="80"/>
						</TD>
					</TR>

					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>
					
					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style ="text-decoration:none;font-weight:bold;font-size:11;color:black" >
								<bean:message key="ui.job.dimension.clustering.description" bundle="dataEnrichmentMessages" />
							</div>
						</TD>						
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:textarea property="description" cols="25" rows="2" styleId="description"/>
						</TD>
					</TR>

					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>

					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style ="text-decoration:none;font-weight:bold;font-size:11;color:black">
								<bean:message key="ui.job.dimension.clustering.job.expiration.date" bundle="dataEnrichmentMessages" />
								<span style = "color:red;font-size:18px">*</span>
							</div>
						</TD>
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:text property="jobExpirationDate" size="15" styleId="jobExpirationDate" styleClass="inputStyle" maxlength="10" readonly="true"/>&nbsp;
							<html:text property="jobExpirationDateHourMinute" size="5" styleId="jobExpirationDateHourMinute" styleClass="inputStyle" maxlength="5" value="0:00"/>
							&nbsp;<bean:message key="ui.job.dimension.gmt" bundle="dataEnrichmentMessages" />&nbsp;<%=new SimpleDateFormat("Z").format(new Date())%>&nbsp;&nbsp;&nbsp;<font size="1"><bean:message key="ui.dataEnrichment.datePattern" bundle='dataEnrichmentMessages' /></font>
						</TD>
					</TR>

					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>

					<TR>
						<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
								<bean:message key="ui.job.dimension.clustering.dimension.selection" bundle="dataEnrichmentMessages" />							
							<span style = "color:red;font-size:18px">*</span>
						</TD>
					</TR>

					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>
				
					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" ><bean:message key="ui.job.dimension.classification.using.dimension.target.dimension" bundle="dataEnrichmentMessages"></bean:message>
								<span style = "color:red;font-size:18px">*</span>
							</div>
						</TD>
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:select styleId="dimensionToEnrich" name="transactionalClassificationForm" property="dimensionToEnrich" onchange="submitRequest('getDimensionDateFields',this);submitRequestForiegnKeys('getforiegnKeyList');submitRequestForAssociatedIds('getAssociatedIds')">
								<html:options collection="availableDimensions" property="value" labelProperty="label" />
							</html:select>
							<BR/>
							<logic:messagesPresent name="dimnesionIsLocked">
								<FONT COLOR="red" FACE="Arial, Helvetica, sans-serif" SIZE="2">
									<html:messages  name="dimnesionIsLocked" id="msg" bundle="dataEnrichmentMessages">
										<%=pageContext.findAttribute("msg")%>
									</html:messages>
								</FONT>
							</logic:messagesPresent>						
						</TD>
					</TR>
				
					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>

					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" ><bean:message key="ui.job.transactional.classification.enrich.fact.field" bundle="dataEnrichmentMessages" />								
								<span style ="color:red;font-size:18px">*</span>
							</div>
						</TD>
						
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:select property="enrichTransactionalField" styleId="enrichTransactionalField">
								<html:options collection="availableFactField" property="value" labelProperty="label" />
							</html:select>
						</TD>
					</TR>


					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>
					
					<TR>
						<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px"><bean:message key="ui.job.transactional.classification.parameters" bundle="dataEnrichmentMessages" />								
							<span style = "color:red;font-size:18px">*</span>
						</TD>
					</TR>
					
					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>

					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
								<bean:message key="ui.job.dimension.clustering.minimum.match.score" bundle="dataEnrichmentMessages" />
								<span style = "color:red;font-size:18px">*</span>
							</div>
						</TD>
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:text property="minScore" size="20" styleId="minmatchscore" styleClass="inputStyle" maxlength="20"/>
						</TD>
					</TR>
					
					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>

					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" ><bean:message key="ui.job.transactional.classification.apply.association.rule" bundle="dataEnrichmentMessages" />
									
							</div>
						</TD>
				
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
								<html:checkbox property="applyAssociationRule" styleId="applyAssociationRule" onclick="showHideAssociatedRules(this);"/>
						</TD>
					</TR>

					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>
		

				<tbody style="display: none" id="associationRuleId">
					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
								<bean:message key="ui.job.transactional.classification.associated.id" bundle="dataEnrichmentMessages" />
								<span style ="color:red;font-size:18px">*</span>
							</div>
						</TD>
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:select property="associatedId" styleId="associatedId" >
								<html:options collection="associatedIds" property="value" labelProperty="label" />
							</html:select>
						</TD>				
					</TR>
				
					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>

					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
								<bean:message key="ui.job.transactional.classification.foreign.key" bundle="dataEnrichmentMessages" />								
								<span style ="color:red;font-size:18px">*</span>
							</div>
						</TD>
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:select property="foreignKey" styleId="foreignKeyId">
								<html:options collection="foriegnKeys" property="value" labelProperty="label" />
							</html:select>
						</TD>
					</TR>
					
					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>			
					
				</tbody>
	
					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
								<bean:message key="ui.job.transactional.classification.specifykb" bundle="dataEnrichmentMessages" />
							</div>
						</TD>
				
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
								<html:checkbox property="specifyKB" styleId="specifyKB" onclick="showHideKbOption(this);"/>
						</TD>
					</TR>
				
					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>			


				<tbody style="display:none" id="specifyKnowledgeBase">			
					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
									<bean:message key="ui.job.transactional.classification.ktype" bundle="dataEnrichmentMessages" />
								<span style = "color:red;font-size:18px">*</span>
							</div>
						</TD>
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:select property="kbType" styleId="kbType" onchange="submitRequestForKbVersion('getKbVersions',this)">
								<html:options collection="kbTypes" property="value" labelProperty="label" />
							</html:select>
						</TD>
					</TR>
									
					<TR>
						<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
					</TR>

					<TR>
						<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
								<bean:message key="ui.job.transactional.classification.kbversion" bundle="dataEnrichmentMessages" />
								<span style = "color:red;font-size:18px">*</span>
							</div>
						</TD>
						<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:select property="kbVersion" styleId="kbVersion" >
								<html:options collection="kbVersions" property="value" labelProperty="label" />
							</html:select>
						</TD>
					</TR>		
				</tbody>

	
				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<img BORDER='0' SRC='/expensemap/jsp/images/sdm/1x1_trans.gif' WIDTH='3' HEIGHT='15'>&nbsp;&nbsp;
						<img NAME='DateFilterGroup_Image' ID='DateFilterGroup_Image' src='/expensemap/jsp/images/sdm/arrow_collapsed_icon.gif' BORDER=0 align='bottom' onclick="showHideDateFilterGroup(this, 'dateFilterGroup', '/expensemap/jsp/images/sdm/arrow_collapsed_icon.gif', '/expensemap/jsp/images/sdm/arrow_expanded_icon.gif')"  title='<bean:message key="ui.job.dimension.created.date.filter.icon.tooltip" bundle="dataEnrichmentMessages" />'>&nbsp;&nbsp;<bean:message key="ui.job.dimension.clustering.date.filter" bundle="dataEnrichmentMessages" />
					</TD>
				</TR>

				
				<TR id="dateFilterGroup" STYLE="display:none">
					<TD colspan="2" >
						<TABLE  CELLPADDING="0" CELLSPACING="0" BORDER="0" WIDTH="100%" >
							<TR>
								<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px;height:25px">
									<bean:message key="ui.job.dimension.clustering.nodes.created.date.header" bundle="dataEnrichmentMessages" />
								</TD>
								<TD>&nbsp;</TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
									<bean:message key="ui.job.dimension.clustering.date.attribute.filter" bundle="dataEnrichmentMessages" />
								</TD>
								<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
									<html:select  name="transactionalClassificationForm" property="createDateColumn" styleId="createDateColumn" styleClass="tabledata" onchange="createDateColumnChange(this)">
										<html:options collection="createDateColumns" property="value" labelProperty="label"/>
									</html:select>
								</TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">&nbsp;</TD>
								<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
									<html:text property="nodeCreationDate" size="15" styleId="nodeCreationDate" styleClass="inputStyle" maxlength="10" disabled="true" readonly="true"/>&nbsp;
									<html:text property="nodeCreationDateHourMinute" size="5" styleId="nodeCreationDateHourMinute" styleClass="inputStyle" maxlength="5" value="0:00" disabled="true"/>
									&nbsp;<bean:message key="ui.job.dimension.gmt" bundle="dataEnrichmentMessages" />&nbsp;<%=new SimpleDateFormat("Z").format(new Date())%>&nbsp;
									&nbsp;&nbsp;<font size="1"><bean:message key="ui.dataEnrichment.datePattern" bundle='dataEnrichmentMessages' /></font>
								</TD>
							</TR>
						</TABLE>
					</TD>
				</TR>
				
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				
			</TABLE>
			
			<BR/>
			<DIV CLASS="POPFORMBUTTONS">
				<html:submit onclick="return onClickSaveForm();"><bean:message key="ui.job.transactional.classification.begin.transactional.classification" bundle="dataEnrichmentMessages" /></html:submit>&nbsp;

				<html:button property="abc" onclick="top.window.close();"><bean:message key="ui.import.cancle.button" bundle="sdmMessages" /></html:button>

			</DIV>			
			<BR/>
			</TD></TR></TABLE>

			<DIV CLASS="POPFORMINSTRUCTIONS"><br><span style = "color:red;font-size:18px">*</span><bean:message key="ui.job.dimension.clustering.required.field" bundle="dataEnrichmentMessages" /></DIV>
		</TD>	
	</TR>
</TABLE>
</TD></TR></TABLE>
</html:form>


<script language="JavaScript">

	YAHOO.namespace('classify.transactions');
		(function() {
		var Event = YAHOO.util.Event;
		var Dom = YAHOO.util.Dom;
		YAHOO.classify.transactions = {
			init: function() {
				var self = YAHOO.classify.transactions;
				var jobExpDate = document.getElementById("jobExpirationDate");
				var nodeCreationDate = document.getElementById("nodeCreationDate");
				
				Event.on(jobExpDate, "focus", self.openCalendar, [jobExpDate, jobExpDate]);
				Event.on(nodeCreationDate , "focus", self.openCalendar, [nodeCreationDate, nodeCreationDate]);
			},
			openCalendar: function(e, args) {
				YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '','');
			}
		}
		
		Event.onDOMReady(YAHOO.classify.transactions.init, YAHOO.classify.transactions, true);
	})();

</script>

</body>
</html:html>