<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import ="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="java.util.Locale"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="com.emptoris.spendmanager.components.knowledgebase.spi.KnowledgeBaseType"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.text.SimpleDateFormat"%>

<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext); 
	Locale locale = WebUtil.getAppLocale(pageContext);
	//make url for help page    
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = "To be done";
	String date = new SimpleDateFormat("EEE MMM d HH:mm:ss z Z yyyy").format(new Date());


%>
<html:html>
<html:javascript formName="dimensionalClassificationWithKbForm" />
<head>
	<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.job.dimension.classification.wrt.kb.title" bundle="dataEnrichmentMessages" /></title>

	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
	<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css">
	<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/css/dataenrichmentui.css">

	<script type="text/javascript" src="/expensemap/jsp/javascript/stringbuffer.js" ></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>
	<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
	<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>
	
	
	<SCRIPT LANGUAGE="JavaScript">
	
	
	function isInt(x) {
	   var y=parseInt(x);
	   if (isNaN(y)) return false;
	   return x==y && x.toString()==y.toString();
	 } 

	 function isEmpty(fieldVal) {
		if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
			return true;
		}
		return false;
	}

	function validateDimensionalClassificationForm(){
			var createDateColumn = document.dimensionalClassificationWithKbForm.createDateColumn;
			var createDateColumnValue = createDateColumn.options[createDateColumn.selectedIndex].value;
			
			if(createDateColumnValue != ''){
				var nodeCreationDate = document.dimensionalClassificationWithKbForm.nodeCreationDate.value;
				if (isEmpty(nodeCreationDate)) {
					alert("<bean:message key='ui.job.dimension.clustering.date.attribute.filter.required' bundle='dataEnrichmentMessages'/>");
					checkIfdateFilterGroupObjExpanded();
					document.dimensionalClassificationWithKbForm.nodeCreationDate.focus();
					return false;
				}
				var nodeCreationDateHourMinute = document.dimensionalClassificationWithKbForm.nodeCreationDateHourMinute.value;	
				if(!validateHourMinute(nodeCreationDateHourMinute)){						
					checkIfdateFilterGroupObjExpanded();
					document.dimensionalClassificationWithKbForm.nodeCreationDateHourMinute.value = '';	
					document.dimensionalClassificationWithKbForm.nodeCreationDateHourMinute.focus();
					alert("<bean:message key='ui.job.dimension.clustering.time.format' bundle='dataEnrichmentMessages'/>");
					return false;
				}else {
					var tmArr = document.dimensionalClassificationWithKbForm.nodeCreationDateHourMinute.value.split(":");

					if( checkWithCurrentDate(nodeCreationDate, tmArr[0]  , tmArr[1] )){
						checkIfdateFilterGroupObjExpanded();
						alert("<bean:message key='ui.job.dimension.clustering.date.attribute.filter.isgreater' bundle='dataEnrichmentMessages'/>");
						return false;
					}
				}
			}
			return true;
		}
	
	function toggleToUnStructureContent(){
		if(document.getElementById("unStructuredContent").checked){
				clearDropDown();
				document.getElementById("hideAttributes").style.display="none";
		}
	}
	
	// Clear data of known Attribute
	function clearDropDown(){
		for(j=0; j<supplierKnownAttributes.length; j++){
		obj = document.getElementById(supplierKnownAttributes[j]);
			for( i=0; i < obj.options.length;){
						obj.options[i]=null;
			}
		}
	}
	
	function showHideDateFilterGroup(parentId, childrenGroupId, expandIconSrc, collapseIconSrc){
			var childGroupObj = document.getElementById(childrenGroupId);
			var show = false;

			if(childGroupObj != null && typeof childGroupObj != 'undefined'){
				show = childGroupObj.style.display == 'none';
			}

			if(show){
				childGroupObj.style.display = 'table-row';
				parentId.src = collapseIconSrc;
			}else{
				childGroupObj.style.display = 'none';
				parentId.src = expandIconSrc;
			}
		}
		
	function initDimensionalClassificationWithKbForm(){
		createDateColumnChnage(document.dimensionalClassificationWithKbForm.createDateColumn);
	}
	
	function createDateColumnChnage(createDateColumn){

		var createDateColumnValue = createDateColumn.options[createDateColumn.selectedIndex].value;
		if(createDateColumnValue==""){
			document.dimensionalClassificationWithKbForm.nodeCreationDate.value = '';
			document.dimensionalClassificationWithKbForm.nodeCreationDate.disabled = true;

			document.dimensionalClassificationWithKbForm.nodeCreationDateHourMinute.value = '0:00';
			document.dimensionalClassificationWithKbForm.nodeCreationDateHourMinute.disabled = true;
			document.dimensionalClassificationWithKbForm.fullPathEnabled.checked = true;
			document.dimensionalClassificationWithKbForm.preserveExistingStructure.checked = true;			
		}else
		{
			document.dimensionalClassificationWithKbForm.nodeCreationDate.disabled = false;
			document.dimensionalClassificationWithKbForm.nodeCreationDateHourMinute.disabled = false;
			document.dimensionalClassificationWithKbForm.fullPathEnabled.checked = true;
			document.dimensionalClassificationWithKbForm.preserveExistingStructure.checked = true;
		}
	}
		
		
		/*
		 * Java script function for Begin Dimensional Classification
		 */
		function onClickSaveForm() {		
			var attributes = new StringBuffer();
			if(document.getElementById("structuredContent").checked){
			for(j=0; j<supplierKnownAttributes.length; j++){
				obj = document.getElementById(supplierKnownAttributes[j]);				
				attributes.append(obj.value);
				if(j<supplierKnownAttributes.length-1){
					attributes.append(",");
				}				
			}
			}
			var frm = document.getElementById("dimensionalClassificationWithKbForm");
			if (validateDimensionalClassificationWithKbForm(frm) && validateDescriptionField() && validateJobExpirationDate() && validateDimensionalClassificationForm()){
				var confirmMessage = '<bean:message key="ui.job.dimension.clustering.submission.confirmation" bundle="dataEnrichmentMessages" arg0="[JOB_NAME]" arg1="<%=zs.getUser().getName()%>" arg2="<%=date%>"/>';
				confirmMessage = confirmMessage.replace('[JOB_NAME]', document.dimensionalClassificationWithKbForm.jobName.value);
				if (confirm(confirmMessage)) {
					var argStr = "operation=" + "submitDimClassificationWithKB" + "&" +"knowAttributes=" + attributes.toString();
					var url = "/expensemap/dataenrichment/DimensionClassificationWithKbAction.do?" + argStr;
					frm.action = url;
					return true;
				}				
			}
			return false;
		}
		
		function validateData(){
		var frm = document.getElementById("dimensionalClassificationWithKbForm");
			if(validateDimensionalClassificationWithKbForm(frm)){
				return false;
			}
			if(validateJobExpirationDate()){
				return false;
			}
			return true;
		}
		function validateJobExpirationDate(){
			
			var jobExpirationDate = document.dimensionalClassificationWithKbForm.jobExpirationDate.value;	

			if ( isValidDate(jobExpirationDate) == false ) {
				alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.format' bundle='dataEnrichmentMessages'/>");
				return false;
			}

			if(!isEmpty(jobExpirationDate)){
				if(isValidDate(jobExpirationDate)){
					var jobExpirationDateHourMinute = document.dimensionalClassificationWithKbForm.jobExpirationDateHourMinute.value;	
					if(!validateHourMinute(jobExpirationDateHourMinute)){						
						document.dimensionalClassificationWithKbForm.jobExpirationDateHourMinute.value = '';	
						alert("<bean:message key='ui.job.dimension.clustering.time.format' bundle='dataEnrichmentMessages'/>");
						return false;
					}else {
						var tmArr = document.dimensionalClassificationWithKbForm.jobExpirationDateHourMinute.value.split(":");
						if( !checkWithCurrentDate(jobExpirationDate, tmArr[0]  , tmArr[1] )){
							alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.is.less' bundle='dataEnrichmentMessages'/>");
							return false;
						}
					}
				}
			}else
			{
				alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.required' bundle='dataEnrichmentMessages'/>");
				document.dimensionalClassificationWithKbForm.jobExpirationDate.value="";
				document.dimensionalClassificationWithKbForm.jobExpirationDate.focus();
				return false;
			}
			return true;
		}

		function checkIfdateFilterGroupObjExpanded(){
			var dateFilterGroupObj = document.getElementById('dateFilterGroup');
			if( dateFilterGroupObj.style.display == 'none' ){
				dateFilterGroupObj.style.display = 'table-row';
				document.getElementById('DateFilterGroup_Image').src = '/expensemap/jsp/images/sdm/arrow_expanded_icon.gif';
			}
		}
		
		function isValidDate(dateString) {
			var RegExPattern = /^(?=\d)(?:(?:(?:(?:(?:0?[13578]|1[02])(\/)31)\1|(?:(?:0?[1,3-9]|1[0-2])(\/)(?:29|30)\2))(?:(?:1[6-9]|[2-9]\d)?\d{2})|(?:0?2(\/)29\3(?:(?:(?:1[6-9]|[2-9]\d)?(?:0[48]|[2468][048]|[13579][26])|(?:(?:16|[2468][048]|[3579][26])00))))|(?:(?:0?[1-9])|(?:1[0-2]))(\/)(?:0?[1-9]|1\d|2[0-8])\4(?:(?:1[6-9]|[2-9]\d)?\d{2}))($|\ (?=\d)))?(((0?[1-9]|1[012])(:[0-5]\d){0,2}(\ [AP]M))|([01]\d|2[0-3])(:[0-5]\d){1,2})?$/;      
			
			 if ( !( dateString.match(RegExPattern)) && dateString != "" ) {
				return false;    
			 }
			 else{
				return true;
			 }
		}
		
		function validateHourMinute(hourMinute){
			if( !isEmpty(hourMinute) ){
				var tmArr     = hourMinute.split(":");
				if( tmArr.length != 2 || isNaN( tmArr[0] ) || isNaN( tmArr[1] ) || tmArr[1].length < 2 || parseInt( tmArr[0] ) > 23 || parseInt( tmArr[1] ) > 59 ) {
					return false;
				}
			}
			return true;			
		}
		
		function checkWithCurrentDate(dateString, hours, minutes ){
			var currDate = new Date();   	           
			if(dateString!='' || dateString!=null || dateString!='null'){			
				var endYear = dateString.substr(6,4) -0;
				var endMonth = dateString.substr(0,2) - 1;
				var endDay = dateString.substr(3,2) - 0;
				dateString = new Date (endYear, endMonth, endDay, hours, minutes);
				if(dateString > currDate){			
					return true;
				}else{
					return false;
				}
			}
		}
		
		function uncheckFullPathEnabled(){
			var objBox = document.dimensionalClassificationWithKbForm.fullPathEnabled;
		      //check if checked:
		       if (objBox.checked == true) {
		           return false;
		       }
		       if (confirm('<bean:message key="ui.job.dimension.classification.disable.full.tree.path" bundle="dataEnrichmentMessages"/>')) {
		           return true;
		       }
		       objBox.checked = true;
		}
		
		function uncheckPreserveExistingStructure(){
			var existStr = document.dimensionalClassificationWithKbForm.preserveExistingStructure;
	        if (existStr.checked == true) {
	            return false;
	        }
	        if (confirm('<bean:message key="ui.job.dimension.classification.eliminate.previous.hierarchy" bundle="dataEnrichmentMessages"/>')) {
	            return true;
	        }
	        existStr.checked = true;
		}
		function validateDescriptionField() {
			var descriptionObj = document.dimensionalClassificationWithKbForm.description;
			var len = descriptionObj.value.length;
			if(len > 255){
				alert("<bean:message key='ui.job.description.validation.msg' bundle='dataEnrichmentMessages'/>");
				descriptionObj.value="";
				descriptionObj.focus();
				return false;
			}
			return true;	
		}
		</script>
		
	<SCRIPT>
		
		function setOperation(operation){
			document.getElementById('operation').value=operation;
			return true;
		}

		//submit the ajax request
		function submitRequest(operation, selectTag){

			try {
				var dimensionToEnrich = selectTag.options[selectTag.selectedIndex].value;
				if(dimensionToEnrich == ""){
					var minmatchscore = document.getElementById("minmatchscore");
					minmatchscore.value = '';
					var createDateColumn = document.getElementById("createDateColumn");
					for( i=1; i < createDateColumn.options.length;){
						createDateColumn.options[i]=null;
					}
					createDateColumn.fireEvent('onchange');
					return false;
				}
				var argStr = "operation=" + operation + "&" +"dimensionToEnrich=" + dimensionToEnrich;
				var url = "/expensemap/dataenrichment/DimensionClassificationWithKbAction.do?" + argStr;
				jQuery.ajax({
					url: url,
					type: "GET",
					success: responseHandler,
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
						return false;
					},
					async: false
				});
			} catch(e) {
				 alert(e);
			}	
		}

		//handle the ajax response
		function responseHandler(ajaxResponse) {    
			var data = eval(ajaxResponse);
			
			// If there is no data in the response, ignore this
			if (data == null) {
				return;
			} else if( data[0]=="getDimensionDateFields") {

				var minmatchscore = document.getElementById("minmatchscore");
				if(typeof data[1] != "undefined" ){
					minmatchscore.value = data[1];
				}else
				{
					minmatchscore.value = '';
				}

				var createDateColumn = document.getElementById("createDateColumn");
				for( i=0; i < createDateColumn.options.length;){
					createDateColumn.options[i]=null;
				}

				for(i=2 ; i<data.length ; i=i+2){
					createDateColumn.options[createDateColumn.options.length] = new Option(data[i], data[i+1]);
				}
				if(createDateColumn.options.length > 0){
					createDateColumn.options[0].selected=true;
				}
			}
		}
		
		<%java.lang.String [] str = (java.lang.String [])request.getAttribute("supplierKnownAttributes");
		%>
		var supplierKnownAttributes = new Array();
		<%for(int i=0; i<str.length; i++){%>
			supplierKnownAttributes[<%=i%>] = "<%=str[i]%>";
		<%}%>
		
		// for KnowAttributes
		function submitRequestForKnownAttribute(operation, selectTag){
			var selectTag = document.dimensionalClassificationWithKbForm.dimensionToEnrich;
			var dimensionToEnrich = selectTag.options[selectTag.selectedIndex].value;
			
			if(dimensionToEnrich ==""){
				clearDropDown();
				document.getElementById("hideAttributes").style.display="none";
				if(document.getElementById("structuredContent").checked){
				alert('<bean:message key="ui.job.dimension.classification.known.attributes.not.exist" bundle="dataEnrichmentMessages" />');
				}
				return false;
			}
			
			if(document.getElementById("structuredContent").checked && document.getElementById("kbType").value=="<%=KnowledgeBaseType.SUPPLIER%>"){
				document.getElementById("hideAttributes").style.display="table-row";
				
			
			try {
				var argStr = "operation=" + operation + "&" +"dimensionToEnrich=" + dimensionToEnrich;
				var url = "/expensemap/dataenrichment/DimensionClassificationWithKbAction.do?" + argStr;
				jQuery.ajax({
					url: url,
					type: "GET",
					success: knownAttributeresponseHandler,
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
					},
					async: false
				});
			} catch(e) {
				 alert(e);
			}
			}
		}

		//handle the ajax response
		function knownAttributeresponseHandler(ajaxResponse) {    
			var data = eval(ajaxResponse);
			
			// If there is no data in the response, ignore this
			if (data == null) {
				return;
			} else if( data[0]=="getKnownAttributesContentForDim") {
				for(j=0; j<supplierKnownAttributes.length; j++){
					obj = document.getElementById(supplierKnownAttributes[j]);

					for( i=0; i < obj.options.length;){
						obj.options[i]=null;
					}

					for(i=1 ; i<data.length ; i=i+2){
						obj.options[obj.options.length] = new Option(data[i], data[i+1]);
					}
	
					if(obj.options.length > 0){
						obj.options[0].selected=true;
					}
				}
			}
		}
		
		// onchange populate the version list of KB type
		function submitRequestForKbVersion(operation, selectTag){

			try {
				var kbType = selectTag.options[selectTag.selectedIndex].value;
				var structContent = document.getElementById("structContent");
				var unStructContent = document.getElementById("unStructContent");
				if(kbType=="<%=KnowledgeBaseType.SUPPLIER%>"){
				document.dimensionalClassificationWithKbForm.structuredContent.checked = false;
				document.dimensionalClassificationWithKbForm.unStructuredContent.checked = true;
				structContent.style.display="table-row";
				unStructContent.style.display="none";
				}else{
				document.dimensionalClassificationWithKbForm.structuredContent.checked = false;
				document.dimensionalClassificationWithKbForm.unStructuredContent.checked = true;
				clearDropDown();
				document.getElementById("hideAttributes").style.display="none";
				structContent.style.display="none";
				unStructContent.style.display="table-row";
				}
				var argStr = "operation=" + operation + "&" +"kbType=" + kbType;
				var url = "/expensemap/dataenrichment/DimensionClassificationWithKbAction.do?" + argStr;
				jQuery.ajax({
					url: url,
					type: "GET",
					success: kbTypeResponseHandler,
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
						return false;
					},
					async: false
				});
				
			} catch(e) {
				 alert(e);
			}	
		}

		//handle the ajax response
		function kbTypeResponseHandler(ajaxResponse) {    
			var data = eval(ajaxResponse);
			
			// If there is no data in the response, ignore this
			if (data == null) {
				return;
			} else if( data[0]=="getKbVersions") {
				var kbVersion = document.getElementById("kbVersion");
				for( i=0; i < kbVersion.options.length;){
					kbVersion.options[i]=null;
				}

				for(i=1 ; i<data.length ; i=i+2){
					kbVersion.options[kbVersion.options.length] = new Option(data[i], data[i+1]);
				}
				if(kbVersion.options.length > 0){
					kbVersion.options[0].selected=true;
				}
			}
		}


	YAHOO.util.Event.onDOMReady(initDimensionalClassificationWithKbForm);

	</SCRIPT>
</head>


<body class="yui-skin-sam" leftmargin="2" topmargin="2" marginwidth="1" marginheight="1" >
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
		
<html:form method="post" styleId="dimensionalClassificationWithKbForm" action="/DimensionClassificationWithKbAction.do" >


<TABLE WIDTH="96%" CELLPADDING="0" CELLSPACING="0" BORDER="0" align="center">
	<TR CLASS="POPFORMBODY">
		<TD>
			<TABLE CLASS="POPFORMBORDER" CELLPADDING="0" CELLSPACING="1" BORDER="0" WIDTH="100%"><TR CLASS="POPFORMBODY"><TD>
			
			<TABLE width="100%" cellspacing="0" cellpadding="0" border="0" CLASS="POPFORMBODY">
				<TR>
					<TD CLASS="POPFORMTITLE" STYLE="padding-left:3px" nowrap>
						<bean:message key="ui.job.dimension.classification.wrt.kb.title" bundle="dataEnrichmentMessages" />
					</TD>
					<TD align="left" CLASS="POPFORMTITLE">
						<IMG  src="/expensemap/jsp/images/help.gif" border="0" title="Help"  onClick="window.open('<%=helpURL%>','help','')" align="right" style="cursor: pointer">
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.clustering.jobName" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>&nbsp;&nbsp;
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:text property="jobName" styleId="jobName" styleClass="inputStyle" size="20" maxlength="80"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.clustering.description" bundle="dataEnrichmentMessages" />
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:textarea property="description" cols="25" rows="2" styleId="description"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.clustering.job.expiration.date" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:text property="jobExpirationDate" size="15" styleId="jobExpirationDate" styleClass="inputStyle" maxlength="10" readonly="true"/>&nbsp;
						<html:text property="jobExpirationDateHourMinute" size="5" styleId="jobExpirationDateHourMinute" styleClass="inputStyle" maxlength="5" value="0:00"/>
						&nbsp;<bean:message key="ui.job.dimension.gmt" bundle="dataEnrichmentMessages" />&nbsp;<%=new SimpleDateFormat("Z").format(new Date())%>&nbsp;&nbsp;&nbsp;<font size="1"><bean:message key="ui.dataEnrichment.datePattern" bundle='dataEnrichmentMessages' /></font>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<bean:message key="ui.job.dimension.clustering.dimension.selection" bundle="dataEnrichmentMessages" />
						<span style = "color:red;font-size:18px">*</span>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
							<bean:message key="ui.job.dimension.clustering.dimension.to.enrich" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:select styleId="selectCompId" property="dimensionToEnrich" onchange="submitRequest('getDimensionDateFields',this);submitRequestForKnownAttribute('getKnownAttributesContentForDim', this);">
							<html:options collection="dimensionNames" property="value" labelProperty="label" />
						</html:select>
						<BR/>
						<logic:messagesPresent name="dimnesionIsLocked">
							<FONT COLOR="red" FACE="Arial, Helvetica, sans-serif" SIZE="2">
								<html:messages  name="dimnesionIsLocked" id="msg" bundle="dataEnrichmentMessages">
									<%=pageContext.findAttribute("msg")%>
								</html:messages>
							</FONT>
						</logic:messagesPresent>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.classification.kbtype" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:select property="kbType" onchange="submitRequestForKbVersion('getKbVersions',this)">
							<html:options collection="kbTypes" property="value" labelProperty="label" />
						</html:select>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.classification.kb.version" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:select property="kbVersion" styleId="kbVersion" >
							<html:options collection="kbVersions" property="value" labelProperty="label" />
						</html:select>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<bean:message key="ui.job.dimension.classification.using.dimension.classification.parameters" bundle="dataEnrichmentMessages" />
						<span style = "color:red;font-size:18px">*</span>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.clustering.use.vendor.semantics" bundle="dataEnrichmentMessages" />
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:6px">
						<html:checkbox property="venodrSemantics" styleId="venodrSemantics" value="true" />
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div CLASS="DIVSTYLE">
							<bean:message key="ui.job.dimension.clustering.minimum.match.score" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:text property="minmatchscore" size="20" styleId="minmatchscore" styleClass="inputStyle" maxlength="20"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='3' height='15'>&nbsp;&nbsp;
						<img NAME='DateFilterGroup_Image' ID='DateFilterGroup_Image'  src='/expensemap/jsp/images/sdm/arrow_collapsed_icon.gif' border=0 align=bottom onclick="showHideDateFilterGroup(this, 'dateFilterGroup', '/expensemap/jsp/images/sdm/arrow_collapsed_icon.gif', '/expensemap/jsp/images/sdm/arrow_expanded_icon.gif')"  title='<bean:message key="ui.job.dimension.created.date.filter.icon.tooltip" bundle="dataEnrichmentMessages" />'>&nbsp;&nbsp;<bean:message key="ui.job.dimension.clustering.date.filter" bundle="dataEnrichmentMessages" />
					</TD>
				</TR>
				
				<TR id="dateFilterGroup" STYLE="display:none">
					<TD colspan="2" >
						<TABLE  CELLPADDING="0" CELLSPACING="0" BORDER="0" WIDTH="100%" >
							<TR>
								<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px;height:25px">
									<bean:message key="ui.job.dimension.clustering.nodes.created.date.header" bundle="dataEnrichmentMessages" />
								</TD>
								<TD>&nbsp;</TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
									<bean:message key="ui.job.dimension.clustering.date.attribute.filter" bundle="dataEnrichmentMessages" />
								</TD>
								<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
									<html:select  name="dimensionalClassificationWithKbForm" property="createDateColumn" styleId="createDateColumn" styleClass="tabledata" onchange="createDateColumnChnage(this)">
										<html:options collection="createDateColumns" property="value" labelProperty="label"/>
									</html:select>
								</TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">&nbsp;</TD>
								<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
									<html:text property="nodeCreationDate" size="15" styleId="nodeCreationDate" styleClass="inputStyle" maxlength="10" disabled="true" readonly="true"/>&nbsp;
									<html:text property="nodeCreationDateHourMinute" size="5" styleId="nodeCreationDateHourMinute" styleClass="inputStyle" maxlength="5" value="0:00" disabled="true"/>
									&nbsp;<bean:message key="ui.job.dimension.gmt" bundle="dataEnrichmentMessages" />&nbsp;<%=new SimpleDateFormat("Z").format(new Date())%>&nbsp;
									&nbsp;&nbsp;<font size="1"><bean:message key="ui.dataEnrichment.datePattern" bundle='dataEnrichmentMessages' /></font>
								</TD>
							</TR>
							
						</TABLE>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<bean:message key="ui.job.dimension.classification.structure.content" bundle="dataEnrichmentMessages" />
						
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<bean:message key="ui.job.dimension.classification.structure" bundle="dataEnrichmentMessages" />
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:checkbox property="fullPathEnabled" styleId="fullPathEnabled" value="true" onclick="uncheckFullPathEnabled();"/><bean:message key="ui.job.dimension.classification.full.path.enabled" bundle="dataEnrichmentMessages"/><br>
						<html:checkbox property="preserveExistingStructure" styleId="preserveExistingStructure" value="true" onclick="uncheckPreserveExistingStructure();"/><bean:message key="ui.job.dimension.classification.remember.existing.structure" bundle="dataEnrichmentMessages"/>
						<INPUT TYPE="HIDDEN" name="operation"/>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<bean:message key="ui.job.dimension.classification.content" bundle="dataEnrichmentMessages" />
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px;display: none" id="structContent">
						<html:radio property="structuredContent" styleId="structuredContent" value="structuredContent" onclick="submitRequestForKnownAttribute('getKnownAttributesContentForDim', this);"/><bean:message key="ui.job.dimension.classification.label.structured.content" bundle="dataEnrichmentMessages"/><br>
						<html:radio property="structuredContent" styleId="unStructuredContent" value="unStructuredContent" onclick="toggleToUnStructureContent();"/><bean:message key="ui.job.dimension.classification.label.unstructured.content" bundle="dataEnrichmentMessages"/>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px;height: 26;" id="unStructContent"><bean:message key="ui.job.dimension.classification.label.unstructured.content" bundle="dataEnrichmentMessages"/>
						
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				<tbody style="display: none" id="hideAttributes">
				<logic:iterate name="supplierKnownAttributes" type="java.lang.String" id = "knownAttribute" indexId="ctr">
				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
							<%=knownAttribute %>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
							<html:select styleId="<%=knownAttribute %>" property="knowAttributes">
								<html:options collection="<%=knownAttribute %>" property="value" labelProperty="label" />
							</html:select>
					</TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				</logic:iterate>
				</tbody>
				
			</TABLE>
			<BR/>
			<DIV CLASS="POPFORMBUTTONS">
				<html:submit onclick="return onClickSaveForm();"><bean:message key="ui.job.dimension.classification.begin.dimensional.classification" bundle="dataEnrichmentMessages" /></html:submit>&nbsp;

				<html:button property="abc" onclick="top.window.close();"><bean:message key="ui.job.dimension.classification.button.close" bundle="dataEnrichmentMessages" /></html:button>

			</DIV>			
			<BR/>
			</TD></TR></TABLE>

			<DIV CLASS="POPFORMINSTRUCTIONS"><br><span style = "color:red;font-size:18px">*</span><bean:message key="ui.job.dimension.clustering.required.field" bundle="dataEnrichmentMessages" /></DIV>
		</TD>	
	</TR>
			
</TABLE>
</TD></TR></TABLE>
</html:form>


<script language="JavaScript">
 
YAHOO.namespace('dimensional.classification.kb');
(function() {
var Event = YAHOO.util.Event;
var Dom = YAHOO.util.Dom;
	YAHOO.dimensional.classification.kb = {
		init: function() {
			var self = YAHOO.dimensional.classification.kb;
			var jobExpDate = document.getElementById("jobExpirationDate");
			var nodeCreationDate = document.getElementById("nodeCreationDate");
			
			Event.on(jobExpDate, "focus", self.openCalendar, [jobExpDate, jobExpDate]);
			Event.on(nodeCreationDate , "focus", self.openCalendar, [nodeCreationDate, nodeCreationDate]);
		},

		openCalendar: function(e, args) {
			YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '','');
		}
	}
	
	Event.onDOMReady(YAHOO.dimensional.classification.kb.init, YAHOO.dimensional.classification.kb, true);
})();

</script>

</body>
</html:html>