<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import ="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="java.util.Locale"%>
<%@ page import="java.util.Date"%>
<%@ page import="java.text.SimpleDateFormat"%>

<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext); 
	Locale locale = WebUtil.getAppLocale(pageContext);
	//make url for help page    
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = "To be done";

	String date = new SimpleDateFormat("EEE MMM d HH:mm:ss z Z yyyy").format(new Date());
%>
<html:html>
<head>
	<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.job.dimension.classification.using.dimension.title" bundle="dataEnrichmentMessages" /></title>
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css"/>
	<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/dataenrichmentui.css"/>

	<script LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/dataenrichment.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>
	<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
	<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>



	<script LANGUAGE="JavaScript">
		// The method called on load of body to initialize default settings
		function initDimensionalClassificationwrtEDForm(){
			createDateColumnChnage(document.dimensionalClassificationwrtEDForm.createDateColumn);
		}

		// The method to enable/diable Node Created Date filter
		function createDateColumnChnage(createDateColumn){

			var createDateColumnValue = createDateColumn.options[createDateColumn.selectedIndex].value;
			if(createDateColumnValue==''){
				document.dimensionalClassificationwrtEDForm.nodeCreationDate.value = '';
				document.dimensionalClassificationwrtEDForm.nodeCreationDate.disabled = true;

				document.dimensionalClassificationwrtEDForm.nodeCreationDateHourMinute.value = '0:00';
				document.dimensionalClassificationwrtEDForm.nodeCreationDateHourMinute.disabled = true;
			}else{
				document.dimensionalClassificationwrtEDForm.nodeCreationDate.disabled = false;
				document.dimensionalClassificationwrtEDForm.nodeCreationDateHourMinute.disabled = false;
			}
		}

		// To validate Job Name for required and special characters
		function validateJobName(){
			var iChars = "*|,\":<>[]{}`\';()@&$#%";			
			var jobNameObj = document.dimensionalClassificationwrtEDForm.jobName;

			return validateRequired(jobNameObj, "<bean:message key='ui.job.dimension.clustering.jobName.required' bundle='dataEnrichmentMessages'/>") && validateSpecialChars(jobNameObj, "<bean:message key='ui.job.dimension.clustering.jobName.no.special.char' bundle='dataEnrichmentMessages'/>",  iChars ) ;
			
		}

		// To validate Target dimension is selected
		function validateTargetDimension(){
			var targetDimensionObj = document.dimensionalClassificationwrtEDForm.targetDimension;
			return validateRequired(targetDimensionObj, "<bean:message key='ui.job.dimension.classification.using.dimension.target.dimension.required' bundle='dataEnrichmentMessages'/>" );
        }

		// To validate dimension To Enrich is selected
		function validateDimensionToEnrich(){
			var dimensionToEnrichObj = document.dimensionalClassificationwrtEDForm.dimensionToEnrich;
			return validateRequired(dimensionToEnrichObj, "<bean:message key='ui.job.dimension.clustering.dimension.to.enrich.required' bundle='dataEnrichmentMessages'/>" );			
        }

		// To validate numeric minimum match score
		function validateMinMatchScore(){

			var minMatchScore = document.dimensionalClassificationwrtEDForm.minmatchscore;

			return validateRequired(minMatchScore, "<bean:message key='ui.job.dimension.clustering.minimum.match.score.required' bundle='dataEnrichmentMessages'/>" ) && validateNotNumber(minMatchScore, "<bean:message key='ui.job.dimension.clustering.minimum.match.score.isNotNumeric' bundle='dataEnrichmentMessages'/>") && validateInteger(minMatchScore, "<bean:message key='ui.job.dimension.clustering.minimum.match.score.isFloat' bundle='dataEnrichmentMessages'/>") && validateNumericRange(minMatchScore, "<bean:message key='ui.job.dimension.clustering.minimum.match.score.in.range' bundle='dataEnrichmentMessages' arg0="0" arg1="100"/>", 0, 100);
		}

		// To validate Job Expiration Date for valid format and as required
		function validateJobExpirationDate(){
			var jobExpirationDateObj = document.dimensionalClassificationwrtEDForm.jobExpirationDate;	

			if ( isValidDate(jobExpirationDateObj.value) == false ) {
				alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.format' bundle='dataEnrichmentMessages'/>");
				return false;
			}

			if(!isEmpty(jobExpirationDateObj.value)){
				if(isValidDate(jobExpirationDateObj.value)){
					var jobExpirationDateHourMinuteObj = document.dimensionalClassificationwrtEDForm.jobExpirationDateHourMinute;	
					if(!validateHourMinute(jobExpirationDateHourMinuteObj.value)){
						jobExpirationDateHourMinuteObj.value = '';	
						jobExpirationDateHourMinuteObj.focus();
						alert("<bean:message key='ui.job.dimension.clustering.time.format' bundle='dataEnrichmentMessages'/>");
						return false;
					}else {
						var tmArr = jobExpirationDateHourMinuteObj.value.split(":");
						if( !checkWithCurrentDate(jobExpirationDateObj.value, tmArr[0]  , tmArr[1] )){
							alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.is.less' bundle='dataEnrichmentMessages'/>");
							return false;
						}
					}
				}
			}else
			{
				alert("<bean:message key='ui.job.dimension.clustering.job.expiration.date.required' bundle='dataEnrichmentMessages'/>");
				jobExpirationDateObj.value="";
				jobExpirationDateObj.focus();
				return false;
			}
			return true;
		}	

		// Validate Create Date for date format
		function validateCreateDateColumn(){
			var createDateColumn = document.dimensionalClassificationwrtEDForm.createDateColumn;
			var createDateColumnValue = createDateColumn.options[createDateColumn.selectedIndex].value;
			if(createDateColumnValue != ''){
				var nodeCreationDate = document.dimensionalClassificationwrtEDForm.nodeCreationDate.value;
				if (isEmpty(nodeCreationDate)) {
					alert("<bean:message key='ui.job.dimension.clustering.date.attribute.filter.required' bundle='dataEnrichmentMessages'/>");
					checkIfdateFilterGroupObjExpanded();
					document.dimensionalClassificationwrtEDForm.nodeCreationDate.focus();
					return false;
				}
				var nodeCreationDateHourMinuteObj = document.dimensionalClassificationwrtEDForm.nodeCreationDateHourMinute;	
				if(!validateHourMinute(nodeCreationDateHourMinuteObj.value)){
					checkIfdateFilterGroupObjExpanded();
					nodeCreationDateHourMinuteObj.value = '';	
					nodeCreationDateHourMinuteObj.focus();
					alert("<bean:message key='ui.job.dimension.clustering.time.format' bundle='dataEnrichmentMessages'/>");
					return false;
				}else {
					var tmArr = nodeCreationDateHourMinuteObj.value.split(":");

					if( checkWithCurrentDate(nodeCreationDate, tmArr[0]  , tmArr[1] )){
						checkIfdateFilterGroupObjExpanded();
						alert("<bean:message key='ui.job.dimension.clustering.date.attribute.filter.isgreater' bundle='dataEnrichmentMessages'/>");
						return false;
					}
				}
			}
			return true;
		}

		// To check that Date filter group is expanded and if not then expand it
		function checkIfdateFilterGroupObjExpanded(){
			var dateFilterGroupObj = document.getElementById('dateFilterGroup');
			if( dateFilterGroupObj.style.display == 'none' ){
				dateFilterGroupObj.style.display = 'table-row';
				document.getElementById('DateFilterGroup_Image').src = '/expensemap/jsp/images/sdm/arrow_expanded_icon.gif';
			}
		}

		// To show confirm message on clicking remember existing structure
		function onRememberExistingStructure(){
			var rememberExistingStructure = document.dimensionalClassificationwrtEDForm.rememberExistingStructure
			if (rememberExistingStructure.checked) {
				return false;
			}//
			if (confirm("<bean:message key='ui.job.dimension.classification.using.dimension.remember.existing.structure.warning' bundle='dataEnrichmentMessages'/>")) {
				return true;
			}
			rememberExistingStructure.checked = true;
		}

		// validate all form data on submit
		function validateData(){
			if(!validateJobName()){
				return false;
			}
			if(!validateDescriptionField()){
				return false;
			}
			if(!validateJobExpirationDate()){
				return false;
			}
			if(!validateTargetDimension()){
				return false;
			}
			if(!validateDimensionToEnrich()){
				return false;
			}
			if(!validateMinMatchScore()){
				return false;
			}
			if(!validateCreateDateColumn()){
				return false;
			}

			return true;
		}

		/*
		 * Java script function for validating Dimensional Classification form
		 */
		function onClickSaveForm() {
			if (validateData()){				
				var confirmMessage = '<bean:message key="ui.job.dimension.clustering.submission.confirmation" bundle="dataEnrichmentMessages" arg0="[JOB_NAME]" arg1="<%=zs.getUser().getName()%>" arg2="<%=date%>"/>';
				confirmMessage = confirmMessage.replace('[JOB_NAME]', document.dimensionalClassificationwrtEDForm.jobName.value);
				if (confirm(confirmMessage)) {
					setOperation('submitDimClassificationForm');					
					return true;
				}				
			}
			return false;
			
		}

		// Show or Hide Date filter group
		function showHideDateFilterGroup(parentId, childrenGroupId, expandIconSrc, collapseIconSrc){
			var childGroupObj = document.getElementById(childrenGroupId);
			var show = false;

			if(childGroupObj != null && typeof childGroupObj != 'undefined'){
				show = childGroupObj.style.display == 'none';
			}

			if(show){
				childGroupObj.style.display = 'table-row';
				parentId.src = collapseIconSrc;
			}else{
				childGroupObj.style.display = 'none';
				parentId.src = expandIconSrc;
			}
		}

		function validateDescriptionField() {
			var descriptionObj = document.dimensionalClassificationwrtEDForm.description;
			var len = descriptionObj.value.length;
			if(len > 255){
				alert("<bean:message key='ui.job.description.validation.msg' bundle='dataEnrichmentMessages'/>");
				descriptionObj.value="";
				descriptionObj.focus();
				return false;
			}
			return true;	
		}
	</script>

	<SCRIPT>
		// Set operation value before submit
		function setOperation(operation){
			document.getElementById('operation').value=operation;
			return true;
		}

		//submit the ajax request
		function submitRequest(operation, selectTag){
			try {
				var dimensionToEnrich = selectTag.options[selectTag.selectedIndex].value;
				if(dimensionToEnrich == '' ){
					var minmatchscore = document.getElementById("minmatchscore");
					minmatchscore.value = '';
					var createDateColumn = document.getElementById("createDateColumn");
					for( i=1; i < createDateColumn.options.length;){
						createDateColumn.options[i]=null;
					}
					createDateColumn.fireEvent('onchange');
					return false;
				}
				var argStr = "operation=" + operation + "&" +"dimensionToEnrich=" + dimensionToEnrich;
				var url = "/expensemap/dataenrichment/DimensionalClassificationwrtEDAction.do?" + argStr;
				jQuery.ajax({
					url: url,
					type: "GET",
					success: responseHandler,
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
					},
					async: false
				});
			} catch(e) {
				 alert(e);
			}	
		}

		//handle the ajax response
		function responseHandler(ajaxResponse) {    
			var data = eval(ajaxResponse);
			
			// If there is no data in the response, ignore this
			if (data == null) {
				return;
			} else if( data[0]=="getDimensionDateFields") {

				var minmatchscore = document.getElementById("minmatchscore");
				if(typeof data[1] != "undefined" ){
					minmatchscore.value = data[1];
				}else
				{
					minmatchscore.value = '';
				}

				var createDateColumn = document.getElementById("createDateColumn");
				for( i=0; i < createDateColumn.options.length;){
					createDateColumn.options[i]=null;
				}

				for(i=2 ; i<data.length ; i=i+2){
					createDateColumn.options[createDateColumn.options.length] = new Option(data[i], data[i+1]);
				}
				if(createDateColumn.options.length > 0){
					createDateColumn.options[0].selected=true;
				}
			}
		}
		YAHOO.util.Event.onDOMReady(initDimensionalClassificationwrtEDForm);

	</SCRIPT>

</head>


<body class="yui-skin-sam" leftmargin="2" topmargin="2" marginwidth="1" marginheight="1" >
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

		
<html:form method="post" styleId="dimensionalClassificationwrtEDForm" action="/DimensionalClassificationwrtEDAction.do" >


<TABLE WIDTH="90%" CELLPADDING="0" CELLSPACING="0" BORDER="0" align="center">
	<TR CLASS="POPFORMBODY">
		<TD>
			<TABLE CLASS="POPFORMBORDER" CELLPADDING="0" CELLSPACING="1" BORDER="0" WIDTH="100%"><TR CLASS="POPFORMBODY"><TD>
			
			<TABLE width="100%" cellspacing="0" cellpadding="0" border="0" CLASS="POPFORMBODY">
				<TR>
					<TD CLASS="POPFORMTITLE" STYLE="padding-left:3px">
						<bean:message key="ui.job.dimension.classification.using.dimension.title" bundle="dataEnrichmentMessages" />
					</TD>
					<TD align="left" CLASS="POPFORMTITLE">
						<IMG  src="/expensemap/jsp/images/help.gif" border="0" title="Help"  onClick="window.open('<%=helpURL%>','help','')" align="right" style="cursor: pointer">
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div style ="text-decoration:none;font-weight:bold;font-size:11;color:black" >
							<bean:message key="ui.job.dimension.clustering.jobName" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:text property="jobName" styleId="jobName" styleClass="inputStyle" size="20" maxlength="80"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div style ="text-decoration:none;font-weight:bold;font-size:11;color:black" >
							<bean:message key="ui.job.dimension.clustering.description" bundle="dataEnrichmentMessages" />
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:textarea property="description" cols="25" rows="2" styleId="description"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div style ="text-decoration:none;font-weight:bold;font-size:11;color:black">
							<bean:message key="ui.job.dimension.clustering.job.expiration.date" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:text property="jobExpirationDate" size="15" styleId="jobExpirationDate" styleClass="inputStyle" maxlength="10" readonly="true"/>&nbsp;
						<html:text property="jobExpirationDateHourMinute" size="5" styleId="jobExpirationDateHourMinute" styleClass="inputStyle" maxlength="5" value="0:00"/>
						&nbsp;<bean:message key="ui.job.dimension.gmt" bundle="dataEnrichmentMessages" />&nbsp;<%=new SimpleDateFormat("Z").format(new Date())%>&nbsp;&nbsp;&nbsp;<font size="1"><bean:message key="ui.dataEnrichment.datePattern" bundle='dataEnrichmentMessages' /></font>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<bean:message key="ui.job.dimension.clustering.dimension.selection" bundle="dataEnrichmentMessages" />
						<span style = "color:red;font-size:18px">*</span>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
							<bean:message key="ui.job.dimension.classification.using.dimension.target.dimension" bundle="dataEnrichmentMessages" />
							<span style="color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:select styleId="targetDimension" property="targetDimension">
							<html:options collection="dimensionNames" property="value" labelProperty="label" />
						</html:select>
						<BR/>
						<logic:messagesPresent name="dimnesionIsLocked">
							<FONT COLOR="red" FACE="Arial, Helvetica, sans-serif" SIZE="2">
								<html:messages  name="dimnesionIsLocked" id="msg" bundle="dataEnrichmentMessages">
									<%=pageContext.findAttribute("msg")%>
								</html:messages>
							</FONT>
						</logic:messagesPresent>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
							<bean:message key="ui.job.dimension.clustering.dimension.to.enrich" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:select styleId="selectCompId" property="dimensionToEnrich" onchange="submitRequest('getDimensionDateFields',this)">
							<html:options collection="dimensionNames" property="value" labelProperty="label" />
						</html:select>
						<BR/>
						<logic:messagesPresent name="dimnesionIsLocked">
							<FONT COLOR="red" FACE="Arial, Helvetica, sans-serif" SIZE="2">
								<html:messages  name="dimnesionIsLocked" id="msg" bundle="dataEnrichmentMessages">
									<%=pageContext.findAttribute("msg")%>
								</html:messages>
							</FONT>
						</logic:messagesPresent>

					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<bean:message key="ui.job.dimension.classification.using.dimension.classification.parameters" bundle="dataEnrichmentMessages" />
						<span style = "color:red;font-size:18px">*</span>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
							<bean:message key="ui.job.dimension.clustering.use.vendor.semantics" bundle="dataEnrichmentMessages" />
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:6px">
						<html:checkbox property="venodrSemantics" styleId="venodrSemantics" value="true" />
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
						<div style = "text-decoration:none;font-weight:bold;font-size:11;color:black" >
							<bean:message key="ui.job.dimension.clustering.minimum.match.score" bundle="dataEnrichmentMessages" />
							<span style = "color:red;font-size:18px">*</span>
						</div>
					</TD>
					<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
						<html:text property="minmatchscore" size="20" styleId="minmatchscore" styleClass="inputStyle" maxlength="20"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
	
				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='3' height='15'>&nbsp;&nbsp;
						<img NAME='DateFilterGroup_Image' ID='DateFilterGroup_Image' src='/expensemap/jsp/images/sdm/arrow_collapsed_icon.gif' border=0 align=bottom onclick="showHideDateFilterGroup(this, 'dateFilterGroup', '/expensemap/jsp/images/sdm/arrow_collapsed_icon.gif', '/expensemap/jsp/images/sdm/arrow_expanded_icon.gif')"  title='<bean:message key="ui.job.dimension.created.date.filter.icon.tooltip" bundle="dataEnrichmentMessages" />'> &nbsp;&nbsp;<bean:message key="ui.job.dimension.clustering.date.filter" bundle="dataEnrichmentMessages" />
					</TD>
				</TR>
				
				<TR id="dateFilterGroup" STYLE="display:none">
					<TD colspan="2" >
						<TABLE  CELLPADDING="0" CELLSPACING="0" BORDER="0" WIDTH="100%" >
							<TR>
								<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px;height:25px">
									<bean:message key="ui.job.dimension.clustering.nodes.created.date.header" bundle="dataEnrichmentMessages" />
								</TD>
								<TD>&nbsp;</TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
									<bean:message key="ui.job.dimension.clustering.date.attribute.filter" bundle="dataEnrichmentMessages" />
								</TD>
								<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
									<html:select  name="dimensionalClassificationwrtEDForm" property="createDateColumn" styleId="createDateColumn" styleClass="tabledata" onchange="createDateColumnChnage(this)">
										<html:options collection="createDateColumns" property="value" labelProperty="label"/>
									</html:select>
								</TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">&nbsp;</TD>
								<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
									<html:text property="nodeCreationDate" size="15" styleId="nodeCreationDate" styleClass="inputStyle" maxlength="10" disabled="true" readonly="true"/>&nbsp;
									<html:text property="nodeCreationDateHourMinute" size="5" styleId="nodeCreationDateHourMinute" styleClass="inputStyle" maxlength="5" value="0:00" disabled="true"/>
									&nbsp;<bean:message key="ui.job.dimension.gmt" bundle="dataEnrichmentMessages" />&nbsp;<%=new SimpleDateFormat("Z").format(new Date())%>&nbsp;&nbsp;&nbsp;<font size="1"><bean:message key="ui.dataEnrichment.datePattern" bundle='dataEnrichmentMessages' /></font>
								</TD>
							</TR>							
						</TABLE>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				
				<TR>
					<TD CLASS="POPFORMSPACER" colspan="2" STYLE="padding-left:3px">
						<img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='3' height='15'>&nbsp;&nbsp;
						<img src='/expensemap/jsp/images/sdm/arrow_expanded_icon.gif' border=0 align=bottom onclick="showHideDateFilterGroup(this, 'structureContentFilterGroup', '/expensemap/jsp/images/sdm/arrow_collapsed_icon.gif', '/expensemap/jsp/images/sdm/arrow_expanded_icon.gif')"  title='<bean:message key="ui.job.dimension.created.date.filter.icon.tooltip" bundle="dataEnrichmentMessages" />'> &nbsp;&nbsp;<bean:message key="ui.job.dimension.classification.using.dimension.structure.content.filter" bundle="dataEnrichmentMessages" />
					</TD>
				</TR>
				
				<TR id="structureContentFilterGroup">
					<TD colspan="2" >
						<TABLE  CELLPADDING="0" CELLSPACING="0" BORDER="0" WIDTH="100%" >							

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
									<bean:message key="ui.job.dimension.classification.using.dimension.structure" bundle="dataEnrichmentMessages" />
								</TD>
								<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:6px">
									<html:checkbox property="rememberExistingStructure" styleId="rememberExistingStructure" value="true" onclick="onRememberExistingStructure()"/>&nbsp;&nbsp;<bean:message key="ui.job.dimension.classification.using.dimension.remember.existing.structure" bundle="dataEnrichmentMessages" />									
								</TD>
							</TR>

							<TR>
								<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
							</TR>

							<TR>
								<TD CLASS="POPFORMLABEL" STYLE="padding-right:10px">
									<bean:message key="ui.job.dimension.classification.using.dimension.content" bundle="dataEnrichmentMessages" />
								</TD>
								<TD CLASS="POPFORMFIELD" width="60%" STYLE="padding-left:10px">
									<html:hidden property="content" styleId="content" value="unStructuredContent" />
									<bean:message bundle="dataEnrichmentMessages" key="ui.job.dimension.classification.using.dimension.un-structured.content"/>
								</TD>
							</TR>
						</TABLE>
					</TD>
				</TR>


				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
			</TABLE>
			<BR/>
			<DIV CLASS="POPFORMBUTTONS">
				<html:submit onclick="return onClickSaveForm();"><bean:message key="ui.job.dimension.classification.using.dimension.begin.dimensional.classification" bundle="dataEnrichmentMessages" /></html:submit>&nbsp;

				<html:button property="close" onclick="top.window.close();"><bean:message key="ui.close.button" bundle="sdmMessages" /></html:button>

				<INPUT TYPE="HIDDEN" name="operation" id="operation"/>

			</DIV>			
			<BR/>
			</TD></TR></TABLE>

			<DIV CLASS="POPFORMINSTRUCTIONS"><br><span style = "color:red;font-size:18px">*</span><bean:message key="ui.job.dimension.clustering.required.field" bundle="dataEnrichmentMessages" /></DIV>
		</TD>	
	</TR>
			
</TABLE>
</TD></TR></TABLE>
</html:form>


<script language="JavaScript">

	YAHOO.namespace('dimensional.classification.wrt.dimension');
	(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.dimensional.classification.wrt.dimension = {
		init: function() {
			var self = YAHOO.dimensional.classification.wrt.dimension;
			var jobExpDate = document.getElementById("jobExpirationDate");
			var nodeCreationDate = document.getElementById("nodeCreationDate");
			
			Event.on(jobExpDate, "focus", self.openCalendar, [jobExpDate, jobExpDate]);
			Event.on(nodeCreationDate , "focus", self.openCalendar, [nodeCreationDate, nodeCreationDate]);
		},

		openCalendar: function(e, args) {
			YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '','');
		}
	}
	
	Event.onDOMReady(YAHOO.dimensional.classification.wrt.dimension.init, YAHOO.dimensional.classification.wrt.dimension, true);
})();

</script>

</body>
</html:html>