<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page import="com.zeborg.util.WebUtil,com.zeborg.expensemap.view2.ZSession,com.zeborg.expensemap.view.ZSessionUtil,com.emptoris.viewer.feedback.FeedbackNodeVO"%>
<%@page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="org.apache.struts.Globals,java.util.Locale" %>
<%@ page import="com.zeborg.expensemap.view.HelpUtil, com.emptoris.viewer.util.CSRFHelper" %>
<%@ page import="com.emptoris.viewer.feedback.FeedbackConstants" %>
<%
WebUtil.addType(response, request);	
ZSession zs = ZSessionUtil.getFromSession(pageContext);
Locale locale = WebUtil.getAppLocale(pageContext);
request.getSession().setAttribute(Globals.LOCALE_KEY, locale);
boolean gskFeedback = ExpenseMapAppProperties.isEnableCustomFeedbackname();
HelpUtil emHelp = HelpUtil.getHelpUtil();
String moveNodeHelpURL="", moveSpendHelpURL="";

if (gskFeedback) {
	moveNodeHelpURL = emHelp.getHelpURLString(FeedbackConstants.GSK_FEEDBACK_MOVE_NODE_HELP, null);
	moveSpendHelpURL = emHelp.getHelpURLString(FeedbackConstants.GSK_FEEDBACK_MOVE_SPEND_HELP, null);
} else {
	moveNodeHelpURL = emHelp.getHelpURLString(FeedbackConstants.FEEDBACK_MOVE_NODE_HELP, locale);
	moveSpendHelpURL = emHelp.getHelpURLString(FeedbackConstants.FEEDBACK_MOVE_SPEND_HELP, locale);
}
%>
<HTML>
<HEAD>
<TITLE><bean:message key="ui.feedback.suggest.title" /></TITLE>
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css"/>
<STYLE TYPE="text/css">
	<!--
	.belowMast 	{ margin: 0 8 0 8 }
	.ResultsHeader { font-family:Arial; font-size:12px; color:#FFFFFF}
	.ResultsHeader1 { font-family:Arial; font-size:12px; color:#003366}
	.HeaderMessage { font-family:Arial; font-size:11px; color:#FFFFFF; text-align:left;}
	.TREENODE{ font-family: Arial, Helvetica, sans-serif; font-size: 11px; color: #000063; text-align:center; background-color: A5B6DE; }
	.tableData { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#0C209B; text-decoration:none; text-align:center}
	.errmsg { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:bold; color:red; text-decoration:none; text-align:left}
	.tableData1 { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#0C209B; text-decoration:none; text-align:left;}
	.columnHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #DEE2EA;}
	.columnHeadingStyleRight{ font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:right; background-color: #DEE2EA;}
	.rowHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left; background-color: #DEE2EA;}
	.rowHeadingStyleNew { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left;  background-color: #FFFFCC;}
	.cellStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #000000; text-align:right; }
	.checkStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #DEE2EA;}
	.checkStyleNew { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #FFFFCC;}
	.checkBoxStyle { HEIGHT: 12px; WIDTH: 12px; }
	A {color:#0000FF; text-decoration:none}
	A:LINK {color:#0000FF; text-decoration:none}
	A:ACTIVE {color:#0000FF; text-decoration:underline}
	A:VISITED {color:#0000FF; text-decoration:none}
	A:HOVER {color:#0000FF; text-decoration:underline}
	.dimTitle { font-family:sans-serif, Tahoma, Verdana, Geneva, Arial, Helvetica; font-size:12px; color:#003366; }
	.hand{cursor="hand"}
	-->
</STYLE>
<!-- Dependency --> 
<script src="/expensemap/jsp/javascript/yui/build/yahoo/yahoo-min.js" ></script>
<!-- Event source file -->
<script src="/expensemap/jsp/javascript/yui/build/event/event-min.js" ></script>

<script type="text/javascript">

	var sourceDimensionDesc='<bean:write name="feedbackCreateForm" property="sourceDimension"/>';
	var sourceDimensionDisplayName='<bean:write name="feedbackCreateForm" property="hidselectedNodeName"/>';
	function checkIsTopSelected(feedbackType,sourceDimension,sourceDimensionDisplayName)
	{
		var fromAdditionalFeedback = document.getElementById('fromAdditionalFeedback').value;
		var url='/expensemap/feedback/DimensionTreeSearchAction.do?feedbackType='+feedbackType+'&sourceDimension='+sourceDimension+'&prefix=/feedback&sourceDimensionDisplayName='+sourceDimensionDisplayName+'&fromAdditionalFeedback='+fromAdditionalFeedback;
		var topLevel = document.getElementById('isTopLevel');
		if(topLevel != null ){
			if(topLevel.checked){
				topLevel.checked=false;
				if(document.getElementById('selectedNodeName')) {
					document.getElementById("selectedNodeName").innerText='<bean:message key="ui.feedback.tree.icon.message"/>';
				}
			}
		}
		var midOfthescreen=screen.width/7;  		// modified for larger window size needed based on updates for PR 42498
		var midbotOfthescreen=screen.height/7;  	// modified for larger window size needed based on updates for PR 42498
		window.open(url,"",'width=720,height=600,scrollbars=yes,toolbar=no,status=no,resizable=yes,top='+midOfthescreen+',left='+midbotOfthescreen);
		return true;
		
	}

	function reloadMe(nodeInfo)
	{
	    var idNameLevelList = nodeInfo.split('nodeselector=');
		document.getElementById('targetNodeId').value= idNameLevelList[0];
		document.getElementById('targetNodeName').value=idNameLevelList[1];
		document.getElementById('targetNodeLevel').value=idNameLevelList[2];
  		document.getElementById('hidselectedNodeName').value=idNameLevelList[3];
  		document.getElementById('anchorNode').value=idNameLevelList[4];
  		document.getElementById('isNodeSpendZero').value=idNameLevelList[5];
		document.getElementById('parentFeedbackId').value=idNameLevelList[7];
		
		if(document.getElementById('selectedNodeSpendStr')&& idNameLevelList.length==8)
		{
			val=idNameLevelList[6].substr(0,idNameLevelList[6].length-1);
			document.getElementById('selectedNodeSpendStr').value=val;
		}
  		setValue();
	}
	function setValue(){
		document.getElementById('comment').focus();
		var value = document.getElementById('hidselectedNodeName').value;
		if(document.forms[0].isTopLevel)
		{
			if(document.forms[0].isTopLevel.checked){
				value = document.forms[0].dimensionDisplayName.value;
			}
		}
                if(document.getElementById('selectedNodeName'))
		{
					if(value=='')
			{
						value='<bean:message key="ui.feedback.tree.icon.message"/>';
			}
			document.getElementById('selectedNodeName').innerHTML=value;
		}
		if(value=='' || value==null || value=='null')value=' ';
		value = unEscapeBracket(value);
		if(document.getElementById('selectedNodeName')) {
			document.getElementById('selectedNodeName').innerHTML='&nbsp;'+ '<span>' + value + '</span>';
		}
		
		value = document.getElementById('anchorNode').value;
		if(value=='' || value==null || value=='null')value=' ';
		document.getElementById('anchorNode').value=value;
                if(document.getElementById('selectedNode'))
		{
			value = document.getElementById('hidselectedNodeName').value;
			selObj=document.getElementById('selectedNode');
			for(i=0;i<selObj.options.length;i++)
			{

				if(selObj.options[i].text==value)
				{
					selObj.options[i].selected=true;
				}
			}
		}
	}
	function storeSpendOfSelectedNode(spenStr)
	{
		document.getElementById('selectedNodeSpendStr').value=spenStr;
	}

	function setAction(action){

		var theForm = document.getElementById('FeedbackCreateForm');
		theForm.action = "/expensemap/feedback/ManageSuggestFeedbackAction.do";
		
		if(document.getElementById('selectedNode')&& 'cancel'!=action )
		{
			if(document.getElementById('selectedNode').value=='')
			{
				document.getElementById('errmsgplace').innerHTML=('<bean:message key="ui.feedback.error.msg"/>');
				return false;
			}
			if(document.getElementById('comment').value=='')
			{
				document.getElementById('errmsgplace').innerHTML=('<bean:message key="ui.feedback.error.msg"/>');
				return false;
			}
		}
		if('cancel'!=action )
		{
			if(document.getElementById('targetNodeId').value=='')
			{
				document.getElementById('errmsgplace').innerHTML=('<bean:message key="ui.feedback.error.msg"/>');
				return false;
			}
			if(document.getElementById('targetNodeId').value=='0' && document.getElementById('fromAdditionalFeedback').value=='true'){
				document.getElementById('errmsgplace').innerHTML=('<bean:message key="ui.error.new.node.for.additional.feedback"/>');
				return false;
			}
			if(document.getElementById('comment').value=='')
			{
				document.getElementById('errmsgplace').innerHTML=('<bean:message key="ui.feedback.error.msg"/>');
				return false;
			}
		document.getElementById("btnSubmit").disabled=true;
		}
		if(document.getElementById('selectedNodeName'))
		{
			document.getElementById('anchorStr').value=document.getElementById('selectedNodeName').innerHTML;
		}
		if(document.getElementById('selectedNode'))
		{
			document.getElementById('anchorStr').value=document.getElementById('targetNodeName').value;
		}
		
		document.getElementById('submitAction').value=action;
		theForm.submit();
	}
function handleHiddenFields()
	{
		if(document.forms[0].isTopLevel)
		{
			if(document.forms[0].isTopLevel.checked)
			{
				document.forms[0].targetNodeName.value=sourceDimensionDesc;
				document.forms[0].targetNodeId.value=0;
				document.forms[0].targetNodeLevel.value=0;
				if(document.getElementById('selectedNodeName')) {
					document.getElementById("selectedNodeName").innerHTML= '&nbsp;' + document.forms[0].dimensionDisplayName.value;
				}
				if(sourceDimensionDisplayName=='')
				{
					if(document.getElementById('selectedNodeName')) {
						document.getElementById("selectedNodeName").innerHTML='&nbsp;'+document.forms[0].dimensionDisplayName.value;
					}
				}

			}else
			{
				document.forms[0].targetNodeName.value=sourceDimensionDesc;
				document.forms[0].targetNodeId.value="";
				document.forms[0].targetNodeLevel.value="";
				if(document.getElementById('selectedNodeName')) {
					document.getElementById("selectedNodeName").innerHTML='<bean:message key="ui.feedback.tree.icon.message"/>';
				}
			}
		}
	}
	
	function unEscapeBracket( str) {
	    var from = "<";
	    var to = "&lt;";
	    var idx = str.indexOf( from );
	    while ( idx > -1 ) {
	        str = str.replace( from, to ); 
	        idx = str.indexOf( from );
	    }
	    return str;
	}
	YAHOO.util.Event.onDOMReady(setValue);
</script>

</HEAD>

<BODY LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">
<DIV ALIGN=CENTER>
<html:form action="/ManageSuggestFeedbackAction" styleId="FeedbackCreateForm">
<TABLE width=570 CELLSPACING="0" CELLPADDING="0" border="0" >
<TR><td colspan="3" nowrap><img src="/expensemap/jsp/images/transparent.gif" height=10 border=0></td></TR>
	<TR>
	   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
	   <td class="error" colspan="2">
	 	<logic:notPresent name="org.apache.struts.action.ERROR">
				<html:messages id="msg" message="true">
					<b><bean:write name="msg" /></b>
				</html:messages>
		</logic:notPresent>
			<b><html:errors/></b>
	  </td>
</TR>
<TR>
   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
   <td nowrap>
   <table border=0 cellpadding=2 cellspacing=0  WIDTH="100%"
                  bgcolor="<bean:write name="feedbackCreateForm" property="searchColor"/>" >
    <TR CLASS="ResultsHeader">
		<td style="font-family:Arial; color:#003366;align:center" height="25" nowrap id="dispname"></td>
		<TD style="font-family:Arial; color:#003366;align:center" height="25" nowrap>&nbsp;&nbsp;
			<logic:equal name="feedbackCreateForm" property="feedbackType" value="Move">
			<!--  42508 if enable custom names for feedback options is true display custom name else display localized default name -->
			<%if(!ExpenseMapAppProperties.isEnableCustomFeedbackname()) {%>
				<b><bean:message key="ui.feedback.page.move.title"/></b>
			<%}else{ %>
				<b><%=ExpenseMapAppProperties.getFeedbackTypeMove() + " "%><bean:message key="ui.feedback.page.feedbackRequest"/></b>
			<%} %>		
			<A TARGET="_blank" HREF="<%=moveNodeHelpURL%>">
			<IMG SRC="/expensemap/jsp/images/help.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<bean:message key='ui.label.Help'/>"></A>
			</logic:equal>
			<logic:equal name="feedbackCreateForm" property="feedbackType" value="Map">
			<!--  42508 if enable custom names for feedback options is true display custom name else display localized default name -->
			<%if(!ExpenseMapAppProperties.isEnableCustomFeedbackname()) {%>
				<b><bean:message key="ui.feedback.page.map.title"/></b>
			<%}else{ %>
				<b><%=ExpenseMapAppProperties.getFeedbackTypeMap() + " "%><bean:message key="ui.feedback.page.feedbackRequest"/></b>
			<%} %>			
			<A TARGET="_blank" HREF="<%=moveSpendHelpURL%>">
			<IMG SRC="/expensemap/jsp/images/help.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<bean:message key='ui.label.Help'/>"></A>
			</logic:equal>
			
		</TD>
	</TR>
	</TABLE>
  </TD>
  <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
</TR>
<html:hidden property="feedbackType" styleId="feedbackType" />
<html:hidden property="sourceDimension" styleId="sourceDimension" />
<html:hidden property="previousDim" styleId="previousDim" />
<logic:notEmpty name="feedbackCreateForm" property="previousDim">
<INPUT TYPE="hidden" NAME="Additional" value="true" id="Additional"/>
</logic:notEmpty>
<html:hidden property="operation" styleId="operation" />
<html:hidden property="submitAction" styleId="submitAction" />
<html:hidden property="searchColor" styleId="searchColor" />
<html:hidden property="dimensionDisplayName" styleId="dimensionDisplayName" />
<html:hidden property="anchorStr" styleId="anchorStr" />
<html:hidden property="selectedNodeSpendStr" styleId="selectedNodeSpendStr" />

<TR>
   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>

   <TD>
	<TABLE WIDTH="100%" CELLSPACING="0" CELLPADDING="0" border="0" >
	  <TR><td nowrap><img src="/expensemap/jsp/images/transparent.gif" height=5 border=0></td></TR>
	  <TR><td>
<!--  source node display table start -->	
      <TABLE WIDTH="100%" CELLSPACING="0" CELLPADDING="0">	
		<tr>
			<td>
				<TABLE WIDTH="100%" CELLSPACING="0" CELLPADDING="0" BGCOLOR="#000063">	
						<TR CLASS="ResultsHeader">
						   <td CLASS="ResultsHeader" align="left" height="25" nowrap><b>&nbsp;&nbsp;<bean:message key="ui.label.mainViewMode.Source"/>&nbsp;&nbsp;</b></td>
						</TR>
		        	</TABLE>
			</td>
		</tr>
		<TR>
			<logic:notEmpty name="feedbackCreateForm" property="sourceNodes">
			<TD>
			<div id="theSourceNodes" style=" height:125;overflow-y:scroll;  border:1px outset;">
			            <table border=0 cellpadding=1 cellspacing=0 WIDTH="100%">
							<tr WIDTH="100%">
			        			<td CLASS="columnHeadingStyle"><bean:write name="feedbackCreateForm" property="displayNameOfFullname"/>&nbsp;</td>
			        			<td CLASS="columnHeadingStyle"><bean:message key="ui.label.level"/>&nbsp;</td>
				   				<logic:iterate id="mName" name="feedbackCreateForm" property="measureDisplayNames">
							 	<td CLASS="columnHeadingStyle"><bean:write name="mName"/>&nbsp;</td>
				   				</logic:iterate>
							</tr>
							   <logic:iterate id="item" name="feedbackCreateForm" property="sourceNodes" 
							     type="com.emptoris.viewer.feedback.FeedbackNodeVO">
							  <tr WIDTH="100%">
							     <td CLASS="tabledata"><bean:write name="item" property="nodeName"/>&nbsp;</td>
							     <!-- 44211 level count will start from 0 -->
							     <td CLASS="tabledata"><%= item.getLevel()-1 %>&nbsp;</td>
							     <logic:iterate id="mValue" name="item" property="measureValuesForDisplay">
							     <td CLASS="tabledata"><bean:write name="mValue"/>&nbsp;</td>
							     </logic:iterate>
							 </tr>				
							 </logic:iterate>
<logic:notEmpty name="feedbackCreateForm" property="previousFeedbackTarget">
							  <tr>
									<td class="tabledata1"><B><bean:message key="ui.feedbak.label.source.derived.from"/></B>&nbsp;</td>
									<td>&nbsp;</td>
									<logic:iterate id="mName" name="feedbackCreateForm" property="measureDisplayNames">
									<td >&nbsp;</td>
									</logic:iterate>
								</tr>
								<tr WIDTH="100%">
									<td CLASS="columnHeadingStyle"><bean:message key="ui.feedback.fullname.label"/>&nbsp;</td>
									<td CLASS="columnHeadingStyle"><bean:message key="ui.label.level"/>&nbsp;</td>
									<logic:iterate id="mName" name="feedbackCreateForm" property="measureDisplayNames">
									<td CLASS="columnHeadingStyle"><bean:write name="mName"/>&nbsp;</td>
									</logic:iterate>
								</tr>
								   <bean:define name="feedbackCreateForm" id="nodeVo" property="previousFeedbackTarget" type="com.emptoris.viewer.feedback.FeedbackNodeVO"/>
								  <tr WIDTH="100%">
									  <td CLASS="tableData"><bean:write name="feedbackCreateForm" property="previousDim"/> ><%=nodeVo.getNodeName().replaceAll("&gt;",">")%>&nbsp;</td>
									 <td CLASS="tabledata"><bean:write name="nodeVo" property="level"/>&nbsp;</td>
									 <logic:iterate id="mValue" name="nodeVo" property="measureValuesForDisplay">
									 <td CLASS="tabledata"><bean:write name="mValue"/>&nbsp;</td>
									 </logic:iterate>
								 </tr>
				  
			  </logic:notEmpty>
						</table>
           </div>
           </TD>
           </logic:notEmpty>
           <logic:empty name="feedbackCreateForm" property="sourceNodes">
              <td height="25" CLASS="tabledata1"><bean:message key="ui.feedback.suggest.map.nosource" /></td>
              <logic:notEmpty name="feedbackCreateForm" property="previousFeedbackTarget">
			  <tr>
			  <td>
			  <table WIDTH="100%">
				 <tr WIDTH="100%">
					<td class="tabledata1"><B><bean:message key="ui.feedbak.label.source.derived.from"/></B>&nbsp;</td>
					<td>&nbsp;</td>
					<logic:iterate id="mName" name="feedbackCreateForm" property="measureDisplayNames">
					<td >&nbsp;</td>
					</logic:iterate>
				</tr>
				<tr WIDTH="100%">
					<td CLASS="columnHeadingStyle"><bean:message key="ui.feedback.fullname.label"/>&nbsp;</td>
					<td CLASS="columnHeadingStyle"><bean:message key="ui.label.level"/>&nbsp;</td>
					<logic:iterate id="mName" name="feedbackCreateForm" property="measureDisplayNames">
					<td CLASS="columnHeadingStyle"><bean:write name="mName"/>&nbsp;</td>
					</logic:iterate>
				</tr>
				   <bean:define name="feedbackCreateForm" id="nodeVo" property="previousFeedbackTarget" type="com.emptoris.viewer.feedback.FeedbackNodeVO"/>
				  <tr WIDTH="100%">
					  <td CLASS="tableData"><bean:write name="feedbackCreateForm" property="previousDim"/> ><%=nodeVo.getNodeName().replaceAll("&gt;",">")%>&nbsp;</td>
					 <td CLASS="tabledata"><bean:write name="nodeVo" property="level"/>&nbsp;</td>
					 <logic:iterate id="mValue" name="nodeVo" property="measureValuesForDisplay">
					 <td CLASS="tabledata"><bean:write name="mValue"/>&nbsp;</td>
					 </logic:iterate>
				 </tr>
				  
			  </table>
			  </td>
			  </tr>
			  </logic:notEmpty>
           </logic:empty>
		</TR>
		</TABLE>	
<!--  source node display table end -->	
        </td></TR>	
		<TR><td nowrap><img src="/expensemap/jsp/images/transparent.gif" height=10 border=0></td></TR>
		<TR><td nowrap><img src="/expensemap/jsp/images/transparent.gif" height=10 border=0></td></TR>
				<TR><td colspan="3" nowrap id="errmsgplace" class="errmsg"></td></TR>
<!--  destination node display table end -->	
		<TABLE WIDTH="100%" CELLSPACING="1" CELLPADDING="1" border="0">	
		<tr>
			<td colspan="2">
					<TABLE WIDTH="100%" CELLSPACING="0" CELLPADDING="0" BGCOLOR="#000063">	
						<TR CLASS="ResultsHeader">
						   <td CLASS="ResultsHeader" align="left" height="25" nowrap><b>&nbsp;&nbsp;<bean:message key="ui.feedback.destination.label"/>&nbsp;</b></td>
						</TR>
		        	</TABLE>
			</td>
		</tr>
		<logic:notEqual name="feedbackCreateForm" property="feedbackType" value="Map">
		  <logic:greaterThan name="feedbackCreateForm" property="sourceLevel" value="1" >
			<tr>
				<td rowspan="2" height="25" class="columnHeadingStyleRight" nowrap><bean:message key="ui.feedback.selected.target"/>&nbsp;<span id="dispname1"></span><FONT COLOR="red">*</FONT></td>
				<td height="25" class="tabledata1" ><html:checkbox name="feedbackCreateForm" onclick="handleHiddenFields()" styleId='isTopLevel' property="isTopLevel"/>&nbsp;<bean:message key="ui.feedback.processing.movetoplevel"/>&nbsp;<U><bean:message key="ui.feedback.processing.or"/></U></td>
			</tr>
		</logic:greaterThan>
		</logic:notEqual>
		<tr>
		 <logic:lessThan name="feedbackCreateForm" property="sourceLevel" value="2" >
				<td height="25" CLASS="columnHeadingStyleRight" nowrap><bean:message key="ui.feedback.selected.target"/>&nbsp;<span id="dispname1"></span>><FONT COLOR="red">*</FONT></td>
		</logic:lessThan>
		<logic:equal name="feedbackCreateForm" property="feedbackType" value="Map">
			<logic:greaterThan name="feedbackCreateForm" property="sourceLevel" value="1" >
				<td height="25" CLASS="columnHeadingStyleRight" nowrap><bean:message key="ui.feedback.selected.target"/>&nbsp;<span id="dispname1"></span><FONT COLOR="red">*</FONT></td>
			</logic:greaterThan>
		</logic:equal>
		<logic:empty name="feedbackCreateForm" property="searchResults">
		<td nowrap CLASS="tabledata1">&nbsp;<img CLASS="hand" onclick="checkIsTopSelected('<bean:write name="feedbackCreateForm" property="feedbackType"/>','<bean:write name="feedbackCreateForm" property="sourceDimension"/>','<bean:write name="feedbackCreateForm" property="sourceDimensionDisplayName"/>')" src="/expensemap/jsp/feedback/images/dimension_tree.gif" />&nbsp;<span id="selectedNodeName" CLASS="tabledata1"><bean:message key="ui.feedback.tree.icon.message"/>&nbsp;</span></td>
		</logic:empty>
		<logic:notEmpty name="feedbackCreateForm" property="searchResults">
						<td>
						<%String zeroSpendValue = "false"; 
						  String spendStr="";
						%>
						
						<select name="selectedNode" onchange="reloadMe(this.value)">
						<option value=''>Select</option>
						<logic:iterate id="feedbackNodeVO" name="feedbackCreateForm" property="searchResults" 
							     type="com.emptoris.viewer.feedback.FeedbackNodeVO">
						<%
							spendStr="";
						%>

								 <logic:iterate id="eachMeasureValue" name="feedbackNodeVO" property="measureValuesForDisplay">
								 <% spendStr =spendStr+eachMeasureValue+"~";
								   %>
	      				    <logic:equal name="eachMeasureValue" value="0">
		      					   <%zeroSpendValue = "true"; %>
							</logic:equal>
							</logic:iterate>
						<option value="<esapi:html><%=String.valueOf(feedbackNodeVO.getNodeId())%></esapi:html>nodeselector=<esapi:html><%=feedbackNodeVO.getNodeName()%></esapi:html>nodeselector=1nodeselector=<esapi:html><%=feedbackNodeVO.getNodeName()%></esapi:html>nodeselector=<esapi:html><%=feedbackNodeVO.getAnchorStr()%></esapi:html>nodeselector=<esapi:html><%=zeroSpendValue%></esapi:html>nodeselector=<esapi:html><%=spendStr%></esapi:html>nodeselector=<esapi:html><%=feedbackNodeVO.getFeedbackId()%></esapi:html>"><esapi:html><%=feedbackNodeVO.getNodeName()%></esapi:html></option>
						</logic:iterate>
						</td>
					</logic:notEmpty>
		</tr>
						<html:hidden property="targetNodeName" styleId="targetNodeName" />
						<html:hidden property="targetNodeId" styleId="targetNodeId"/>
						<html:hidden property="targetNodeLevel" styleId="targetNodeLevel"/>
						<html:hidden property="hidselectedNodeName" styleId="hidselectedNodeName"/>
						<html:hidden property="anchorNode" styleId="anchorNode"/>
						<html:hidden property="isNodeSpendZero" styleId="isNodeSpendZero"/>
						<html:hidden property="parentFeedbackId" styleId="parentFeedbackId"/>
					
					

				<logic:equal name="feedbackCreateForm" property="feedbackType" value="Map">
				   <logic:equal name="feedbackCreateForm" property="weightBoxVisible" value="true">
					<tr>
		  				<td height="25" CLASS="columnHeadingStyleRight"><bean:message key="ui.feedback.processing.weight"/>&nbsp;</td>
		  				<td height="25" CLASS="tabledata1">&nbsp;<html:text name="feedbackCreateForm" property="weight"/></td>
			        </tr>
			       </logic:equal>
			       <logic:notEqual name="feedbackCreateForm" property="weightBoxVisible" value="true">
			         <html:hidden property="weight" styleId="weight"/>
			       </logic:notEqual>
			    </logic:equal>
					<tr>
		  				<td height="25" CLASS="columnHeadingStyleRight"><bean:message key="ui.feedback.processing.comment"/>&nbsp;<FONT COLOR="red">*</FONT></td>
		 				<td height="25" CLASS="tabledata1">&nbsp;<html:textarea rows="4" cols="55" name="feedbackCreateForm" styleId="comment" property="comment"/></td>
					</tr>
		<TR><td colspan="2"><img src="/expensemap/jsp/images/transparent.gif" height=5 border=0></td></TR>
		<TR>
		  <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
		  <td class="tableData">
		    <html:button property="submitAction" styleId="btnSubmit" onclick="return setAction('submit');"><bean:message key="button.submit"/> &nbsp;</html:button>
		    <html:button property="submitAction" onclick="return setAction('cancel');"><bean:message key="ui.label.Cancel"/>&nbsp;&nbsp;</html:button>
		  </td>
		</TR>
		</TABLE>

<!--  destination node display table end -->	
        </td></TR>	
	</TABLE>
    </TD>
    <td><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
</TR>
</TABLE>
<input type="hidden" id="fromAdditionalFeedback" name="fromAdditionalFeedback" value="<esapi:htmlatt>${param.fromAdditionalFeedback}</esapi:htmlatt>"/>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</html:form>
<script type="text/javascript">

	var dispName=unescape('<bean:write name="feedbackCreateForm" property="dimensionDisplayName"/>');
	document.getElementById("dispname").innerHTML='<b>&nbsp;&nbsp;&nbsp;'+dispName+'</b>';
	if(document.getElementById("dispname1")){
		document.getElementById("dispname1").innerHTML='<b>&nbsp;&nbsp;&nbsp;'+dispName+'</b>';
	}		
</SCRIPT>
</DIV>
</BODY>
</HTML>