<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>

<%@ page import="com.zeborg.util.WebUtil,com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="org.apache.struts.Globals,java.util.Locale" %>
<%@ page import="com.zeborg.expensemap.view.HelpUtil" %>
<%@ page import="com.emptoris.viewer.feedback.FeedbackConstants" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="java.util.Locale, com.emptoris.viewer.util.CSRFHelper"%>
<%
ZSession zs = ZSessionUtil.getFromSession(pageContext);
Locale locale = zs.getUser().getLocale();
WebUtil.addType(response, request);	
request.getSession().setAttribute(Globals.LOCALE_KEY, locale);
String helpURL ="";
boolean gskFeedback = ExpenseMapAppProperties.isEnableCustomFeedbackname();

HelpUtil emHelp = HelpUtil.getHelpUtil();

if(gskFeedback) {
	helpURL = emHelp.getHelpURLString(FeedbackConstants.GSK_FEEDBACK_RENAME_NODE_HELP, null);
} else {
	helpURL = emHelp.getHelpURLString(FeedbackConstants.FEEDBACK_RENAME_NODE_HELP, locale);
}   
%>
<HTML>
<HEAD>
<TITLE><bean:message key="ui.feedback.page.rename.title" /></TITLE>
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">
<STYLE TYPE="text/css">
	<!--
	.belowMast 	{ margin: 0 8 0 8 }
	.ResultsHeader { font-family:Arial; font-size:12px; color:#FFFFFF}
	.ResultsHeader1 { font-family:Arial; font-size:12px; color:#003366}
	.HeaderMessage { font-family:Arial; font-size:11px; color:#003366}
	.TREENODE{ font-family: Arial, Helvetica, sans-serif; font-size: 11px; color: #000063; text-align:center; background-color: A5B6DE; }
	.tableData { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#0C209B; text-decoration:none; text-align:left}
	.tableData2 { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#FFFFE0; text-decoration:none; text-align:left}
	.columnHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left; background-color: #DEE2EA;}
	.columnHeadingStyle1{ font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left; background-color: #DEE2EA;}
	.rowHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left; background-color: #DEE2EA;}
	.rowHeadingStyleNew { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left;  background-color: #FFFFCC;}
	.cellStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #000000; text-align:right; }
	.checkStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #DEE2EA;}
	.checkStyleNew { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #FFFFCC;}
	.checkBoxStyle { HEIGHT: 12px; WIDTH: 12px; }
	A {color:#0000FF; text-decoration:none}
	A:LINK {color:#0000FF; text-decoration:none}
	A:ACTIVE {color:#0000FF; text-decoration:underline}
	A:VISITED {color:#0000FF; text-decoration:none}
	A:HOVER {color:#0000FF; text-decoration:underline}
	.dimTitle { font-family:sans-serif, Tahoma, Verdana, Geneva, Arial, Helvetica; font-size:12px; color:#003366; }
	.errmsg { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:bold; color:red; text-decoration:none; text-align:left}
	-->
</STYLE>
</HEAD>
<BODY LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="init();">
<script type="text/javascript"> 
	function trim(str){
		var trimmed = str.replace(/^\s+|\s+$/g, '') ;
		return trimmed;
	}

	function setOperation(operation){

		var theForm = document.getElementById('FeedbackCreateForm');
		theForm.action = "/expensemap/feedback/SuggestNodeEditAction.do";
		
		if(operation=='submit'){
			if(!validate())	return false;
		document.getElementById("btnRename").disabled=true;
		/*
			This will validate user input with allowedChar inputs
		*/
			var iChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_0123456789~`!@#$%^&*()_-+=|}]{[\"':;?/>.<, ";
			var userInput = document.getElementById('nodeNewName');

			if(!validateAllowedCharacter(userInput, iChars)){
				document.getElementById('errmsgplace').innerHTML="<bean:message key='ui.feedback.no.special.char.error.msg'/>";
				return false;
			}
		}

		document.getElementById('operation').value=operation;
		document.getElementById('errmsgplace').innerHTML="";
		theForm.submit();
   }

   function validate(){
		if(trim(document.getElementById('comment').value)=='' || trim(document.getElementById('nodeNewName').value)==''){
			document.getElementById('errmsgplace').innerHTML="<bean:message key='ui.feedback.error.msg'/>";
			return false;
		}
		return true;
	}
	
	/*
		This metthod will validate user input with allowedChar inputs
	*/
	function validateAllowedCharacter(userInput, allowedChar){	
		if( typeof userInput != "undefined"){
			var userInputValue = userInput.value;
			for (var i = 0; i < userInputValue.length; i++) {
				if (allowedChar.indexOf(userInputValue.charAt(i)) == -1){
					userInput.focus();
					return false;
				}
			}
		}
		return true;
	}

	function init(){
		document.getElementById("nodeNewName").focus();
	}
	
</script>
<DIV ALIGN=CENTER>
<html:form action="/SuggestNodeEditAction" styleId="FeedbackCreateForm">
<TABLE width=570 CELLSPACING="0" CELLPADDING="0" border="0" >
<TR><td colspan="3"><img src="/expensemap/jsp/images/transparent.gif" height=10 border=0></td></TR>
<TR>
	   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
	   <td class="error" colspan="2">
	 	<html:messages id="msg" message="true">
		<b><bean:write name="msg" />
		</html:messages>
	  </td>
</TR>
<TR><td colspan="3" nowrap id="errmsgplace" class="errmsg"></td></TR>
<TR>
  <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
  <td nowrap>
   		<table border=0 cellpadding=2 cellspacing=0  WIDTH="100%"
                  bgcolor="<bean:write name="feedbackCreateForm" property="searchColor"/>" >
    		<TR CLASS="ResultsHeader">
				<td style="font-family:Arial; color:#003366;align:center" height="25" nowrap id="dispname">
					
				</td>
				  <td style="font-family:Arial; color:#003366;align:center" height="25" nowrap>&nbsp;&nbsp;
				  <!--  42508 if enable custom names for feedback options is true display custom name else display localized default name -->
				  <%if(!ExpenseMapAppProperties.isEnableCustomFeedbackname()) {%>
	  				  	<b><bean:message key="ui.feedback.page.rename.title"/></b>
	  			  <%}else{ %>				  
				  		<b><%=ExpenseMapAppProperties.getFeedbackTypeRename() + " "%><bean:message key="ui.feedback.page.feedbackRequest"/></b>
				  <%} %>		
						<A TARGET="_blank" HREF="<%=helpURL%>">
						<IMG SRC="/expensemap/jsp/images/help.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<bean:message key='ui.label.Help'/>"></A>
				  </td>
  		   </tr>
  		</table>
  </td>
  <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
</TR>
<logic:notEmpty name="feedbackCreateForm" property="sourceNodes">
<html:hidden property="operation" styleId="operation" />
<html:hidden property="sourceDimension" styleId="sourceDimension"/>
<html:hidden property="feedbackType" styleId="feedbackType"/>
<html:hidden property="searchColor" styleId="searchColor"/>
<html:hidden property="dimensionDisplayName" styleId="dimensionDisplayName"/>
<TR>
   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
   <TD>
	<TABLE WIDTH="100%" CELLSPACING="0" CELLPADDING="0" border="0" >
	  <TR><td>
      <TABLE WIDTH="100%" CELLSPACING="0" CELLPADDING="0">	
		  </td></TR>
	  <TR><td nowrap><img src="/expensemap/jsp/images/transparent.gif" height=5 border=0></td></TR>
	  <TR><td>
      <TABLE WIDTH="100%" CELLSPACING="0" CELLPADDING="0">	
		<tr>
			<td>
			<TABLE WIDTH="100%" CELLSPACING="0" CELLPADDING="0" BGCOLOR="#000063">	
				<TR CLASS="ResultsHeader">
					<td CLASS="ResultsHeader" align="left" height="25" nowrap>
					    <b>&nbsp;&nbsp;<bean:message key="ui.label.mainViewMode.Source"/>&nbsp;&nbsp;
					    </b>
					</td>
				</TR>
		    </TABLE>
			</td>
		</tr>
		<TR>
			<TD>
			<div id="theRenameNodes" style=" height:150;overflow-y:scroll; border:1px outset;">
			            <table border=0 cellpadding=0 cellspacing=0>
							
							<logic:iterate id="item" name="feedbackCreateForm" property="sourceNodes" 
							     type="com.emptoris.viewer.feedback.FeedbackNodeVO">
							 <tr>
							   <td CLASS="columnHeadingStyle"><bean:write name="item" property="nodeName"/></td>
							   <td CLASS="columnHeadingStyle"colspan="3">&nbsp;</td>
							 </tr>
				   			 <logic:iterate id="attrItem" name="item" property="attributesVO" 
		  									 type="com.emptoris.viewer.feedback.FeedbackNodeAttributeVO">
		  				
							     <tr>
							         <td CLASS="tabledata">&nbsp;</td>
									 <td CLASS="tabledata"><bean:write name="attrItem" property="attributeName"/>&nbsp;<FONT COLOR="red">*</FONT></td>
									 <logic:equal name="attrItem" property="attributeName" value="FULL_NM"> 
									    <td CLASS="tabledata">
									     <html:text name="feedbackCreateForm" maxlength="255"  styleId="nodeNewName" 
									        readonly="false" 
									        property='<%="renameResultMap("+ attrItem.getNodeId()+":"+attrItem.getAttributeName()+")"%>'/>
									    &nbsp;&nbsp;</td>
									 </logic:equal>
									 <logic:notEqual name="attrItem" property="attributeName" value="FULL_NM"> 
									    <td CLASS="tabledata">
									      <html:text name="feedbackCreateForm"  styleId="nodeNewName" 
									       readonly="true" 
									       property='<%="renameResultMap("+ attrItem.getNodeId()+":"+attrItem.getAttributeName()+")"%>'/>
									       &nbsp;&nbsp;
									    </td>
									 </logic:notEqual>
									 <td CLASS="tabledata"><bean:write name="attrItem" property="attributeValue"/>&nbsp;</td>
								 </tr>
							   </logic:iterate>			
							</logic:iterate>
						</table>
           </div>
		   </TD>
		</TR>
		</TABLE>	
<!--  source node display table end -->	
        </td></TR>	
		<TR><td nowrap><img src="/expensemap/jsp/images/transparent.gif" height=10 border=0></td></TR>
		<TR><td>
			<TABLE WIDTH="100%" CELLSPACING="1" CELLPADDING="1">
			<TR>
		      <td CLASS="columnHeadingStyle1"><bean:message key="ui.feedback.processing.comment"/>&nbsp;<FONT COLOR="red">*</FONT></td>
		  	  <td CLASS="tabledata">
		  		    <html:textarea rows="4" cols="60" name="feedbackCreateForm" property="comment" styleId="comment"/></td>
			</TR>
			</TABLE>
        </td></TR>	
	</TABLE>
		<BR>
		<center>
			<html:button property="operation" styleId="btnRename" onclick="setOperation('submit');"><bean:message key="button.submit"/></html:button>&nbsp;&nbsp;
			<html:button property="operation" onclick="setOperation('cancel');"><bean:message key="ui.label.Cancel"/></html:button>
	    </center>
    </TD>
   </TR>
</logic:notEmpty>
</TABLE>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</html:form>
</DIV>
</BODY>
<SCRIPT LANGUAGE="JavaScript">
<!--
		var dispName=unescape('<bean:write name="feedbackCreateForm" property="dimensionDisplayName"/>');
		document.getElementById("dispname").innerHTML='<b>&nbsp;'+dispName+'&nbsp;&nbsp;</b>'		
//-->
</SCRIPT>
</HTML>