<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties, java.util.List"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession,java.util.Date" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil,java.text.SimpleDateFormat, com.zeborg.acl.util.LocaleUtil"%>
<%@ page import="com.zeborg.expensemap.view.FormatUtil"%>
<%@ page import ="com.zeborg.acl.model.ACUser,com.zeborg.util.EncodeUtil" %>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>

<%
	// Set variables needed for display e.g. user name and build information.
	ACUser user = ((ZSession) request.getSession(false).getAttribute("ZSession")).getUser();
	String userNumberFormat = user.getNumberFormat();
	String dateString = new SimpleDateFormat(user.getDateFormat()).format(new Date());
	String pattern = "[^\\d]";	
	String userDateFormat = dateString.replaceAll(pattern, "_"); 
	
%>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/export.css" />
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript">

// Common method to open Export UI for csv/excel. This method is common for Dimension viewer, transaction export, analytic export, tabulation
// export and top reports export. Dashboard Export method is separate. this jsp is included in all these modules jsp's for export csv/excel function.

function openExportBox (reportName, crId, status,reportTypeId, remoteId, bookmarkId,analyticId) {
    dbNamePanel = new YAHOO.widget.Panel("newPanel", { width: "700px", fixedcenter: true, constraintoviewport: true, visible: false,modal:true,close:false} );
    var strHeader = getHeader(reportTypeId);
    dbNamePanel.setHeader('<span style="font-family: verdana, arial, helvetica, sans-serif;font-size:11px;font-color:black">'+ strHeader +'</span>');
    var saveAsLabel = "<bean:message key='ui.report.table.header.export' />";
    var cancelLabel = "<bean:message key='ui.label.Cancel' />";
	var level=getLevelsBydimId(reportName);
	var noOfRowsForDim = getNoOfRowsBydimId(reportName);
	reportName=unescape(trim(reportName));
	var levelStr='';
	for(i=1;i<=level;i++){	
		levelStr += '<option value='+i+'>'+ (i-1) +'</option>';
	}
	
	var numFormatStr = '';
	
	<% List<String> numFormats = FormatUtil.getNumberFormats(); 
	
	for (String numberFormat : numFormats) {%>
	
		<% if(userNumberFormat.equals(numberFormat) ){ %>		
		numFormatStr += '<option value="<%=numberFormat%>" selected ><%=numberFormat%></option>';
	<%} else { %>
		numFormatStr += '<option value="<%=numberFormat%>"><%=numberFormat%></option>';
	<%
			} //else
	}
	%>

	var bodyString = ''; 
	bodyString+='<table border=1 align="center" style="width:94%"><TR><td align="right" class="leftTD">'+"<bean:message key='ui.label.File.Name' />"+'<font color="red"> *</font></td><td class="rightTD" align="left"><input type="text" id="fileName" size="30" maxlength="50" value="' + reportName + '_<%=userDateFormat%>"/></td></tr>';
	bodyString+='<tr><td align="right" class="leftTD">'+ "<bean:message key='ui.label.file.type' />" + '</td>';
	bodyString+='<td class="rightTD"><table width="100%"><tr><td class="innerTD" style="width:20%"><input type="radio" name="fileType" id="fileTypeCsv" value="CSV" onclick="toggleOptionDiv(\'CSV\');">'+ "<bean:message key='ui.label.csv' />"+'<br />';
	bodyString+='<input type="radio" name="fileType" id="fileTypeXls" value="XLS" onclick="toggleOptionDiv(\'XLS\');" checked="true">'+"<bean:message key='ui.label.xls' />"+ '<br />';
	bodyString+='<span style="display: none" id="fileTypeXlsxSpan"><input type="radio" name="fileType" id="fileTypeXlsx" value="XLSX" onclick="toggleOptionDiv(\'XLXS\');">'+ "<bean:message key='ui.label.xlsx' />"+'</span><td>';
	bodyString+='<td class="innerTD"><span style="display: none; white-space: nowrap; position: relative;" id="unmergeXlsSpan"><input type="checkbox" name="chkunMergeCells" id="chkunMergeCells" value="chkunMergeCells" ><b style="font-size: 11px; position: absolute; top: 4px">'+ "<bean:message key='ui.label.unmerged.cell' />"+'</b></span>';
	bodyString+='<div id="dimensionOptionsDiv" ><table border=0 style="width:100%"><tr><td colspan=2>';
	bodyString+='<span class="propertyLabel">'+ "<bean:message key='ui.label.expand.to.level' />"+'</span>&nbsp;&nbsp;&nbsp&nbsp';
	bodyString+='<select  id="level"  name="level" class="selectStyle">'+levelStr+'</select>';
	bodyString+='</td></tr></table></div>';
	//second div
	bodyString+='<div id="dimensionNoOfRowsOptionsDiv"><table border=0 style="width:100%"><tr><td class="innerTD" id="nodesRowsTD">';
	bodyString+='<span class="propertyLabel">'+"<bean:message key='ui.label.nodes'/>"+'</span></td>';
	bodyString+='<td class="innerTD" style="border: 1px solid #cccccc; padding: 3px;"><input type="radio" name="nodeOptions"  id="nodeOptions" value="All" onclick="disableTextBox(\'All\',this);" >' + "<bean:message key='ui.label.export.all.nodes' />"+'&nbsp;';
	bodyString+='<input type="radio" name="nodeOptions" id="nodeOptions" value="Visible" onclick="disableTextBox(\'Visible\',this);" checked="true" >' + "<bean:message key='ui.label.Visible' />"+'&nbsp;';
	bodyString+='<input type="radio" name="nodeOptions" id="nodeOptions" value="Specify"  onclick="disableTextBox(\'Specify\',this);" >' + "<bean:message key='ui.label.export.specific.nodes' />"+ '&nbsp;';
	bodyString+='<input type="text" name="noOfRows" size="3" id="noOfRows" maxlength="5" disabled="true" value="'+ noOfRowsForDim + '"/>&nbsp;';
	bodyString+='</td></tr></table></div>';
	bodyString+='<input type="hidden" name="nodeOptionsValue" id="nodeOptionsValue" value="Visible" >';
	bodyString+='</td></tr></table></td></tr>';
	
	bodyString+='<tr id="trNumFormat"><td align="right" class="leftTD"><div id="lableNumberFormat">'+"<bean:message key='ui.label.number.format.for.export'/>" + '</div></TD>';
	bodyString+='<td class="rightTD"> <div id="drNumberFormat"> <select name="exportNumberFormat" id="exportNumberFormat" size="1">';
	bodyString+=numFormatStr;
	bodyString+='</select></div></td></tr>';
	bodyString+='</td></tr>';

	var methodParamsString = getParamString(reportName, crId, status, reportTypeId, remoteId, bookmarkId,analyticId);

	bodyString+='<tr><td colspan="2" class="buttons"><button onclick="'+methodParamsString+'">' + saveAsLabel + '</button>&nbsp;<button onclick="javascript:closeExportBox();">' + cancelLabel + '</button></td></tr></table>';
	
	dbNamePanel.setBody(bodyString);
	
	dbNamePanel.render(document.body);
	initDiv();
	dbNamePanel.show();
}

// Common method to disable No Of Rows text box for All and Visible types.  It will be only enabled for Specify option.
function disableTextBox(type, obj){
 	var noOfRows = document.getElementById("noOfRows");
 	document.getElementById("nodeOptionsValue").value = obj.value;
 	if (type == 'All' || type == 'Visible') {
		noOfRows.disabled = true;
 	} else {
		noOfRows.disabled = false; 	
 	}
}

// Close/hide Export UI
function closeExportBox(){
	var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
	dimensionOptionsDiv.style.visibility = 'hidden';
	var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
	dimensionNoOfRowsOptionsDiv.style.visibility = 'hidden';
	dbNamePanel.hide();
}

function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}


</script>