<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page import="java.util.*,java.io.PrintWriter,java.net.*,java.rmi.*,javax.naming.*,javax.rmi.*,java.text.*,
                   com.zeborg.acl.model.ACUser,
                   com.zeborg.cubem.model.CubeMeta,
                   com.zeborg.expensemap.model3.DataSet,com.zeborg.web.DefaultApplicationSession"
 %>
 <%@ page import="com.zeborg.util.*,com.zeborg.expensemap.util.*" %>
 <%@ page import="com.zeborg.expensemap.view.*,com.zeborg.expensemap.view2.*" %>
 <%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager" %>
 <%@ page import="org.owasp.esapi.ESAPI"%>
 <%@ include file="begin_page.jspf" %>
 <% response.setHeader("Expires", "Tue, 24 Oct 1996 17:42:00 GMT"); %>
<HTML>
<HEAD>
<fmt:setBundle basename="ExpensemapMessagesBundle" />

<%
	EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, locale);	
	String action = request.getParameter("theAction");	
	String title = "";
	//this file is used in dynamicView and crosstab print. We will get printTitle in request from dynamicView 
	//and for crosstabs printTitle is prepared in action.
	String printTitle = "";
	
	if(action!=null && action.equalsIgnoreCase("printReport")) {
		title = ExpenseMapAppProperties.getExpensemapTitle()+ " - " + bundle.getValue("ui.emptoris.title.printpreview")+request.getParameter("printTitle");
		if (request.getParameter("printTitle") != null) {
			printTitle = request.getParameter("printTitle");
		}
	} else if(action!=null && action.equalsIgnoreCase("printCrossTabReport")) {
		printTitle = ChartCrossTabUtil.getTitle(zs, request.getParameter("ctId"));
		title = ExpenseMapAppProperties.getExpensemapTitle()+ " - " + bundle.getValue("ui.emptoris.title.printpreview.crosstab")+printTitle;
		
	}
%>
<TITLE><%=ESAPI.encoder().encodeForHTML(title)%></TITLE>

<!--LINK REL="stylesheet" TYPE="text/css" HREF="stylesheets/print.css"-->
<LINK REL="stylesheet" TYPE="text/css" HREF="stylesheets/macromap.css">
<STYLE TYPE="text/css">
<!--
.columnHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #DEE2EA; }
.columnDataStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left; background-color: #DEE2EA; }
.breadCrumbHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left;}
.rowHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left; background-color: #DEE2EA; }
.checkStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #DEE2EA; }
.cellStyle { font-family: Arial, Helvetica, sans-serif; font-size: 11px; color: #000000; text-align:right; }
TD { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #000000; }
.POPTD {
		BORDER: gray 1px outset;
		border-collapse: collapse;
		font-family: Arial, Helvetica, sans-serif;
		font-size: 11px;
		color: 3333CC;
}
-->
.wrap {white-space:nowrap;border:1px outset gray;}
.nowrap {border:1px outset gray;}
.ar {border:1px outset gray;text-align:right;}
.bar {border:1px outset gray;background-color:#DEE2EA;text-align:right;}
.tb0 {border-collapse:collapse;border:1px outset gray;}
.ca {white-space:nowrap;border:1px outset gray;text-align:center;}
.wac {white-space:nowrap;border:1px outset gray;text-align:center;}
.war {white-space:nowrap;border:1px outset gray;text-align:right;font-weight: bold;}
.wac_bold {white-space:nowrap;border:1px outset gray;text-align:center;font-weight: bold;}
</STYLE>
</HEAD>

<BODY LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">

<%

	ACUser u = zs.getUser();
	CubeMeta c = zs.getCubeMeta();
	DataSet ds = zs.getDataSet();
	PrintWriter pout = new PrintWriter(out,true);	
%>


<c:set var="userDatePattern" value="<%=u.getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=u.getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	

<!--DIV ID="totalPage" CLASS="alignTop"-->

<%-- build the masthead --%>
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>

<BR>

<SPAN CLASS="printTitle"><fmt:message key ='ui.emptoris'/>: <%=ESAPI.encoder().encodeForHTML(printTitle)%></SPAN>
<BR>
<BR>

<%
		// check what type of print action we should perform
		String theAction = request.getParameter("theAction");
		if( theAction != null ){
				if( theAction.equalsIgnoreCase("printReport") ){  // prints individual reports from the view
						// show the bread crumbs and print out the report
%>			<jsp:include page="../Export.do?operation=exportPrint&dimension=${param.dimension}" flush="true" />
<%
			   }else if( theAction.equalsIgnoreCase("printCrossTabReport") ){
%>
 			<jsp:include page="../Export.do?operation=exportCrossTabPrint" flush="true" />
<%
			}
	}
%>
<BR>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0">
		<TR>	<!-- 43568 - get value for report prepared for text from expensemap.application.properties -->
				<TD CLASS="breadcrumb" ALIGN="right"><b><fmt:message key ='ui.label.Report.Prepared.for.Text'/></b>&nbsp;</TD>
				<TD CLASS="breadcrumb">&nbsp;<%=u.getDisplayName()%></TD>				
		</TR>
		<TR>
				<TD CLASS="breadcrumb" ALIGN="right"><fmt:message key ='ui.label.Company.'/>&nbsp;</TD>
				<TD CLASS="breadcrumb">&nbsp;<%=ds.getAcCompany().getName()%></TD>
		</TR>
		<TR>
				<TD CLASS="breadcrumb" ALIGN="right"><fmt:message key ='ui.label.Emptoris.Source.'/>&nbsp;</TD>
				<TD CLASS="breadcrumb">&nbsp;<%=ds.getDisplayName()%></TD>
		</TR>
		<TR>
				<TD CLASS="breadcrumb" ALIGN="right"><fmt:message key ='ui.label.History.'/>&nbsp;</TD>
				<%
					if (ds.getHistoryNotes()==null){
				%>
				<TD CLASS="breadcrumb">&nbsp;</TD>
				<%}else{%>
				<TD CLASS="breadcrumb">&nbsp;<%=ds.getHistoryNotes()%></TD>
				<%}%>
		</TR>
		<TR>
				<TD CLASS="breadcrumb" ALIGN="right"><fmt:message key ='ui.label.Description.'/>&nbsp;</TD>
				
				<TD CLASS="breadcrumb">&nbsp;<%= ds.getDescription()%></TD>
		</TR>
		<TR>
				<TD CLASS="breadcrumb" ALIGN="right"><fmt:message key ='ui.label.Date.Printed.'/>&nbsp;</TD>
				<TD CLASS="breadcrumb">&nbsp;<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" value="<%= new Date() %>"  /></TD>
		</TR>
<tr><td>&nbsp;</td></tr>
</TABLE>
</BODY>
</HTML>

<%@ include file="end_page.jspf"%>