<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil,com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<%	 
	//make url for help page    
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = "To be done";		
%>


<HTML>
	<HEAD>
	<TITLE><%=ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="apply.rule.page.title" bundle="ruleMessage" /> </TITLE>

	<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/scripts/sdm.css">
	<script src = "/expensemap/jsp/javascript/dataenrichment.js"></script>
		
	<script type="text/javascript">

		var popUpRefArr = [];
			
		function isAnyFeedbackTypeChecked(){
			var theForm = document.getElementById("applyRulePage");			
			if(!(theForm.addEnable.checked 
				|| theForm.mapEnable.checked
				|| theForm.renameEnable.checked
				|| theForm.moveEnable.checked)){							
				alert("<bean:message key='apply.rule.select.atleast.one.feedback.msg' bundle='emMessages'/>");			
				return false;
			}
			
			if(theForm.mapEnable.checked){
				if(!theForm.applysequentialMapRules.checked){
					if(!(theForm.weightSelected.checked 
						|| theForm.timeSelected.checked
						|| theForm.addNodeDepthSelected.checked
						|| theForm.specificitySelected.checked)){							
						alert("<bean:message key='ui.online.feedback.strategy.requied' bundle='emMessages'/>");			
						return false;
					}
				}
			}
			
			alert("<bean:message key='apply.rule.submit.rule.msg' bundle='ruleMessage'/>");
			
			if( document.getElementById('applyRuleOptionalPage').style.display=='table-row-group'){
				theForm.specificityCondition[0].disabled=false;
				theForm.specificityCondition[1].disabled=false;
				theForm.timeCondition[0].disabled=false;
				theForm.timeCondition[1].disabled=false;
				theForm.addNodeDepthCondition[0].disabled=false;
				theForm.addNodeDepthCondition[1].disabled=false;
				theForm.weightSelected.disabled = false;
				theForm.timeSelected.disabled = false;
				theForm.addNodeDepthSelected.disabled=false;
				theForm.specificitySelected.disabled=false;				
				theForm.time.disabled=false;
				theForm.weight.disabled=false;
				theForm.specificity.disabled=false;
				theForm.addNodeDepth.disabled=false;

			}
			return true;
		}

		function  chooseStrategy(){
			var url = "/expensemap/rulemanagement/ConflictResolutionStrategyAction.do?method=listConflictResolutionStrategy&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
			var ht = 650;
	        var wt = 700;
			var left = (screen.width/2)-(wt/2);
			var top = (screen.height/2)-(ht/2);      			
			var popUpObj = window.open(url, 'conflict_Strategy_Window','resizable=no,width='+wt+',height='+ht+',left='+left+',top='+top);	
			popUpRefArr.push(popUpObj);			
		}

		function showHide(childrenGroupId){		
			var childGroupObj = document.getElementById(childrenGroupId);
			var show = false;
			if(childGroupObj != null && typeof childGroupObj != 'undefined'){
				show = childGroupObj.style.display == 'none';
			}
			if(show){
				childGroupObj.style.display = 'table-row';
				
			}else{
				childGroupObj.style.display = 'none';				
			}
		}

		function enableSequentialMapping(){
			var theForm = document.getElementById("applyRulePage");
			theForm.applysequentialMapRules.disabled=(!theForm.mapEnable.checked);
		}
		
		function hideOptionalPage(){
			var obj = document.getElementById('applyRuleOptionalPage');
			if(obj.style.display=='table-row-group'){
				obj.style.display='none';
			}
		}

	</script>
	
	<script type="text/javascript">
	//submit the ajax request
		function submitRequest(operation, selectTag){
			if(selectTag.checked){
				try {
					var argStr = "method=" + operation
					var url = "/expensemap/rulemanagement/ApplyRuleAction.do?" + argStr + "&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
					
					var ajaxResponse = jQuery.ajax({
					url: url,
					type: "post",
					error: function(xhr, status, error) {
						alert('Error: ' + xhr.statusText);
						return false;
					},
					async: false					
				}).responseText;
				responseHandler(ajaxResponse);
				} catch(e) {
					 alert(e);
				}
			}else{
				var obj = document.getElementById('factTR');
				obj.style.display = 'none';
				var factCreatedDate = document.getElementById("factCreatedDate");
				for( i=0; i < factCreatedDate.options.length;){
					factCreatedDate.options[i]=null;
				}
			}			
		}

		//handle the ajax response
		function responseHandler(response) {    
			
				var data = eval(response);
				
				// If there is no data in the response, ignore this
				if (data == null) {
					return;
				} else if( data[0]=="showTransactionDates") {

					var factCreatedDate = document.getElementById("factCreatedDate");
					for( i=0; i < factCreatedDate.options.length;){
						factCreatedDate.options[i]=null;
					}

					for(i=1 ; i<data.length ; i=i+2){
						factCreatedDate.options[factCreatedDate.options.length] = new Option(data[i], data[i+1]);
					}
					if(factCreatedDate.options.length > 0){
						factCreatedDate.options[0].selected=true;
					}
					var obj = document.getElementById('factTR');
					obj.style.display = 'table-row';					
				}
			
		}
	
	</script>
	
</HEAD>
		<BODY onunload="closePopUp(popUpRefArr);">
		<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>					
		
		<logic:messagesPresent message="true">
			<font color="red" face="Arial, Helvetica, sans-serif" size="2">
				<b><html:messages id="msg" message="true" bundle="ruleMessage">
					&nbsp;&nbsp;&nbsp;<%=pageContext.findAttribute("msg")%>
				</html:messages></b>
			</font>
		</logic:messagesPresent>
							
			<html:form styleId="applyRulePage" action="/ApplyRuleAction.do?method=submitApplyRuleJob" method="post">
				<table class="InnerTableWithBorder" cellSpacing="0" align="center" cellPadding="0"  border="0" >
					<tr style="padding-left: 3px">
						<TD CLASS="reportTitle"  width="50%" align="left"><bean:message key="apply.rule.feedback.input.title" bundle="ruleMessage"/></TD>
					</tr>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<td class="POPFORMLABEL"></td>
					<TD CLASS="POPFORMFIELD" WIDTH="60%">
					   <c:choose>
							<c:when test="${requestScope.isAddEnabled}">
								<html:checkbox property="addEnable" />
							</c:when>
							<c:otherwise>
								<html:checkbox property="addEnable"  disabled="true"/>
							</c:otherwise>
					   </c:choose>
					&nbsp;<bean:message key="feedback.type.add" bundle="emMessages" /></TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<td class="POPFORMLABEL"></td>
					<TD CLASS="POPFORMFIELD" WIDTH="60%">
						<c:choose>
							<c:when test="${requestScope.isMapEnabled}">
								<html:checkbox property="mapEnable" onclick="showHide('chooseStartegyButton');hideOptionalPage();enableSequentialMapping();"/>
							</c:when>
							<c:otherwise>
								<html:checkbox property="mapEnable"  disabled="true"/>
							</c:otherwise>
					   </c:choose>
					   &nbsp;<bean:message key="feedback.type.map" bundle="emMessages" /> 
					   <c:choose>
							<c:when test="${requestScope.isMapEnabled}">
					   &nbsp;&nbsp;<html:checkbox property="applysequentialMapRules" disabled="true" onclick="showHide('chooseStartegyButton');"/> <bean:message key="apply.map.rule.sequential" bundle="ruleMessage" />
					   </c:when>
							<c:otherwise>
						<html:checkbox property="applysequentialMapRules"  disabled="true"/>
							</c:otherwise>
							</c:choose>
					   </TD>
					   
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<td class="POPFORMLABEL"></td>
					<TD CLASS="POPFORMFIELD" WIDTH="60%">
							<c:choose>
							<c:when test="${requestScope.isRenameEnabled}">
								<html:checkbox property="renameEnable" />
							</c:when>
							<c:otherwise>
								<html:checkbox property="renameEnable" disabled="true"/>
							</c:otherwise>
					   </c:choose>
					   &nbsp;<bean:message key="feedback.type.rename" bundle="emMessages" /></TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<td class="POPFORMLABEL"></td>
					<TD CLASS="POPFORMFIELD" WIDTH="60%"><c:choose>
							<c:when test="${requestScope.isMoveEnabled}">
								<html:checkbox property="moveEnable" />
							</c:when>
							<c:otherwise>
								<html:checkbox property="moveEnable" disabled="true"/>
							</c:otherwise>
					   </c:choose>
					   &nbsp;<bean:message key="feedback.type.move" bundle="emMessages" /></TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				<TR>
					<td class="POPFORMLABEL"><bean:message key="ui.label.enable.transaction.based.apply.rule" bundle="ruleMessage" /></td>
					<TD CLASS="POPFORMFIELD" WIDTH="60%">
					<input type="checkbox" id="enableTransctionBasedApplyRule" name="enableTransctionBasedApplyRule" onclick="submitRequest('showTransactionDates',this);"/>
							
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				<TR id='factTR' style="display: none">
					<TD class="POPFORMLABEL"><bean:message key="apply.rule.feedback.select.fact.date" bundle="ruleMessage"/></TD>	
					<TD class="POPFORMFIELD" width="60%"  style="padding: 3px 0;">&nbsp;
						<html:select  styleId="factCreatedDate" property="factCreatedDate" styleId="factCreatedDate">
							
						</html:select>  
					</TD>
				</TR>
				
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				
			<tbody style="display: none" id="applyRuleOptionalPage" >

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>					
					<TD CLASS="reportTitle" ><bean:message key="apply.rule.feedback.optional.input.title" bundle="emMessages" /></TD>
				</TR>
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD class="POPFORMLABEL"></TD>
					<TD class="POPFORMFIELD" width="60%">
					    <html:checkbox property="weightSelected" styleId="weightSelected" disabled='true' />
							&nbsp;<bean:message key="ui.feedback.processing.weight" bundle="emMessages"/>
						<html:text disabled='true' property="weight" size="20" styleId="weight" styleClass="inputStyle" maxlength="20"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD class="POPFORMLABEL"></TD>
					<TD class="POPFORMFIELD" width="60%">
						    <html:checkbox property="specificitySelected" styleId="specificitySelected" disabled='true' />
							&nbsp;<bean:message key="apply.rule.feedback.optional.input.specificity" bundle="emMessages"/>
							<html:text disabled='true' property="specificity" size="20" styleId="specificity" styleClass="inputStyle" maxlength="20"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD class="POPFORMLABEL"></TD>				
					<TD class="POPFORMFIELD" width="60%">
						<html:radio disabled='true' property="specificityCondition"  value="0" styleId="specificityCondition"/>&nbsp;
						<bean:message key="apply.rule.feedback.optional.input.cond.direct" bundle="emMessages"/><BR/>
						<html:radio disabled='true' property="specificityCondition"  value="1" styleId="specificityCondition"/>&nbsp;
						<bean:message key="apply.rule.feedback.optional.input.cond.inverse" bundle="emMessages"/>
						&nbsp;</TD>

				</TR>
				
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				<TR>
					<TD class="POPFORMLABEL"></TD>	
					<TD class="POPFORMFIELD" width="60%">
						<html:checkbox property="timeSelected" styleId="timeSelected" disabled='true'/>
						&nbsp;<bean:message key="apply.rule.feedback.optional.input.time" bundle="emMessages"/>
						<html:text disabled='true' property="time" size="20" styleId="time" styleClass="inputStyle" maxlength="20"/>
					</TD>

				</TR>			

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD class="POPFORMLABEL"></TD>	
					<TD class="POPFORMFIELD" width="60%">			
						<html:radio disabled='true' property="timeCondition"  value="0" styleId="timeCondition"/>&nbsp;
						<bean:message key="apply.rule.feedback.optional.input.time.cond.most.recent" bundle="emMessages"/>
						<BR/>
						<html:radio disabled='true' property="timeCondition"  value="1" styleId="timeCondition"/>&nbsp;
						<bean:message key="apply.rule.feedback.optional.input.time.cond.least.recent" bundle="emMessages"/>
					</TD>
				</TR>
			
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
				
				<TR>
					<TD class="POPFORMLABEL"></TD>	
					<TD class="POPFORMFIELD" width="60%">
						<html:checkbox property="addNodeDepthSelected" styleId="addNodeDepthSelected" disabled='true'/>
						&nbsp;<bean:message key="apply.rule.feedback.optional.input.addnodedepth" bundle="emMessages"/>
						<html:text disabled='true' property="addNodeDepth" size="20" styleId="addNodeDepth" styleClass="inputStyle" maxlength="20"/>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD class="POPFORMLABEL"></TD>	
					<TD class="POPFORMFIELD" width="60%">
					    <html:radio disabled='true' property="addNodeDepthCondition"  value="0" styleId="addNodeDepthCondition"/>
					    <bean:message key="apply.rule.feedback.optional.input.cond.direct" bundle="emMessages"/><BR/>
						<html:radio disabled='true' property="addNodeDepthCondition"  value="1" styleId="addNodeDepthCondition"/>
						<bean:message key="apply.rule.feedback.optional.input.cond.inverse" bundle="emMessages"/>
					</TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>
			
				<TR>					
					<TD CLASS="reportTitle" ><bean:message key="apply.rule.feedback.optional.input.dimension.reset.title" bundle="ruleMessage"/></TD>
				</TR>

				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR>
					<TD class="POPFORMLABEL"></TD>	

					<TD class="POPFORMFIELD" width="60%">
						<html:checkbox property="resetSlected" styleId="resetSlected" onclick="showHide(['dimensionTR'])"/>
						&nbsp;<bean:message key="apply.rule.feedback.optional.input.reset.spend.assignment" bundle="ruleMessage"/>
					</TD>
				</TR>
				
				<TR>
					<TD colspan="2" height="0.1px" CLASS="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></TD>
				</TR>

				<TR id='dimensionTR' style="display:none";>
					<TD class="POPFORMLABEL"><bean:message key="apply.rule.feedback.optional.input.reset.dimension" bundle="ruleMessage"/></TD>	
					<TD class="POPFORMFIELD" width="60%">&nbsp;
						<html:select  property="dimensionToReset" styleId="dimensionToReset" multiple="true" size="3" >
							<html:options collection="dimensionList" property="value" labelProperty="label"/>
						</html:select>  
					</TD>
				</TR>

			</tbody>

			</TABLE>
			
				<br>

				<table  cellSpacing="0" align="center" cellPadding="0"  border="0">
					<Tr>
						<TD id="chooseStartegyButton"  style="display:none">
							<c:if test="${requestScope.isMapEnabled}">
								<INPUT type="BUTTON" name="choose_Strategy" value="Choose Strategy" onclick="chooseStrategy();"/>&nbsp;
							</c:if>
						</TD>
						<TD>
							<html:submit onclick="return isAnyFeedbackTypeChecked();">
								<bean:message key="apply.rule.page.title" bundle="ruleMessage"/>
							</html:submit>&nbsp;
						</TD>
						<TD>
							<INPUT type="BUTTON" name="cancel" value="<bean:message key='ui.label.Cancel' bundle='emMessages'/>"	ONCLICK="top.window.close();" />
						</TD>
					</Tr>
				</table>
				<input type ="hidden" name="AuthCode" id="AuthCode" value="<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>"/>
			</html:form>
		</BODY>	
</HTML>