<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@	page import="com.zeborg.expensemap.util.HelpLocaleUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.util.WebUtil"%>
<%@ page import="com.emptoris.viewer.search.util.PagingInfo"%>
<%@ page import="java.util.*"%>
<%@ page import="org.apache.struts.Globals,java.util.Locale" %>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.view.*" %>

<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	WebUtil.addType(response, request);
	WebUtil.addNoCache(response);
	pageContext.setAttribute("returnToURL","../SearchDimensionAction.do", PageContext.SESSION_SCOPE);
	// This is required for struts to know which locale to use for labels, messages.
	Locale locale = zs.getUser().getLocale();
	request.getSession().setAttribute(Globals.LOCALE_KEY, locale);
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("search",locale);    
	
	EmResourceBundle baseResourceBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, zs.getUser().getLocale());
	//fix for bug no 37765 - vijay 
	Map nodeMap = new HashMap();
	int selectedNodesSize = 0;
	
	if(session.getAttribute("nodeMap")!=null){
		nodeMap = (Map)session.getAttribute("nodeMap");	
	}

	PagingInfo pgInfo = new PagingInfo();
	if(request.getAttribute("pageInfo")!=null){
		pgInfo = (PagingInfo)request.getAttribute("pageInfo");
	}
	String currPage = String.valueOf(pgInfo.getCurrentPageNo());
	Set<String> nodes = new HashSet<String>();
	if(!currPage.equals("0")){
		nodes = (Set)nodeMap.get(currPage);
		if(nodes!=null){
			selectedNodesSize = nodes.size();
		}
	}
	StringBuilder sbuf = new StringBuilder();
	if(nodes!=null){
		sbuf.append("[");
		Iterator itr = nodes.iterator();
			while(itr.hasNext()){
				sbuf.append("\"");
				sbuf.append((String)itr.next());
				sbuf.append("\"");
				sbuf.append(",");
			}
		if(sbuf.indexOf(",") > 0){	
			sbuf = new StringBuilder(sbuf.substring(0,sbuf.lastIndexOf(",")));
		}	
		sbuf.append("]");	
	}
	int totalNodeListSize = pgInfo.getTotalNumberOfRecords();
	int warnLimit = ExpenseMapAppProperties.getEmMaxNodeApplyLimitWarning();
	String maxLimit = String.valueOf(ExpenseMapAppProperties.getEmMaxNodeApplyLimit());
	int multiListSearchCharLimit = ExpenseMapAppProperties.getMultilistSearchCriteriaCharLimit();

%>
<!-- end comment fix for bug no 37765 - vijay  -->
<HTML:HTML>
	<HEAD>
		<fmt:setBundle basename="ExpensemapMessagesBundle" />
		<TITLE><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message bundle="search" key="search.title" /></TITLE>
		<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">
		<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/preferences.css"> 
		<SCRIPT LANGUAGE="javascript" SRC="/expensemap/jsp/javascript/header.js"></SCRIPT>
		<SCRIPT LANGUAGE="javascript" SRC="/expensemap/jsp/javascript/views_script.js"></SCRIPT>
		<SCRIPT LANGUAGE="javascript" SRC="/expensemap/jsp/javascript/mainView.js"></SCRIPT>

		<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
		<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
		<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css" />
		<STYLE>
			.yui-skin-sam .yui-panel {
			position: absolute;
			}
			.yui-skin-sam .yui-calcontainer {
			font-family: Arial, Helvetica, sans-serif;
			font: 70%;
				width:160px;
				width:180px !ie;			
			}
			.yui-skin-sam .yui-panel .bd {
				display:block;
				overflow:hidden;
				width:180px;
				width:200px !ie;
			}
			#pb {
				position: absolute;
				top: 200px;
				left: 200px;
			}
			#pb.yui-overlay { 
				background-image: url(/expensemap/jsp/images/dimension-viewer-progressbar/75p_white.png);
				border: 1px solid black;
				padding: 5px;
				margin: 10px;
				font-size: 13px;
				font-weight: bold;
				color: black;
			}			
		</STYLE>
		<SCRIPT type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></SCRIPT>
		<SCRIPT type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></SCRIPT>
		<SCRIPT type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></SCRIPT>
		<SCRIPT type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></SCRIPT>	
		<SCRIPT type="text/javascript" src="/expensemap/scripts/popup-cal.js"></SCRIPT>
		<SCRIPT type="text/javascript" src="/expensemap/scripts/localeData.js"></SCRIPT>
	</HEAD>
	<BODY class="yui-skin-sam" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onLoad="setCheckBox();">
		<html:form action="/SearchDimensionAction" styleId="searchDimensionForm">
			<div id="pb" style="visibility:hidden">
				<div class="hd" align="center" style="font-family: arial,helvetica,clean,sans-serif; font-size: 11px; color: darkblue;">
				 <fmt:message key="ui.label.Processing.request"/>
				</div>
				<div class="bd" align="center"><img src="/expensemap/jsp/images/dimension-viewer-progressbar/rel_interstitial_loading_resized.gif" /></div>
			</div>		
			<html:hidden property="operation" styleId="operation"/>
			<html:hidden property="pageNo" styleId="pageNo"/>
			<html:hidden property="selectedSearchFilterType" styleId="selectedSearchFilterType"/>
			<INPUT type=hidden name="newSearch" id="newSearch">
			<!-- fix for bug no 37765 - vijay  -->
			<html:hidden property="currPageNo" value="<%=currPage%>"/>
			<!-- end comment fix for bug no 37765 - vijay  -->

			<SCRIPT>
				var lowLimitInnerHTML = '<html:text styleClass="tabledata" maxlength="4000" property="searchKeyword" style="width: 100%;" styleId="search.string"/>';
				var highLimitInnerHTML = '<html:text styleClass="tabledata" maxlength="4000" property="highLimit" styleId="highLimit"/>';
				// following styles will be used for displaying input boxes for date dimensions.
				var dateLowLimitInnerHTML = '<html:text styleClass="tabledata" size="25" maxlength="4000" property="searchKeyword"   styleId="search.string"/>';
				var dateHighLimitInnerHTML = '&nbsp;&nbsp;&nbsp;<html:text styleClass="tabledata" size="25" maxlength="4000" property="highLimit" styleId="highLimit"/>';
				var searchCriteriaToRetain = "";
				var lowDateToRetain = "";
				var highDateToRetain = "";
				var progressBar = null;
				var xmlHttp;
				function ResetHttpRequest() {
					xmlHttp = false;
					// branch for native XMLHttpRequest object
					if(window.XMLHttpRequest) {
						try {
							xmlHttp = new XMLHttpRequest();
						} catch(e) {
							xmlHttp = false;
						}
					// branch for IE/Windows ActiveX version
					} else if(window.ActiveXObject) {
						try {
							xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
						} catch(e) {
							try {
								xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
							} catch(e) {
								  xmlHttp = false;
							}
						}
					}

				   if (!xmlHttp) alert('<%=baseResourceBundle.getValue("ui.message.Browser.does.not.support.AJAX.type.request")%>');
				}

				function sendRequest(argStr)
				{
					try {
						showProgressBar();
						preserveSearchCriteria();
						ResetHttpRequest();
						xmlHttp.open("GET", "/expensemap/jsp/search/searchAjaxProcessor.jsp?" + argStr, true);
						xmlHttp.send(null);
						xmlHttp.onreadystatechange = responseHandler;
					} catch(e) {
						 alert(e);
					}
				}

				function responseHandler(){
					hideProgressBar();
					if (xmlHttp.readyState == 4){
						if (xmlHttp.status != 200) {
							alert("<%=baseResourceBundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%>" + xmlHttp.statusText);
							return false;
						}
						var response = xmlHttp.responseText;
						var data = eval(response);
						// If there is no data in the response, ignore this
						if (data == null) {
						   return;
						}
						if (data[0] == "Error"){
							var errorCode = data[1];
							if(errorCode == "session.timeout")
							{
							   var timeoutURL = data[3];
							   parent.location.href=timeoutURL;
							   return;
							}
							if(errorCode == "validation.error"){
								// validation failed for SaveAndApply, throw error and return.
								alert("<bean:message bundle='search' key='ui.error.message.em.max.node.apply.limit' arg0='<%=maxLimit%>'/>");
								return;
							}
						}else if(data[0] == "Success"){
							var warnLmt = <%=warnLimit%>;
							var nodeListSize = data[2];
							if(nodeListSize == 0){
								if(data[1] == 'SaveAndApply'){
									alert("<bean:message bundle='search' key='ui.search.error.Please.select.a.member.and.click.Apply' />");
									return false;
								}		       		
							}
							if(nodeListSize > warnLmt){
								if(confirm("<bean:message bundle='search' key='ui.message.em.max.node.apply.limit.warning'/>")){
									setOperation(data[1]);
									document.getElementById("searchDimensionForm").submit();		
								}else{
									return false;
								}
							}else{
									setOperation(data[1]);
									document.getElementById("searchDimensionForm").submit();					
							}		
						}else if(data[0] == "saveResults"){
							var nodeListSize = data[1];
							if(nodeListSize == 0){
								alert("<bean:message bundle='search' key='ui.search.error.Please.select.a.member.and.click.Save' />");
								return false;
							}else{
								saveResults(data[0]);
							}
						} else if(data[0] == "setFiltersOnAttributeChange") {
							var dType = data[2];
							document.getElementById("searchFilter").length = 0;
							var selectedFilter = '';
							var data = data[1];
							var arr = data.split(';');
							for (var i=0; i < arr.length-1;i++) {
								if (i==0) {
									selectedFilter=arr[i].split(':')[1];
								}
								var newOpt1 = new Option(arr[i].split(':')[1], arr[i].split(':')[0]);
								document.getElementById("searchFilter").options[i] = newOpt1;
							}
							
							if (dType == 'date') {
								if (selectedFilter == 'Between') {
									document.getElementById("lowLimitSpan").style.display = 'inline';
									document.getElementById("highLimitSpan").style.display = 'inline';
									document.getElementById("highLimitSpan").innerHTML = dateHighLimitInnerHTML;
									document.getElementById("lowLimitSpan").innerHTML = dateLowLimitInnerHTML;
									document.getElementById("highLimit").value = highDateToRetain;
								} else {
									document.getElementById("highLimitSpan").style.display = 'none';
									document.getElementById("highLimitSpan").innerHTML = dateHighLimitInnerHTML;
									document.getElementById("lowLimitSpan").innerHTML = dateLowLimitInnerHTML;
								}

								document.getElementById("search.string").value = lowDateToRetain;
								
								document.getElementById("stringOrSearchOption").style.display = 'none';
								document.searchForm.delimeterSeparated.checked = false;				
								
								var fromDateField = document.getElementById("search.string");
								var toDateField = document.getElementById("highLimit");
								YAHOO.util.Event.on(fromDateField, "focus", openCalendar, [fromDateField, fromDateField]);
								YAHOO.util.Event.on(toDateField, "focus", openCalendar, [toDateField, toDateField]);

							} else {
								document.getElementById("stringOrSearchOption").style.display = 'block';
								document.getElementById("highLimitSpan").style.display = 'none';
								document.getElementById("lowLimitSpan").style.display = 'block';
								document.getElementById("lowLimitSpan").innerHTML = lowLimitInnerHTML;
								document.getElementById("search.string").value = searchCriteriaToRetain;
								
								var fromDateField = document.getElementById("search.string");
								var toDateField = document.getElementById("highLimit");
								YAHOO.util.Event.removeListener ( fromDateField, "focus" , openCalendar );
								YAHOO.util.Event.removeListener ( toDateField, "focus" , openCalendar );
							}
							if(document.searchForm.delimeterSeparated.checked){
								document.getElementById('delimeter').disabled = false;
							}else{
								document.getElementById('delimeter').value = ',';
								document.getElementById('delimeter').disabled =true;
							}

							document.searchForm.selectedSearchFilterType.value = dType;
						} else if(data[0] == "TOTAL_SELECTED_NODE_COUNT") {
							var TOTAL_NODES_COUNT = <%=totalNodeListSize%>;
							var TOTAL_SELECTED_NODE_COUNT = data[1];
							if(TOTAL_NODES_COUNT == TOTAL_SELECTED_NODE_COUNT){
								document.getElementById("checkAllPg").checked=true;
								document.getElementById("selectAllAcrossPage").value = true;
							}else{
								document.getElementById("checkAllPg").checked=false;
								document.getElementById("selectAllAcrossPage").value = false;
							}
						}
					}
				}

				/*send ajax request to update selected node's map, whether particular node is checked or unchecked.*/
				function updateSelectedNodes(chkBox){
					/*request format : 'updateSelectedNodes',<CURRENT_PAGE_NO>,<CHECKBOX_ID>,<CHECKED_VALUE>*/
					if(!chkBox.checked){
						// checkbox is unchecked, so set selectAllAcrossPage flag to false
						document.getElementById("selectAllAcrossPage").value = false;
					}
					updateCheckboxesOnCurrentPage();
					sendRequest('updateSelectedNodes'+","+<%=currPage%>+","+chkBox.id+","+chkBox.checked);
				}

				/*same as above function, but don't check for updateCheckboxesOnCurrentPage()*/
				function updateSelectedNodesForSelectAll(chkBox){
					/*request format : 'updateSelectedNodes',<CURRENT_PAGE_NO>,<CHECKBOX_ID>,<CHECKED_VALUE>*/
					if(!chkBox.checked){
						// checkbox is unchecked, so set selectAllAcrossPage flat to false
						document.getElementById("selectAllAcrossPage").value = false;
					}
					sendRequest('updateSelectedNodes'+","+<%=currPage%>+","+chkBox.id+","+chkBox.checked);
				}

				/*this function will check if all checkboxes on current page will be checked = true, then enable SELECTALL checkbox.*/
				function updateCheckboxesOnCurrentPage(){
					var formObj = document.getElementById("searchDimensionForm");	
					var checkboxes = document.searchForm.selectedNodes;
					var allChecked = true;
					if(checkboxes){
						if (!checkboxes[0] ) { 
								allChecked = checkboxes.checked;
							}else{
								for( var index=0; index < checkboxes.length; index++ ) {
									var checkboxObj = checkboxes[index];
									   if(!checkboxObj.checked){
										allChecked = false;
										break;
									   }
								}//end for
							}//end else	
					formObj.checkAll.checked = allChecked;
					formObj.checkAll1.checked = allChecked;
					}
				}

				function updateCheckboxes(flag){
					var formObj = document.getElementById("searchDimensionForm");	
					if (flag=="applyNodes"){
						var checkboxes = document.searchForm.applyNodes;
					}else if (flag=="savedNodes"){
						var checkboxes = document.searchForm.savedNodes;
					}
					var allChecked = true;
					if(checkboxes){
						if (!checkboxes[0] ) {
								allChecked = checkboxes.checked;
							}else{
								for( var index=0; index < checkboxes.length; index++ ) {
									var checkboxObj = checkboxes[index];
									   if(!checkboxObj.checked){
										allChecked = false;
										break;
									   }
								}//end for
							}//end else
								
							if (flag=="applyNodes"){
								formObj.checkAllApplyNodes.checked = allChecked;
							}else if (flag=="savedNodes"){
								formObj.checkAllSavedNodes.checked = allChecked;
							}					
							/*if(checkboxElement.id="savedNodes"){
								
							}
							if(checkboxElement.id="applyNodes"){
								
							}*/
					}
				}

				function largeNodeWarning(enabledStr, checkbox){
					if(checkbox.checked && (enabledStr == 'disabled'))
					{
						var answer = confirm('<%=baseResourceBundle.getValue("ui.dimension.message.confirm.large.node.drill2")%>');
						if(!answer){
							checkbox.checked = false;
							return false;
						}
					}
					return true;
				}

				function setCheckBox() {
					//intialising Search criteria  for enterKey to work for search
					document.getElementById("searchDimensionSelected").focus();
					setOperation('searchResults');

					var chkBox = eval(<%=sbuf.toString()%>);
					if(chkBox!=null){
						for(var i=0;i<chkBox.length;i++){
							var ch = document.getElementById(chkBox[i]);
							if(ch!=null){
								ch.checked = true;
							}
						}
					}
					
					if(document.getElementById("selectAllAcrossPage")){	
						var selectAllVal = document.getElementById("selectAllAcrossPage").value;
						if(document.getElementById("checkAllPg")){
							if(selectAllVal == 'true'){		
								document.getElementById("checkAllPg").checked = true;		
								checkAllPage(document.getElementById("checkAllPg"));
							}			
						}
					}
					
					updateCheckboxesOnCurrentPage();
					visibleSpanForDate();
					hideProgressBar();
					
				}
				
				function visibleSpanForDate() {
					var fType = document.searchForm.selectedSearchFilterType.value;
					var mylist=document.getElementById("searchFilter");  		
					var selFilter = mylist.options[mylist.selectedIndex].value;
					if (fType== 'date' && selFilter == 'Between') {
						document.getElementById("lowLimitSpan").style.display = 'inline';
						document.getElementById("highLimitSpan").style.display = 'inline';
						document.getElementById("highLimitSpan").innerHTML = dateHighLimitInnerHTML;
						document.getElementById("lowLimitSpan").innerHTML = dateLowLimitInnerHTML;
						
						var fromDateField = document.getElementById("search.string");
						var toDateField = document.getElementById("highLimit");
						YAHOO.util.Event.on(fromDateField, "focus", openCalendar, [fromDateField, fromDateField]);
						YAHOO.util.Event.on(toDateField, "focus", openCalendar, [toDateField, toDateField]);
						document.getElementById("stringOrSearchOption").style.display = 'none';
						document.searchForm.delimeterSeparated.checked = false;		
					} else if (fType== 'date' ) {
						document.getElementById("highLimitSpan").style.display = 'none';
						document.getElementById("highLimitSpan").innerHTML = dateHighLimitInnerHTML;
						document.getElementById("lowLimitSpan").innerHTML = dateLowLimitInnerHTML;
						var fromDateField = document.getElementById("search.string");
						var toDateField = document.getElementById("highLimit");
						YAHOO.util.Event.on(fromDateField, "focus", openCalendar, [fromDateField, fromDateField]);
						YAHOO.util.Event.on(toDateField, "focus", openCalendar, [toDateField, toDateField]);
						document.getElementById("stringOrSearchOption").style.display = 'none';
						document.searchForm.delimeterSeparated.checked = false;
					} else {
						document.getElementById("stringOrSearchOption").style.display = 'block';
						document.getElementById("lowLimitSpan").style.display = 'block';
						document.getElementById("lowLimitSpan").innerHTML = lowLimitInnerHTML;
						var fromDateField = document.getElementById("search.string");
						var toDateField = document.getElementById("highLimit");
						YAHOO.util.Event.removeListener ( fromDateField, "focus" , openCalendar );
						YAHOO.util.Event.removeListener ( toDateField, "focus" , openCalendar );
					}
					
					if(!document.searchForm.delimeterSeparated.checked){
						document.getElementById('delimeter').disabled=true;
						document.getElementById('delimeter').value=',';						
					}

				}

				function setDimension(){
					preserveSearchCriteria();
					setOperation('searchDimensions');
					var mylist=document.getElementById("searchDimensionSelected");  		
					document.getElementById("searchDimensionSelectedLabel").value=mylist.options[mylist.selectedIndex].text;
					document.getElementById("searchDimensionSelectedValue").value=mylist.options[mylist.selectedIndex].value;
					document.getElementById("selectAllAcrossPage").value = false;
					document.searchForm.submit();
				}
 			
				function setFilter(filterType) {
					preserveSearchCriteria();
					visibleSpanForDate();
					populateKeywordFields();
				}
 	
				function saveResults(operation){
					var checkboxes = document.searchForm.selectedNodes;
					if(checkboxes)
					{
						var flg=0;
						if(!checkboxes[0]){ 
							if (checkboxes.type == "checkbox"){
								if(checkboxes.checked){
									flg++;
								}
							}
						}else{
							for( var index=0; index < checkboxes.length; index++ ){
								var checkboxObj = checkboxes[index];
								if(checkboxObj.checked){
									flg++;
								}
							}
						}
						// check if user has selected any nodes
						// on any other page
						var nodesSelected = <%= ( nodeMap != null && nodeMap.isEmpty() == false) %>;
						if(flg==0 && !nodesSelected){
							alert("<bean:message bundle='search' key='ui.search.error.Please.select.a.member.and.click.Save' />");
							return false;
						}else{
							setOperation(operation);        	
							document.getElementById("searchDimensionForm").submit();
						}
					}
				}
	
				function setNewSearch()	{ 
					document.getElementById('newSearch').value='true';
					document.getElementById('pageNo').value='1';	
					document.getElementById("selectAllAcrossPage").value = false;
				}
	
				function setOperation(operation) { 	 
					document.getElementById('operation').value=operation;
					return true;
				}

				function setPageNo(pageNo){
					document.getElementById('pageNo').value=pageNo;
					setOperation('searchResults');
					document.searchForm.submit();
				}
	

				function checkMemberExist(flag,operation, e){
					if(flag=="selectedNodes"){		    
						var checkboxes = document.searchForm.selectedNodes;
					}else if (flag=="applyNodes"){
						var checkboxes = document.searchForm.applyNodes;
					}else if (flag=="savedNodes" && notifyFilterChecks()){
						var checkboxes = document.searchForm.savedNodes;
					}
					if(checkboxes){
						var flg=0;
						if(!checkboxes[0]){ 
							if (checkboxes.type == "checkbox") {
								if(checkboxes.checked){
									flg++;
								}
							}
						}else{
							for( var index=0; index < checkboxes.length; index++ ){
								var checkboxObj = checkboxes[index];
								if(checkboxObj.checked){
									flg++;
								}
							}
						}
						// check if user has selected any nodes
						// on any other page
						var nodesSelected = <%= ( nodeMap != null && nodeMap.isEmpty() == false) %>;
						if(flg==0 && !nodesSelected  && flag !="applyNodes" && flag!="savedNodes"){
							alert("<bean:message bundle='search' key='ui.search.error.Please.select.a.member.and.click.Apply' />");
							return false;
						}else{
							//if user has selected at least one checkbox and there are no previously saved nodes on screen
							if(flg!=0 && !(document.searchForm.savedNodes)){
								//If there exists a right pane of applied filter nodes
								if( document.searchForm.applyNodes){
									if(!confirm('<%=baseResourceBundle.getValue("ui.search.apply.notification.message")%>')){
										return false;
										}
								}else{
									if(!confirm('<%=baseResourceBundle.getValue("ui.search.apply.confirmation.message")%>')){ 
										return false;
									}
								}
							}
							var keepChk = document.getElementById("keepFilters");
							var keepCurFilter = 'false';
							if(keepChk){
								keepCurFilter = keepChk.checked;
							}
							var dimName = document.getElementById("searchDimensionSelected").value;
							if(flag=="selectedNodes"){
								sendRequest('maxNodeValidationForSaveAndApply,'+dimName+','+keepCurFilter);
							}else if(flag=="savedNodes"){
								sendRequest('maxNodeValidationApply,'+dimName+','+keepCurFilter);
							}else{
								setOperation(operation);
							}
						}
					}
				}
				
				function notifyFilterChecks(){
					var checkboxes = document.searchForm.savedNodes;
					var applyFilter = true;
						if(checkboxes){
							if(!checkboxes[0]){
								if (checkboxes.type == "checkbox") {
									if(checkboxes.checked){
										var message = "<bean:message key='ui.search.error.applies.to.all'  bundle='search' arg0='${searchForm.totalSavedSearch}'/>";
										if(!confirm(message)){
											applyFilter = false;
										}
									}
								}
							}else{
								for( var index=0; index < checkboxes.length; index++ ){
									var checkboxObj = checkboxes[index];
									if(checkboxObj.checked){
										var message = "<bean:message key='ui.search.error.applies.to.all'  bundle='search' arg0='${searchForm.totalSavedSearch}'/>";
										if(!confirm(message)){
											applyFilter = false;
											break;
										}else{
											applyFilter = true;
											break;
										}
									}
								}
							}
						}
						return applyFilter;
				}
				function removeMember(flag,operation) {
					if (flag=="applyNodes"){
						var checkboxes = document.searchForm.applyNodes;
					}else if (flag=="savedNodes"){
						var checkboxes = document.searchForm.savedNodes;
					}
					if(checkboxes) {
						var flg=0;
						if(!checkboxes[0]) { 
							if (checkboxes.type == "checkbox") {
								if(checkboxes.checked) {
									flg++;
								}
							}
						} else {
							for( var index=0; index < checkboxes.length; index++ ) {
								var checkboxObj = checkboxes[index];
								if(checkboxObj.checked)	{
									flg++;
								}
							}
						}
						   
						if(flg==0) {
							alert("<bean:message bundle='search' key='ui.search.error.Please.select.a.member.and.click.Remove' />");
							return false;
						} else {
							setOperation(operation);
						}
					}
				}
					
				function addFilter(formObj,operation){
					if(formObj.addCurrentFilters.checked)
					{
						formObj.keepFilters.checked="checked";
						setOperation(operation);
					}else{
						formObj.keepFilters.checked="checked";
						setOperation('searchDimensions');
					}
					document.searchForm.submit();
				}

				function addMultiKeep(operation){
					setOperation(operation);
					document.searchForm.submit();
				}
 	
 				var isLf = new Array();
				<logic:iterate id="item" name="searchForm" property="isLeaf" indexId="nodeCount" > 
					isLf[<bean:write name="nodeCount"/>] = <bean:write name="item"/>;
  				</logic:iterate>
    	
				function checkAllOfLeaves(formObj){
					// clear the other select/DeSelect form inputs
					if ( formObj.checkAll.checked ){
						formObj.checkAll.checked = false;
						checkAllBoxes(formObj ,true);
					}
					// clear all check boxes if checked.
					formObj.checkAllLevel.value = "";

					var checkboxes = document.searchForm.selectedNodes;
						
					var nodeCnt=0;
					// check the leaves
					var totalRec = <bean:write name="searchForm" property="totalSearch" scope="request"/>	

					for(var i=0; i<totalRec; i++) {
						var checkboxObj=null;
						if ( !checkboxes[0] ) { 
							if (checkboxes.type == "checkbox") {
								checkboxObj = checkboxes;
							}
						} else {
							checkboxObj = checkboxes[i];
						}
						if ( checkboxObj != null ) {				
							if(isLf[i]==true){ 
								checkboxObj.checked=formObj.checkAllLeaves.checked;
								updateSelectedNodes(checkboxObj);
							}			
						}	  
					}
				}
	
				function checkAllOfLevel(formObj) {
					formObj.checkAllLeaves.checked = false;
					var level =formObj.checkAllLevel.value;
					var checkboxes = document.searchForm.selectedNodes;
					for (var j=0;j<=level.length;j++ ){
						if( level == "" || isNaN(level) || level.charAt(j) == "."){
							alert("<bean:message bundle='search' key='ui.search.error.Please.enter.valid.Level' />");
							return;
						}
					}
					var totalRec = <bean:write name="searchForm" property="totalSearch" scope="request"/>;
					for(var i=0; i<totalRec; i++) {
						var checkboxObj=null;
						if (!checkboxes[0]) { 
							if (checkboxes.type == "checkbox") {
								checkboxObj = checkboxes;
							}
						}else{
							checkboxObj = checkboxes[i];
						}
						if(checkboxObj!= null) {
							var node=checkboxObj.value;
							var li = node.lastIndexOf("::");
							var nodelevel=node.substring(li+2,node.length)
							checkboxObj.checked=false;
							// select the checkbox only if it is enabled
							if( ( ! checkboxObj.disabled )  && level==nodelevel ) {
								checkboxObj.checked=true;
							}
							updateSelectedNodes(checkboxObj);
						}
					}
				}
	
				function checkAllPage(chkBox){
					var checkVal = chkBox.checked;
					document.getElementById("selectAllAcrossPage").value = checkVal;	
					var formObj = document.getElementById("searchDimensionForm");	
					formObj.checkAll.checked = checkVal;
					if(!checkVal){
						formObj.checkAllLeaves.checked = checkVal;
					}
					checkAllBoxes(formObj, false);
					sendRequest('selectAcrossPage'+','+checkVal);
				}
	
	
				function checkAllBoxes( formObj, callfromLeafNode ) {
					//clear other
					formObj.checkAllLevel.value = "";
					formObj.checkAllLeaves.value=false;
					if(callfromLeafNode==false)
					{
						formObj.checkAllLeaves.checked=false;
					}
					var checkboxes = document.searchForm.selectedNodes;
					var checkAllBox = document.searchForm.checkAll1;
					if ( checkboxes ) {
						if ( !checkboxes[0] ) { 
							if (checkboxes.type == "checkbox") {
								if(!checkboxes.disabled){
								   checkboxes.checked = formObj.checkAll.checked;
								   checkAllBox.checked = formObj.checkAll.checked;
								   updateSelectedNodesForSelectAll(checkboxes);
								}
							}
						} else {
							for( var index=0; index < checkboxes.length; index++ ) {
								var checkboxObj = checkboxes[index];
								if ((checkboxObj.type == "checkbox") &&
									(checkboxObj.form.name == formObj.name)) {
									if(!checkboxObj.disabled){
									   checkboxObj.checked = formObj.checkAll.checked;
									   checkAllBox.checked = formObj.checkAll.checked;
									   updateSelectedNodesForSelectAll(checkboxObj);
									}
								}
							}
						}
					}
				}

				function checkAllBoxes1( formObj ) {
					//clear other
					formObj.checkAllLevel.value = "";
					formObj.checkAllLeaves.value="";	
					var checkboxes = document.searchForm.selectedNodes;
					var checkAllBox = document.searchForm.checkAll;
				
					if ( checkboxes ) {
						if ( !checkboxes[0] ) { 
							if (checkboxes.type == "checkbox") {
								if(!checkboxes.disabled){
								   checkboxes.checked = formObj.checkAll1.checked;
								   checkAllBox.checked = formObj.checkAll1.checked;
								   updateSelectedNodesForSelectAll(checkboxes);
								}
							}
						} else {
							for( var index=0; index < checkboxes.length; index++ ) {
								var checkboxObj = checkboxes[index];
								if ((checkboxObj.type == "checkbox") &&
									(checkboxObj.form.name == formObj.name)) {
									if(!checkboxObj.disabled){
									   checkboxObj.checked = formObj.checkAll1.checked;
									   checkAllBox.checked = formObj.checkAll1.checked;
									   updateSelectedNodesForSelectAll(checkboxObj);
									}
								}
							}
						}
					}
				}

				function checkAllSavedNode( formObj ) {
					var checkboxes = document.searchForm.savedNodes;
					if ( checkboxes ) {
						if ( !checkboxes[0] ) { 
							if (checkboxes.type == "checkbox") {
								if(!checkboxes.disabled){
								   checkboxes.checked = formObj.checkAllSavedNodes.checked;
								}
							}
						} else {
							for( var index=0; index < checkboxes.length; index++ ) {
								var checkboxObj = checkboxes[index];
								if ((checkboxObj.type == "checkbox") &&
									(checkboxObj.form.name == formObj.name)) {
									if(!checkboxObj.disabled){
									   checkboxObj.checked = formObj.checkAllSavedNodes.checked;
									}
								}
							}
						}
					}
				}

				function checkAllApplyNode( formObj ) {
					var checkboxes = document.searchForm.applyNodes;
					if ( checkboxes ) {
						if ( !checkboxes[0] ) { 
							if (checkboxes.type == "checkbox") {
								if(!checkboxes.disabled){
								   checkboxes.checked = formObj.checkAllApplyNodes.checked;
								}
							}
						} else {
							for( var index=0; index < checkboxes.length; index++ ) {
								var checkboxObj = checkboxes[index];
								if ((checkboxObj.type == "checkbox") &&
									(checkboxObj.form.name == formObj.name)) {
									if(!checkboxObj.disabled){
									   checkboxObj.checked = formObj.checkAllApplyNodes.checked;
									}
								}
							}
						}
					}
				}
 	
				/* Sets filter list on change of attribute depending on type of attribute, date or string. */
				function setFiltersOnAttributeChange() {
					var dimSel = document.getElementById("searchDimensionSelected").value;
					var attributeSel = document.getElementById("attributeSelected").value;
					var delimeterSeparated = document.getElementById("delimeterSeparated").checked;
					sendRequest('setFiltersOnAttributeChange'+","+ dimSel + ","+ attributeSel + "," +delimeterSeparated);
				}

				function validateDelimeterSeparated(){
					var delimeterSeparated = document.getElementById("delimeterSeparated").checked;
					var delimeter = document.searchForm.delimeter.value;
					if(delimeterSeparated == true ){ 
					 	if( delimeter.length == 0 ){
							alert("<bean:message key='ui.search.error.delimeter.required' bundle='search'/>");
							document.searchForm.delimeter.focus();
							return false;
						}						
						var specialChars = ",|;:/~";
						if(specialChars.indexOf(delimeter)==-1){
							alert("<bean:message key='ui.search.alert.delimeter.special.char' bundle='search'/>");
							document.searchForm.delimeter.value='';
							document.searchForm.delimeter.focus();
							return false;
						}
						var searchCriteria = document.searchForm.searchKeyword.value;
						<c:set var="charLimit" value="<%=multiListSearchCharLimit%>" />
						var charLimit = '${charLimit}';
						if(searchCriteria.length >= charLimit){
							alert("<bean:message key='multilist.search.criteria.char.limit' arg0='${charLimit}'  bundle='search'/>");
							document.searchForm.searchKeyword.value='';
							document.searchForm.searchKeyword.focus();
							return false;
						}					
					}
					return true;
				}

				function validateEmptySearchCriteria(){
					if(document.searchForm.searchKeyword.value==""){
						alert("<bean:message key='ui.search.error.search.keyword.empty' bundle='search'/>");
						document.searchForm.searchKeyword.focus();
						return false;
					} else if (document.getElementById("highLimitSpan").style.display != "none") {
						if (document.searchForm.highLimit.value == "") {
							alert("<bean:message key='ui.toDate.alertmsg' bundle='search'/>");
							document.searchForm.highLimit.focus();
							return false;
						}
					}
					return true;
				}
 	
				/* This function validates date fields if attribute type is date.*/
				function validateDate() {
					var isValid=true;
					var type = document.searchForm.selectedSearchFilterType.value;
					var loLimitValue = document.searchForm.searchKeyword.value;
					var opValue = document.searchForm.searchFilter.value;
					var highLimitValue = document.searchForm.highLimit.value;
					loLimitValue = trim(loLimitValue);
					highLimitValue = trim(highLimitValue);
					document.searchForm.highLimit.value = highLimitValue;
					if (type == 'date') {
						if (loLimitValue == "") {
							alert("<bean:message key='ui.toDate.alertmsg' bundle='search'/>");
							return false;
						}

						if ( opValue == "Between" ) {
							if (highLimitValue == "") {
								alert("<bean:message key='ui.toDate.alertmsg' bundle='search'/>");
								return false;
							}
						}
					}
					return true;
				}
				
				/* Save search strings of type string or date depending upon chosen dimension and filter types */
				function preserveSearchCriteria() {
					var dType = document.searchForm.selectedSearchFilterType.value;
					var filterValue = document.searchForm.searchFilter.value;
					
					if (dType == 'date') {
						lowDateToRetain = document.getElementById("search.string").value;
						if (document.getElementById("highLimit").value != "") {
							highDateToRetain = document.getElementById("highLimit").value;
						}
						
					} else { // string type
						searchCriteriaToRetain = document.getElementById("search.string").value;
					}
				}
				
				/* Populate keyword fields depending on whether they are date related or not */
				function populateKeywordFields() {
					var fType = document.searchForm.selectedSearchFilterType.value;
					var filterValue = document.searchForm.searchFilter.value;
					if (fType == 'date') {
						document.getElementById("search.string").value = lowDateToRetain;
						if (filterValue == 'Between') {
							document.getElementById("highLimit").value = highDateToRetain;
						}
					} else {
						document.getElementById("search.string").value = searchCriteriaToRetain;
					}
				}
				
				/* Trims spaces.*/
				function trim(s) {
					return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
				}
				
				function submitSearchForm(){
					if(validateDelimeterSeparated() && validateEmptySearchCriteria() && validateDate() && setOperation('searchResults')){
						setNewSearch();
						showProgressBar();
						return true;
					}
					return false;
				}

			function hideProgressBar() {
				if(progressBar!=null){
					progressBar.hide();
				}
			}
			
			function showProgressBar() {
				progressBar.show();
			}
				
		</SCRIPT>

			<%CubeUtil.buildExpMapMastHead(out,"search/search.jsp",zs,true,null,zs.getUser().getLocale(),null);%>
			<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
			<jsp:include page="/jsp/topMenu.jsp">
				<jsp:param name="helpUrl" value="<%=helpURL%>"/>
			</jsp:include>
			
			<div style="padding-top: 8px"></div>
			<logic:messagesPresent> 
				<TR>
					<TD align="left">
						<FONT class="errordisplay" color="red" size="3">    
							<html:messages id="error" bundle="search"> 
								<bean:write name="error"/><BR>
							</html:messages> 
						</FONT>
					</TD>
				</TR>
			</logic:messagesPresent>
			
			<TABLE border="0" class="InnerTableWithBorder" cellpadding="0px" cellspacing="1px">
				<TR>
					<TD width="5%" style="height: 25px; padding-left:5px;" nowrap>
						<B><bean:message bundle="search" key="ui.search.dimension.label" /></B>
					</TD>
					<TD width="23%" style="padding-left:5px" nowrap>
						<html:select styleClass="tabledata" name="searchForm" property="searchDimensionSelected"  styleId="searchDimensionSelected" size="1" onchange="return setDimension();">
							<html:optionsCollection name="searchForm" property="dimensionList" label="label" value="value" filter="false" />
						</html:select>
					</TD>
					<TD width="5%" style="padding-left:5px" nowrap>&nbsp;&nbsp;<B><bean:message bundle="search" key="ui.search.attribute.label" /></B>
					</TD>
					<TD width="40%" style="padding-left:5px">
						<TABLE border="0" width="100%" cellpadding="0px" cellspacing="1px">
							<TR>
								<TD WIDTH="5%">
									<span>
										<html:select styleClass="tabledata"  property="attributeSelected" styleId="attributeSelected" onchange="return setFiltersOnAttributeChange();">
											<html:options collection="attributeList" property="label" labelProperty="value" />		
										</html:select>
									</span>
								</TD>
								<TD WIDTH="10%" ALIGN="right" nowrap>
									<SPAN id="stringOrSearchOption" style="display:none; padding-left: 5px;">
										<html:checkbox property="delimeterSeparated" styleId="delimeterSeparated" value="true" onclick="return setFiltersOnAttributeChange();"/>&nbsp;<bean:message bundle="search" key="ui.search.list.separated.by"/>&nbsp;&nbsp;&nbsp;
										<html:select property="delimeter" styleId="delimeter">
											  <html:option value=",">,</html:option>
											  <html:option value="|">|</html:option>
											  <html:option value=";">;</html:option>
											  <html:option value=":">:</html:option>
											  <html:option value="/">/</html:option>
											  <html:option value="~">~</html:option>
										</html:select>
									</SPAN>
								</TD>
							</TR>
						</TABLE>
					</TD>
					<TD></TD>
				</TR>
				<TR>
					<TD nowrap style="height: 25px; padding-left:5px" ><B><bean:message bundle="search" key="ui.search.filter.label" /></B>
					</TD>
					<TD nowrap style="padding-left:5px" >	 
						<html:select  styleClass="tabledata" name="searchForm" property="searchFilter" styleId="searchFilter" size="1" onchange="return setFilter('filter');">
							<html:optionsCollection name="searchForm" property="searchFilterList" label="label" value="value" />	
						</html:select>
					</TD>
					<TD style="padding-left:5px" nowrap>&nbsp;&nbsp;<B><bean:message bundle="search" key="ui.ruleform.cri.label" />:</B>
					</TD>
					<TD style="padding-left:5px">
						<TABLE style="table-layout: fixed; width: 100%">
							<TR>
								<TD>
									 <SPAN id="lowLimitSpan">
										<html:text styleClass="tabledata" size="85" maxlength="4000" property="searchKeyword" styleId="search.string"/>
									 </SPAN>
									 <SPAN id="highLimitSpan" style="display: none;">
										&nbsp;&nbsp;&nbsp;<html:text styleClass="tabledata" size="25" property="highLimit" styleId="highLimit" />
									</SPAN>
								</TD>
							</TR>
						</TABLE>
					</TD>
					<TD ALIGN="RIGHT" nowrap>
						<html:submit property="operation" onclick="return submitSearchForm();"><bean:message bundle="search" key="ui.label.Search" /></html:submit>
					   <html:submit property="operation"  onclick="return setOperation('Cancel');"><bean:message bundle="search" key="ui.label.Cancel" /></html:submit>&nbsp;&nbsp;
					</TD>
				</TR>
				<logic:match name="searchForm" property="haveDataFilters" value="true">
					<TR>
							<TD  colspan="2" valign="top" align="left" nowrap style="padding-left: 5px;">
								<B><bean:message bundle="search" key="ui.search.filteron.label" />
								<bean:write name="searchForm" property="filterOn" scope="request" filter="false"/></B>
								<html:hidden property="filterOn"/>
							</TD>
							<TD  nowrap valign="top">
								<html:checkbox property="keepFilters" styleId="keepFilters" value="yes" onclick="return addMultiKeep('searchDimensions');"/>
								<B><bean:message bundle="search" key="ui.search.keepcurrentfilter.label" /></B>
							</TD>
							<TD colspan="3">&nbsp;</TD>
					</TR>
				</logic:match>
				<logic:match name="searchForm" property="addToBCVisibility" value="visible">
					<TR>
							<TD  colspan="2" nowrap valign="top" >
							</TD>
							<TD  nowrap valign="top" >
								 <html:checkbox property="addCurrentFilters" value="yes" onclick="return addFilter(this.form,'SaveAndDisplayCurrentFilter');"/><B><bean:message bundle="search" key="ui.search.addtofilter.label" /></B>
							</TD>
					</TR>
				</logic:match>
			</TABLE>

			<div style="padding-top: 8px"></div>
			<logic:notEqual name="searchForm" property="searchKeyword" value="">
				<logic:equal name="searchForm" property="totalSearch" value="0">
					<TABLE style="margin-left: 1%;">
						<TR>
							<TD class="tdStyle">
								<bean:message bundle="search" key="ui.search.members.empty" />
							</TD>
						</TR>
					</TABLE>
					<logic:notEmpty name="searchForm" property="searchSavedMembers">
						<TABLE class="InnerTableWithBorder" style="background-color: white; border-width: 0;">
							<TR >
								<TD class="tdStyle" >
									<bean:message bundle="search" key="ui.search.successful.message" arg0="${searchForm.totalSavedSearch}"/>
								</TD>
								<TD class="tdStyle" align ="right" style="font-size:10pt">
									<html:button property="operation" title='<%=baseResourceBundle.getValue("ui.message.Click.Apply.to.filter.on.selected.members")%>'  onclick="return checkMemberExist('savedNodes','Apply',event);" >
										<bean:message bundle="search" key="button.apply" />
									</html:button>
									<html:submit property="operation" title='<%=baseResourceBundle.getValue("ui.message.Click.to.remove.selected.members")%>' onclick="return removeMember('savedNodes','remove');" >
										<bean:message bundle="search" key="ui.search.button.remove" />
									</html:submit>
								</TD>
							</TR>
						</TABLE>
						<TABLE class="InnerTableWithBorder">
							<TR>
		 						<TD class="thead"  align="center" width="5%"><INPUT type="checkbox"  name="checkAllSavedNodes"  onClick="checkAllSavedNode(this.form);"></TD>
		 						<TD class="thead" align="center" width="5%"><bean:message bundle="search" key="ui.label.level" /></TD>
								<TD class="thead" align="center" width="90%"><bean:message bundle="search" key="ui.search.saved" />&nbsp;<bean:write name="searchForm" property="searchDimensionSelectedLabel" scope="request"/>&nbsp;<bean:message bundle="search" key="ui.label.Members" /></TD>
							</TR>
           					<logic:iterate id="eachRow" name="searchForm" property="searchSavedMembers" type="com.emptoris.viewer.search.SearchNodeVO" indexId="ctr">
           						<c:choose>
									<c:when test="${ctr % 2 == 0}" >
										<c:set var="rowStyle" value="trEven" scope="page" />
									</c:when>
									<c:otherwise>
										<c:set var="rowStyle" value="trOdd" scope="page" />
									</c:otherwise>
								</c:choose>
								<TR class="${ rowStyle }">
									<TD class=".tdStyle" align="center">
										<INPUT type="checkbox" name="savedNodes" value="<bean:write name="eachRow" property="nodeId"/>" onclick="updateCheckboxes('savedNodes');"/>
									</TD>
									<TD class=".tdStyle" align="center"><bean:write name="eachRow" property="level"/></TD>
									<TD class=".tdStyle" align="left"><bean:write name="eachRow" property="nodeName" /></TD>			    
								</TR>
							</logic:iterate>	 
						</TABLE>
					</logic:notEmpty>
				</logic:equal>
			</logic:notEqual>
			<c:if test="${ ! empty searchForm.searchResults }">	
				<TABLE  class="InnerTableWithBorder" style="background-color: #ECF4FE;" cellspacing="0">
				<bean:define id="pageInfo" name="pageInfo" scope="request" type="com.emptoris.viewer.search.util.PagingInfo" />
				<bean:define id="totalSearch" name="searchForm" scope="request" property="totalSearch" />
					<TR>
						<TD  nowrap align="left"><B>
							<c:if test="${ pageInfo.offSet == 0 }">
								<c:set var="arg0" value="1 - ${ pageInfo.tempSize }" />
							</c:if>
							<c:if test="${ pageInfo.offSet > 0 }">
								<c:set var="arg0" value="${ pageInfo.offSet } - ${ pageInfo.tempSize }" />
							</c:if>
							<bean:message key='ui.search.result.label.with.pagination'  bundle='search' arg0='${ arg0 }' arg1='${ searchForm.totalSearch }' /> 
							</FONT></B>
							&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							<c:if test="${ pageInfo.currentPageNo >1 }">	
								<INPUT TYPE="IMAGE" SRC="jsp/images/beginning_enabled.gif" border="0" onclick="setPageNo(1)" TITLE="<bean:message bundle='search' key='ui.search.tooltip.Move.First' />" />
							</c:if>
							<c:if test="${ pageInfo.currentPageNo <2 }">
								<IMG SRC="jsp/images/beginning_disabled.gif"  BORDER="0" TITLE="<bean:message bundle='search' key='ui.search.tooltip.Move.First' />">	
							</c:if>
							<c:choose>
								<c:when test="${ pageInfo.previous ==true }">
									<INPUT TYPE="IMAGE" SRC="jsp/images/back_enabled.gif" border="0" TITLE="<bean:message bundle='search' key='ui.search.tooltip.Move.Previous' />" onclick="setPageNo(<%= pageInfo.getPreviousPageNo() %>)"/>		
								</c:when>
								<c:otherwise>
										<IMG SRC="jsp/images/back_disabled.gif"  BORDER="0" TITLE="<bean:message bundle='search' key='ui.search.tooltip.Move.Previous' />">
								</c:otherwise>
							</c:choose>
							<c:choose>
								<c:when test="${ pageInfo.next ==true }">
									<INPUT TYPE="IMAGE" SRC="jsp/images/forward_enabled.gif" border="0" TITLE="<bean:message bundle='search' key='ui.search.tooltip.Move.Next' />" onclick="setPageNo(<%= pageInfo.getNextPageNo() %>)"/>		
								</c:when>
								<c:otherwise>
										<IMG SRC="jsp/images/forward_disabled.gif"  BORDER="0" TITLE="<bean:message bundle='search' key='ui.search.tooltip.Move.Next' />">
								</c:otherwise>
							</c:choose>
							<c:choose>
								<c:when test="${ pageInfo.currentPageNo == pageInfo.totalNoOfPages }">
									<IMG SRC="jsp/images/end_disabled.gif"  BORDER="0" TITLE="<bean:message bundle='search' key='ui.search.tooltip.Move.Last' />">		
								</c:when>
								<c:otherwise>
									<INPUT TYPE="IMAGE" SRC="jsp/images/end_enabled.gif" border="0" TITLE="<bean:message bundle='search' key='ui.search.tooltip.Move.Last' />" onclick="setPageNo(<%= pageInfo.getLastPageNo() %>)"/>	
								</c:otherwise>
							</c:choose>
						</TD>
					</TR>
				</TABLE>
				
				<TABLE border="0" class="InnerTableWithBorder" style="background-color: white; border-width: 0;" cellspacing="1">
					<TR>
						<TD width="10%" style="font-size:10pt">
							<logic:greaterThan name="searchForm" property="totalSearch" scope="request" value="0">
								<INPUT type="checkbox"  name="checkAllPg" id="checkAllPg"  onclick="checkAllPage(this);">&nbsp;<bean:message bundle="search" key="ui.search.selectall.across.page.label" arg0="<%=String.valueOf(totalNodeListSize)%>"/>			
							</logic:greaterThan>
						</TD>
						<TD  width="10%" nowrap="nowrap" style="font-size:10pt">
							<INPUT type="checkbox"  name="checkAll"  onClick="checkAllBoxes(this.form, false);">&nbsp;<bean:message bundle="search" key="ui.search.selectall.label" />  
						</TD>
						<TD style="font-size:10pt">
							<INPUT type="checkbox" id="checkAllLeaves" name="checkAllLeaves" onclick="checkAllOfLeaves(this.form);"/>&nbsp;<bean:message bundle="search" key="ui.search.selectallleaf.label" />				
						</TD>
					</TR>
					<TR>
						<TD width="10%" nowrap style="font-size:10pt">
							&nbsp;<bean:message bundle="search" key="ui.search.enterlevel.label" />
						</TD>
						<TD style="font-size:10pt">							
							<INPUT type="text" id="checkAllLevel" name="checkAllLevel"  maxlength="2" size="5"  CLASS="controlStyle"/>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<INPUT type="button" value="<bean:message bundle='search' key='ui.label.Select' />" onclick="checkAllOfLevel(this.form);"/>
						</TD>
						<logic:present  name="searchForm" property="searchSavedMembers">
						<logic:notEmpty name="searchForm" property="searchSavedMembers">
							<TD nowrap style="font-size:10pt;" align="right">
									<bean:message bundle="search" key="ui.search.saved.members.message" arg0="${searchForm.totalSavedSearch}"/>
							</TD>
						</logic:notEmpty>
						</logic:present>
					</TR>
				</TABLE>
	
				<TABLE width="100%" >
					<TR>
						<c:set var="colSpan" value="1" />
						<c:set var="width" value="70%" />
						<c:if test="${ empty searchForm.searchSavedMembers }">
							<c:set var="colSpan" value="2" />
							<c:set var="width" value="100%" />
						</c:if>
						<TD colspan="${ colSpan }" width="${ width }" valign="top">
							<TABLE class="InnerTableWithBorder" style="margin-left:10px;">
	     						<TR>
	     						<TD>&nbsp;</TD>
	     						<bean:size id="attributeCount" name="attributeListToDisplay" />
	     						<bean:size id="measureCount" name="searchForm" property="measureDisplayNames"/>
	     						<!-- Adding 1 for level column  -->
								<c:set var="dynamicColSpan" value="${ attributeCount + measureCount + 1}" />
								<TD style="font-size:10pt;" colspan="${dynamicColSpan}" align="right">
							<html:button property="operation"  title='<%=baseResourceBundle.getValue("ui.message.Click.Apply.to.filter.on.selected.members")%>' onclick="return checkMemberExist('selectedNodes','SaveAndApply',event);">
								<bean:message bundle="search" key="button.apply" />
							</html:button>&nbsp;<html:button property="operation" title='<%=baseResourceBundle.getValue("ui.message.Click.Save.to.keep.selected.members")%>' onclick="sendRequest('saveResults');" >
								<bean:message bundle="search" key="ui.label.Save" />
							</html:button>
						</TD>
								
								</TR>
								<TR>
		 							<TD CLASS="thead" align="center" width="5%"><INPUT type="checkbox"  name="checkAll1"  onClick="checkAllBoxes1(this.form);" title="<bean:message bundle='search' key='ui.search.selectall.label' />"> </TD>
		    						<TD CLASS="thead" align="center" width="5%">&nbsp;<bean:message bundle="search" key="ui.label.level" /></TD>
									<logic:iterate id="item" name="attributeListToDisplay"  >
										<TD CLASS="thead" align="center">&nbsp;<bean:write name="item" property="value"/>&nbsp;</TD>
									</logic:iterate> 
									<logic:iterate id="item" name="searchForm" property="measureDisplayNames"> 
										<TD  CLASS="thead" align="center"> &nbsp;<bean:write name="item"/>&nbsp;</TD>
									</logic:iterate>
    							</TR>
								<logic:present name="searchForm" property="searchResults">	
									<logic:iterate id="eachRow" name="searchForm" property="searchResults" type="com.emptoris.viewer.search.SearchNodeVO" indexId="ctr">		
										<c:choose>
										<c:when test="${ctr % 2 == 0}" >
											<c:set var="rowStyle" value="trEven" scope="page" />
										</c:when>
										<c:otherwise>
											<c:set var="rowStyle" value="trOdd" scope="page" />
										</c:otherwise>
										</c:choose>
			
										<TR class="${ rowStyle }">
											<TD class=".tdStyle" NOWRAP align="center">
												<INPUT type="checkbox" name="selectedNodes" onClick = "largeNodeWarning('<bean:write name='eachRow' property='largeLeafNode'/>',this);updateSelectedNodes(this);" value="<bean:write name="eachRow" property="nodeId"/>::<bean:write name="eachRow" property="nodeName"/>::<bean:write name="eachRow" property="level"/>" id="<bean:write name="eachRow" property="nodeId"/>"/>
											</TD>
											<TD class=".tdStyle" NOWRAP align="center"><bean:write name="eachRow" property="level"/></TD>
											<logic:notEmpty name="eachRow" property="attributesVO">
												<logic:iterate id="attributeValue" name="eachRow" property="attributesVO">
	      		 									<TD class=".tdStyle" align="left"><bean:write name="attributeValue"  /></TD>
	      										</logic:iterate> 
											</logic:notEmpty>
		 									<logic:notEmpty name="eachRow" property="measureValuesForDisplay">
												<logic:iterate id="eachMeasureValue" name="eachRow" property="measureValuesForDisplay">
	      		 									<TD class=".tdStyle" nowrap align="right"><bean:write name="eachMeasureValue"/></TD>
												</logic:iterate> 
											</logic:notEmpty>
										</TR>
									</logic:iterate>
	   							</logic:present>	 
	   						</TABLE>
						</TD>
						<logic:notEmpty name="searchForm" property="searchSavedMembers">
							<TD class=".tdStyle" valign="top">
								<TABLE class="InnerTableWithBorder">
									<TR>
										<TD style="font-size:10pt" colspan="3" nowrap class=".tdStyle" align="right">
											 <html:submit property="operation" title='<%=baseResourceBundle.getValue("ui.message.Click.to.remove.selected.members")%>' onclick="return removeMember('applyNodes','remove');"  >
												<bean:message bundle="search" key="ui.search.button.remove" /> 
											 </html:submit>
										</TD>
									</TR>
									<TR >
										<TD class="thead" align="center" width="5%"><INPUT type="checkbox"  name="checkAllApplyNodes"  onClick="checkAllApplyNode(this.form);"> </TD>
										<TD class="thead" align="center" width="5%"><bean:message bundle="search" key="ui.label.level" /></TD>
										<TD class="thead" align="center" width="90%"><bean:message bundle="search" key="ui.search.saved" />&nbsp;<bean:write name="searchForm" property="selectedDimension" scope="request"/>&nbsp;<bean:message bundle="search" key="ui.label.Members" /></TD>
									</TR>
									<logic:iterate id="eachRow" name="searchForm" property="searchSavedMembers" type="com.emptoris.viewer.search.SearchNodeVO" indexId="ctr">
										<c:choose>
											<c:when test="${ctr % 2 == 0}" >
												<c:set var="rowStyle" value="trEven" scope="page" />
											</c:when>
											<c:otherwise>
												<c:set var="rowStyle" value="trOdd" scope="page" />
											</c:otherwise>
										</c:choose>
										<TR class="${ rowStyle }">
											<TD class=".tdStyle" align="center">
												<INPUT type="checkbox" name="applyNodes" value="<bean:write name="eachRow" property="nodeId"/>" onclick="updateCheckboxes('applyNodes');"/>
											</TD>
											<TD class=".tdStyle" align="center"><bean:write name="eachRow" property="level"/></TD>
											<TD class=".tdStyle" align="left"><bean:write name="eachRow" property="nodeName" /></TD>					  
										</TR>
									</logic:iterate>			         
								</TABLE>			
							</TD> 
						</logic:notEmpty>
					</TR> 	     
				</TABLE>
			</c:if>
			<logic:present  name="searchForm" property="savedMembers">
				<logic:notEmpty name="searchForm" property="savedMembers">
					<TABLE class="InnerTableWithBorder" style="background-color: white; border-width: 0;">
						<TR >
							<TD class=".tdStyle" >
								<bean:message bundle="search" key="ui.search.successful.message" arg0="${searchForm.totalSavedSearch}"/>
							</TD>
							<TD class=".tdStyle" align ="right" style="font-size:10pt">
								<html:button property="operation" title='<%=baseResourceBundle.getValue("ui.message.Click.Apply.to.filter.on.selected.members")%>'  onclick="return checkMemberExist('savedNodes','Apply',event);" >
									<bean:message bundle="search" key="button.apply" />
								</html:button>
								<html:submit property="operation" title='<%=baseResourceBundle.getValue("ui.message.Click.to.remove.selected.members")%>' onclick="return removeMember('savedNodes','remove');" >
									<bean:message bundle="search" key="ui.search.button.remove" />
								</html:submit>
							</TD>
						</TR>
					</TABLE>
					<TABLE class="InnerTableWithBorder">
						<TR>
		 					<TD class="thead"  align="center" width="5%"><INPUT type="checkbox"  name="checkAllSavedNodes"  onClick="checkAllSavedNode(this.form);"></TD>
		 					<TD class="thead" align="center" width="5%"><bean:message bundle="search" key="ui.label.level" /></TD>
							<TD class="thead" align="center" width="90%"><bean:message bundle="search" key="ui.search.saved" />&nbsp;<bean:write name="searchForm" property="searchDimensionSelectedLabel" scope="request"/>&nbsp;<bean:message bundle="search" key="ui.label.Members" /></TD>
						</TR>
           				<logic:iterate id="eachRow" name="searchForm" property="savedMembers" type="com.emptoris.viewer.search.SearchNodeVO" indexId="ctr">
           					<c:choose>
								<c:when test="${ctr % 2 == 0}" >
									<c:set var="rowStyle" value="trEven" scope="page" />
								</c:when>
								<c:otherwise>
									<c:set var="rowStyle" value="trOdd" scope="page" />
								</c:otherwise>
							</c:choose>
							<TR class="${ rowStyle }">
								<TD class=".tdStyle" align="center">
									<INPUT type="checkbox" name="savedNodes" value="<bean:write name="eachRow" property="nodeId"/>" onclick="updateCheckboxes('savedNodes');"/>
								</TD>
								<TD class=".tdStyle" align="center"><bean:write name="eachRow" property="level"/></TD>
								<TD class=".tdStyle" align="left"><bean:write name="eachRow" property="nodeName" /></TD>			    
							</TR>
						</logic:iterate>	 
					</TABLE>
				</logic:notEmpty>
			</logic:present>
			<html:hidden property="searchDimensionSelectedLabel" styleId="searchDimensionSelectedLabel"/>	
			<html:hidden property="selectAllAcrossPage" styleId="selectAllAcrossPage"/>	
			<html:hidden property="searchDimensionSelectedValue" styleId="searchDimensionSelectedValue"/>
			</html:form>

		<SCRIPT language="JavaScript">

		YAHOO.namespace('emptoris.analytics.search.UI');
		(function() {
			var Event = YAHOO.util.Event;
			var Dom = YAHOO.util.Dom;
			YAHOO.emptoris.analytics.search.UI = {
				init: function() {
					var self = YAHOO.emptoris.analytics.search.UI;
					var fromDateField = document.getElementById("search.string");
					var toDateField = document.getElementById("highLimit");
					var dType = document.searchForm.selectedSearchFilterType;
					if (dType == "date") {
						Event.on(fromDateField, "focus", self.openCalendar, [fromDateField, fromDateField]);
						Event.on(toDateField, "focus", self.openCalendar, [toDateField, toDateField]);
					}
					
					progressBar = new YAHOO.widget.Overlay("pb", { fixedcenter:true, visible:false, width:"180px" } );
					progressBar.render(document.body);
				},

				openCalendar: function(e, args) {	
					YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
				}
			}

			Event.onDOMReady(YAHOO.emptoris.analytics.search.UI.init, YAHOO.emptoris.analytics.search.UI, true);
		})();

			function openCalendar(e, args) {	
					YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
			}
		</SCRIPT>

	</BODY>
</HTML:HTML>