<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page pageEncoding="UTF-8" contentType="text/html;charset=UTF-8"%>
<%@page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="org.apache.struts.Globals" %>
<%@ page import="com.emptoris.viewer.controllers.admin.srvrmgmt.util.UsageReportConstants"%>
<%@ page import="java.util.Locale, com.emptoris.viewer.util.CSRFHelper" %>
<%@ page import="com.zeborg.util.WebUtil" %>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,
com.zeborg.expensemap.il8n.EmLocalizationManager"
%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>

<% request.getSession().setAttribute(Globals.LOCALE_KEY, WebUtil.getAppLocale(pageContext)); 
	EmResourceBundle baseBundle=EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, WebUtil.getAppLocale(pageContext));
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.create.usage.report.help.page", WebUtil.getAppLocale(pageContext));
%>

<html>
<head>
	<script src = "/expensemap/jsp/javascript/caparea.js" ></script>
	<SCRIPT language="JavaScript" src="/expensemap/jsp/js/util/htmlDecodeUtil.js" type=text/javascript></SCRIPT>
	
<script language="JavaScript">
		var endandcurrent = "<fmt:message key='ui.error.endandcurrent' />";
		var endandstart = "<fmt:message key='ui.error.endandstart' />";
		var startandcurrent = "<fmt:message key='ui.error.startandcurrent' />";
		var enddate = "<fmt:message key='ui.error.enddate' />";
		var startdate = "<fmt:message key='ui.error.startdate' />";
		var informationrequired = "<fmt:message key='ui.error.usability.informationneeded' />";
</script>

<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/fonts/fonts.css" />

<style type="text/css">
.yui-skin-sam .yui-panel {
position: absolute;
}

.yui-skin-sam .yui-calcontainer{
font-family: Arial, Helvetica, sans-serif;
font: 100%;
	width:160px;
	width:180px !ie;
}
.yui-skin-sam .yui-panel .bd {
	display:block;
	overflow:hidden;	
	width:180px;
	width:200px !ie;
}
.yui-skin-sam .yui-calcontainer .yui-cal-nav{
	margin-left:-6em;
	width:13em;
}

.tableData 	{ font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#0C209B; text-decoration:none; }
.errorMessage {
	text-align: middle;
	font-weight: bold;
	color: red;
}

.hidden {
display: none;
}
</style>

<!-- include jQuery, which is maintained in mainPageHeader.jsp -->
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build//json/json-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource-min.js"></script>

<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>

<SCRIPT language="JavaScript">

/**
 * Get the available users based on the search critrion.
 */
function refreshAvailableUsers() {
	var searchStr = document.getElementById("searchText").value;
	searchStr = searchStr.replace(/^\s*/, "").replace(/\s*$/, "");
	var selectedUsers = document.getElementById('selectedUsers');
	var users=document.getElementById("users");
	users.options.length = 0;
	
	var queryParams="";
	var selectedUsersCount = selectedUsers.options.length;
	for(var i=0; i < selectedUsersCount; i++){
		queryParams += "selectedUserId=" + selectedUsers.options[i].value + "&";
    }	
	var allRoles = document.getElementById("roles");
	var role="";
	for (var k=0;k< allRoles.options.length; k++) {
		if (allRoles.options[k].selected) {
			queryParams += "roleId=" + allRoles.options[k].value + "&";
		}
	}
	queryParams += "userNameCriterion=" + searchStr + "&";
	var showDisabledUsers = document.getElementById("showDisabledUsers").checked;
	queryParams += "showDisabledUsers=" + showDisabledUsers;
	
	var dsXHR = new YAHOO.util.XHRDataSource("/expensemap/admin/getUsersForRoles.shtm");
	dsXHR.responseType = YAHOO.util.XHRDataSource.TYPE_JSON;
	dsXHR.connMethodPost = true;
	dsXHR.responseSchema = { 
		    resultsList : "ResultSet", // String pointer to result data
		    // Field order doesn't matter and not all data is required to have a field
		    fields : [
		              { key: "id" },
		              { key: "name" }
		          ]
	};
	var callBack = function(o, r, p) {
		var userCount = r.results.length;
		if ( userCount > 0 ) {
			for (var i = 0; i < userCount; i++) {
				var opt = new Option(r.results[i].name, r.results[i].id);
				users.options[users.options.length] =opt; 
			}
		}
	};
	dsXHR.sendRequest(queryParams, {success: callBack, failure: callBack});
}


//Delete the selected users from Available Users List and add it to Selected Users List
function moveToRight(source, target ,action) {
    var sc, itemText, i, newIndex, listy;
    target.selectedIndex = -1;
    //Add in Selected User List
	for (i=0; i < source.options.length; i++) {
        if (action == "all" || (action == "single" && source.options[i].selected)){
        	var o=source.options[i];
        	items=new Option(o.text,o.value);
            newIndex=target.options.length;
            target.options[newIndex]=items;
            target.options[newIndex].selected=true;
		}
    }

	//Delete from Available User List
    for (i=0; i < source.options.length; ) {
        if (action == "all" || (action == "single" && source.options[i].selected)){
            source.options[i]=null
        } else {
            i = i + 1;
        }
    }
}
// Delete the selected users from Selected Users List and add them to Available Users List only if they satisfy
// serach criteria and comes under any of the selected roles.
function moveToLeft(source, target ,action) {
    target.selectedIndex = -1;
    var usersWithSearchCriteria = "";
    var usersWithSearchCriteriaCount = 0;
    var searchStr = document.getElementById("searchText").value;
	searchStr = searchStr.replace(/^\s*/, "").replace(/\s*$/, "");

	//Find users satisfing search criteria
    for (var i = 0 ;i < source.options.length ; ) {
        if (action == "all" || (action == "single" && source.options[i].selected)) {        
            if(searchStr == "" || source.options[i].text.indexOf(searchStr) == 0){
            	usersWithSearchCriteriaCount++;
            }
            source.options[i]=null;
        } else {
            i = i + 1;
        }
    }
	
	//Send ajax request Only if there at least one user satisfing search criteria
	if(usersWithSearchCriteriaCount !=0){
		//var args ="refreshAvailableUsersBySelectedUsers" 
		//		  + "," + usersWithSearchCriteriaCount + usersWithSearchCriteria ;
		//sendRequest(args);
		var selectedUsers = document.getElementById('selectedUsers');
		var users=document.getElementById("users");
		for(  i=users.options.length; i >=0 ;i--){
			users.remove(i);
		}
		var queryParams="";
		var selectedUsersCount = selectedUsers.options.length;
		for(var i=0; i < selectedUsersCount; i++){
			queryParams += "selectedUserId=" + selectedUsers.options[i].value + "&";
	    }	
		var allRoles = document.getElementById("roles");
		var role="";
		for (var k=0;k< allRoles.options.length; k++) {
			if (allRoles.options[k].selected) {
				queryParams += "roleId=" + allRoles.options[k].value + "&";
			}
		}
		queryParams += "userNameCriterion=" + searchStr + "&";
		var showDisabledUsers = document.getElementById("showDisabledUsers").checked;
		queryParams += "showDisabledUsers=" + showDisabledUsers;
		var dsXHR = new YAHOO.util.XHRDataSource("/expensemap/admin/getUsersForRoles.shtm");
		dsXHR.responseType = YAHOO.util.XHRDataSource.TYPE_JSON;
		dsXHR.connMethodPost = true;
		dsXHR.responseSchema = { 
			    resultsList : "ResultSet", // String pointer to result data
			    // Field order doesn't matter and not all data is required to have a field
			    fields : [
			              { key: "id" },
			              { key: "name" }
			          ]
		};
		var callBack = function(o, r, p) {
			var userCount = r.results.length;
			if ( userCount > 0 ) {
				for (var i = 0; i < userCount; i++) {
					var opt = new Option(r.results[i].name, r.results[i].id);
					users.options[users.options.length] =opt; 
				}
			}
		};
		dsXHR.sendRequest(queryParams, {success: callBack, failure: callBack});
	}
}

function selectAllSelectedUsers(){
     var selectedUsers = document.getElementById('selectedUsers');
     for(var i=0; i < selectedUsers.options.length ; i++){
     	selectedUsers.options[i].selected=true;
     }
}

function unselectAllSelectedUsers(){
     var selectedUsers = document.getElementById('selectedUsers');
     for(var i=0; i < selectedUsers.options.length ; i++){
     	selectedUsers.options[i].selected=false;
     }
}

function enableButton() {
	if (document.getElementById("roles").selectedIndex != -1){
		document.getElementById("goButton").disabled = false;
	} else {
		document.getElementById("goButton").disabled = true;
	}
}

function cancel(){
	window.location="/expensemap/admin/showAllUsageReports.shtm";
}

function addPleaseSelectOption(selectObject){
	selectObject.options[0] = new Option("<fmt:message key='ui.options.please.select' />","");	
}
function resetOnChange(){
	document.getElementById('selectedUsers').options.length = 0;
	document.getElementById('users').options.length = 0;
	document.getElementById('roles').options.length = 0;
}

function getDatasetsForOrganization(org){
	var datasets=document.getElementById("dataset");
	for(  i=datasets.options.length; i >=0 ;i--){
		datasets.remove(i);
	}	
	resetOnChange();
	init();
	unselectAllSelectedUsers();
	if(org.value==''){
		datasets.disabled=true;
	} else {
		var dsXHR = new YAHOO.util.XHRDataSource("/expensemap/admin/getDatasetsForOrg.shtm");
		dsXHR.responseType = YAHOO.util.XHRDataSource.TYPE_JSON;
		dsXHR.connMethodPost = true;
		dsXHR.responseSchema = { 
			    resultsList : "ResultSet", // String pointer to result data
			    // Field order doesn't matter and not all data is required to have a field
			    fields : [
			              { key: "id" },
			              { key: "name" }
			          ]
		};
		var callBack = function(o, r, p) {
			var dsCount = r.results.length;
			if ( dsCount > 0 ) {
				var datasets=document.getElementById("dataset");
				datasets.disabled=false;
				addPleaseSelectOption(datasets);
				for (var i = 0; i < dsCount; i++) {
					var opt = new Option(r.results[i].name, r.results[i].id);
					datasets.options[datasets.options.length] = opt;
				}
			}
			
		};
		dsXHR.sendRequest("organization=" + org.value, {success: callBack, failure: callBack});
	}
}

function getRolesForDataSet(dataset){
	resetOnChange();
	init();
	unselectAllSelectedUsers();
	if( dataset.value != '' ) {
		var organization=document.getElementById("organization");
		// submitRequest("getRoles",organization);
		var dsXHR = new YAHOO.util.XHRDataSource("/expensemap/admin/getRolesForDataset.shtm");
		dsXHR.responseType = YAHOO.util.XHRDataSource.TYPE_JSON;
		dsXHR.connMethodPost = true;
		dsXHR.responseSchema = { 
			    resultsList : "ResultSet", // String pointer to result data
			    // Field order doesn't matter and not all data is required to have a field
			    fields : [
			              { key: "id" },
			              { key: "name" }
			          ]
		};
		var callBack = function(o, r, p) {
			var roleCount = r.results.length;
			if ( roleCount > 0 ) {
				var roles=document.getElementById("roles");
				for (var i = 0; i < roleCount; i++) {
					var opt = new Option(r.results[i].name, r.results[i].id);
					roles.options[roles.options.length] = opt;
				}
			}
			
		};
		dsXHR.sendRequest("dsId=" + dataset.value, {success: callBack, failure: callBack});
	}
}
function getUsersForRole(selectTag){
	if ( selectTag.value!='' ) {
		var selectedUsers = document.getElementById('selectedUsers');
		var users=document.getElementById("users");
		for(  i=users.options.length; i >=0 ;i--){
			users.remove(i);
		}
		var queryParams="";
		var selectedUsersCount = selectedUsers.options.length;
		for(var i=0; i < selectedUsersCount; i++){
			queryParams += "selectedUserId=" + selectedUsers.options[i].value + "&";
	    }	
		var allRoles = document.getElementById("roles");
		var role="";
		for (var k=0;k< allRoles.options.length; k++) {
			if (allRoles.options[k].selected) {
				queryParams += "roleId=" + allRoles.options[k].value + "&";
			}
		}
		var showDisabledUsers = document.getElementById("showDisabledUsers").checked;
		queryParams += "showDisabledUsers=" + showDisabledUsers;
		
		var dsXHR = new YAHOO.util.XHRDataSource("/expensemap/admin/getUsersForRoles.shtm");
		dsXHR.responseType = YAHOO.util.XHRDataSource.TYPE_JSON;
		dsXHR.connMethodPost = true;
		dsXHR.responseSchema = { 
			    resultsList : "ResultSet", // String pointer to result data
			    // Field order doesn't matter and not all data is required to have a field
			    fields : [
			              { key: "id" },
			              { key: "name" }
			          ]
		};
		var callBack = function(o, r, p) {
			var userCount = r.results.length;
			if ( userCount > 0 ) {
				for (var i = 0; i < userCount; i++) {
					var opt = new Option(r.results[i].name, r.results[i].id);
					users.options[users.options.length] =opt; 
				}
				init();
				unselectAllSelectedUsers();
			}
		};
		dsXHR.sendRequest(queryParams, {success: callBack, failure: callBack});
	}
}

/* Remove disabled users from right side selection box */
function removeDisabledUsersFromRight(){
		var queryParams = "";
		var allRoles = document.getElementById("roles");
		var role = "";
		for (var k=0; k< allRoles.options.length; k++) {
			if (allRoles.options[k].selected) {
				queryParams += "roleId=" + allRoles.options[k].value + "&";
			}
		}
		
		var dsXHR = new YAHOO.util.XHRDataSource("/expensemap/admin/getDisabledUsersForRoles.shtm");
		dsXHR.responseType = YAHOO.util.XHRDataSource.TYPE_JSON;
		dsXHR.connMethodPost = true;
		dsXHR.responseSchema = { 
			    resultsList : "ResultSet", // String pointer to result data
			    // Field order doesn't matter and not all data is required to have a field
			    fields : [
			              { key: "id" },
			              { key: "name" }
			          ]
		};
		var callBack = function(o, r, p) {
			var userCount = r.results.length;
			var disabledUsers = new Array();
			if ( userCount > 0 ) {
				for (var i = 0; i < userCount; i++) {
					disabledUsers[i] = r.results[i].id;
				}
			}
			
			// if there are any disabled users present in the selected users list, remove them
			var selectedUsers = document.getElementById('selectedUsers');
			var selectedUsersCount = selectedUsers.options.length;
			for(var i = selectedUsersCount - 1; i >= 0; i--) {
				for(var j = 0; j < disabledUsers.length; j++) {
					if (selectedUsers.options[i].value == disabledUsers[j]) {
						selectedUsers.options[i] = null;
					}
				}
			}	
		};
		dsXHR.sendRequest(queryParams, {success: callBack, failure: callBack});
}
		
function openHelp(){
   	open( "<%=helpURL%>", "_blank" );
}

function init() {
	document.getElementById("searchText").value = "";

	if (document.getElementById("roles").selectedIndex != -1){
		document.getElementById("goButton").disabled = false;
		document.getElementById("searchText").disabled = false;
	}
	else {
		document.getElementById("goButton").disabled = true;
		document.getElementById("searchText").disabled = true;
	}
	
	var organization = document.getElementById("organization");
	if (organization.value != '') {
		var datasets=document.getElementById("dataset");
		datasets.disabled=false;
	}
}


function StringToDate(userDateString){
	if(userDateString!='' && userDateString!=null && userDateString!='null'){
		var endYear = userDateString.substr(6,4) -0;
		var endMonth = userDateString.substr(0,2) - 1;
		var endDay = userDateString.substr(3,2) - 0;
		userDateString = new Date (endYear, endMonth, endDay);
		return userDateString;
	}
	return null;
}

function validateForm(form) {
	var message = '';
	if ( YAHOO.lang.trim(form.reportName.value) == '' ) {
		message = '${reportNameRequired}';
	}
	if ( YAHOO.lang.trim(form.fromDate.value) == '' ) {
		if (message != '') {
			message += '\n';
		}
		message += '${sDateRequired}';
	}
	if ( YAHOO.lang.trim(form.toDate.value) == '' ) {
		if (message != '') {
			message += '\n';
		}
		message += '${eDateRequired}';
	}
	
	if(!document.getElementById("createUsageReportForm").loginout.checked && 
		    !document.getElementById("createUsageReportForm").dashboards.checked && 
			!document.getElementById("createUsageReportForm").clicks.checked  && 
			!document.getElementById("createUsageReportForm").analytics.checked && 
			!document.getElementById("createUsageReportForm").bookmarks.checked && 
			!document.getElementById("createUsageReportForm").feedbacks.checked && 
		!document.getElementById("createUsageReportForm").crosstabs.checked &&
		!document.getElementById("createUsageReportForm").OLFUsageReport.checked &&
		!document.getElementById("createUsageReportForm").datasetViewed.checked) {
		if (message != '') {
			message += '\n';
		}
		message += '${usageInfoRequired}';
	}
	if (!document.getElementById("createUsageReportForm").OLFUsageReport.checked) {
		var organization = document.getElementById("organization");
		if (organization.value == '') {
			if (message != '') {
				message += '\n';
			}
			message += '${orgRequired}';
			message += '\n' + '${dsRequired}';
			message += '\n' + '${roleRequired}';
			message += '\n' + '${selectedUsersRequired}';
		} else {
			var Dataset = document.getElementById("dataset");
			if (Dataset.value == '') {
				if (message != '') {
					message += '\n';
				}
				message += '${dsRequired}';
				message += '\n' + '${roleRequired}';
				message += '\n' + '${selectedUsersRequired}';
			} else {
				if (document.getElementById("roles").selectedIndex >= 0) {
					var selectedUsers = document.getElementById('selectedUsers');
					var selectedUsersCount = selectedUsers.options.length;
					if (selectedUsersCount <= 0) {
						if (message != '') {
							message += '\n';
						}
						message += '${selectedUsersRequired}';
					}
				} else {
					if (message != '') {
						message += '\n';
					}
					message += '${roleRequired}';
					message += '\n' + '${selectedUsersRequired}';
				}
			}
		}
	}
	
	if (message != '') {
		alert(message);
		return false;
	}
	selectAllSelectedUsers();
	return true;
}

/* Show or hide disabled users from left side and right side selection boxes. */
function toggleDisabledUsers() {
	// Refresh availiable users only when any role is selected
	if (document.getElementById("roles").selectedIndex >= 0) {
		getUsersForRole("dummyvalue");
		
		var showDisabledUsers = document.getElementById("showDisabledUsers").checked;
		if (!showDisabledUsers) {
			removeDisabledUsersFromRight();
		}
	}
}

function disableEnableOLFCheckBox(){
	if(document.getElementById("createUsageReportForm").loginout.checked || 
	    document.getElementById("createUsageReportForm").dashboards.checked || 
		document.getElementById("createUsageReportForm").clicks.checked	|| 
		document.getElementById("createUsageReportForm").analytics.checked || 
		document.getElementById("createUsageReportForm").bookmarks.checked || 
		document.getElementById("createUsageReportForm").feedbacks.checked || 
		document.getElementById("createUsageReportForm").crosstabs.checked ||
		document.getElementById("createUsageReportForm").datasetViewed.checked){
		// If any usgae check box is seleted then user can not create OLF usage report		
		document.getElementById('OLFUsageReport').disabled=true;	
	}else{
		// If OLF check box is selected then user can not create other usage reprot
		document.getElementById('OLFUsageReport').disabled=false;
	}
	checkUncheckSelectAll();
}

function checkUncheckSelectAll(){
	if(document.getElementById("createUsageReportForm").loginout.checked && 
	    document.getElementById("createUsageReportForm").dashboards.checked && 
		document.getElementById("createUsageReportForm").clicks.checked	&& 
		document.getElementById("createUsageReportForm").analytics.checked && 
		document.getElementById("createUsageReportForm").bookmarks.checked && 
		document.getElementById("createUsageReportForm").feedbacks.checked && 
		document.getElementById("createUsageReportForm").crosstabs.checked &&
		document.getElementById("createUsageReportForm").datasetViewed.checked){
		
		document.getElementById('createUsageReportForm').selectall.checked=true;
	}else{
		document.getElementById('createUsageReportForm').selectall.checked=false;
		
	}

}

function checkSelectAll(){
	var usageSelectAll = document.getElementById("selectall").checked;
	if ( checkSelectAll ) {	    			
		document.getElementById('loginout').checked = usageSelectAll;
		document.getElementById('dashboards').checked = usageSelectAll;
		document.getElementById('clicks').checked = usageSelectAll;
		document.getElementById('analytics').checked = usageSelectAll;
		document.getElementById('bookmarks').checked = usageSelectAll;
		document.getElementById('feedbacks').checked = usageSelectAll;
		document.getElementById('crosstabs').checked = usageSelectAll;
		document.getElementById('datasetViewed').checked = usageSelectAll;
		document.getElementById('OLFUsageReport').disabled = usageSelectAll;
	} else {
		document.getElementById('loginout').checked = usageSelectAll;
		document.getElementById('dashboards').checked = usageSelectAll;
		document.getElementById('clicks').checked = usageSelectAll;
		document.getElementById('analytics').checked = usageSelectAll;
		document.getElementById('bookmarks').checked = usageSelectAll;
		document.getElementById('feedbacks').checked = usageSelectAll;
		document.getElementById('crosstabs').checked = usageSelectAll;
		document.getElementById('datasetViewed').checked = usageSelectAll;
		document.getElementById('OLFUsageReport').disabled = usageSelectAll;
	}

}

</script>
</head>
<body class="yui-skin-sam" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" bgcolor="#CED7E7" onload="init();">
<c:forEach items="${error}" var="m" >
<span class="errorMessage"><spring:message message="${m}" htmlEscape="false"/></span><br/>
</c:forEach>
<form:form action="/expensemap/admin/createUsageReport.shtm" commandName="usageReportForm" id="createUsageReportForm" onsubmit="return validateForm(this);">
<table width="80%" border="0" cellpadding="1" cellspacing="1" bgcolor="#336699" align="center">
<tr>
	<td align="right" nowrap="nowrap" height="19" width="80%" valign=top bgcolor="#336699">
	<table width="100%" border="0" cellpadding="0" cellspacing="0" bgcolor="#336699">
	<tr>
		<td width="80%" style="font-family:Arial,Helvetica,sans-serif; font-size:11px; color:#FFFFFF">
		<B><FONT size="+1"><fmt:message key="ui.usability.title" /></font></B>
		</td>
		<td><a href="/expensemap/admin/showAllUsageReports.shtm"><font color="#FFFFFF" size="1"><fmt:message key="ui.usability.allreports" /></font></a></td>
		<td>
			<a href="#" onclick="openHelp();">
				<img  src="/expensemap/jsp/images/help.gif" border="0" title="<fmt:message  key='ui.label.Help'/>"/>
			</a>
		</td>	
	</tr>
	</table>
	</td>
</tr>
</table>
<center>
<table width="80%" border="0" cellpadding="1" cellspacing="1" bgcolor="#FFFFFF" id="mainFormTable">
	<tr>
		<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap" width="30%">&nbsp;<fmt:message key="ui.label.Name" /><font color="red"> *</font></td>
		<td align="left"><form:input path="reportName" id="reportname"size="25" maxlength="50" /></td>
	</tr>
	<tr>
		<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap">&nbsp;<fmt:message key="ui.usability.startdate" /><font color="red"> *</font></td>
		<td align="left"><form:input path="fromDate" id="fromDate" /></td>
	</tr>
	<tr>
		<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap">&nbsp;<fmt:message key="ui.usability.enddate" /><font color="red"> *</font></td>
		<td align="left"><form:input path="toDate" id="toDate" /></td>
	</tr>
	<tr>
		<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap">&nbsp;<fmt:message key="ui.usability.selectinformation" /><font color="red"> *</font>
			<BR>(<fmt:message key="ui.usability.mandatoryinformation" />)
			<BR>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<form:checkbox path="reportOptions" onclick="checkSelectAll();" id="selectall" value="SelectAll" /><fmt:message key="ui.usability.SelectAll" />
		</td>
		<td bgcolor="#FFFFFF" class="tabledata" nowrap="nowrap" colspan="2">
			<table width="100%" align="left">
			<tr> 
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<form:checkbox path="reportOptions" onclick="disableEnableOLFCheckBox();" id="loginout" value="Login"/><fmt:message key="ui.usability.loginout" />
				</td>
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<form:checkbox path="reportOptions" onclick="disableEnableOLFCheckBox();" id="dashboards" value="Dashboards" /><fmt:message key="ui.label.Dashboards" />
				</td>
				<td class="tabledata" nowrap="nowrap">
					<form:checkbox path="olfUsageReport" id="OLFUsageReport" /><fmt:message key="ui.title.online.feedback" />
				</td>
			</tr>
			<tr>
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<form:checkbox path="reportOptions" onclick="disableEnableOLFCheckBox();" id="clicks" value="Clicks" /><fmt:message key="ui.usability.clicks" />
				</td>
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<form:checkbox path="reportOptions" onclick="disableEnableOLFCheckBox();" id="analytics" value="Analytics" /><fmt:message key="ui.label.Analytics" />
				</td>
			</tr>
			<tr>
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<form:checkbox path="reportOptions" onclick="disableEnableOLFCheckBox();" id="bookmarks" value="Bookmark" /><fmt:message key="ui.label.Bookmarks" />
				</td>
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<form:checkbox path="reportOptions" onclick="disableEnableOLFCheckBox();" id="feedbacks" value="Feedbacks" /><fmt:message key="ui.usability.Feedbacks" />
				</td>
			</tr>
			<tr>
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<form:checkbox path="reportOptions" onclick="disableEnableOLFCheckBox();" id="crosstabs" value="Crosstab" /><fmt:message key="ui.label.tabulation.menu" />
				</td>
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<form:checkbox path="reportOptions" onclick="disableEnableOLFCheckBox();" id="datasetViewed" value="Dataset" /><fmt:message key="ui.usability.report.heading.dataset.viewed" />
				</td>
			</tr>
			</table>
		</td>
	</tr>
	<tr class="optional visible">
		<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap">&nbsp;<fmt:message key="ui.usability.organization" /><font color="red"> *</font></td>
		<td align="left">
			<form:select path="organization" size="1" onchange="getDatasetsForOrganization(this);" id="organization">
				<form:option value="" ><fmt:message key="ui.options.please.select" /></form:option>
				<form:options items="${organizations}" itemValue="id" itemLabel="companyNameCode" />
			</form:select>								  
		</td>
	</tr>							
	<tr class="optional visible">
		<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap">&nbsp;<fmt:message key="ui.usability.datasets" /><font color="red"> *</font></td>
		<td align="left">
			<form:select path="dataset" size="1" onchange="getRolesForDataSet(this);" id="dataset">
				<form:options items="${datasets}" itemLabel="displayName" itemValue="id"/>
			</form:select>
		</td>
	</tr>								
	<tr class="optional visible">
		<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap">&nbsp;<fmt:message key="ui.label.Role" /><font color="red"> *</font></td>
		<td align="left">
			<form:select path="selectedRoleIds" multiple="true" size="4" cssStyle="width:185px" onchange="getUsersForRole(this);enableButton();" id="roles">
				<form:options items="${roles}" itemLabel="name" itemValue="id"/>
			</form:select>
			<input type="hidden" name="newselect" value="">										
		</td>
	</tr>
	<tr class="optional visible">
		<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap">
			<table>
			<tr>
				<td class="tabledata" rowspan="2" align="center" valign="middle"><fmt:message key="ui.label.User" /><font color="red"> *</font></td>
				<td class="tabledata">
					<input type="text" name="searchText" size="25" maxlength="50" id="searchText"/>&nbsp;
					<input type="button" name="goButton" onclick="refreshAvailableUsers();" id="goButton" value="<fmt:message key='ui.button.Go' />" />
				</td>
			</tr>
			<tr><td class="tabledata"><fmt:message key="ui.usability.search.byuser.text" /></td></tr>
			<tr>
				<td class="tabledata" nowrap="nowrap" colspan="2">
					<div id="showDisabledUsersDiv" style="display: inline;">
						<form:checkbox path="reportOptions" onclick="toggleDisabledUsers();" id="showDisabledUsers" value="showDisabledUsers"/> <fmt:message key="ui.usability.includeDisabledUsers" />
					</div>
				</td>			
			</tr>
			</table>
		</td>
		<td align="left" valign="top" class="tabledata">
			<table>
			<tr>
				<td class="tabledata" align="center"><fmt:message key="ui.label.Available.Users" /></td>
				<td class="tabledata" >&nbsp;</td>
				<td class="tabledata"><fmt:message key="ui.usability.selected.users.text" /></td>
			</tr>
			<tr>
				<td class="tabledata">
					<select name="users" multiple="multiple" size="4" style="width:185px" id="users">
						<c:forEach items="${availableUsers}" var="u"><option value="${u.id}">${u.displayName}</option></c:forEach>
					</select>
				</td>
				<td>
					<img src="/expensemap/jsp/nav_images/move_all_to_right_icon.gif" onclick="moveToRight(document.getElementById('users'), document.getElementById('selectedUsers'), 'all');"><br/>
					<img src="/expensemap/jsp/nav_images/move_to_right_icon.gif" onclick="moveToRight(document.getElementById('users'), document.getElementById('selectedUsers'), 'single');"><br/>
					<img src="/expensemap/jsp/nav_images/move_to_left_icon.gif" onclick="moveToLeft(document.getElementById('selectedUsers'), document.getElementById('users'), 'single');"><br/>
					<img src="/expensemap/jsp/nav_images/move_all_to_left_icon.gif" onclick="moveToLeft(document.getElementById('selectedUsers'), document.getElementById('users'), 'all');">
				</td>
				<td class="tabledata">
					<form:select path="selectedUserIds" multiple="true" size="4" cssStyle="width:185px" id="selectedUsers" items="${selectedUsers}" itemLabel="displayName" itemValue="id">
					</form:select>
				</td>
			</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td colspan="2" align="center">
		<input type="submit" value="<fmt:message key='button.submit' />" />&nbsp;&nbsp;
		<input type="button" value="<fmt:message key='ui.label.Cancel' />" onclick="cancel();" />
		</td>
	</tr>
</table>
</center>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form:form>

<script language="JavaScript">

YAHOO.namespace('emptoris.create.usage.UI');
(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.emptoris.create.usage.UI = {
		init: function() {
			var self = YAHOO.emptoris.create.usage.UI;
			var toDate = document.getElementById("toDate");
			var fromDate = document.getElementById("fromDate");
            Event.on(toDate, "focus", self.openCalendar, [toDate, toDate]);
            Event.on(fromDate, "focus", self.openCalendar, [fromDate, fromDate]);
            
            var toggleDisplayedRows = function() {
            	var optionalRows = Dom.getElementsByClassName("optional", "tr", "mainFormTable");
            	var olfEnabled = Dom.get("OLFUsageReport").checked;
	    		if ( olfEnabled ) {	    			
	    			for(var i = optionalRows.length; i >= 0; i--) {
	    				Dom.addClass(optionalRows[i], "hidden");
	    			}
	    		} else {
	    			for(var i = optionalRows.length; i >= 0; i--) {
	    				Dom.removeClass(optionalRows[i], "hidden");
	    			}
	    		}
	    		document.getElementById('loginout').disabled=olfEnabled;
	    		document.getElementById('dashboards').disabled=olfEnabled;
	    		document.getElementById('clicks').disabled=olfEnabled;
	    		document.getElementById('analytics').disabled=olfEnabled;
	    		document.getElementById('bookmarks').disabled=olfEnabled;
	    		document.getElementById('feedbacks').disabled=olfEnabled;
	    		document.getElementById('crosstabs').disabled=olfEnabled;
	    		document.getElementById('datasetViewed').disabled=olfEnabled;
	    		document.getElementById('selectall').disabled=olfEnabled;
				/* align searchText and showDisabledUsers checkbox vertically. */
				var searchTextLeft = jQuery("#searchText").position().left;
				jQuery("#showDisabledUsersDiv").css({"position": "absolute", "left": searchTextLeft});
            }

            Event.on("OLFUsageReport", "click", toggleDisplayedRows);
            
		},

		openCalendar: function(e, args) {
    		YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}');
		}
	}

	Event.onDOMReady(YAHOO.emptoris.create.usage.UI.init, YAHOO.emptoris.create.usage.UI, true);
})();
</script>
</body>
</html>