<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>


<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="com.zeborg.expensemap.view2.ZSession, com.emptoris.viewer.util.CSRFHelper"%>
<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@ page pageEncoding="UTF-8" contentType="text/html;charset=UTF-8"%>

<%	ZSession zs = ZSessionUtil.getZSession(pageContext);%>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	

<html>
		
<head>
<link rel="stylesheet" type="text/css" href="../stylesheets/macromap.css">
<style type="text/css">
.tabledata {
	color: black !important;
	font-family: verdana;
	font-size: 11px;
	text-decoration: none;
	padding-left: 5px;
}

.heading {
	font-family: verdana;
	font-size: 11px;
	color: #31659C;
	text-align: center;
	background-color: A5B6DE;
	font-weight: bold
}
.myHeading {
	font-family: verdana;
	font-size: 11px;
	color: black !important;
}

A { font-family:verdana; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:none; }
A:LINK { font-family:verdana; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:none; }
A:ACTIVE { font-family:verdana; font-size:12px; font-weight:bold; color:#FF0000; text-decoration:underline; }
A:VISITED { font-family:verdana; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:none; }
A:HOVER { font-family:verdana; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:underline; }

</style>

<script type="text/javascript">

function exportToExcel(){
	
	if(!confirm('<fmt:message key="ui.confirm.message.for.export.excel"/>')) return false;
	var theForm = document.getElementById('usageReportForm');
	theForm.exportType.value="EXCEL";
	theForm.method="GET";
	theForm.action="/expensemap/admin/getDetailUsageReport.shtm";
	theForm.submit();	
}

function printUsageReport(){
	var theForm = document.getElementById('usageReportForm');
	theForm.exportType.value="PRINT";
	theForm.method="GET";
	theForm.action="/expensemap/admin/getDetailUsageReport.shtm";
	theForm.target="_blank";
	theForm.submit();	
}

</script>

</head>

<body leftmargin="0" rightmargin="0" topmargin="0" marginwidth="0" marginheight="0" bgcolor="#CED7E7">	
<form id="usageReportForm">
<table width="100%" border="0" cellpadding="1" cellspacing="0" bgcolor="#336699">
<tr>
<!-- 44974 link to take user back to report list-->
<td width="100%" height="21">
<a href="/expensemap/admin/showAllUsageReports.shtm"> &nbsp;<fmt:message key="ui.usability.allreports"/></a>
</td>
<td align="right" nowrap height="21"></td>
<c:if test="${ canExport == true }">
<td>
	<a onclick="exportToExcel();" href="#">
	<img src="../jsp/images/excel_new.gif" width="16" height="16" border="0" title='<fmt:message key="ui.usability.export.excel"/>' >
	</a>
</td>
<td></td>
<td>
	<a onclick="printUsageReport();" href="#">
		<img src="../jsp/images/print.gif" width="16" height="16" border="0" title='<fmt:message key="ui.usability.print"/>' >
	</a>
</td>
<td></td>
</c:if>
</tr>
</table>

<table class="tabledata">
<tr>
<th align="left" class="myHeading"><fmt:message key="ui.report.table.header.name" />:</th>
<th align="left"><c:out value="${ usageReport.usageReportVO.reportName }" /></th>
</tr>
<tr>
<th align="left" class="myHeading" ><fmt:message key="ui.label.Date.Created" />:</th>
<th align="left"><fmt:formatDate  value="${ usageReport.usageReportVO.creationDate }" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}"/></th>
</tr>
<c:if test="${ ! usageReport.usageReportVO.olfUsageReportRequest}" >
<tr>
<th align="left" class="myHeading"><fmt:message key="ui.label.Company" />:</th>
<th align="left"><c:out value="${ usageReport.usageReportVO.companyId }" /></th>
</tr>
<tr>
<th align="left" class="myHeading"><fmt:message key="ui.label.Dataset" />:</th>
<th align="left"><c:out value="${ usageReport.usageReportVO.datasetId }" /></th>
</tr>
</c:if>
<tr>
<th align="left" class="myHeading"><fmt:message key="ui.usability.startdate" />:</th>
<th align="left"><fmt:formatDate  value="${ usageReport.usageReportVO.startDate }" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" /></th>
</tr>
<tr>
<th align="left" class="myHeading"><fmt:message key="ui.usability.enddate" />:</th>
<th align="left"><fmt:formatDate  value="${ usageReport.usageReportVO.endDate }" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" /></th>
</tr>
</table>
<table width="100%" border="1" cellspacing="0" cellpadding="3">
	<tr height="20" class="heading">
		<th width="15%" valign="bottom"><fmt:message key="ui.usability.report.heading.user" /></th>
		<th width="15%" valign="bottom"><fmt:message key="ui.usability.report.heading.display.name" /></th>
		<c:choose>
			<c:when test="${usageReport.usageReportVO.olfUsageReportRequest}">
				<th valign="bottom"><fmt:message key="ui.usability.report.heading.datasetname" /></th>
				<th valign="bottom"><fmt:message key="ui.usability.report.heading.feedbackapplied.date" /></th>
				<th valign="bottom"><fmt:message key="ui.usability.report.heading.addcount" /></th>
				<th valign="bottom"><fmt:message key="ui.usability.report.heading.mapcount" /></th>
				<th valign="bottom"><fmt:message key="ui.usability.report.heading.movecount" /></th>
				<th valign="bottom"><fmt:message key="ui.usability.report.heading.renamecount" /></th>
				<th valign="bottom"><fmt:message key="ui.usability.report.heading.total" /></th>
			</c:when>
			<c:otherwise>
				<c:if test="${usageReport.usageReportVO.login}">
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.logins" /></th>				
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.days" /></th>
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.firstday" /></th>
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.lastday" /></th>
				</c:if>
				<c:if test="${usageReport.usageReportVO.datasetAccess}">
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.dataset.viewed" /></th>
				</c:if>
				<c:if test="${usageReport.usageReportVO.click}">
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.clicks" /></th>
				</c:if>
				<c:if test="${usageReport.usageReportVO.bookmark}">
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.bookmarks" /></th>
				</c:if>
				<c:if test="${usageReport.usageReportVO.tabulation}">
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.crosstabs" /></th>
				</c:if>
				<c:if test="${usageReport.usageReportVO.dashboard}">
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.dashboards" /></th>
				</c:if>
				<c:if test="${usageReport.usageReportVO.analytic}">
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.analytics" /></th>
				</c:if>
				<c:if test="${usageReport.usageReportVO.feedback}">
					<th valign="bottom"><fmt:message key="ui.usability.report.heading.feedbacks" /></th>	
				</c:if>
			</c:otherwise>
		</c:choose>
	</tr>
		<c:forEach items="${ usageReport.usageReportRows }" var="row">
			<tr bgcolor="#dee3ef" align="center">			
				<td class="tabledata" align="left"><c:out value="${ row.userName }" /></td>
				<td class="tabledata" align="left"><c:out value="${ row.displayName }" /></td>
				<c:choose>
					<c:when test="${ usageReport.usageReportVO.olfUsageReportRequest}">
						<td class="tabledata"><c:out value="${ row.dataSetName }" /></td>
						<td class="tabledata">
							<c:choose>
								<c:when test="${ empty row.feedBackAppliedDate }">&nbsp;-&nbsp;</c:when>
								<c:otherwise><fmt:formatDate value="${row.feedBackAppliedDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" /></c:otherwise>
							</c:choose>
						</td>
						<td class="tabledata"><c:out value="${ row.addFeedBackCount }" /></td>
						<td class="tabledata"><c:out value="${ row.mapFeedBackCount }" /></td>
						<td class="tabledata"><c:out value="${ row.moveFeedBackCount }" /></td>
						<td class="tabledata"><c:out value="${ row.renameFeedBackCount }" /></td>
						<td class="tabledata"><c:out value="${ row.totalFeedBackCount }" /></td>
					</c:when>
					<c:otherwise>
						<c:if test="${usageReport.usageReportVO.login}">
							<td class="tabledata"><c:out value="${ row.totalLogins }" /></td>
							<td class="tabledata"><c:out value="${ row.totalDays }" /></td>
							<td class="tabledata">
								<c:choose>
									<c:when test="${ empty row.firstLoginDate }">&nbsp;-&nbsp;</c:when>
									<c:otherwise><fmt:formatDate value="${row.firstLoginDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" /></c:otherwise>
								</c:choose>
							</td>
							<td class="tabledata">
								<c:choose>
									<c:when test="${ empty row.lastLoginDate }">&nbsp;-&nbsp;</c:when>
									<c:otherwise><fmt:formatDate value="${row.lastLoginDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern}" /></c:otherwise>
								</c:choose>
							</td>
						</c:if>
						<c:if test="${usageReport.usageReportVO.datasetAccess}">
							<td class="tabledata"><c:out value="${ row.datasetViewedCount }" /></td>
						</c:if>
						<c:if test="${usageReport.usageReportVO.click}">
							<td class="tabledata"><c:out value="${ row.totalClicks }" /></td>
						</c:if>
						<c:if test="${usageReport.usageReportVO.bookmark}">
							<td class="tabledata"><c:out value="${ row.bookmarksCreated }" /></td>
						</c:if>
						<c:if test="${usageReport.usageReportVO.tabulation}">
							<td class="tabledata"><c:out value="${ row.crosstabsRun }" /></td>
						</c:if>
						<c:if test="${usageReport.usageReportVO.dashboard}">
							<td class="tabledata"><c:out value="${ row.dashboardsViewed }" /></td>
						</c:if>
						<c:if test="${usageReport.usageReportVO.analytic}">
							<td class="tabledata"><c:out value="${ row.analyticsViewed }" /></td>
						</c:if>
						<c:if test="${usageReport.usageReportVO.feedback}">
							<td class="tabledata"><c:out value="${ row.feedbacksSubmitted }" /></td>
						</c:if>
					</c:otherwise>
				</c:choose>
			</tr>
		</c:forEach>
	</table>
	<input type="hidden" name="detailReportId" id="detailReportId" value="${param.detailReportId}"/>
	<input type="hidden" name="exportType" id="exportType" value=""/>
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form>
</body>
</html>