<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page language="java"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>
<%@page import="java.util.List,java.util.Locale, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="org.apache.struts.Globals,com.zeborg.util.WebUtil" %>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="com.emptoris.cubem.service.support.DatasetConstants" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>

<%
Locale locale = WebUtil.getAppLocale(pageContext);
request.getSession(false).setAttribute(Globals.LOCALE_KEY, locale);
ZSession zs = ZSessionUtil.getFromSession(pageContext);
%>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	

<html>
<head>

<STYLE TYPE="text/css">
<!--
.text { font-family:arial,helvetica,sans-serif; font-size:14px; font-weight:bold; color:#003366; }
.error { font-family:arial,helvetica,sans-serif; font-size:12px; font-weight:bold; color:#FF0000; }
.login { font-family:arial,helvetica,sans-serif; font-size:12px; font-weight:bold; color:#003366; }
.warning{font-family:'Arial, Helvetica, sans-serif';font-size:'10pt';font-weight:'bold';color: Red;background-color : transparent;}
.spacer { font-family:Arial,Helvetica,sans-serif; font-size:3px; color:#FFFFFF; }
.smallwhite { font-family:Arial,Helvetica,sans-serif; font-size:12px; color:#FFFFFF; text-decoration:none; }
A { font-family:Arial,Helvetica,sans-serif; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:none; }
A:LINK { font-family:Arial,Helvetica,sans-serif; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:none; }
A:ACTIVE { font-family:Arial,Helvetica,sans-serif; font-size:12px; font-weight:bold; color:#FF0000; text-decoration:underline; }
A:VISITED { font-family:Arial,Helvetica,sans-serif; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:none; }
A:HOVER { font-family:Arial,Helvetica,sans-serif; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:underline; }
.tabledata 	{ font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#0C209B; text-decoration:none; }
.LIST_SORT_HEAD { FONT-WEIGHT: normal; FONT-SIZE: 11px; COLOR: #FFFFFF; FONT-FAMILY: arial, helvetica, sans-serif;TEXT-ALIGN: left; TEXT-DECORATION: none }
-->
.errorMessage {
	text-align: middle;
	font-weight: bold;
	color: red;
}
</STYLE>

<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">
<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/dataenrichment.js"></SCRIPT>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<SCRIPT src = "/expensemap/jsp/javascript/header.js"></SCRIPT>
<script src="/expensemap/jsp/javascript/stringbuffer.js" ></script>

<script language="JavaScript">
var crosstabError = '<spring:message code="ui.crosstab.error"/>';
var loadingInProgressInnerHTML = '<span><a href="/expensemap/datasetLoadingMonitoring.shtm?dataSetId=${datasetForm.id}&returnTo=editDatasetPage"><font style="color: #0C209B;"><spring:message code="ui.label.datasetloading.in.progress.link"/></font></a></span>';

function changePassword(obj){
	obj.style.display="inline";
	obj.removeAttribute("disabled");
	obj.value="";
	obj.focus();
}

function saveChanges(){
	var frm = document.getElementById("dataSetForm");
	if(validateData() && isOnlineFeedbackConfigDefined()){
		frm.method="post";
		frm.action="/expensemap/saveDataset.xhtm?action=save";
		frm.submit();
	}
	return false;
}

function saveAndUpdateStat(){
	
	document.getElementById("linkToDatasetProgressMonitoringPage").innerHTML = loadingInProgressInnerHTML;
    var frm = document.getElementById("dataSetForm");	
    if ( validateData() && isOnlineFeedbackConfigDefined() ) {
    	document.getElementById("doPublish").disabled = false;
		frm.method="post";
		frm.action="/expensemap/saveDataset.xhtm";
		frm.submit();
		showLinkToDatasetLoadingProgressMonitoringPage();
	    disableAllInputs();
	}
	return false;
}

function unLoad(){
    var frm = document.getElementById("dataSetForm");
	frm.method="post";
	frm.action="/expensemap/unloadDataset.xhtm";
	frm.submit();
}

function cancelTask(){
	window.self.location.href="/expensemap/getDatasetList.xhtm";;
}

function getLmyraConfig(){
	window.open("/expensemap/manageOlapAgents.xhtm","LMyRAConfig","width=650,height=413,scrollbars=yes,status=no,resizable=no");
}

function getOnlineFeedbackConfig(){
if(isSDMCubeCompatible()){
	var url = "/expensemap/rulemanagement/OnlineFeedbackConfigurationAction.do?operation=loadOnlineFeedbackTypeForm&datasetId=${datasetForm.id}&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
	var ht = 590;
    var wt = 700;
	var left = (screen.width/2)-(wt/2);
	var top = (screen.height/2)-(ht/2);      			
	window.open(url, 'OnlineFeedBack_Window','resizable=yes,status=yes,width='+wt+',height='+ht+',left='+left+',top='+top);
	}
}

function enableOnlineFeedbackoption(){
	var feedbackEnableObj = document.getElementById('feedbackEnableCheckBox');
	var onlineFeedBackEnableObj = document.getElementById('onlineFeedbackCheckBox');
	var onlineFeedbackBtnObj = document.getElementById('onlineFeedbackBtn');

	if(feedbackEnableObj.checked){		
		onlineFeedBackEnableObj.disabled=false;
	}else{
		onlineFeedBackEnableObj.checked=false;
		onlineFeedBackEnableObj.disabled=true;		
		onlineFeedbackBtnObj.disabled=true;
	}
}

function enableOnlineFeedbackConfigButton(){
	var onlineFeedBackEnableObj = document.getElementById('onlineFeedbackCheckBox');
	var onlineFeedbackBtnObj = document.getElementById('onlineFeedbackBtn');
	if(onlineFeedBackEnableObj.checked){
		onlineFeedbackBtnObj.disabled=false;
	}else{
		onlineFeedbackBtnObj.disabled=true;
	}
}

function init(){
	enableOnlineFeedbackoption();
	enableOnlineFeedbackConfigButton();
}

function isOnlineFeedbackConfigDefined(){
	var addEnable = document.getElementById('addEnabled');
	var mapEnable = document.getElementById('mapEnabled');
	var renameEnable = document.getElementById('renameEnabled');
	var moveEnable = document.getElementById('moveEnabled');
	var onlineFeedBackEnableObj = document.getElementById('onlineFeedbackCheckBox');
	if(onlineFeedBackEnableObj.checked){
		if(addEnable.value == 'true' || mapEnable.value == 'true' 
			|| renameEnable.value == 'true' || moveEnable.value == 'true'){
			return true; 
		}else{
			alert('<spring:message code="ui.admin.configure.online.feedback"/>');
			return false;
		}
	}
	return true;
}
	function validateCompatibilitySDM(ajaxResponse){
		var data = eval(ajaxResponse);
		// If there is no data in the response, ignore this
		if(data[0] == "validateCompatibilitySDM" ){
			if(!data[1]){
				alert(data[2]);
				return false;
			}
		}
		
		return true;
	}

	function isSDMCubeCompatible(){
		var frm = document.getElementById('dataSetForm');
		var dataSetJdbcUrl = frm.jdbcURL.value;
		
		try {			
			var url = "/expensemap/rulemanagement/OnlineFeedbackConfigurationAction.do?operation=checkCubeIsCompatibleWithSDM&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
			var params = {};
			params['jdbcUrl'] = dataSetJdbcUrl;
			params['jdbcUserName'] = frm.jdbcUserName.value;
			params['jdbcPassword'] = frm.jdbcPassword.value;
			params['datasetId'] =  '${datasetForm.id}';
			var ajaxResponse = jQuery.ajax({
				url: url,
				type: "POST",
				data: params,
				async: false,
				error: function(xhr, status, error) {
					 alert('<spring:message code="ui.admin.problem.in.retrieving.data"/> ' + xhr.statusText);
				}
			}).responseText;
		
			return validateCompatibilitySDM(ajaxResponse);
		} catch(e) {
			 alert(e.message);
		}
	}

	function validateData(){
		return validateDataSetName() && validateDataSetDisplayName() && validateDataSetJdbcUserName() && validateDataSetJdbcPassword() &&
		validateDataSetJdbcUrl() && validateTabulationReportingEngineUrl() && validateDataSetTabulationJdbcUserName() &&  validateDataSetTabulationJdbcPassword() &&
		validateTabulationReportingEngineJdbcUrl() && validateAnalyticsReportingEngineUrl() &&  validateDataSetAnalyticsJdbcUserName() && validateDataSetAnalyticsJdbcPassword() &&
		validateAnalyticJdbcUrl() && validateDashboardPdfReportingEngineUrl() && validateDataSetPdfJdbcUserName() && validateDataSetPdfJdbcPassword() &&
		validatePdfReportingEngineJdbcUrl() && validateMaxCrossTabNodes();
	}

	function validateInteger(field, message){
		if ( typeof field != "undefined" && !isInt(field.value)) {
			alert(message);
			field.value="";
			field.focus();
			return false;
		}
		return true;
	}

	function validatePositiveInteger(field, message){
		
		var num =Number(field.value);
			if(num<0){
				alert(message);
				field.value="";
				field.focus();
				return false;
			}
		return true;
	}


	function validateDataSetName(){
		var datasetobj = document.dataSetForm.name;
		return validateRequired(datasetobj,"<spring:message code='errors.dataset.name.required'/>");
	}
	
	function validateDataSetDisplayName(){
		var displayNameobj = document.dataSetForm.displayName;
		return validateRequired(displayNameobj,"<spring:message code='errors.dataset.display.name.required'/>");
	}
	
	function validateDataSetJdbcUserName(){
		var displayNameobj = document.dataSetForm.jdbcUserName;
		return validateRequired(displayNameobj,"<spring:message code='error.dataset.jdbcusername.required'/>");
	}
	
	function validateDataSetJdbcPassword(){
		var displayNameobj = document.dataSetForm.jdbcPassword;
		return validateRequired(displayNameobj,"<spring:message code='error.dataset.jdbcpassword.required'/>");
	}

	function validateDataSetJdbcUrl(){
		var dataSetJdbcUrlObj = document.dataSetForm.jdbcURL;
		return validateRequired(dataSetJdbcUrlObj,"<spring:message code='errors.dataSetJdbcUrl.required'/>");
	}

	function validateDataSetTabulationJdbcUserName(){
		var displayNameobj = document.dataSetForm.tabjdbcUserName;
		return validateRequired(displayNameobj,"<spring:message code='error.dataset.tabulation.jdbcusername.required'/>");
	}
	
	function validateDataSetTabulationJdbcPassword(){
		var displayNameobj = document.dataSetForm.tabjdbcPassword;
		return validateRequired(displayNameobj,"<spring:message code='error.dataset.tabulation.jdbcpassword.required'/>");
	}
	function validateTabulationReportingEngineJdbcUrl(){
		var tabulationReportingEngineJdbcUrlObj = document.dataSetForm.tabulationReportingEngineJdbcUrl;
		return validateRequired(tabulationReportingEngineJdbcUrlObj,"<spring:message code='errors.tabulationReportingEngineJdbcUrl.required'/>");
	}
	
	function validateTabulationReportingEngineUrl(){
		var tabulationReportingEngineUrlObj = document.dataSetForm.tabulationReportingEngineUrl;
		return validateRequired(tabulationReportingEngineUrlObj,"<spring:message code='errors.tabulationReportingEngineUrl.required'/>");
	}
	
	function validateDataSetAnalyticsJdbcUserName(){
		var displayNameobj = document.dataSetForm.analyticsjdbcUserName;
		return validateRequired(displayNameobj,"<spring:message code='error.dataset.analytics.jdbcusername.required'/>");
	}
	
	function validateDataSetAnalyticsJdbcPassword(){
		var displayNameobj = document.dataSetForm.analyticsjdbcPassword;
		return validateRequired(displayNameobj,"<spring:message code='error.dataset.analytics.jdbcpassword.required'/>");
	}
	function validateAnalyticJdbcUrl(){
		var	analyticsReportingEngineJdbcUrlobj = document.dataSetForm.analyticsReportingEngineJDBCUrl;
		return validateRequired(analyticsReportingEngineJdbcUrlobj,"<spring:message code='errors.analyticsReportingEngineJdbcUrl.required'/>");
	}

	function validateAnalyticsReportingEngineUrl(){
		var	analyticsReportingEngineUrlobj = document.dataSetForm.analyticsReportingEngineUrl;
		return validateRequired(analyticsReportingEngineUrlobj,"<spring:message code='errors.analyticsReportingEngineUrl.required'/>");
	}

	function validateMaxCrossTabNodes(){
		var	maxCrossTabNodesobj = document.dataSetForm.maxCrossTabNodes;
		return validateRequired(maxCrossTabNodesobj,"<spring:message code="errors.maxCrossTabNodes.required"/>") && validateInteger(maxCrossTabNodesobj, "<spring:message code='errors.maxCrossTabNodes.valid.value'/>") && validatePositiveInteger(maxCrossTabNodesobj, "<spring:message code='ui.crosstab.error'/>");
	}
	function validateDataSetPdfJdbcUserName(){
		var displayNameobj = document.dataSetForm.pdfjdbcUserName;
		return validateRequired(displayNameobj,"<spring:message code='error.dataset.pdf.jdbcusername.required'/>");
	}
	
	function validateDataSetPdfJdbcPassword(){
		var displayNameobj = document.dataSetForm.pdfjdbcPassword;
		return validateRequired(displayNameobj,"<spring:message code='error.dataset.pdf.jdbcpassword.required'/>");
	}
	function validateDashboardPdfReportingEngineUrl(){
		var dashboardPdfReportingEngineUrlobj = document.dataSetForm.dashboardPdfReportingEngineUrl;
		return validateRequired(dashboardPdfReportingEngineUrlobj,"<spring:message code='errors.dashboardPdfReportingEngineUrl.required'/>");
	}

	function validatePdfReportingEngineJdbcUrl(){
		var pdfReportingEngineJdbcUrlOjb = document.dataSetForm.pdfReportingEngineJDBCUrl;
		return validateRequired(pdfReportingEngineJdbcUrlOjb,"<spring:message code='errors.pdfReportingEngineJdbcUrl.required'/>");
	}

	function updateCubeMetaId(dataSetId, dataSetName){
		var msg = "<spring:message code='cube.id.update.confirm.msg'/>";
		msg = msg.replace('{0}', dataSetName);
		if(confirm('<spring:message code="cube.id.update.usage.update.confirm" htmlEscape="false"/>')){
			if(confirm(msg)) {
				var dataSetJdbcUrl =  document.dataSetForm.jdbcUserName.value+":"+document.dataSetForm.jdbcPassword.value+"@"+document.dataSetForm.dataSetJdbcUrl.value;
				var url = "/expensemap/getUpdateCubeMetaId.shtm?dataSetId="+dataSetId+"&dataSetJdbcUrl="+dataSetJdbcUrl;
				var ht = 100;
			    var wt = 290;
			    var left = (screen.width/2)-(wt/2);
			    var top = (screen.height/2)-(ht/2);       
			    window.open(url, '_blank', "resizable=no,scrollbars=no,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
			}
		}
	}
	
	function saveOlfConfigValuesToForm(o) {
		document.getElementById("addEnabled").value = o.addEnabled;
		document.getElementById("mapEnabled").value = o.mapEnabled;
		document.getElementById("renameEnabled").value = o.renameEnabled;
		document.getElementById("moveEnabled").value = o.moveEnabled;
		document.getElementById("specificityCondition").value = o.specificityCondition;
		document.getElementById("timeCondition").value = o.timeCondition;
		document.getElementById("addNodeDepthCondition").value = o.addNodeDepthCondition;
		document.getElementById("time").value = (o.time=='' || o.time == 'undefined' ? 0 : o.time);
		document.getElementById("weight").value = (o.weight=='' || o.weight == 'undefined' ? 0 : o.weight);
		document.getElementById("specificity").value = (o.specificity || o.specificity == 'undefined' == '' ? 0 : o.specificity);
		document.getElementById("addNodeDepth").value = (o.addNodeDepth || o.addNodeDepth == 'undefined' == '' ? 0 : o.addNodeDepth);
	}
	
	function getOlfConfig() {
		var o = {
			addEnabled : document.getElementById("addEnabled").value,
			mapEnabled : document.getElementById("mapEnabled").value,
			renameEnabled : document.getElementById("renameEnabled").value,
			moveEnabled : document.getElementById("moveEnabled").value,
			specificityCondition : document.getElementById("specificityCondition").value,
			timeCondition : document.getElementById("timeCondition").value,
			addNodeDepthCondition : document.getElementById("addNodeDepthCondition").value,
			time : document.getElementById("time").value,
			weight : document.getElementById("weight").value,
			specificity : document.getElementById("specificity").value,
			addNodeDepth : document.getElementById("addNodeDepth").value
		};
		return o;
	}
	
	function disableAllInputs() {
		var allInputs = jQuery(":input");
		jQuery.each(allInputs, function() {
			jQuery(this).attr("disabled", true);
		});

		// The cancle button should always be enabled.
		jQuery("#cancelBtn").removeAttr("disabled");
	}
	
	function showLinkToDatasetLoadingProgressMonitoringPage() {
		jQuery("#linkToDatasetProgressMonitoringPage").show();
	}
	
</script>
</head>
<c:choose>
	<c:when test='${isDatasetLoadingInProgress}'>
		<body>
	</c:when>
	<c:otherwise>
		<body onload="init();">
	</c:otherwise>
</c:choose>
<form:form commandName="datasetForm" name="dataSetForm" method="post" id="dataSetForm" >
<c:forEach items="${error}" var="m" >
<span class="errorMessage"><spring:message message="${m}" /></span><br/>
</c:forEach>
<table width="65%" border=0 cellpadding=1 cellspacing=1 bgcolor="#336699" align="center">
<tr>
	<td align=right nowrap height="21">
	<table width="100%" border=0 cellpadding=0 cellspacing=0 bgcolor="#336699">
		<tr class="LIST_SORT_HEAD">
			<td width="80%" style="font-family:Arial,Helvetica,sans-serif; font-size:11px; color:#FFFFFF"><B><FONT size="+1">
			<c:choose>
			<c:when test='${ empty datasetForm.id }'>
				<spring:message code="ui.admin.dataset.new"/>
			</c:when>
			<c:otherwise>
				<spring:message code="ui.admin.dataset.edit" />&nbsp;${datasetForm.name }
			</c:otherwise>
			</c:choose>
			</FONT></B></td>
			<td><a href="/expensemap/getDatasetList.xhtm"><font color="#FFFFFF"><spring:message code="ui.admin.dataset.alldataset" /></font></a></td>
		</tr>
	</table>
	</td>
</tr>
<tr><td>	
<table width="100%" border=0 cellpadding=1 cellspacing=1 bgcolor="#FFFFFF">
<tr>
	<td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.label.Name"/></td>
	<td align="left"><form:input path="name"  size="15" cssClass="inputStyle"/></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.label.Display.Name"/></td>
     <td align="left"><form:input path="displayName" size="15" cssClass="inputStyle"/></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.label.Jdbc.Username.Password"/></td>
    <td  align="left"><input type=text name="jdbcUserName" id="jdbcUserName"  value="${requestScope.jdbcUserName }" autocomplete="off"/>
    	<c:choose>
			<c:when test='${ empty datasetForm.id }'>
				<input type="password" name="jdbcPassword" id="jdbcPassword" autocomplete="off" />	
			</c:when>
			<c:otherwise>
				<input type=password name="jdbcPassword" id="jdbcPassword" disabled="disabled" style="display: none" autocomplete="off" /> <A onclick="changePassword(document.dataSetForm.jdbcPassword);" style="cursor: pointer;"><IMG border=0 src="/expensemap/jsp/images/edit.gif" title="<spring:message code='ui.label.Change.Password'/>"> </A>
			</c:otherwise>
		</c:choose>
   </td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.label.Jdbc.url"/></td>
     <td align="left"><form:input path="jdbcURL" size="85" cssClass="inputStyle" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.tabulation.reportingEngine.url"/></td>
     <td align="left"><form:input path="tabulationReportingEngineUrl" size="85" cssClass="inputStyle" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.tabulation.reportingengine.username.password"/></td>
	<td  align="left"><input type=text name="tabjdbcUserName" id="tabjdbcUserName" value="${requestScope.tabjdbcUserName }" autocomplete="off" />
		<c:choose>
			<c:when test='${ empty datasetForm.id }'>
				<input type="password" name="tabjdbcPassword" id="tabjdbcPassword" autocomplete="off" />	
			</c:when>
			<c:otherwise>
				<input type=password name="tabjdbcPassword" id="tabjdbcPassword" disabled="disabled" style="display: none" autocomplete="off"/> <A onclick="changePassword(document.dataSetForm.tabjdbcPassword);" style="cursor: pointer;"><IMG border=0 src="/expensemap/jsp/images/edit.gif" title="<spring:message code='ui.label.Change.Password'/>"> </A>
			</c:otherwise>
		</c:choose>
	</td>
</tr>

<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.tabulation.reportingEngine.jdbcurl"/></td>
     <td align="left"><form:input path="tabulationReportingEngineJdbcUrl" size="85" cssClass="inputStyle" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.reportingEngine.url"/></td>
     <td align="left"><form:input path="analyticsReportingEngineUrl" size="85" cssClass="inputStyle" /></td>
</tr>

<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.analytics.reportingengine.username.password"/></td>
     <td  align="left"><input type="text" name="analyticsjdbcUserName" id="analyticsjdbcUserName" value="${requestScope.analyticsjdbcUserName }"  autocomplete="off"/>
	     <c:choose>
				<c:when test='${ empty datasetForm.id }'>
					<input type="password" name="analyticsjdbcPassword" id="analyticsjdbcPassword" autocomplete="off" />	
				</c:when>
				<c:otherwise>
					<input type="password" name="analyticsjdbcPassword"  id="analyticsjdbcPassword" disabled="disabled" style="display: none" autocomplete="off"/> <A onclick="changePassword(document.dataSetForm.analyticsjdbcPassword);" style="cursor: pointer;"><IMG border=0 src="/expensemap/jsp/images/edit.gif" title="<spring:message code='ui.label.Change.Password'/>"> </A>
				</c:otherwise>
		</c:choose>
     </td>
     
</tr>

<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.reportingEngine.jdbcurl"/></td>
     <td align="left"><form:input path="analyticsReportingEngineJDBCUrl" size="85" cssClass="inputStyle" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.dashboard.pdf.reportingEngine.url"/></td>
     <td align="left"><form:input path="dashboardPdfReportingEngineUrl" size="85" cssClass="inputStyle" /></td>
</tr>

<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.pdf.repotingEngine.jdbc.userid.password"/></td>
  <td  align="left"><input type="text" name="pdfjdbcUserName" id="pdfjdbcUserName" value="${requestScope.pdfjdbcUserName }" autocomplete="off" />
	 	<c:choose>
			<c:when test='${ empty datasetForm.id }'>
				<input type="password" name="pdfjdbcPassword" id="pdfjdbcPassword" autocomplete="off"/>	
			</c:when>
			<c:otherwise>
				<input type="password" name="pdfjdbcPassword" id="pdfjdbcPassword" disabled="disabled" style="display: none" autocomplete="off"/> <A onclick="changePassword(document.dataSetForm.pdfjdbcPassword);" style="cursor: pointer;"><IMG border=0 src="/expensemap/jsp/images/edit.gif" title="<spring:message code='ui.label.Change.Password'/>"> </A>
			</c:otherwise>
		</c:choose>	
  </td>
</tr>

<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.pdf.reportingEngine.jdbcurl"/></td>
     <td align="left"><form:input path="pdfReportingEngineJDBCUrl" size="85" cssClass="inputStyle" /></td>
</tr>
<tr>
	 <c:set var="DATASET_LOADED" value="<%= DatasetConstants.DATASET_STATUS_LOADED %>" />
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.loaded"/></td>
     <td align="left">
	 <c:if test="${datasetForm.status == DATASET_LOADED}">X</c:if>
</td>
</tr>
<tr>
  	 <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.label.Company"/></td>
	 <td align="left">
	 	 <form:select path="acCompany" size="1">
			<form:options items="${companyList}" itemValue="id" itemLabel="companyNameCode" />
 		 </form:select>
	 </td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.description"/></td>
     <td align="left"><form:textarea path="description" cols="60" rows="3"/></td>
</tr>
<tr>
	 <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.history"/></td>
	 <td align="left"><form:textarea path="historyNotes" cols="60" rows="3"/></td>
</tr>	
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.disclaimer"/></td>
     <td align="left"><form:input path="disclaimerKey" size="85"/></td>
</tr>	
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.enabled"/></td>
     <td align="left"><form:checkbox path="enabled" /></td>
</tr>
<tr>
	 <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.feedbackenabled"/> </td>
	 <td align="left"><form:checkbox id="feedbackEnableCheckBox" path="feedbackEnabled" onclick="enableOnlineFeedbackoption();"/></td>
</tr>
<tr>
	 <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.online.feedbackenabled"/> </td>
	 <td align="left"><form:checkbox id="onlineFeedbackCheckBox" path="onlineFeedbackEnabled" onclick="enableOnlineFeedbackConfigButton();"/></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.restrictuser"/></td>
     <td align="left"><form:checkbox path="restrictedUserAllowedFeedback" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.restrictfeedback"/></td>
     <td align="left"><form:checkbox path="ruleTypeEnabled" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.weightbox"/></td>
     <td align="left"><form:checkbox path="feedbackWeightEnabled" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.incrhierachy"/></td>
     <td align="left"><form:checkbox path="restrictIncreasingHierarchyDepth" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.bookmarkenabled"/></td>
     <td align="left"><form:checkbox path="bookmarkEnabled" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.useremail"/></td>
     <td align="left"><form:input path="feedBackCustomerEmail" size="50" cssClass="inputStyle" /></td>
</tr>
<tr>
     <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.adminemail"/></td>
     <td align="left"><form:input path="feedBackZeborgEmail" size="50" cssClass="inputStyle" /></td>
</tr>
<tr>
    <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.feebackserverurl"/></td>
    <td align="left"><form:input path="feedbackServer" size="85" cssClass="inputStyle" /></td>
</tr>
<tr>
    <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.admin.dataset.datelastbuilt"/></td>
    <td align="left"><fmt:formatDate  value="${datasetForm.cubeMeta.lastBuiltTime}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}"/></td>
</tr>
<tr>
    <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.usability.startdate"/></td>
    <td align="left"><fmt:formatDate  value="${datasetForm.cubeMeta.beginDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}"/></td>
</tr>
<tr>
    <td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.usability.enddate"/></td>
    <td align="left"><fmt:formatDate  value="${datasetForm.cubeMeta.endDate}" timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}"/></td>
</tr>
<tr>
    <td bgcolor="#C5C5C5" class="tabledata" nowrap><font color="red" size="3">*</font><spring:message code="ui.admin.dataset.crosstabnodes"/></td>
    <td align="left"><form:input path="maxCrossTabNodes" size="15" cssClass="inputStyle"/></td>
</tr>
<tr>
	<td colspan="2" align="center">
		<c:if test='${isEditRequest}'>
			<input type="button" name="updateBtn" value="<spring:message code='ui.label.update.cube.meta.id'/>" onclick="updateCubeMetaId('${dataSetForm.dataSetId}', '${dataSetForm.dataSetName}')">&nbsp;&nbsp;
		</c:if>	
			<c:choose>
				<c:when test='${ empty datasetForm.id }'>	
					<input type="button" id="saveAndUpdate" name="saveAndUpdate" value="<spring:message code='ui.admin.dataset.btn.saveupdate'/>" disabled="true" onclick="saveAndUpdateStat();" >&nbsp;&nbsp;
				</c:when>
				<c:otherwise>
					<input type="button" id="saveAndUpdate" name="saveAndUpdate" value="<spring:message code='ui.admin.dataset.btn.saveupdate'/>" onclick="saveAndUpdateStat();" >&nbsp;&nbsp;
				</c:otherwise>
			</c:choose>	
			<c:choose>
				<c:when test='${datasetForm.status == DATASET_LOADED}'>
					<input type="button" name="unLoadBtn" value="<spring:message code='ui.admin.dataset.btn.unload'/>" onclick="unLoad();">&nbsp;&nbsp;							
				</c:when>
				<c:otherwise>
					<input type="button" name="unLoadBtn" value="<spring:message code='ui.admin.dataset.btn.unload'/>" disabled="true" onclick="unLoad();">&nbsp;&nbsp;		
				</c:otherwise>
			</c:choose>	
			<input type="button" name="olapagentBtn" value="<spring:message code='ui.admin.dataset.btn.olapagent'/>" onclick="getLmyraConfig();">&nbsp;&nbsp;
			<input type="button" id="onlineFeedbackBtn" name="onlineFeedbackBtn" value="<spring:message code='ui.admin.dataset.btn.online.feedback'/>" onclick="getOnlineFeedbackConfig();" disabled="true" >&nbsp;&nbsp;			
	</td>
</tr>
<tr>
	<td colspan="2" align="center">
		<input type="button" name="saveBtn" id="saveBtn" value="<spring:message code='ui.label.Save'/>" onclick="saveChanges();">&nbsp;&nbsp;
		<input type="button" name="cancelBtn" id="cancelBtn" value="<spring:message code='ui.label.Cancel'/>" onclick="cancelTask();">&nbsp;&nbsp;
	</td>
</tr>
<tr>
	<td id="linkToDatasetProgressMonitoringPage" name="linkToDatasetProgressMonitoringPage" colspan="3" align="center" style="display: none;"></td>
</tr>
</table>

<c:set var="DATASET_STATUS_PROCESSING" value="<%= DatasetConstants.DATASET_STATUS_PROCESSING %>" />
<c:if test='${datasetForm.status == DATASET_STATUS_PROCESSING}'>
	<script type="text/javascript">
		document.getElementById("linkToDatasetProgressMonitoringPage").innerHTML = loadingInProgressInnerHTML;
		disableAllInputs();
		showLinkToDatasetLoadingProgressMonitoringPage();
	</script>
</c:if>

<form:hidden id="addEnabled" path="onlineFeedbackConfiguration.addFeedbackEnabled" />
<form:hidden id="mapEnabled" path="onlineFeedbackConfiguration.mapFeedbackEnabled" />
<form:hidden id="renameEnabled" path="onlineFeedbackConfiguration.renameFeedbackEnabled" />
<form:hidden id="moveEnabled" path="onlineFeedbackConfiguration.moveFeedbackEnabled" />
<form:hidden id="specificityCondition" path="onlineFeedbackConfiguration.specificityConditon" />
<form:hidden id="timeCondition" path="onlineFeedbackConfiguration.timeConditon" />
<form:hidden id="addNodeDepthCondition" path="onlineFeedbackConfiguration.addNodeDepthConditon" />
<form:hidden id="time" path="onlineFeedbackConfiguration.time" />
<form:hidden id="weight" path="onlineFeedbackConfiguration.weight" />
<form:hidden id="specificity" path="onlineFeedbackConfiguration.specificity" />
<form:hidden id="addNodeDepth" path="onlineFeedbackConfiguration.addNodeDepth" />
<input type="hidden" name="doPublish" value="true" id="doPublish" disabled="disabled" />
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form:form>
</body>
</html>