<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page pageEncoding="UTF-8" contentType="text/html;charset=UTF-8"%>

<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>


<html>
<head>
<STYLE TYPE="text/css">
<!--
.text { font-family:verdana;  font-size:14px; font-weight:bold; color:#003366; }
.error { font-family:verdana; font-size:12px; font-weight:bold; color:#FF0000; }
.login { font-family:verdana; font-size:12px; font-weight:bold; color:#003366; }
.warning{font-family:verdana; font-size:11px; font-weight:'bold';color: Red;background-color : transparent;}
.spacer { font-family:verdana;font-size:3px; color:#FFFFFF; }
.smallwhite { font-family:verdana; font-size:11px; color:#FFFFFF; text-decoration:none; }

.LIST_SORT_HEAD { FONT-WEIGHT: normal; FONT-SIZE: 11px; COLOR: #FFFFFF; FONT-FAMILY: arial, helvetica, sans-serif;TEXT-ALIGN: left; TEXT-DECORATION: none }
.HeaderLink { font-size:13px; font-weight:bold; COLOR: #FFFFFF; FONT-FAMILY: arial, helvetica, sans-serif;}

class B { font-family:verdana; font-size:12px; font-weight:bold; color:#FFFFFF; text-decoration:none; }
B:TEXT { font-family:verdana; font-size:12px; font-weight:bold; color:#336699; text-decoration:none; }
.TAB{   FONT-SIZE: 11px;    COLOR: #333366;    FONT-FAMILY: verdana;    TEXT-DECORATION: none}
-->
.errorMessage {
	text-align: middle;
	font-weight: bold;
	color: red;
}

.tableData {
    color: black !important;
	font-family: verdana;
	font-size: 11px;
	text-decoration: none;
	padding-left: 5px;
} 

select{
	color: black !important;
	font-family: verdana;
	font-size: 11px;
	text-decoration: none;
}

body {
	font-family: "Trebuchet MS", "Helvetica", "Arial",  "Verdana", "sans-serif";
	font-size: 62.5%;
}

</STYLE>
<script type="text/javascript" src="/expensemap/js/jquery-1.4.2.js"></script>
<script type="text/javascript" src="/expensemap/js/jquery-1.4.2.min.js"></script>
<script type="text/javascript" src="/expensemap/js/jquery-ui-1.8.2.custom.min.js"></script>
<link rel="stylesheet" href="/expensemap/css/jquery-ui-1.7.2.custom.css" />
<script>
	$(function() {
		var tmp = document.getElementById("measureNames").value;
		var availableTags = tmp.split(',');
		function split( val ) {
		var measureNameRegex = new RegExp("^[a-zA-Z0-9_][a-zA-Z0-9_]*$");
		var newValue="";
		var position = val.length-1;
		while( measureNameRegex.test(val.charAt( position ))){
			newValue=val.charAt( position )+newValue;
			position--;
		}
		if(position>=0 && newValue==""){
			newValue = val.charAt( position );
		}
		return newValue;
		}
		
		function extractLast( term ) {
			return split( term );
		}

		$( "#formula" )
			.autocomplete({
				minLength: 0,
				source: function( request, response ) {
					// delegate back to autocomplete, but extract the last term
					response( $.ui.autocomplete.filter(
						
						availableTags, extractLast( request.term ) ) );
				},
				focus: function() {
					// prevent value inserted on focus
					return false;
				},
				select: function( event, ui ) {
					var terms = split( this.value );
					this.value=this.value.substr(0,this.value.lastIndexOf(terms));
					this.value=this.value+ui.item.value;
					return false;
				}
			});
	});
	
</script>
</head>
<body  leftmargin="0" rightmargin="0" topmargin="0" marginwidth="0"MARGINHEIGHT="0" onload="chkselectAll()">
<c:forEach items="${error}" var="m" >
<span class="errorMessage"><spring:message message="${m}" /></span><br/>
</c:forEach>
<form:form id="measureForm" commandName="measureForm" action="/expensemap/admin/manageMeasures.xhtm" method="post" >

<table width="80%" border=0 cellpadding=1 cellspacing=1 bgcolor="#336699" align="center">
	<tr>
		<td align="right" height="21" nowrap="nowrap" >
			<table width="100%" border=0 cellpadding=0 cellspacing=0 bgcolor="#336699">
			<tr class="LIST_SORT_HEAD">
				<td width="80%" style="verdana; font-size:11px; color:#FFFFFF">
				<b><font size="+1">
					<c:choose>
					<c:when test="${ ! empty measureForm.id }">
						<spring:message code="ui.editing.measure" />:${ measureForm.name }
					</c:when>
					<c:otherwise>
						<spring:message code="ui.create.new.measure" />
					</c:otherwise>
					</c:choose>
				</font></b>
				</td>
				<td>
					<a href="#" id="showAll"><font color="#FFFFFF"><spring:message code="ui.measure.all.measures"/></font></a>
				</td>
			</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td>
			<table width="100%" border="0" cellpadding="1" cellspacing="1" bgcolor="#FFFFFF" >
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap"><spring:message code="ui.label.Name"/><font color="red"> *</font></td>
				<td class="tabledata">
				<c:choose>
					<c:when test="${ ! empty measureForm.id }">${ measureForm.name }</c:when>
					<c:otherwise><form:input id="mName" path="name" size="14" maxlength="250" /></c:otherwise>
				</c:choose>
				</td>
			</tr>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap"><spring:message code="ui.label.Display.Type"/></td>
				<td><form:select id="measureType" path="type" items="${measureTypes}" itemLabel="label" itemValue="id" /></td>
			</tr>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap"><spring:message code="ui.label.Rollup.Type"/></td>
				<td>
					<c:choose>
						<c:when test="${!empty measureForm.id && measureForm.cubeMeasure}">
							<span class="tabledata"><c:out value="${rollupTypes[0].label}" /></span>
						</c:when>
						<c:otherwise>
							<form:select id="rollupType" path="rollupType" items="${rollupTypes}" itemLabel="label" itemValue="id" onchange="rollupTypeChanged()"/>
						</c:otherwise>
					</c:choose>
				</td>
			</tr>
			<c:if test="${ empty measureForm.id || measureForm.calculatedMeasure }">
				<tr>
				<div class="ui-widget">
					<td bgcolor="#C5C5C5" class="tabledata" nowrap="nowrap"><spring:message code="ui.label.Formula"/><font color="red"> *</font></td>
					<td class="tabledata" ><form:input path="formula" id="formula" size="35" maxlength="250" /></td>
				</div>
				</tr>
			</c:if>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.label.Display.Name"/><font color="red"> *</font></td>
				<td class="tabledata" ><form:input path="displayName" id="displayName" size="14" maxlength="250" /></td>  
			</tr>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.measure.unit.of.measure"/></td>
				<td class="tabledata" nowrap>
				      <div id="radioDiv2" >
				      <input type="radio" name="uomType" value="currency" id="r_currency" /><spring:message code="ui.measure.currency"/>&nbsp;
				      <input type="radio" name="uomType" value="other" id="r_other" /><spring:message code="ui.label.other"/>&nbsp;
				      </div> 
				</td>
			</tr>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap id="labelDiv"><spring:message code="ui.label.Currency.Symbol" /></td>
				<td class="tabledata" nowrap>
					<div id="currencyDiv" style="visibility:hidden;position:absolute;">
						<form:select id="currencySymbolSelect" path="currencySymbol" items="${currencies}" itemLabel="symbolAbbrv" itemValue="abbreviation" htmlEscape="false"/>
					</div>	
					<div id="otherDiv" style="visibility:hidden ;position:relative;" >
						<form:input id="currencySymbolText" size="7" path="currencySymbol" maxlength ="250" />
					</div>
				</td>
			</tr>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.measure.unit.of.measure.position"/></td>
				<td  class="tabledata"><form:select path="currencySymbolPosition" items="${curSymbolPositions}" itemLabel="key" itemValue="id" /></td>
			</tr>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.label.Significant.Digits"/></td>
				<td  class="tabledata"><form:input path="significantDigits" size="14" maxlength="1" id="sDigits" /></td>
			</tr>
			<c:if test="${ empty measureForm.id || measureForm.calculatedMeasure }">
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.measure.percentage.of.measures"/></td>
				<td class="tabledata">
					<form:radiobutton path="percentageOfMeasure" value="0" id ="noneMeasureCheckbox" /><spring:message code="ui.label.None"/><br>
					<form:radiobutton path="percentageOfMeasure" value="1" id ="totalMeasureCheckbox" /><spring:message code="ui.measure.percentage.of.total.measure"/><br>
					<form:radiobutton path="percentageOfMeasure" value="2" id ="drillpointMeasureCheckbox" /><spring:message code="ui.measure.percentage.of.drillpoint.measure"/><br>
				</td>
			</tr>
			</c:if>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.label.dynamic.masking"/></td>
				<td  class="tabledata">
					<form:select id="maskingMeasureDimension" items="${maskingDimCriteria}"  path="maskingMeasureDimension" itemLabel="label" itemValue="id"/>
				</td>
			</tr>			
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.select.all.dimensions"/></td>
				<td  class="tabledata">
					<input id='selectAllRows' name='selectAllRows' type='checkbox' onClick='selectAll(this);'/> 
				</td>
			</tr>
			<tr>
				<td bgcolor="#C5C5C5" class="tabledata" nowrap><spring:message code="ui.measure.dimension.measure.displayed"/></td>
				<td  class="tabledata">
					<form:checkboxes onclick='updateSelectAll(this);' items="${dimensions}"  delimiter="<br>" path="dimensionMetas" itemValue="id" itemLabel="displayName" />
				</td>
			</tr>
			<tr><td colspan="2"><table width="70%" align="left"><tr>
				<td align="right">
					<input type="submit" onclick="return validateInput();" id="save" value="<spring:message code="ui.label.Save"/>" /> 
				</td>
				<td align="right">
					<input type="button" id="cancel" value="<spring:message code="ui.label.Cancel"/>" />
				</td>
			</tr>
			</table>
			</td>
		</tr>
		</table>
		</td>
	</tr>
</table>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
<input type="hidden" name="cubeMetaId" value="${param.cubeMetaId}" />
<input type="hidden" name="measureNames" id="measureNames" value="${measureNames}" />
<input type="hidden" name="op" value="${op}" id="op" />
</form:form>

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript">
	function chkselectAll() {
			var theForm = document.getElementById("measureForm");
			var selectAllControl = document.getElementById("selectAllRows");
			var allSelected ;		
			if (!theForm.dimensionMetas.length ) {
				allSelected = theForm.dimensionMetas.checked;
			} else {
				for( var i=0; i< theForm.dimensionMetas.length; i++ ) {
					if ( theForm.dimensionMetas[i].checked == false ) {
						allSelected = false;
						break;
					}else{
						allSelected = true;
					}
				}
			}
			selectAllControl.checked = allSelected;
					
		}
  function selectAll(selectAllControl) {
			var theForm =  document.getElementById("measureForm");
			if ( theForm.dimensionMetas == null ) {
				document.getElementById("selectAllRows").checked=false;
				document.getElementById("selectAllRows").disabled=true;
				return false;	
			} 
			
			if ( theForm.dimensionMetas.length ) {
				// There are more than one rows on this form.
				for( var i=0; i< theForm.dimensionMetas.length; i++ ) {					
					theForm.dimensionMetas[i].checked = selectAllControl.checked;
				}
			}
			// There is just a single row on this form.
			theForm.dimensionMetas.checked = selectAllControl.checked;
					
		}
		
	function updateSelectAll(checkboxSelected) {			
		var theForm = document.getElementById("measureForm");
		var selectAllControl = document.getElementById("selectAllRows");
		var allSelected = true;			
		if (!theForm.dimensionMetas.length ) {
			allSelected = checkboxSelected.checked;
		} else {
			for( var i=0; i< theForm.dimensionMetas.length; i++ ) {
				if ( theForm.dimensionMetas[i].checked == false ) {
					allSelected = false;
					break;
				}
			}
		}
		selectAllControl.checked = allSelected;
					
	}

	var measureNameRegex = new RegExp("^[a-zA-Z_][a-zA-Z0-9_]*$");
	
  	function validateInput() {
	  	var id = '${measureForm.id}';
	  	var message = '';
		var inputStr = document.getElementById("mName");
		var inputDisplayName = document.getElementById("displayName");
		var inputFormula = document.getElementById("formula");
		if (id==null || id == '') {
			if ( inputStr && inputStr.value != '') {
				if(! measureNameRegex.test(inputStr.value)){
					message = '<spring:message code="ui.measure.error.message"/>';
				}
			} else {
				message = '<spring:message code="ui.measure.validate.name.required"/>';
			}
		}
		if (inputDisplayName.value == '') {
			if (message != '') {
				message += '\n';
			}
			message += '<spring:message code="ui.measure.validate.display.name"/>';
		}

		if (inputFormula.value == '') {
			if (message != '') {
				message += '\n';
			}
			message += '<spring:message code="ui.measure.validate.formula"/>';
		}

		if (message != '') {
			alert(message);
			return false;
		}
		
		if ( document.getElementById("sDigits").value == '' ) {
			document.getElementById("sDigits").value = 0;
		}
		
	    return true;
    }
	
	<c:if test="${ empty measureForm.id || measureForm.calculatedMeasure }">
	function rollupTypeChanged() {
		var rollupType = document.getElementById('rollupType').value;
		// Disable % total measure and % drillpoint measure checkboxes if hybrid rollup type is selected.
		if (rollupType.toLowerCase() == 'hybrid') {
			document.getElementById('totalMeasureCheckbox').disabled = true;
			document.getElementById('drillpointMeasureCheckbox').disabled = true;
		} else {
			document.getElementById('totalMeasureCheckbox').disabled = false;
			document.getElementById('drillpointMeasureCheckbox').disabled = false;
		}
	}
	</c:if>

	(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.util.Event.onDOMReady(function() {
		
		var onChangeMeasureType = function() {
			var measureType = Dom.get("measureType").value;			
			if ( measureType != 'SPEND' ) {
				Dom.get("r_currency").disabled = true;
			} else {
				Dom.get("r_currency").disabled = false;
			}
		};
		Event.on("measureType", "change", onChangeMeasureType);
		
		var enableCurrencyLookup = function() {
			Dom.get('labelDiv').innerHTML="<spring:message code='ui.label.Currency.Symbol'/>";
			Dom.setStyle("otherDiv","visibility","hidden");
			Dom.get("currencySymbolText").disabled = true;
			Dom.setStyle("currencyDiv","visibility","visible");
			Dom.get("currencySymbolSelect").disabled = false;
		};
		
		Event.on("r_currency", "click", enableCurrencyLookup);
		var disableCurrencyLookup = function() {
			Dom.get('labelDiv').innerHTML="<spring:message code='ui.measure.display.label'/>";
			Dom.setStyle("currencyDiv", "visibility","hidden");
			Dom.get("currencySymbolSelect").disabled = true;
			Dom.setStyle("otherDiv","visibility","visible");
			Dom.get("currencySymbolText").disabled = false;
		};
		Event.on("r_other", "click", disableCurrencyLookup);
		
		onChangeMeasureType();
		Dom.get("r_${uomType}").checked = true;
		<c:choose>
		<c:when test="${ uomType == 'currency' }">enableCurrencyLookup();</c:when>
		<c:otherwise>disableCurrencyLookup();</c:otherwise>
		</c:choose>
		<c:if test="${ ! saveEnabled }">
			Dom.get("save").disabled = true;
		</c:if>
		var showAllMeasures = function() {
			var form = Dom.get("measureForm");
			form.method = "get";
			form.action = "/expensemap/admin/manageMeasures.xhtm";
			form.op.value = "list";
			form.submit();
		};
		Event.on("cancel", "click", showAllMeasures);
		Event.on("showAll", "click", showAllMeasures);
		
		var checkForNumbers = function() {
			var validChars = "012345";
			var isNumber=true;
			var value = this.value;
			for (i = 0; i < value.length && isNumber == true; i++) {
				var c = value.charAt(i);
				if (validChars.indexOf(c) == -1) {
					alert('<spring:message code="ui.measure.validate.significant"/>');
					document.forms[0].significantDigits.value = "";
					return false;
				}
			}
			return true;
		}
		Event.on("sDigits", "keyup", checkForNumbers);
		
		<c:if test="${ empty measureForm.id || measureForm.calculatedMeasure }">
		rollupTypeChanged();
		</c:if>

	});

})();
</script>
</body>
</html>