<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@ page language="java" contentType="text/html; charset=UTF-8"  pageEncoding="UTF-8"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticReportHeaderVO"%>
<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="com.zeborg.acl.util.ACManager"%>
<%@ page import="java.util.*, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import ="org.apache.struts.Globals,com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties,com.zeborg.expensemap.view.HelpUtil" %>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.analytic.ReportType"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	Locale locale = zs.getUser().getLocale();
	EmResourceBundle bundle=EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE, locale);
	String cubeName = zs.getDataSet().getDisplayName();	
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.existing.analytics.help.page", locale);
	pageContext.setAttribute("returnToURL","../showAnalyticPage.xhtm", PageContext.SESSION_SCOPE);
	EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, locale);
	String title = ExpenseMapAppProperties.getExpensemapTitle()+ " - "+ baseBundle.getValue("ui.emptoris.title.viewer.analytic");	
	CubeUtil.buildExpMapMastHead(out,"viewFrame_analytic.jsp",zs,true,null,locale,null);
%>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<title><%=title %></title>

			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid_rtl.css"/>
			<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/claroGrid.css"/>
			<link rel="stylesheet" href="/expensemap/css/spendGridPageStyle.css"/>

			<script type="text/javascript">
				dojoConfig = {
					baseUrl : "/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/"						
				};
			</script>
		
			<script type="text/javascript" src="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js" data-dojo-config="parseOnLoad: true" ></script>

			<script type="text/javascript">										
				
				dojo.require("dojo/domReady");
				dojo.require("dojo/store/Memory");
				dojo.require("dojo/data/ObjectStore");
				dojo.require("dojox/grid/DataGrid");
				dojo.require("dojo/_base/xhr");
				dojo.require("dijit/layout/BorderContainer");
				dojo.require("dijit/form/Button");
				dojo.require("dijit/form/Select");
				dojo.require("dijit/TitlePane");
				dojo.require("dijit/form/TextBox");
				dojo.require("dijit/form/CheckBox");
				dojo.require('dijit/form/NumberTextBox');
				dojo.require("dijit/form/DateTextBox");
				dojo.require("dijit/form/ValidationTextBox");
				
				var analytic_Grid_Layout, analytic_Grid_Store, analytic_Grid_Obj, dataStore , categoryLabelValue;							
				var buttonEnableString="";
				var canCreateTopReports;
				var isDataAvailable=false;

						dojo.ready(function(){
											
							analytic_Grid_Layout = [
											{													
												name: "<input id='selectAllRows' name='selectAllRows' type='checkbox' onClick='selectAll(this);enableDisable();' />",
												fields :['id','eriId','status','type'],
												formatter:addCheckBox,
												width:"3%"
											},{
												id: 'name',
												name: '<fmt:message key="ui.label.Name" />',
												fields:['id','name','shortName','topReport','privateTopReport','type','template','statusInvalid','showReportViewOption','eriId','showRegenerateOption'],
												formatter:createLink,
												headerStyles:"cursor:pointer",
												width:"10%"
											},{
												id: 'userDisplayName',
												field:'userDisplayName',												
												name: '<fmt:message key="ui.label.Created.By"/>',
												formatter:renderUserName,
												width:"10%"							
											},{
												id: 'description',
												field:'description',													
												formatter:renderDescription,
												name: '<fmt:message key="ui.label.Description"/>',
												headerStyles:"cursor:pointer",
												width:"30%"
											},{
												id: 'dateCreated',
												fields:['dateCreatedStr'],
												formatter:renderDateCreated,
												name: '<fmt:message key="ui.label.Date.Created"/>',												
												headerStyles:"cursor:pointer",
												width:"15%"
											},{
												id: 'type',
												fields:['displayReportType','template'],													
												name: '<fmt:message key="rpt.listing.column.report.type"/>',
												formatter:renderAnalyticType,
												headerStyles:"cursor:pointer",
												width:"10%"
												
											},{
												id: 'status',
												fields:['eriId','displayStatus','statusInvalid'],
												name: '<fmt:message key="ui.label.Status"/>',
												formatter:renderSatus,
												headerStyles:"cursor:pointer",
												width:"10%"												
											},{
												id: 'Share',
												fields:['id','shareOptionEnabled'],													
												name: '<fmt:message key="ui.label.Share"/>',
												formatter:renderShareIcon,												
												width:"5%"
											}
									];

							require(["dojox/grid/DataGrid", "dojo/store/Memory", "dojo/data/ObjectStore", "dojo/_base/xhr", "dojo/domReady", "dijit/form/Select"],
								function(DataGrid, Memory, ObjectStore, xhr){
										regenrateAnalyticErrorMsg();
										xhr.post({
											url: "/expensemap/fetchAnalyticList.jxhtm",
											handleAs: "json",
											content:{theAction: "showAll"}
										}).then(function(responseData){
											
											isDataAvailable = (responseData.analyticReportList.length > 0)?true:false;

											canCreateTopReports = responseData.analyticsListForm.canCreateTopReports;
											categoryLabelValue = new dijit.form.Select({
																			id:"category",
																			name: "category",
																			store: new ObjectStore({ objectStore: new Memory({ data: responseData.categorylabelvalue })}),
																			maxHeight: -1
																		}
																			,"category_div");
											categoryLabelValue.startup();
											showTopReortDiv(responseData);
											enableDisableButton_OnGridLoad();
											configurePaginationComponent(responseData.analyticsListForm.pagination)
											analytic_Grid_Store = new dojo.store.Memory({ data: responseData.analyticReportList });																	
											dataStore = new ObjectStore({ objectStore: analytic_Grid_Store });
											analytic_Grid_Obj = new DataGrid({
																				id:'analytic_Grid',
																				store: dataStore,																			
																				canSort : canSort,
																				rowSelector:'0px',
																				selectionMode:"single",																
																				autoHeight:true,
																				escapeHTMLInData:false,
																				structure : analytic_Grid_Layout 			
																	},																		
																	"Grid_Div"
																);// End of DataGrid.										
											analytic_Grid_Obj.startup();
										});
							});

							/* All button event handler  -- START */
							require(["dojo/on", "dojo/topic", "dojo/dom-construct"],
								function(on, topic, domConstruct) {

									var resetSearch = dojo.byId("resetSearch");
									on(resetSearch, "click", function() {								
										resetSearchOptions();								
									});

									var search = dojo.byId("search");
									on(search, "click", function() {
										if(	dojo.byId("search_analyticName").value=="" && 
											dojo.byId("search_FromDate").value=="" && 
											dojo.byId("search_ToDate").value=="" && 
											!document.getElementById("transaction").checked && 
											!document.getElementById("dimension").checked && 
											!document.getElementById("trend").checked && 
											!document.getElementById("topn").checked)
											dojo.byId("theAction").value = "showAll";

										showAllAnalytic();
									});

									var showAll = dojo.byId("showAll");
									on(showAll, "click", function() {
										dojo.byId("theAction").value = "showAll";
										resetSearchOptions();
										showAllAnalytic();
									});
							
									var refresh = dojo.byId("refresh");
									on(refresh, "click", function() {										
										dojo.byId("theAction").value="getCurrent";
										showAllAnalytic();
									});

									var deleteAction = dojo.byId("delete");
									on(deleteAction, "click", function() {
										if(!dijit.byId("delete").get('disabled')){
											dojo.byId("theAction").value="getCurrent";
											deleteAnalytic();
										}
									});

									var cancel = dojo.byId("cancel");
									on(cancel, "click", function() {
										if(!dijit.byId("cancel").get('disabled')){
											dojo.byId("theAction").value="getCurrent";
											cancelJob();
										}
									});
								
									var topReport = dojo.byId("topReport");
									on(topReport, "click", function() {										
										if(!dijit.byId("topReport").get('disabled')){											
											dojo.byId("theAction").value="getCurrent";
											saveAsTopReport();
										}
									});// Top Report event handler.	


									var applyPageSizeButton = dojo.byId("applyPageSize");
									on(applyPageSizeButton, "click",function() {
										dojo.byId("pageSize").value = dojo.byId("userInput_pageSize").value;									
										dojo.byId("theAction").value="getCurrent";										
										showAllAnalytic();
									});	
							});// End of Event handler require.

							/* All button event handler  -- END */
						});//End of DOJO ready function.
						
						
						function regenrateAnalyticErrorMsg(){
							if('${regeneration_error_msg_key}' != ''){
								var gridMsgDiv = dojo.byId("errorMsg_other");								
								gridMsgDiv.style.display = "block";
								gridMsgDiv.innerHTML =  "<b>" + '<c:out value="${regeneration_error_msg_key} " />' + "</b>";
							}
							if('${permission_error_msg_key}' != ''){
								var gridMsgDiv = dojo.byId("errorMsg_other");								
								gridMsgDiv.style.display = "block";
								gridMsgDiv.innerHTML =  "</br>";
								gridMsgDiv.innerHTML =  "<b>" + '<c:out value="${permission_error_msg_key} " />' + "</b>";
							}
						}

						
						function refreshGridStore(responseData){							
							if(!validateUserSession(responseData)) return false; // function validateUserSession() defined with topMenu.jsp
							isDataAvailable = (responseData.analyticReportList.length > 0)?true:false;
							enableDisableButton_OnGridLoad();
							displayErrorIfAny(responseData);							
							showTopReortDiv(responseData);							
							configurePaginationComponent(responseData.analyticsListForm.pagination);							
							var newStore = new dojo.store.Memory({ data: responseData.analyticReportList });					
							var newDataStore = new dojo.data.ObjectStore({ objectStore: newStore });							
							analytic_Grid_Obj.setStore(newDataStore);							
						}
			

						function submitRequest(url){
							var frm = document.getElementById("analyticsListForm");
							frm.action = url;
							var xhrArgs = {
								form: frm,					
								handleAs: "json",
								load: function(data){
									refreshGridStore(data);
								}// end of load.										
							}// End of xhrArgs.
							dojo.xhrPost(xhrArgs);
						}

						function displayErrorIfAny(responseData){
							var gridMsgDiv = dojo.byId("errorMsg_grid");
							var searchMsgDiv = dojo.byId("errorMsg_search");
							gridMsgDiv.style.display = "none";
							gridMsgDiv.innerHTML =  "";
							searchMsgDiv.style.display = "none";						
							searchMsgDiv.innerHTML = "";						
							if(responseData.errorMsg_grid != 'undefined' && responseData.errorMsg_grid != null ){
								gridMsgDiv.style.display = "block";
								gridMsgDiv.innerHTML =  "<b>"+responseData.errorMsg_grid+"</b>";
							}
							if(responseData.errorMsg_search != 'undefined' && responseData.errorMsg_search != null){
								searchMsgDiv.style.display = "block";
								searchMsgDiv.innerHTML = "<b>" + responseData.errorMsg_search + "</b>";
							}
						}
						
						//open help page
						function openHelp(){
							open( "<%=helpURL%>", "_blank" );	
						}
						//Open Analytic print page
						function printAnalytic(){
							if(isDataAvailable){
								var frm = document.getElementById("analyticsListForm");
								frm.method="post";
								frm.action="/expensemap/printAnalytic.xhtm";
								frm.target='_new';
								frm.submit();
								frm.target='_self';
							}else {	
								alert("<fmt:message key='errors.noprintdata'/>");
								return false;
							}							
						}
						function showAllAnalytic(){
							var frm = document.getElementById("analyticsListForm");
							submitRequest("/expensemap/fetchAnalyticList.jxhtm");				
						}

						function resetSearchOptions(){
							dijit.byId("search_analyticName").set('value','');
							dijit.byId("search_FromDate").set('value',' ');
							dijit.byId("search_ToDate").set('value',' ');
							dijit.byId("search_createdBy").set('value','');
							dijit.byId("transaction").set('checked',false);
							dijit.byId("dimension").set('checked',false);
							dijit.byId("trend").set('checked',false);
							dijit.byId("topn").set('checked',false);
							HideSearchErrDiv();
						}

						function HideSearchErrDiv(){
							var searchErrDiv = document.getElementById("errorMsg_search");
							if(searchErrDiv.style.display=='block'){
								searchErrDiv.innerHTML="";
								searchErrDiv.style.display='none';
							}
						}

						//fields :['id','eriId','status','type']
						function addCheckBox(fields){							
							return "<input type='checkbox' name='analyticIds' value='" + fields[0] + ":" + fields[2] + ":" + fields[1] + ":" + fields[3] +" 'onclick='updateSelectAll();enableDisable();' />";
						}
						
						function selectAll(selectAllControl) {				
							var theForm =  document.getElementById("analyticsListForm");
							if ( theForm.analyticIds == null ) {
								document.getElementById("selectAllRows").checked=false;
								document.getElementById("selectAllRows").disabled=true;
								return false;	
							} 

							if ( theForm.analyticIds.length ) {
								// There are more than one rows on this form.
								for( var i=0; i< theForm.analyticIds.length; i++ ) {					
									theForm.analyticIds[i].checked = selectAllControl.checked;
								}
							}				
							// There is just a single row on this form.
							theForm.analyticIds.checked = selectAllControl.checked;				
						}

						function updateSelectAll(){				
							var theForm = document.getElementById("analyticsListForm");
							var selectAllControl = document.getElementById("selectAllRows");
							var allSelected = true;
							
							if ( ! theForm.analyticIds.length ) {
								allSelected = theForm.analyticIds.checked;
							}else {
								for( var i=0; i< theForm.analyticIds.length; i++ ){
									if ( theForm.analyticIds[i].checked == false ){
										allSelected = false;
										break;
									}	
								}
							}
							selectAllControl.checked = allSelected;
						}						
						
						function checkAtLeastOneSelected() {				
							var frm = document.getElementById("analyticsListForm");
							if (frm.analyticIds.length) { // if the checkbox group is an array (one check box is not an array)
								var noOfRows = frm.analyticIds.length;
								for (i = 0; i < noOfRows; i++) {
									if (frm.analyticIds[i].checked == true) {			
										return true;
									}
								}
							}else { // There is only one check box (it's not an array)
								if (frm.analyticIds.checked) { // if the one check box is checked
									return true;
								}
							}
							return false;
						}

						

						function enableDisable() {	    	
							var theForm = document.getElementById("analyticsListForm");
							if (theForm.analyticIds.length) { // if the checkbox group is an array (one check box is not an array)
								var noOfRows = theForm.analyticIds.length;
								for (i = 0; i < noOfRows; i++) {
									if (theForm.analyticIds[i].checked == true) {										
										buildButtonString(theForm.analyticIds[i].value); 
									}
								}
							}else { // There is only one check box (it's not an array)
								if (theForm.analyticIds.checked) { // if the one check box is checked
									buildButtonString(theForm.analyticIds.value); 
								}
							}							
							enableDisableButtons(buttonEnableString);
							buttonEnableString="";
							manualSelectUnselect();
						}

						function buildButtonString(statusValue) {
							
							var status=statusValue.split(':')[1];
							if ( status == 'RUNNING' || status == 'SUBMITTED' && buttonEnableString.indexOf('c') == -1 ) {
								var tmp = buttonEnableString + "c";
								if  ( buttonEnableString.indexOf('d') == -1 )
									tmp = tmp + "d";
									buttonEnableString=tmp;
							} else if ( (status!='COMPLETED' && status!='SUBMITTED') && buttonEnableString.indexOf('d') == -1 ) {
								var tmp=buttonEnableString+"d";
								buttonEnableString=tmp;
							} else if (status=='COMPLETED') {
								var tmp=buttonEnableString;
								if  ( buttonEnableString.indexOf('d') == -1 )
									tmp = tmp + "d";
								if  ( buttonEnableString.indexOf('s') == -1 )
									tmp = tmp + "s";
								buttonEnableString=tmp;   
							}
						}
						
						function manualSelectUnselect(noOfRows) {
							var theForm = document.getElementById("analyticsListForm");
							var selectAllObj = document.getElementById("selectAllRows");
							var allSelected = true;
							if(theForm.analyticIds){
								if(theForm.analyticIds.length){
									var noOfRows = theForm.analyticIds.length;
									for (i = 0; i < noOfRows; i++) {
										if (theForm.analyticIds[i].checked == false) {										
											allSelected=false;
											break;
										}
									}
								}else{
									if (theForm.analyticIds.checked==false) { // if the one check box is checked
										allSelected=false;
									}
								}
							}
							selectAllObj = 	allSelected;
						}

						function enableDisableButtons(buttonEnableString) {							
							if (buttonEnableString.indexOf('d') != -1 )
								dijit.byId("delete").set('disabled',false);
							else
								dijit.byId("delete").set('disabled',true);							    
									   
							if ( buttonEnableString.indexOf('c') != -1 )
								dijit.byId("cancel").set('disabled',false);								
							else
								dijit.byId("cancel").set('disabled',true);
							
							
							if(canCreateTopReports){
								if ( buttonEnableString.indexOf('s') != -1 ) {
									enableDisableComponents(false);
								} else {
									enableDisableComponents(true);
								}
							}
						}
						
						function enableDisableComponents(value){
							dijit.byId("topReport").set("disabled",value);
							dijit.byId("category").set("disabled",value);
							dijit.byId("privateReport").set("disabled",value);									
						}
						
						function enableDisableButton_OnGridLoad(){							
							dijit.byId("delete").set("disabled",true);
							dijit.byId("cancel").set("disabled",true);
							enableDisableComponents(true);
						}
						//fields:['id','name','shortName','topReport','privateTopReport','type','template','statusInvalid','showReportViewOption','eriId','showRegenerateOption']
						function createLink(fields){
							var linkString = "";
							if(fields[3]){
								linkString += "<img src='/expensemap/jsp/images/report/reports_icon.gif' border='0' title='<fmt:message key='ui.topn.Top.Report'/>' />";
							}
							if(fields[4]){
								linkString += "<img src='/expensemap/jsp/images/report/private_reports_icon.jpg' border='0' title='<fmt:message key='ui.topn.Private.Top.Report'/>' />";
							}

							if(fields[7]){
								linkString += "<span title='" + fields[1] + "'>" + fields[2] +"</span>";
							}else if(fields[10]){
								linkString +="<a href=# onclick=regenerate(\'" + fields[0] + "\'); title=\'" + fields[1] + "\' >" + fields[2] + "</a>";
							}else if(fields[8]){
								linkString +="<a href=# onclick=viewReport(\'" + fields[9] + "\',\'"+ fields[0] +"\',\'"+ fields[5] +"\'); title=\'" + fields[1] + "\' >" + fields[2] + "</a>";
							}else if(fields[6]){
								linkString +="<a href=# onclick=viewTemplate(\'" + fields[0] + "\',\'"+ fields[5] +"\'); title=\'" + fields[1] + "\' >" + fields[2] + "</a>";
							}else{
								linkString += "<span title='" + fields[1] + "'>" + fields[2] +"</span>";
							}
							return linkString;
						}
						
						// User shouldn't submit multiple request for regenation of Analytic Request.
						var regenerateRequestCount = 0;
						function regenerate(reportId){
							if (confirm("<fmt:message key='ui.alertmsg.regenerate.analytics' />") && regenerateRequestCount++ < 1){
								var frm = document.getElementById("analyticsListForm");
								frm.method="post";
								frm.action="/expensemap/analytic/regenerateAnalyticsAction.do?reportId="+reportId;
								frm.submit();
							}else{
								return false;
							}
						}

						function viewTemplate(id, reportType) {							
							var frm = document.getElementById("analyticsListForm");
							frm.method="post";
							document.getElementById("templateId").value=id;
							if ( reportType =="<%=ReportType.TREND%>" ) {
								frm.action="/expensemap/analytic/trendAnalyticAction.do";
							} else if( reportType =="<%=ReportType.TOPN%>" ) {
								frm.action="/expensemap/analytic/topnAnalyticAction.do";
							}else {		
								frm.action="/expensemap/analytic/editTemplate.do";		
							}							
							frm.submit();
						}

						function viewReport(eriId,id,reportType){							
							var frm = document.getElementById("analyticsListForm");
							frm.method="post";
							document.getElementById("eriId").value=eriId;
							document.getElementById("reportId").value=id;
							document.getElementById("reportType").value=reportType;							
							frm.action="/expensemap/analytic/renderAnalyticsAction.do";		
							frm.submit();
						}						

						function renderUserName(field){
							if(field!=null && field!='') return field;
							return "&nbsp;"
						}
						
						function renderDescription(field){
							if(field!=null && field!='') return field;
							return "&nbsp;"
						}
						
						//fields:['eriId','status','statusInvalid'],
						function renderSatus(fields){
							var returnString;
							
							if(fields[1]=='NOT_APPLICABLE') return '&nbsp;'
							returnString = fields[1];
							if(fields[0]=='-2'){
								returnString += "&nbsp;<img src='/expensemap/jsp/images/report/reports_icon_data_refreshed.gif' border='0' title='<fmt:message key='crosstab.refreshed.filters'/>' >"; 
							}
							if(fields[2]){
								returnString += "<br><fmt:message key='ui.label.status.Needs.Recreation'/>";
							}							
							return returnString;
						}
						//fields:['type','template'],	
						function renderAnalyticType(fields){
							if(fields[1])
								return (fields[0] + "&nbsp;<img src='/expensemap/jsp/analytics/images/icon_template.gif' border='0' title='<fmt:message key='ui.image.tooltip.template' />'>");
							return (fields[0] + "&nbsp;<img src='/expensemap/jsp/analytics/images/icon_report.gif' border='0' title='<fmt:message key='ui.label.mainViewMode.Report' />'>");
						}
						
						//Function will render creation date of Dashboard objects
						//field:dateCreatedStr
						function renderDateCreated(fields){
							if(isEmpty(fields[0])) return "&nbsp;";
							
							return fields[0];					
						}

						function isEmpty(field){
							if( field != null && field != "" )	return false;

							return true;
						}
						//fields:['id','shareOptionEnabled']
						function renderShareIcon(fields){							
							if(fields[1]){
								return '<a href=# onclick=shareView(\'' + fields[0] + '\');><img src=/expensemap/jsp/images/share_icon.gif border=0/></a>';								
							}
							return "&nbsp;";
						}
						
						function shareView(reportId){
							var ht = 475;
							var wt = 935;
							var left = (screen.width/2)-(wt/2);
							var top = (screen.height/2)-(ht/2);	
							open('/expensemap/shareObject.shtm?viewType=analytic&id=' + reportId, '_blank', "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
						}

						function canSort(col){								
							var returnVal = true;				
							//positive for an ascending sort and negative for a descending sort
							var sortingOrder = "desc";
							if(col > 0)
								sortingOrder="asc";							

							dojo.byId("listSortOrder").value = sortingOrder;

							var sortingColName;

							switch(col){

								case 2:	case -2:
									sortingColName = "byName";
									break;
								case 3:	 case -3:
									sortingColName = "createdBy";
									break;
								case 4:  case -4:
									sortingColName = "description";
									break;
								case 5:  case -5:
									sortingColName = "createDate";
									break;					
								case 6:	case -6:
									sortingColName = "type";
									break;
								case 7:	case -7:
									sortingColName = "status";
									break;
								
								case 1:	 case -1:								
								case 8:	 case -8:								
									returnVal = false;
									break;
							}				
							dojo.byId("listSortColumnName").value = sortingColName;
							dojo.byId("theAction").value="getCurrent";
							if(returnVal){								
								showAllAnalytic();
							}
							return returnVal;
						}
						

						function deleteAnalytic(){
							var frm = document.getElementById("analyticsListForm");
							var isSelected = checkAtLeastOneSelected();							
							if (frm.analyticIds.length > 0 && isSelected || frm.analyticIds.value && isSelected) {
								if (confirm('<fmt:message key="ui.delete.alertmsg"/>')) {									
									submitRequest("/expensemap/deleteAnalytic.jxhtm");
								}
							}
						}
						
						function cancelJob(){
							var frm = document.getElementById("analyticsListForm");
							var isSelected = checkAtLeastOneSelected();							
							if (frm.analyticIds.length > 0 && isSelected || frm.analyticIds.value && isSelected) {
								if (confirm('<fmt:message key="ui.cancel.alertmsg"/>')) {
									submitRequest("/expensemap/cancelAnalytic.jxhtm");
								}
							}
						}

						function saveAsTopReport() {
							var theForm = document.getElementById("analyticsListForm");;
							var isSelected = checkAtLeastOneSelected();	
							if(isSelected){
								if (theForm.analyticIds.length > 0  || theForm.analyticIds.value) {
									if (theForm.analyticIds.length) { // if the checkbox group is an array (one check box is not an array)
										var noOfRows = theForm.analyticIds.length;
										for (i = 0; i < noOfRows; i++) {
											if (theForm.analyticIds[i].checked == true) {			
												var statusVlaue=theForm.analyticIds[i].value;
												var status=statusVlaue.split(':')[1];
												if (status!='COMPLETED'){
													alert("<fmt:message key='ui.msg.topReport.ValidateCompletedStatus' />")	     
													return false;
												}
											}
										}
									}else { // There is only one check box (it's not an array)
										if (theForm.analyticIds.checked) { // if the one check box is checked
											var statusVlaue=theForm.analyticIds.value;
											var status=statusVlaue.split(':')[1];
											if (status!='COMPLETED'){
												alert("<fmt:message key='ui.msg.topReport.ValidateCompletedStatus' />")	     
												return false;
											}
										}
									}
									
								}
							
								var privateReport = document.getElementById("privateReport").checked;
								var reportCategory = dijit.byId('category').value;
								var confirmMsg = "<fmt:message key='ui.save.topreport.alertmsg'/>";							
								if(privateReport)
									confirmMsg = "<fmt:message key='ui.save.topreport.private.continue.alertmsg' />";							

								if (confirm(confirmMsg )){
									var url = "/expensemap/saveAnalyticAsTopReport.jxhtm";								
									theForm.action = url;
									var xhrArgs = {
										form: theForm,
										handleAs: "json",
										content: {catId: reportCategory,isPrivate: privateReport},
										load: function(data){
											refreshGridStore(data);
										}// end of load.
									}// End of xhrArgs.
									dojo.xhrPost(xhrArgs);
								}
							}														
						}
						
						// Show OR Hide create top report options.
						function showTopReortDiv(responseData){
							var topReortDiv = dojo.byId("topReortDiv");
							if(responseData.analyticsListForm.canCreateTopReports){
								topReortDiv.style.display="block";
							}else{
								topReortDiv.style.display="none";
							}					
							dijit.byId("privateReport").set("checked",false);				
						}


						function configurePaginationComponent(pageData){
							//Set all Hidden variables
							dojo.byId("startRec").value=pageData.startRec;				
							dojo.byId("pageSize").value=pageData.pageSize;
							dojo.byId("userInput_pageSize").value=pageData.pageSize;
							dojo.byId("limitRec").value=pageData.limitRec;
							dojo.byId("totalRec").value=pageData.totalRec;
							dojo.byId("listSortOrder").value=pageData.listSortOrder;
							dojo.byId("listSortColumnName").value=pageData.listSortColumnName;
							dojo.byId("lastRecord").value=pageData.lastRecord;		
							var totalObjectCount = pageData.totalRec;							
							
							if(totalObjectCount!='undefined' && totalObjectCount > 0){								
								dojo.byId("pagination_div").style.display="block";		
								dojo.byId("pagination_text").innerHTML="";
								var firstImg = dojo.byId("first");
								var prevImg = dojo.byId("prev");
								if(pageData.startRec == 1 ){									
									firstImg.src = '/expensemap/jsp/images/beginning_disabled.gif';
									firstImg.title="<fmt:message key='tooltip.you.are.at.top'/>";
									firstImg.onclick=function(){};//donothing
										
									prevImg.src = '/expensemap/jsp/images/back_disabled.gif';			
									prevImg.title="<fmt:message key='tooltip.you.are.at.top'/>"
									prevImg.onclick = function(){};//donothing
								}else{

									firstImg.src = '/expensemap/jsp/images/beginning_enabled.gif';
									firstImg.title="<fmt:message key='tooltip.go.top'/>";
									firstImg.onclick=goToFirst;

									prevImg.src = '/expensemap/jsp/images/back_enabled.gif';
									prevImg.title=getToolTip("<fmt:message key='ui.image.tooltip.movePrevious'/>",pageData.pageSize);
									prevImg.onclick = goToPrev;
								}

								var nextImg = dojo.byId("next");
								var lastImg = dojo.byId("last");		
								if(pageData.limitRec == pageData.totalRec){
									
									nextImg.src = '/expensemap/jsp/images/forward_disabled.gif';
									nextImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";
									nextImg.onclick= function(){};//donothing
										
									lastImg.src = '/expensemap/jsp/images/end_disabled.gif';
									lastImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";	
									lastImg.onclick = function(){};//donothing
								}else{			
									nextImg.src = '/expensemap/jsp/images/forward_enabled.gif';
									var argForToolTip = ((pageData.totalRec-pageData.limitRec)>=pageData.pageSize)? pageData.pageSize : (pageData.totalRec - pageData.limitRec);
									nextImg.title=getToolTip("<fmt:message key='ui.image.tooltip.moveNext' />", argForToolTip);
									nextImg.onclick = goToNext;
									
									lastImg.src = '/expensemap/jsp/images/end_enabled.gif';
									lastImg.title="<fmt:message key='tooltip.go.bottom' />";
									lastImg.onclick = goToLast;
								}	
								dojo.byId("pagination_text").innerHTML = getPaginationText("<fmt:message key='ui.label.pagination.text' />",pageData.startRec,pageData.limitRec,pageData.totalRec);
							}else{
								dojo.byId("pagination_div").style.display="none";
							}
					}
		
					function getToolTip(msg,arg){			
						msg = msg.replace("{0}",arg);					
						return msg;
					}
					
					function getPaginationText(msg,startRec, limitRec, totalRec){
						msg = msg.replace("{0}", startRec);			
						msg = msg.replace("{1}" , limitRec);			
						msg = msg.replace("{2}", totalRec);			
						return msg;
					}
					
					function goToFirst(){getMaxRows('getFirst', false);}
					function goToPrev(){getMaxRows('getPrev', false);}
					function goToNext(){getMaxRows('getNext', false);}
					function goToLast(){getMaxRows('getLast', false);}

					function getMaxRows(action,applied){			
						var prevPageSize =dojo.byId("pageSize").value;
						var currPageSize = dojo.byId("userInput_pageSize").value;	
						if(!applied && prevPageSize!=currPageSize){				
							alert("<fmt:message key='ui.analytics.Navigate' />");
							return false;
						}else{				
							dojo.byId("pageSize").value = currPageSize;
							dojo.byId("theAction").value = action;				
							showAllAnalytic();
						}											
					}
			</script>
	</head>

<body class="claro">
	<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
	<jsp:include page="/jsp/topMenu.jsp">
		<jsp:param name="topMenuForm" value="analyticsListForm"/>
	</jsp:include>  
<div id="containerDiv" class="container" >	
	<form:form action="/expensemap/showAnalyticPage.xhtm" commandName="analyticsListForm" id="analyticsListForm">
			<!-- Search Tabulation START --> 
			<table class="tableWithBorder">
				 <tr>
					<td class="headerText" style="white-space:nowrap;"><fmt:message key="ui.label.Analytics" /></td>
					<td class="headerText" align="center" style="width:100%"><fmt:message key="ui.label.Dataset"  />&nbsp;<fmt:message key="ui.label.Name" />:&nbsp;<%=cubeName.toUpperCase()%></td>	
					<td align="right" style="width:30px;"><a href="#" onclick="printAnalytic();"><img src="/expensemap/jsp/images/print.gif" border="0" title="<fmt:message key='ui.print.image.tooltip'/>"/></a></td>	
					<td align="right" style="width:30px;">
						<a href="#" onclick="openHelp();">
							<img  src="/expensemap/jsp/images/help.gif" border="1" title="<fmt:message  key='ui.label.Help'/>"/>
						</a>						
					</td>
				</tr>
			</table>
			
			<div id="errorMsg_search" class="errorMsg"></div>
			<div id="searchDiv" class="searchContainer titleText" data-dojo-type="dijit/TitlePane" data-dojo-props="title: '<fmt:message key='ui.label.search' />',open:false,duration:1000" >
				<table width="" border="0" cellspacing="0" cellpadding="0" >
					<tr><td>
						<div class="searchComponentContainer">
							<div class="searchComponent">
								<fmt:message key="ui.report.table.header.name"/> &nbsp;&nbsp;
								<input type="text" name="search.analyticName" id="search_analyticName" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true"/>
							</div>							
							<div class="searchComponent">
								<fmt:message key="rpt.listing.search.fromDate"/>&nbsp;&nbsp;
								<input type="text" name="search.fromDateStr" id="search_FromDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>
							</div>
							<div class="searchComponent">
								<fmt:message key="rpt.listing.search.toDate"/>&nbsp;&nbsp;
								<input type="text" name="search.toDateStr" id="search_ToDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>							
							</div>
							<div class="searchComponent">
								<fmt:message key="ui.label.Created.By"/> &nbsp;&nbsp;
								<input type="text" name="search.createdBy" id="search_createdBy" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true"/>
							</div>	
							<div class="searchComponent search_checkBox">
								<fmt:message key="rpt.listing.column.report.type"/>:&nbsp;&nbsp;
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="transaction" name="search.reportTypeStr" value="TRANSACTION"/>&nbsp;<fmt:message key="ui.label.reportType.TRANSACTION" />&nbsp;	
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="dimension" name="search.reportTypeStr" value="DIMENSION" />&nbsp;<fmt:message key="ui.label.reportType.DIMENSION" />&nbsp;
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="trend" name="search.reportTypeStr" value="TREND" />&nbsp;<fmt:message key="ui.label.reportType.TREND"/>&nbsp;
								<input type="checkbox" data-dojo-type="dijit/form/CheckBox" id="topn" name="search.reportTypeStr" value="TOPN" />&nbsp;<fmt:message key="ui.label.reportType.TOPN" />&nbsp;
							</div>
						</div>
					</td></tr>
					<tr><td align="left" width="20%">				
						<div>
							<button data-dojo-type="dijit/form/Button" class="searchButton" id="search" name="search" type="button" >
								<fmt:message key="ui.label.search"/>
							</button>
							<button data-dojo-type="dijit/form/Button" class="searchButton" id="resetSearch" name="resetSearch" type="button" >
								<fmt:message key="button.reset"/>									
							</button>
						</div>	  
					</td></tr>
				</table>				
			</div>
			<!-- END OF SEARCH TITLE PANE-->
			
			<!-- GRID ELEMENTS -->
			<div id="errorMsg_grid" class="errorMsg"></div>
			<div id="errorMsg_other" class="errorMsg"></div>
			<br>
			<div id="Grid_Div" name="Grid_Div" class="objectGridDiv"></div>
			<!-- GRID ELEMENTS -->
			
			<!-- Action Buttons -->

			<div id="actionContainerDiv" class="actionContainerDiv">
				
				<div class="actionButton">
					<button data-dojo-type="dijit/form/Button" id="showAll" name="showAll"><fmt:message key="ui.label.ShowAll"/></button>
					<button data-dojo-type="dijit/form/Button" id="refresh" name="refresh"><fmt:message key="ui.label.Refresh"/></button>
					<button data-dojo-type="dijit/form/Button" id="delete" name="delete"><fmt:message key="ui.label.Delete" /></button>
					<button data-dojo-type="dijit/form/Button" id="cancel" name="cancel"><fmt:message key="button.cancelJob" /></button>
				</div>
						
				<div id="topReortDiv" style="display:block; float:left;">
					<button data-dojo-type="dijit/form/Button" id="topReport" name="topReport" ><fmt:message key="button.SaveAsTopreports"/></button>					
					<div id="category_div"></div> &nbsp;
					<input type="checkbox" data-dojo-type="dijit/form/CheckBox" name="privateReport" id="privateReport" /> 
					<span><fmt:message key="ui.label.private.report"/></span>
				</div>

				
				<!--Paggination  -->
				<div id='pagination_div' class="paginationDiv">
					<img id="first" style="vertical-align:middle;"/> 
					<img id="prev" style="vertical-align:middle;"/> 
					<img id="next" style="vertical-align:middle;"/> 
					<img id="last" style="vertical-align:middle;"/> &nbsp;
					<label id="pagination_text"></label> &nbsp;
					<!--Msg need to externalized-->
					<input type="text" id="userInput_pageSize" required="true"
								   maxLength="3"									   
								   data-dojo-type="dijit/form/ValidationTextBox"
								   data-dojo-props="regExp:'\\d{0,3}',
													style:{width:'5em'},
													promptMessage: '<fmt:message key= 'ui.bookmark.grid.pagesize.promptmessage'/>',
													invalidMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>',
													missingMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>'														
													" />
							
					<button data-dojo-type="dijit/form/Button" id="applyPageSize" name="applyPageSize" ><fmt:message key="button.apply"/></button>
				</div>
				<!--Paggination -->

			</div>
			<!-- Action Buttons -->

			<form:hidden id="startRec" path="pagination.startRec" />
			<form:hidden id="pageSize" path="pagination.pageSize" />
			<form:hidden id="limitRec" path="pagination.limitRec" />
			<form:hidden id="totalRec" path="pagination.totalRec" />
			<form:hidden id="lastRecord" path="pagination.lastRecord" />						
			<form:hidden id="listSortColumnName" path="pagination.listSortColumnName" />
			<form:hidden id="listSortOrder" path="pagination.listSortOrder" />
			<form:hidden id="theAction" path="theAction"/>
			
			<input type="hidden" id="eriId" name="eriId" />
			<input type="hidden" id="reportId" name="reportId" />
			<input type="hidden" id="reportType" name="reportType"/>
			<input type="hidden" id="reportName" name="reportName" />
			<input type="hidden" id="templateId" name="templateId" />
			<input type="hidden" id="operation" name="operation" value="editTemplate"/>
			<input type ='hidden' name="AuthCode" id="AuthCode" value="<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>"/>
	</form:form>
</div>
</body>	
</html>