<%-- 
   Created on Jul 17, 2012
  
   (C) COPYRIGHT International Business Machines Corp. 2012,2013.
   All rights reserved.
  
   US Government Users Restricted Rights - Use, duplication or
   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@ page language="java" contentType="text/html; charset=UTF-8"  pageEncoding="UTF-8"%>
<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="java.util.*,java.text.*"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import ="com.zeborg.util.WebUtil, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="java.util.Locale" %>

<%
		ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);	
		Locale locale=zs.getUser().getLocale();		
		String cubeName = zs.getDataSet().getDisplayName();			
		String  helpURL = HelpUtil.getHelpUtil().getHelpURLString("view_bookmark",locale);			
		pageContext.setAttribute("returnToURL","../showBookmarkListPage.xhtm", PageContext.SESSION_SCOPE);	
		EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_SRC_RESOURCE_BUNDLE, locale);
		String title = ExpenseMapAppProperties.getExpensemapTitle()+ " - "+ baseBundle.getValue("ui.label.existing.bookmarks");
		CubeUtil.buildExpMapMastHead(out,"viewFrame_attachment.jsp",zs,true,null,locale,null);
%>
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title><%=title %></title>

    <link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit.css"/>
    <link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit_rtl.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro_rtl.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid_rtl.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/claroGrid.css"/>
	<link rel="stylesheet" href="/expensemap/css/spendGridPageStyle.css"/>
	<script type="text/javascript">
		dojoConfig = {
			baseUrl : "/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/"
				
		};
	</script>

	<script type="text/javascript" src="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js" data-dojo-config="parseOnLoad: true" ></script>

	<script type="text/javascript">
										
			dojo.require("dojo/domReady");
			dojo.require("dojo/store/Memory");
			dojo.require("dojo/data/ObjectStore");
			dojo.require("dojox/grid/DataGrid");
			dojo.require("dojo/_base/xhr");
			dojo.require("dijit/layout/BorderContainer");
			dojo.require("dijit/form/Button");
			dojo.require("dijit/form/Select");
			dojo.require("dijit/TitlePane");
			dojo.require("dijit/form/TextBox");
			dojo.require("dijit/form/CheckBox");
			dojo.require('dijit/form/NumberTextBox');
			dojo.require("dijit/form/DateTextBox");
			dojo.require("dijit/form/ValidationTextBox");

			
			
			
						
dojo.ready(function(){
				
				var bookMark_Grid_Layout, bookMark_Grid_Store, bookMark_Grid_Obj, dataStore,categoryLabelValue;
				var isRootUser;
				
				var oldNameValue;
				var oldDescValue;

				//Layout definition.

				bookMark_Grid_Layout = [
										{														
											name: "<input id='selectAllRows' name='selectAllRows' type='checkbox' onClick='selectAll(this);'/>",
											fields :['id','deleteEnabled'],
											formatter:addCheckBox,								
											width:"30px"
										},{
											id: 'name',
											name: '<fmt:message key="ui.label.Name" />',
											fields: ['name'],
											headerStyles:"cursor:pointer",
											formatter:createLink,
											editable:true,
											width:"30%"
										},{
											id: 'sharedBy',
											name: '<fmt:message key="ui.label.Shared.By"/>',
											formatter:renderSharedBy,
											field: 'sharedBy',
											width:"10%"
										},{
											id: 'description',
											name: '<fmt:message key="ui.label.Description"/>',
											field:'description',								
											editable:'true',
											formatter : editDescription,
											width:"30%"
										},{
											id: 'dateCreated',
											name: '<fmt:message key="ui.label.Date.Created"/>',
											fields: ['userFormatDateCreated'],
											formatter:renderDateCreated,
											headerStyles:"cursor:pointer",											
											width:"10%"
										},{
											id: 'dateUpdated',
											name: '<fmt:message key="ui.label.Date.Last.Updated"/>',
											fields: ['userFormatDateUpdated'],
											formatter:renderDateUpdated,
											headerStyles:"cursor:pointer",
											width:"10%"
										},{
											id: 'share',
											name: '<fmt:message key="ui.label.Share"/>',
											fields: ['id','shareEnabled'],
											formatter:addShareImage,
											width:"10%"
										}
									];
	

					  require(["dojox/grid/DataGrid", "dojo/store/Memory", "dojo/data/ObjectStore", "dojo/_base/xhr", "dojo/domReady", "dijit/form/Select"],
						
							function(DataGrid, Memory, ObjectStore, xhr){
										xhr.post({
											url: "/expensemap/showList.jxhtm",
											handleAs: "json",
											content:{theAction: "showAll"}
										}).then(function(data){

										configurePaginationComponent(data.bookMarkListForm.bookmarkPagination);
										categoryLabelValue = new dijit.form.Select({
																			id:"category",
																			name: "category",
																			store: new ObjectStore({ objectStore: new Memory({ data: data.categorylabelvalue })}),
																			maxHeight: -1
																		 }
																		,"category_div");
										categoryLabelValue.startup();

										showTopReortDiv(data);
										isRootUser = data.isRootUser;
										bookMark_Grid_Store = new dojo.store.Memory({ data: data.bookmarkList });											 
										dataStore = new ObjectStore({ objectStore: bookMark_Grid_Store });
										bookMark_Grid_Obj = new DataGrid({
																			id:'bookMark_Grid',																			
																			autoHeight:true,
																			store: dataStore,																			
																			canSort : canSort,
																			canEdit : isEditable,
																			selectionMode:"single",
																			rowSelector: '0px',
																			onCellMouseOver: showImage,
																			onCellMouseOut: hideImage,
																			onApplyCellEdit : renameBookmark,
																			escapeHTMLInData:false,
																			structure : bookMark_Grid_Layout			
																		},																		
																		"bookMark_Grid_Div"
																);// End of DataGrid.										
										bookMark_Grid_Obj.startup();
																
										dojo.connect(bookMark_Grid_Obj, 'onStartEdit', function(inCell, inRowIndex) {
											oldNameValue = eval(bookMark_Grid_Obj.getItem(inRowIndex)).name; 
											oldDescValue = eval(bookMark_Grid_Obj.getItem(inRowIndex)).description;
										});	
										
										});
							}//End of function.
						);// End of required.
						
						// displays edit icon on mouser over
					function showImage(e){
							var imageDiv;
							if(isEditable(e.cell,e.rowIndex)){
								if(e.cell.id == 'name'){
									imageDiv = dojo.byId("imageDivName"+e.rowIndex);
									if(imageDiv){
										imageDiv.style.visibility = '';
									}
								}else if( e.cell.id == 'description'){
									imageDiv = dojo.byId("imageDivDescription"+e.rowIndex);
									if(imageDiv){
										imageDiv.style.visibility = '';
									}
								}
							}
							 
					}
					// hides edit icon on mouser out
					function hideImage(e){
						   if(e.cell.id === 'name' || e.cell.id === 'description'){
							  var imgDivName = dojo.byId("imageDivName"+e.rowIndex);
							  var imgDivDesc = dojo.byId("imageDivDescription"+e.rowIndex);
     						 
							  if(imgDivName){
								  imgDivName.style.visibility = 'hidden';
								} 
							  if(imgDivDesc){
								  imgDivDesc.style.visibility = 'hidden';
								}
						   }
     				}
						
					  function isEditable (inCell, inRowIndex){
					       var grid = dijit.byId("bookMark_Grid");
					       var isOwner = eval(grid.getItem(inRowIndex)).owner;
					       var shareEnabled = eval(grid.getItem(inRowIndex)).shareEnabled;
						   var hasDroppedMembers = eval(grid.getItem(inRowIndex)).hasDroppedMembers;

						   // The description and name of a bookmark having dropped members is disallowed to be edited from the list page.
						   if (hasDroppedMembers) {
						   		return false;
						   	}
						   	
					       if(!isRootUser){
					            if (!isOwner || !shareEnabled ){
					                return false;
					          } else {
					     	       return true;
					          }
					       } else {
					       	 return true;
					       }
					   }
					
					
					  function renameBookmark(inValue,inRowIndex,inFieldIndex){
						  var grid = dijit.byId("bookMark_Grid");
						  var bkId = eval(grid.getItem(inRowIndex)).id;
						  var bookMarkName = eval(grid.getItem(inRowIndex)).name;
						  var desc = eval(grid.getItem(inRowIndex)).description;
						  var isOwner = eval(grid.getItem(inRowIndex)).owner;
						  var shareEnabled = eval(grid.getItem(inRowIndex)).shareEnabled;
						  var errorMessage = document.getElementById("errorMsg_grid");
						  var isbookMarkNameEdit = false;
						  
						  if(inFieldIndex=="description"){
							  if (inValue === oldDescValue) {
								    errorMessage.style.display = "none";
								    errorMessage.innerHTML = '' ;
									return false;
							}
							  desc = dojo.trim(inValue); 
						  }
						  
						  // XXX: We get undefined for name column. Could be bug with Dojo Datagrid.
						  if (inFieldIndex == undefined) {
							  if (inValue === oldNameValue) {
								    errorMessage.style.display = "none";
								    errorMessage.innerHTML = '' ;
									return;
							 }
							  bookMarkName = dojo.trim(inValue); 
							  isbookMarkNameEdit = true;
						  }
						  
						  if(bookMarkName == "" || desc == ""){
							  errorMessage.style.display = "block";
							  var store = grid.store;
							  // XXX: We get undefined for name column. Could be bug with Dojo Datagrid.
							  if(inFieldIndex == undefined){
							  	errorMessage.innerHTML = '<fmt:message key="ui.message.Please.fill.in.the.following.field.s.."/> <fmt:message key="ui.label.Name" />' ;
							  	store.setValue(grid.getItem(inRowIndex), inFieldIndex, oldNameValue);
							  }
							  if(inFieldIndex=="description"){
								  errorMessage.innerHTML = '<fmt:message key="ui.message.Please.fill.in.the.following.field.s.."/> <fmt:message key="ui.label.Description"/>'  ;
								  store.setValue(grid.getItem(inRowIndex), inFieldIndex, oldDescValue);
							  }
							 
							  grid.update();
							  return false;
						  }else {
							  errorMessage.style.display = "none";
							  errorMessage.innerHTML = '' ;
						  }
						  
						  //checking the bookmarkName length
						  if(bookMarkName.length > 255){
							  errorMessage.style.display = "block";
							  errorMessage.innerHTML = '<fmt:message key="ui.message.name.is.too.long.please.enter.maximum.255.characters.in.name.field"/>' ;
							  var store = grid.store;
							  store.setValue(grid.getItem(inRowIndex), inFieldIndex, oldNameValue);
							  grid.update();
							  return false;
						  }else {
							  errorMessage.style.display = "none";
							  errorMessage.innerHTML = '' ;
						    }
						  
						//checking the bookmarkDescription length
						  if(desc.length >255){
							  errorMessage.style.display = "block";
							  errorMessage.innerHTML = '<fmt:message key="ui.message.description.is.too.long.please.enter.maximum.255.characters.in.description.field"/>' ;
							  var store = grid.store;
							  store.setValue(grid.getItem(inRowIndex), inFieldIndex, oldDescValue);
							  grid.update();
							  return false;
						  }else {
							  errorMessage.style.display = "none";
							  errorMessage.innerHTML = '' ;
						  }
						 						  
						var frm = dojo.byId("bookMarkListForm");
						frm.action="/expensemap/save_bk.jxhtm";	
						var xhrArgs = {
								 form: frm,
								handleAs: "json",
								content : {description:desc,id:bkId,name:bookMarkName,"saveType":"Save","bookMarkNameEdit":isbookMarkNameEdit,theAction:"getCurrent"},
								load: function(data){
									if(!eval(data)){
										return;
									}
									refreshGridStore(data);
								}// end of load.										
							}// End of xhrArgs.
						dojo.xhrPost(xhrArgs);
						}
						
					function refreshGridStore(responseData){
						if(!validateUserSession(responseData)) return false; // function validateUserSession() defined with topMenu.jsp
						displayErrorIfAny(responseData);
						showTopReortDiv(responseData);						
						configurePaginationComponent(responseData.bookMarkListForm.bookmarkPagination);	
						var newStore = new dojo.store.Memory({ data: responseData.bookmarkList });						
						var newDataStore = new dojo.data.ObjectStore({ objectStore: newStore });						
						bookMark_Grid_Obj.setStore(newDataStore);						
					}

					function displayErrorIfAny(responseData){
						var gridMsgDiv = dojo.byId("errorMsg_grid");
						var searchMsgDiv = dojo.byId("errorMsg_search");
						var msgDiv = dojo.byId("msg");
						msgDiv.style.display = "none";
						msgDiv.innerHTML =  "";
						gridMsgDiv.style.display = "none";
						gridMsgDiv.innerHTML =  "";
						searchMsgDiv.style.display = "none";						
						searchMsgDiv.innerHTML = "";						
						if(responseData.errorMsg_grid != 'undefined' && responseData.errorMsg_grid != null ){
							gridMsgDiv.style.display = "block";
							gridMsgDiv.innerHTML =  "<b>"+responseData.errorMsg_grid+"</b>";
						}
						if(responseData.errorMsg_search != 'undefined' && responseData.errorMsg_search != null){
							searchMsgDiv.style.display = "block";
							searchMsgDiv.innerHTML = "<b>" + responseData.errorMsg_search + "</b>";
						}
					}

					function showAllBookMark(){						
						var frm = dojo.byId("bookMarkListForm");
						frm.action="/expensemap/showList.jxhtm";	
						var xhrArgs = {
								form: frm,
								handleAs: "json",
								load: function(data){
									refreshGridStore(data);
								}// end of load.										
							}// End of xhrArgs.
						dojo.xhrPost(xhrArgs);
						
					}
					
					require(["dojo/on", "dojo/topic", "dojo/dom-construct"],
						function(on, topic, domConstruct) {

							var resetSearch = dojo.byId("resetSearch");
							on(resetSearch, "click", function() {								
								resetSearchOptions();								
							});
							
							var showAll = dojo.byId("showAll");
							on(showAll, "click", function() {
								resetSearchOptions();
								dojo.byId("theAction").value = "showAll";
								showAllBookMark();
							});

							

						    var searchButton = dojo.byId("search");
							on(searchButton, "click",function() {								
								if(dojo.byId("search_name").value=="" && 
								   dojo.byId("search_createdBy").value=="" && 
								   dojo.byId("search_FromDate").value=="" && 
								   dojo.byId("search_ToDate").value=="")
									
								   dojo.byId("theAction").value="showAll";
								 
								   showAllBookMark();
								
							});

							var applyPageSizeButton = dojo.byId("applyPageSize");
							on(applyPageSizeButton, "click",function() {								
								dojo.byId("pageSize").value = dojo.byId("userInput_pageSize").value;
								dojo.byId("maxRowsList").value = dojo.byId("pageSize").value;
								dojo.byId("theAction").value="getCurrent";
								showAllBookMark();
							});				



							var deleteButton = dojo.byId("delete");
							on(deleteButton, "click", function() {								
								if(!dijit.byId("delete").get("disabled")){
									var frm = dojo.byId("bookMarkListForm");
									var isSelected = checkAtLeastOneSelected();
									if (frm.bookmarkIds.length > 0 && isSelected || frm.bookmarkIds.value && isSelected) {
										if (confirm('<fmt:message key="ui.delete.alertmsg"/>')) {
											frm.action="/expensemap/deleteBookMark.jxhtm";										
											var xhrArgs = {
												form: frm,
												handleAs: "json",
												load: function(data){
													refreshGridStore(data);
												}// end of load.										
											}// End of xhrArgs.
											dojo.xhrPost(xhrArgs);
										}
									}
								}
							});


							var topReport = dojo.byId("topReport");
							on(topReport, "click", function() {
								if(!dijit.byId("topReport").get("disabled")){
									var frm = dojo.byId("bookMarkListForm");
									var noOfRows ;
									
									if(frm.bookmarkIds.checked){
										noOfRows=1;
									}else{
										noOfRows = frm.bookmarkIds.length;
									}
									var reportCategory=frm.category.value;
									var privateReport=frm.privateReport.checked;									
									var confirmMsg = '';
									
									if(privateReport){
										confirmMsg="<fmt:message key='ui.save.topreport.private.continue.alertmsg' />";
									}else{
										confirmMsg = "<fmt:message key='ui.save.topreport.alertmsg' />";
									}
									if (confirm(confirmMsg)){																				
										frm.action = "/expensemap/saveBookmarkAsTopReport.jxhtm";
										var xhrArgs = { form:frm,
														handleAs: "json",												
														content: {category: reportCategory,privateReport: privateReport},
														load: function(data){refreshGridStore(data);}};										  
										 dojo.xhrPost(xhrArgs);
									}else{
										return false;
									}
								}
							});// Top Report event handler.




						}//End of function. 
					);// End of require.
					
			// name		
			function createLink(field, inRowIndex){
			    var returnString = "";
			    var grid = dijit.byId("bookMark_Grid");
			    var id = eval(grid.getItem(inRowIndex)).id;
			    var name = eval(grid.getItem(inRowIndex)).name;
			    var isTopReport = eval(grid.getItem(inRowIndex)).topReport
			    var isPrivateTopReport = eval(grid.getItem(inRowIndex)).privateTopReport;
			    if(isPrivateTopReport)
			     returnString = "<img src='/expensemap/jsp/images/report/private_reports_icon.jpg' border='0' title='<fmt:message key='ui.topn.Private.Top.Report' />' />";
			    if(isTopReport)
			     returnString = "<img src='/expensemap/jsp/images/report/reports_icon.gif' border='0' title='<fmt:message key='ui.topn.Top.Report' />' />";					

			     return returnString + '<a href="#" onclick="viewBookMark(\'' + id + '\')" >' + name + '</a><span style="visibility:hidden;margin-left:10px;" id="imageDivName'+inRowIndex+'" ><img  src="/expensemap/jsp/images/edit.gif" border="0" /></span>';    
			}

			// for displaying edit icon for description field
			function editDescription(field, inRowIndex){
				var grid = dijit.byId("bookMark_Grid");
				var hasDroppedMembers = eval(grid.getItem(inRowIndex)).hasDroppedMembers;
				
				var desc = ""
				if (hasDroppedMembers) {
					var bookmarkId = eval(grid.getItem(inRowIndex)).id;
					desc = '<a href="#" title=<fmt:message  key="ui.lable.bookmark.droppedmembers"/> onClick=showMembers(\"'+ bookmarkId +'\");><fmt:message  key="ui.lable.bookmark.droppedmembers"/></a><br>';
				}
				
				desc = desc + field  +  '<span style="visibility:hidden;margin-left:10px;" id="imageDivDescription'+inRowIndex+'" ><img  src="/expensemap/jsp/images/edit.gif" border="0" /></span>';
				
				return desc;
			}

			// [id , deleteEnabled]
			function addCheckBox(fields){				
				if(fields[1])
					return '<input type="checkbox" name="bookmarkIds"  value="'+ fields[0] + '"onclick="updateSelectAll(this);"  />';
				return '<input type="checkbox" data-dojo-type="dijit/form/CheckBox" disabled />';
			}

			function canSort(col){
				
				var returnVal = true;
				
				//positive for an ascending sort and negative for a descending sort
				var sortingOrder = "desc";
				if(col > 0){
					sortingOrder="asc";
				}

				dojo.byId("listSortOrder").value = sortingOrder;

				var sortingColName;

				switch(col){
											
					case 2:	case -2:
						sortingColName = "byName";
						break;
					case 5: case -5:
						sortingColName = "dateCreated";
						break;					
					case 6:	case -6:
						sortingColName = "dateUpdated";
						break;	
					case  1: case -1:
					case 3:	case -3:
					case 4:	case -4:
					case 7: case -7:
						returnVal = false;
						break;					
									
				}
				
				dojo.byId("listSortColumnName").value = sortingColName;
				dojo.byId("theAction").value="getCurrent";
				if(returnVal){ showAllBookMark();}

				return returnVal;
			}

			/*
				issue with IE 8 and 9.
				if col field value is null then Col value will be blank and
				CSS will not be applied. so return html space tag 
			*/

			function renderSharedBy(field){
				if(field!=null){return field;}

				return "&nbsp;";
				
			}
			
			//Function will render creation date of Dashboard objects
				//field:dateCreatedStr
				function renderDateCreated(fields){
					if(isEmpty(fields[0])) return "&nbsp;";
					
					return fields[0];					
				}

				//Function will render last updated date of Dashboard objects
				//field:dateUpdatedStr
				function renderDateUpdated(fields){
					if(isEmpty(fields[0])) return "&nbsp;";					
					
					return fields[0];					
				}
					// Function will check whether field is Empty or not.
				function isEmpty(field){
					if( field != null && field != "" )	return false;

					return true;
				}
			
			/*
				issue with IE 8 and 9.
				if col field value is null then Col value will be blank and
				CSS will not be applied. so return html space tag 
			*/			
			//['id','shareEnabled']
			function addShareImage(fields){
				if(fields[1])
					return '<a href="#" onclick="shareView(\'' + fields[0] + '\');"><img src="/expensemap/jsp/images/share_icon.gif" border="0"/></a>';					
				return "&nbsp;"
			}


			function isOwner(val){
				if(val)
					return '<img src="/expensemap/jsp/images/nonshared.gif">';
				return '<img src="/expensemap/jsp/images/shared.gif">';
			}



function isOwner(val){
	if(val)
		return '<img src="/expensemap/jsp/images/nonshared.gif">';
	return '<img src="/expensemap/jsp/images/shared.gif">';
}
			


function configurePaginationComponent(pageData){
	
	//Set all Hidden variables
	dojo.byId("startRec").value=pageData.startRec;				
	dojo.byId("pageSize").value=pageData.pageSize;
	dojo.byId("userInput_pageSize").value=pageData.pageSize;
	dojo.byId("limitRec").value=pageData.limitRec;
	dojo.byId("totalRec").value=pageData.totalRec;
	dojo.byId("listSortOrder").value=pageData.listSortOrder;
	dojo.byId("listSortColumnName").value=pageData.listSortColumnName;
	dojo.byId("lastRecord").value=pageData.lastRecord;		
	var totalBookMarkCount = pageData.totalRec;

	if(totalBookMarkCount!='undefined' && totalBookMarkCount > 0){		
		dojo.byId("pagination_div").style.display="block";		
		dojo.byId("pagination_text").innerHTML="";
		var firstImg = dojo.byId("first");
		var prevImg = dojo.byId("prev");
		if(pageData.startRec==1){
			
			firstImg.src = '/expensemap/jsp/images/beginning_disabled.gif';
			firstImg.title="<fmt:message key='tooltip.you.are.at.top'/>";
			firstImg.onclick=function(){};//donothing
				
			prevImg.src = '/expensemap/jsp/images/back_disabled.gif';			
			prevImg.title="<fmt:message key='tooltip.you.are.at.top'/>"
			prevImg.onclick = function(){};//donothing
		}else{
			firstImg.src = '/expensemap/jsp/images/beginning_enabled.gif';
			firstImg.title="<fmt:message key='tooltip.go.top'/>";
			firstImg.onclick=goToFirst;

			prevImg.src = '/expensemap/jsp/images/back_enabled.gif';
			prevImg.title=getToolTip("<fmt:message key='ui.image.tooltip.movePrevious'/>",pageData.pageSize);
			prevImg.onclick = goToPrev;
		}

		var nextImg = dojo.byId("next");
		var lastImg = dojo.byId("last");		
		if(pageData.limitRec == pageData.totalRec){
			nextImg.src = '/expensemap/jsp/images/forward_disabled.gif';
			nextImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";
			nextImg.onclick= function(){};//donothing
				
			lastImg.src = '/expensemap/jsp/images/end_disabled.gif';
			lastImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";	
			lastImg.onclick = function(){};//donothing
		}else{			
			nextImg.src = '/expensemap/jsp/images/forward_enabled.gif';
			var argForToolTip = ((pageData.totalRec-pageData.limitRec)>=pageData.pageSize)? pageData.pageSize : (pageData.totalRec - pageData.limitRec);
			nextImg.title=getToolTip("<fmt:message key='ui.image.tooltip.moveNext' />", argForToolTip);
			nextImg.onclick = goToNext;
			
			lastImg.src = '/expensemap/jsp/images/end_enabled.gif';
			lastImg.title="<fmt:message key='tooltip.go.bottom' />";
			lastImg.onclick = goToLast;
		}	
		dojo.byId("pagination_text").innerHTML = getPaginationText("<fmt:message key='ui.label.pagination.text' />",pageData.startRec,pageData.limitRec,pageData.totalRec);
	}else{
		dojo.byId("pagination_div").style.display="none";
	}
}
		function getToolTip(msg,arg){			
			msg = msg.replace("{0}",arg);					
			return msg;
		}
		
		function getPaginationText(msg,startRec, limitRec, totalRec){
			msg = msg.replace("{0}", startRec);			
			msg = msg.replace("{1}" , limitRec);			
			msg = msg.replace("{2}", totalRec);			
			return msg;
		}
		
		function goToFirst(){getMaxRows('getFirst', false);}
		function goToPrev(){getMaxRows('getPrev', false);}
		function goToNext(){getMaxRows('getNext', false);}
		function goToLast(){getMaxRows('getLast', false);}

		function getMaxRows(action,applied){			
			var prevPageSize =dojo.byId("pageSize").value;
			var currPageSize = dojo.byId("userInput_pageSize").value;	
			if(!applied && prevPageSize!=currPageSize){				
				alert("<fmt:message key='ui.analytics.Navigate' />");
				return false;
			}else{				
				dojo.byId("pageSize").value = currPageSize;
				dojo.byId("theAction").value = action;				
				showAllBookMark();
			}											
		}

});// End of dojo.ready.
		
		function openHelp(){			
			open( "<%=helpURL%>", "SA_Help" );	
		}
		function viewBookMark(bkid){
			open('/expensemap/getDimensionalView.do?viewSelected=dimension&bkid=' + bkid, '_self', 'resizable=yes,width=1000,height=470' );
		}

		function shareView(id) {
			var ht = 475;
			var wt = 935;
			var left = (screen.width/2)-(wt/2);
			var top = (screen.height/2)-(ht/2);	
			open('/expensemap/shareObject.shtm?viewType=bookmark&id=' + id, 'SA_ShareView', "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
		}
		
		
		
		// Show OR Hide create top report options.
		function showTopReortDiv(responseData){
			var topReortDiv = dojo.byId("topReortDiv");
			if(responseData.canCreateTopReport){
				topReortDiv.style.display="block";
				
			}else{
				topReortDiv.style.display="none";
			}
			dijit.byId("topReport").set("disabled",true);
			dijit.byId("category").set("disabled",true);			
			dijit.byId("privateReport").set("checked",false);
			dijit.byId("privateReport").set("disabled",true);			
			dijit.byId("delete").set("disabled",true);
		}
	
		
	
		function viewBookMark(bkid){
			open('/expensemap/getDimensionalView.do?viewSelected=dimension&bkid=' + bkid, '_self', 'resizable=yes,width=1000,height=470' );
		}
		
		function selectAll(selectAllControl) {
			var theForm =  document.getElementById("bookMarkListForm");
			if ( theForm.bookmarkIds == null ) {
				document.getElementById("selectAllRows").checked=false;
				document.getElementById("selectAllRows").disabled=true;
				return false;	
			} 
			
			if ( theForm.bookmarkIds.length ) {
				// There are more than one rows on this form.
				for( var i=0; i< theForm.bookmarkIds.length; i++ ) {					
					theForm.bookmarkIds[i].checked = selectAllControl.checked;
				}
			}
			// There is just a single row on this form.
			theForm.bookmarkIds.checked = selectAllControl.checked;
			enableDisableComponents(!selectAllControl.checked);			
		}
		
		function enableDisableComponents(value){
			dijit.byId("topReport").set("disabled",value);
			dijit.byId("category").set("disabled",value);
			dijit.byId("privateReport").set("disabled",value);
			dijit.byId("delete").set("disabled",value);			
		}
		
		function updateSelectAll(checkboxSelected) {			
			var theForm = document.getElementById("bookMarkListForm");
			var selectAllControl = document.getElementById("selectAllRows");
			var allSelected = true;			
			if (!theForm.bookmarkIds.length ) {
				allSelected = checkboxSelected.checked;
			} else {
				for( var i=0; i< theForm.bookmarkIds.length; i++ ) {
					if ( theForm.bookmarkIds[i].checked == false ) {
						allSelected = false;
						break;
					}
				}
			}
			
			selectAllControl.checked = allSelected;
			if (checkAtLeastOneSelected()) {
				enableDisableComponents(false);					
			}else{
				enableDisableComponents(true);					
			}				
		}

		function checkAtLeastOneSelected() {				
			var frm = document.getElementById("bookMarkListForm");
			if (frm.bookmarkIds.length) { // if the checkbox group is an array (one check box is not an array)
				var noOfRows = frm.bookmarkIds.length;
				for (i = 0; i < noOfRows; i++) {
					if (frm.bookmarkIds[i].checked == true) {			
						return true;
					}
				}
			}else { // There is only one check box (it's not an array)
				if (frm.bookmarkIds.checked) { // if the one check box is checked
					return true;
				}
			}
			return false;
		}

		function shareView(id) {
			var ht = 475;
			var wt = 935;
			var left = (screen.width/2)-(wt/2);
			var top = (screen.height/2)-(ht/2);	
			open('/expensemap/shareObject.shtm?viewType=bookmark&id=' + id, 'SA_ShareView', "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
		}

		function resetSearchOptions(){				
			dijit.byId("search_name").set('value',"");
			dijit.byId("search_createdBy").set('value',"");
			dijit.byId("search_FromDate").set('value',' ');
			dijit.byId("search_ToDate").set('value',' ');
			HideSearchErrDiv();
		}

		function HideSearchErrDiv(){
			var searchErrDiv = document.getElementById("errorMsg_search");
			if(searchErrDiv.style.display=='block'){
				searchErrDiv.innerHTML="";
				searchErrDiv.style.display='none';
			}
		}
		function showMembers(bookmarkId){	
			var ht = 400;
			var wt = 550;
			var left = (screen.width/2)-(wt/2);
			var top = (screen.height/2)-(ht/2);	
			var url ="/expensemap/bookmark/showDroppedMembers.xhtm?bkId=" + bookmarkId; 
			window.open(url, "_blank", "resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
		}

	</script>

</head>
<body class="claro">
	
	<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
	<jsp:include page="/jsp/topMenu.jsp">
		<jsp:param name="topMenuForm" value="bookMarkListForm"/>
	</jsp:include>   
		
<div id="containerDiv" class="container" >	
	<form:form action="/expensemap/showBookmarkListPage.xhtm" commandName="bookMarkListForm" id="bookMarkListForm">
		<table class="tableWithBorder">
			 <tr>
				<td class="headerText"><fmt:message key="ui.label.existing.bookmarks"/></td>
				<td class="headerText" align="left"><fmt:message key="ui.usability.report.heading.datasetname"  />:&nbsp;<%=cubeName.toUpperCase()%></td>	
				<td align="right"><a onclick="openHelp();" href="#"><img title="<fmt:message  key='ui.label.Help' />" src="/expensemap/jsp/images/help.gif" border="0"></a></td>
			</tr>
		</table>
		<div id="errorMsg_search" class="errorMsg"></div>
		<div id="searchDiv" class="searchContainer titleText" data-dojo-type="dijit/TitlePane" data-dojo-props="title: '<fmt:message key='ui.label.search' />',open:false,duration:1000" >
			<table width="" border="0" cellspacing="0" cellpadding="0" >
			<tr><td>
				<div class="searchComponentContainer">
					<div class="searchComponent">
						<fmt:message key="ui.label.search.BookmarkName"/> &nbsp;&nbsp;
						<input type="text" name="search.name" id="search_name" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true"/>
					</div>
					<div class="searchComponent">
						<fmt:message key="ui.label.Created.By"/>&nbsp;&nbsp;
						<input type="text" name="search.createdBy" id="search_createdBy" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true"  />
					</div>
					<div class="searchComponent">
						<fmt:message key="rpt.listing.search.fromDate"/>&nbsp;&nbsp;
						<input type="text" name="search.fromDateStr" id="search_FromDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>
					</div>
					<div class="searchComponent">
						<fmt:message key="rpt.listing.search.toDate"/>&nbsp;&nbsp;
						<input type="text" name="search.toDateStr" id="search_ToDate" data-dojo-type="dijit/form/DateTextBox" constraints="{datePattern:'${userDatePattern}'}"/>							
					</div>
				</div>
			</td></tr>

			<tr><td align="left" width="20%">				
					<div>
						<button data-dojo-type="dijit/form/Button" class="searchButton" id="search" name="search" type="button" >
							<fmt:message key="ui.label.search"/>
						</button>
						<button data-dojo-type="dijit/form/Button" class="searchButton" id="resetSearch" name="resetSearch" type="button" >
							<fmt:message key="button.reset"/>									
						</button>
					</div>	  
				</td></tr>
			</table>
		</div>

		<div  class="errorMsg" id="msg" name="msg"></div>
				
		<div id="errorMsg_grid" class="errorMsg"></div>
		<BR>
		<div id="bookMark_Grid_Div" name="bookMark_Grid_Div" class="objectGridDiv"></div>
				
		<div id="actionContainerDiv" class="actionContainerDiv">
			<div class="actionButton">
				<button data-dojo-type="dijit/form/Button" id="showAll" name="showAll"><fmt:message key="show.all"/></button>					
				<button data-dojo-type="dijit/form/Button" id="delete" name="delete"><fmt:message key="ui.label.Delete" /></button>
			</div>
						
			<div id="topReortDiv" style="display:block;float:left;">
				<button data-dojo-type="dijit/form/Button" id="topReport" name="topReport" type="button"><fmt:message key="button.SaveAsTopreports"/></button>					
				<div id="category_div"></div> &nbsp;
				<input type="checkbox" data-dojo-type="dijit/form/CheckBox" name="privateReport" id="privateReport" /> 
				<span><fmt:message key="ui.label.private.report"/></span>
			</div>
		
			<div id='pagination_div' class="paginationDiv">
				<img id="first" style="vertical-align:middle;"/> 
				<img id="prev" style="vertical-align:middle;"/> 
				<img id="next" style="vertical-align:middle;"/> 
				<img id="last" style="vertical-align:middle;"/> &nbsp;
				<label id="pagination_text"></label> &nbsp;
				<!--Msg need to externalized-->
				<input type="text" id="userInput_pageSize" required="true"
							   maxLength="3"									   
							   data-dojo-type="dijit/form/ValidationTextBox"
							   data-dojo-props="regExp:'\\d{0,3}',
												style:{width:'5em'},
												promptMessage: '<fmt:message key= 'ui.bookmark.grid.pagesize.promptmessage'/>',
												invalidMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>',
												missingMessage:'<fmt:message key= 'ui.alertmsg.rowsPerPage'/>'														
												" />
							
				<button data-dojo-type="dijit/form/Button" id="applyPageSize" name="applyPageSize" type="button" ><fmt:message key="button.apply"/></button>
			</div>
		</div>

		<form:hidden id="startRec" path="bookmarkPagination.startRec" />
		<form:hidden id="pageSize" path="bookmarkPagination.pageSize" />
		<form:hidden id="limitRec" path="bookmarkPagination.limitRec" />
		<form:hidden id="totalRec" path="bookmarkPagination.totalRec" />
		<form:hidden id="lastRecord" path="bookmarkPagination.lastRecord" />
		<form:hidden id="listSortOrder" path="bookmarkPagination.listSortOrder" />
		<form:hidden id="listSortColumnName" path="bookmarkPagination.listSortColumnName" />
		<form:hidden id="theAction" path="theAction"/>
		<input type="hidden" name="maxRowsList" id="maxRowsList" />
		<input type ='hidden' name="AuthCode" id="AuthCode" value="<c:out value='${sessionScope.hma_code_allActions}'/>"/>
	</form:form>
</div>
</body>		
</html>