<%--
   Created on Jul 17, 2012
  
   (C) COPYRIGHT International Business Machines Corp. 2012
   All rights reserved.
  
   US Government Users Restricted Rights - Use, duplication or
   disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<%@ taglib uri="http://www.springframework.org/tags/form" prefix="form"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@ page import="com.zeborg.expensemap.model3.DataSet"%>
<%@ page import="java.util.*,java.text.*"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import ="com.zeborg.util.WebUtil, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="java.util.Locale" %>

<%
	ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);
	Locale locale=zs.getUser().getLocale();
	String cubeName = zs.getDataSet().getDisplayName();
	String  helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.help.dashboards.bookmark.search.page",locale);
	EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_SRC_RESOURCE_BUNDLE, locale);
%>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title><%= ExpenseMapAppProperties.getExpensemapTitle() + " - " + baseBundle.getValue("ui.label.existing.bookmarks") %></title>

    <link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit.css"/>
    <link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/dijit_rtl.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dijit/themes/claro/claro_rtl.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/Grid_rtl.css"/>
	<link rel="stylesheet" href="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojox/grid/resources/claroGrid.css"/>
	<link rel="stylesheet" href="/expensemap/css/spendGridPageStyle.css"/>
	
	<script type="text/javascript">
		dojoConfig = {
			baseUrl : "/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/"
				
		};
	</script>

	<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js"></script>
	<script type="text/javascript" src="/expensemap/jsp/javascript/idx/dojo_1.7.2/dojo/dojo.js" data-dojo-config="parseOnLoad: true" ></script>

	<script type="text/javascript">
										
			dojo.require("dojo/domReady");
			dojo.require("dojo/store/Memory");
			dojo.require("dojo/data/ObjectStore");
			dojo.require("dojox/grid/DataGrid");
			dojo.require("dojo/_base/xhr");
			dojo.require("dijit/layout/BorderContainer");
			dojo.require("dijit/form/Button");
			dojo.require("dijit/form/Select");
			dojo.require("dijit/TitlePane");
			dojo.require("dijit/form/TextBox");
			dojo.require("dijit/form/CheckBox");
			dojo.require('dijit/form/NumberTextBox');
			dojo.require("dijit/form/DateTextBox");
			dojo.require("dijit/form/ValidationTextBox");
			
			var searchBookmarkFunction;
			
dojo.ready(function(){
							
		var bookMark_Grid_Layout, bookMark_Grid_Store, bookMark_Grid_Obj, dataStore;
		var isRootUser;

		bookMark_Grid_Layout = [
					{
						id: 'name',
						name: '<fmt:message key="ui.label.Name" />',
						field:'name',
						headerStyles:"cursor:pointer;",
						formatter:createLink,
						width: "auto"
					},{
						id: 'owner',
						name: '<fmt:message key="ui.label.Ownership"/>',
						field: 'owner',
						formatter : isOwner,
						width:"10%"
					},{
						id: 'sharedBy',
						name: '<fmt:message key="ui.label.Shared.By"/>',
						formatter:renderSharedBy,
						field: 'sharedBy',
						width:"10%"
					},{
						id: 'description',
						name: '<fmt:message key="ui.label.Description" />',
						field:'description',
						formatter : renderDescription,
						width:"20%"
					},{
						id: 'dateCreated',
						name: '<fmt:message key="ui.label.Date.Created" />',
						field: 'userFormatDateCreated',
						headerStyles:"cursor:pointer;",
						width:"20%"
					},{
						id: 'dateUpdated',
						name: '<fmt:message key="ui.label.Date.Last.Updated" />',
						field: 'userFormatDateUpdated',
						headerStyles:"cursor:pointer;",
						width:"20%"
					}
			];
			
			
			require(["dojox/grid/DataGrid", "dojo/domReady"],

				function(DataGrid){
					bookMark_Grid_Obj = new DataGrid({
														id:'bookMark_Grid',																			
														autoHeight:true,
														store: dataStore,																			
														canSort : canSort,
														style:"display:none",
														selectionMode:"single",
														rowSelector: '0px',
														structure : bookMark_Grid_Layout			
													},																		
													"bookMark_Grid_Div"
											);// End of DataGrid.										
					bookMark_Grid_Obj.startup();
				}//End of function.
			);// End of required.
			
			function canSort(col) {							
				var returnVal = true;

				//positive for an ascending sort and negative for a descending sort
				var sortingOrder = "desc";
				if(col > 0){
					sortingOrder="asc";
				}

				dojo.byId("listSortOrder").value = sortingOrder;

				var sortingColName;

				switch(col){

					case 1:	case -1:
						sortingColName = "byName";
						break;
					case 5: case -5:
						sortingColName = "dateCreated";
						break;					
					case 6:	case -6:
						sortingColName = "dateUpdated";
						break;	
					case  1: case -1:
					case 3:	case -3:
					case 4:	case -4:
					case 5: case -5:
					case 9:	case -9:
					case 8:	case -8:					
						returnVal = false;
						break;					

				}

				dojo.byId("listSortColumnName").value = sortingColName;
				dojo.byId("theAction").value="getCurrent";
				if(returnVal){ showAllBookMark();}

				return returnVal;
			}
			
			
			function refreshGridStore(responseData) {
				displayErrorIfAny(responseData);
				if(responseData.bookmarkList.length > 0){
					bookMark_Grid_Obj.set("style","display:block");
					configurePaginationComponent(responseData.bookMarkListForm.bookmarkPagination);	
					var newStore = new dojo.store.Memory({ data: responseData.bookmarkList });
					var newDataStore = new dojo.data.ObjectStore({ objectStore: newStore });
					bookMark_Grid_Obj.setStore(newDataStore);
					
					// To correctly render the last row, resize and update the grid after some interval.
					setTimeout(function() {
						bookMark_Grid_Obj.resize();
						bookMark_Grid_Obj.update();
					}, 350);
				}else{
					bookMark_Grid_Obj.set("style","display:none");
				}									
			}			
			
			// name		
			function createLink(field, inRowIndex){
			    var grid = dijit.byId("bookMark_Grid");
			    var id = eval(grid.getItem(inRowIndex)).id;
			    // Replace all html code of single quote(&#x27) with \'
			    var name = eval(grid.getItem(inRowIndex)).name;
			    var shortName = eval(grid.getItem(inRowIndex)).shortName;
			    return '<a href="#" onclick="goToDashboardPage(\'' + id + '\'' + ',\''
							+ escapeHexEncodedHTML(name) + '\')" title="'+name+'">' + name + '</a>'; 
			}
			
			function renderDescription(field, inRowIndex){
				if (field != null) {
					var grid = dijit.byId("bookMark_Grid");
					return grid.getItem(inRowIndex).description;
				}

				return "&nbsp;";
			}

			/*
				issue with IE 8 and 9.
				if col field value is null then Col value will be blank and
				CSS will not be applied. so return html space tag 
			*/
			function renderSharedBy(field){
				if(field!=null){return field;}

				return "&nbsp;";
			}
			
			function isOwner(val){
				if(val)
					return '<img src="/expensemap/jsp/images/nonshared.gif">';
				return '<img src="/expensemap/jsp/images/shared.gif">';
			}
									
									
			function showAllBookMark(){						
				var frm = dojo.byId("bookMarkListForm");
				frm.action="/expensemap/showList.jxhtm";	
				var xhrArgs = {
						form: frm,
						handleAs: "json",
						load: function(data){
							refreshGridStore(data);
						}// end of load.										
					}// End of xhrArgs.
				dojo.xhrPost(xhrArgs);									
			}

			
			function displayErrorIfAny(responseData){
				var gridMsgDiv = dojo.byId("errorMsg_grid");
				var searchMsgDiv = dojo.byId("errorMsg_search");
				gridMsgDiv.style.display = "none";
				gridMsgDiv.innerHTML =  "";
				searchMsgDiv.style.display = "none";						
				searchMsgDiv.innerHTML = "";						
				if(responseData.errorMsg_grid != 'undefined' && responseData.errorMsg_grid != null ){
					gridMsgDiv.style.display = "block";
					gridMsgDiv.innerHTML =  "<b>"+responseData.errorMsg_grid+"</b>";
				}
				if(responseData.errorMsg_search != 'undefined' && responseData.errorMsg_search != null){
					searchMsgDiv.style.display = "block";
					searchMsgDiv.innerHTML = "<b>" + responseData.errorMsg_search + "</b>";
				}
			}
					
			require(["dojo/on", "dojo/topic", "dojo/dom-construct"],
				function(on, topic, domConstruct) {
				    var searchButton = dojo.byId("search");
					on(searchButton, "click",function() {
						searchBookmark();
					});
					
				}
			);		
	
	function searchBookmark() {
		var searchNameString = dojo.trim(dojo.byId("search_name").value); 
		if(searchNameString=="") { 
			alert('<fmt:message key="ui.message.please.enter.part.of.a.bookmark.name.to.search" />');
			return false;
		}

		showAllBookMark();
	}
	
	searchBookmarkFunction = searchBookmark;
			
	function configurePaginationComponent(pageData){
		//Set all Hidden variables
		dojo.byId("startRec").value=pageData.startRec;				
		dojo.byId("pageSize").value=pageData.pageSize;
		dojo.byId("limitRec").value=pageData.limitRec;
		dojo.byId("totalRec").value=pageData.totalRec;
		dojo.byId("listSortOrder").value=pageData.listSortOrder;
		dojo.byId("listSortColumnName").value=pageData.listSortColumnName;
		dojo.byId("lastRecord").value=pageData.lastRecord;		
		var totalBookMarkCount = pageData.totalRec;

		if(totalBookMarkCount!='undefined' && totalBookMarkCount > 0){
			dojo.byId("pagination_div").style.display="block";
			var firstImg = dojo.byId("first");
			var prevImg = dojo.byId("prev");
			if(pageData.startRec==1){
				firstImg.src = '/expensemap/jsp/images/beginning_disabled.gif';
				firstImg.title="<fmt:message key='tooltip.you.are.at.top' />";
				firstImg.onclick=function(){};//donothing

				prevImg.src = '/expensemap/jsp/images/back_disabled.gif';			
				prevImg.title="<fmt:message key='tooltip.you.are.at.top' />"
				prevImg.onclick = function(){};//donothing
			} else {
				firstImg.src = '/expensemap/jsp/images/beginning_enabled.gif';
				firstImg.title="<fmt:message key='tooltip.go.top' />";
				firstImg.onclick=goToFirst;

				prevImg.src = '/expensemap/jsp/images/back_enabled.gif';
				prevImg.title=getToolTip("<fmt:message key='ui.image.tooltip.movePrevious' />",pageData.pageSize);
				prevImg.onclick = goToPrev;
			}

			var nextImg = dojo.byId("next");
			var lastImg = dojo.byId("last");		
			if(pageData.limitRec == pageData.totalRec){
				nextImg.src = '/expensemap/jsp/images/forward_disabled.gif';
				nextImg.title="<fmt:message key='tooltip.you.are.at.bottom' />";
				nextImg.onclick= function(){};//donothing

				lastImg.src = '/expensemap/jsp/images/end_disabled.gif';
				lastImg.title="<fmt:message key='tooltip.you.are.at.bottom'/>";	
				lastImg.onclick = function(){};//donothing
			} else {
				nextImg.src = '/expensemap/jsp/images/forward_enabled.gif';
				var argForToolTip = ((pageData.totalRec-pageData.limitRec)>=pageData.pageSize)? pageData.pageSize : (pageData.totalRec - pageData.limitRec);
				nextImg.title=getToolTip("<fmt:message key='ui.image.tooltip.moveNext' />", argForToolTip);
				nextImg.onclick = goToNext;

				lastImg.src = '/expensemap/jsp/images/end_enabled.gif';
				lastImg.title="<fmt:message key='tooltip.go.bottom' />";
				lastImg.onclick = goToLast;
			}
		} else {
			dojo.byId("pagination_div").style.display="none";
		}
	}

	function getToolTip(msg,arg){			
		msg = msg.replace("{0}",arg);					
		return msg;
	}

	function getPaginationText(msg,startRec, limitRec, totalRec){
		msg = msg.replace("{0}", startRec);			
		msg = msg.replace("{1}" , limitRec);			
		msg = msg.replace("{2}", totalRec);
		return msg;
	}

	function goToFirst(){getMaxRows('getFirst', false);}
	function goToPrev(){getMaxRows('getPrev', false);}
	function goToNext(){getMaxRows('getNext', false);}
	function goToLast(){getMaxRows('getLast', false);}

	function getMaxRows(action,applied){	
		var prevPageSize =dojo.byId("pageSize").value;
		dojo.byId("theAction").value = action;				
		showAllBookMark();
	}	
	
}); // End of dojo.ready.

	function searchKeyPressHandler(event) {
		if (event.keyCode == 13) {
			searchBookmarkFunction();
			(event.preventDefault) ? event.preventDefault() : event.returnValue = false;
			return false;
		}
	}

	function goToDashboardPage(id, name) {
		window.opener.storeSelectedNode(name, id);
		self.close();
	}
	
	function openHelp(){			
		window.open('<%=helpURL%>','help','');	
	}	

</script>

</head>

<body class="claro">
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<div id="containerDiv" class="container" >
	<form:form commandName="bookMarkListForm" id="bookMarkListForm">
		<table class="tableWithBorder">
			 <tr>
				<td><b><fmt:message key="ui.label.existing.bookmarks" /></b></td>
				<td align="left"><b><fmt:message key="ui.label.Dataset" />&nbsp;<fmt:message key="ui.label.Name" />:&nbsp;<%=cubeName.toUpperCase()%></b></td>	
				<td align="right"><a onclick="openHelp();" href="#"><img title="<fmt:message  key='ui.label.Help' />" src="/expensemap/jsp/images/help.gif" border="0"></a></td>
			</tr>
		</table>
		<div id="errorMsg_search" class="errorMsg"></div>
		<div id="searchDiv" class="searchContainer" data-dojo-type="dijit/TitlePane" data-dojo-props="title: '<fmt:message key='ui.label.search' />',duration:1000" >
			<table width="" border="0" cellspacing="2" cellpadding="0" >
			<tr><td>
				<div class="searchComponentContainer">
					<div class="searchComponent" id="searchComponentDiv" onkeypress="searchKeyPressHandler(event)">
						<fmt:message key="ui.label.search.BookmarkName" /> &nbsp;&nbsp;
						<input type="text" name="search.name" id="search_name" data-dojo-type="dijit/form/TextBox" data-dojo-props="trim:true, style:{width:'20em'}"/>
					</div>
				</div>
			</td>
			<td align="left" width="20%">
				<div>
					<button data-dojo-type="dijit/form/Button" id="search" name="search" type="button">
						<fmt:message key="ui.label.search" />
					</button>
				</div>	  
			</td></tr>
			</table>
		</div>
		
		<div  class="errorMsg" id="msg" name="msg"></div>
						
		<div id="errorMsg_grid" class="errorMsg"></div>
		<BR />
		<div id="bookMark_Grid_Div" name="bookMark_Grid_Div" class="objectGridDiv" ></div>
		
		<div id="actionContainerDiv" class="actionContainerDiv">
		
			<div id='pagination_div' class="paginationDiv" style="visibility:hidden" >
				<img id="first"/> 
				<img id="prev"/> 
				<img id="next"/> 
				<img id="last"/> &nbsp;
			</div>
		</div>
		
		<form:hidden id="startRec" path="bookmarkPagination.startRec" />
		<form:hidden id="pageSize" path="bookmarkPagination.pageSize" />
		<form:hidden id="limitRec" path="bookmarkPagination.limitRec" />
		<form:hidden id="totalRec" path="bookmarkPagination.totalRec" />
		<form:hidden id="lastRecord" path="bookmarkPagination.lastRecord" />
		<form:hidden id="listSortOrder" path="bookmarkPagination.listSortOrder" />
		<form:hidden id="listSortColumnName" path="bookmarkPagination.listSortColumnName" />
		<form:hidden id="theAction" path="theAction"/>
		<input type="hidden" name="maxRowsList" id="maxRowsList" />
		<input type ='hidden' name="AuthCode" id="AuthCode" value="<c:out value='${sessionScope.hma_code_allActions}'/>"/>
	</form:form>
</div>
</body>		
</html>