<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page pageEncoding="UTF-8" contentType="text/html; charset=UTF-8"%>
<%@ page language="java"%>
<%@ taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@page import="java.util.List,java.util.Locale, com.emptoris.viewer.util.CSRFHelper"%>
<%@page import="com.emptoris.viewer.util.RenderUtil"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
  <LINK REL="stylesheet" TYPE="text/css" href="/expensemap/jsp/stylesheets/adminTableData.css"/>
	<style TYPE="text/css">
		
.tabledata {
    color: #000000 !important;
    font-family: verdana;
    font-size: 11px;
    padding-left: 5px;
    text-decoration: none;
	} 

	#exportQueryTable {
		border: 1px solid #336699;
		font-family: verdana;
		font-size: 11px;
	}
	
	#exportQueryTable th { height: 20px; }

	</style>
    <title></title>
	<script type="text/javascript">
	function exportQueries(){ 
		if(!validatefstmName()){
			return false;
		}
		if(!validateLayetName()){
			return false;
		}
		var fstmval = document.getElementById("fstm").value; 
		var layerName = document.getElementById("layer").value;
		var url	= "/expensemap/getCognosDataSecurity.xhtm?fstm="+fstmval+"&layer="+layerName+"&dsId=${param.dsId}";
		window.open(url,"_blank");
	 }
	
	function validatefstmName(){
		var fstm = document.getElementById("fstm"); 
		return validateRequired(fstm,"<spring:message code='ui.enter.fstm.table.name' />") ;
	}
	
	function validateLayetName(){
		var layerName = document.getElementById("layer");
		return validateRequired(layerName, "<spring:message code='ui.enter.cognos.namespace.name' />") ;
	}
	
	function validateRequired(field, message){	
		if ( typeof field != "undefined" ) {
			if( isEmpty(field.value.replace(/^\s+/,''))){
				alert(message);
				field.focus();
				return false;		
			}
		}
		return true;
	}
	
	function isEmpty(fieldVal) {
		if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
			return true;
		}
		return false;
	}
	
	function changeTabletoLowercase(){
		var fstm = document.getElementById("fstm").value; 
		
		if(fstm !=null ){
			document.getElementById("fstm").value=fstm.toLowerCase();
		}
	}
	
	function changeTabletoUppercase(){
		var fstm = document.getElementById("fstm").value; 
		
		if(fstm !=null ){
			document.getElementById("fstm").value=fstm.toUpperCase(); 
		}
	}
	function reloadAll(){
		var frm = document.getElementById("mainform");
		frm.method='post';
		frm.action='/expensemap/jsp/admin/admin_menuframe.jsp?returnTo=cubeSelect.jsp';
		frm.submit();
	}
	
	</script>
  </head>
  <body>
  <form  name="exportCognosQry" method="post" id="exportCognosQry" >
	<table id="exportQueryTable" border="0" align="center" width="80%"  cellspacing="1" cellpadding="1" >
		<tr bgcolor="#336699" >
			<th colspan="2" align="center" style="color: #ffffff"><spring:message code="ui.label.Export.Query" /></th>
		</tr>
		<tr>
			<td class="tabledata" bgcolor="#C5C5C5" width="50%" ><spring:message code="ui.label.published.package.database" /></td>
			<td  ><input type="radio" name="targetDB" id="mysqlDb" checked onclick="changeTabletoLowercase();"><spring:message code="ui.label.database.mysql" /></input>
			<input type="radio" name="targetDB" id="oracleDb"   onclick="changeTabletoUppercase();"/><spring:message code="ui.label.database.oracle" /></input>
		</tr>
		<tr>
			<td class="tabledata" bgcolor="#C5C5C5" width="50%"><spring:message code="ui.label.fstm.table.name" />&nbsp;<font  color="red">*</font></td>
			<td  ><input type ="text" size="80"   name="fstm" id="fstm" value="fact_spend_transaction_month"/></td>
		</tr>
		<tr>
			<td class="tabledata" bgcolor="#C5C5C5" width="50%" ><spring:message code="ui.label.cognos.namespace.name" />&nbsp;<font  color="red">*</font></td>
			<td ><input type ="text" size="80" name="layer" id="layer" value="Presentation Layer"/></td>
		</tr>
		<tr>
			<td align="right"><input type="button" value="<spring:message code='ui.tooltip.export' />" onclick="exportQueries();"></td>
			<td align="left" ><input type="button" value="<spring:message code='ui.label.Cancel' />" onclick="reloadAll();"></td>
		</tr>
	</table>
	<%RenderUtil.renderHiddenSecurityToken(pageContext, "CreateEditSF");%>
  <form>
  </body>
</html>


