<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import ="com.zeborg.util.WebUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="java.util.Locale"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view.*, com.emptoris.viewer.util.CSRFHelper" %>
<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	Locale locale = zs.getUser().getLocale();
	//make url for help page    
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = emHelp.getHelpURLString("help.url.alert.search.page",locale);
%>
<html:html>
<head>
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.label.search.alert.names" bundle="dashboard" /></title>

<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css">
<script language="JavaScript">
function submitSearchForm() {
	
	/**
	 * The following code needs some explanation. This page is opened in a pop-up window.
	 * When user clicks on Apply button, we POST the form. However, we want the parent window
	 * to receive the response as we close this window. So we get reference to the parent's Document Object
	 * by using "window.opener.document". In this document we have an empty form called "commonSearchForm".
	 * We clone the form elements (fields) of the source form (the one on the current window), and add them
	 * to the commonSearchForm. Then we submit the commonSearchForm.
	 */
	var targetDocument = window.opener.document;
	var commonSearchFormDiv = window.opener.document.getElementById("commonSearchFormDiv");
	var frm = targetDocument.createElement("form");
	frm.setAttribute("id","commonSearchForm");
	commonSearchFormDiv.appendChild(frm);
	
	var targetForm = targetDocument.getElementById("commonSearchForm");
	
	var localFormElements = document.bookmarkForm.elements;
	for(i=0; i < localFormElements.length; i++){
		if (localFormElements[i].type == 'hidden' || localFormElements[i].type == 'text' ) {
			cloneElement(targetDocument, targetForm, localFormElements[i]);
		}
	}
	targetForm.action = "/expensemap/bookmark/applyAlertSearchOptions.do";
	targetForm.method = "post";
	targetForm.submit();
	window.close();
	
}

function cloneElement(targetDocument, targetForm, sourceElement) {
	var clone = targetDocument.createElement("input");
	clone.setAttribute("name", sourceElement.name);
	clone.setAttribute("type",  "hidden");
	clone.setAttribute("value",  sourceElement.value);
	targetForm.appendChild(clone);
}

function isEmpty(fieldVal) {
	if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
   		return true;
	}
}function openHelp(){
	open( "<%=helpURL%>", "_blank" );	
}
</script>
</head>
<body leftmargin=2 topmargin=2 marginwidth=1 marginheight=1>
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<html:form method="post" styleId="bookmarkForm" action="applyAlertSearchOptions.do" >
<table class="InnerTableWithBorder" align="center" style="background-color: #eeeeee;border: 1px solid light gray;width:94%">
	<tr>
		<td class="reportTitle" align="left"><bean:message key="ui.label.search.alert.names" bundle='dashboard'  /></td>		
		<td class="reportTitle" align=right><A onclick=openHelp(); href="#"><IMG title=<bean:message  key='ui.label.Help' bundle='dashboard'/> src="/expensemap/jsp/images/help.gif" border=0></A></td>	
	</tr>
	<tr><td colspan="2"><hr noshade size="1"></td></tr>
	<tr>
		<td class="labelStyle" align="right"><bean:message key="ui.label.search.AlertName"  bundle="emSrcMessages" /></td>
		<td class="labelStyle" align="left"><html:text property="search.name" size="15" styleId="search.name" styleClass="inputStyle" maxlength="20"/></td>	
	</tr>
	<tr><td colspan="2"><hr noshade size="1"></td></tr> 
	<tr><td colspan="2" align="center">
			<html:button property="submitBtn" onclick="submitSearchForm();"><bean:message key="button.apply"  bundle="dashboard" /></html:button>&nbsp;
			<html:button property="cancel" onclick="window.close();"><bean:message key="ui.label.Cancel"  bundle="dashboard" /></html:button>
		</td>
	</tr>
</table>
<input id="bookmarkPagination.startRec" type="hidden" name="bookmarkPagination.startRec" value='<c:out value="${ bookmarkForm.bookmarkPagination.startRec }" />' />
<input id="bookmarkPagination.pageSize" type="hidden" name="bookmarkPagination.pageSize" value='<c:out value="${ bookmarkForm.bookmarkPagination.pageSize }" />' />
<input id="bookmarkPagination.limitRec" type="hidden" name="bookmarkPagination.limitRec" value='<c:out value="${ bookmarkForm.bookmarkPagination.limitRec }" />' />
<input id="bookmarkPagination.listSortColumnName" type="hidden" name="bookmarkPagination.listSortColumnName" value='<c:out value="${ bookmarkForm.bookmarkPagination.listSortColumnName }" />' />
<input id="bookmarkPagination.listSortOrder" type="hidden" name="bookmarkPagination.listSortOrder" value='<c:out value="${ bookmarkForm.bookmarkPagination.listSortOrder }" />' />
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
<script language="JavaScript">document.getElementById("search.name").focus();</script>

</html:form>
</body>
</html:html>