<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import ="com.zeborg.expensemap.view2.*,com.zeborg.expensemap.view.*"%>
<%@ page import="com.zeborg.util.*"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="java.util.*"%>
<%@ page import="org.owasp.esapi.ESAPI"%>

<%ZSession zs = ZSessionUtil.getFromSession(pageContext); 
Locale locale = zs.getUser().getLocale();	
String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.analytic.search.help.page", locale);
%>
<html:html>
<head>
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="rpt.listing.searchWindow.title" bundle="analytic"  /></title>
<html:javascript formName="analyticsSearchForm" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/fonts/fonts.css" />

<style>
.yui-skin-sam .yui-panel {
position: absolute;
}

.yui-skin-sam .yui-calcontainer{
font-family: Arial, Helvetica, sans-serif;
font: 100%;
	width:160px;
	width:180px !ie;
}
.yui-skin-sam .yui-panel .bd {
	display:block;
	overflow:hidden;	
	width:180px;
	width:200px !ie;
}

.yui-skin-sam .yui-calcontainer .yui-cal-nav{
	margin-left:-6em;
	width:13em;
}

</style>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>	
<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>

<script language="JavaScript">
function submitAnalyticsSearchForm() {
	var frm = document.analyticsSearchForm;
 	if(validateSearchForm()){
 		frm.action = "/expensemap/analytic/applySearchOptions.do";
 		frm.submit();
 	
 	}
}

function validateSearchForm(){
	var isValid=true;
	var msg = "";
	
	if (!isEmpty(msg)) {
		var msgArray = new Array();			
		msgArray = msg.split(";");		
		alert(msgArray[0]);		
	}		
	return isValid;
}

function isEmpty(fieldVal) {
	if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
   		return true;
	}
}
function openHelp(){
	open( "<%=helpURL%>", "_blank" );	
}

function init(){
	document.getElementById("analyticName").focus();	
}

YAHOO.util.Event.onDOMReady(init);

</script>
</head>
<body class="yui-skin-sam" leftmargin=2 topmargin=2 marginwidth=1 marginheight=1>
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<html:form method="post" styleId="analyticsSearchForm" action="applySearchOptions.do" style="margin-top: 19px;">
<!-- error msg for date  -->
<logic:messagesPresent message="true">
<center>
<font color="red" face="Verdana" size="2"><b>
<html:messages id="msg" message="true" bundle="analytic"> 
        <%=pageContext.findAttribute("msg")%>
</html:messages>
</center>
</font>
</logic:messagesPresent>

		<table class="InnerTableWithBorder" align="center" style="width:94%" >
			<tr>
				<td class="reportTitle" align="left"><bean:message key="rpt.listing.searchWindow.title" bundle='analytic'  /></td>
				<td align="right"><a href="#" onclick="openHelp();"><img  src="/expensemap/jsp/images/help.gif" border="0" title="<bean:message  key='ui.label.Help' bundle='analytic'/>"/></a></td>
			</tr>
			<tr><td colspan="2"><hr noshade size="1"></td></tr>
			<tr align="center" >
					<td align="right"><bean:message key="ui.report.table.header.name"  bundle="analytic" /></td>
					<td align="left"><html:text property="analyticName" size="15" styleId="analyticName" styleClass="inputStyle" maxlength="20"/></td>	
			</tr>
					
			<tr>
					<td align="right"><bean:message key="rpt.listing.search.fromDate" bundle="analytic" /></td>
					<td align="left"><html:text property="fromDate" size="15" styleId = "fromDate" styleClass="inputStyle" maxlength="10"/>
					</td>			    
			</tr>
			<tr>
					<td align="right"><bean:message key="rpt.listing.search.toDate"  bundle="analytic" /></td>
					<td align="left"><html:text property="toDate" size="15" styleId = "toDate" styleClass="inputStyle" maxlength="10"/>
					</td> 	    					    
			</tr>
			<tr>
					<td align="right"><bean:message key="ui.label.Created.By"  bundle="analytic" /></td>
					<td align="left"><html:text property="createdBy" size="15" styleId="createdBy" styleClass="inputStyle" maxlength="15" /></td>
			</tr>	
			<TR>
					<TD align="right"><bean:message key="rpt.listing.column.report.type" bundle='analytic'  /></TD>
					<TD>
					<table width="95%" border="0" cellpadding="0" cellspacing="0" >
						<tr>
						<c:forEach var="currentReportTypeVO" items="${ REPORT_TYPE_LIST }" varStatus="ctr" >
									<td align="left"><font size="1">
											<!-- create the checkbox and selected attribute -->
											<html:multibox  property="reportType" >
												<bean:write name="currentReportTypeVO" property="value" filter="false"/>
											</html:multibox>
											<!-- create the label, note that "br" tag will format it vertically -->
											<bean:write name="currentReportTypeVO" property="label" filter="false"/>
										</font>
									</td>
						</c:forEach>
						</tr>
					</table>
					</TD>
			</TR>

		</td>
		</tr> 
		<tr><td colspan="2"><hr noshade size="1"></td></tr> 
		<tr><td colspan="2" align="center">
				<html:button property="submitBtn" onclick="submitAnalyticsSearchForm();"><bean:message key="button.apply"  bundle="analytic" /></html:button>&nbsp;
				<html:button property="cancel" onclick="window.close();"><bean:message key="ui.label.Cancel"  bundle="analytic" /></html:button>
			</td>
		</tr>
	</table>
	
<!--  Added hidden fields WRT PR# 40624 -->
<input type="hidden" name="listSortColumn" id="listSortColumn" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortColumn"))%>">
<input type="hidden" name="listSortOrder"    id="listSortOrder"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortOrder"))%>">
<input type="hidden" name="limitRec"    id="limitRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("limitRec"))%>">
<input type="hidden" name="startRec"    id="startRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("startRec"))%>">
<input type="hidden" name="pageSize"	id="pageSize"	value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("pageSize"))%>">

</html:form>
<script language="JavaScript">

YAHOO.namespace('emptoris.analytics.search.UI');
(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.emptoris.analytics.search.UI = {
		init: function() {
			var self = YAHOO.emptoris.analytics.search.UI;
			var fromDateField = document.getElementById("fromDate");
			var toDateField = document.getElementById("toDate");
			Event.on(fromDateField, "focus", self.openCalendar, [fromDateField, fromDateField]);
			Event.on(toDateField, "focus", self.openCalendar, [toDateField, toDateField]);
		},

		openCalendar: function(e, args) {	
    		YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
		}
	}

	Event.onDOMReady(YAHOO.emptoris.analytics.search.UI.init, YAHOO.emptoris.analytics.search.UI, true);
})();
</script>
</body>
</html:html>