<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.emptoris.analytics.common.util.AnalyticUtility"%>
<%@include file="../includes/tlib.jspf"%>
<%@ page import="java.text.SimpleDateFormat"%>
<%@ page import="java.util.*"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.util.WebUtil,com.zeborg.expensemap.model3.ExpensemapACLUtil"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticRequestContext"%>
<%@ page import="com.zeborg.expensemap.view.TableViewUtil" %>
<%@ page import="com.zeborg.util.EncodeUtil" %>
<%@ page import="java.net.URLEncoder" %>
<%@ page import="com.zeborg.expensemap.analytic.TrendAnalyticCondition,com.zeborg.expensemap.analytic.TopnAnalyticCondition" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>

<%
 if(ExpenseMapAppProperties.isRetainExportExcelCellValue()){
%>
<html xmlns:x="urn:schemas-microsoft-com:office:excel" xmlns="http://www.w3.org/TR/REC-html40" >
<%
}else{
 %>
 <html>
 <%} %>
<head>
<STYLE TYPE="text/css">
<!--
.errordisplay{
	font-family: Arial, Helvetica, sans-serif;
	font-size: 11pt;
	font-style: normal;
	color: Red;
	font-weight : bold;
}
-->
</STYLE>
<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	if (ExpensemapACLUtil.hasExportTo_CSV_OR_ExcelPermission(zs.getUser())){
	response.reset();
	String encoding = WebUtil.getEncoding();
	String charSet = "charset="
			+ ((null == encoding) ? "UTF-8" : encoding);
	WebUtil.addNoCache(response);
	response.setContentType("application/vnd.ms-excel;" + charSet);
	
	String reportName = request.getParameter("reportName");
	// 42718 use underscore instead of problematic characters in filename
	String formattedFilename = URLEncoder.encode(EncodeUtil.specialcharToUnderscore(TableViewUtil.decode(reportName))+ ".xls","UTF-8").replace("+","");
	response.setHeader("Content-Disposition", "attachment; filename="+formattedFilename+ "; filename*=UTF-8''"+formattedFilename);
	response.setContentType("application/vnd.ms-excel;" + "UTF-8");
	TopnAnalyticCondition topnCondition = ((AnalyticRequestContext) request.getAttribute("exportReportContext")).getTopnAnalyticCondition();
		 
%>


<meta http-equiv=Content-Type content="text/html; <%=charSet%>">
<title><bean:message key="ui.label.export.to.excel" bundle="analytic" /></title>

<!--LINK REL="stylesheet" TYPE="text/css" HREF="stylesheets/export.css"-->
<!--<LINK REL="stylesheet" TYPE="text/css" HREF="stylesheets/macromap.css">-->
		
<STYLE TYPE="text/css">
<!--
.rowHeadingStyle{font-family:Arial,Helvetica,sans-serif;font-size:12px;color:#000000;;text-align:left;background-color:#C0C0C0;}
.columnLabels { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #DEE2EA; }
.cellStyle{ font-family: Arial, Helvetica, sans-serif; font-size: 11px; color: #000000;  }
.columnDataStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left; background-color: #DEE2EA; }
-->
</STYLE>
<!--SCRIPT LANGUAGE="javascript" SRC="javascript/export.js"></SCRIPT-->
</head>
<body>
<table>
	<tr class="rowHeadingStyle">
		<td nowrap="nowrap"><b><bean:message key="rpt.cubeName"
			bundle="analytic" /><b>:${ cube }</td>
	</tr>
	<tr class="rowHeadingStyle">
		<td nowrap="nowrap"><b><bean:message key="ui.label.User"
			bundle="analytic" /><b>: ${ exportReportContext.user }</td>
	</tr>
	<tr class="rowHeadingStyle">
		<td nowrap="nowrap"><b><bean:message key="ui.report.table.header.name"
			bundle="analytic" />: <c:out value="${ exportReportContext.reportName }"/></b></td>
	</tr>
</table>
<br>
<table>
	<tr>
	    <td nowrap="nowrap"><b><bean:message key="ui.analyticsReport.criteria"	bundle="analytic" />:</b></td>
	    <td>
				<c:choose>
					<c:when test="${ exportReportContext.topnAnalyticCondition != null}">
						<bean:message key="button.show" bundle= "analytic"/> &nbsp;${ exportReportContext.analyticConditions[0].categoryDisplayName }&nbsp;
						<bean:message key="ui.ruleform.by.label" bundle="analytic" /> &nbsp;<%=TableViewUtil.decode(topnCondition.getSortByDisplayName())%>&nbsp;						
						<c:if test="${ exportReportContext.analyticConditionCount > 1 }">
							<bean:message key="ui.ruleform.whose.label" bundle="analytic" />
						</c:if>
					</c:when>
					<c:otherwise>
					<bean:message key="ui.label.ShowAll" bundle= "analytic"/>&nbsp;${ exportReportContext.analyticConditions[0].categoryDisplayName }&nbsp;
						<bean:message key="ui.ruleform.whose.label" bundle="analytic" />
					</c:otherwise>
				</c:choose>	
	    </td>
    </tr>
	<c:forEach items="${ exportReportContext.analyticConditions }"	var="condition" varStatus="status">
	<c:if test="${!condition.hiddenRule}">
		<tr>
			<td>&nbsp;</td>
			<td>
				<c:if test="${ condition.cumulative == true }">
					<bean:message key="ui.ruleform.cumulative.label" bundle= "analytic"/>&nbsp;
				</c:if>		
				<c:if test="${ ! empty condition.level && condition.level != -1}">
					<bean:message key="ui.label.level" bundle= "analytic"/>&nbsp;${ condition.level -1}&nbsp;
				</c:if>
				<c:if test="${ ! empty condition.level && condition.level == -1}">
					<bean:message key="ui.label.leaf.level.node" bundle="analytic" />&nbsp;
				</c:if>
			    ${ condition.attributeDisplayName }&nbsp;${ condition.operatorDisplayName}&nbsp;${ condition.virtualLowLimit }&nbsp;
				<c:if test="${ ! empty condition.virtualHighLimit }">
					<bean:message key="ui.ruleform.label.and" bundle= "analytic"/>&nbsp;${ condition.virtualHighLimit }
				</c:if>
				<c:if test="${ condition.percentTotalOption.name != 'NONE' }">
					<bean:message key="${ condition.percentTotalOption.resourceKey }" bundle="analytic" />&nbsp;
				</c:if>				
			</td>			
		</tr>
	</c:if>		
	<!-- displaying trend condition -->			
	</c:forEach>
	
	<c:if test="${ exportReportContext.topnAnalyticCondition != null && exportReportContext.topnAnalyticCondition.topNLimitValue !=null }">
	<% String resourceKeyId = "ui.options."+((AnalyticRequestContext)request.getAttribute("exportReportContext")).getTopnAnalyticCondition().getTopNLimitClause().toLowerCase();%>
	<tr><td>&nbsp;</td>
	<td>
		<bean:message key="ui.label.display" bundle="analytic" />&nbsp;
		<bean:message key="<%=resourceKeyId%>" bundle="analytic" />
		&nbsp;<c:out value="${  exportReportContext.topnAnalyticCondition.topNLimitValue }" />
		<c:choose>
			<c:when test="${ exportReportContext.topnAnalyticCondition.reportOnPercentMeasure}">
				&nbsp;<bean:message key="ui.label.percent.of" bundle="analytic" />&nbsp;<%=TableViewUtil.decode(topnCondition.getSortByDisplayName())%>
			</c:when>
			<c:otherwise>
				&nbsp;<bean:message key="ui.label.export.to.excel.rows" bundle="analytic" />
			</c:otherwise>
		</c:choose>
	</td></tr>
</c:if>
	<tr>
	<td>&nbsp;</td>
	  <td>
		<%
		AnalyticRequestContext context = (AnalyticRequestContext)request.getAttribute("exportReportContext");
		TrendAnalyticCondition trendCondition = context.getTrendAnalyticCondition();%>
			<%if(trendCondition != null){ %>
				<bean:message key="ui.ruleform.for.label" bundle="analytic"/> <%=trendCondition.getTimeDimensionDisplayName()%>
				<% if(trendCondition.getTrendType().equalsIgnoreCase("discrete")){ %>
					<bean:message key="ui.operator.Between" bundle="analytic"/> <%=trendCondition.getStartPeriodHierarchyStr()%>&nbsp;<bean:message key="ui.ruleform.label.and" bundle="analytic"/>&nbsp;<%=trendCondition.getEndPeriodHierarchyStr()%>
				<% }else if(trendCondition.getTrendType().equalsIgnoreCase("continuous")){ 
						if(trendCondition.getTimeDimension().equalsIgnoreCase("dimtime")){%>
							<bean:message key="ui.ruleform.for.label" bundle="analytic"/>&nbsp;<bean:message key="<%=AnalyticUtility.getAllTimePeriodDisplayName(trendCondition.getTimePointLevel())%>" bundle="analytic" />
					<% 	}else { 
						Integer level = new Integer(trendCondition.getTimePointLevel());
					%>	
						<bean:message key="ui.ruleform.all.label" bundle="analytic"/>&nbsp;<bean:message key="ui.label.level" bundle="analytic"/>&nbsp;<%=level.intValue()-1%>
					<%	}
					}	//if dim = DIMTIME
				}// end if null%>
		</td>
	</tr>
	<tr>
   		<td align="left"><b><bean:message key="display.filters.AdditionalFilters" bundle= "analytic"/>:</b></td>
   		<td>
   		<c:if test="${ empty exportReportContext.sessionFilters && empty exportReportContext.contextFilters }">
				<b><bean:message key="ui.label.None" bundle= "analytic"/></b>
		</c:if>
		</td>	
   	</tr>
   	
	<c:if test="${ ! empty exportReportContext.sessionFilters }">
	<tr><td>&nbsp;</td></tr>			
	<tr>						
	<td valign="top"><b><bean:message key="display.filters.SessionFilters"  bundle="analytic"/>:</b></td>					
	<td>${ exportReportContext.formattedSessionFilters}</td>
	</tr>	
	</c:if>
	
	<c:if test="${ ! empty exportReportContext.contextFilters }">
		<tr><td>&nbsp;</td></tr>			
		<tr>						
		<td  valign="top"><b><bean:message key="display.filters.ContextFilters"  bundle="analytic"/>:</b></td>					
		<td >${ exportReportContext.formattedContextFilters}</td>
		</tr>	
	</c:if>
	
	
	
</table>

<logic:messagesPresent>
	<tr>
		<td align="left"><font class="errordisplay" color="red" size="3">
		<html:messages id="error" bundle="analytic">
			<bean:write name="error" />
			<br>
		</html:messages> </font></td>
	</tr>
</logic:messagesPresent>
<br>
<br>
<table border="1" cellpadding="0" cellspacing="1" >
	<tr>
		<c:choose>
			<c:when test="${exportReportContext.reportType == 'TREND' ||exportReportContext.reportType == 'DIMENSION'||exportReportContext.reportType == 'TOPN'}">
				<c:set var="beginIndex" value="1"/>
			</c:when>
			<c:otherwise>
				<c:set var="beginIndex" value="0"/>
			</c:otherwise>
		</c:choose>	
		<c:forEach items="${ exportReportContext.columnLabels }" var="column"	varStatus="columnCount" begin="${ beginIndex }">
			<c:if test="${ !exportReportContext.userPreferences[columnCount.count-1].hidden }" >
				<c:choose>
					<c:when test="${ column.percentageOfMeasure == 1 || column.percentageOfMeasure == 2 }">			
						<td class="columnLabels" align="center">${ column.displayName } (%)</td>
					</c:when>
					<c:when test="${ not empty column.currencySymbol }">			
						<td class="columnLabels" align="center">${ column.displayName } (${column.currencySymbol })</td>
					</c:when>
					<c:otherwise>
						<td class="columnLabels" align="center">${ column.displayName }</td>
					</c:otherwise>
				</c:choose>
			</c:if> 
		</c:forEach>
	</tr>
	<c:forEach items="${ exportToExcel.data }" var="row" varStatus="rowNum">
		<tr>
			<c:forEach items="${ row }" var="column" varStatus="colNum" begin="${ beginIndex }">				
				<c:if test="${!exportReportContext.userPreferences[colNum.index].hidden}" >
					<c:choose>
						<c:when test="${ (exportReportContext.reportType == 'TREND' ||exportReportContext.reportType == 'DIMENSION'||exportReportContext.reportType == 'TOPN')  && (colNum.count == 1) }">
							<!-- <td align="${ exportReportContext.columnLabels[colNum.index].type.alignment }" class="cellStyle" >${ column -1}</td> -->
							<c:choose>
								<c:when test="${ exportReportContext.columnLabels[colNum.index].type == 'STRING' || exportReportContext.columnLabels[colNum.index].type == 'DOUBLE' || exportReportContext.columnLabels[colNum.index].type == 'DATE'}">
									<td align="${ exportReportContext.columnLabels[colNum.index].type.alignment }" class="cellStyle" x:str>${ column -1}</td>
								</c:when>
								<c:otherwise>
									<td align="${ exportReportContext.columnLabels[colNum.index].type.alignment }" class="cellStyle">${ column -1}</td>
								</c:otherwise>
							</c:choose>
						</c:when>
						<c:otherwise>	
							<!-- <td align="${ exportReportContext.columnLabels[colNum.index].type.alignment }" class="cellStyle" >${column }</td> -->
							<c:choose>
								<c:when test="${ exportReportContext.columnLabels[colNum.index].type == 'STRING' || exportReportContext.columnLabels[colNum.index].type == 'DOUBLE' || exportReportContext.columnLabels[colNum.index].type == 'DATE'}">
									<td align="${ exportReportContext.columnLabels[colNum.index].type.alignment }" class="cellStyle" x:str><c:out value="${ column }" /></td>
								</c:when>
								<c:otherwise>
									<td align="${ exportReportContext.columnLabels[colNum.index].type.alignment }" class="cellStyle"><c:out value="${ column }" /></td>
								</c:otherwise>
							</c:choose>
						</c:otherwise>
					</c:choose>	
				</c:if> 		
			</c:forEach>
		</tr>
	</c:forEach>
</table>
<%
	 }
else
{
	%>
	<span class="errorDisplay"><bean:message key="ui.errormsg.not.having_permission.to.export.to.excel"  bundle="analytic"/><br>
	<input type="button" value="Close" name="close" onclick="window.close();"/>
	</span>
	<%
}
	%>
</body>
</html>
