<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession,com.zeborg.expensemap.view.HelpUtil, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="java.util.Date,java.text.SimpleDateFormat,org.apache.struts.util.LabelValueBean,com.zeborg.acl.util.LocaleUtil,java.util.List"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties, com.zeborg.expensemap.il8n.EmResourceBundle,
com.zeborg.expensemap.il8n.EmLocalizationManager, com.zeborg.expensemap.view.CubeUtil,com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>

<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	CubeUtil.buildExpMapMastHead(out,"viewFrame_analytic.jsp",zs,true,null,zs.getUser().getLocale(),null);
	EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, zs.getUser().getLocale());
	String title = ExpenseMapAppProperties.getExpensemapTitle();
	title = title + " - " + baseBundle.getValue("ui.analytics.Title");
	String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.view.analytic.report.help.page", zs.getUser().getLocale());	
%>
<html>
<head>
<title><%=title%></title>
<style>
			a, A:link, a:visited, a:active, A:hover
				{color: #330099;}
		</style>
<link rel="stylesheet" type="text/css"
	href="/expensemap/jsp/analytics/scripts/analyticscss.css">
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/export.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />

<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>



<script language="javascript">
		
		
		// export report to xls/csv.
		function exportReport() {
			var isEmpty='${ empty reportVO.data }';
			if(isEmpty=='true')	{
				alert("<bean:message key='errors.noexportdata' bundle ='analytic'/>");
				return false;
			} else {
				if(document.getElementById("fileTypeXls").checked &&
						parseInt('${reportContext.totalRec }')>parseInt('<%=ExpenseMapAppProperties.getMaxRecordsForExcel()%>')){
					alert("<bean:message key='ui.alertmsg.records.exceed.excel.limit' bundle ='analytic'/>");
					return false;
				} else {
					var frm = document.getElementById("reportRenderForm");
					var displayModeCsv = document.getElementById("fileTypeCsv");
    				var displayModeXls = document.getElementById("fileTypeXls");
					var fileName = document.getElementById("fileName");
					var fName = trim(fileName.value);
					var numFormatObject = document.getElementById("exportNumberFormat");
					var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
					//method in commons.js
					if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
						
						var reportId = document.getElementById("reportId").value ;
						frm.numberFormat.value = numFormat;
						frm.reportName.value = fName;
						frm.method="post";
						var url='';
						if ( displayModeCsv.checked == true ) {
							url = "/expensemap/analytic/analyticsExportExcelCSV.do?level="+${ reportContext.level };
						} else if ( displayModeXls.checked == true ) {
							url = "/expensemap/analytic/analyticsExportExcel.do?level="+${ reportContext.level };
						}
						frm.action= url;
						frm.submit();
						closeExportBox();
					}
				}
			}
		}
		
		// Returns the function name and its params as a string for calling export functionality from common export UI in commonExportUI.jsp
		function getParamString(name, id, status) {
			return "javascript:exportReport()";
		}
		
		// Returns header string for export ui called from commonExportUI.jsp. It depends upon module its called for.
		function getHeader() {
			return "<bean:message key='ui.title.exporting.Analyitc'/>";
		}

		// Show/hide divs upon selection of csv/excel type. called from commonExportUI.jsp
		function toggleOptionDiv(fileType) {
		}

		// Initialize the export UI. show/hide divs. It depends upon each module which div to show/hide. called from commonExportUI.jsp
		function initDiv() {
			var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
			var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
			dimensionOptionsDiv.style.visibility = 'hidden';
			dimensionNoOfRowsOptionsDiv.style.visibility = 'hidden';
		}

		// Returns level by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
		function getLevelsBydimId(dimId) {
			return 0;
		}

		//Returns no of rows by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
		function getNoOfRowsBydimId(dimId) {
			return 0;
		}
		var buttonSelected = false;
		
		function selectCheckBox(checkBox, flag) {
			if ( checkBox.disabled == false ) {
				checkBox.checked = flag ;
			}
		}

	function printReport(action){
		var isEmpty='${ empty reportVO.data }';
		if(isEmpty=='true')	{
			alert("<bean:message key='errors.noprintdata'  bundle ='analytic'/>");
			return false;
		} else {	
			var frm = document.getElementById("reportRenderForm");
			frm.method="post";
			frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction="+action+"&pageType=_pf";
			frm.target='_new';
			frm.submit();
			frm.target='_self';
		}
	}
		   
	function getReportList() {
		var frm = document.getElementById("reportRenderForm");
		var order=document.getElementById("listSortOrder").value;
		var columnName=document.getElementById("listSortColumn").value;
		frm.method="post";
		frm.action="/expensemap/showAnalyticPage.xhtm";
		frm.submit();
	}
		      
	function selectAll(){
		alert("<bean:message key='ui.label.Select.All'  bundle='analytic'/>");
	}
	
	function submitFormForSorting(columnId) {
	    var order = document.getElementById("sortOrder").value;
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do" ;
		if(order=='ASC'){
			order='DESC';
		}else if(order=='DESC'){
			order='ASC';
		}
		document.getElementById("sortOrder").value=order;
		document.getElementById("sortColumn").value=columnId;
		frm.submit();

	}
	function paginate(action){
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction="+action;
		frm.submit();
	}
			
	// A JS function to request data for a specific level.
	function getDataForLevel(selectedLevel) {
		var frm = document.getElementById("reportRenderForm");
		document.getElementById("Level").value = selectedLevel.value;
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do";
		frm.submit();
	}
	function openHelp(){
		open( "<%=helpURL%>", "_blank" );
    }
</script>
</head>
<body class="yui-skin-sam">
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="reportRenderForm"/>
</jsp:include>

<form name="reportRenderForm" id="reportRenderForm">
<jsp:include page="/jsp/includes/commonExportUI.jsp"/>
<logic:messagesPresent message="true">
	<br>
	<font color="red" face="Verdana" size="2">
		<html:messages id="msg" message="true" bundle="analytic">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
	</font>
</logic:messagesPresent>
<logic:messagesNotPresent message="true">
	<c:if test="${ empty reportVO.data }" >
		<br>
		<font color="red" face="Verdana" size="2">
			<b><bean:message key="error.com.emptoris.analytics.noDataFound" bundle="analytic" /></b>
		</font>
	</c:if>
	<br>
	<table class="tableWithBorderAna" align="center">
		<tr>
			<td align="left"><b><bean:message key="ui.analytics.Title" bundle= "analytic"/></b></td>
			<td align="center"><b><bean:message key="rpt.cubeName" bundle= "analytic"/>: ${cube}</b></td>			
			<td align="right">
			<c:choose>	
				<c:when  test="${ !empty reportVO.data || !empty reportVO.chartData}">
				<c:if test="${ canExportAnalyticReport == 'true'  }">	
				<a href="#" onclick="JavaScript:openExportBox('<esapi:html><c:out value="${reportContext.reportName}" /></esapi:html>');">
					<img src="/expensemap/jsp/images/excel.gif"
						title="<bean:message key='ui.label.export.to.excel' bundle= "analytic" />"
						border="0"></a>&nbsp;
				</c:if>
				<a href="#" onclick="printReport('getCurrent');">
					<img src="/expensemap/jsp/images/print.gif"
						title="<bean:message key='ui.print.image.tooltip'  bundle= "analytic" />"
						border="0"></a>&nbsp;
				</c:when>
			</c:choose>	
				<a href="#" onclick="openHelp();">
					<img src="/expensemap/jsp/images/help.gif"
						title="<bean:message key='ui.label.Help'  bundle= "analytic"/>"
						border="0"></a>&nbsp;
			</td>
		</tr>
	</table>
	<table class="InnerTableWithBorderAna" align="center">
		<tr>
			<td><b><bean:message key="ui.report.table.header.name"
				bundle="analytic" /> : <c:out value="${ reportContext.reportName }"/> </b></td>
		</tr>		
			
		<tr>
			<td><b><bean:message key="ui.analyticsReport.criteria"	bundle="analytic" />:</b>
				<c:forEach items="${ reportContext.analyticConditions }"	var="condition" varStatus="status">
					<c:if test="${ status.count == 1 }">			
						<bean:message key="ui.label.ShowAll" bundle= "analytic"/>&nbsp;${ condition.categoryDisplayName }
						&nbsp;<bean:message key="ui.ruleform.whose.label" bundle= "analytic"/>				
					</c:if>
					<tr>
					<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;		
					<c:if test="${ condition.category != 'Transactions' }">
								${ condition.categoryDisplayName }&nbsp;
					</c:if>
				   				${ condition.attributeDisplayName }&nbsp;
								${ condition.operatorDisplayName }&nbsp;
								${ condition.virtualLowLimit }&nbsp;
					<c:if test="${ ! empty condition.virtualHighLimit }">
						<bean:message key="ui.ruleform.label.and" bundle= "analytic"/>&nbsp;${ condition.virtualHighLimit }
					</c:if>
					</td>
					</tr>	
				</c:forEach>
			</td>		
		</tr>
		<tr>
			<td align="left" colspan="2"><b> <bean:message key="display.filters.AdditionalFilters" bundle= "analytic"/>:  </b>	
				<c:if test="${ empty reportContext.sessionFilters && empty reportContext.contextFilters }">
					<b><bean:message key="ui.label.None" bundle= "analytic"/></b>
				</c:if>
				<c:if test="${ ! empty reportContext.sessionFilters }">	
					<a title="${ reportContext.formattedSessionFilters }"><b><bean:message key="display.filters.SessionFilters"  bundle="analytic"/></b></a>&nbsp;<img src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;		
				</c:if>		
				<c:if test="${ ! empty reportContext.contextFilters }">	
					<a title="${ reportContext.formattedContextFilters }"><b><bean:message key="display.filters.ContextFilters"  bundle="analytic"/></b></a>&nbsp;<img src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;		
				</c:if>	
			</td>	
		</tr>
	</table>

	<br>
	<table class="tableWithBorderAna" align="center">
	<tr>
		<c:forEach items="${ reportContext.columnLabels }" var="column" varStatus="columnCount" >
			<c:if test="${ !reportContext.userPreferences[columnCount.count-1].hidden }" >
				<td NOWRAP class="thead" align="center">
					<a href="#" onclick="submitFormForSorting('${ columnCount.count }')" >
						<c:choose>
							<c:when test="${ column.type == 'AMOUNT' }">
								<c:if test="${ZSession.virtualCurrencyConversionFactor==0}">
									${ column.displayName }(${ column.currencySymbol })
								</c:if>
								<c:if test="${ZSession.virtualCurrencyConversionFactor!=0}">
									${ column.displayName }(${ ZSession.virtualCurrencySymbol })
								</c:if>
							</c:when>
							<c:otherwise>
								${ column.displayName }					
							</c:otherwise>
						</c:choose>
						<c:if test="${ columnCount.count == reportContext.sortColumn }">
							<c:choose>
								<c:when test="${ 'ASC' == reportContext.sortOrder }">
									<img src="/expensemap/jsp/images/up.gif" border="0">
								</c:when>
								<c:otherwise>
									<img src="/expensemap/jsp/images/down.gif" border="0">
								</c:otherwise>
							</c:choose>			
	              		</c:if>            
					</a>
				</td>	               
			</c:if>  
		</c:forEach>
	</tr>

	<c:forEach items="${ reportVO.data }" var="row" varStatus="rowNum">
	 
		<c:choose>
			<c:when test="${ rowNum.count % 2 == 0 }">
				<c:set var="className" value="trEven" />
			</c:when>
			<c:otherwise>
				<c:set var="className" value="trOdd" />
			</c:otherwise>
		</c:choose>
		<tr class="${ className }" >
		<c:forEach items="${ row }" var="column" varStatus="colNum" >
		 <c:if test="${ !reportContext.userPreferences[colNum.index].hidden }" >
			<td align="${ reportContext.columnLabels[colNum.index].type.alignment }"><c:out value="${ column }" /></td>
		  </c:if> 	
		</c:forEach>
		</tr>
	  
	</c:forEach>

	</table>
	<c:if test="${ ! empty reportVO.data }" >
		<br>
		<table width="98%" align="center" >
			<tr align="center">			
				<td colspan="3">
					<jsp:include flush="true" page="pagination.jsp">
						<jsp:param name="isDataPresent"	value="${ ! empty reportVO.data }" />
						<jsp:param name="pageSize" value="${reportContext.pageSize }" />
						<jsp:param name="totalRec" value="${reportContext.totalRec }" />
						<jsp:param name="startRec" value="${reportContext.startRec }" />
						<jsp:param name="limitRec" value="${reportContext.limitRec }" />
						<jsp:param name="maxRecordPerPage" value="${reportContext.pageSize }" />
					</jsp:include>
				</td>
			</tr>
		</table>
	</c:if>
</logic:messagesNotPresent>
<br>
<table width="98%" align="center" >
	<tr align="center">
		<td align="center">
			<html:button property="backButton" onclick="getReportList();">
					<bean:message key="button.back" bundle="analytic" />
			</html:button>
		</td>
	</tr>
</table>

<input type="hidden" name="sortOrder" id="sortOrder" value="${ reportContext.sortOrder }" />
<input type="hidden" name="sortColumn" id="sortColumn"	value="${ reportContext.sortColumn }" />
<input type="hidden" name="reportId" id="reportId" value="${ reportContext.reportId }" />
<input type="hidden" name="eriId" id="eriId" value="${ reportContext.eriId }" />
<input type="hidden" name="reportType" id="reportType" value="${ reportContext.reportType }" />
<input type="hidden" name="listSortColumn" id="listSortColumn" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortColumn"))%>">
<input type="hidden" name="listSortOrder"    id="listSortOrder"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortOrder"))%>">
<input type="hidden" name="listLimitRec"    id="listLimitRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listLimitRec"))%>">
<input type="hidden" name="listStartRec"    id="listStartRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listStartRec"))%>">
<input type="hidden" name="numberFormat" value="" />
<input type="hidden" name="reportName" id="reportName"  value='<c:out value="${ reportContext.reportName }" />' />
<c:if test="${ ! empty reportContext.baseDimensionLevels }">
	<input type="hidden" name="Level" id="Level" value="${ reportContext.level }" />
</c:if>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</form>
</body>
</html>
