<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager,com.zeborg.expensemap.util.HelpLocaleUtil,java.util.*,
com.zeborg.expensemap.util.ExpenseMapAppProperties,com.zeborg.util.WebUtil"
%>
<%@ page import="com.zeborg.expensemap.view2.ZSession, com.emptoris.viewer.util.CSRFHelper" %>
<%@ page import="com.zeborg.expensemap.view.CubeUtil,com.zeborg.expensemap.view.HelpUtil" %>
<%@ page import="org.owasp.esapi.ESAPI"%>

<%
ZSession zs = com.zeborg.expensemap.view.ZSessionUtil.getFromSession(pageContext);
Locale locale = zs.getUser().getLocale();	
EmResourceBundle bundle=EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE, locale);
String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.creating.topNAnalytic.help.page", locale);
String title = ExpenseMapAppProperties.getExpensemapTitle()+ " - "+ bundle.getValue("ui.title.create.new.analytic.report");
CubeUtil.buildExpMapMastHead(out,"viewFrame_analytic.jsp",zs,true,null,locale,null);
%>
<html:html>
<head>
<title><%=title%></title>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css" />
<style>
.yui-skin-sam .yui-panel {
position: absolute;
}

.yui-skin-sam .yui-calcontainer{
font-family: Arial, Helvetica, sans-serif;
font: 100%;
	width:160px;
	width:180px !ie;
}
.yui-skin-sam .yui-panel .bd {
	display:block;
	overflow:hidden;	
	width:180px;
	width:200px !ie;
}

.hEffect {
	cursor:hand;
	color:#0000FF;
	font-size: 11px;
	text-decoration : NONE;
	FONT-FAMILY: Arial;
}

.hEffect:hover {
	color:red;
}
</STYLE>

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>	
<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>
<SCRIPT language="JavaScript" src="/expensemap/jsp/js/util/htmlDecodeUtil.js" type="text/javascript"></SCRIPT>

<script language="JavaScript">
var topReportSelected = false;
window.select_current = new Array(); 

function addPleaseSelectOption(selectObject){
	selectObject.options[0] = new Option("<bean:message key='ui.options.please.select' bundle='analytic' />","");
}

//submit the ajax request
function submitRequest(operation, selectTag){
	if (selectTag.options[selectTag.selectedIndex].disabled) { 
	       selectTag.selectedIndex = window.select_current[selectTag.id]; 
	}
	else {
		window.select_current[selectTag.id] = selectTag.selectedIndex;
	if(operation == 'getSortByList'){
			resetOnChange();
			if(selectTag.value==''){
				var sortBy= document.getElementById("sortBy");
				addPleaseSelectOption(sortBy);}
			}
		}
	if(selectTag.value!='' && selectTag.value!='--'){
			submitAjaxRequest(operation,selectTag.name,selectTag.value);	
	}
}

function resetOnChange(){
		//disable sort by 
		var sortBy= document.getElementById("sortBy");
		for(  i=sortBy.options.length; i >=0 ;i--){
			sortBy.remove(i);
		}
		//hide level drop down
		var levelList=document.getElementById("selectedLevel");
		for(  i=levelList.options.length; i >=0 ;i--){
				levelList.remove(i);
		}
		sortBy.disabled=true;
		document.getElementById("selectedLevelTD").style.display="none";
		resetAdditionalCondition();
		var selectAdditionalFilter = document.getElementById("selectAdditionalFilter");
		selectAdditionalFilter.checked=false;
		selectAdditionalFilter.disabled = true;
}

function resetAdditionalCondition(){
	//clean additional portion
	//clear whose list
	var whoseList = document.getElementById("currentCondition.attribute");
		for( i=whoseList.options.length; i >0 ;i--){
			whoseList.remove(i);
		}
	//clear level
	var levelList = document.getElementById("currentCondition.level");
		if(!levelList.disabled){
			for( i=levelList.options.length; i >0 ;i--){
				levelList.remove(i);
			}
		}
	//clear operator list
	var operatorList = document.getElementById("currentCondition.operator");
		for( i=operatorList.options.length; i >0 ;i--){
			operatorList.remove(i);
		}
		document.getElementById("currentCondition.lowLimit").value='';
		document.getElementById("currentCondition.highLimit").value='';
	
		//disable additional condition related options
		additionalFilterTable.disabled=true;
		document.getElementById("currentCondition.attribute").disabled=true;
		document.getElementById("currentCondition.level").disabled=true;
		document.getElementById("currentCondition.operator").disabled=true;
		document.getElementById("currentCondition.lowLimit").disabled=true;
		document.getElementById("currentCondition.highLimit").disabled=true;
}

function submitAjaxRequest(operation,parmName,parmValue){	
	try {	
		var argStr = "operation=" + operation + "&" + parmName + "=" + parmValue;		
		var url = "/expensemap/analytic/topnAnalyticActionForAjaxRequest.do?" + argStr;
		jQuery.ajax({
			url: url,
			type: "GET",
			success: responseHandler,
			error: function(xhr, status, error) {
				alert("<bean:message bundle='emMessages' key='ui.message.There.was.a.problem.retrieving.data.from.server'/> " + xhr.statusText);
			}
		});
	} catch(e) {
		 alert(e);
	}	
		
}
//handle the ajax response
  
function responseHandler(response) {         
	var data = eval(response);	
	// If there is no data in the response, ignore this
	if (data == null) {
	   return;
	}
	if (data[0] == "Error") {
		var errorCode = data[1];
		if(errorCode == "session.timeout")
		{
		   var timeoutURL = data[3];
		   parent.location.href=timeoutURL;
		   return;
		}else{
			//alert the error
			alert(data[2]);
			return;
			
		}
	}else if(data[0]=="getSortByList"){	
		var sortBy = document.getElementById("sortBy");
		addPleaseSelectOption(sortBy);
		for(i=1 ; i<data.length ; i=i+3){		
			var opt = new Option(getHtmlDecodedValue(data[i]), data[i+1]);
			if(data[i+2]=="true"){
				opt.disabled=true;	
				opt.style.color = "graytext"; 
			}
			sortBy.options[sortBy.options.length] = opt;
			}
		if(sortBy.options.length > 1){
			sortBy.options[0].selected=true;
			sortBy.disabled =false;
		}
		var canAddMoreConditions = ${createTopnRuleForm.canAddMoreConditions};
		var reportOnPercentMeasure = document.all("reportOnPercentMeasure");
		if(canAddMoreConditions && reportOnPercentMeasure[1].checked){
			document.getElementById("selectAdditionalFilter").disabled=false;
		}			
		
	}else if( data[0]=="getDimLevelList") {	
		var level = document.getElementById("selectedLevel");
		var reportOnPercentMeasure = document.all("reportOnPercentMeasure");
		totalNoOfOperatorOption = data[1];
		totalNoOfLavelOption = data[2];
		maxIndex = parseInt(totalNoOfOperatorOption)*2+3
		if(parseInt(totalNoOfLavelOption)>0){
			for( i=level.options.length; i >0 ;i--){
				level.remove(i);
			}
			addPleaseSelectOption(level);
			for(i=maxIndex ; i<data.length-4 ; i=i+2){
				level.options[level.options.length] = new Option(data[i], data[i+1]);
			}
			if(level.options.length > 0){
				level.options[0].selected=true;
				level.disabled =false;
			}
			//select report type
			document.getElementById("selectedLevelTD").style.display="block";
			reportOnPercentMeasure[1].checked = true;
			reportOnPercentMeasure[0].disabled=true;
			var selectAdditionalFilter = document.getElementById("selectAdditionalFilter");
			selectAdditionalFilter.disabled = false;
		}else{
			if(${!empty createTopnRuleForm.savedConditions}){
				reportOnPercentMeasure[0].disabled=true;
			}
			else{
			  reportOnPercentMeasure[0].disabled=false;
			}
			
			if (level.options.length > 0) {
				level.options[0].selected=true;
			}
			level.disabled =true;
			document.getElementById("selectedLevelTD").style.display="none";
			
		}	
		
	}else if( data[0]=="getAttribute") {			
		var attribute = document.getElementById("currentCondition.attribute");
		for( i=attribute.options.length; i >0 ;i--){
			attribute.remove(i);
		}
		attribute.options[0]=null;
		addPleaseSelectOption(attribute);
		for(i=1 ; i<data.length ; i=i+3){		
			var opt = new Option(getHtmlDecodedValue(data[i]), data[i+1]);
			if(data[i+2]=="true"){
				opt.disabled=true;	
				opt.style.color = "graytext"; 
			}
			attribute.options[attribute.options.length] = opt;
		}
		if(attribute.options.length > 0){
			attribute.options[0].selected=true;
			attribute.disabled =false;
		}
	} else if( data[0]=="processAttribute") {						
		var operator = document.getElementById("currentCondition.operator");
		var level = document.getElementById("currentCondition.level");
		var lowLimit = document.getElementById("currentCondition.lowLimit");
		var highLimit = document.getElementById("currentCondition.highLimit");			
		totalNoOfOperatorOption = data[1];
		totalNoOfLavelOption = data[2];			
		for( i=operator.options.length; i >0 ;i--){
			operator.remove(i);
		}
		maxIndex = parseInt(totalNoOfOperatorOption)*2+3
		addPleaseSelectOption(operator);
		for(i=3 ; i< maxIndex; i=i+2){				
			operator.options[operator.options.length] = new Option(data[i], data[i+1]);
		}
		if(operator.options.length > 0){
			operator.options[0].selected=true;
			operator.disabled =false;
			lowLimit.disabled =false;
		}
		if(parseInt(totalNoOfLavelOption)>0){
			for( i=level.options.length; i >0 ;i--){
				level.remove(i);
			}
			addPleaseSelectOption(level);
			for(i=maxIndex ; i<data.length-4 ; i=i+2){
				level.options[level.options.length] = new Option(data[i], data[i+1]);
			}
			if(level.options.length > 0){
				level.options[0].selected=true;
				level.disabled =false;
			}
		}else{
			level.options[0].selected=true;
			level.disabled =true;
		}	
		//Check and set attribute type
		var attributeType = data[data.length-2];			
		document.getElementById("selectedAttributeType").value=attributeType;
		//Check and set attribute type
		var conditionType = data[data.length-1];
		document.getElementById("currentConditionType").value = conditionType;
		var fromDateField = document.getElementById("currentCondition.lowLimit");
		var toDateField = document.getElementById("currentCondition.highLimit");

		if(attributeType=='DATE'){
			YAHOO.util.Event.on(fromDateField, "focus", showCalendar, [fromDateField, fromDateField]);
			YAHOO.util.Event.on(toDateField, "focus", showCalendar, [toDateField, toDateField]);
		}else{
			YAHOO.util.Event.removeListener ( fromDateField, "focus" , showCalendar );
			YAHOO.util.Event.removeListener ( toDateField, "focus" , showCalendar );
			YAHOO.util.Event.removeListener ( fromDateField, "focus" , self.openCalendar );
			YAHOO.util.Event.removeListener ( toDateField, "focus" , self.openCalendar );
		}	
			
		//Check for percent option
		isPercentEnabled = data[data.length-3];			
		if(isPercentEnabled=="true"){
			if(document.getElementById("includeContextFiltersCheckBox")!=null){
				includeContextFiltersSelected(document.getElementById("includeContextFiltersCheckBox"));
			}
		}else{
			if(document.getElementById("includeContextFiltersCheckBox")!=null){
				includeContextFiltersSelected(document.getElementById("includeContextFiltersCheckBox"));
			}
		}
		init(conditionType);
		//Reset Limit			
		lowLimit.value="";
		highLimit.value="";
		enableLimitTextFields(operator.options[operator.selectedIndex]);
	}
	document.getElementById("operation").value=data[0];		
}

function setPrevSelectValue(obj){
	 window.select_current[obj.id] = obj.selectedIndex;
}

function enableTopReportCategories(isTopReport) {
	topReportSelected=isTopReport;
	if( isTopReport ) {
		document.getElementById("topReportCategory").disabled = false;
	} else {
		document.getElementById("topReportCategory").disabled = true;
	}
}

function selectDimension(selectedDimension) {
	var frm = document.getElementById('createTopnRuleForm');
	if ( selectedDimension.value != '' ) {
		frm.action = "/expensemap/analytic/ProcessDimensionSelectAction.do";
		frm.submit();
	} else {
		alert("<bean:message key='ui.alertmsg.trend.category.select' bundle='analytic'/>");
		frm.submit();
	}
}

function selectAttribute(selectedAttribute) {	
	if (selectedAttribute.options[selectedAttribute.selectedIndex].disabled) { 
		selectedAttribute.selectedIndex = window.select_current[selectedAttribute.id]; 
	    }else{
	    	window.select_current[selectedAttribute.id] = selectedAttribute.selectedIndex;
	    	if ( selectedAttribute.value == '' || selectedAttribute.value == '--' ) {
	    		alert("<bean:message key='ui.alertmsg.attribute.select' bundle='analytic'/>");
	    	} else {
	    		var frm = document.getElementById('createTopnRuleForm');
	    		frm.action = "/expensemap/analytic/ProcessAttributeSelectAction.do";
	    		frm.submit();
	    	}
	    }	
}

function addNewCondition() {
	var frm = document.getElementById('createTopnRuleForm');
	document.getElementById("operation").value="addCondition";
	if ( validateNewCondition() ) {
		frm.action = "/expensemap/analytic/topnAnalyticAction.do";
		frm.submit();
	}
}

function deleteCondition() {
	var frm = document.getElementById('createTopnRuleForm');
	document.getElementById("operation").value="removeCondition";
	frm.action = "/expensemap/analytic/topnAnalyticAction.do";
	frm.submit();
}

function cancelAnalyticForm() {	
	var frm = document.getElementById('createTopnRuleForm');
	frm.action = "/expensemap/showAnalyticPage.xhtm";
	frm.submit();
}

function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

function saveTemplate(createNew) {
	//////
	var frm = document.getElementById('createTopnRuleForm');
 	var returnValue = validateNewRuleForm();
 	
 	//Assign "null" to "SortColumn" and "SortOrder", to get the default sort column 
	//and sort order after report submitted.
	document.getElementById("listSortColumn").value = "null";
	document.getElementById("listSortOrder").value = "null";
	document.getElementById("operation").value="saveTemplate";
	
 	if (returnValue ) {
 		if(topReportSelected)
		{
			alert("<bean:message key='ui.alertmsg.Top.Reports.option.is.not.applicable.for.Templates' bundle='analytic'/>");
			return false;
		}
 		document.getElementById("createNew").value = createNew;
 		frm.method = "post";
 		frm.action = "/expensemap/analytic/topnAnalyticAction.do";
 		frm.submit();
 	}
}

/**
 * process operator selection.
 * @param operator - operator selected
 */
function processOperator(operator) {	
	enableLimitTextFields(operator);
}

/**
 * Enables high limit text box when Between is selected.
 * @param operator - operator selected
 */
function enableLimitTextFields(operator) {	
	if ( operator.value == 'Between' ) {
		document.getElementById("highLimitTD").style.visibility = 'visible';
		document.getElementById("currentCondition.highLimit").disabled = false;
	} else {
		document.getElementById("highLimitTD").style.visibility = 'hidden';
		document.getElementById("currentCondition.highLimit").disabled = true;
	}
}

function validateNewCondition() {
	var isValid=true;
	var msg='';
	var attrValue=trim(document.getElementById("currentCondition.attribute").value) ; 
	var catValue= trim(document.getElementById("currentCondition.category").value) ;
	var opValue=trim(document.getElementById("currentCondition.operator").value);
	var lowLimit=document.getElementById("currentCondition.lowLimit");
	var highLimit=document.getElementById("currentCondition.highLimit");
	var loLimitValue=trim(lowLimit.value);
	var highLimitValue=trim(highLimit.value);
	//set low limit and high limit after removing spaces
	lowLimit.value=loLimitValue;
	highLimit.value=highLimitValue;
	// Tells us datatype for attribute currently selected.
	// Empty if no attribute is selected so far.
	var attributeType = document.getElementById("selectedAttributeType").value;
	
	if( opValue != "Between" ) {
		highLimitValue="N.A";
	}
	
    if( isEmpty(catValue) ) {
    	msg=msg+"<bean:message key='ui.alertmsg.trend.category.select' bundle='analytic'/>"+ ";" ;    
    	isValid=false;
    }
		
    if (isEmpty(attrValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.attribute.select' bundle='analytic'/>"+ ";" ;    
		isValid=false;
    }
    
    if ( ! (document.getElementById("currentCondition.level").disabled) ) { 
	    var lvlValue = trim(document.getElementById("currentCondition.level").value); 
	    if (isEmpty(lvlValue)) {
			msg=msg+"<bean:message key='ui.alertmsg.level.select' bundle='analytic'/>"+ ";";    
			isValid=false;
        }
    }  
    
    if ( isEmpty(opValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.Opertator.select' bundle='analytic'/>"+ ";" ;    
		isValid=false;
	}

   	if (isEmpty(loLimitValue)) {
		msg=msg+"<bean:message key='ui.alertmsg.lowLimit.select' bundle='analytic'/>"+ ";" ;    
		isValid=false;
	}
                 
   	if ( ! (document.getElementById("currentCondition.highLimit").disabled) ) { 
		if ( isEmpty(highLimitValue) ) {
			msg=msg+"<bean:message key='ui.alertmsg.lowLimit.select' bundle='analytic'/>"+ ";" ;    
			isValid=false;
       	}  
   	} 
	
	if(!validateMaxLen()){
    	msg = msg + "<bean:message key='ui.desc.maxLength.alertmsg' bundle='analytic'/>"+ ";" ;
    	isValid=false;
    }
	if (!isEmpty(trim(msg))) {
		var msgArray = new Array();			
		msgArray = msg.split(";");		
		alert(msgArray[0]);
		
	}

	return isValid;
}

// A common resuable JS function to test empty fields.
function isEmpty(fieldVal) {
	if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
   		return true;
	}
}

function validateNewRuleForm(){
	var isValid=true;
	var name = document.getElementById("reportName");
	var topNLimit= document.getElementById("topNLimitValue");
	var category= document.getElementById("currentCondition.category");
	var sortBy= document.getElementById("sortBy");
	var selectedLevel= document.getElementById("selectedLevel");
	
	var nameValue = trim(name.value);
	var topNLimitValue= trim(topNLimit.value);
	var categoryValue= trim(category.value);
	var sortByValue= trim(sortBy.value);
	var selectedLevelValue= trim(selectedLevel.value);
	topNLimit.value=topNLimitValue;
	if(isEmpty(nameValue)){
		alert("<bean:message key='ui.validate.required.reportName.msg' bundle='analytic'/>") ;   
		name.focus();
		return false;
    }
    if(!validateMaxLen()){
    	alert("<bean:message key='ui.desc.maxLength.alertmsg' bundle='analytic'/>");
    	document.getElementById("desc").focus();
    	return false;
    }    
    if(topNLimitValue==0 ||topNLimitValue ><%=Integer.MAX_VALUE%>||isEmpty(topNLimitValue) || isNaN(topNLimitValue) || !(topNLimitValue.indexOf("+")==-1 && topNLimitValue.indexOf("-")==-1)||(topNLimitValue.indexOf(".")>-1 && document.all("reportOnPercentMeasure")[1].checked)){
		alert("<bean:message key='ui.topn.limit.alertmsg' bundle='analytic'/>");
		topNLimit.focus();
		return false;
    }
    if(isEmpty(categoryValue)){
		alert("<bean:message key='ui.alertmsg.trend.category.select' bundle='analytic'/>");
		category.focus();
		return false;
    }
    if(isEmpty(sortByValue) ){
		alert("<bean:message key='ui.topn.select.sortBy.alertmsg' bundle='analytic'/>");
		sortBy.focus();
		return false;
    }
    if(selectedLevel.disabled==false && isEmpty(selectedLevelValue) ){
		alert("<bean:message key='ui.alertmsg.level.select' bundle='analytic'/>");
		selectedLevel.focus();
		return false;
    }   
	return true;
}

function submitAnalyticForm() {
 	var frm = document.getElementById('createTopnRuleForm');
 	var returnValue = validateNewRuleForm();
	
	//Assign "null" to "SortColumn" and "SortOrder", to get the default sort column 
	//and sort order after report submitted.
 	document.getElementById("listSortColumn").value = "null";
	document.getElementById("listSortOrder").value = "null";
	document.getElementById("operation").value="submitReport";
 	// set the cumulative & 
 	if(returnValue ){
 		frm.action = "/expensemap/analytic/topnAnalyticAction.do";
 		frm.submit();
 	}
}

/*
 * Sets the value for include context filter hidden field.
 * @param - includeContextFiltersCheckBox - the check box control
 */
function includeContextFiltersSelected(includeContextFiltersCheckBox) {	
	document.getElementById("includeContextFilters").value = includeContextFiltersCheckBox.checked;	
}

/*
 * Sets the value for include session filter hidden field.
 * @param - includeSessionFiltersCheckBox - the check box control
 */
function includeSessionFiltersSelected(includeSessionFiltersCheckBox) {
	document.getElementById("includeSessionFilters").value = includeSessionFiltersCheckBox.checked;
}

function init(conditionType) {
	// set the "include context filter check-box" if present
	if ( document.getElementById("includeContextFilters") ) {
		if ( document.getElementById("includeContextFilters").value == 'true' ) {
			document.getElementById("includeContextFiltersCheckBox").checked = true;
		} else {
			document.getElementById("includeContextFiltersCheckBox").checked = false;			
		}
	}

	if ( document.getElementById("includeSessionFilters") ) {
		if ( document.getElementById("includeSessionFilters").value == 'true' ) {
			document.getElementById("includeSessionFiltersCheckBox").checked = true;
		} else {
			document.getElementById("includeSessionFiltersCheckBox").checked = false;
		}
	}	
	var isTopReport = ${ createTopnRuleForm.topReport};
	if(isTopReport){
		topReportSelected =true;
	}
	document.getElementById('reportName').focus();
}


function validateMaxLen(){
	var maxlen = document.getElementById("desc").value.length;				
	if(maxlen>255){
		return false;
	}
	else{
		return true;
	}
}
function openHelp(){
	open( "<%=helpURL%>", "_blank" );	
}
/** enable additional filter check box */
function enableAdditionalFilter(){
	var selectAdditionalFilter = document.getElementById("selectAdditionalFilter");
	var additionalFilterTable = document.getElementById("additionalFilterTable");			
	if(selectAdditionalFilter.checked){		
		var category = document.getElementById("currentCondition.category");
		document.getElementById("add").disabled=false;		
		if(isEmpty(category)){
			alert("<bean:message key='ui.alertmsg.trend.category.select' bundle='analytic'/>");
			selectAdditionalFilter.checked = false;
			category.focus();
		}else{
			additionalFilterTable.disabled=false;
			submitAjaxRequest("getAttribute", "currentCondition.category",category.value);
		}
	}else{
		additionalFilterTable.disabled=true;	
		submitAjaxRequest("selectAdditionalFilterOf","","");
		document.getElementById("currentCondition.attribute").disabled=true;
		document.getElementById("currentCondition.level").disabled=true;
		document.getElementById("currentCondition.operator").disabled=true;
		document.getElementById("currentCondition.lowLimit").disabled=true;
		document.getElementById("currentCondition.highLimit").disabled=true;
		document.getElementById("add").disabled=true;
	}
}
function enableDisableAdditionalCondition(isSelectAdditionalFilter,canAddMoreConditions,isLevelListNotEmpty,isSavedConditionsAvailable,isReportOnPercentMeasure){		
	var selectAdditionalFilter = document.getElementById("selectAdditionalFilter");
	var additionalFilterTable = document.getElementById("additionalFilterTable");		
	if(isSelectAdditionalFilter && canAddMoreConditions && !isReportOnPercentMeasure){
			additionalFilterTable.disabled = false;
			selectAdditionalFilter.checked = true;	
			if(${createTopnRuleForm.operation == 'editTemplate'}==true){
				document.getElementById("currentCondition.lowLimit").disabled=true;
			}
	}else{
		document.getElementById("currentCondition.attribute").disabled=true;
		document.getElementById("currentCondition.level").disabled=true;
		document.getElementById("currentCondition.operator").disabled=true;
		document.getElementById("currentCondition.lowLimit").disabled=true;
		document.getElementById("currentCondition.highLimit").disabled=true;
		selectAdditionalFilter.checked = false;
		var category = document.getElementById("currentCondition.category");
		if(isReportOnPercentMeasure){
			selectAdditionalFilter.disabled=true;
		}else if(document.getElementById("operation").value=="editTemplate" && canAddMoreConditions){
			selectAdditionalFilter.disabled=false;
		}else if(document.getElementById("operation").value=="removeCondition"){
			selectAdditionalFilter.disabled=false;
		}
		else {
			selectAdditionalFilter.disabled=true;
		}
		
	}
	var reportOnPercentMeasure = document.all("reportOnPercentMeasure");
	if(isLevelListNotEmpty){
		document.getElementById("selectedLevelTD").style.display="block";
	}else{
		document.getElementById("selectedLevelTD").style.display="none";
	}
	if(isSavedConditionsAvailable||isLevelListNotEmpty){
	 reportOnPercentMeasure[0].disabled=true;
	}
}
/** Enable disable additional filter section */
function disableAdditionalConditionSection(){
	var additionalFilterTable = document.getElementById("additionalFilterTable");	
	document.getElementById("currentCondition.attribute").disabled=true;
	document.getElementById("currentCondition.level").disabled=true;
	document.getElementById("currentCondition.operator").disabled=true;
	document.getElementById("currentCondition.lowLimit").disabled=true;
	document.getElementById("currentCondition.highLimit").disabled=true;
	additionalFilterTable.disabled=true;
}
/**
*/
function enableDisableAddAdditionalFilter(flag){
	var selectAdditionalFilter = document.getElementById("selectAdditionalFilter");	
	if(flag){
		//Uncheck additional condition check box and disable it
		selectAdditionalFilter.checked=false;
		selectAdditionalFilter.disabled = true;
		//reset values populated for additional filter
		resetAdditionalCondition();
	}else{
	//enable additional portion
		if(document.getElementById("currentCondition.category").value != ''){
			selectAdditionalFilter.disabled = false;				
		}
	}
}
/**
* Retrive sort by list. and change
*/
function changeCategory(obj){
	submitRequest('getSortByList', obj);
}
</script>
</head>
<body class="yui-skin-sam" onload="init('${ createTopnRuleForm.currentCondition.type }');" >
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="createTopnRuleForm"/>
</jsp:include>

<logic:messagesPresent message="true">
	<br>
	<font color="red" face="Verdana" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="analytic">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
</logic:messagesPresent>

<br>
<html:form method="post" action="/topnAnalyticAction.do?operation=''" styleId="createTopnRuleForm" onsubmit="return validatecreateTopnRuleForm(this);" >
<center>
<!-- show filters applied -->

	<table class="testTable" width="98%">
		<tr>
			<td align="left" colspan="1"><b> <bean:message key="display.filters.CurrentFilters" bundle= "analytic"/>:  </b>	
				<c:if test="${ empty SESSION_FILTERS && empty CONTEXT_FILTERS }">
					<b><bean:message key="ui.label.None" bundle= "analytic"/></b>
				</c:if>	
				<c:if test="${ ! empty SESSION_FILTERS }">	
					<input type="checkbox" id="includeSessionFiltersCheckBox" onclick="includeSessionFiltersSelected(this);" />
					<a class="hEffect" href="javascript:void();" onclick="return false" title="${ SESSION_FILTERS }">
					<bean:message key='ui.ruleform.include.session.filters.label' bundle="analytic"/></a>
					<html:hidden property="includeSessionFilters" styleId="includeSessionFilters" />
				</c:if>		
				<c:if test="${ ! empty SESSION_FILTERS && ! empty CONTEXT_FILTERS }">
					<b>|</b>
				</c:if>
				<c:if test="${ ! empty CONTEXT_FILTERS }">	
					<input type="checkbox" id="includeContextFiltersCheckBox" onclick="includeContextFiltersSelected(this);" />
					<a class="hEffect" href="javascript:void();" onclick="return false" title="${ CONTEXT_FILTERS }"><bean:message key='ui.ruleform.include.context.filters.label' bundle="analytic"/></a>
					<html:hidden property="includeContextFilters" styleId="includeContextFilters" />
				</c:if>	
			</td>
			<td align="right" ><a href="#" onclick="openHelp();"><img  src="/expensemap/jsp/images/help.gif" border="0" title="<bean:message  key='ui.label.Help' bundle='analytic'/>"/></a></td>	
		</tr>
		<tr>
			<td colspan="2"><hr></td>
		</tr>
		<c:if test="${ createTopnRuleForm.definedAsTemplate == true && ! empty TEMPLATE_FILTERS }">
			<tr>
				<td align="left" colspan="2">
					<c:if test="${ ! empty TEMPLATE_FILTERS }">
						<b><bean:message key='display.filters.TemplateFilters' bundle="analytic"/> : </b>
						<a title="${ TEMPLATE_FILTERS }"><img src="/expensemap/jsp/images/filter.gif" border="0"></a>
					</c:if>		
				</td>	
			</tr>
			<tr>
				<td colspan="2"><hr></td>
			</tr>
		</c:if>
		<tr>
			<td>
				<table class="tableWithoutBorder" width="70%">
					<tr>
						<td><b><bean:message key='ui.label.Name'
								bundle="analytic" /></b></td>
						<td><html:text name="createTopnRuleForm" property="reportName" styleId="reportName"  styleClass="inputStyle" size="60" maxlength="255" /></td>
					</tr>
					<tr>
						<td valign="top"><b><bean:message key='ui.label.Description'
								bundle="analytic" /></b></td>
						<td><html:textarea name="createTopnRuleForm" property="desc" styleId="desc" cols="60" rows="3" styleClass="inputStyle"  style="width:320px;"/></td>
					</tr>
				</table>
			</td>
			<td>
				<c:if test="${ createTopnRuleForm.canCreateTopReports == true }">
					<table class="tableWithoutBorder" width="70%">	
						<tr>
							<td colspan="2" align="left">
								<b><bean:message key="rpt.listing.column.report.type" bundle="analytic" /></b>
							</td>
						</tr>
						<tr>
							<td>
								<html:radio  property="topReport" value="false" styleId="" onclick="enableTopReportCategories(this.checked == false)" >
	        						<b><bean:message key="ui.label.Original" bundle="analytic"/></b>
	        					</html:radio>
	        				</td>
	        			</tr>
	        			<tr>
	        				<td>
	        					<html:radio  property="topReport" value="true" styleId="" onclick="enableTopReportCategories(this.checked == true)">
									<b><bean:message key="ui.label.TopReports" bundle="analytic"/></b>
								</html:radio>&nbsp;
			        			<html:select property="topReportCategory" size="1" styleId="topReportCategory" 
			        				disabled="${ createTopnRuleForm.topReport == false }" styleClass="selectStyle" >
			        				<html:optionsCollection name="createTopnRuleForm" property="topReportCategoriesList" value="value" label="label" />		
								</html:select>
							</td>
						</tr>
					</table>
				</c:if>
			</td>
		</tr>
		<tr>
			<td colspan="2"><hr></td>
		</tr>
		<tr>
			<td colspan="2">
				<table class="tableWithoutBorder" width="100%" border=0>					
						<tr>
							<td align="left" height="15" width="8%" nowrap><b><bean:message key="button.show" bundle="analytic" /></b></td>	<td align=left height="9" width="92%" nowrap>							
							<html:select name="createTopnRuleForm" property="currentCondition.category" size="1"
								onchange="submitRequest('getSortByList',this);" styleClass="selectStyle" 
								styleId="currentCondition.category" disabled="${! createTopnRuleForm.currentCondition.categoryEnabled }" >
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTopnRuleForm.currentCondition.dimensionList }">
									<html:optionsCollection name="createTopnRuleForm" property="currentCondition.dimensionList" label="label" value="value"/>
								</c:if>
							</html:select>
							&nbsp;
							<b><bean:message key="ui.ruleform.by.label" bundle="analytic" /></b>
							<html:select name="createTopnRuleForm" styleId="sortBy"  property="sortBy" size="1" styleClass="selectStyle" onfocus="setPrevSelectValue(this)" disabled="${ empty createTopnRuleForm.sortByList }" onchange="submitRequest('getDimLevelList', this);">
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTopnRuleForm.sortByList }">
					            <logic:iterate name="createTopnRuleForm" property="sortByList" id="sortByObject" type="com.emptoris.analytics.controllers.actionforms.AttributeHolder">
					            	<logic:equal name="sortByObject" property="disabled" value ="true">
					            		<option value="<%=sortByObject.getName()%>" disabled style="color:graytext"><%=sortByObject.getDisplayName()%></option>						
					            	</logic:equal>
					            	<logic:equal name="sortByObject" property="disabled" value ="false">
										<logic:equal name="createTopnRuleForm" property="sortBy" value ="<%=sortByObject.getName()%>">
				            				<option value="<%=sortByObject.getName()%>" selected ><%=sortByObject.getDisplayName()%></option>
										</logic:equal>
										<logic:notEqual name="createTopnRuleForm" property="sortBy" value ="<%=sortByObject.getName()%>">
				            				<option value="<%=sortByObject.getName()%>"><%=sortByObject.getDisplayName()%></option>
										</logic:notEqual>
				            		</logic:equal>
			            		</logic:iterate>
								</c:if>
							</html:select>	
							
											
							<div id="selectedLevelTD" style="display:none;position:relative;">								
								<b><bean:message key="ui.label.level" bundle="analytic" /></b>						
								<html:select name="createTopnRuleForm" property="selectedLevel" styleId="selectedLevel"  size="1" styleClass="selectStyle"
									disabled="${ empty createTopnRuleForm.levelList }" onchange="submitRequest('selectedDimCountLevel', this);" >
									<html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
									<c:if test="${ ! empty createTopnRuleForm.levelList }" >
										<html:optionsCollection name="createTopnRuleForm" property="levelList" label="label" value="value" />
									</c:if>
								</html:select>									
								</div>
							</Td>
							</tr>
						<tr>
							<td align="left" height="15" width="8%" nowrap rowspan=2><b><bean:message key="ui.label.displayAs" bundle="analytic" /></b></td>
							<td align=left height="9" width="90%" nowrap colspan=2 rowspan=2>							
							<html:select name="createTopnRuleForm" property="topNLimitClause" styleId="topNLimitClause"  size="1" styleClass="selectStyle">
					            <c:if test="${ ! empty createTopnRuleForm.topNLimitClauseList }" >
									<html:optionsCollection name="createTopnRuleForm" property="topNLimitClauseList" label="label" value="value" />
								</c:if>
							</html:select>
							&nbsp;
							<input type="text" name="topNLimitValue" id="topNLimitValue"  size="10"
										 class="inputStyle" maxlength="100" value='<bean:write name="createTopnRuleForm" property="topNLimitValue" filter="false"/>'>							
							&nbsp;
							<div nowrap>															
								<html:radio name="createTopnRuleForm" property="reportOnPercentMeasure"  styleId="reportOnPercentMeasure"  value="true"  disabled="false" onclick="enableDisableAddAdditionalFilter(true);"/>&nbsp;<bean:message key="ui.label.percent.of.selected.measure" bundle="analytic" />
								</BR><html:radio name="createTopnRuleForm" property="reportOnPercentMeasure" styleId="reportOnPercentMeasure"  value="false"  disabled="false" onclick="enableDisableAddAdditionalFilter(false);"/>&nbsp;<bean:message key='ui.label.export.to.excel.rows' bundle="analytic" />
							</div>
							</td>
						</tr>
						<tr><td>&nbsp;</td><td>&nbsp;</td></tr>
						</table></br>
			</td>
		</tr>
		<tr>
			<td colspan="2"><hr></td>
		</tr>
		<tr>
			<td colspan="2">
				<table class="tableWithoutBorder" width="100%" cellspacing="0" cellspacing="0" valign="top">
						<tr>
						<td align="left" height="9">
								<font size="1" color="red"><bean:message key="ui.note.additional.conditions.supported.only.for.rows" bundle='analytic'/></font>
						</td>
					</tr>
						<tr>
							<td align="left" height="15" width="7%" nowrap><b><bean:message	key="ui.label.add.additional.filter" bundle="analytic" /></b>&nbsp;&nbsp;
							<input type="checkbox" id="selectAdditionalFilter" onclick="enableAdditionalFilter();" />
							</td>
						</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td colspan="2">				
					<table class="tableWithoutBorder"  id="additionalFilterTable" width="100%" disabled=${ empty createTopnRuleForm.savedConditions } border=0>
					<tr height="0"  ><td  height="0"  width="15%"></td><td  height="0"  width="25%"></td><td  height="0"  width="1%"></td><td  height="0"  width="10%"></td> <td  height="0"  width="49%"></td></tr>					
					<tr>						
						<td align="left" height="9" nowrap><b><bean:message
							key="ui.ruleform.whose.label" bundle="analytic" /></b></td>
						<td align="left" colspan=3>
							<html:select name="createTopnRuleForm" property="currentCondition.attribute" size="1" styleClass="selectStyle"
								styleId="currentCondition.attribute" onchange="submitRequest('processAttribute', this);" onfocus="setPrevSelectValue(this)" 
								disabled="${ !(createTopnRuleForm.selectAdditionalFilter && not empty createTopnRuleForm.currentCondition.attributeList) }">
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTopnRuleForm.currentCondition.attributeList }">
					            <logic:iterate name="createTopnRuleForm" property="currentCondition.attributeList" id="attributeObject" type="com.emptoris.analytics.controllers.actionforms.AttributeHolder">
					            	<logic:equal name="attributeObject" property="disabled" value ="true">
					            		<option value="<%=attributeObject.getName()%>" disabled style="color:graytext"><%=attributeObject.getDisplayName()%></option>						
					            	</logic:equal>
					            	<logic:equal name="attributeObject" property="disabled" value ="false">
										<logic:equal name="createTopnRuleForm" property="currentCondition.attribute" value ="<%=attributeObject.getName()%>">
				            				<option value="<%=attributeObject.getName()%>" selected ><%=attributeObject.getDisplayName()%></option>
										</logic:equal>
										<logic:notEqual name="createTopnRuleForm" property="currentCondition.attribute" value ="<%=attributeObject.getName()%>">
				            				<option value="<%=attributeObject.getName()%>"><%=attributeObject.getDisplayName()%></option>
										</logic:notEqual>
				            		</logic:equal>
			            		</logic:iterate>
								</c:if>
							</html:select>
						</td>
					</tr>
					<tr>							
						<td align="left" height="9" nowrap>
							<b><bean:message key="ui.label.level" bundle="analytic" /></b></td>
						<td align="left" height="9" colspan=3 nowrap>
							<html:select name="createTopnRuleForm" styleId="currentCondition.level" property="currentCondition.level" size="1" styleClass="selectStyle"
								disabled="${ !(createTopnRuleForm.selectAdditionalFilter && not empty createTopnRuleForm.currentCondition.levelList)||createTopnRuleForm.operation == 'editTemplate'}" >
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTopnRuleForm.currentCondition.levelList }" >
									<html:optionsCollection name="createTopnRuleForm" property="currentCondition.levelList" label="label" value="value" />
								</c:if>
							</html:select>
						</td>
					</tr>
					<tr>
						<td align="left" height="9" nowrap><b><bean:message key="ui.ruleform.cri.label" bundle="analytic" /></b></td>
						<td align="left" height="9" colspan=1 nowrap>
							<html:select name="createTopnRuleForm" property="currentCondition.operator" styleId="currentCondition.operator"  size="1"		styleClass="selectStyle" 
								disabled="${ !(createTopnRuleForm.selectAdditionalFilter && not empty createTopnRuleForm.currentCondition.operatorList )||createTopnRuleForm.operation == 'editTemplate' }" onchange="processOperator(this.options[selectedIndex])">
					            <html:option value=""><bean:message key='ui.options.please.select' bundle="analytic" /></html:option>
					            <c:if test="${ ! empty createTopnRuleForm.currentCondition.operatorList }">
									<html:optionsCollection name="createTopnRuleForm" property="currentCondition.operatorList" label="label" value="value" />
								</c:if>
							</html:select>
							&nbsp;
							<c:choose>	
								<c:when test="${ !empty createTopnRuleForm.currentCondition.selectedAttributeType }" >
									<input type="text" name="currentCondition.lowLimit" id="currentCondition.lowLimit"  size="25" class="inputStyle" maxlength="255" value='<bean:write name="createTopnRuleForm" property="currentCondition.lowLimit" filter="false"/>'>
								</c:when>
								<c:otherwise>				
									<input type="text" name="currentCondition.lowLimit" id="currentCondition.lowLimit"  size="25"
										 class="inputStyle" maxlength="255" value='<bean:write name="createTopnRuleForm" property="currentCondition.lowLimit" filter="false"/>' disabled>
								</c:otherwise>
							</c:choose>	
						</td>
								
							<c:choose>
								<c:when test="${ ! empty createTopnRuleForm.currentCondition.highLimit }">
									<td id="highLimitTD" style="visibility:visible;" align="left" nowrap>
										<c:choose>	
											<c:when test="${! empty createTopnRuleForm.currentCondition.selectedAttributeType }" >
												&nbsp;&nbsp;
												<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25" class="inputStyle" maxlength="255" value='<bean:write name="createTopnRuleForm" property="currentCondition.highLimit" filter="false"/>'>
											</c:when>
											<c:otherwise>				
												&nbsp;&nbsp;<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25" class="inputStyle" maxlength="255"	value='<bean:write name="createTopnRuleForm" property="currentCondition.highLimit" filter="false"/>' disabled>											
											</c:otherwise>
										</c:choose>																					
									</td>
									
								</c:when>
								<c:otherwise>
									<td id="highLimitTD" style="visibility:hidden;" align="left" nowrap>
									&nbsp;&nbsp;<input type="text" name="currentCondition.highLimit" id="currentCondition.highLimit" size="25"
											disabled="true"  class="inputStyle" maxlength="50" value='<bean:write name="createTopnRuleForm" property="currentCondition.highLimit" filter="false"/>'/>
									
									</td>
									
								</c:otherwise>
							</c:choose>	

						</td>
					</tr>										
					<tr>
						<td  style="font-size:10pt" align="left" height="9" colspan="2">
							<html:button property="add" styleId="add" onclick="addNewCondition();"
							disabled="${!(createTopnRuleForm.canAddMoreConditions && createTopnRuleForm.selectAdditionalFilter && not empty createTopnRuleForm.currentCondition.attributeList) }">
								<bean:message key='button.add.condition' bundle='analytic'/>
							</html:button>
						</td>
					</tr>
				</table>
			</td>
		</tr>
		<c:if test="${ not empty createTopnRuleForm.savedConditions }">
		<tr>
			<td valign="top" colspan="2"><hr></td>
		</tr>
		<tr>
			<td colspan="2">
				<table class="tableWithoutBorder" align=left width="80%" border=0>
					<c:forEach items="${ createTopnRuleForm.savedConditions }" var="condition" varStatus="count" >
					<c:if test="${!condition.hiddenRule}">
						<tr>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.categoryDisplayName }</option>
								</select>
							</td>							
							<td>
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.attributeDisplayName }</option>
								</select>
							</td>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<c:choose>
										<c:when test="${ ! empty condition.level && condition.level != -1 }">
											<option>${ condition.level - 1 }</option>
										</c:when>
										<c:when test="${ ! empty condition.level && condition.level == -1 }">
											<option><bean:message key='ui.options.all.leaf.nodes' bundle="analytic"/></option>
										</c:when>
										<c:otherwise>
											<option><bean:message key='ui.options.please.select' bundle="analytic" /></option>
										</c:otherwise>
									</c:choose>
								</select>
							</td>
							<td align="left" height="9">
								<select disabled="disabled" class="selectStyle" >
									<option>${ condition.operator }</option>
								</select>
							</td>
							<td align="left" height="9">
								<input type="text" disabled="disabled" class="inputStyle" size="10" value="${ condition.lowLimit }" title="${ condition.lowLimit }">
								<c:choose>
									<c:when test="${ ! empty condition.highLimit }">
										<span style="visibility:visible;">
											<input type="text" disabled="disabled" size="10" class="inputStyle" value="${ condition.highLimit }" title="${ condition.highLimit }">
										</span>
									</c:when>
									<c:otherwise>
										<span style="visibility:hidden;">
											<input type="text" disabled="disabled" size="10" class="inputStyle" value="" >
										</span>
									</c:otherwise>
								</c:choose>								
							</td>
							<td  style="font-size:10pt" align="left" height="9">
								<html:button property="delete" onclick="deleteCondition(${ count.index });" 
									disabled="${ createTopnRuleForm.savedConditionCount != count.count }">
									<bean:message key='ui.search.button.remove' bundle='analytic'/>
								</html:button>
							</td>
						</tr>
						</c:if>
					</c:forEach>
					
				</table>
			</td>
		</tr>
		</c:if>
		<tr>
			<td valign="top" align="center" colspan="2"><hr></td>
		</tr>				
		<tr>
			<td align="center" colspan="2">
				<table>
					<tr>
						<c:choose>
							<c:when test="${ createTopnRuleForm.definedAsTemplate }">
								<td  style="font-size:10pt">				
									<html:button property="createTemplate" onclick="saveTemplate(true);" >
										<bean:message key='button.create.new.template' bundle="analytic" />
									</html:button>
								</td>
								<c:if test="${ createTopnRuleForm.templateUpdateAllowed }">
								<td  style="font-size:10pt">							
									<html:button property="updateTemplate" onclick="saveTemplate(false);" >
										<bean:message key='button.update.template' bundle="analytic" />
									</html:button>
								</td>
								</c:if>
							</c:when>
							<c:otherwise>
								<td  style="font-size:10pt">
									<html:button property="saveBtn" onclick="saveTemplate(true);">
										<bean:message key='button.saveAsTemplate' bundle="analytic" />
									</html:button>
								</td>
							</c:otherwise>
						</c:choose>
						<td  style="font-size:10pt">
							<html:button property="submitBtn" onclick="submitAnalyticForm();" >
								<bean:message key='button.submit' bundle="analytic" />
							</html:button>
						</td>
						<td  style="font-size:10pt">
							<html:button property="cancelBtn" onclick="cancelAnalyticForm();">
								<bean:message key='ui.label.Cancel' bundle="analytic" />
							</html:button>
						</td>
					</tr>
				</table>
			</td>
		</tr>
	</table>
	<input type="hidden" name="createNew" id="createNew" value="${ createTopnRuleForm.definedAsTemplate == false }" />
	<c:if test="${ createTopnRuleForm.definedAsTemplate == true }">
		<input type="hidden" name="templateId" id="templateId" value="${ createTopnRuleForm.templateId }" />
	</c:if>
	<input type="hidden" name="listSortColumn" id="listSortColumn" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortColumn"))%>">
	<input type="hidden" name="listSortOrder"    id="listSortOrder"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortOrder"))%>">
	<input type="hidden" name="listLimitRec"    id="listLimitRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listLimitRec"))%>">
	<input type="hidden" name="listStartRec"    id="listStartRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listStartRec"))%>">
	<input type="hidden" name="operation"    id="operation" value="${createTopnRuleForm.operation}">
	<input type="hidden" name="selectedAttributeType" id="selectedAttributeType" value='<bean:write name="createTopnRuleForm" property="currentCondition.selectedAttributeType"/>'>
	<input type="hidden" name="currentConditionType" id="currentConditionType" value='<bean:write name="createTopnRuleForm" property="currentCondition.type"/>'>
	<input type="hidden" name="savedConditionCount" id="savedConditionCount" value='<bean:write name="createTopnRuleForm" property="savedConditionCount"/>'>
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</center>
<SCRIPT>enableDisableAdditionalCondition(${createTopnRuleForm.selectAdditionalFilter},${createTopnRuleForm.canAddMoreConditions},${ ! empty createTopnRuleForm.levelList },${!empty createTopnRuleForm.savedConditions},${createTopnRuleForm.reportOnPercentMeasure});</SCRIPT>
</html:form>

<script language="JavaScript">

YAHOO.namespace('emptoris.analytics.search.UI');
(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.emptoris.analytics.search.UI = {
		init: function() {
			var self = YAHOO.emptoris.analytics.search.UI;
			var fromDateField = document.getElementById("currentCondition.lowLimit");
			var toDateField = document.getElementById("currentCondition.highLimit");
			var attributeType = '${ createTopnRuleForm.currentCondition.selectedAttributeType }';
			if ( attributeType == 'DATE' ) {
				Event.on(fromDateField, "focus", self.openCalendar, [fromDateField, fromDateField]);
				Event.on(toDateField, "focus", self.openCalendar, [toDateField, toDateField]);
			} else {
				Event.removeListener ( fromDateField, "focus" , self.openCalendar );
				Event.removeListener ( toDateField, "focus" , self.openCalendar );
			}
		},

		openCalendar: function(e, args) {	
    		YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
		}
	}

	Event.onDOMReady(YAHOO.emptoris.analytics.search.UI.init, YAHOO.emptoris.analytics.search.UI, true);
})();

function showCalendar(e, args) {
    	YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
}
</script>


</body>
</html:html>