<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@page import="com.emptoris.analytics.common.util.AnalyticUtility"%>
<%@page import="com.emptoris.viewer.ReportViewType"%>
<%@ include file="../../includes/tlib.jspf"%>
<%@ page import="java.util.*, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.emptoris.analytics.common.valueobjects.AnalyticRequestContext"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession,com.zeborg.expensemap.analytic.AnalyticsTrendPreferences" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil,com.zeborg.expensemap.view.HelpUtil,com.zeborg.util.WebUtil,ilog.views.chart.data.IlvDefaultDataSource" %>
<%@ page import="com.emptoris.analytics.common.valueobjects.*" %>
<%@ page import="com.zeborg.expensemap.util.AnalyticsQueryBuilder,java.util.Map,com.zeborg.expensemap.analytic.TrendAnalyticCondition"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.util.ExpenseMapAppProperties, com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="com.zeborg.expensemap.analytic.AnalyticCondition,com.emptoris.analytics.common.util.AnalyticActionsConstants"%>
<%@ page import="java.util.Date,java.text.SimpleDateFormat,org.apache.struts.util.LabelValueBean,com.zeborg.acl.util.LocaleUtil,java.util.List"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>

<%
boolean checkAll = false;
ZSession zs = ZSessionUtil.getFromSession(pageContext);
String expFrame = zs.getExpensemapFrame();
StringBuffer sbuf = new StringBuffer();
AnalyticRequestContext context = (AnalyticRequestContext) session.getAttribute("reportContext");
Set<String> multikeeps = new HashSet<String>();
if(context.getMultiKeeps() != null){
	multikeeps = context.getMultiKeeps();
}
int currentLevel = context.getLevel();
Map<String,Set<String>> nodesPerLevel = new HashMap<String,Set<String>>();
if(context.getNodesPerLevel() != null){
	nodesPerLevel = context.getNodesPerLevel();
}
Set<String> nodeSet = new HashSet<String>();
if(nodesPerLevel.get(String.valueOf(currentLevel)) != null){
	nodeSet = nodesPerLevel.get(String.valueOf(currentLevel));
}
if(multikeeps.containsAll(nodeSet)){
	checkAll = true;
}
if(nodeSet.isEmpty()){
	checkAll = false;
}
AnalyticReportVO reportData = (AnalyticReportVO)request.getAttribute("reportVO");
List<List<Object>> data = reportData.getData();
if (multikeeps != null) {
	sbuf.append("[");
	if(data != null){
		for(int i=0;i<data.size();i++){
			List<Object> list = (List<Object>)data.get(i);
			
			String id = list.get(0).toString();
			if(multikeeps.contains(id)){
				sbuf.append("\"");
				sbuf.append(id);
				sbuf.append("\"");
				sbuf.append(",");
			}
		}
	}
	if (sbuf.indexOf(",") > 0) {
		sbuf = new StringBuffer(sbuf.substring(0, sbuf.lastIndexOf(",")));
	}
	sbuf.append("]");
}
Locale locale =zs.getUser().getLocale();
EmResourceBundle bundle=EmLocalizationManager.getBundle(EmLocalizationManager.ANALYTICS_MESSAGEBUNDLE, locale);
String helpURL = HelpUtil.getHelpUtil().getHelpURLString("ui.view.analytic.report.help.page", locale);
int warnLimit = ExpenseMapAppProperties.getEmMaxNodeApplyLimitWarning();
String maxLimit = String.valueOf(ExpenseMapAppProperties.getEmMaxNodeApplyLimit());
CubeUtil.buildExpMapMastHead(out,"viewFrame_analytic.jsp",zs,true,null,locale,null);
EmResourceBundle baseBundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, locale);
String title = ExpenseMapAppProperties.getExpensemapTitle();
title = title + " - " + baseBundle.getValue("ui.trendnanalytics.Title");

String newDisplayType = "";String altText = "";

if ( ReportViewType.TABLE.equals(context.getViewType())) {
	newDisplayType = ReportViewType.GRAPH.name();
	altText = "ui.label.toggle.chart";
} else {
	newDisplayType = ReportViewType.TABLE.name();
	altText = "ui.label.toggle.table";
}

%>
<html>
<head>
<title><%=title%></title>
<style>
a, A:link, a:visited, a:active, A:hover	{color: #330099;}
</style>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/fonts/fonts-min.css" /> 
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/button/assets/skins/sam/button.css" /> 
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" /> 
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script> 
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script> 
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script> 
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script> 
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script> 
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script> 
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css">
<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>

<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/export.css">

<style type="text/css">

.buttonStyle{
		font: 10px arial;
}
#popupMenu a{
		text-decoration: none;
		padding-left: 6px;
		color: black;
		display: block;
}
</style>

<script language="javascript">

	// export report to xls/csv.
	function exportReport() {
		var isEmpty='${ empty reportVO.data }';
		if(isEmpty=='true')	{
			alert("<bean:message key='errors.noexportdata' bundle ='analytic'/>");
			return false;
		} else {
			if(document.getElementById("fileTypeXls").checked &&
					parseInt('${reportContext.totalRec }')>parseInt('<%=ExpenseMapAppProperties.getMaxRecordsForExcel()%>')){
				alert("<bean:message key='ui.alertmsg.records.exceed.excel.limit' bundle ='analytic'/>");
				return false;
			} else {
				var frm = document.getElementById("reportRenderForm");
				var displayModeCsv = document.getElementById("fileTypeCsv");
    			var displayModeXls = document.getElementById("fileTypeXls");
				var fileName = document.getElementById("fileName");
				var fName = trim(fileName.value);
				//method in commons.js
				if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key="ui.pdf.create.page.error.message.supported.special.characters" />" + '\n  _   -')) {
					
					var numFormatObject = document.getElementById("exportNumberFormat");
					var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
					var reportId = document.getElementById("reportId").value ;
					frm.numberFormat.value = numFormat;
					frm.reportName.value = fName;
					frm.method="post";
					var url='';
					if ( displayModeCsv.checked == true ) {
						url = "/expensemap/analytic/analyticsExportExcelCSV.do?level="+${ reportContext.level };
					} else if ( displayModeXls.checked == true ) {
						url = "/expensemap/analytic/analyticsExportExcel.do?level="+${ reportContext.level };
					}
					frm.action= url;
					frm.submit();
					closeExportBox();
				}
			}
		}
	}
	
	// Returns the function name and its params as a string for calling export functionality from common export UI in commonExportUI.jsp
	function getParamString(name, id, status) {
		return "javascript:exportReport()";
	}
	
	// Show/hide divs upon selection of csv/excel type. called from commonExportUI.jsp
	function toggleOptionDiv(fileType) {
	}
	
	// Returns header string for export ui called from commonExportUI.jsp. It depends upon module its called for.
	function getHeader() {
		return "<bean:message key='ui.title.exporting.Analyitc'/>";
	}
	
	// Initialize the export UI. show/hide divs. It depends upon each module which div to show/hide. called from commonExportUI.jsp
	function initDiv() {
		var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
		var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
		dimensionOptionsDiv.style.visibility = 'hidden';
		dimensionNoOfRowsOptionsDiv.style.visibility = 'hidden';
	}

	// Returns level by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
	function getLevelsBydimId(dimId) {
		return 0;
	}

	//Returns no of rows by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
	function getNoOfRowsBydimId(dimId) {
		return 0;
	}

	// StringBuffer Object 
	function StringBuffer() { 
	   this.buffer = []; 
	} 
	
	StringBuffer.prototype.append = function append(string) { 
	   this.buffer.push(string); 
	   return this; 
	}
	
	StringBuffer.prototype.toString = function toString() { 
	   return this.buffer.join(""); 
	}

	/*
		As per display type, this function will return true/false whether data is present or not.
	*/	
	function isDataPresent(){
		<c:choose>
		<c:when test="${ empty reportVO.data && empty reportVO.chartData }">return false;</c:when>
		<c:otherwise>return true;</c:otherwise>
		</c:choose>
	}

	function printReport(action){
		var isEmpty = isDataPresent();
		if(isEmpty=='true')	{
			alert("<bean:message key='errors.noprintdata'  bundle ='analytic'/>");
			return false;
		} else {
			var frm = document.getElementById("reportRenderForm");
			frm.method="post";
			frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction="+action+"&pageType=_pf";
			frm.target='_new';
			frm.submit();
			frm.target='_self';
		}
	}

	function checkAllBoxes(formObj){
	    var checkboxes = document.reportRenderForm.ids;
	    var ids = new StringBuffer();
	    var checkAllVal = formObj.checkAll.checked;
	    if (checkboxes) {
		   	if (!checkboxes[0] ) { 
				checkboxes.checked = checkAllVal;
				ids.append(',');
				ids.append(checkboxes.id);							
		     }else{
		     	var chkLen = checkboxes.length;
			    for( var index=0; index < chkLen; index++ ) {
					var checkboxObj = checkboxes[index];
					checkboxObj.checked = checkAllVal;
					ids.append(',');
					ids.append(checkboxObj.id);			
				}// end for
			 }
	     }
	     sendPostRequest('updateSelectedAllNodes'+","+checkAllVal+ids.toString());
 	}
		   
	function getReportList() {
		var frm = document.getElementById("reportRenderForm");
		var order=document.getElementById("listSortOrder").value;
		var columnName=document.getElementById("listSortColumn").value;
		frm.method="post";
		frm.action="/expensemap/showAnalyticPage.xhtm";
		frm.submit();
	}
		      
	function processMultikeepRequest(checkList,noOfRows) {
		if ( checkForMultikeep(checkList,noOfRows) == false ) {
			return false;
		}
		
		var currentFiltersApplied = "${ DIMENSION_NODE_FILTER_APPLIED }";
		if ( currentFiltersApplied == "" || currentFiltersApplied == "false" ) {
			submitFormForMultiKeep(checkList, noOfRows);
		} else {
			// show popup
			YAHOO.analytic.trend.multikeep.container.popUpMenu.show();
		}
		
	}

	YAHOO.util.Event.onDOMReady(function () {
	
	var checkIntersectionBeforeMultikeepRequest = function() {
		if ( document.getElementById("keepCurrentFilters").checked == true ) {			
    		sendAjaxPostRequest();
    	} else {
    		submitFormForMultiKeep(document.reportRenderForm.ids,'${ reportVO.size }');
    	}
	};

	YAHOO.namespace("analytic.trend.multikeep.container");

	YAHOO.analytic.trend.multikeep.container.popUpMenu = new YAHOO.widget.Dialog("popupMenu", 
							{							  
							  width   : "200px",							 
							  visible : false,								  
							  constraintoviewport : true,
							  buttons : [{  text:"<bean:message key='button.apply' bundle='analytic' />",
											handler:checkIntersectionBeforeMultikeepRequest }																				
										]
							});

	YAHOO.util.Event.addListener(document.getElementById('multiKeepLink'), 'click', setCoordinate);
	function setCoordinate(e){
		var X = YAHOO.util.Event.getPageX(e);
		var Y = YAHOO.util.Event.getPageY(e);
		YAHOO.analytic.trend.multikeep.container.popUpMenu.cfg.setProperty('X', X-200);
		YAHOO.analytic.trend.multikeep.container.popUpMenu.cfg.setProperty('Y', Y + 10);
	}
	YAHOO.analytic.trend.multikeep.container.popUpMenu.render();	
}); // end of onDomReady.



	function checkForMultikeep(checkList,noOfRows) {
		var checkFlag = false;
		if ( noOfRows == 0 ) {
			alert("<bean:message key='ui.alertmsg.multikeep' bundle='analytic'/>");
			return false;
		}
		    
		for(i=0; i < noOfRows; i++) {
			if ( noOfRows == 1 && checkList.checked == true ) {
				checkFlag = true;
				break;  
			} else if (noOfRows == 1 && checkList.checked == false ) {
				checkFlag = false;
				break;  
			} else if (checkList[i].checked == true) {
				checkFlag = true;
				break;  
			}
		}
	if(!isMultiKeep() && checkFlag == false ) {
			alert("<bean:message key='ui.alertmsg.multikeep.select' bundle='analytic'/>");
			return false;
		}
		return true;
	}
	
	
	function submitFormForMultiKeep(checkList,noOfRows) {
		if ( checkForMultikeep(checkList,noOfRows) == false ) {
			return false;
		}
		var keepCurFilter = 'false';
		var chk = document.getElementById("keepCurrentFilters");
		if(chk){
			keepCurFilter = chk.checked;
		}
		var dimName = document.getElementById('dimensionName').value;
		sendRequest('maxNodeValidation,'+dimName+','+keepCurFilter);		
	}
		
	function submitFormForSorting(columnId) {
	    var order = document.getElementById("sortOrder").value;
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do" ;
		if(order=='ASC'){
			order='DESC';
		}else if(order=='DESC'){
			order='ASC';
		}
		document.getElementById("sortOrder").value=order;
		document.getElementById("sortColumn").value=columnId;
		frm.submit();
	}
	
	function paginate(action){
		var frm = document.getElementById("reportRenderForm");
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction="+action;
		frm.submit();
	}
		
	// A JS function to request data for a specific level.
	function getDataForLevel(selectedLevel) {
		var frm = document.getElementById("reportRenderForm");
		document.getElementById("Level").value = selectedLevel.value;
		frm.method="post";
		frm.action="/expensemap/analytic/renderAnalyticsAction.do";
		frm.submit();
	}
	
	function openHelp(){
    	open( "<%=helpURL%>", "_blank" );
    }
    
	function setCheckBox() {
    	var chkBox = eval(<%=sbuf.toString()%>);
    	if(chkBox!=null){
    		for(var i=0;i<chkBox.length;i++){    			
    			var ch = document.getElementById(chkBox[i]);
    			if(ch!=null){
    				ch.checked = true;
    			}
    		}    		
       }
       
       var doCheck = "<%=checkAll%>";
       if(document.getElementById("checkAllPg")){
       if(doCheck == 'true'){
       		document.getElementById("checkAllPg").checked = true;
       }else{
       		document.getElementById("checkAllPg").checked = false;
       }
	   updateCheckboxesOnCurrentPage();	
	   }
 	}
    
    function isEmpty(fieldVal) {
    	if(fieldVal==null || fieldVal=='' || fieldVal=='null' ) {			
       		return true;
    	}
	}
    
    function setUnchecked(checkbox){
	    var unckecked = document.getElementById("UncheckedList");	    
	    if(!checkbox.checked) {
	        if(isEmpty(trim(unckecked.value))){
				unckecked.value =checkbox.value;
			}else{
				unckecked.value = unckecked.value+','+checkbox.value;
			}
		}
		updateSelectedNodes(checkbox);
    }  
	
    // Used for AJAX
    var	xmlHttp = false;
    // A JS to submit AJAX POST to check intersection of filters being applied
    function sendAjaxPostRequest() {
		
	    // branch for native XMLHttpRequest object
	    if(window.XMLHttpRequest) {
			try {
				xmlHttp = new XMLHttpRequest();			
		    } catch(e) {
				xmlHttp = false;
			}
	
	    // branch for IE/Windows ActiveX version
	    } else if(window.ActiveXObject) {
		    try {
		    	xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");	    	
		    } catch(e) {
			    try {
					xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");				
			    } catch(e) {
			          xmlHttp = false;
			    }	
		    }
	    } 

	    if(xmlHttp)
	    {		
			// Open connection
			try {		    
				// Setup a function for the server to run when it's done			
				xmlHttp.onreadystatechange = receiveResponse;			
				xmlHttp.open("POST", "/expensemap/analytic/AnalyticsMultiKeepCheckIntersection.do", true);
				xmlHttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
				// construct parameters for post
				var params = "dimensionName=" + '${ reportContext.baseDimension }'
					+ "&ids=" + getSelectedIds()
					+ "&UncheckedList=" + document.getElementById('UncheckedList').value;
				xmlHttp.send(params);
			} catch(e) {
				 xmlHttp = false;
				alert(e)
			}
		}else{
			alert("<bean:message key='ui.message.Browser.does.not.support.AJAX.type.request' bundle ='emMessages'/>");
		}
	}
	
	function getSelectedIds() {
		var selectedIds = "";
		var checkboxes = document.reportRenderForm.ids;
		if ( ! checkboxes[0] ) {
			// There is only one checkbox
			if ( checkboxes.checked ) {
				return checkboxes.value;
			}
		}
		for( var index=0; index < checkboxes.length; index++ ) {
			var checkboxObj = checkboxes[index];
			if ( checkboxObj.checked )	{
				if ( selectedIds.length > 0 ) {
					selectedIds = selectedIds + ",";
				}
				selectedIds = selectedIds + checkboxObj.value;
			}
		}
		return selectedIds;
	}
	
	function receiveResponse() {
		if (xmlHttp.readyState == 4) {
		    if (xmlHttp.status != 200) {
		    	alert("<bean:message key='ui.message.There.was.a.problem.retrieving.data.from.server' bundle ='emMessages'/>");
	            return false;
	        }
	
			var response = xmlHttp.responseText;
			var data = eval(response);
			
			if ( data == 'true' ) {
				submitFormForMultiKeep(document.reportRenderForm.ids,'${ reportVO.size }');
			} else {
				document.getElementById("keepCurrentFilters").checked = false;
				if ( confirm("<bean:message key='ui.alertmsg.multikeep.no.intersection' bundle='analytic'/>") ) {
					submitFormForMultiKeep(document.reportRenderForm.ids,'${ reportVO.size }');
				}
				return false;
			}
		}	
	}
	
	function updateCheckboxesOnCurrentPage(){
		var formObj = document.getElementById("reportRenderForm");	
		var checkboxes = document.reportRenderForm.ids;
		var allChecked = true;
		if(checkboxes){
			if (!checkboxes[0] ) { 
				allChecked = checkboxes.checked;
			}else{
				for( var index=0; index < checkboxes.length; index++ ) {
					var checkboxObj = checkboxes[index];
					   if(!checkboxObj.checked){
							allChecked = false;
							break;
					   }
				}//end for
			}//end else
		formObj.checkAll.checked = allChecked;
		}
	}
	
	function checkAllPage(chkBox){
		var checkVal = chkBox.checked;
		document.getElementById("selectAllAcrossPage").value = checkVal;	
		var formObj = document.getElementById("reportRenderForm");	
		formObj.checkAll.checked = checkVal;
		//select all checkboxes on page
		var checkboxes = document.reportRenderForm.ids;
	    if(checkboxes){
		   	if (!checkboxes[0] ) { 
				checkboxes.checked = checkVal;
		     }else{
		     	var chkLen = checkboxes.length;
			    for( var index=0; index < chkLen; index++ ) {
					var checkboxObj = checkboxes[index];
					checkboxObj.checked = checkVal;
				} 
			 }
	     }
		 var currentLevel = document.getElementById("Level").value;
		 sendRequest('selectAcrossPage'+','+checkVal+','+currentLevel);
	}	

	function updateSelectedNodes(chkBox){
		/*request format : 'updateSelectedNodes',<CHECKBOX_ID>,<CHECKED_VALUE>*/
		if(!chkBox.checked){
			// checkbox is unchecked, so set selectAllAcrossPage flag to false
			document.getElementById("selectAllAcrossPage").value = false;
		}
		updateCheckboxesOnCurrentPage();		
		sendRequest('updateSelectedNodes'+","+chkBox.id+","+chkBox.checked);
	}

var xmlHttp2;
function ResetHttpRequest() {
	xmlHttp2 = false;
    // branch for native XMLHttpRequest object
    if(window.XMLHttpRequest) {
		try {
			xmlHttp2 = new XMLHttpRequest();
	    } catch(e) {
			xmlHttp2 = false;
		}
    // branch for IE/Windows ActiveX version
    } else if(window.ActiveXObject) {
	    try {
	    	xmlHttp2 = new ActiveXObject("Msxml2.XMLHTTP");
	    } catch(e) {
		    try {
				xmlHttp2 = new ActiveXObject("Microsoft.XMLHTTP");
		    } catch(e) {
		          xmlHttp2 = false;
		    }
	    }
    }

   if (!xmlHttp2) alert("<bean:message key='ui.message.Browser.does.not.support.AJAX.type.request' bundle ='emMessages'/>");
}

function sendRequest(argStr){
	try {
	    ResetHttpRequest();
		xmlHttp2.open("GET", "/expensemap/jsp/analytics/analyticsAjaxProcessor.jsp?" + argStr, true);
		xmlHttp2.send(null);
		xmlHttp2.onreadystatechange = responseHandler;
	} catch(e) {
		 alert(e);
	}
}

//This function checks if any node selected across the pages
function isMultiKeep() {
	try {
		ResetHttpRequest();
		xmlHttp2.open("GET", "/expensemap/jsp/analytics/analyticsAjaxProcessor.jsp?checkMultikeep", false);
		xmlHttp2.send(null);
		var data = eval(xmlHttp2.responseText);
		return data[1];
	} catch(e) {
		 alert(e);
	}
}
	
function sendPostRequest(argStr){
	try {
	    ResetHttpRequest();
		xmlHttp2.open("POST", "/expensemap/jsp/analytics/analyticsAjaxProcessor.jsp", true);
		xmlHttp2.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		var param = 'var='+argStr;
		xmlHttp2.send(param);
		xmlHttp2.onreadystatechange = responseHandler;
	} catch(e) {
		 alert(e);
	}
}

function responseHandler(){
	if (xmlHttp2.readyState == 4){
	    if (xmlHttp2.status != 200) {
            alert("<bean:message key='ui.message.There.was.a.problem.retrieving.data.from.server' bundle ='emMessages'/>");
            return false;
        }
		var response = xmlHttp2.responseText;
		var data = eval(response);
		// If there is no data in the response, ignore this
		if (data == null) {
		   return;
		}
		if (data[0] == "Error"){
		    var errorCode = data[1];
		    if(errorCode == "session.timeout")
		    {
		       var timeoutURL = data[3];
		       parent.location.href=timeoutURL;
		       return;
		    }
		    if(errorCode == "validation.error"){
			    alert("<bean:message bundle='search' key='ui.error.message.em.max.node.apply.limit' arg0='<%=maxLimit%>' />");
		    	return;
		    }
		}else {
			if(data[0] == "Success"){
				if(data[1] == "submitFormForMultiKeep"){
					var warnLmt = <%=warnLimit%>;
					var nodeListSize = data[2];
					if(nodeListSize > warnLmt){
						if(confirm("<bean:message bundle='search' key='ui.message.em.max.node.apply.limit.warning'/>")){
							var expenFrame = '<%=expFrame%>';
							var frm = document.getElementById("reportRenderForm");
							frm.method="post";
							frm.action="/expensemap/analytic/AnalyticsMultiKeep.do";
							frm.target = expenFrame;
							frm.submit();
						}else{
							return;
						}
					}else{
							var expenFrame = '<%=expFrame%>';
							var frm = document.getElementById("reportRenderForm");
							frm.method="post";
							frm.action="/expensemap/analytic/AnalyticsMultiKeep.do";
							frm.target = expenFrame;
							frm.submit();										
					}	
				}
			}
			else if(data[0] == "TOTAL_SELECTED_NODE_COUNT") {
				var TOTAL_NODES_COUNT = <%= context.getTotalRec() %>;
				var TOTAL_SELECTED_NODE_COUNT = data[1];
				
				if(TOTAL_NODES_COUNT == TOTAL_SELECTED_NODE_COUNT){
					document.getElementById("checkAllPg").checked=true;
				}else{
					document.getElementById("checkAllPg").checked=false;
				}
			}
		}
	}
}
	
function commonFuntion(){
	setCheckBox();
}

function toggleDisplayType(newType){
	var frm = document.getElementById("reportRenderForm");
	frm.method="post";
	frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction=getCurrent&displayType="+newType;
	frm.submit();
}

function getChartPreferencesWindow(){
	var ht = 320;
	var wt = 650;
	var left = (screen.width/2)-(wt/2);
	var top = (screen.height/2)-(ht/2);
	   
	var reportId = "${reportContext.reportId}"; 
	window.open("/expensemap/analytic/getChartPreferences.do?reportId="+reportId, "Chart_Preferences", "width="+wt+",height="+ht+",left="+left+",top="+top+",scrollbars=no,status=yes,resizable=no");
}

function reloadPage(){
	var frm = document.getElementById("reportRenderForm");
	frm.method="post";
	frm.action="/expensemap/analytic/renderAnalyticsAction.do?theAction=getCurrent";
	frm.submit();
}
</script>
</head>
<body onload="commonFuntion();"  class="yui-skin-sam">
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="reportRenderForm"/>
</jsp:include>

<form name="reportRenderForm" id="reportRenderForm">
<jsp:include page="/jsp/includes/commonExportUI.jsp"/>
<c:if test="${ empty reportVO.data && empty reportVO.chartData }">
<br>
	<font color="red" face="Verdana" size="2"> <b><bean:message key="error.com.emptoris.analytics.noDataFound" bundle="analytic" /></b></font>
</c:if> 

<br>

<table class="tableWithBorderAna" align="center">
	<tr>
		<td align="left"><b><bean:message key="ui.trendnanalytics.Title" bundle="analytic" /></b></td>
		<td align="center"><b><bean:message	key="rpt.cubeName" bundle="analytic" />: ${cube}</b></td>
		<td align="right">
			<c:choose>	
				<c:when  test="${ !empty reportVO.data || !empty reportVO.chartData}">
					<img src="/expensemap/jsp/images/report/chart_table_icon.gif" title="<bean:message key='<%=altText%>' bundle="analytic" />" border="0" onclick="toggleDisplayType('<%=newDisplayType%>')"  style="cursor:pointer"/>&nbsp;
					<% if( ReportViewType.GRAPH.equals(context.getViewType())){ %>
						<img id="multiKeepLink" src="/expensemap/jsp/images/report/prefereneces_icon.gif" title="<bean:message key='ui.label.chart.preferences' bundle="analytic" />" border="0" onclick="getChartPreferencesWindow()"  style="cursor:pointer"/>&nbsp;
					<%} else { %>
					<img id="multiKeepLink" src="/expensemap/jsp/images/keeponly.gif" title="<bean:message key='ui.keeponly.image.tooltip' bundle="analytic"/>" border="0" onclick="processMultikeepRequest(document.reportRenderForm.ids,'${ reportVO.size }');" style="cursor:pointer"/>&nbsp;
					<c:if test="${ canExportAnalyticReport == 'true'  }">
						<img src="/expensemap/jsp/images/excel.gif" title="<bean:message key='ui.label.export.to.excel' bundle="analytic" />" border="0" onclick="openExportBox('<esapi:html><c:out value="${reportContext.reportName}" /></esapi:html>');" style="cursor:pointer"/>&nbsp;
					</c:if>
					<%}%>
					<img src="/expensemap/jsp/images/print.gif" title="<bean:message key='ui.print.image.tooltip' bundle="analytic"/>" border="0" onclick="printReport('getCurrent');" style="cursor:pointer"/>&nbsp;
				</c:when>
			</c:choose>	
			<img src="/expensemap/jsp/images/help.gif" title="<bean:message key='ui.label.Help' bundle="analytic"/>" border="0" onclick="openHelp();" style="cursor:pointer"/>			
		</td>
	</tr>
</table>

<table class="InnerTableWithBorderAna" align="center">
	<tr>
		<td><b><bean:message key="ui.report.table.header.name"	bundle="analytic" /> :  <c:out value="${ reportContext.reportName }"/></b></td>		
	</tr>
	<tr>
		<td><b><bean:message key="ui.analyticsReport.criteria"	bundle="analytic" />:</b> 
			<%
				String conditionalFlag = "";
				List<AnalyticCondition>  reportList = context.getAnalyticConditions();
				Iterator<AnalyticCondition> iterator = reportList.iterator();
				TrendAnalyticCondition trendCondition = context.getTrendAnalyticCondition();
			%>
			<c:forEach items="${ reportContext.analyticConditions }" var="condition" varStatus="status">				
				<%	
					//pr-44080 if the language is japanese,then query is retrived from property file by passing placehoders .
					if(locale.getLanguage()=="ja"){
						AnalyticCondition vo = iterator.next();			
				%>				
							<tr> <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
								&nbsp;
								<c:if test="${ condition.cumulative == true }">
									<%conditionalFlag += "Cumulative";%>					
								</c:if>
								<c:if test="${ ! empty condition.level }">
									<%conditionalFlag += "Level";%>
								</c:if>
								<c:if test="${ ! empty condition.highLimit }">
									<%conditionalFlag += "HighLimit";%>
								</c:if>
								<c:if test="${ condition.percentTotalOption.name != 'NONE' }">
									<%conditionalFlag += "NotNone";%>		
								</c:if>
								<%=AnalyticsQueryBuilder.getQuery(vo,bundle,conditionalFlag)%>
								<%conditionalFlag= "";%>							
							</td></tr>			
					<%}else {%>
						<c:if test="${ status.count == 1 }">
							<bean:message key="ui.label.ShowAll" bundle="analytic" />&nbsp;${ condition.categoryDisplayName }
						&nbsp;<bean:message key="ui.ruleform.whose.label" bundle="analytic" />
						</c:if>
						<tr>
							<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
							<c:if test="${ condition.cumulative == true }">
								<bean:message key="ui.ruleform.cumulative.label" bundle="analytic" />&nbsp;
							</c:if>
							<c:if test="${ ! empty condition.level && condition.level != -1 }">
								<bean:message key="ui.label.level" bundle="analytic" />&nbsp;${ condition.level -1}&nbsp;
							</c:if>
							<c:if test="${ ! empty condition.level && condition.level == -1}">
								<bean:message key="ui.label.leaf.level.node" bundle="analytic" />&nbsp;
							</c:if>
							${ condition.attributeDisplayName }&nbsp; ${ condition.operatorDisplayName }&nbsp;${ condition.virtualLowLimit}&nbsp;
							<c:if test="${ ! empty condition.virtualHighLimit }">
										<bean:message key="ui.ruleform.label.and" bundle="analytic" />&nbsp;${ condition.virtualHighLimit }
							</c:if>
							<c:if test="${ condition.percentTotalOption.name != 'NONE' }">
								<bean:message key="${ condition.percentTotalOption.resourceKey }" bundle="analytic" />&nbsp;
							</c:if>
							</td>
						</tr>
					<%}%>
			</c:forEach>
		</td>
	</tr>
	<!-- displaying trend condition -->		
	<tr>
		<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
			<%if(trendCondition != null){ %>
				<bean:message key="ui.ruleform.for.label" bundle="analytic"/> <%=trendCondition.getTimeDimensionDisplayName()%>
				<% if(trendCondition.getTrendType().equalsIgnoreCase("discrete")){ %>
					<bean:message key="ui.operator.Between" bundle="analytic"/> <%=trendCondition.getStartPeriodHierarchyStr()%> &nbsp;<bean:message key="ui.ruleform.label.and" bundle="analytic"/>&nbsp; <%=trendCondition.getEndPeriodHierarchyStr()%>
				<% }else if(trendCondition.getTrendType().equalsIgnoreCase("continuous")){ %>
					
				<% 		if(trendCondition.getTimeDimension().equalsIgnoreCase("dimtime")){%>
							<bean:message key="ui.ruleform.for.label" bundle="analytic"/> &nbsp; <bean:message key="<%=AnalyticUtility.getAllTimePeriodDisplayName(trendCondition.getTimePointLevel())%>" bundle="analytic" />
					<% 	}else { 
						Integer level = new Integer(trendCondition.getTimePointLevel());
					%>	
						<bean:message key="ui.ruleform.all.label" bundle="analytic"/>&nbsp; <bean:message key="ui.label.level" bundle="analytic"/>&nbsp;<%=level.intValue()-1%>
					<%	}
					}	//if dim = DIMTIME
				}// end if null%>
		</td>
	</tr>
	<!-- end //display trend condition -->
	<tr>
		<td align="left"><b><bean:message key="display.filters.AdditionalFilters" bundle="analytic" />: </b> 
			<c:if test="${ empty reportContext.sessionFilters && empty reportContext.contextFilters }">
				<b><bean:message key="ui.label.None" bundle="analytic" /></b>
			</c:if> 
			<c:if test="${ ! empty reportContext.sessionFilters }">
				<a title="${ reportContext.formattedSessionFilters }"><b><bean:message	key="display.filters.SessionFilters" bundle="analytic" /></b></a>&nbsp;
				<img src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;	
			</c:if> 
			<c:if test="${ ! empty reportContext.contextFilters }">
				<a title="${ reportContext.formattedContextFilters }"><b><bean:message	key="display.filters.ContextFilters" bundle="analytic" /></b></a>&nbsp;
				<img src="/expensemap/jsp/images/filter.gif" border="0">&nbsp;&nbsp;	
			</c:if>
		</td>
		<td align="right" style="font-size:10pt"><b><bean:message key="ui.label.level" bundle="analytic" /></b>&nbsp;
		<select onchange="getDataForLevel(this.options[selectedIndex]);">
		<!-- show all level option only for table. -->
		<% if( ReportViewType.TABLE.equals(context.getViewType())){ %>
			<option value="-1"><bean:message key="ui.options.all.levels" bundle="analytic" /></option>
			<%} %>
				<c:forEach begin="1" end="${ reportContext.baseDimensionLevels }" var="level">
					<c:choose>
						<c:when test="${ level == reportContext.level }">
							<option value="${ level }" selected>${ level -1 }</option>
						</c:when>
						<c:otherwise>
							<option value="${ level }">${ level -1}</option>
						</c:otherwise>
					</c:choose>
				</c:forEach>
			</select>
		</td>
	</tr>
</table>
<% if( ReportViewType.TABLE.equals(context.getViewType())){ %>
<table width="98%">
	<tr>
		<td align="right">
			<b><font face="Verdana" size="2"><bean:message key="ui.search.selectall.across.page.label" bundle="search" arg0="${reportContext.totalRec}"/></font></b>
			<input type="checkbox"  name="checkAllPg" id="checkAllPg"  onclick="checkAllPage(this);">&nbsp;
		</td>
	</tr>
</table>

<table class="tableWithBorderAna" align="center">
	<tr>
		<c:forEach items="${ reportContext.columnLabels }" var="column"	varStatus="columnCount" begin="1">
			<td NOWRAP class="thead" align="center"><a href="#"	onclick="submitFormForSorting('${ columnCount.count + 1 }')"> ${column.displayName } 
				<c:if test="${ (columnCount.count + 1) == reportContext.sortColumn }">
					<c:choose>
						<c:when test="${ 'ASC' == reportContext.sortOrder }">
							<img src="/expensemap/jsp/images/up.gif" border="0">
						</c:when>
						<c:otherwise>
							<img src="/expensemap/jsp/images/down.gif" border="0">					
						</c:otherwise>
					</c:choose></a> 
				</c:if>
			</td>
		</c:forEach>
		<td NOWRAP class="thead" align="center">
			<input type="checkbox" name="checkAll" onClick="checkAllBoxes(this.form);" title="<bean:message key='ui.search.selectall.label' bundle='search'/>">
		</td>
	</tr>
	<c:forEach items="${ reportVO.data }" var="row" varStatus="rowNum">	
		<c:choose>
			<c:when test="${ rowNum.count % 2 == 0 }">
				<tr class="trEven">
			</c:when>
			<c:otherwise>
				<tr class="trOdd">
			</c:otherwise>
		</c:choose>
		<c:forEach items="${ row }" var="column" varStatus="colNum" begin="1">
			<c:choose>
				<c:when test="${colNum.count == 1 }">
					<td align="center">${column -1}</td>
				</c:when>
				<c:otherwise>
					<td align="${ reportContext.columnLabels[colNum.index].type.alignment }"><c:out value="${ column }" /></td>
				</c:otherwise>
			</c:choose>
		</c:forEach>
		<td align="center"><INPUT type="checkbox" name="ids" value="${ row[0] }" id="${ row[0] }" onClick="setUnchecked(this)" /></td>
		</tr>
	</c:forEach>
</table>
<% } else { 
	AnalyticsTrendPreferences pref = (AnalyticsTrendPreferences)request.getAttribute("chartPreferences");
	IlvDefaultDataSource dataSource = (IlvDefaultDataSource)request.getAttribute("dataSource");
	int width = pref.getWidth();
	int height = pref.getHeight();
	StringBuffer imageSrc = new StringBuffer("/expensemap/jsp/analytics/trend/imageGen.jsp?request=image&width=");
	imageSrc.append(width).append("&height=").append(height);
	session.setAttribute("dataSource",dataSource);	
	session.setAttribute("chartPreferences",pref);
%>
<br>
<c:if test="${ ! empty reportVO.chartData }">
<center>
<div id="ImageDiv">  
	<jsp:include page="/analyticsTrendChartServlet" flush="true">  
  		<jsp:param name="request" value="imagemap"/>
  		<jsp:param name="image" value="<%=imageSrc%>"/>
  		<jsp:param name="width" value="<%=width%>"/>
  		<jsp:param name="height" value="<%=height%>"/>
  	</jsp:include>																		
</div>  
<center>
</c:if>	
<% } %>
<br>
<% if( ReportViewType.TABLE.equals(context.getViewType())){ %>
<c:if test="${ ! empty reportVO.data }">
	<table width="98%" align="center">
		<tr align="center">
			<td colspan="3"><jsp:include flush="true" page="../pagination.jsp">
				<jsp:param name="isDataPresent" value="${ ! empty reportVO.data }" />
				<jsp:param name="pageSize" value="${reportContext.pageSize }" />
				<jsp:param name="totalRec" value="${reportContext.totalRec }" />
				<jsp:param name="startRec" value="${reportContext.startRec }" />
				<jsp:param name="limitRec" value="${reportContext.limitRec }" />
				<jsp:param name="maxRecordPerPage"	value="${reportContext.pageSize }" />
			</jsp:include></td>
		</tr>
	</table>	
</c:if> 
<%}else { %>
<c:if test="${ ! empty reportVO.chartData }">
	<table width="98%" align="center">
		<tr align="center">
			<td colspan="3"><jsp:include flush="true" page="../pagination.jsp">
				<jsp:param name="isDataPresent" value="${ ! empty reportVO.chartData }" />
				<jsp:param name="pageSize" value="${reportContext.pageSize }" />
				<jsp:param name="totalRec" value="${reportContext.totalRec }" />
				<jsp:param name="startRec" value="${reportContext.startRec }" />
				<jsp:param name="limitRec" value="${reportContext.limitRec }" />
				<jsp:param name="maxRecordPerPage"	value="${reportContext.pageSize }" />
			</jsp:include></td>
		</tr>
	</table>	
</c:if> 
<%}%>


<br>
<table width="98%" align="center">
	<tr align="center">
		<td colspan="4"><html:button property="backButton" onclick="getReportList();">
			<bean:message key="button.back" bundle="analytic" />
		</html:button></td>
	</tr>
</table>

<input type="hidden" name="sortOrder" 	 		 id="sortOrder" 		   value="${ reportContext.sortOrder }" /> 
<input type="hidden" name="sortColumn" 			 id="sortColumn"		   value="${ reportContext.sortColumn }" />
<input type="hidden" name="reportId" 			 id="reportId" 			   value="${ reportContext.reportId }" /> 
<input type="hidden" name="eriId" 				 id="eriId"  			   value="${ reportContext.eriId }" /> 
<input type="hidden" name="reportType" 			 id="reportType" 		   value="${ reportContext.reportType }" />
<input type="hidden" name="Level" 				 id="Level" 		       value="${ reportContext.level }" /> 
<input type="hidden" name="dimensionName"		 id="dimensionName"		   value="${ reportContext.baseDimension }" />
<input type="hidden" name="viewType" 			 id="viewType" 		       value="${ reportContext.viewType }" />
<input type="hidden" name="UncheckedList" 		 id="UncheckedList"        value="" />
<input type="hidden" name="listSortColumn" 		 id="listSortColumn"       value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortColumn"))%>">
<input type="hidden" name="listSortOrder"  		 id="listSortOrder"        value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listSortOrder"))%>">
<input type="hidden" name="listLimitRec"   		 id="listLimitRec"    	   value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listLimitRec"))%>">
<input type="hidden" name="listStartRec"  		 id="listStartRec"    	   value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listStartRec"))%>">
<input type="hidden" name="listPageSize"   		 id="listPageSize"    	   value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("listPageSize"))%>">
<input type="hidden" name="selectAllAcrossPage"  id="selectAllAcrossPage"  value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("selectAllAcrossPage"))%>">
<input type="hidden" name="numberFormat" value="" />
<input type="hidden" name="reportName" id="reportName"  value='<c:out value="${ reportContext.reportName }" />' />
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
<c:if test="${ DIMENSION_NODE_FILTER_APPLIED == 'true' }">
	<div id="popupMenu"  >		
		<div class='hd'><bean:message key="ui.label.apply.analytic.filters" bundle="analytic" /></div>
		<div class='bd'>
			<input type="checkbox" id="keepCurrentFilters" name="keepCurrentFilters" value="true" />
			<bean:message key="ui.label.keep.current.filters" bundle="analytic" />
		</div>
	</div>
</c:if>
</form>
</body>
</html>