<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%@include file="../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager,com.zeborg.util.EncodeUtil"%>
<%@ page import="com.emptoris.viewer.crosstab.common.CrosstabActionConstants"%>
<%@ page import="com.zeborg.expensemap.view.TableViewUtil"%>
<%@page import="com.emptoris.viewer.ReportViewType"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ include file="../begin_page.jspf"%>

<HTML>
<HEAD>
<style>
.POPTD {
		BORDER: gray 1px outset;
		border-collapse: collapse;
		font-family: Arial, Helvetica, sans-serif;
		font-size: 11px;
		color: 3333CC;
}
.INFOMSGTD {
		BORDER: gray 1px outset;
		border-collapse: collapse;
		font-family: Arial, Helvetica, sans-serif;
		font-size: 13px;
		color: 3333CC;
}
.VIEWBUTTON {
		BORDER: gray 1px outset;
		border-collapse: collapse;
		font-family: Arial, Helvetica, sans-serif;
		font-size: 11px;
		color: 3333CC;
}

.POPTABLE {
		BORDER: gray 1px outset;
		border-collapse: collapse;
}
.dimTitle { font-family:Arial, Helvetica, sans-serif; font-size:13px; color:#003366; }

#mainpage {
	           position: absolute; 
			   top: 30px;
               left:0px;
			}
			
#progressDiv {	overflow-y: auto; overflow-x: auto; padding-top:15px; width:100%; display: none; }
</style>

<%
		String exportType = "CrossTab";  // cannot export an image
		List<String> rowDimDisplayNameList = (List<String>)request.getAttribute(CrosstabActionConstants.RequestParameter.ROW_DIM_DISPLAY_NAME);
		List<String> columnDimDisplayNameList = (List<String>)request.getAttribute(CrosstabActionConstants.RequestParameter.COLUMN_DIM_DISPLAY_NAME);
	    String rowDimDisplayName = (rowDimDisplayNameList.isEmpty())?"":(String)rowDimDisplayNameList.get(0);
	    String columnDimDisplayName = (columnDimDisplayNameList.isEmpty())?"":(String)columnDimDisplayNameList.get(0);
	    String rowDimDisplayName1 = (String)((rowDimDisplayNameList.isEmpty())?"":(rowDimDisplayNameList.size()>1)? rowDimDisplayNameList.get(1):"");
	    String columnDimDisplayName1 = (String)((columnDimDisplayNameList.isEmpty())?"":(columnDimDisplayNameList.size()>1)? columnDimDisplayNameList.get(1):"");
	    String pref = "";
	    String displayType = (String)request.getAttribute(CrosstabActionConstants.RequestParameter.DISPLAY_TYPE);
	    String ctId = (String)request.getAttribute(CrosstabActionConstants.RequestParameter.CROSSTAB_ID);
	    String viewCrossTab = null;
	    long crosstabWaitInterval =   ExpenseMapAppProperties.getCrosstabWaitStateIntervalInSecond();
%>
<STYLE TYPE='text/css'>
.WAIT_PAGE{FONT-WEIGHT:NORMAL; FONT-SIZE:10pt;COLOR:#7B799C; FONT-FAMILY:arial, helvetica, sans;}
.LATER_PAGE{FONT-WEIGHT:NORMAL; FONT-SIZE:14pt;COLOR:#FF0000; FONT-FAMILY:arial, helvetica, sans;}
</STYLE>

<script type="text/javascript"
	src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>

<script language="JavaScript">
//Submit form for refresh.
var timerMessage= false;

function submitFrm() {
	var frm = document.getElementById('createCrosstabForm');
	frm.action = "/expensemap/crosstab/renderCrosstab.do?scale=normal&pWidth="+YAHOO.util.Dom.getViewportWidth()+"&pHeight="+YAHOO.util.Dom.getViewportHeight();
	frm.timerMessage.value=timerMessage;
	frm.startTime.value=startTime;
	frm.submit();
	showProgressBar();
	var obj2 = document.getElementById("mainpage");
	obj2.style.visibility = 'hidden';
	obj2.style.position='relative';
	
	}
	
function onLoad(){
	var frm = document.getElementById('createCrosstabForm');
	var toggleMsg= <%=ESAPI.encoder().encodeForJavaScript(request.getParameter("timerMessage"))!= null ? ESAPI.encoder().encodeForJavaScript(request.getParameter("timerMessage")) : "null"%>
	if(toggleMsg){
		var msgbar = document.getElementById("progressDiv");
		msgbar.style.display = "block";
		var refreshbar = document.getElementById("refreshDiv");
		refreshbar.style.display = "none";
		timerMessage= true;
	}
}
//Show progress bar.
function showProgressBar() {
	var pbar = document.getElementById("waitpage");
	var divHtml = '<table width="100%" height="100%" ><tr><td   class="WAIT_PAGE" align="center" valign="center">';
	divHtml += '<IMG src="/expensemap/jsp/images/clock.gif" alt=""><br>' + "<bean:message bundle='crosstab' key='ui.label.Processing.request'/>" + '<br>';
	divHtml += "<bean:message bundle='crosstab' key='wait'/>" + '</td></tr></table>';
	pbar.innerHTML = divHtml;
	pbar.style.position = "absolute";
	pbar.style.visibility = "visible";
}

<% if (request.getParameter("startTime")!= null){
%>
var startTime =<%=ESAPI.encoder().encodeForJavaScript(request.getParameter("startTime"))%>;
<%} else { %>
var startTime =new Date().getTime();
<% }%>

var timer = setInterval(showTimerInfo, 1000);

function showTimerInfo() {
	var currentTime = new Date().getTime();
	if((currentTime - startTime )/1000 % <%=crosstabWaitInterval%> < 1 ){
		timerMessage= true;
		var msgbar = document.getElementById("progressDiv");
		msgbar.style.display = "block";
		var refreshbar = document.getElementById("refreshDiv");
		refreshbar.style.display = "none";
		submitFrm();
		clearInterval(timer);
	}
}

</script>
</HEAD>
<body topmargin=0 leftmargin=0 onload="onLoad();">

<jsp:include page="../chart/chartToolBar.jsp">
	<jsp:param name="displayType" value="<%=displayType%>" />
	<jsp:param name="ctId" value="<%=ctId%>" />
	<jsp:param name="viewCrossTab" value="<%=viewCrossTab%>" />
	<jsp:param name="ExportType" value="<%=exportType%>" />
	<jsp:param name="columnDimensionName1" value="<%=columnDimDisplayName%>" />
	<jsp:param name="columnDimensionName2" value="<%=columnDimDisplayName1%>" />
	<jsp:param name="rowDimensionName1" value="<%=rowDimDisplayName%>" />
	<jsp:param name="rowDimensionName2" value="<%=rowDimDisplayName1%>" />
</jsp:include>

<html:form action="/saveCrosstab.do" method="post" styleId="createCrosstabForm">
<DIV id="mainpage" style="overflow-y: auto; overflow-x: auto; padding-top:15px; width:100%;">
		<table width="100%" border=0 cellpadding=1 cellspacing=0>
			<tr>
				<td align="right">
					<button onClick="submitFrm()"><bean:message key='ui.label.Refresh' bundle='crosstab' /></button>
				</td>
			</tr>
		</table>

	<table>
		<TR>
			<TD BGCOLOR="#B5B4B4" CLASS="POPTD" NOWRAP><B><bean:message key='ui.label.Name' bundle='crosstab' />:</B></TD>
			<TD CLASS="POPTD" ALIGN="left" NOWRAP><c:out value="<%=TableViewUtil.decode((String)request.getAttribute(CrosstabActionConstants.RequestParameter.CROSSTAB_NAME))%>"/></TD>
		</TR>
		<TR>
			<TD BGCOLOR="#B5B4B4" CLASS="POPTD" NOWRAP><B><bean:message key='ui.label.Row.Dimension' bundle='crosstab' />:</B></TD>
			<TD CLASS="POPTD" ALIGN="left" NOWRAP><%=request.getAttribute(CrosstabActionConstants.RequestParameter.ROW_DIMENSIONS)%></TD>
		</TR>
		<TR>
			<TD BGCOLOR="#B5B4B4" CLASS="POPTD" NOWRAP><B><bean:message key='ui.label.Column.Dimension' bundle='crosstab' />:</B></TD>
			<TD CLASS="POPTD" ALIGN="left" NOWRAP><%=(request.getAttribute(CrosstabActionConstants.RequestParameter.COLUMN_DIMENSIONS)==null || request.getAttribute(CrosstabActionConstants.RequestParameter.COLUMN_DIMENSIONS).equals("null"))?"None":request.getAttribute(CrosstabActionConstants.RequestParameter.COLUMN_DIMENSIONS)%></TD>
		</TR>
	</table>

<DIV id="refreshDiv">
	<table width="70%" border=0 cellpadding=1 cellspacing=0>
		<tr>
			<td align=left CLASS="INFOMSGTD">
				<bean:message key="crosstab.list.checkStatus"  bundle="crosstab" />
			</td>
		</tr>
	</table>
</DIV>	

<table>
	<input type="hidden" id="crosstabid" name="crosstabid" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.CROSSTAB_ID)%>"/>
	<input type="hidden" id="bkid" name="bkid" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.BKID)%>"/>
	<input type="hidden" id="displayType" name="displayType" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.DISPLAY_TYPE)%>"/>
	<input type="hidden" id="viewCrossTab" name="viewCrossTab" value="true"/>
	<input type="hidden" id="newDisplayType" name="newDisplayType" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.NEW_DISPLAY_TYPE)%>"/>

	
	<!-- used for dashboard rendering  -->
	<input type="hidden" id="expensemapFrame" name="expensemapFrame" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.EXPENSEMAP_FRAME)%>"/>
	<input type="hidden" id="panelType" name="panelType" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.PANEL_TYPE)%>"/>
	<input type="hidden" id="dimName" name="dimName" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.DIMENSION_NAME)%>"/>
	<input type="hidden" id="url" name="url" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.URL)%>"/>
	<input type="hidden" id="errorMessage" name="errorMessage" value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.ERROR_MSG)%>"/>
	<input type="hidden" id="timerMessage" name="timerMessage" value="false"/>
	<input type="hidden" id="startTime" name="startTime" value=""/>
</table>

<DIV id="progressDiv">
<table width="70%" border=0 cellpadding=1 cellspacing=0>
		<tr>
			<td align=left CLASS="INFOMSGTD">
				<bean:message key="crosstab.list.status.timer.info"  bundle="crosstab" />
			</td>
		</tr>
	</table>
</DIV>
</Div>
<DIV ID="waitpage"></DIV>
</html:form>
</BODY>
</HTML>
 <%@ include file="../end_page.jspf"%>