<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%@page import="com.emptoris.viewer.ReportViewType"%>
<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.model3.CrossTab, com.emptoris.viewer.util.CSRFHelper" %>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.crosstab.util.CrosstabService" %>
<%@ page import="com.emptoris.viewer.crosstab.common.CrosstabActionConstants"%>
<%@page import="java.util.List" %>
<%@page import="com.emptoris.viewer.chart.CrossTabChartParameters,com.zeborg.chart.DefaultAxialData"%>
 <%@ page import="org.owasp.esapi.ESAPI"%>
 
<% 
	response.setHeader("Pragma", "no-cache");
	response.setHeader("Cache-Control", "no-cache");
	response.setDateHeader ("Expires", -1); 
%>
<html>
<head>
<STYLE TYPE="text/css">
<!--
form { margin: 0px; padding: 0px; }
.dimTitle { font-family:Arial, Helvetica, sans-serif; font-size:13px; color:#003366; }
#waitpage { position: absolute; }
#mainpage { position: absolute; visibility: hidden; left:0px;}
.WAIT_PAGE{FONT-WEIGHT:NORMAL; FONT-SIZE:10pt;COLOR:#7B799C; FONT-FAMILY:arial, helvetica, sans;}
.LATER_PAGE{FONT-WEIGHT:NORMAL; FONT-SIZE:14pt;COLOR:#FF0000; FONT-FAMILY:arial, helvetica, sans;}
.POPTD {
		BORDER: gray 1px outset;
		border-collapse: collapse;
		font-family: Arial, Helvetica, sans-serif;
		font-size: 11px;
		color: 3333CC;
-->
</STYLE>

<%
String bkid = request.getParameter("bkid");
ZSession zs = ZSessionUtil.getFromSession(pageContext);
CrossTab crsstab = CrosstabService.getInstance().findCrosstabFromBookmarkAndUser(bkid,zs.getUser());
%>

<SCRIPT type="text/javascript">
function toggleGraphType(newType){
	document.getElementById("newDisplayType").value = newType;
	var frm = document.getElementById("chartForm");
	frm.action = "/expensemap/crosstab/renderCrosstab.do?bkid=<%=ESAPI.encoder().encodeForJavaScript(bkid)%>";
	frm.submit();
}

function changeGraphType(){
	window.open("/expensemap/crosstab/getPreferences.do?bkid=<%=ESAPI.encoder().encodeForJavaScript(bkid)%>", "Chart_Preferences", "width=650,height=300,left=350,top=250,scrollbars=no,status=yes,resizable=no");
}

function doResize() {
    if ( document.getElementById('mainpage') != null ) {
      resizeDIV('mainpage', 23);
      resizeDIVwidth('mainpage', 23);
      window.onresize = doResize;
    }
}

function init() {	
    var waitPage = document.getElementById("waitpage");
    var mainPage = document.getElementById("mainpage");
	
    waitPage.style.visibility="hidden";
    mainPage.style.visibility="visible";
}

function reDrawChart(){
	var frm = document.getElementById("chartForm");
	frm.action = "/expensemap/crosstab/renderCrosstab.do?bkid=<%=ESAPI.encoder().encodeForJavaScript(bkid)%>";
	frm.submit();
	
}

function printPreviewChart(bkid){
	var ht = 600;
	var wt = 800;
	var left = (screen.width/2)-(wt/2);
	var top = (screen.height/2)-(ht/2);
	window.open("/expensemap/jsp/crosstab/printPreviewChart.jsp?bkid=<%=ESAPI.encoder().encodeForJavaScript(bkid)%>&AuthCode="+encodeURIComponent("<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>"), "Chart_PrintPreview", "width="+wt+",height="+ht+",left="+left+",top="+top+",menubar=yes,scrollbars=yes,status=yes,resizable=yes");
}
								
</SCRIPT>
</head>
<%
	int wMargin = 20;
	int hMargin = 55;
	int width = crsstab.getBookmark().getEmChartState().getChartSize().getChartWidth();
	int height = crsstab.getBookmark().getEmChartState().getChartSize().getChartHeight();
	
	int cWidth=width-wMargin;
	int cHeight=height-hMargin;
	
	String ctabId =crsstab.getCrossTabId();
	String imageSrc = "/expensemap/jsp/chart/imggen.jsp?request=image&width="+cWidth+"&height="+cHeight;

	String exportType = "CrossTab";  // cannot export an image
	List<String> rowDimDisplayNameList = (List<String>)request.getAttribute(CrosstabActionConstants.RequestParameter.ROW_DIM_DISPLAY_NAME);
	List<String> columnDimDisplayNameList = (List<String>)request.getAttribute(CrosstabActionConstants.RequestParameter.COLUMN_DIM_DISPLAY_NAME);
	String rowDimDisplayName = (String)((rowDimDisplayNameList.isEmpty())?"none":rowDimDisplayNameList.get(0));
    String columnDimDisplayName = (String)((columnDimDisplayNameList.isEmpty())?"none":columnDimDisplayNameList.get(0));
    String rowDimDisplayName1 = (String)((rowDimDisplayNameList.size()<2)?"none":rowDimDisplayNameList.get(1));
    String columnDimDisplayName1 = (String)((columnDimDisplayNameList.size()<2)?"none":columnDimDisplayNameList.get(1));

    String pref = "";
    String displayType = (String)request.getAttribute(CrosstabActionConstants.RequestParameter.DISPLAY_TYPE);
    String viewCrossTab = "true";    
    session.setAttribute("chartData"+ctabId ,request.getAttribute("chartData"+ctabId));
    
    CrossTabChartParameters crossTabChartParameters = new CrossTabChartParameters();
    DefaultAxialData chartData = (DefaultAxialData)request.getAttribute("chartData"+ctabId);
    crossTabChartParameters.setChartData(chartData);
    crossTabChartParameters.setTopReport(false);
	crossTabChartParameters.setBookmarkId(bkid);
	crossTabChartParameters.setCrosstabId(ctabId);
	
	session.setAttribute("crossTabChartParameters", crossTabChartParameters);
%>

<jsp:include page="../chart/chartToolBar.jsp">
	<jsp:param name="displayType" value="<%=displayType%>" />
	<jsp:param name="ctId" value="<%=ctabId%>" />
	<jsp:param name="bkid" value="<%=bkid%>" />
	<jsp:param name="viewCrossTab" value="<%=viewCrossTab%>" />
	<jsp:param name="ExportType" value="<%=exportType%>" />
	<jsp:param name="columnDimensionName1" value="<%=columnDimDisplayName%>" />
	<jsp:param name="columnDimensionName2" value="<%=columnDimDisplayName1%>" />
	<jsp:param name="rowDimensionName1" value="<%=rowDimDisplayName%>" />
	<jsp:param name="rowDimensionName2" value="<%=rowDimDisplayName1%>" />
</jsp:include>

<SCRIPT type="text/javascript">
    var exportSpan = document.getElementById("exportSpan");
    if ( exportSpan != null ) {
        exportSpan.style.display = "inline";
    }
</SCRIPT>
<form id="chartForm" style="padding-top:22px">
<BODY LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="init();" class="yui-skin-sam">
<DIV ID="waitpage" style="width:100%; text-align:center;">
    <BR><BR>
	<table width="100%" height="100%" >
		<tr>
			<td   class="WAIT_PAGE" align="center" valign="center">
            
				<IMG src="/expensemap/jsp/images/clock.gif" title=''>
            
					<br>
						<bean:message key='ui.label.Processing.request' bundle='crosstab'/><br>
						<bean:message key='wait' bundle='crosstab'/>
			</td>
		</tr>
	</table>
  </DIV>
  
<DIV ID="mainpage" style="overflow-x: auto; overflow-y: hidden;">
<table>
	<TR>
		<TD BGCOLOR="#B5B4B4" CLASS="POPTD" NOWRAP><B><bean:message key='ui.label.Name' bundle='crosstab' />:</B></TD>
		<TD CLASS="POPTD" ALIGN="left" NOWRAP><c:out value="<%=request.getAttribute(CrosstabActionConstants.RequestParameter.CROSSTAB_NAME)%>"/></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#B5B4B4" CLASS="POPTD" NOWRAP><B><bean:message key='ui.label.Row.Dimension' bundle='crosstab' />:</B></TD>
		<TD CLASS="POPTD" ALIGN="left" NOWRAP><%=request.getAttribute(CrosstabActionConstants.RequestParameter.ROW_DIMENSIONS)%></TD>
	</TR>
	<TR>
		<TD BGCOLOR="#B5B4B4" CLASS="POPTD" NOWRAP><B><bean:message key='ui.label.Column.Dimension' bundle='crosstab' />:</B></TD>
		<TD CLASS="POPTD" ALIGN="left" NOWRAP><%=(request.getAttribute(CrosstabActionConstants.RequestParameter.COLUMN_DIMENSIONS)==null || request.getAttribute(CrosstabActionConstants.RequestParameter.COLUMN_DIMENSIONS).equals("null"))?"None":request.getAttribute(CrosstabActionConstants.RequestParameter.COLUMN_DIMENSIONS)%></TD>
	</TR>
</table>
<div id="crossTabImageDiv">
	<jsp:include page="/crossTabChartServlet" flush="true">
		<jsp:param name="request" value="imagemap"/>
		<jsp:param name="width" value="<%=cWidth%>"/>
		<jsp:param name="height" value="<%=cHeight%>"/>
		<jsp:param name="image" value="<%=imageSrc%>"/>
	</jsp:include>
</div>
</DIV>
<div id="hiddenDiv" style="visibility:hidden">
<input type="button" id="hiddenButton" onclick="reDrawChart();">
</div>

<input type="hidden" id="bkid" name="bkid" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter(CrosstabActionConstants.RequestParameter.BKID))%>">
<input type="hidden" id="newDisplayType" name="newDisplayType" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter(CrosstabActionConstants.RequestParameter.NEW_DISPLAY_TYPE))%>">
</body>
</form>
</html>