<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import ="com.zeborg.expensemap.view2.*,com.zeborg.expensemap.view.*"%>
<%@ page import="com.zeborg.util.*"
%><%@ page import="com.zeborg.expensemap.view.*,com.zeborg.expensemap.web.*,com.zeborg.expensemap.view2.*"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle,com.zeborg.expensemap.il8n.EmLocalizationManager,com.zeborg.expensemap.util.ExpenseMapAppProperties,com.zeborg.expensemap.util.HelpLocaleUtil"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="java.util.*"%>
<%@ page import="org.owasp.esapi.ESAPI"%>

<%
	ZSession zs = ZSessionUtil.getFromSession(pageContext); 
	String helpURL = com.zeborg.expensemap.view.HelpUtil.getHelpUtil().getHelpURLString("ui.crosstab.search.help.page", zs.getUser().getLocale());
 
%>
<html:html>
<head>
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.crosstab.listing.searchWindow.title" bundle="crosstab"  /></title>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/calendar/assets/skins/sam/calendar.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/analytics/scripts/analyticscss.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/fonts/fonts.css" />

<style>
.yui-skin-sam .yui-panel {
position: absolute;
}

.yui-skin-sam .yui-calcontainer{
font-family: Arial, Helvetica, sans-serif;
font: 100%;
	width:160px;
	width:180px !ie;
}

.yui-skin-sam .yui-panel .bd {
	display:block;
	overflow:hidden;	
	width:180px;
	width:200px !ie;
}
.yui-skin-sam .yui-calcontainer .yui-cal-nav{
	margin-left:-6em;
	width:13em;
}

</style>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/calendar/calendar-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource.js"></script>	
<script type="text/javascript" src="/expensemap/scripts/popup-cal.js"></script>
<script type="text/javascript" src="/expensemap/scripts/localeData.js"></script>

<script language="JavaScript">
function submitForm() {
	var theForm = document.getElementById('crosstabSearchForm');
	theForm.action = "/expensemap/crosstab/applySearchOptions.do";
	theForm.submit();
}

function init(){
	document.getElementById('crosstabName').focus();
} 


function openHelp(){
	open( "<%=helpURL%>", "_blank" );	
}
</script>
</head>
<body class="yui-skin-sam" leftmargin=2 topmargin=2 marginwidth=1 marginheight=1 onload="init();">
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<html:form method="post" styleId="crosstabSearchForm" action="applySearchOptions.do" style="margin-top: 19px;">
<!-- error msg for date  -->
<logic:messagesPresent message="true">
<center>
<font color="red" face="Verdana" size="2"><b>
<html:messages id="msg" message="true" bundle="analytic"> 
        <%=pageContext.findAttribute("msg")%>
</html:messages>
</center>
</font>
</logic:messagesPresent>

<table class="InnerTableWithBorder" align="center" style="width:94%">
	<tr>
		<td class="reportTitle" align="left"><bean:message key="ui.crosstab.listing.search.reporttitle" bundle='crosstab'  /></td>
	<td align="right"><a href="#" onclick="openHelp();"><img  src="/expensemap/jsp/images/help.gif" border="0" title="<bean:message  key='ui.label.Help' bundle='analytic'/>"/></a></td>
	</tr>
	<tr><td colspan="2"><hr noshade size="1"></td></tr>
	<tr>
		<td align="right"><bean:message key="ui.crosstab.search.name"  bundle="crosstab" /></td>
		<td align="left"><html:text property="crosstabName" size="15" styleId="crosstabName" styleClass="inputStyle" maxlength="20"/></td>	
	</tr>
	
	<tr>
		<td align="right"><bean:message key="rpt.listing.search.fromDate" bundle="analytic" /></td>
		<td align="left"><html:text property="fromDate" size="15" styleId = "fromDate" styleClass="inputStyle" maxlength="10"/>
	    </td>
	</tr>
	<tr>
		<td align="right"><bean:message key="rpt.listing.search.toDate"  bundle="analytic" /></td>
		<td align="left"><html:text property="toDate" size="15" styleId = "toDate" styleClass="inputStyle" maxlength="10"/>
	    </td>
	</tr>	
	<TR>
			<TD align="right"><bean:message key="ui.label.Status" bundle="analytic" /></TD>
			<TD>
			<table width="100%" border="0" cellpadding="0" cellspacing="0" >
				<c:forEach begin="0" end="${ crosstabSearchForm.measureRows }" var="rowCount" >
					<tr>
						<c:forEach begin="0" end="2" var="colCount" varStatus="colStatus"  >
							<td align="left"><font size="1">
								<c:set var="itemIndex" value="${ (rowCount*3) + (colCount) }"/>
								<c:set scope="page" var="displayStatus" value="${ crosstabSearchForm.displayStatuses[itemIndex] }" />
								<c:if test="${ ! empty displayStatus }">
									<bean:define id="bean" name="displayStatus" scope="page" type="org.apache.struts.util.LabelValueBean" />
									<!-- create the checkbox and selected attribute -->
									<html:multibox  property="selectedStatuses" >
										<bean:write name="bean" property="value"/>
									</html:multibox>
									<!-- create the label, note that "br" tag will format it vertically -->
									<bean:write name="bean" property="label"/>
								</c:if></font>
							</td>
						</c:forEach>
					</tr>
				</c:forEach>
				</tr>
			</table>
			</TD>
	</TR>
	<tr><td colspan="2"><hr noshade size="1"></td></tr> 
	<tr><td colspan="2" align="center">
			<input type="button" name="submitBtn" onclick="return submitForm();" value='<bean:message key="button.apply"  bundle="analytic" />' />&nbsp;
			<input type="button" name="cancel" onclick="window.close();" value='<bean:message key="ui.label.Cancel"  bundle="analytic" />' />
		</td>
	</tr>
	
</table>
<!--  Added hidden fields WRT PR# 40624 -->
<input type="hidden" name="crossTabSortColumn" id="crossTabSortColumn" value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("crossTabSortColumn"))%>">
<input type="hidden" name="crossTabSortOrder"    id="crossTabSortOrder"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("crossTabSortOrder"))%>">
<input type="hidden" name="limitRec"    id="limitRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("limitRec"))%>">
<input type="hidden" name="startRec"  id="startRec"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("startRec"))%>">
<input type="hidden" name="pageSize"  id="pageSize"    value="<%=ESAPI.encoder().encodeForHTML(request.getParameter("pageSize"))%>">

</html:form>
<script language="JavaScript">
YAHOO.namespace('emptoris.analytics.search.UI');
(function() {
	var Event = YAHOO.util.Event;
	var Dom = YAHOO.util.Dom;
	YAHOO.emptoris.analytics.search.UI = {
		init: function() {
			var self = YAHOO.emptoris.analytics.search.UI;
			var fromDateField = document.getElementById("fromDate");
			var toDateField = document.getElementById("toDate");
			Event.on(fromDateField, "focus", self.openCalendar, [fromDateField, fromDateField]);
			Event.on(toDateField, "focus", self.openCalendar, [toDateField, toDateField]);
		},

		openCalendar: function(e, args) {	
    		YAHOO.emptoris.widget.PopupCalendar.openCalendar(args, '${languageLocale}','${dateFormatPattern}'); 
		}
	}

	Event.onDOMReady(YAHOO.emptoris.analytics.search.UI.init, YAHOO.emptoris.analytics.search.UI, true);
})();</script>
</body>
</html:html>