<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page language="java" contentType="text/html; charset=UTF-8"  pageEncoding="UTF-8"%>
<%@page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>

<html>
<head>
<script type="text/javascript">
	
	function submitForm(){		
		if(isSelected()){				
			document.getElementById("checkCubeJobs").submit();
		}			
	}
	
	function isSelected(){		
		var selectedDimensions = document.getElementsByName("selectedDimensions");
		if(null==selectedDimensions){
			return false;
		}
		var noOfRows = selectedDimensions.length;
	    if (selectedDimensions[0]) { // if the checkbox group is an array (one check box is not an array)
			for (var i = 0; i < noOfRows; i++) {
				if (selectedDimensions[i].checked == true) {
						return true;
				}
			}
		}else { // There is only one check box (it's not an array)
			if (selectedDimensions.checked) { // if the one check box is checked
				 return true;
			  }				  
		}
		alert("<bean:message key='ui.cube.msg.select.atleast.one.dimension' bundle='sdmMessages'/>");
		return false;
	}
</script>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="cube.job.data.integrity.check.title" bundle="sdmMessages"/></title>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/scripts/sdm.css">
</head>
<body>
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
<logic:messagesPresent message="true">
	<font color="red" face="Arial, Helvetica, sans-serif" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="sdmMessages">
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
</logic:messagesPresent>

<form name="checkCubeJobs" id="checkCubeJobs" method="post" action="/expensemap/datamanager/CheckCubeJobsAction.do?method=submitDataIntegrityJob" >

	<table class="InnerTableWithBorder"  cellSpacing="0" align="center" cellPadding="0"  border="0">
		<tr>
			<td class=POPFORMTITLE ><bean:message key="cube.job.data.integrity.check.title" bundle="sdmMessages"/></td>
			<td class=POPFORMTITLE style="TEXT-ALIGN: right;"><img src="/expensemap/jsp/images/help.gif" border="0" title="Help" style="cursor: pointer"></td>
		</tr>
		<tr>
		   <td class="POPFORMRULE" colSpan="5" height="1"> </td>
		</tr>
		<tr>
			<td class="POPFORMLABEL" width="50%"><bean:message key="cube.job.select.dimension" bundle="sdmMessages"/></td>
			<td class="POPFORMFIELD" ><logic:iterate name="availableDimensionList" type="org.apache.struts.util.LabelValueBean" id="currentDimension" indexId="ctr">
				&nbsp;&nbsp;<html:multibox name="checkCubeJobs" property="selectedDimensions" styleId="selectedDimensions" value="${currentDimension.value}"/>
				<bean:write name="currentDimension" property="value" filter="false" /><br></logic:iterate></td>
		</tr>
		<tr>
		    <td class="POPFORMRULE" colSpan="5" height="1"></td>
		</tr>
	    <tr>
           <td  colSpan="5" align="center" class="buttonStyle">&nbsp;</td>
        </tr>
		<tr>
			<td colspan="2" align="center" class="buttonStyle">
				<html:button property="submitBtn" onclick="submitForm();"><bean:message key="ui.cube.job.submit.button" bundle="sdmMessages"/></html:button>&nbsp;
				<html:button property="cancel" onclick="window.close();"><bean:message key="ui.import.cancle.button" bundle="sdmMessages"/></html:button>
			</td>
		</tr>
	    <tr>
           <td  colSpan="5" align="center" class="buttonStyle">&nbsp;</td>
        </tr>
</table>
<form>
</body>
</html>