<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/css/dataenrichmentui.css">

<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/dataenrichment.js"></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC="/expensemap/jsp/javascript/FormChangeValidation.js"></SCRIPT>
<script type="text/javascript">
	//Assigns the MatchIgnoreCase function as an equalsIgnoreCase method of the String object
	String.prototype.equalsIgnoreCase=MatchIgnoreCase;

	// This function will match String with ignoring case
	function MatchIgnoreCase(strTerm){
		var strToSearch = this.toLowerCase();
		strTerm = strTerm.toLowerCase();
		if(strToSearch==strTerm){
			return true;
		}else
		{
			return false;
		}
	} //End Function

	// A call back method to validate form data
	function validateFormFields(targetWindow,actionValue){			
		document.factTableDefinitionForm.formChanged.value = formChanged(document.factTableDefinitionForm);
		<c:if test="${not sessionScope.isCubeProcessed}">
			if(validateDescription() && validateFactFile() && validateFactFileType()){
				document.factTableDefinitionForm.operation.value = actionValue;
				document.factTableDefinitionForm.target = "_self";
				document.factTableDefinitionForm.submit();
			}		
		</c:if>
		<c:if test="${sessionScope.isCubeProcessed}">
			document.factTableDefinitionForm.operation.value = actionValue;
			document.factTableDefinitionForm.target = "_self";
			document.factTableDefinitionForm.submit();
		</c:if>
		return false;		
	}

	// To validate size of Description 
	function validateDescription(){
		var descriptionObj = factTableDefinitionForm.description;

		if(descriptionObj.value.length > 255){
			alert("<bean:message key='ui.fact.description.maximum.size.validation' bundle='sdmMessages'/>" );
			return false;
		}
		return true;			
	}

	// Validates the file extensions
	function validateFileExtension(fileNameObj){
		var fileExtn = '';
        var dotIndex = fileNameObj.value.lastIndexOf('.');
        if(dotIndex != -1){
            fileExtn = fileNameObj.value.substr(dotIndex+1);
        }
		if(!(fileExtn.equalsIgnoreCase('csv') || fileExtn.equalsIgnoreCase('txt'))){
			alert("<bean:message key='ui.fact.file.invalid.extension' bundle='sdmMessages'/>" );
			return false;
		}
		return true;
	}

	// To validate fact file is selected
	function validateFactFile(){
		var fileNameObj = factTableDefinitionForm.fileName;
		return validateRequired(fileNameObj, "<bean:message key='ui.fact.file.required' bundle='sdmMessages' />" ) && validateFileExtension(fileNameObj);	
	}

	// To validate file type is selected
	function validateFactFileType(){
		var fileTypeObj = factTableDefinitionForm.fileType;
		return validateRequired(fileTypeObj, "<bean:message key='ui.fact.file.type.required' bundle='sdmMessages' />" );
	}

		
</script>

<html:form styleId="factTableDefinitionForm" target="_top" action="/FactTableDefinitionAction.do" method="post">
<table align="center" class="POPFORMBODY" cellSpacing="0" cellPadding="0" width="80%" border="0">
	<tr>
		<td>
			<table class="POPFORMBORDER" cellSpacing="1" cellPadding="0" width="100%" border="0">
				<tr class="POPFORMBODY">
					<td>					
						<table class="POPFORMBODY" cellSpacing="0" cellPadding="0" width="100%" border="0">
							<logic:messagesPresent message="true">
								<TR>
									<TD colspan="2" CLASS="POPFORMTITLE" STYLE="padding-left:5px">
										<FONT COLOR="red" FACE="Arial, Helvetica, sans-serif" SIZE="2">
											<b><html:messages id="msg" message="true" bundle="sdmMessages">
												&nbsp;&nbsp;&nbsp;<%=pageContext.findAttribute("msg")%>
											</html:messages></b>
										</FONT>
									</TD>
								</TR>
							</logic:messagesPresent>
							<tr>
								<td class="POPFORMLABEL" STYLE="padding-right:5px" width="50%">
									<div class="DIVLABELSTYLE">
										<bean:message key="ui.fact.description" bundle="sdmMessages" />
									</div>
								</td>
								<c:if test="${not sessionScope.isCubeProcessed}">
									<td class="POPFORMFIELD" STYLE="padding-left:5px" height="170px">
										<html:textarea styleId="description" property="description" rows="9" cols="30" />
									</td>
								</c:if>
								<c:if test="${sessionScope.isCubeProcessed}">
									<td class="POPFORMFIELD" STYLE="padding-left:5px" height="25px">
										<bean:write name="factTableDefinitionForm" property="description"/>
									</td>
								</c:if>								
							</tr>

							<tr>
								<td colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></td>
							</tr>
							<tr>
								<td class="POPFORMLABEL" STYLE="padding-right:5px" height="25px"><div class="DIVLABELSTYLE"><bean:message key="ui.fact.choose.file" bundle="sdmMessages" /><span class="requiredFields">*</span></div></td>
								<td class="POPFORMFIELD" STYLE="padding-left:5px">
									<html:select styleId="fileName" property="fileName" >
										<html:options collection="filesList" property="value" labelProperty="label" />
									</html:select>
								</td>
							</tr>

							<tr>
								<td colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></td>
							</tr>
							<tr>
								<td class="POPFORMLABEL" STYLE="padding-right:5px" height="25px"><div class="DIVLABELSTYLE"><bean:message key="ui.fact.file.type" bundle="sdmMessages" /><span class="requiredFields">*</span></div></td>
								<td class="POPFORMFIELD" STYLE="padding-left:5px">
									<c:if test="${not sessionScope.isCubeProcessed}">
										<html:select styleId="fileType" property="fileType" >
											<html:options collection="fileTypes" property="value" labelProperty="label" />
										</html:select>
									</c:if>
									<c:if test="${sessionScope.isCubeProcessed}">
										<bean:write name="factTableDefinitionForm" property="fileType"/>
									</c:if>
								</td>
							</tr>
							<tr>
								<td colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></td>
							</tr>
							<tr>
								<td class="POPFORMLABEL" STYLE="padding-right:5px" width="50%">
									<div class="DIVLABELSTYLE">
										<bean:message key="ui.lable.fact.optimize" bundle="sdmMessages" />
									</div>
								</td>
								<td class="POPFORMFIELD" STYLE="padding-left:5px" height="25px">
									<html:checkbox property="optimizeFactColumnLength" styleId="optimizeFactColumnLength" />
								</td>
							</tr>
							<tr>
								<td colspan="2" height="0.1px" class="POPFORMRULE"><img border='0' src='/expensemap/jsp/images/sdm/1x1_trans.gif' width='100%' height='1' ></td>
							</tr>
						</table>						
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td>
			<table>
				<tr>
					<td>
						<div class="POPFORMINSTRUCTIONS"><br><span class="requiredFields">*</span><bean:message key="ui.import.required.fields" bundle="sdmMessages" /></div>
					</td>
				</tr>
				<tr>
					<td>
						<p class="DIRECTIONS">
							<img src="/expensemap/jsp/images/happy_help_icon.gif" border="0" width="11" height="13">&nbsp;&nbsp;&nbsp;<bean:message key="ui.fact.table.information.help" bundle="sdmMessages" />
						</p>			    
					</td>
				</tr>
			</table>
		</td>
	</tr>
</table>
<input type="hidden" id="operation" name="operation" value="save"/>
<input type="hidden" id="formChanged" name="formChanged" value="false"/>
<html:hidden property="stepId" styleId="stepId"/>
<input type="hidden" name="stepLink" id="stepLink" value="<c:out value='${currentStep.loadStepLink}'/>"/>
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</html:form>