<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties" %>
<%@page import="com.zeborg.expensemap.il8n.EmResourceBundle"%>
<%@page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@page import="com.zeborg.expensemap.view.*, com.emptoris.viewer.util.CSRFHelper"%>
<%@page import="com.zeborg.acl.util.ACManager"%>
<%@page import="com.zeborg.expensemap.model3.DataSet"%>
<%@page import="java.util.Locale" %>
<%@page import="com.emptoris.viewer.dashboards.common.util.DashboardConstants"%>
<%@ page import="com.zeborg.expensemap.model3.ExpensemapACLUtil"%>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ include file="header.jsp" %>
<html:html>
<%String helpKey="default";%>
<c:choose>
	<c:when test="${ empty dashboardId }">
	<%helpKey=DashboardConstants.CREATE_DASHBOARD_PAGE_HELP_URL; %>
		<TITLE><%=ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.button.label.Create.Dashboard"  bundle="dashboard" /></TITLE>
	</c:when>
	<c:otherwise>
	<% helpKey=DashboardConstants.EDIT_DASHBOARD_PAGE_HELP_URL;%>
		<TITLE><%=ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.label.Edit.Dashboard"  bundle="dashboard" /></TITLE>
	</c:otherwise>
</c:choose>

<html:javascript formName="createDashboardForm" />
<head>
<!-- for adding scrollbar in autocomplete result container  -->
<style type="text/css">
#bookMarkContainer .yui-ac-content,#crossTabContainer .yui-ac-content,#reportContainer .yui-ac-content,
#analyticsContainer .yui-ac-content{border:1px solid  #404040;background:#fff;position: absolute; top: 17px; }
#bookMarkContainer .yui-ac-content,#crossTabContainer .yui-ac-content,#reportContainer .yui-ac-content,
#analyticsContainer .yui-ac-content { max-height:16em;overflow:auto;overflow-x:auto; _height:14em;  width:99%}
.yui-skin-sam .yui-ac-content .yui-ac-highlight { color: black !important; }
</style>

<%
	Locale locale =zs.getUser().getLocale();
	EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE,locale );
	
    //make the help  page url    
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = emHelp.getHelpURLString(helpKey, locale);	
%>


<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/reset/reset.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/autocomplete/assets/skins/sam/autocomplete.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/button/assets/skins/sam/button.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/yui-container-override.css" />
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/createNewDashboard.css" />
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardPanel.css" />
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css" />

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/animation/animation-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/utilities/utilities.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>

<body class="yui-skin-sam" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" 
 onload="javascript:init(); javascript:preCreatePanels();">

<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/datasource/datasource-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/autocomplete/autocomplete-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/stringbuffer.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>
<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="createDashboardForm"/>
	<jsp:param name="isDashboardCreatePage" value="true"/>
	<jsp:param name="helpUrl" value="<%=helpURL%>"/>
</jsp:include>

<script type="text/javascript">

function showAllDashboards(){
	var frm = document.getElementById("createDashboardForm");
	frm.action = "/expensemap/showDashboardPage.xhtm";
	frm.method = "post";
	frm.submit();

}


//save dashboard
function saveDashboard() {
	var frm = document.getElementById("createDashboardForm");
	var cancelSave = false ;
	var empty = true;
	for ( var keys in panelElementArray ) {
		empty = false;
	}
	if ( empty ) {
		var msg = "<bean:message key="ui.dashboard.create.page.layout.panels.contains.required" bundle="dashboard"/>";
		alert(msg);
		return false;
	}
	
	if ( validateCreateDashboardForm(frm) ) {
		var maxPanelIndex = 0;
		for ( var keys in panelElementArray ) {
			var panelType = panelElementArray[keys].split('|');
			if(panelType[0]=="External" && ! validateUrl(document.getElementById(keys+'_url'))){
				cancelSave = true;
				break;
			}
			var panelName = '';
			var txt = document.getElementById(keys+'_name');
			if(txt){
				panelName = YAHOO.lang.trim(txt.value);
			}
			if(!panelName){
				var errmsg = "<bean:message key='ui.dashboard.create.page.panel.name.required'  bundle='dashboard'/>";
				alert(errmsg);
				txt.focus();
				return false;
			}
			else if (panelName.length>50){
				var arg0="<bean:message key='ui.dashboard.create.page.panel.name'  bundle='dashboard'/>";				
				var errmsg = "<bean:message key='errors.maxlength' arg0='' arg1='50' bundle='dashboard'/>";
				alert(arg0+errmsg);
				txt.focus();
				return false;
			}
			createHiddenFieldsForPanelMetadata(keys, panelName, frm);
			var panelIndex = parseInt(keys.replace("objPanel",""));
			maxPanelIndex = (panelIndex > maxPanelIndex) ? panelIndex : maxPanelIndex;
		}
	
		if(cancelSave) return false;

		if ( document.getElementById('dashBoardName').value !=
			document.getElementById('originalDBName').value ) {
			if ( checkForDuplicateName( document.getElementById('dashBoardName').value ) ) {
				var msg = "<bean:message key='ui.msg.duplicate.name'  bundle='dashboard'/>";
				alert(msg);
				document.getElementById('dashBoardName').focus();
				return false;
			}
		}
		// create a new hidden field to store max panel index. It will help us
		// to parse parameters on server side.
		var maxPanelIndexField = document.createElement('input');
		maxPanelIndexField.setAttribute("name",  "max_panel_index");
		maxPanelIndexField.setAttribute("value", maxPanelIndex);
		maxPanelIndexField.setAttribute("type", "hidden");
		frm.appendChild(maxPanelIndexField);
		
		/* Due to customization overlay changes, the default panel Y position has to be sent from client to server.
		 * This value will override default preferences if required and new panel Y position will be calculated accordingly.
		 * 60px is the Y offset for first panel Y position in normal case (no customization applied) from menubar position.
		 * XXX: This value should be in sync with renderDashboard.jsp function snapToGrid -> panelMinYVal
		 */
		jQuery("#panelMinYVal").val(parseInt(jQuery("#topMenu").offset().top + jQuery("#topMenu").height()) + 60);
		
		frm.action = "/expensemap/dashboards/saveDashBoardAction.do";
		frm.method = "post";

		frm.submit();
	}else{
		return false;
	}
}

function checkForDuplicateName(dashboardName) {
	try {
		var url = "/expensemap/dashboards/CheckDuplicateDashboardName.do";
		var ajaxResponse = jQuery.ajax({
			url: url,
			type: "POST",
			data: {
				dashboardName: dashboardName,
				dashboardId: document.getElementById("dashboardId").value
			},
			async: false
		}).responseText;
		
		return processDuplicateNameValidation(ajaxResponse);
	} catch(e) {
		 alert(e);
	}
}

function processDuplicateNameValidation(ajaxResponse) {
	var data = eval(ajaxResponse);
	// check if session is still active.
	if ( checkIfSessionActive(data) == false ) {
		return;
	}
	if ( data[1] == 'true' ) {
		return true;
	}
	return false;
}

// Checks if session is still active.
function checkIfSessionActive(data) {
	if (data[0] == "Error"){
		var errorCode = data[1];
		if(errorCode == "session.timeout") {
			var timeoutURL = data[3];
			//for intg environment the location should be expensemap frame
			parent.location.href=timeoutURL;
			return false;
		}
	}
	return true;
}

function createHiddenFieldsForPanelMetadata(panelKey, panelName, frm) {
	// create a hidden field to store name of the panel corresponding to panelKey.
	var panelNameField = document.createElement('input');
	panelNameField.setAttribute("name", panelKey + "_name");
	panelNameField.setAttribute("value", panelName);
	panelNameField.setAttribute("type", "hidden");
	frm.appendChild(panelNameField);
	// create a hidden field to store content type of the panel corresponding to panelKey.
	// For each panel we have an entry in the global map. The entry stores three elements
	// separated by | viz panel type | panel source id (eg. bookmark id) | panel content id (eg. dimension meta id)
	var panelContent = panelElementArray[panelKey].split('|');

	var panelTypeField = document.createElement('input');
	panelTypeField.setAttribute("name", panelKey + "_panel_type");
	panelTypeField.setAttribute("value", panelContent[0]);
	panelTypeField.setAttribute("type", "hidden");
	frm.appendChild(panelTypeField);

	var panelSourceField = document.createElement('input');
	panelSourceField.setAttribute("name", panelKey + "_panel_source");
	panelSourceField.setAttribute("value", panelContent[1]);
	panelSourceField.setAttribute("type", "hidden");
	frm.appendChild(panelSourceField);

	var panelContentField = document.createElement('input');
	if(panelContent[0]=="External"){
		panelContentField.setAttribute("name", panelKey + "_panel_content");				
		panelContentField.setAttribute("value", YAHOO.lang.trim(document.getElementById(panelKey+"_url").value));
		panelContentField.setAttribute("type", "hidden");
		frm.appendChild(panelContentField);		
	}else{		
		panelContentField.setAttribute("name", panelKey + "_panel_content");
		panelContentField.setAttribute("value", panelContent[2]);
		panelContentField.setAttribute("type", "hidden");
		frm.appendChild(panelContentField);
	}
	
	if ( panelContent.length == 4 ) {
		var panelIdField = document.createElement('input');
		panelIdField.setAttribute("name", panelKey + "_panel_id");
		panelIdField.setAttribute("value", panelContent[3]);
		panelIdField.setAttribute("type", "hidden");
		frm.appendChild(panelIdField);
	}
}

/*menu bar code ends*/

/*accordion panel code starts*/

var ContentHeight = 255;
var TimeToSlide = 250.0;
var openAccordion = '';

function runAccordion(index){
  var nID = "Accordion" + index + "Content";
  if(openAccordion == nID)
    nID = '';
  setTimeout("animate("
      + new Date().getTime() + "," + TimeToSlide + ",'"
      + openAccordion + "','" + nID + "')", 33);
  openAccordion = nID;
}

function animate(lastTick, timeLeft, closingId, openingId){
  var curTick = new Date().getTime();
  var elapsedTicks = curTick - lastTick;
  var opening = (openingId == '') ?
      null : document.getElementById(openingId);
  var closing = (closingId == '') ?
      null : document.getElementById(closingId);
  if(timeLeft <= elapsedTicks) {
    if(opening != null)
      opening.style.height = ContentHeight + 'px';
    if(closing != null){
      closing.style.display = 'none';
      closing.style.height = '0px';
    }
    return;
  }

  timeLeft -= elapsedTicks;
  var newClosedHeight =
      Math.round((timeLeft/TimeToSlide) * ContentHeight);

  if(opening != null){
    if(opening.style.display != 'block')
      opening.style.display = 'block';
    opening.style.height =
        (ContentHeight - newClosedHeight) + 'px';
  }

  if(closing != null)
      closing.style.height = newClosedHeight + 'px';

  setTimeout("animate(" + curTick + "," + timeLeft + ",'"
      + closingId + "','" + openingId + "')", 33);
}
/*accordion panel code ends*/


/* BEGIN RESIZEPANEL SUBCLASS */
YAHOO.widget.ResizePanel = function(el, userConfig) {
    if (arguments.length > 0) {
        YAHOO.widget.ResizePanel.superclass.constructor.call(this, el, userConfig);
    }
}

YAHOO.widget.ResizePanel.CSS_PANEL_RESIZE = "yui-resizepanel";
YAHOO.widget.ResizePanel.CSS_RESIZE_HANDLE = "resizehandle";

YAHOO.extend(YAHOO.widget.ResizePanel, YAHOO.widget.Panel, {
    init: function(el, userConfig) {   
        YAHOO.widget.ResizePanel.superclass.init.call(this, el);    
        this.beforeInitEvent.fire(YAHOO.widget.ResizePanel);
        
        var Dom = YAHOO.util.Dom,
            Event = YAHOO.util.Event,
            oInnerElement = this.innerElement,
            oResizeHandle = document.createElement("DIV"),
            sResizeHandleId = this.id + "_resizehandle";
         
         oResizeHandle.id = sResizeHandleId;
         oResizeHandle.className = YAHOO.widget.ResizePanel.CSS_RESIZE_HANDLE;
    
        Dom.addClass(oInnerElement, YAHOO.widget.ResizePanel.CSS_PANEL_RESIZE);
    
        this.resizeHandle = oResizeHandle;
    
        function initResizeFunctionality() {
    
            var me = this,
                oHeader = this.header,
                oBody = this.body,                
                nStartWidth,
                nStartHeight,
                aStartPos,
                nBodyBorderTopWidth,
                nBodyBorderBottomWidth,
                nBodyTopPadding,
                nBodyBottomPadding,
                nBodyOffset;
        
            oInnerElement.appendChild(oResizeHandle);    
            this.ddResize = new YAHOO.util.DragDrop(sResizeHandleId, this.id);    
            this.ddResize.setHandleElId(sResizeHandleId);
    
            this.ddResize.onMouseDown = function(e) {
    
                nStartWidth = oInnerElement.offsetWidth;
                nStartHeight = oInnerElement.offsetHeight;
    
                if (YAHOO.env.ua.ie && document.compatMode == "BackCompat") {                
                    nBodyOffset = 0;                
                }
                else {    
                    nBodyBorderTopWidth = parseInt(Dom.getStyle(oBody, "borderTopWidth"), 10),
                    nBodyBorderBottomWidth = parseInt(Dom.getStyle(oBody, "borderBottomWidth"), 10),
                    nBodyTopPadding = parseInt(Dom.getStyle(oBody, "paddingTop"), 10),
                    nBodyBottomPadding = parseInt(Dom.getStyle(oBody, "paddingBottom"), 10),                    
                    nBodyOffset = nBodyBorderTopWidth + nBodyBorderBottomWidth + nBodyTopPadding + nBodyBottomPadding;                
                }
    
                me.cfg.setProperty("width", nStartWidth + "px");    
                aStartPos = [Event.getPageX(e), Event.getPageY(e)];    
            };
            
            this.ddResize.onDrag = function(e) {    
                var aNewPos = [Event.getPageX(e), Event.getPageY(e)],                
                    nOffsetX = aNewPos[0] - aStartPos[0],
                    nOffsetY = aNewPos[1] - aStartPos[1],                    
                    nNewWidth = Math.max(nStartWidth + nOffsetX, 10),
                    nNewHeight = Math.max(nStartHeight + nOffsetY, 10),                    
                    nBodyHeight = (nNewHeight - (oHeader.offsetHeight + nBodyOffset));
                        
                me.cfg.setProperty("width", nNewWidth + "px");
                    
                if (nBodyHeight < 0) {    
                    nBodyHeight = 0;    
                }    
                oBody.style.height =  nBodyHeight + "px";    
            };        
        }        
        
        function onBeforeShow() {    
           initResizeFunctionality.call(this);    
           this.unsubscribe("beforeShow", onBeforeShow);    
        }        
        
        function onBeforeRender() {                        
            if (this.cfg.getProperty("visible")) {    
                initResizeFunctionality.call(this);    
            } else {    
                this.subscribe("beforeShow", onBeforeShow);            
            }            
            this.unsubscribe("beforeRender", onBeforeRender);    
        }    
    
        this.subscribe("beforeRender", onBeforeRender);        
        if (userConfig) {    
            this.cfg.applyConfig(userConfig, true);    
        }    
        this.initEvent.fire(YAHOO.widget.ResizePanel);    
    },
    
    toString: function() {    
        return "ResizePanel " + this.id;    
    }
});

/* END RESIZEPANEL SUBCLASS */

function bringPanelToTop(e,obj){
	obj.bringToTop ();
}

var maxNoOfPanel = ${maxPanel};
var ctr = parseInt(0);
var availablePanels = {};
var panelIds = new Array();

/*prepare list of panels ids*/
function init(){
	var tmp = maxNoOfPanel;
	while(tmp != 0){
		tempId = 'objPanel'+tmp;
		panelIds.push(tempId);
		tmp--;
	}
	/*to populate each textbox intially*/
	populateTextBox("bookMarkInput");
	populateTextBox("crossTabInput");
	populateTextBox("reportInput");
	populateTextBox("analyticsInput");
	document.getElementById("dashBoardName").focus();
}
	
function validateUrl(e){
	var urlTxt = YAHOO.lang.trim(e.value);	
	if(urlTxt.length==0){
		alert("Please enter valid URL!");
		e.focus();
		return false;
	}
	return true;	
}
	/*
	 * Adds a new panel.
	 */
function addPanel(isUrlPanel) {
	var panelId = panelIds.pop(); //get panel id from panelIds array.
	var title = panelId.substring(8);
	var nPanel = new YAHOO.widget.ResizePanel(panelId, {width: "350px", fixedcenter: false, constraintoviewport: false, visible: false} );
	
	if(isUrlPanel=="true"){	
		var body='<div id="'+panelId+'_content"><Center><span>'+
				 "<bean:message key='ui.dashboard.create.page.panel.name' bundle='dashboard'/>" +'</span><br><input type="text" name="'+panelId+'_name" id="' + panelId + '_name" size="40" value="'+"<bean:message key='ui.dashboard.create.page.external.content'  bundle='dashboard'/>" +'" >'+
	             '<br><span >'+"<bean:message key='ui.dashboard.create.page.external.url'  bundle='dashboard'/>"+'</span><br><input type="text" name="' + panelId + '_url" id="'+panelId +'_url" size="40" onchange="validateUrl(this);" />'+
				 '</div>';		
		panelElementArray[panelId] = 'External';
		nPanel.setHeader('<div id="'+panelId+'_header">' + "<bean:message key='ui.label.context' bundle='dashboard'/>" + '</div>');
		nPanel.setBody(body);		
	}else{
		nPanel.setHeader('<div id="'+panelId+'_header">'+ "<bean:message key='ui.label.context' bundle='dashboard'/>"+'</div>');
		nPanel.setBody('<div id="'+panelId+'_content">&nbsp;</div>');
	}
	nPanel.render(document.body);
	YAHOO.util.Event.on(panelId, "click", bringPanelToTop,nPanel);

	var closeEl = YAHOO.util.Dom.getElementsByClassName("container-close", null, nPanel.element)[0]; 
	YAHOO.util.Event.on(closeEl, "click", closePanel, nPanel);
	new YAHOO.util.DDTarget(panelId);
		
	availablePanels[panelId] = nPanel; //push panel object in availablePanels array, which is used in re arranging	
	ctr++;
	reArrangePanels(); // rearrange all panels
	if(ctr == maxNoOfPanel){
		document.getElementById("addButton").disabled = "true";
		document.getElementById("urladdButton").disabled = "true";		
		return false;
	}
}

/*Re-arrange all the panels*/
function reArrangePanels(){
	var xVal = 270;
	var yVal = 170;
	var tmp = parseInt(1);
	for ( var keys in availablePanels ) {
		var obj = availablePanels[keys];
		
		if(tmp % 2 == 0){
			xVal = 640;
		} else if (tmp != 1) {
			xVal = 270;
			yVal = yVal + 123;
		}
		tmp++;
		obj.cfg.setProperty("xy",[xVal,yVal]);
		obj.show();	
	}

}

function closePanel(e, objPan){
	delete panelElementArray[objPan.id];
	panelIds.push(objPan.id); //before removing panel, put it's id in panelIds array.
	ctr--;	
	if(ctr >= maxNoOfPanel){
		document.getElementById("addButton").disabled = true;		
		document.getElementById("urladdButton").disabled = true;	
	}else{
		document.getElementById("addButton").disabled = false;			
		document.getElementById("urladdButton").disabled = false;
	}
	var el = document.getElementById(objPan.id);
	el.parentNode.removeChild(el); // remove that panel from DOM tree
	delete availablePanels[objPan.id];	
}

function preCreatePanel(panIndex, panelName, panelContent , panelType) {
	addPanel('false');
	document.getElementById('objPanel' + panIndex + '_header').innerHTML = panelName;
	if(panelType=="External"){
		var content='<center>' +
			'<span>'+"<bean:message key='ui.dashboard.create.page.panel.name' bundle='dashboard'/>" + '</span><br><input type="text" name="objPanel' + panIndex + '_name" id="objPanel' + panIndex + '_name" size="40" />'	+	
			'<br>'+
     		'<br><span >'+"<bean:message key='ui.dashboard.create.page.external.url'  bundle='dashboard'/>"+'</span><br><input type="text" name="objPanel' + panIndex + '_url" id="objPanel'+panIndex +'_url" size="40" onchange="validateUrl(this);" />' +
			'</center>';
		document.getElementById('objPanel' + panIndex + '_content').innerHTML = content;
		document.getElementById('objPanel' + panIndex + '_name').value = document.getElementById('hidden_panel_' + panIndex + '_name').value;
		document.getElementById('objPanel' + panIndex + '_url').value = panelContent;
	}else{
		var content = '<center>' + panelContent +'<br><br>'+
					"<bean:message key='ui.dashboard.create.page.panel.name' bundle='dashboard'/>"+
					'&nbsp;<input type="text" name="objPanel' + panIndex +'_name" id="objPanel' + panIndex +'_name" size="40" >' +
					'</center>';
		document.getElementById('objPanel' + panIndex + '_content').innerHTML = content;
		document.getElementById('objPanel' + panIndex + '_name').value = document.getElementById('hidden_panel_' + panIndex + '_name').value;
	}
}

function prePopulatePanelMeta(panIndex, panelType, panelSourceId, panelContentId, panelId) {
	panelElementArray['objPanel' + panIndex ] = panelType + '|' + panelSourceId + '|' + panelContentId + '|' + panelId;
}

//creates panels for editing dashboard
function preCreatePanels() {
	<c:forEach items="${ panelInfoList }" var="pInfo" varStatus="status" >
		<c:choose>
			<c:when test="${pInfo.panelType=='External'}">
				preCreatePanel(${ status.count },'${ pInfo.panelName }','<esapi:html>${pInfo.panelContentName }</esapi:html>', '${ pInfo.panelType }');
			</c:when>
			<c:otherwise>
				preCreatePanel(${ status.count },'${ pInfo.panelName }','<esapi:html>${pInfo.panelContentName }</esapi:html>', '${ pInfo.panelType }');
			</c:otherwise>
		</c:choose>
		prePopulatePanelMeta(${ status.count }, '${ pInfo.panelType }', '${ pInfo.panelSourceId }', '${ pInfo.panelContentId }', '${ pInfo.panelId }');
	</c:forEach>
}

/* if search box is empty, clear it's search result pane.*/
function handleResultPane(textBoxObj,resultPaneId){
	var resultPane = document.getElementById(resultPaneId);
	var textBoxVal = textBoxObj.value;
	if(textBoxVal.length == 0){
		resultPane.innerHTML = '';
	}
}
/* to populate each textbox intially .*/
function populateTextBox(textBoxID){
	if("bookMarkInput"==textBoxID){
		var bookmarkmessage="<bean:message key='ui.dashboard.create.page.search.bookmarkmsg'  bundle='dashboard'/>";
		var textBox = document.getElementById(textBoxID);	
		textBox.value=bookmarkmessage;
	}
	if("crossTabInput"==textBoxID){
		var crossTabmessage="<bean:message key='ui.dashboard.create.page.search.crosstabmsg'  bundle='dashboard'/>";
		var textBox = document.getElementById(textBoxID);
		textBox.value=crossTabmessage;
	}
	if("reportInput"==textBoxID){
		var reportmessage="<bean:message key='ui.dashboard.create.page.search.reportmsg'  bundle='dashboard'/>";
		var textBox = document.getElementById(textBoxID);
		textBox.value= reportmessage;
	}
	if("analyticsInput"==textBoxID){
		var analyticsmessage="<bean:message key='ui.dashboard.create.page.search.analyticmsg'  bundle='dashboard'/>";
		var textBox = document.getElementById(textBoxID);
		textBox.value=analyticsmessage;
	}
}
/* to clear each textbox onfocus event .*/
function clearTextBox(textBoxID) {
	if("bookMarkInput"==textBoxID){
		var bookmarkmessage="<bean:message key='ui.dashboard.create.page.search.bookmarkmsg'  bundle='dashboard'/>";
		var textBox = document.getElementById(textBoxID);
		if(textBox.value==bookmarkmessage)
			textBox.value="";
	}
	if("crossTabInput"==textBoxID){
		var crossTabmessage="<bean:message key='ui.dashboard.create.page.search.crosstabmsg'  bundle='dashboard'/>";
		var textBox = document.getElementById(textBoxID);
		if(textBox.value==crossTabmessage)
			textBox.value="";
	}
	if("reportInput"==textBoxID){
		var reportmessage="<bean:message key='ui.dashboard.create.page.search.reportmsg'  bundle='dashboard'/>";
		var textBox = document.getElementById(textBoxID);
		if(textBox.value==reportmessage)
			textBox.value="";
	}
	if("analyticsInput"==textBoxID){
		var analyticsmessage="<bean:message key='ui.dashboard.create.page.search.analyticmsg'  bundle='dashboard'/>";
		var textBox = document.getElementById(textBoxID);
		if(textBox.value==analyticsmessage)
			textBox.value="";
	}
	
}
//this function takes selected bookmark from popup window
//and displays the dimensions of bookmark in accordion
function storeSelectedNode(name,id) {
	var resultPane = document.getElementById("bookMarkSearchResult");
	resultPane.innerHTML = '';
	document.getElementById('bookMarkInput').value = htmlDecode( name );
	sendRequest("action=populateBookMarkDimensionNames&bkId="+id);
}
	
</script>

</head>



<body class="yui-skin-sam" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" 
 onload="javascript:init(); javascript:preCreatePanels();">

<logic:messagesPresent message="true">
	<table  align="right">
	<tr>
	<td align="left" valign="top" ><br>
	<font color="red" face="Verdana" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="dashboard">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font></td>
		</tr>
	</table>
</logic:messagesPresent>

<html:form action="/saveDashBoardAction" method="post" styleId="createDashboardForm">

<div id="note" style="visibility: hidden" class="yui-skin-sam">
<table  width="64%" align="right">
<tr>
<td>
<span class="labelStyle"><bean:message key="ui.dashboard.page.panel.name" bundle="dashboard"/></span>
</td>
</tr>
</table>
</div>
<div class="AccordionContainer">
	<div class="AccordionTitle" style="cursor: default;" ><bean:message key="ui.dashboard.create.page.dashboard.details.title" bundle="dashboard"/></div>
	<div class="AccordionContent"  style="display: inline; height: 200px; " >
		<table>		
			<tr><td><span class="labelStyle"><bean:message key="ui.label.Name" bundle="dashboard"/></span></td></tr>
			<tr><td><html:text property="dashBoardName" styleId="dashBoardName" styleClass="inputStyle" style="width:250px" /></td></tr>
			<tr><td><span class="labelStyle"><bean:message key="ui.label.Description" bundle="dashboard"/></span></td></tr>  		
   			<tr><td><html:textarea property="dashBoardDescription" styleClass="inputStyle" style="width:250px;resize:none" rows="5"/></td></tr>
			<tr>
				<td>
					<input type="button" value="<bean:message key="ui.dashboard.button.add.panel" bundle="dashboard"/>" id="addButton" onclick="addPanel('false');"/>
			    </td>
			</tr> 
			<tr><td>&nbsp;&nbsp;</td></tr> 
			<tr><td><span class="labelStyle"><bean:message key="ui.dashboard.create.page.panel.input" bundle="dashboard"/></span></td></tr>        
		</table>
	</div>
</div>

<table>
<tr>
<td align="left" valign="top">
<div id="AccordionContainer" class="AccordionContainer">
  <div onclick="runAccordion(2);">
  <c:if test="${viewBookmarks}"> 
    <div class="AccordionTitle" onselectstart="return false;"><bean:message key="ui.label.Bookmarks" bundle="dashboard"/></div>
  </c:if>
  </div>
  <div id="Accordion2Content" class="AccordionContent"><span class="labelStyle"><bean:message key="ui.dashboard.create.page.bookmark.search" bundle="dashboard"/></span>
  &nbsp;&nbsp; <input type="button" value="<bean:message key='ui.label.Search' bundle='dashboard'/>" id="searchButton" onclick="openSearchBookmarkWindow();"/>
  <br>			  
    <input id="bookMarkInput" type="text" size="5" onkeyup="handleResultPane(this,'bookMarkSearchResult');" onfocus="clearTextBox('bookMarkInput');">
    <div id="bookMarkContainer" style="z-index:1"></div><br><br>		
    <DIV id="bookMarkSearchResult" style="position:absolute"></DIV>
  </div>

  <div onclick="runAccordion(3);">
  <c:if test="${viewTabulation}"> 
    <div class="AccordionTitle" onselectstart="return false;"><bean:message key="ui.label.tabulation.menu" bundle="dashboard"/></div>
  </c:if>    
  </div>
  <div id="Accordion3Content" class="AccordionContent"><span class="labelStyle"><bean:message key="ui.dashboard.create.page.crosstab.search" bundle="dashboard"/></span><br>
    <span class="labelStyle"><input id="crossTabInput" type="text" size="5" onkeyup="handleResultPane(this,'crossTabSearchResult');"onfocus="clearTextBox('crossTabInput')"></span>
    <div id="crossTabContainer" style="z-index:1"></div><br><br>		
    <DIV id="crossTabSearchResult" style="position:absolute"></DIV>
  </div>

  <div onclick="runAccordion(4);">
  <c:if test="${viewAttachments}">
    <div class="AccordionTitle" onselectstart="return false;"><bean:message key="ui.label.Reports" bundle="dashboard"/></div>
  </c:if>
  </div>
  <div id="Accordion4Content" class="AccordionContent"><span class="labelStyle"><bean:message key="ui.dashboard.create.page.report.search" bundle="dashboard"/></span><br>
   <span class="labelStyle"> <input id="reportInput" type="text" size="5" onkeyup="handleResultPane(this,'reportSearchResult');"onfocus="clearTextBox('reportInput')"></span>
    <div id="reportContainer" style="z-index:1"></div><br><br>		
    <DIV id="reportSearchResult" style="position:absolute"></DIV> 
  </div>

  <div onclick="runAccordion(5);">
  <c:if test="${viewAnalytics}">
     <div class="AccordionTitle" onselectstart="return false;"><bean:message key="ui.label.Analytics" bundle="dashboard"/>   
  </c:if>
    </div>
  </div>
  <div id="Accordion5Content" class="AccordionContent"><span class="labelStyle"><bean:message key="ui.dashboard.create.page.analytic.search" bundle="dashboard"/></span><br>
    <span class="labelStyle"><input id="analyticsInput" type="text" size="5" onkeyup="handleResultPane(this,'analyticsSearchResult');" onfocus="clearTextBox('analyticsInput')"></span>
    <div id="analyticsContainer" style="z-index:1"></div><br><br>		
    <DIV id="analyticsSearchResult" style="position:absolute"></DIV>
  </div>
	<div onclick="runAccordion(6);">
		<c:if test="${enableExternalUrl}">
    		<div class="AccordionTitle" onselectstart="return false;"><bean:message key="ui.dashboard.create.page.external.url" bundle="dashboard"/></div>
    	</c:if>
	</div>

	<div id="Accordion6Content" class="AccordionContent" >
	<input type="button" value="<bean:message key='ui.dashboard.button.add.panel' bundle='dashboard'/>" id="urladdButton" onclick="addPanel('true');"/>		  
  </div>
</div>
</td>

</tr>
</table>

<script type="text/javascript">

var panelElementArray = {};
var maxResultsDisplayedInSearch = parseInt('${maxResultsDisplayed}');
var newWindow = null;
function openSearchBookmarkWindow(){
		var ht = 500;
		var wt = 950;
		var left = (screen.width/2)-(wt/2);
		var top = (screen.height/2)-(ht/2);	
		//if popup window is not opened or it is closed by user
		//then open popup window
	if(!newWindow ||(newWindow && (newWindow.closed ||(!newWindow.document.URL)))){
		 newWindow =window.open("/expensemap/bookmarks/showBookmarkSearchPage.xhtm","_blank","resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
	}
}

// Sends ajax request.
function sendRequest(argStr){
	try {
		jQuery.ajax({
			url: "/expensemap/dashboards/dashboardAjax.shtm?" + argStr,
			type: "GET",
			dataType: "text",
			success: responseHandler,
			error: function(xhr, status, error) {
				alert('<%=bundle.getValue("ui.message.There.was.a.problem.retrieving.data.from.server")%> ' + xhr.statusText);
			}
		});
	} catch(e) {
		 alert(e);
	}
}

// Ajax response handler
function responseHandler(response){
	var listStr = new StringBuffer();
	/* Response received will be in following example.
	['BOOKMARK','BOOKMARK NAME','BOOKMARK ID','{BOOKMARKS'S DIMENSION ID:NAME}']		
	*/
		
	var responseArr = eval(response);
    var type = responseArr[0];
    var typeName = responseArr[1];
    var typeId = responseArr[2];
	var str = "requestMap = "+responseArr[3];
	eval(str);
	var ulId = '';
	var resultPanelId = '';
	if(type == 'BOOKMARK'){
		ulId = 'bookMarkDimView';
		resultPanelId = 'bookMarkSearchResult';
		var hiddenBKSTR = "<bean:message key='ui.label.Bookmarks'  bundle='dashboard'/>" + ' > '+ typeName + ' > ';
		document.getElementById("bookMarkPanelTitle").value = hiddenBKSTR;
	}else if(type == 'CROSSTAB'){
		ulId = 'crossTabDimView';
		resultPanelId = 'crossTabSearchResult';
		var hiddenCTSTR = "<bean:message key='ui.label.tabulation.menu'  bundle='dashboard'/>" + ' > '+ typeName + ' > ';
		document.getElementById("crossTabPanelTitle").value = hiddenCTSTR;			
	}
		
	listStr.append('<ul class="draglist" id="'+ulId+'">');		
		
	for(key in requestMap){
		var listItemId = type + '|' + typeId + '|' + key;
		listStr.append('<li class="listItem" id="'+listItemId+'">'+htmlEncode(requestMap[key])+'</li>');
		new YAHOO.example.DDList(listItemId);
	}
	listStr.append('</ul>');
			
	document.getElementById(resultPanelId).innerHTML = listStr.toString();
}


YAHOO.example.DS_XHR = new function() {
	/* START : AUTOCOMPLETE FUNCTIONALITY FOR BOOKMARKS*/
	var bkDataSource = new YAHOO.widget.DS_XHR("/expensemap/dashboards/dashboardAjax.shtm",["ResultSet","TITLE","ID","SHARE"]);
	bkDataSource.scriptQueryParam = "searchString"; 
	bkDataSource.scriptQueryAppend = "action=searchBookmark";
	bkDataSource.responseType = YAHOO.widget.DS_XHR.TYPE_JSON;
	bkDataSource.connMethodPost=true;
    this.bkAutoComp = new YAHOO.widget.AutoComplete('bookMarkInput','bookMarkContainer',bkDataSource);
    this.bkAutoComp.prehighlightClassName = "yui-ac-prehighlight";
    this.bkAutoComp.typeAhead = false;
    this.bkAutoComp.useShadow = false;
    this.bkAutoComp.minQueryLength = 1;
    this.bkAutoComp.maxResultsDisplayed=maxResultsDisplayedInSearch;
    var dretEvent = function(type, args) {
					var oAutoComp = args[0];  
					var data=args[2];
					if(data.length == 0){					
					oAutoComp.setBody("<div id=\"bookMarkContainer\" style='font-weight:bold'><font color=\"blue\" face=\"Arial\" size=\"2\">"+"<bean:message key='ui.dashboard.create.page.search.errormsg'  bundle='dashboard'/>"+"</font></div>");
				}
				
	};			 
	this.bkAutoComp.dataReturnEvent.subscribe(dretEvent); 
    this.bkAutoComp.formatResult = function(aResultItem, sQuery) {
    	
       var sKey = aResultItem[0]; // the entire result key
       var sKeyQuery = sKey.substr(0, sQuery.length); // the query itself
       var sKeyRemainder = sKey.substr(sQuery.length); // the rest of the result

       var id = aResultItem[1]; 
	   var aMarkup;
	   if(aResultItem[2] == "true") { // If bookmark is a shared by other user
		   aMarkup = ["<div id='ysearchresult'>",
			  '<img   id="ysearchresult" +"1"   src="/expensemap/jsp/images/shared.gif">',
			  '&nbsp;&nbsp;',
			  "<span style='font-weight:bold'>",
			  htmlEncode(sKeyQuery),
			  "</span>",
			  htmlEncode(sKeyRemainder),
			  "</div>"];
	   } else { 
   		   aMarkup = ["<div id='ysearchresult'>",
			  '<img   id="ysearchresult" +"1"   src="/expensemap/jsp/images/nonshared.gif">',
			  '&nbsp;&nbsp;',
			  "<span style='font-weight:bold'>",
			  htmlEncode(sKeyQuery),
			  "</span>",
			  htmlEncode(sKeyRemainder),
			  "</div>"];
	   }
      return (aMarkup.join(""));
	};
	
	function fnBookMarkCallback(e, args) {
		document.getElementById('bookMarkInput').value = htmlDecode( args[2][0] );
	    sendRequest("action=populateBookMarkDimensionNames&bkId="+args[2][1]);
 	}
 	this.bkAutoComp.itemSelectEvent.subscribe(fnBookMarkCallback);
	/* END : AUTOCOMPLETE FUNCTIONALITY FOR BOOKMARKS*/
	
	/* START : AUTOCOMPLETE FUNCTIONALITY FOR CROSSTABS*/	
 	var ctDataSource = new YAHOO.widget.DS_XHR("/expensemap/dashboards/dashboardAjax.shtm",["ResultSet","TITLE","ID","SHARE"]);
	ctDataSource.scriptQueryParam = "searchString"; 
	ctDataSource.scriptQueryAppend = "action=searchCrossTab";
	ctDataSource.responseType = YAHOO.widget.DS_XHR.TYPE_JSON;
	ctDataSource.connMethodPost=true;
    this.ctAutoComp = new YAHOO.widget.AutoComplete('crossTabInput','crossTabContainer',ctDataSource);
    this.ctAutoComp.prehighlightClassName = "yui-ac-prehighlight";
    this.ctAutoComp.typeAhead = false;
    this.ctAutoComp.useShadow = false;
    this.ctAutoComp.minQueryLength = 1;
    this.ctAutoComp.maxResultsDisplayed=maxResultsDisplayedInSearch;
    var dretEvent = function(type, args) {
					var oAutoComp = args[0];  
					var data=args[2];
					if(data.length == 0){					
					oAutoComp.setBody("<div id=\"crossTabContainer\" style='font-weight:bold'><font color=\"blue\" face=\"Arial\" size=\"2\">"+"<bean:message key='ui.dashboard.create.page.search.errormsg'  bundle='dashboard'/>"+ "</font></div>");
				}
				
	};			 
	this.ctAutoComp.dataReturnEvent.subscribe(dretEvent); 
    this.ctAutoComp.formatResult = function(aResultItem, sQuery) {
       
       var sKey = aResultItem[0]; // the entire result key
       var sKeyQuery = sKey.substr(0, sQuery.length); // the query itself
       var sKeyRemainder = sKey.substr(sQuery.length); // the rest of the result
       
       var id = aResultItem[1]; 
	   var aMarkup;
	   if(aResultItem[2] == "true") { // If crosstab is a shared by other user
		   aMarkup = ["<div id='ysearchresult'>",
			  '<img   id="ysearchresult" +"1"   src="/expensemap/jsp/images/shared.gif">',
			  '&nbsp;&nbsp;',
			  "<span style='font-weight:bold'>",
			  htmlEncode(sKeyQuery),
			  "</span>",
			  htmlEncode(sKeyRemainder),
			  "</div>"];
	   } else { 
   		   aMarkup = ["<div id='ysearchresult'>",
			  '<img   id="ysearchresult" +"1"   src="/expensemap/jsp/images/nonshared.gif">',
			  '&nbsp;&nbsp;',
			  "<span style='font-weight:bold'>",
			  htmlEncode(sKeyQuery),
			  "</span>",
			  htmlEncode(sKeyRemainder),
			  "</div>"];
	   }	   
       return (aMarkup.join(""));
	};
	
	function fnCrossTabCallback(e, args) {
		document.getElementById('crossTabInput').value = htmlDecode( args[2][0] );
	    sendRequest("action=populateCrossTabDimensionNames&bkId="+args[2][1]);
 	}
 	this.ctAutoComp.itemSelectEvent.subscribe(fnCrossTabCallback);
	/* END : AUTOCOMPLETE FUNCTIONALITY FOR CROSSTABS*/	 	

	/* START : AUTOCOMPLETE FUNCTIONALITY FOR REPORTS*/	 	
 	var rptDataSource = new YAHOO.widget.DS_XHR ("/expensemap/dashboards/dashboardAjax.shtm",["ResultSet","TITLE","ID"]);
	rptDataSource.scriptQueryParam = "searchString"; 
	rptDataSource.scriptQueryAppend = "action=searchReport";
	rptDataSource.connMethodPost=true;
	rptDataSource.responseType = YAHOO.widget.DS_XHR.TYPE_JSON;
    this.rptAutoComp = new YAHOO.widget.AutoComplete('reportInput','reportContainer',rptDataSource);
    this.rptAutoComp.prehighlightClassName = "yui-ac-prehighlight";
    this.rptAutoComp.typeAhead = false;
    this.rptAutoComp.useShadow = false;
    this.rptAutoComp.minQueryLength = 1;   
    this.rptAutoComp.maxResultsDisplayed=maxResultsDisplayedInSearch;
    var dretEvent = function(type, args) {
		var oAutoComp = args[0];  
		var data=args[2];
		if(data.length == 0){					
			oAutoComp.setBody("<div id=\"reportContainer\" style='font-weight:bold'><font color=\"blue\" face=\"Arial\" size=\"2\">"+"<bean:message key='ui.dashboard.create.page.search.errormsg'  bundle='dashboard'/>"+"</font></div>");
		}
	};			 
	this.rptAutoComp.dataReturnEvent.subscribe(dretEvent); 
    this.rptAutoComp.formatResult = function(aResultItem, sQuery) {
       var sKey = htmlDecode(aResultItem[0]); // the entire result key
       var sKeyQuery = sKey.substr(0, sQuery.length); // the query itself
       var sKeyRemainder = htmlEncode(sKey.substr(sQuery.length)); // the rest of the result
       var id = aResultItem[1]; 
       var aMarkup = ["<div id='ysearchresult'>",
          "<span style='font-weight:bold'>",
          sKeyQuery,
          "</span>",
          sKeyRemainder,
          "</div>"];
	      return (aMarkup.join(""));
	};
	
	function fnReportCallback(e, args) {
		var hiddenRPTSTR = "<bean:message key='ui.label.Reports'  bundle='dashboard'/>" + ' > '+ args[2][0] + ' > ';
		document.getElementById("reportPanelTitle").value = hiddenRPTSTR;
		var listStr = new StringBuffer();
		listStr.append('<ul class="draglist" id="reportDimView">');
		var listItemId = 'REPORT' + '|' + args[2][1] + '|' + args[2][0];
		listStr.append('<li class="listItem" id="'+listItemId+'">'+htmlEncode(args[2][0])+'</li>');
		listStr.append('</ul>');
		
		document.getElementById('reportSearchResult').innerHTML = listStr.toString();
		new YAHOO.example.DDList(listItemId);
		
		document.getElementById('reportInput').value = htmlDecode( args[2][0] );
 	}
	
 	this.rptAutoComp.itemSelectEvent.subscribe(fnReportCallback);	
	/* END : AUTOCOMPLETE FUNCTIONALITY FOR REPORTS*/	 	
	
	/* START : AUTOCOMPLETE FUNCTIONALITY FOR ANALYTICS*/	
 	var anaDataSource = new YAHOO.widget.DS_XHR ("/expensemap/dashboards/dashboardAjax.shtm",["ResultSet","TITLE","ID","SHARE"]);
	anaDataSource.scriptQueryParam = "searchString"; 
	anaDataSource.scriptQueryAppend = "action=searchAnalytics";
	anaDataSource.responseType = YAHOO.widget.DS_XHR.TYPE_JSON;
	anaDataSource.connMethodPost=true;
    this.anaAutoComp = new YAHOO.widget.AutoComplete('analyticsInput','analyticsContainer',anaDataSource);
    this.anaAutoComp.prehighlightClassName = "yui-ac-prehighlight";
    this.anaAutoComp.typeAhead = false;
    this.anaAutoComp.useShadow = false;
    this.anaAutoComp.minQueryLength = 1;    
    this.anaAutoComp.maxResultsDisplayed=maxResultsDisplayedInSearch;
    var dretEvent = function(type, args) {
		var oAutoComp = args[0];  
		var data=args[2];
		if(data.length == 0){					
			oAutoComp.setBody("<div id=\"analyticsContainer\" style='font-weight:bold'><font color=\"blue\" face=\"Arial\" size=\"2\">"+"<bean:message key='ui.dashboard.create.page.search.errormsg'  bundle='dashboard'/>"+"</font></div>");
		}
	};			 
	this.anaAutoComp.dataReturnEvent.subscribe(dretEvent);   
    this.anaAutoComp.formatResult = function(aResultItem, sQuery) {
    	var sKey = aResultItem[0]; // the entire result key
        var sKeyQuery = sKey.substr(0, sQuery.length); // the query itself
        var sKeyRemainder = sKey.substr(sQuery.length); // the rest of the result
        
       	var id = aResultItem[1]; 
	   	var aMarkup;
	   	if(aResultItem[2] == "true") { // If analytic is a shared by other user
		   aMarkup = ["<div id='ysearchresult'>",
			  '<img   id="ysearchresult" +"1"   src="/expensemap/jsp/images/shared.gif">',
			  '&nbsp;&nbsp;',
			  "<span style='font-weight:bold'>",
			  htmlEncode(sKeyQuery),
			  "</span>",
			  htmlEncode(sKeyRemainder),
			  "</div>"];
	   	} else { 
   		   aMarkup = ["<div id='ysearchresult'>",
			  '<img   id="ysearchresult" +"1"   src="/expensemap/jsp/images/nonshared.gif">',
			  '&nbsp;&nbsp;',
			  "<span style='font-weight:bold'>",
			  htmlEncode(sKeyQuery),
			  "</span>",
			  htmlEncode(sKeyRemainder),
			  "</div>"];
	   	}		   
      	return (aMarkup.join(""));
	};
	
	function fnAnalyticsCallback(e, args) {
		var hiddenANASTR = "<bean:message key='ui.label.Analytics'  bundle='dashboard'/>" + ' > '+ args[2][0] + ' > ';
		document.getElementById("analyticsPanelTitle").value = hiddenANASTR;
		var listStr = new StringBuffer();
		listStr.append('<ul class="draglist" id="analyticsDimView">');
		var listItemId = 'ANALYTICS' + '|' + args[2][1] + '|' + escape(args[2][0]);
		listStr.append('<li class="listItem" id="'+listItemId+'">'+htmlEncode(args[2][0])+'</li>');
		listStr.append('</ul>');
		
		document.getElementById('analyticsSearchResult').innerHTML = listStr.toString();
		new YAHOO.example.DDList(listItemId);
		document.getElementById('analyticsInput').value = htmlDecode( args[2][0] );
 	}
 	this.anaAutoComp.itemSelectEvent.subscribe(fnAnalyticsCallback);
	/* END : AUTOCOMPLETE FUNCTIONALITY FOR ANALYTICS*/	 				
};
</script>

<script type="text/javascript">
// drap n drop related code starts 

(function() {
var Dom = YAHOO.util.Dom;
var Event = YAHOO.util.Event;
var DDM = YAHOO.util.DragDropMgr;

YAHOO.example.DDApp = {
    initilize: function() {
       new YAHOO.util.DDTarget("bookMarkDimView");
       new YAHOO.util.DDTarget("crossTabDimView");
       new YAHOO.util.DDTarget("reportDimView");
       new YAHOO.util.DDTarget("analyticsDimView");
    }
};

YAHOO.example.DDList = function(id, sGroup, config) {
    YAHOO.example.DDList.superclass.constructor.call(this, id, sGroup, config);
    this.logger = this.logger || YAHOO;
    var el = this.getDragEl();
    Dom.setStyle(el, "opacity", 0.67); // The proxy is slightly transparent
    this.goingUp = false;
    this.lastY = 0;
};

YAHOO.extend(YAHOO.example.DDList, YAHOO.util.DDProxy, {
    startDrag: function(x, y) {
        // make the proxy look like the source element
        var dragEl = this.getDragEl();
        var clickEl = this.getEl();
        Dom.setStyle(clickEl, "visibility", "hidden");
        dragEl.innerHTML = clickEl.innerHTML;
		Dom.setStyle(dragEl, "color", Dom.getStyle(clickEl, "color"));
        Dom.setStyle(dragEl, "backgroundColor", Dom.getStyle(clickEl, "backgroundColor"));
        Dom.setStyle(dragEl, "border", "2px solid gray");
    },

    endDrag: function(e) {
    if (DDM.interactionInfo.drop.length === 1) {
		var noteObj = document.getElementById("note");
		noteObj.style.visibility="visible";
    }
        var srcEl = this.getEl();
        var proxy = this.getDragEl();
        // Show the proxy element and animate it to the src element's location
        Dom.setStyle(proxy, "visibility", "");
        var a = new YAHOO.util.Motion( 
            proxy, { 
                points: { 
                    to: Dom.getXY(srcEl)
                }
            }, 
            0.2, 
            YAHOO.util.Easing.easeOut 
        )
        var proxyid = proxy.id;
        var thisid = this.id;

        // Hide the proxy and show the source element when finished with the animation
        a.onComplete.subscribe(function() {
                Dom.setStyle(proxyid, "visibility", "hidden");
                Dom.setStyle(thisid, "visibility", "");
            });
        a.animate();
    },

    onDragDrop: function(e, id) {
        if (DDM.interactionInfo.drop.length === 1) {
		    var pt = DDM.interactionInfo.point; 
            var region = DDM.interactionInfo.sourceRegion; 
            // Check to see if we are over the source element's location.  We will
            // append to the bottom of the list once we are sure it was a drop in
            // the negative space (the area of the list without any list items)
            if (!region.intersect(pt)) {
                var newid = id+'_content';
                var destEl = Dom.get(newid);
				// PR - 70305.
                if(null==destEl){
                    return;
                }                
                var destDD = DDM.getDDById(id);
                var content = '<div id="listItemDiv"><center>'+this.getEl().innerHTML;
                content = content + '<br><br>'+"<bean:message key='ui.dashboard.create.page.panel.name' bundle='dashboard'/>"+'&nbsp;<input type="text" name="'+id+'_name" id="'+id+'_name" size="40" ></center></div>';
                destEl.innerHTML = content;
                destDD.isEmpty = false;
                DDM.refreshCache();
                var dropContentId = this.getEl().id;
                panelElementArray[id] = dropContentId;
                dropContentId = dropContentId.substring(0,dropContentId.indexOf("|"));
                var msgId = '';
                if(dropContentId == 'BOOKMARK'){
                	msgId = 'bookMarkPanelTitle';
                }else if(dropContentId == 'CROSSTAB'){
                	msgId = 'crossTabPanelTitle';
                }else if(dropContentId == 'REPORT'){
                	msgId = 'reportPanelTitle';
                }else if(dropContentId == 'ANALYTICS'){
                	msgId = 'analyticsPanelTitle';
                }
                var panelHeaderMsg = htmlDecode ( document.getElementById(msgId).value ) + xmlDecode ( htmlDecode( this.getEl().innerHTML ) );

                //To avoid showing repeated report/anlytics/crosstab name in panel header
                //remove last name entry in header message   
				var tempArray = panelElementArray[id].split("|");
				if(tempArray[1]==tempArray[2]){
					panelHeaderMsg = panelHeaderMsg.substring(0,panelHeaderMsg.lastIndexOf(">"));
				}
				//To truncate the default panel name to 50 char.
				if(panelHeaderMsg.length>50){
					panelHeaderMsg = panelHeaderMsg.substring(0,47)+'...';				  
				}
                Dom.get(id+'_header').innerHTML = htmlEncode(panelHeaderMsg);
                Dom.get(id+'_name').value = panelHeaderMsg;
            }         
        }
    },

    onDrag: function(e) {
        // Keep track of the direction of the drag for use during onDragOver
        var y = Event.getPageY(e);
        if (y < this.lastY) {
            this.goingUp = true;
        } else if (y > this.lastY) {
            this.goingUp = false;
        }
        this.lastY = y;
    },

    onDragOver: function(e, id) {  
        var srcEl = this.getEl();
        var destEl = Dom.get(id);
        // We are only concerned with list items, we ignore the dragover
        // notifications for the list.
        if (destEl.nodeName.toLowerCase() == "li") {
            var orig_p = srcEl.parentNode;
            var p = destEl.parentNode;
            if (this.goingUp) {
                p.insertBefore(srcEl, destEl); // insert above
            } else {
                p.insertBefore(srcEl, destEl.nextSibling); // insert below
            }
            DDM.refreshCache();
        }
    }
});

Event.onDOMReady(YAHOO.example.DDApp.initilize, YAHOO.example.DDApp, true);
})();
// drap n drop related code ends 
</script>	

<html:hidden property="dashboardId" styleId="dashboardId" value="${ dashboardId }"/>
<input type="hidden" name="AuthCode" id="AuthCode" value="<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>"/>
<input type="hidden" id="originalDBName" name="originalDBName" value="<c:out value='${ originalDashBoardName }'/>" />
<input type="hidden" id="bookMarkPanelTitle">
<input type="hidden" id="crossTabPanelTitle">
<input type="hidden" id="reportPanelTitle">
<input type="hidden" id="analyticsPanelTitle">
<input type="hidden" id="panelMinYVal" name="panelMinYVal">

<!-- Hidden Text Boxes for existing panel names -->

<c:forEach items="${ panelInfoList }" var="pInfo" varStatus="status" >
	<input type="hidden" id="hidden_panel_${ status.count }_name" value="${ pInfo.panelName }">
</c:forEach>
</html:form>
</body>
</html:html>