<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../../includes/tlib.jspf"%>
<%@ page import="java.util.Locale,java.util.Map"%>
<%@ page import="com.zeborg.util.WebUtil,java.util.Iterator"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession" %>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil" %>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.emptoris.viewer.dashboards.common.util.DashboardConstants"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>
<%@ include file="../header.jsp"%>

<%
Locale locale = zs.getUser().getLocale();
ZSession zsession = ZSessionUtil.getFromSession(pageContext);
String userId = zsession.getUser().getId();
%>
<c:set var="userDatePattern" value="<%=zsession.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zsession.getUser().getTimeZone()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	

<html>
<TITLE><%=ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.dashboard.pdf.list.header" bundle="dashboard"/></TITLE>
<head>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/animation/animation.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/utilities/utilities.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo/yahoo.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dom/dom-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/event/event-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/menu/menu.js"></script>
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardscss.css">

<style>
	a, A:link, a:visited, a:active, A:hover
	{color: #330099;}
</style>
<%
    HelpUtil emHelp = HelpUtil.getHelpUtil();
	String helpURL = emHelp.getHelpURLString(DashboardConstants.DASHBOARD_PDF_LIST_PAGE_HELP_URL, locale);	

	String sortOrder = (String)request.getAttribute("sortOrder");
   	String sortCol =  request.getParameter("sortColumn"); 
	if(sortCol == null || sortCol.equals("null") || sortCol.equals(""))
	{
		sortCol="dateCreated";
	} 
	if (sortOrder == null || sortOrder.equals("null") || sortOrder.equals("")) {
		sortOrder = "desc";
	}
	Integer pageSize = new Integer(0);
	if (request.getAttribute("pageSize") != null) {
		pageSize = (Integer)request.getAttribute("pageSize");
	} else {
		pageSize = 15;
	}
	//set return to url
	pageContext.setAttribute("returnToURL","../dashboards/showDashboardPDFList.do", PageContext.SESSION_SCOPE);
	
	%>
<script type="text/javascript">

//submit form for pagination
function paginate(action, pageSize) {
	var frm = document.getElementById("dashboardPdfListForm");
	frm.method="post";
	frm.action="/expensemap/dashboards/showDashboardList.do?theAction=" + action + "&pageSize=" + pageSize;
	frm.submit();
}
//Sort 
function sort(sortListBy) {
	var sortOrder = document.getElementById("sortOrder");
	if (sortOrder==null || sortOrder.value == '' || sortOrder.value=='null')
		sortOrder.value = 'desc';

	var url='/expensemap/dashboards/showDashboardList.do?sortColumn='+sortListBy+'&sortOrder='+sortOrder.value;
	var frm = document.getElementById("dashboardPdfListForm");
	frm.action = url;
	if(sortOrder.value=='asc') {
		sortOrder.value='desc';
	} else if(sortOrder.value=='desc') {
		sortOrder.value='asc';
	}
	document.getElementById("sortOrder").value = sortOrder.value;
	document.getElementById("sortColumn").value = sortListBy;
	frm.submit();
}

function openPDF(fileName,eriId,status, fileId){

	if(status=='STALE'){
	   var answer = confirm("<bean:message key='ui.dashboard.pdf.job.stale' bundle='dashboard'/>"); 
	   if(answer){
	    var frm = document.getElementById("dashboardPdfListForm");
	    frm.method="post";
	    frm.action="/expensemap/dashboards/regeneartePDF.do?fileId=" + fileId;
	    frm.submit();
	    return;	   
       }
	}
	var usr = "<%=userId%>";
	var space = '\u0020';
	for(var i=0;i<fileName.length;i++){
		if(fileName.charAt(i) == space){
			fileName = fileName.replace(space,'-');
		}
	}
	 var frm = document.getElementById("dashboardPdfListForm");
	    frm.method="post";
	    frm.action="/expensemap/dashboards/downloadPDF.do?fileId=" + fileId;
	    frm.submit();
	    return;	  
}
//code added 
function trim(s) {
    return s.replace( /^\s*/, "" ).replace( /\s*$/, "" );
}

//Cancel the search action
function clearAll() {
	var frm = document.getElementById("dashboardPdfListForm");
	mytable = document.getElementById("bottomtable"); 
	mytable.style.left = 0+'px';
	mytable.style.top = 50+'px';
	return false;
}

//Search for the pdf
function search() {
	var frm = document.getElementById("dashboardPdfListForm");
	var url = '/expensemap/dashboards/getSearchPDF.do?startRec='+"<c:out value='${requestScope.startRec}'/>"+'&pageSize='+"<c:out value='${requestScope.pageSize}'/>"+'&limitRec='+"<c:out value='${requestScope.limitRec}'/>"+'&sortOrder='+ "<c:out value='${requestScope.sortOrder}'/>" + '&sortColumn='+"<c:out value='${requestScope.sortColumn}'/>";
	
	window.open(url, "PDF_Search", "width=536,height=450,scrollbars=no,status=no,resizable=no");
}

//Refresh PDF list
function refreshList() {
	paginate('getCurrent', <%=pageSize%>);
}
/**
 * This JS function responds to Delete Button Click and
 * initiates the Delete Work-flow.
 */
function deleteSelected() {	
	var frm = document.getElementById("dashboardPdfListForm");

	if (frm.selectBox == null) {
		alert("<bean:message key='ui.dashboard.pdf.job.delete.noReports' bundle='dashboard'/>");
		return;
	}
	if (!checkForValidState('delete')) {
		alert("<bean:message key='ui.dashboard.pdf.job.inprgress.donotdelete' bundle='dashboard'/>");
		return;
	}
	
	var isSelected = checkAtLeastOneSelected();
	if (frm.selectBox.length > 0 && isSelected||frm.selectBox.value && isSelected) {
		if (confirmDelete()) {
			frm.action = "/expensemap/dashboards/deletePDF.do";
			frm.method = "post";
			frm.submit();
		}
	} else if (frm.selectBox.length > 0 && !isSelected||frm.selectBox.value && !isSelected) {
	
		alert("<bean:message key='ui.dashboard.pdf.message.select.pdf.to.delete' bundle='dashboard'/>");
	} else {
		alert("<bean:message key='ui.dashboard.pdf.job.delete.noReports' bundle='dashboard'/>");
	}
}

//Confirm delete action
function confirmDelete(){
	var confirmDelete ="<bean:message key='ui.delete.alertmsg' bundle='dashboard'/>";
	//Are you sure you want to Delete';
	if (confirm(confirmDelete)) {
 		return true;
	} else {
		return false;
	}
}
//Validate if at least one pdf is selected.
function checkAtLeastOneSelected() {
	var frm = document.getElementById("dashboardPdfListForm");
	var noOfRows = frm.selectBox.length;
   if (frm.selectBox[0]) { // if the checkbox group is an array (one check box is not an array)
	for (i = 0; i < noOfRows; i++) {
	if (frm.selectBox[i].checked == true) {
			return true;
		}
	}
	}
	else { // There is only one check box (it's not an array)
	 if (frm.selectBox.checked) { // if the one check box is checked
	         return true;
	      }
	      
	      }

	return false;
}
//Check for valid state of pdf for particular action.
function checkForValidState(type) {
	var frm = document.getElementById("dashboardPdfListForm");
	if(frm.selectBox[0]){
	var noOfRows = frm.selectBox.length;
	for (i = 0; i < noOfRows; i++) {
		var val = frm.selectBox[i].value;
		var temp = new Array();
		temp = val.split('_');
		if (type == 'delete') {
			if (frm.selectBox[i].checked == true && (temp[1] == "SUBMITTED") ) {
				//Do not select in progress report(s) for deletion
				return false;
			}
		}
	}
	}else { // There is only one check box (it's not an array)
	 if (frm.selectBox.value) { // if the one check box is checked
	        var val = frm.selectBox.value;
		 		var temp = new Array();
		 		temp = val.split('_');
		 		if (type == 'delete') {
		 			if (frm.selectBox.checked == true && (temp[1] == "SUBMITTED") ) {
		 				//Do not select in progress report(s) for deletion
		 				return false;
		 			}
		 		}
	
	      }
	      
	      }
	return true;
}
//Enable/disable buttons
 function setButtons(statusVal, chkbox){
 	if(statusVal == 'RUNNING' &&  chkbox.checked == true ){
 		document.getElementById("deleteBtn").disabled=false;
 	 }
 	else if(statusVal == 'SUBMITTED' &&  chkbox.checked == true ){
 			document.getElementById("deleteBtn").disabled=true;
 	}else if ( (statusVal != 'RUNNING'|| statusVal != 'SUBMITTED' ) &&  chkbox.checked == true){
 		document.getElementById("deleteBtn").disabled=false;
 		}
 	if (!checkAtLeastOneSelected()) {
 		document.getElementById("deleteBtn").disabled=true;
 	 	}
 	//updates selectAll checkbox if all checkboxes are selected.
	updateSelectAll();
}

/**
 * This JS function updates the selectAll check-box based on user's selection.
 * i.e. when user selects each-and-every checkbox manually, the selectAll check-box gets selected too.
 *
 */
function updateSelectAll() {
	var theForm = document.getElementById("dashboardPdfListForm");
	var selectAllControl = document.getElementById("selectAll");
	var allSelected = true;
	if ( ! theForm.selectBox.length ) {
		allSelected = theForm.selectBox.checked;
	} else {
		for( var i=0; i< theForm.selectBox.length; i++ ) {
			if ( theForm.selectBox[i].checked == false ) {
				allSelected = false;
				break;
			}	
		}
	}
	selectAllControl.checked = allSelected;
}

//Select all checkboxes.
function checkAll(selectAllControl)
{
	var theForm = document.dashboardPdfListForm;
   	
	if(selectAllControl.checked == false) {
		if(document.getElementById("deleteBtn")!= null){
			document.getElementById("deleteBtn").disabled=true;
		}
	} else {
		if(document.getElementById("deleteBtn")!= null){
			document.getElementById("deleteBtn").disabled=false;
		}
	}
	
	
	if ( theForm.selectBox == null ) {
	   	return false;	
	} 
	   	
	if ( theForm.selectBox.length ) {
	   	// There are more than one rows on this form.
		for( var i=0; i< theForm.selectBox.length; i++ ) {
			theForm.selectBox[i].checked = selectAllControl.checked;
		}
		return true;
	}
	
	// There is just a single row on this form.
   	theForm.selectBox.checked = selectAllControl.checked;
} 
function selectCheckBox(checkBox, flag) {
	if ( checkBox.disabled == false ) {
		checkBox.checked = flag ;
	}
}
function isArray(obj){
	return(typeof(obj.length)=="undefined")?false:true;
}

//Sort
function sort(sortListBy) {
	var sortOrder = document.getElementById("sortOrder");
	if (sortOrder==null || sortOrder.value == '' || sortOrder.value=='null')
		sortOrder.value = 'asc';

	var url='/expensemap/dashboards/showDashboardPDFList.do?sortColumn='+sortListBy+'&sortOrder='+sortOrder.value;
	var frm = document.getElementById("dashboardPdfListForm");
	frm.action = url;
	if(sortOrder.value=='asc') {
		sortOrder.value='desc';
	} else if(sortOrder.value=='desc') {
		sortOrder.value='asc';
	}
	document.getElementById("sortOrder").value = sortOrder.value;
	document.getElementById("sortColumn").value = sortListBy;
	frm.submit();
}
//submit form for pagination
function paginate(action, maxRows) {
	var frm = document.getElementById("dashboardPdfListForm");
	frm.method="post";
	frm.action="/expensemap/dashboards/showDashboardPDFList.do?theAction="+action + "&pageSize=" + maxRows;
	frm.submit();
}
//end of code added
function showPanelInfo(fileId){
	var ht = 400;
	var wt = 550;
	var left = (screen.width/2)-(wt/2);
	var top = (screen.height/2)-(ht/2);
	window.open("/expensemap/dashboards/showPanelInfo.xhtm?fileId="+fileId,"_blank","resizable=yes,scrollbars=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
}

function init(){
	var obj = document.getElementById("maxRowsList");
	if(obj!=null && obj!='null' && obj!='undefined'){
		obj.focus();
	}		
}

function validateSubmit(){
	if(isValidNumber()){
		document.getElementById("pageSize").value = document.getElementById("maxRowsList").value; 
	}
}

</script>
</head>
<BODY class="yui-skin-sam" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="init();"> 	
 <jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="isDashboardPdfListPage" value="true"/>
 </jsp:include>
 <br>
<logic:messagesPresent message="true" property="org.apache.struts.action.GLOBAL_MESSAGE" >
	<center>
	<font color="red" face="Arial, Helvetica, sans-serif" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="dashboard"> 
		      <bean:write name="msg" bundle="dashboard"/> 
		</html:messages>
		</b>
	</font>
	</center>
</logic:messagesPresent>
<logic:messagesPresent message="true" property="emSrcMessages" >
<center>
	<font color="red" face="Arial, Helvetica, sans-serif" size="2">
		<b>
		<html:messages id="msg" message="true" property="emSrcMessages" bundle="emSrcMessages">
			<bean:write name="msg"/>
		</html:messages>
		</b>
	</font>
</center>
</logic:messagesPresent>
<form id="dashboardPdfListForm" name="dashboardPdfListForm" onsubmit="validateSubmit();">
	<br>
	<table class="tableWithBorder">
 	 <tr>
       	<td class="reportTitle"><bean:message key="ui.dashboard.pdf.list.header" bundle="dashboard"/></td>
		<td><b><bean:message key="rpt.cubeName" bundle="analytic"/>:&nbsp;<%=zs.getDataSet().getDisplayName().toUpperCase()%></b></td>
	
		<td>
		<IMG title="<bean:message key='ui.label.Help' bundle='emMessages'/>" src="/expensemap/jsp/images/help.gif" border=0 align="right" style="CURSOR: pointer" onClick="window.open('<%=helpURL%>','help','')">
		</td>
		
	 </tr>
	</table>
	<table class="InnerTableWithBorder">
		<tr>
		    <td  NOWRAP align="center" class="thead"><a style="color:#330099;font-size:9pt;font-weight: bold;text-decoration: underline;" href="#" onClick="sort('name');">
		    	<bean:message key="ui.label.Name" bundle="dashboard" /></a>
		    	<%if((sortOrder != null && sortOrder.equals("desc")) && (sortCol != null && sortCol.equals("name"))){%>
					<img src="/expensemap/jsp/images/down.gif	 " border="0">
				<%}else if((sortOrder != null && sortOrder.equals("asc")) && (sortCol != null && sortCol.equals("name"))){%>
					<img src="/expensemap/jsp/images/up.gif" border="0"><%}%>
			</td> 
			<td nowrap class="thead" align="center">
				<bean:message key="ui.dashboard.pdf.export.notes" bundle="dashboard" />
			</td>
			<td nowrap class="thead" align="center" >
				<bean:message key="ui.label.dashboard"  bundle="dashboard" />
			</td>	
			<td nowrap class="thead" align="center" style="width:100;">
				<bean:message key="ui.dashboard.label.type" bundle="dashboard" />
			</td>
			<td nowrap class="thead" align="center"><a style="color:#330099;font-size:9pt;font-weight: bold;text-decoration: underline;" href="#" onClick="sort('dateCreated');">
				<bean:message key="ui.label.Date.Created" bundle="dashboard" /></a>
				<%if((sortOrder != null && sortOrder.equals("desc")) && (sortCol != null && sortCol.equals("dateCreated"))){%>
					<img src="/expensemap/jsp/images/down.gif	" border="0">
				<%}else if((sortOrder != null && sortOrder.equals("asc")) && (sortCol != null && sortCol.equals("dateCreated"))){%>
					<img src="/expensemap/jsp/images/up.gif" border="0"><%}%>
			</td>	
			<td nowrap class="thead" align="center">
				<bean:message key="ui.label.Status"  bundle="dashboard" />				
			</td>
			<td nowrap class="thead" align="center">
				<input id="selectAll" type="checkbox" onclick="checkAll(this);">
			</td>
	 </tr>
		
 <logic:iterate name="pdfList" type="com.emptoris.viewer.dashboards.common.valueobjects.PdfLinkViewBean" id = "pdfLinkViewBean" indexId="ctr">
		<c:choose>
			<c:when test="${ctr % 2 == 0}" >
				<c:set var="rowClass" value="trEven" scope="page" />
			</c:when>
			<c:otherwise>
				<c:set var="rowClass" value="trOddForPDF" scope="page" />
			</c:otherwise>
		</c:choose>
  <tr class="${rowClass}">
			<%
			Map<String,String> db = pdfLinkViewBean.getDashboards();
			String value = "";
			int dbCount=db.size(); //Dashboard count value will be used to set the rowSpan value in each row.
			if(pdfLinkViewBean.getStatus().equalsIgnoreCase("COMPLETED")||pdfLinkViewBean.getStatus().equalsIgnoreCase("STALE")){
			%>
			<td class=".tdStyle" align="left" rowSpan="<%=dbCount %>"><a style="text-decoration: underline;"
				href="#" onclick="openPDF('${ pdfLinkViewBean.fileName}','${ pdfLinkViewBean.eriId}','${ pdfLinkViewBean.status}','${ pdfLinkViewBean.fileId}');">
				<bean:write	name="pdfLinkViewBean" property="fileName" filter="false" /></a></td>
			<%}else{ %>	
			<td class=".tdStyle" align="left" rowSpan="<%=dbCount %>"><bean:write	name="pdfLinkViewBean" property="fileName" filter="false" /></td>
			<%}%>
			<td class=".tdStyle" align="left" rowSpan="<%=dbCount %>"><bean:write name="pdfLinkViewBean" property="notes" /></td>
			
			<% Iterator allDataItr = db.entrySet().iterator();
			   //iterator content will be like this : <db name>|<panel 1>,<panel 2>
				int dbCtr = 0;
				int  showRowData=0;
				while (allDataItr.hasNext()) {
					Map.Entry entry = (Map.Entry)allDataItr.next();
					value = (String)entry.getValue();
					String dbName = value.substring(0,value.indexOf("|"));			
					String panelStr = value.substring(value.indexOf("|")+1,value.length());
					String panelArray[] = panelStr.split(",");
					%>
					<%if(showRowData==0){%>
					<td class=".tdStyle"  align="left" > <%=dbName%> &nbsp;</td>
					<td class=".tdStyle" align="left" rowSpan="<%=dbCount %>"><a href="#" onclick="showPanelInfo('${ pdfLinkViewBean.fileId}');"><IMG SRC="../jsp/images/info_icon.gif"  BORDER="0" title="<bean:message key='ui.tool.tip.panel.info' bundle='dashboard'/>"/></a>  &nbsp;<bean:message key="${ pdfLinkViewBean.type}" bundle="dashboard"/></td>
					<td class=".tdStyle" align="center" rowSpan="<%=dbCount %>">
						<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" value="${ pdfLinkViewBean.dateCreated }" /></td>
					<td  class=".tdStyle" align="center" rowSpan="<%=dbCount %>">
					<%String status = "ui.label.status."+pdfLinkViewBean.getStatus();%>
					<bean:message key="<%=status%>" bundle="dashboard"/>			
					<%if(pdfLinkViewBean.getStatus().equalsIgnoreCase("STALE")){%>
						 <img src=/expensemap/jsp/images/report/reports_icon_data_refreshed.gif border=0 title="<bean:message key='ui.affected.data.refresh' bundle='dashboard'/>">
					<%}%>
					</td>
					<td  class=".tdStyle" align="center" rowSpan="<%=dbCount %>">
						 <c:choose>
								<c:when test="${pdfLinkViewBean.deleteEnabled}" >
									<input type="checkbox" name="selectBox" value="${pdfLinkViewBean.fileId}_${pdfLinkViewBean.status}" onclick="setButtons('${pdfLinkViewBean.status}', this);" />
								</c:when>
								<c:otherwise>
									<input type="checkbox" disabled="disabled" />
								</c:otherwise>
						</c:choose>
	     			</td> 
	     		</tr>
					<%}else{%>
						 <tr class="${rowClass}">
							<td class=".tdStyle"  align="left" > <%=dbName%> &nbsp;</td>
						</tr>
					<%}
					dbCtr ++;
					showRowData++;
					%> 
			<% }// end while (allDataItr.hasNext())
			 // Fix for PR # 72401 : handled the condition if there is no dashboard present.
			// if dbCtr == 0 it means there is not any dashboard present.	
			if (dbCtr == 0){%>
				<td class=".tdStyle"  align="left">&nbsp;</td>
				<td class=".tdStyle" align="left" rowSpan="<%=dbCount %>"><a href="#" onclick="showPanelInfo('${ pdfLinkViewBean.fileId}');"><IMG SRC="../jsp/images/info_icon.gif"  BORDER="0" title="<bean:message key='ui.tool.tip.panel.info' bundle='dashboard'/>"/></a>  &nbsp;<bean:message key="${ pdfLinkViewBean.type}" bundle="dashboard"/></td>
				<td class=".tdStyle" align="center" rowSpan="<%=dbCount %>">
				<fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" value="${ pdfLinkViewBean.dateCreated }" /></td>
				<td  class=".tdStyle" align="center" rowSpan="<%=dbCount %>">
				<%String status = "ui.label.status."+pdfLinkViewBean.getStatus();%>
				<bean:message key="<%=status%>" bundle="dashboard"/>			
					<%if(pdfLinkViewBean.getStatus().equalsIgnoreCase("STALE")){%>
						 <img src=/expensemap/jsp/images/report/reports_icon_data_refreshed.gif border=0 title="<bean:message key='ui.affected.data.refresh' bundle='dashboard'/>">
					<%}%>
				</td>
				<td  class=".tdStyle" align="center" rowSpan="<%=dbCount %>">
			 		<c:choose>
						<c:when test="${pdfLinkViewBean.deleteEnabled}" >
							<input type="checkbox" name="selectBox" value="${pdfLinkViewBean.fileId}_${pdfLinkViewBean.status}" onclick="setButtons('${pdfLinkViewBean.status}', this);" />
						</c:when>
						<c:otherwise>
							<input type="checkbox" disabled="disabled" />
						</c:otherwise>
					</c:choose>
				</td>
			<%}//end Fix for PR # 72401 %>
 </logic:iterate>
</table>
<BR>
		<table class="tableWithoutBorder" width="98%" >
			<tr>
				<td>
				   <c:if test="${!empty pdfList }" >
					<jsp:include flush="true" page="PDFListPagination.jsp" />
						
				   </c:if>
				</td>
			</tr>
		</table>

		<table class="tableWithoutBorder" width="98%">
		<tr>
		   <td>
		   <INPUT type="button" onClick="search();" value="<bean:message key='ui.label.Search' bundle='dashboard' />" />
		 	&nbsp;
		   <INPUT type="button" onclick="showPDFLinkPage();"  value="<bean:message key='ui.label.ShowAll' bundle='emMessages' />" name=showAllBtn /> 
            &nbsp;
		   <INPUT type="button" onClick="refreshList();" value="<bean:message key='ui.label.Refresh' bundle='dashboard' />" />
      	   &nbsp;
      	   <INPUT type="button" disabled onClick="deleteSelected();" id="deleteBtn" value="<bean:message key='ui.label.Delete' bundle='dashboard' />" />
           </td>
 	     </tr>
 	     </table>
	<input type="hidden" name="sortColumn" id="sortColumn" value="<c:out value='${ param.sortColumn }'/>">
	<input type="hidden" name="sortOrder"  id="sortOrder"    value="<c:out value='${ param.sortOrder }'/>">
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>

</form>
</body>
</html>