<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="java.net.URLEncoder"%>
<%@ page import="com.zeborg.expensemap.dashboard.model.DashboardPanelPreferences"%>
<%@ page import="com.zeborg.expensemap.framework.util.EmPropertyReader"%>
<%@ page import="org.owasp.esapi.ESAPI"%>

<% response.setHeader("Pragma", "no-cache");%>
<% response.setHeader("Cache-Control", "no-cache");%>
<% response.setDateHeader ("Expires", -1); %>

<%@ include file="dashboardPanelMenu.jspf"%>

<html>
<head>

<script  type="text/javascript"  src="/expensemap/jsp/javascript/yui/build/yahoo/yahoo-min.js"></script>
<!-- Dependencies --> 
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container_core-min.js"></script>
<!-- Source File -->
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>

<!-- Core + Skin CSS -->
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/menu/assets/skins/sam/menu.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/button/assets/skins/sam/button.css" />


<!-- panel renderer css -->
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/dashboards/panelRenderer.css" />

<style type="text/css">
.dashboardPanelContextMenu{	
 font-family: Arial, Helvetica, sans-serif;
 font-weight:normal;
 font-size: 13px; 
 color: #3A2278; 
 text-align: left;
 padding-right: 5px;
 padding-left: 5px;
 
 }
 </style>
<script type="text/javascript">

//Creating menu items array
var aItems=[
     {
     		text: "<bean:message key='ui.label.context' bundle='dashboard' />",    
     		submenu: {id: "<bean:message key='ui.label.context' bundle='dashboard' />",
     		itemdata: 
    		  [
   				 [
    				 { text: "<bean:message key='button.tableView' bundle='dashboard' />", onclick: { fn: renderView , obj: ["TABLE"]} },
    				 { text: "<bean:message key='ui.label.fit.to.window' bundle='dashboard' />", onclick: { fn: refreshOnly , obj: ["GRAPH"]} }
   				 ],
   				 [
     				 { text: "<bean:message key='ui.remove.filter' bundle='dashboard' />", onclick: { fn: removeFilter } },
     				 { text: "<bean:message key='ui.dashboard.menu.zoom.out' bundle='dashboard' />", onclick: { fn: levelUp } },
     				 { text: "<bean:message key='ui.dashboard.menu.static.window' bundle='dashboard' />", onclick: { fn: setStaticval } }
    			 ],
    			 [
      			 <% if(Boolean.TRUE.equals(request.getAttribute("ExportToPdfForNewDashboard"))){%> 
    			 	 { text: "<bean:message key='ui.dashboard.menu.export.to.pdf.link' bundle='dashboard' />",onclick: { fn: exportToPDF }},
    			 <% } %>
    				 { text: "<bean:message key='ui.dashboard.menu.preferences' bundle='dashboard' />", onclick: { fn: openPrefsWindow } }
                 ]
             ]
	      }
	},
    {
    	text: "<bean:message key='ui.label.dashboard' bundle='dashboard' />",    
    	submenu: {id: "<bean:message key='ui.label.dashboard' bundle='dashboard' />",
    	itemdata: 
    	 [
    		 [
    			  { text: "<bean:message key='ui.dashboard.menu.show.context' bundle='dashboard' />", onclick: { fn: parent.openContextPanel } }
    		 ],
    		 [
     			  { text: "<bean:message key='ui.dashboard.menu.snap.to.grid' bundle='dashboard' />", onclick: { fn: parent.snapToGrid } },
				  { text: "<bean:message key='ui.dashboard.menu.allreset' bundle='dashboard' />", onclick: { fn: resetAll , obj: ["GRAPH"]} },
    			  { text: "<bean:message key='ui.dashboard.menu.hide.all.panels' bundle='dashboard' />", onclick: { fn: parent.hideAllPanels } }
   			 ],
   			 [
      		 <% if(Boolean.TRUE.equals(request.getAttribute("CreateNewDashboard"))){
	      	     if("true".equals(request.getParameter("owner"))){%> 
    			  { text: "<bean:message key='ui.label.Edit' bundle='dashboard' />", onclick: { fn: editDashboard } },
	     	 <%  }
	      	    } %>
    			  { text: "<bean:message key='ui.label.Save' bundle='dashboard' />", onclick: { fn: saveDashboard } },
      		 <% if(Boolean.TRUE.equals(request.getAttribute("CreateNewDashboard"))){ %>
    			  { text: "<bean:message key='ui.dashboard.menu.saveas' bundle='dashboard' />", onclick: { fn: saveDashboardAs } },     
     		 <% }
      		    if(Boolean.TRUE.equals(request.getAttribute("ExportToPdfForNewDashboard"))){%> 
				  { text: "<bean:message key='ui.dashboard.menu.export.to.pdf.link' bundle='dashboard' />", onclick: { fn: exportDashboardAsPDF } },
     		 <% } %>
   				  { text: "<bean:message key='ui.label.ShowAll' bundle='dashboard' />", onclick: { fn: showAllDashboards } }
    		 ]
   		 ]
   	   }
    }   
  ];

//Instantiate context menu
var oContextMenu = new YAHOO.widget.ContextMenu("mycontextmenu", { trigger: document} );
//Add menu items and subscribe to the menu item on click event 
oContextMenu.addItems(aItems);
 

//getting submenu items for context menu Panel
var panelSubMenuItems= oContextMenu.getItem(0).cfg.getProperty("submenu");
var arrGroup=panelSubMenuItems.getItemGroups();
//getting static submenu item
var nonInteractiveSubMenuItem=arrGroup[1][2];

//function for submitting form on onclick event on menu item
function renderView(p_sType, p_aArgs, p_oValue) {
	changeView(p_oValue[0]);    
}


//function for submitting form on onclick event on menu item
function refreshOnly(p_sType, p_aArgs, p_oValue) {
	submitForm();    
}

function refreshOnPrefChange(){
    // var frm = document.getElementById("frm1");  
	// var panelType =document.getElementById("panelType").value;
	// frm.method="post";	
	// frm.action="/expensemap/dashboards/renderDashboardPanel.do?viewType=chart"+"&pWidth="+YAHOO.util.Dom.getViewportWidth()+"&pHeight="+YAHOO.util.Dom.getViewportHeight()+"&requestType=update"+"&pageNo=first";
	// frm.submit();	
}

//display under constuction 
function alertUnderConstruction(){
	alert('Under Construction ');
}

// Save a copy of the current dashboard.
function saveDashboardAs(){
	parent.openSaveAsBox ();
}

// Save current state of the dashboard.
function saveDashboard() {
	parent.saveDashboard();
}

//submit form
function changeView(viewType){	
	var frm = document.getElementById("frm1");
	var panelId = document.getElementById("dashboardPanelId").value;
	var filterNodes = parent.getFilters(panelId);
	if(!(filterNodes == "undefined" || filterNodes == null || filterNodes.length <= 0)){
		document.getElementById("beginIndex").value='1';	
	}
	frm.method="post";
	frm.action="/expensemap/dashboards/changeView.do?viewType="+viewType+"&pWidth="+YAHOO.util.Dom.getViewportWidth()+"&pHeight="+YAHOO.util.Dom.getViewportHeight()+"&drillDim="+filterNodes;
	frm.submit();
}


//submit form
function doPaging(beginIndex){
	var frm = document.getElementById("frm1"); 	
	document.getElementById("beginIndex").value=beginIndex;	
	var panelId = document.getElementById("dashboardPanelId").value;
	parent.panelPageMap[panelId]=beginIndex;	
	var filterNodes = parent.getFilters(panelId);
	frm.method="post";
	frm.action="/expensemap/dashboards/renderDashboardPanel.do?viewType=chart"+"&pWidth="+YAHOO.util.Dom.getViewportWidth()+"&pHeight="+YAHOO.util.Dom.getViewportHeight()+"&drillDim="+filterNodes;
	frm.submit();
}


//refresh view
function resetAll(p_sType, p_aArgs, p_oValue){
	refresh(p_oValue[0]);
}

//refresh view
function refresh(viewType){
	if(nonInteractiveSubMenuItem.cfg.getProperty("checked")){
		alert("<bean:message	key='ui.static.window' bundle='dashboard' />");
		return;
	}
	var bookMarkId =document.getElementById("bookMarkId").value;
	parent.resetAll(bookMarkId);
}

/**
 * This method is invoked when user decides to reset all dynamic panels for a bookmark.
 * It will clear the context filters and re-render the panel.
 */
function reset(bookMarkId){
	document.getElementById("beginIndex").value='1';
	parent.panelPageMap[panelId]='1';
	var bkid = document.getElementById("bookMarkId").value;
	if( bkid == bookMarkId ){
		if( ! nonInteractiveSubMenuItem.cfg.getProperty("checked") ) {
			var panelId = document.getElementById("dashboardPanelId").value;
			parent.panelContextFilters[panelId] = {};
			parent.panelContextFilterNames[panelId] = {};
			submitForm();
		}
    }
}

//opens preference window
function openPrefsWindow(){
	var dbId=document.getElementById("dashboardId").value;
	var dimensionName=document.getElementById("dimensionName").value;
	var dbPanelId=document.getElementById("dashboardPanelId").value;
	window.open("/expensemap/dashboards/showPanelPreferences.do?dbId="+dbId+"&dbPanelId="+dbPanelId,"Dashboard_Preferences","width=650,height=380,scrollbars=yes,toolbar=no,status=no,resizable=no");
}

//renders view for this node
function reRender(nodeId) {
	document.getElementById("beginIndex").value='1';	
	var isThisStatic = nonInteractiveSubMenuItem.cfg.getProperty("checked");
	var panId = document.getElementById("dashboardPanelId").value;
	var dimensionName= document.getElementById("dimensionName").value;
	var bookMarkId = document.getElementById("bookMarkId").value;
	parent.getBookmarkContextFilters(bookMarkId)[dimensionName]=nodeId;
	//parent.getBookmarkContextFilterNames(bookMarkId)[dimensionName]=nodeName;
	parent.notifyAllPanels(panId, dimensionName, nodeId, bookMarkId, isThisStatic);
	if( ! isThisStatic ) {
		parent.panelPageMap[panId]='1';
		var panelId = document.getElementById("dashboardPanelId").value;
		parent.getContextFiltersForPanel(panelId)[dimensionName] = nodeId;
		//parent.getContextFilterNamesForPanel(panelId)[dimensionName] = nodeName;
 		submitForm();
 	}
}

//go one level up
function levelUp() { 	
	var isThisStatic = nonInteractiveSubMenuItem.cfg.getProperty("checked");	
	if (!isThisStatic) {
		var dimensionName= document.getElementById("dimensionName").value;		      
	    var panelId = document.getElementById("dashboardPanelId").value;
	    var nodeId  = parent.getContextFiltersForPanel(panelId)[dimensionName];
		if(typeof nodeId =="undefined" || nodeId==0 ){			
			alert("<bean:message	key='ui.message.top.level' bundle='dashboard' />");
			return;	
		 }

		var ajaxResponse = null;
		try {
			var url = "/expensemap/dashboards/GetParentNode.do";
			ajaxResponse = eval(jQuery.ajax({
				url: url,
				type: "GET",
				data: {nodeId: nodeId, dimensionName: dimensionName},
				async: false
			}).responseText);					
				
			if (checkIfSessionActive(ajaxResponse) == false) {
				return;
			}
		} catch(e) {
			alert(e);			 
		}
		
		if (ajaxResponse[1] == 0) {
			removeFilter();
			return;
		} else {
			reRender(ajaxResponse[1]);
		}
	} else {
		alert("<bean:message key='ui.static.window' bundle='dashboard' />");
		return;
	}	
}

// Checks if session is still active.
function checkIfSessionActive(data) {
	if (data[0] == "Error"){
		var errorCode = data[1];
		if(errorCode == "session.timeout") {
			var timeoutURL = data[3];
			//for intg environment the location should be expensemap frame
			parent.location.href=timeoutURL;
			return false;
		}
	}
	return true;
}


//updates panel
function updateOnDrill(nodeId, dimensionName, bookMarkId ) {
	var bkid =document.getElementById("bookMarkId").value;   
	if ( bkid == bookMarkId ) {
		if( ! nonInteractiveSubMenuItem.cfg.getProperty("checked") ) {
			// Update the map of local context filters with the nodeId
			var panelId = document.getElementById("dashboardPanelId").value;
			parent.getContextFiltersForPanel(panelId)[dimensionName] = nodeId;
			submitForm();
	    }
	}
}



//remove filter
function removeFilter() {
	var dimensionName= document.getElementById("dimensionName").value;
	var bookMarkId = document.getElementById("bookMarkId").value;
	var panId = document.getElementById("dashboardPanelId").value;
	var isThisStatic = nonInteractiveSubMenuItem.cfg.getProperty("checked"); 
	if(typeof  parent.getContextFiltersForPanel(panId)[dimensionName]=='undefined'){
		alert("<bean:message key='ui.dashboard.renderBookmarkchartpage.noFiltermsg' bundle='dashboard' />");
		return;
	}
	parent.removeBookmarkFilterForDimension(bookMarkId, dimensionName); 
	parent.notifyAllPanelsOnFilterRemoval(panId, dimensionName,bookMarkId); 
    if( ! isThisStatic ) {            
 			delete parent.getContextFiltersForPanel(panId)[dimensionName]; 			 
  		    submitForm();
 	  } 
}

//update on filter removal
function updateOnFilterRemoval(dimensionName, bookMarkId){  
     var bkid =document.getElementById("bookMarkId").value; 
     var panId = document.getElementById("dashboardPanelId").value;
  	 if ( bkid == bookMarkId ) {
  		if( ! nonInteractiveSubMenuItem.cfg.getProperty("checked") ) {  		          
  			 delete parent.getContextFiltersForPanel(panId)[dimensionName];
  			 submitForm();
  	    }
	}
}

//submit
function submitForm() {
	var frm = document.getElementById("frm1");
	var panelId = document.getElementById("dashboardPanelId").value;
	var contextFilters = parent.getFilters(panelId);
	frm.method="post";	
	frm.action="/expensemap/dashboards/renderDashboardPanel.do?viewType=chart&pWidth="+YAHOO.util.Dom.getViewportWidth()+"&pHeight="+YAHOO.util.Dom.getViewportHeight()+"&drillDim="+contextFilters;
	frm.submit();
}

//set panel static
function setStaticval(){

	var panelId = document.getElementById("dashboardPanelId").value;
	var bookMarkId = document.getElementById("bookMarkId").value;
	
	if(nonInteractiveSubMenuItem.cfg.getProperty("checked")==true){
		nonInteractiveSubMenuItem.cfg.setProperty("checked", false);
		document.getElementById("glow").bgColor='';
		parent.synchronizeFilters(bookMarkId,panelId);
	}else{
		nonInteractiveSubMenuItem.cfg.setProperty("checked", true);
		document.getElementById("glow").bgColor='#E0E0E0';
	}
	document.getElementById("staticVal").value =nonInteractiveSubMenuItem.cfg.getProperty("checked");		
	parent.panelStaticMap[panelId]=document.getElementById("staticVal").value;
}


//when dom is ready do the following
YAHOO.util.Event.onDOMReady(function () {
  //rendering menu inside DOMready so that 
  //It should render in a proper way
   oContextMenu.render(document.body);
 	var statVal='<%=ESAPI.encoder().encodeForJavaScript(request.getParameter("staticVal"))%>';
	var contextMenuStyle='dashboardPanelContextMenu';
	if(statVal=='null'){
		statVal=false;
		document.getElementById("glow").bgColor='';
	}if(statVal=='false'){
		statVal=false;
		document.getElementById("glow").bgColor='';
	}if(statVal=='true'){
		statVal=true;
		document.getElementById("glow").bgColor='#E0E0E0';
	}
	nonInteractiveSubMenuItem.cfg.setProperty("checked", statVal);
	//setting style to context menu items
	oContextMenu.getItem(0).cfg.setProperty("classname",contextMenuStyle);
	oContextMenu.getItem(1).cfg.setProperty("classname",contextMenuStyle);
	
});

// shows list of all dashboards
function showAllDashboards(){
	parent.showAllDashboards();
}

//renders to the edit page
function editDashboard(){
	parent.editDashboard();
}

function exportToPDF(){
	parent.setValuesForPDFExport();
	var ht = 500;
	var wt = 750;
	var left = (screen.width/2)-(wt/2);
	var top = (screen.height/2)-(ht/2);	
	var dashboardid = document.getElementById("dashboardId").value;
	var panelId = document.getElementById("dashboardPanelId").value;
	window.open("/expensemap/dashboards/getPDFExportDialog.do?exportType=dashboardPanel&dashboardId="+dashboardid+"&panelId="+panelId,"_blank","scrollbars=yes,resizable=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
}

/**
 * Use this function to invoke dashboard export dialog.
 */
function exportDashboardAsPDF() {
	parent.exportToPDF();
}
</script>



</head>

<body class="yui-skin-sam" TOPMARGIN="0">
<table style="top: 25px;" WIDTH="100%">
<tr>
<td>
<logic:messagesPresent message="true">
	<br>
	<font color="red" face="Verdana" size="2">
		<html:messages id="msg" message="true" bundle="dashboard">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
	</font>
</logic:messagesPresent>

<logic:messagesNotPresent message="true" >
<script>
var imgUrl = escape("bookmarkChartImage.shtm?done=true&request=image&width=${pWidth}&height=${pHeight}&chartAttrName=${chartAttrName}");
var sUrl = "bookmarkChartImage.shtm?request=imagemap&width=${pWidth}&height=${pHeight}&chartAttrName=${chartAttrName}&image=" + imgUrl;
var callback = {   
	 	success: function(o) {
	 		if ( o.responseText !== undefined) {
	 			document.getElementById('chartImage').innerHTML = o.responseText;
	 		}
	 	}
	};
	YAHOO.util.Connect.asyncRequest('POST', sUrl, callback);
</script>
<table border="0" cellpadding="0" cellspacing="0" bgcolor="#FFFFFF">
	<tr>
		<td align="center">
		<div id="canvas">
		<center><div id="chartImage"></div></center>
		</div>
		</td>
	</tr>
</table>
</logic:messagesNotPresent>
</td>
</tr>
</table>
</body>
</html>