<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf" %>
<%@ page import="java.util.List, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil,java.util.List"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="java.util.Date,java.text.SimpleDateFormat,org.apache.commons.lang.StringEscapeUtils"%>
<%@ page import="com.emptoris.viewer.dashboards.common.valueobjects.DashboardPanelInfo"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="com.zeborg.expensemap.view.HelpUtil,com.zeborg.acl.util.LocaleUtil" %>
<%@ page import="com.zeborg.util.WebUtil,java.util.Locale,org.apache.struts.util.LabelValueBean"%>
<%@ page import="com.emptoris.viewer.dashboards.common.util.DashboardConstants"%>
<%@ page import="com.zeborg.expensemap.view.TableViewUtil" %>
<%@ page import="com.zeborg.util.EncodeUtil" %>
<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ page import="com.zeborg.expensemap.view.FormatUtil"%>

<html>
<head>
<TITLE><%=ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.dashboard.create.page.dashboard.details.title"  bundle="dashboard" /></TITLE>

<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/reset/reset-min.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/yui-container-override.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/progressbar/assets/skins/sam/progressbar.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/renderdashboard.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/dashboards/scripts/dashboardPanel.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/export.css">
<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>

<style type="text/css">
.hidden {
display: none;
}
</style>
<%@ include file="header.jsp" %>
<%
    //make url for help page
	//ZSession zs = ZSessionUtil.getFromSession(pageContext);
    Locale locale = zs.getUser().getLocale();
	HelpUtil emHelp = HelpUtil.getHelpUtil();
	//set return to url
	String sortCol="dateCreated";
	String dashBoardSortOrder = "desc";
	
	pageContext.setAttribute("returnToURL", "../showDashboardPage.xhtm", PageContext.SESSION_SCOPE);
	String rDbid=null;
	if(request.getParameter("dashBoardId")!=null){
		rDbid=(String)request.getParameter("dashBoardId");
	}else if((String)request.getAttribute("newDashboardId")!=null){
		rDbid=(String)request.getAttribute("newDashboardId");
	}else if(request.getAttribute("dashBoardId")!=null){
		rDbid=(String)request.getAttribute("dashBoardId");
	}else if(request.getParameter("newDashboardId")!=null){
		rDbid=(String)request.getParameter("newDashboardId");
	}

	List<DashboardPanelInfo> panelUrls =(List<DashboardPanelInfo>) request.getAttribute("urlInfo");
	int numOfPanles = (panelUrls == null) ? 0 : panelUrls.size();	
	
	// Total number of loadable panels, excludes attachment and external link panels.
	int totalLoadablePanels = 0;
	if (panelUrls != null) {
		for (DashboardPanelInfo panel: panelUrls) {
			if (panel.isOnLoadEventToBeTracked()) {
				totalLoadablePanels++;
			}
		}
	}
	String dateString = new SimpleDateFormat("MM_dd_yyyy").format(new Date());
	String userNumberFormat = zs.getUser().getNumberFormat();
%>

<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/animation/animation-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/utilities/utilities.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="/expensemap/scripts/loadingPanel.js"></script>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>

<script type="text/javascript">
	var allInteractiveFrames = {};
	// keep track of loaded panels
	var totalLoadablePanelsLoaded = 0;
	
	/* This JS function performs two actions:
	 * 1. Store the frame in the collection of interactive panels if it is INTERACTIVE. 
	 * 2. Hide loading progress bar when all panels(iframes) are loaded.
	 */
	function registerMe(frame, panelCount, panelId, isInteractive, isOnLoadEventToBeTracked) {
		if ( isInteractive ) {   
			allInteractiveFrames[panelId] = frame;
		}
		
		if (isOnLoadEventToBeTracked) {
			totalLoadablePanelsLoaded++;
		}
		
		/* First we are setting iframe src to "about:blank" and then body is loaded, we set it to actual panel contents.
		 * Hence, iframes emit onLoad event twice.
		 */
		if ((totalLoadablePanelsLoaded/2 == <%= totalLoadablePanels %>) && typeof loadingPanel != "undefined") {
			loadingPanel.hide();
		}
	}
</script>
</head>

<jsp:include page="/jsp/topMenu.jsp">
	<jsp:param name="topMenuForm" value="dashboardRenderForm"/>
	<jsp:param name="isDashboardRenderPage" value="true"/>
	<jsp:param name="isdbowner" value="${dbowner}"/>
	<jsp:param name="helpUrl" value="<%=HelpUtil.getHelpUtil().getHelpURLString(DashboardConstants.RENDER_DASHBOARD_PAGE_HELP_URL, locale)%>"/>
</jsp:include>

<body id="dash-body" class="yui-skin-sam" onload="setIFrameSources();">

<br>
<logic:messagesPresent message="true">
	<br>
	<font color="red" face="Verdana" size="2">
		<html:messages id="msg" message="true" bundle="dashboard">
			<%=pageContext.findAttribute("msg")%>
		</html:messages>
	</font>
</logic:messagesPresent>
<c:if test="${! empty dashboardName }">

<html:form styleId="dashboardRenderForm" action="/saveAsDashbaord">

<TABLE  width="100%" height="40%" border="0" align="center" cellpadding="0" cellspacing="0" >
 <tr>
    <td><table width="100%" border="0" cellspacing="0" cellpadding="0">
      <tr>
        <td nowrap="nowrap" class="dashName">${ dashboardName }</td>
        <td width="100%" class="dashDescription" title="${dbDescForContextPanel}">${ dashboardDesc }</td>
        <td nowrap="nowrap" class="dashShowHide"><b><bean:message key="ui.dashboard.label.show.panels" bundle="dashboard" /></b></td>
        <td align="left" valign="bottom" nowrap="nowrap" class="showPanelsarea">
		<%
			for(int panelCount=0;panelCount< panelUrls.size();panelCount++){
				String panelId=panelUrls.get(panelCount).getPanelId();
				String panelIdStr="panel"+(panelCount+1);
				String hiddenPanelIdStr="hidden_panel"+(panelCount+1);
				String showIdStr="showbutton"+(panelCount+1);
				boolean isInteractive = panelUrls.get(panelCount).isInteractive();
				boolean isOnLoadEventToBeTracked = panelUrls.get(panelCount).isOnLoadEventToBeTracked();
				String pUrl="/expensemap/dashboards/renderDashboardPanel.do?"+panelUrls.get(panelCount).getUrlString();
		%> 
			<img   id="<%=showIdStr%>"   src="/expensemap/jsp/images/dashboard/panel_icon_on.gif"  title="<%=panelUrls.get(panelCount).getPanelString()%>" border="0" style="cursor:pointer" onclick="toggleToOnImage(this)"> 	
			<div id="<%=panelIdStr%>" >
				<div class="hd"><%=panelUrls.get(panelCount).getPanelString()%></div>
				<div class="bd" >
					<iframe id="<%=panelId%>" src ="about:blank"  frameborder="0"  style="height:100%;width:100%;"
						onload="javascript:registerMe(this,'<%=panelCount%>', '<%=panelId%>', <%=isInteractive%>, <%=isOnLoadEventToBeTracked%>);"></iframe>
				</div>
			</div>
			<input type="hidden" id="<%=hiddenPanelIdStr%>" value='<%=panelId%>'>
		<%}%>
		</td>
      </tr>
      <tr>
        <td height="5" class="dashBand1"><img src="/expensemap/jsp/images/transparent.gif" width="1" height="5" /></td>
        <td height="5" bgcolor="#EEEEEE" class="dashBand2"><img src="/expensemap/jsp/images/transparent.gif" width="1" height="1" /></td>
        <td height="5" bgcolor="#EEEEEE" class="dashBand2"><img src="/expensemap/jsp/images/transparent.gif" width="1" height="1" /></td>
        <td height="5" bgcolor="#EEEEEE" class="dashBand3"><img src="/expensemap/jsp/images/transparent.gif" width="1" height="1" /></td>
      </tr>
    </table></td>
  </tr>
  <tr>
    <td align="center" valign="top" class="dashBotarea"><img src="/expensemap/jsp/images/transparent.gif" width="1" height="450" /></td>
  </tr>
</TABLE>
<input type="hidden" id="dashboardId" value='<%=ESAPI.encoder().encodeForHTML(rDbid)%>'>
<input type="hidden" id="dashboardName" value='${ dashboardName }'>
<input type="hidden" id="dashboardDesc" value='${ dashboardDesc }'>
<input type="hidden" id="dbDescForContextPanel" value='${dbDescForContextPanel}'>
<input type="hidden" id="dashboardOwner" value='${ dashboardOwner }'>
<input type="hidden" id="dashboardate" value='${ dashboardDateCreated }'>

<html:hidden styleId="panelsXYLocations"    property="panelsXYLocations"/>
<html:hidden styleId="panelDimension"       property="panelDimension"/>
<html:hidden styleId="panelsVisibility"     property="panelsVisibility"/>
<html:hidden styleId="panelFilters"         property="panelFilters"/>
<html:hidden styleId="staticPanelString"    property="staticPanelString"/>
<html:hidden styleId="panelPageString"      property="panelPageString"/>
<html:hidden styleId="showContext"          property="showContext"/>

<input type="hidden" name="numberFormat" value="" />
<input type="hidden" name="fileName" value="" />
<input type="hidden" name="userInputFileName" value="" />
<input type="hidden" name="reportName" value="" />
<input type="hidden" name="exportType" value=""/>
<input type="hidden" name="dimensionName" value="" />

<input type="hidden" id="PDFpanelFilters" />
<input type="hidden" id="PDFpanelPageString" />
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</html:form>
<div id="yuiLoadingPanel"></div>
<div id="info">
<div class="hd">
<span class="modalHeaderStyle"><bean:message key="ui.dashboard.create.page.dashboar.context" bundle="dashboard" /></span>
</div>
<div class="bd">
<table>
<tr><td><span class="modalHeaderStyle"><bean:message key="ui.label.Name" bundle="dashboard" />:</span></td>
	<td><span class="modalHeaderStyle">${dashboardName}</span></td>
</tr>
<tr>
	<td><span class="modalHeaderStyle"><bean:message key="ui.label.Description" bundle="dashboard" />:</span></td>
	<td><span class="modalHeaderStyle">${dashboardDesc}</span></td>
</tr>
<tr>
	<td><span class="modalHeaderStyle"><bean:message key="ui.label.Created.By" bundle="dashboard" />:</span></td>
	<td><span class="modalHeaderStyle">${dashboardOwner}</span></td>
</tr>
<tr>
	<td><span class="modalHeaderStyle"><bean:message key="ui.label.Date.Created" bundle="dashboard" />:</span></td>
	<td><span class="modalHeaderStyle">${dashboardDateCreated}</span></td>
</tr>
</table>
</div>
</div>

<script type="text/javascript">
//global array for panels
var allPanels = new Array();
var panelIdArray = new Array();
var locationMap = {}; //stores panel's xy location. key = panelId(panel1,panel2,....)
var dimensionMap = {}; //stores panel's height and width. key = panelId(panel1,panel2,....)
var panelVisibilityMap = {}; //stores panel's visibility info. key = panelId(panel1,panel2,....)
var currentHeightWidth = {}; //this will have current height and width info of panel. key = panelId(panel1,panel2,....)

var panelContextFilters = {};
var panelContextFilterNames = {};
var panelStaticMap={};
var panelPageMap={};
var bookmarkContextFilters={};//map for maintaining filters on bookmark level
var bookmarkContextFilterNames={};//map for maintaining filter node names on bookmark level

var dbNamePanel;
var dbExportPanel;
var contextPanel;
var contentReady=false;

//panel preferences
var isDashboardPage='true';
var xVal1='${ panelAnchorX }';
var yVal1='${ panelAnchorY }';	
var panelHeight1='${ panelHeight }';
var panelWidth1= '${ panelWidth }';	

var loadingPanel;

var panelIDName = {};
var fileName = {};
var userNumberFormat = '<%=userNumberFormat%>';

<%
	for ( int i=0; i < panelUrls.size(); i++ ) {
%>
	panelIDName['<%=panelUrls.get(i).getPanelId()%>'] = '<%=StringEscapeUtils.escapeHtml(panelUrls.get(i).getPanelString())%>';
	fileName['<%=panelUrls.get(i).getPanelId()%>'] = '<%=panelUrls.get(i).getPanelString()%>';
<%
}
%>

/**
 * Returns a Map containing Context filters for specified bookmarkId.
 * @param bkId
 */
function getBookmarkContextFilters(bookMarkId) {
	if( bookmarkContextFilters[bookMarkId] == null ) {
		bookmarkContextFilters[bookMarkId]={};
	}
	return bookmarkContextFilters[bookMarkId];
}

/**
 * Returns a Map containing Context filter names for specified bookmarkId.
 * @param bkId
 */
function getBookmarkContextFilterNames(bookMarkId) {
	if( bookmarkContextFilterNames[bookMarkId] == null ) {
		bookmarkContextFilterNames[bookMarkId]={};
	}
	return bookmarkContextFilterNames[bookMarkId];
}

/**
 * Returns a Map containing Context filter names for specified bookmarkId.
 * @param bookmarkId
 * @param panelId
 *
 */
function synchronizeFilters(bookmarkId,panelId) {
	
    panelContextFilters[panelId]={};
    panelContextFilterNames[panelId]={};
    
    var panelFilterMap = getContextFiltersForPanel(panelId);
    var bookmarkFilterMap = getBookmarkContextFilters(bookmarkId);
    
    var panelFilterNameMap =getContextFilterNamesForPanel(panelId);
    var bookmarkFilterNameMap=getBookmarkContextFilterNames(bookmarkId);

	//copy filters from bookmark map to panel map.
	for( key in bookmarkFilterMap ) {
		delete panelFilterMap[key];
		panelFilterMap[key]=bookmarkFilterMap[key];
	}

    //copy filters from bookmark map to panel map.
    for( key in bookmarkFilterNameMap ) {
		delete panelFilterNameMap[key];
		panelFilterNameMap[key]=bookmarkFilterNameMap[key];
	}
}

/**
 * Returns a Map containing Context filters for specified panel id.
 * @param bkId
 */
function getContextFiltersForPanel(panelId) {
	if ( panelContextFilters[panelId] == null ) {
		panelContextFilters[panelId] ={};
	}
	return panelContextFilters[panelId];
}

/**
 * Returns a Map containing Context filters for specified panel id.
 * @param bkId
 */
function getContextFilterNamesForPanel(panelId) {
	if ( panelContextFilterNames[panelId] == null ) {
		panelContextFilterNames[panelId] ={};
	}
	return panelContextFilterNames[panelId];
}

//display all panels
function showAll() {
	for(var i = 1; i <= num; i++ ) {
		allPanels[i].show();
		oPanel1.cfg.setProperty("xy", [300,159]);
	}	
}

//hide all panels
function hideAllPanels(){
	for(var panelNo = 1; panelNo < allPanels.length; panelNo++ ) {
		if(panelVisibilityMap[allPanels[panelNo].id] == "true"){
			allPanels[panelNo].hide();
			var image = document.getElementById("showbutton"+panelNo);
			image.src=image.src.substring(0,image.src.lastIndexOf('/')+1)+"panel_icon_off.gif";
			panelVisibilityMap[allPanels[panelNo].id] = 'false';	
		}
	}
}

//display single panel
function showSinglePanel(e, objPan){	
	objPan.show();
	panelVisibilityMap[objPan.id] = 'true';
}

//opens panel in center of screen 
function openSinglePanel(e, objPan){ 
	if(panelVisibilityMap[objPan.id]=='false'){
	    //added for snap 
	   objPan.cfg.setProperty("xy", [300,200]);
	   objPan.bringToTop ();
	   //added for snap 
	   objPan.show();
	   panelVisibilityMap[objPan.id] = 'true';
	}	
	
}


function toggleToOnImage(image){
	var iamge_name = image.src.substring(image.src.lastIndexOf('/')+1);
	if(iamge_name=="panel_icon_off.gif"){
		image.src=image.src.substring(0,image.src.lastIndexOf('/')+1)+"panel_icon_on.gif";
	}
}
function closePanel(e, objPan){
	var panelNo = objPan.id.substring(5)
	var image = document.getElementById("showbutton"+panelNo);
	image.src=image.src.substring(0,image.src.lastIndexOf('/')+1)+"panel_icon_off.gif";
	panelVisibilityMap[objPan.id] = 'false';
}

// BEGIN RESIZEPANEL SUBCLASS //
YAHOO.widget.ResizePanel = function(el, userConfig) {
    if (arguments.length > 0) {
        YAHOO.widget.ResizePanel.superclass.constructor.call(this, el, userConfig);
    }
}

YAHOO.widget.ResizePanel.CSS_PANEL_RESIZE = "yui-resizepanel";
YAHOO.widget.ResizePanel.CSS_RESIZE_HANDLE = "resizehandle";

YAHOO.extend(YAHOO.widget.ResizePanel, YAHOO.widget.Panel, {
	init: function(el, userConfig) {
		YAHOO.widget.ResizePanel.superclass.init.call(this, el);
		this.beforeInitEvent.fire(YAHOO.widget.ResizePanel);

		var Dom = YAHOO.util.Dom,
			Event = YAHOO.util.Event,
			oInnerElement = this.innerElement,
			oResizeHandle = document.createElement("DIV"),
			sResizeHandleId = this.id + "_resizehandle";

		oResizeHandle.id = sResizeHandleId;
		oResizeHandle.className = YAHOO.widget.ResizePanel.CSS_RESIZE_HANDLE;

		Dom.addClass(oInnerElement, YAHOO.widget.ResizePanel.CSS_PANEL_RESIZE);

		this.resizeHandle = oResizeHandle;

		function initResizeFunctionality() {
            var me = this,
                oHeader = this.header,
                oBody = this.body,
                nStartWidth,
                nStartHeight,
                aStartPos,
                nBodyBorderTopWidth,
                nBodyBorderBottomWidth,
                nBodyTopPadding,
                nBodyBottomPadding,
                nBodyOffset;

            oInnerElement.appendChild(oResizeHandle);
            this.ddResize = new YAHOO.util.DragDrop(sResizeHandleId, this.id);
            this.ddResize.setHandleElId(sResizeHandleId);
            this.ddResize.onMouseDown = function(e) {
                nStartWidth = oInnerElement.offsetWidth;
                nStartHeight = oInnerElement.offsetHeight;
                if (YAHOO.env.ua.ie && document.compatMode == "BackCompat") {
                    nBodyOffset = 0;
                } else {
                    nBodyBorderTopWidth = parseInt(Dom.getStyle(oBody, "borderTopWidth"), 10),
                    nBodyBorderBottomWidth = parseInt(Dom.getStyle(oBody, "borderBottomWidth"), 10),
                    nBodyTopPadding = parseInt(Dom.getStyle(oBody, "paddingTop"), 10),
                    nBodyBottomPadding = parseInt(Dom.getStyle(oBody, "paddingBottom"), 10),
                    nBodyOffset = nBodyBorderTopWidth + nBodyBorderBottomWidth + nBodyTopPadding + nBodyBottomPadding;
                }
                me.cfg.setProperty("width", nStartWidth + "px");
                aStartPos = [Event.getPageX(e), Event.getPageY(e)];
            };

            this.ddResize.onDrag = function(e) {
                var aNewPos = [Event.getPageX(e), Event.getPageY(e)],
                    nOffsetX = aNewPos[0] - aStartPos[0],
                    nOffsetY = aNewPos[1] - aStartPos[1],
                    nNewWidth = Math.max(nStartWidth + nOffsetX, 10),
                    nNewHeight = Math.max(nStartHeight + nOffsetY, 10),
                    nBodyHeight = (nNewHeight - (oHeader.offsetHeight + nBodyOffset));

                me.cfg.setProperty("width", nNewWidth + "px");

                if (nBodyHeight < 0) {
                    nBodyHeight = 0;
                }
                oBody.style.height =  nBodyHeight + "px";
                currentHeightWidth[me.id] = nBodyHeight + "px" + ',' + nNewWidth + "px";
               
            };
        }

        function onBeforeShow() {
			initResizeFunctionality.call(this);
			this.unsubscribe("beforeShow", onBeforeShow);
        }

        function onBeforeRender() {
            if (this.cfg.getProperty("visible")) {
                initResizeFunctionality.call(this);
            } else {
                this.subscribe("beforeShow", onBeforeShow);
            }
            this.unsubscribe("beforeRender", onBeforeRender);
        }
        this.subscribe("beforeRender", onBeforeRender);
        if (userConfig) {
            this.cfg.applyConfig(userConfig, true);
        }
        this.initEvent.fire(YAHOO.widget.ResizePanel);
    },

    toString: function() {
        return "ResizePanel " + this.id;
    }
});
// END RESIZEPANEL SUBCLASS //

/** 
 * To get around the firefox/chrome bug which causes the iframe src locations to be hit twice when used with YUI panel, 
 * we set iframe source after DOM is ready for manipulation.
 */
function setIFrameSources() {
	<%
		for(int panelCount=0;panelCount< panelUrls.size();panelCount++) {
			String panelId=panelUrls.get(panelCount).getPanelId();
			String pUrl="/expensemap/dashboards/renderDashboardPanel.do?"+panelUrls.get(panelCount).getUrlString();
	%> 
	document.getElementById('<%=panelId%>').src = '<%=pUrl%>';
	<%}%>
}

//initialize single panel
function initializePanel(panelId,xVal,yVal,hVal,wVal) {	
	// create a new panel
	var h = parseInt(hVal)+"px";
	var w = wVal+"px";
	var oPanel = new YAHOO.widget.ResizePanel("panel" + panelId, {width: w, height: h, fixedcenter: false, constraintoviewport: false, visible: true} );
	oPanel.cfg.setProperty("xy", [xVal,yVal]);
	oPanel.render();
	
	// Register event handlers.
	YAHOO.util.Event.on("showbutton" + panelId, "click", openSinglePanel, oPanel);
	YAHOO.util.Event.on("hidebutton" + panelId, "click", oPanel.hide, null, oPanel);
	YAHOO.util.Event.on("panel" + panelId, "click", myfunction, oPanel);
	
	var closeEl = YAHOO.util.Dom.getElementsByClassName("container-close", null, oPanel.element)[0]; 
	YAHOO.util.Event.on(closeEl, "click", closePanel, oPanel);

	// Save the reference to this panel in a Global array/map.
	allPanels[panelId] = oPanel;
	panelIdArray[panelId] = "panel" + panelId;
	currentHeightWidth["panel" + panelId] = h + ',' + w;
}

//creates specified number of panels
function createPanels(num) {
    var xVal = '';
    var yVal = '';
    var height = '';
    var width = '';
	for(var i = 1; i <= num; i++ ) {
		var key = 'panel'+i;
		var temp = locationMap[key];
		xVal = temp.substring(0,temp.indexOf(','));
		yVal = temp.substring(temp.indexOf(',')+1,temp.length);
		xVal = parseInt(xVal);
		yVal = parseInt(yVal);
		var dim = dimensionMap[key];
		height = dim.substring(0,dim.indexOf(','));
		width = dim.substring(dim.indexOf(',')+1,dim.length);
		initializePanel(i,xVal,yVal,height,width);
	}

	for(var i = 1; i <= num; i++ ) {
		var key = 'panel'+i;
		var prop = panelVisibilityMap[key];
		var panelObj = allPanels[i];
		if(prop == 'true'){
			showSinglePanel(null,panelObj);
		}else if(prop == 'false'){
			panelObj.hide();
			closePanel(null,panelObj);
		}
	}
}

function showContext(){
	if(document.getElementById('showContext').value=='true')
		openContextPanel();
}

YAHOO.util.Event.onDOMReady(function() {
	// Show loading panel only if dashboard contains loadable panels
	if (<%= totalLoadablePanels %>) {
		loadingPanel = new yuiLoadingPanel({header:''});
		loadingPanel.show("<bean:message key='ui.dashboard.page.loading' bundle='dashboard' />");
	}

	contextPanel= new YAHOO.widget.Panel("info", { width: "500px", visible: false, 
		fixedcenter: true, constraintoviewport: true } );
	contextPanel.render();
		
	// load panel XY position map
	initPanelXYPositionMap();

	// load panel size map
	initPanelDimensionsMap();
	
	// load panel visibility map
	initPanelVisibilityMap();
	
	//load filter map
	initContextFiltersMap();

	//load filter name map
	initContextFilterNamesMap();

	//load staticstatmap
	initStaticPanelMap();
	
	// load panel paging map
	initPagingInfoMap();
	
	//load bookmark filter map
	initBookmarkFilterMap();
	
	//init bookmark filter map
	initBookmarkNameFiletrMap();

	// showContext();

	createPanels('<%=numOfPanles%>');
	
	// make loading progress bar modal by manipulating z-index
	var D = YAHOO.util.Dom; 
	D.setStyle("yuiLoadingPanel_mask", "z-index", '<%=numOfPanles * 2 + 1%>'); // semi-transparent black background
	D.setStyle("yuiLoadingPanel_c", "z-index", '<%=numOfPanles * 2 + 2%>'); // progress bar
	});

/**
 * Initialise JS map to store bookmark context filters.
 */
function initBookmarkFilterMap() {
	var bookMarkFiltersStr = '${ bookmarkFilters }';
	var bmkfArr=bookMarkFiltersStr.split(';');
	for( var i=0; i < bmkfArr.length; i++ ) {
		var temp = bmkfArr[i];
		if( trim(temp) != '' ) {
			var key = temp.substring(0,temp.indexOf('|'));
			var val = temp.substring(temp.indexOf('|')+1,temp.length);
			var valArr=val.split(',');
			for(var j=0; j < valArr.length; j++ ) {
				if( trim(valArr[j]) != '' ) {
					var nodeArr=valArr[j].split(':');					
					getBookmarkContextFilters(key)[nodeArr[0]]=nodeArr[1];	                
				}
			}
		}
	 }
}

/**
 * Initialise JS map to store bookmark context filters.
 */
function initBookmarkNameFiletrMap() {
	var bookMarkFiltersNameStr = '${ bookmarkFiltersName }';
	var bmkNamefArr=bookMarkFiltersNameStr.split(';');
	for( var i=0; i < bmkNamefArr.length; i++ ) {
		var temp =bmkNamefArr[i];
		if( trim(temp) != '' ) {
			var key = temp.substring(0,temp.indexOf('|'));
			var val = temp.substring(temp.indexOf('|')+1,temp.length);
			var valArr=val.split(',');
			for(var j=0; j < valArr.length; j++ ) {
				if( trim(valArr[j]) != '' ) {
					var nodeArr=valArr[j].split(':');					
					getBookmarkContextFilterNames(key)[nodeArr[0]]=nodeArr[1];	                
				}
			}
		}
	 }
}

/**
 * Initialise JS map to store panelwise XY position.
 */
function initPanelXYPositionMap() {
	var xyListStr = '${ xyList }';
	var arr = xyListStr.split(';');
	for(var i=0;i<arr.length;i++){
		var temp = arr[i];
		var key = temp.substring(0,temp.indexOf(':'));
		var val = temp.substring(temp.indexOf(':')+1,temp.length);
		locationMap[key] = val;
	}
}
/**
 * Initialise JS map to store panelwise visibility state.
 */
function initPanelDimensionsMap() {
	var panelDimension = '${ panelDimension }';
	var dimArr = panelDimension.split(';');
	for(var i=0;i<dimArr.length;i++){
		var temp = dimArr[i];
		var key = temp.substring(0,temp.indexOf(':'));
		var val = temp.substring(temp.indexOf(':')+1,temp.length);
		dimensionMap[key] = val;
	}

}
/**
 * Initialise JS map to store panelwise visibility state.
 */
function initPanelVisibilityMap() {
	var panelsVisibility = '${ panelsVisibility }';
	var visArr = panelsVisibility.split(';');
	for(var i=0;i<visArr.length;i++){
		var temp = visArr[i];
		var key = temp.substring(0,temp.indexOf(':'));
		var val = temp.substring(temp.indexOf(':')+1,temp.length);
		panelVisibilityMap[key] = val;
	}
}
/**
 * Initialise JS map to store panelwise context filters.
 */
function initContextFiltersMap() {
	var contextFiltersStr = '${ contextFiltersStr }';
	var panfArr=contextFiltersStr.split(';');
	for( var i=0; i < panfArr.length; i++ ) {
		var temp = panfArr[i];
		if( trim(temp) != '' ) {
			var key = temp.substring(0,temp.indexOf('|'));
			var val = temp.substring(temp.indexOf('|')+1,temp.length);
			var valArr=val.split(',');
			for(var j=0; j < valArr.length; j++ ) {
				if( trim(valArr[j]) != '' ) {
					var nodeArr=valArr[j].split(':');
					getContextFiltersForPanel(key)[nodeArr[0]] =nodeArr[1];
				}
			}
		}
	 }
}

/**
 * Initialise JS map to store panelwise context filter names.
 */
function initContextFilterNamesMap() {
	var contextFiltersNameStr = '${ contextFiltersNameStr }';
	var panfNameArr = contextFiltersNameStr.split(';');
	for( var i=0; i < panfNameArr.length; i++ ) {
		var temp = panfNameArr[i];
		if( trim(temp) != '' ) {
			var key = temp.substring(0,temp.indexOf('|'));
			var val = temp.substring(temp.indexOf('|')+1,temp.length);
			var valArr = val.split(',');
			for(var j=0; j < valArr.length; j++ ) {
				if( trim(valArr[j]) != '' ) {
					var nodeArr=valArr[j].split(':');
					getContextFilterNamesForPanel(key)[nodeArr[0]] = nodeArr[1];
				}
			}
		}
	}
}
/**
 * Initialise JS map to store panelwise static flag.
 */
function initStaticPanelMap() {
	var staticPanelStr = '${ staticPanelStr }';
	var stPanArr = staticPanelStr.split(';');
	for(var i=0; i < stPanArr.length; i++ ) {
		var temp = stPanArr[i];
		if( trim(temp) != '' ) {
			var key = temp.substring(0,temp.indexOf('|'));
			var val = temp.substring(temp.indexOf('|')+1,temp.length);
			panelStaticMap[key]=val;
		}
	}

}
/**
 * Initialise JS map to store panelwise paging position.
 */
function initPagingInfoMap() {
	//load page map
	var panelPageStr = '${ panelPageStr }';
	var pagePanArr= panelPageStr.split(';');
	for(var i=0; i < pagePanArr.length; i++ ) {
		var temp = pagePanArr[i];
		if( trim(temp) != '' ) {
			var key = temp.substring(0,temp.indexOf('|'));
			var val = temp.substring(temp.indexOf('|')+1,temp.length);
			panelPageMap[key] = val;
		}
	}
}

//bring panel to front
function myfunction(e,obj){
	obj.bringToTop ();
}

//opens context panel
function openContextPanel(){
	contextPanel.show();
    contextPanel.bringToTop();
}

function closeContextPanel(){
	document.getElementById('showContext').value = false; 
}


function checkForDuplicateName(dashboardName) {
	try {
		var url = "/expensemap/dashboards/CheckDuplicateDashboardName.do";
		var ajaxResponse = jQuery.ajax({
									url: url,
									type: "POST",
									data: {dashboardName: dashboardName},
									async: false
								}).responseText;
		return processDuplicateNameValidation(ajaxResponse);
	} catch(e) {
		 alert(e);
	}
}

function processDuplicateNameValidation(ajaxResponse) {
	var data = eval(ajaxResponse);
	// check if session is still active.
	if ( checkIfSessionActive(data) == false ) {
		return;
	}
	if ( data[1] == 'true' ) {
		return true;
	}
	return false;
}

// Checks if session is still active.
function checkIfSessionActive(data) {
	if (data[0] == "Error"){
		var errorCode = data[1];
		if(errorCode == "session.timeout") {
			var timeoutURL = data[3];
			//for intg environment the location should be expensemap frame
			parent.location.href=timeoutURL;
			return false;
		}
	}
	return true;
}

 /**
  * Creates a copy of the dashboard.
  */
function SaveAs(){
	var dbname = document.getElementById("newDashboardName").value;
	if( trim(dbname) == '') {
		alert("<bean:message key='ui.dashboard.create.page.dashboard.name.required' bundle='dashboard' />");
		document.getElementById('newDashboardName').focus();
		return false;
	} else {
		dbname = trim(dbname);
	}
	// check name for duplicates
	if ( checkForDuplicateName( dbname ) ) {
		var msg = "<bean:message key='ui.msg.duplicate.name' bundle='dashboard'/>";
		alert(msg);
		document.getElementById('newDashboardName').focus();
		return false;
	}
	dbNamePanel.hide();
	submitSaveRequest(true, dbname);
}

/**
 * Submits a request to save dashboard.
 */
function submitSaveRequest(isCreateNewCopy, dbname) {
	var frm = document.getElementById("dashboardRenderForm");
	var dbid= document.getElementById("dashboardId").value;
	var locStr = '';var dimStr = '';var visStr = '';var fstr='';var staticStr='';var pageStr='';
	for(var i=1 ; i < panelIdArray.length ; i++){
		var panelId = panelIdArray[i];
		var hiddenPanelId = document.getElementById('hidden_'+panelId).value;
		var temp = panelId.substring(5); //get numrical key by splitting 'panel1, panel2, ... '.
		var obj = allPanels[temp];
		var visible = panelVisibilityMap[panelId];
		
		var loc = obj.cfg.getProperty("xy");
		locStr = locStr + hiddenPanelId + ':' + loc + ';'; //construct string like panelId1 : xy postion ; panelId2:xy postion ; ...
		
		var dim = currentHeightWidth[panelId];
		var hVal = dim.substring(0,dim.indexOf(','));
		var wVal = dim.substring(dim.indexOf(',')+1,dim.length);
		hVal = trimPx(hVal);
		wVal = trimPx(wVal);
		
		dimStr = dimStr + hiddenPanelId + ':' + hVal + ',' + wVal + ';' ;//construct string like panlelId1:height,width; .....			
		visStr = visStr + hiddenPanelId + ':' + visible + ';'; //construct string like panlelId1:true(visible true/false),.....  
		fstr=fstr + hiddenPanelId +'|'+getFilters(hiddenPanelId)+';'  ;//construct string like panlelId1|dimensionName:nodeId,dimensionName:nodeid;panlelId1|dimensionName:nodeId,dimensionName:nodeid						 
		staticStr=staticStr+hiddenPanelId+':'+panelStaticMap[hiddenPanelId]+',';
		pageStr=pageStr+hiddenPanelId+':'+panelPageMap[hiddenPanelId]+',';
	   				
	}
	if(locStr.indexOf(';') >= 0){
		locStr = locStr.substring(0,locStr.lastIndexOf(';'));
	}
	if(dimStr.indexOf(';') >= 0){
		dimStr = dimStr.substring(0,dimStr.lastIndexOf(';'));
	}
	if(visStr.indexOf(';') >= 0){
		visStr = visStr.substring(0,visStr.lastIndexOf(';'));
	}
	document.getElementById("panelsXYLocations").value = locStr;
	document.getElementById("panelDimension").value = dimStr;
	document.getElementById("panelsVisibility").value = visStr;
	document.getElementById("panelFilters").value =fstr;
	document.getElementById("staticPanelString").value =staticStr;
	document.getElementById("panelPageString").value =pageStr;
	
	var dbNameField = document.createElement('input');
	dbNameField.setAttribute("name", "dashboardName");
	dbNameField.setAttribute("value", dbname);
	dbNameField.setAttribute("type", "hidden");
	frm.appendChild(dbNameField);
	
	frm.action = "/expensemap/dashboards/saveAsDashbaord.do?createNewCopy=" + isCreateNewCopy + "&dashboardId=" + dbid;
	frm.method = "post";
	frm.submit();
}

//remove 'px' from height and width value
function trimPx(val) {
	var res = val.substring(0,val.indexOf('p'));
	return res;
}

function closeSaveAsBox(){
	dbNamePanel.hide();
}

/**
 * This JS functin responds to Edit menu Click and
 * initiates the Edit Work-flow.
 */
function editDashboard(){
	var dashboardid = document.getElementById("dashboardId").value;
	var frm = document.getElementById("dashboardRenderForm");
	frm.action = "/expensemap/dashboards/editDashboard.do?dashboardId="+dashboardid;
	frm.method = "post";
	frm.submit();	
}

function trim(str, chars) {
    return ltrim(rtrim(str, chars), chars);
}

function ltrim(str, chars) {
    chars = chars || "\\s";
    return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
}

function rtrim(str, chars) {
    chars = chars || "\\s";
    return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
}

/*
 * Propogates a DRILL EVENT to all panels.
 */
function notifyAllPanels(panId, dimensionName, nodeId, bookMarkId, isThisStatic) {
	// Loop thru all panels and pass the Id and name of the node on which the user has clicked.
	// But exclude the panel that originated the event.    
	for (interactiveFrame in allInteractiveFrames) {
		var frame = allInteractiveFrames[interactiveFrame];
		if ( frame.id != panId ) {
			frame.contentWindow.updateOnDrill(nodeId, dimensionName, bookMarkId);
		}
	}
}


//gets filter names string from the map of filter names.
function getFilterNames(panelId) {
	var filterNameStr='';
	filterNamesMap = getContextFilterNamesForPanel(panelId);
	for( key in filterNamesMap ) {	       
		filterNameStr=filterNameStr+key +':'+filterNamesMap[key]+',';
	}
	return filterNameStr;
}

//gets filter string
function getFilters(panelId){
	var filterStr='';
	var filterMap = getContextFiltersForPanel(panelId);
	for (key in filterMap) {	       
		filterStr=filterStr+key +':'+filterMap[key]+',';
	}
	return  filterStr;
}

//reset all
function resetAll(bookMarkId) {	
	bookmarkContextFilters={};
	bookmarkContextFilterNames={};
	for (interactiveFrame in allInteractiveFrames) {
		allInteractiveFrames[interactiveFrame].contentWindow.reset(bookMarkId);
	}
}

 //removes filter from bookmark filter stack for this dimension.
function removeBookmarkFilterForDimension(bookMarkId, dimensionName){      
	delete getBookmarkContextFilters(bookMarkId)[dimensionName];
	delete getBookmarkContextFilterNames(bookMarkId)[dimensionName];
} 


//notifies all panels for filter removal
function  notifyAllPanelsOnFilterRemoval(panId, dimensionName,bookMarkId){
	// Loop thru all panels and pass the Id and name of the node on which the user has clicked.
	// But exclude the panel that originated the event.    
	for (interactiveFrame in allInteractiveFrames) {
		var frame = allInteractiveFrames[interactiveFrame];
		if ( frame.id != panId ) {
			frame.contentWindow.updateOnFilterRemoval(dimensionName, bookMarkId);
		}
	}
}

//snap map
function getSnapStatus() {	
	var snapStatus={};	
	for(var panelNo = 1; panelNo < allPanels.length; panelNo++ ) {	
	       if(panelVisibilityMap[allPanels[panelNo].id] == "true"){
	           snapStatus[allPanels[panelNo].id]='0';	                 
	     }	                 
	}	
	return snapStatus;
}

//shortest distance between two points
function distance(x1,y1,x2,y2) {
	//find horizontal distance (x)
	var x = x2 - x1;
	//find vertical distance (y)
	var y = y2 - y1;
	//do calculation
	var hyp = Math.sqrt(x*x + y*y);
	return hyp;
}

function setValuesForPDFExport(){
	var fstr='';var pageStr='';
	for(var i=1 ; i < panelIdArray.length ; i++){
		var panelId = panelIdArray[i];
		var hiddenPanelId = document.getElementById('hidden_'+panelId).value;
		var temp = panelId.substring(5); //get numrical key by splitting 'panel1, panel2, ... '.
		var obj = allPanels[temp];
		var visible = panelVisibilityMap[panelId];
		
		fstr=fstr + hiddenPanelId +'|'+getFilters(hiddenPanelId)+';'  ;//construct string like panlelId1|dimensionName:nodeId,dimensionName:nodeid;panlelId1|dimensionName:nodeId,dimensionName:nodeid						 
		pageStr=pageStr+hiddenPanelId+':'+panelPageMap[hiddenPanelId]+',';
	   				
	}
	document.getElementById("PDFpanelFilters").value = fstr;
	document.getElementById("PDFpanelPageString").value = pageStr;
}

</script>

</c:if>
<script type="text/javascript">
function exportToPDF(){
	<c:if test="${! empty dashboardName }">
	setValuesForPDFExport();
	var ht = 500;
	var wt = 750;
	var left = (screen.width/2)-(wt/2);
	var top = (screen.height/2)-(ht/2);
	var dashboardid = document.getElementById("dashboardId").value;
	window.open("/expensemap/dashboards/getPDFExportDialog.do?exportType=dashboard&dashboardId="+dashboardid,"_blank","scrollbars=yes,resizable=yes,height="+ht+",width="+wt+",menubar=no,toolbar=no,left="+left+",top="+top);
	</c:if>
}
/**
 * Saves the current state of the dashboard.
 */
function saveDashboard() {
	<c:if test="${! empty dashboardName }">
	submitSaveRequest(false, '');
	</c:if>
}
function openSaveAsBox (){
	<c:if test="${! empty dashboardName }">
    dbNamePanel = new YAHOO.widget.Panel("newPanel", { width: "300px", fixedcenter: true, constraintoviewport: true, visible: false,modal:true} );
    dbNamePanel.setHeader('<span class="modalHeaderStyle">'+"<bean:message key='ui.dashboard.create.page.enter.dashboard.name' bundle='dashboard' />"+'</span>');
    var saveAsLabel = "<bean:message key='ui.dashboard.menu.saveas' bundle='dashboard' />";
    var cancelLabel = "<bean:message key='ui.label.Cancel' bundle='dashboard' />";
	dbNamePanel.setBody('<table><tr><td><input type="text" id="newDashboardName" size="40"/></td></tr><tr><td><button onclick="javascript:SaveAs();">' + saveAsLabel + '</button>&nbsp;<button onclick="javascript:closeSaveAsBox();">' + cancelLabel + '</button></td></tr></table>');
	dbNamePanel.render(document.body);
	dbNamePanel.show();
	document.getElementById('newDashboardName').focus();
	</c:if>
}

// Close export box.
function closeExportBox(){
	dbExportPanel.hide();
}

// Open export dialog box.
function openExportBox (operation, dbId, panelId, reportId, level, beginIndex) {
    dbExportPanel = new YAHOO.widget.Panel("exportPanel", { width: "700px", fixedcenter: true, constraintoviewport: false, visible: false,modal:true,close:false} );
    var methodToCall = '';
    if (operation == 'Tabulations') {
		methodToCall = 'exportTabulationToExcel(\'' + dbId + '\',\''+ panelId + '\', \'' + reportId+ '\')';
		dbExportPanel.setHeader('<span class="exportHeader">'+ "<bean:message key='ui.title.exporting.tabulation' />"+'</span>');
    } else if (operation == 'Analytics') {
		methodToCall = 'exportAnalyticsToExcel(\'' + dbId + '\',\''+ panelId + '\',\'' + reportId+ '\', \'' + level + '\')';
		dbExportPanel.setHeader('<span class="exportHeader">' + "<bean:message key='ui.title.exporting.Analyitc' />" + '</span>');
    } else if (operation == 'DimensionPanel') {
    	methodToCall = 'exportDimensionToExcel(\'' + dbId + '\',\''+ panelId + '\',\'' + reportId+ '\',\'' + beginIndex+ '\')';
		dbExportPanel.setHeader('<span class="exportHeader">'+"<bean:message key='ui.title.exporting.Dimensions' />"+'</span>');
    } else if (operation == 'DimensionAll') {
    	methodToCall = 'exportAllToExcel(\'' + dbId + '\',\''+ panelId + '\',\'' + reportId+ '\')';
		dbExportPanel.setHeader('<span class="exportHeader">'+"<bean:message key='ui.title.exporting.Dimensions' />"+'</span>');
    }
    
    var saveAsLabel = "<bean:message key='ui.report.table.header.export' />";
    var cancelLabel = "<bean:message key='ui.label.Cancel' />";
	var levelStr='';
	var numFormatStr = '';
	
	<% List<String> numFormats = FormatUtil.getNumberFormats(); 
	
	for (String numberFormat : numFormats) {%>
	
		<% if(userNumberFormat.equals(numberFormat) ){ %>		
		numFormatStr += '<option value="<%=numberFormat%>" selected ><%=numberFormat%></option>';
	<%} else { %>
		numFormatStr += '<option value="<%=numberFormat%>"><%=numberFormat%></option>';
	<%
			} //else
	}
	%>	
	
	var bodyString = ''; 
	
	bodyString+='<table border=1 align="center" style="width:94%" ><TR><td class="leftTD" align="right">' + "<bean:message key='ui.label.File.Name' />"+'<font color="red"> *</font></td><td CLASS="rightTD" align="left"><input type="text" id="fileName" size="30" styleClass="inputStyle" maxlength="50" value="' + getPanelName(panelId) + '_<%=dateString%>" /></td></tr>';
	bodyString+='<tr><td class="leftTD" align="right">' + "<bean:message key='ui.label.file.type' />" + '</td>';
	bodyString+='<td class="rightTD"><input type="radio" name="fileType" id="fileTypeCsv" value="CSV" onclick="toggleOptionDiv(\'CSV\');" disabled>'+"<bean:message key='ui.label.csv' />"+'<br>';
	bodyString+='<input type="radio" name="fileType" id="fileTypeXls" value="XLS" checked="true" onclick="toggleOptionDiv(\'XLS\');">' + "<bean:message key='ui.label.xls' />" + '<br />';
	if(operation == 'Tabulations'){ 
		bodyString+='<span style="display: block" id="fileTypeXlsxSpan"><input type="radio" name="fileType" id="fileTypeXlsx" value="XLSX" onclick="toggleOptionDiv(\'XLXS\');" >'+"<bean:message key='ui.label.xlsx' />"+'</span>';
	}
	bodyString+='</td></tr>';

	bodyString+='<tr id="trNumFormat"><td class="leftTD" align="right"><div id="lableNumberFormat">'+"<bean:message key='ui.label.number.format.for.export'/>"+'</div></TD>';
	bodyString+='<td class="rightTD"><div id="drNumberFormat"><select name="exportNumberFormat" id="exportNumberFormat" size="1">';
	bodyString+=numFormatStr;
	bodyString+='</select></td></div></tr>';
	bodyString+='</td></tr>';
	
	bodyString+='<tr><td colspan="2" class="buttons"><button onclick="'+ methodToCall +'">' + saveAsLabel + '</button>&nbsp;<button onclick="javascript:closeExportBox();">' + cancelLabel + '</button></td></tr></table>';

	dbExportPanel.setBody(bodyString);
	dbExportPanel.render(document.body);
	dbExportPanel.subscribe("beforeShow", showXlsx);
	dbExportPanel.show();
}

function showXlsx()
{
	document.getElementById("fileTypeXlsx").checked=true;
	document.getElementById("drNumberFormat").style.display = "none";
	document.getElementById("lableNumberFormat").style.display = "none";
	document.getElementById("trNumFormat").style.display = "none";
}

//show number format only for csv and xls. Hide it for xlsx
function toggleOptionDiv(fileType) {
	if (document.getElementById("fileTypeXlsx").checked ){
		document.getElementById("drNumberFormat").style.display = "none";
		document.getElementById("lableNumberFormat").style.display = "none";
		document.getElementById("trNumFormat").style.display = "none";
	}else if((document.getElementById("fileTypeXls").checked)){
		document.getElementById("drNumberFormat").style.display = "block";
		document.getElementById("lableNumberFormat").style.display = "block";
		document.getElementById("trNumFormat").style.display = "table-row";
	}else{
		document.getElementById("drNumberFormat").style.display = "block";
		document.getElementById("lableNumberFormat").style.display = "block";
		document.getElementById("trNumFormat").style.display = "table-row";
	}
}

//function for exporting panel data to excel
function exportDimensionToExcel(dbId, dbPanelId, dimName, beginIndex) {
    var fileName = document.getElementById("fileName");
    var fName = trim(fileName.value);
    //method in commons.js
    if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
	    var numberFormat = document.getElementById("numberFormat");
	    var contextFilters = getFilters(dbPanelId);
	    var frm = document.getElementById("dashboardRenderForm");	    
	    var numFormatObject = document.getElementById("exportNumberFormat");
		var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
		frm.numberFormat.value = numFormat;
	    frm.fileName.value = fName;
	    frm.dimensionName.value = dimName;
	    frm.exportType.value="Panel";
	    
	    frm.method = "post";
	    frm.action = "/expensemap/dashboards/ExportDashboardPanel.do?dbId=" + dbId + "&dbPanelId=" + dbPanelId + "&drillDim=" + contextFilters + "&beginIndex=" + beginIndex;
	    frm.submit();
	    closeExportBox();
	}
}

// function to Export All 
function exportAllToExcel(dbId, dbPanelId, dimName) {
    var fileName = document.getElementById("fileName");
    var fName = trim(fileName.value);
    //method in commons.js
    if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
    	
    	var frm = document.getElementById("dashboardRenderForm");
    	var numFormatObject = document.getElementById("exportNumberFormat");
 		var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
 		frm.numberFormat.value = numFormat;     
	    var contextFilters = getFilters(dbPanelId);
	    frm.fileName.value = fName;
	    frm.dimensionName.value = dimName;
	    frm.exportType.value="All";
	    frm.method = "post";
	    frm.action = "/expensemap/dashboards/ExportDashboardPanel.do?dbId=" + dbId + "&dbPanelId=" + dbPanelId + "&drillDim=" + contextFilters;
	    frm.submit();
	    closeExportBox();
	}
}

//Export Analytic report to excel.
function exportAnalyticsToExcel(dbId, dbPanelId, reportId, level){
	var fileName = document.getElementById("fileName");
	var fName = trim(fileName.value);
	//method in commons.js
    	if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
		var frm = document.getElementById("dashboardRenderForm");
        var numFormatObject = document.getElementById("exportNumberFormat");
		var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
		frm.numberFormat.value = numFormat;			
    	frm.reportName.value = fName;
        frm.method="post";
        frm.action="/expensemap/analytic/analyticsExportExcel.do?level="+level+"&reportId="+reportId+"&dashboardId="+dbId + "&dashboardPanelId=" + dbPanelId;
        frm.submit();
        closeExportBox();
    }
}

//function for exporting panel data to excel 
function exportTabulationToExcel(dbId, dbPanelId, bookmarkId){
	var fileName = document.getElementById("fileName");
	var fName = trim(fileName.value);
	var displayModeXls = document.getElementById("fileTypeXls");
	var displayModeXlsx = document.getElementById("fileTypeXlsx");
	//method in commons.js
    	if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
    	var frm = document.getElementById("dashboardRenderForm");		
    	var numFormatObject = document.getElementById("exportNumberFormat");
 		var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
 		frm.numberFormat.value = numFormat;
        frm.userInputFileName.value = fName;
		frm.method="post";
		if ( displayModeXls.checked == true ) {
			frm.action="/expensemap/Export.do?operation=exportCrossTabExcel&theAction=exportCrossTabExcel&dbId="+dbId+"&dbPanelId="+dbPanelId + "&bookMarkId=" + bookmarkId;
		}else if ( displayModeXlsx.checked == true ) {
			if(isExportable(bookmarkId)){
	    		frm.action="/expensemap/Export.do?operation=exportCrossTabExcelx&theAction=exportCrossTabExcel&dbId="+dbId+"&dbPanelId="+dbPanelId + "&bookMarkId=" + bookmarkId;
	    	}else{
	    		alert("<bean:message key='ui.message.use.export.option.xls.for.tabulation'/>  ");
				return;
	    	}
		}
		
		frm.submit();
		closeExportBox();
	}
}


function isExportable(bkid){
	try {
		var url = "/expensemap/checkExportXlsxCrosstabAction.xhtm";
		var ajaxResponse = eval(jQuery.ajax({
									url: url,
									type: "GET",
									data: {bkid: bkid},
									async: false
								}).responseText);
		if (ajaxResponse[0]=="TRUE") {
			return true ;
		} else {
			return false ;
		} 
	} catch(e) {
			return false ;
	}
}

//snap to grid algo..
function snapToGrid(){	
	<c:if test="${! empty dashboardName }">
    var snapStatus = getSnapStatus();		
    var xVal=parseInt(xVal1);
    var yVal=parseInt(yVal1);	
	// XXX: This value should be in sync with #panelMinYVal in createNewDashBoard.jsp
    var panelMinYVal = parseInt(jQuery("#topMenu").offset().top + jQuery("#topMenu").height()) + 60;
	// In order to avoid overlapping panels on dashboard name, override Y position if necessary
	if (yVal < panelMinYVal) {
		yVal = panelMinYVal;
	}
    var panelHeight=panelHeight1;
    var panelWidth= panelWidth1;	
    var orgXval=xVal;			
    var visPanelCount=0;
    
    var Hgap = ${hGap};
    var Vgap = ${vGap};
    var Numcols = ${numOfCols};
    
	for(var panelNo = 1; panelNo < allPanels.length; panelNo++ ) {
	if(panelVisibilityMap[allPanels[panelNo].id] == "true"){
	     visPanelCount++;		 
		 var closestPanel=null;
		 var closestDistance=10000;
		 for(var count = 1; count < allPanels.length; count++ ) {
				if(panelVisibilityMap[allPanels[count].id] == "true" && snapStatus[allPanels[count].id]!='1'){
				    var pX=allPanels[count].cfg.getProperty("x");
				    var pY=allPanels[count].cfg.getProperty("y");
		            dist=distance(pX,pY,xVal,yVal);    
		 	        if(dist<closestDistance){	                        
		 	                closestDistance=dist;
		 	                closestPanel=allPanels[count];                   
		 	         }		 	        
		 	    }		 	     
	        }			 
		 var nPanel=closestPanel;		
		 if(snapStatus[nPanel.id]!='1'){
		     allPanels[panelNo].cfg.setProperty("height", panelHeight );
			 allPanels[panelNo].cfg.setProperty("width", panelWidth );		 
			 currentHeightWidth[allPanels[panelNo].id] = panelHeight + "px" + ',' + panelWidth + "px";	
			 nPanel.cfg.setProperty("xy", [xVal,yVal]);
		 	 snapStatus[nPanel.id]='1';
		 }		 	 
		 xVal = xVal + parseInt(panelWidth)+Hgap;		 
         if((visPanelCount)%Numcols == 0){      		 
      		xVal = orgXval;
			yVal = yVal + parseInt(panelHeight)+Vgap;       
       		}       		
       	}       	
     }    
	</c:if>
}

function getPanelName(panelId) {
	return fileName[panelId];
}

</script>
</body>    	
</html>  