<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>

<%@ page import="org.owasp.esapi.ESAPI"%>
<%@ page import="com.zeborg.util.WebUtil,com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.util.HelpLocaleUtil,com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@ page import="org.apache.struts.Globals,java.util.Locale" %>
<%@ page import="com.zeborg.expensemap.view.HelpUtil" %>
<%@ page import="com.emptoris.viewer.feedback.FeedbackConstants" %>

<%@ page import="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.util.EncodeUtil"%>
<%@ page import="java.util.Locale, com.emptoris.viewer.util.CSRFHelper"%>

<%
ZSession zs = ZSessionUtil.getFromSession(pageContext);
Locale locale = WebUtil.getAppLocale(pageContext);
WebUtil.addType(response, request);
request.getSession().setAttribute(Globals.LOCALE_KEY, locale);
boolean gskFeedback = ExpenseMapAppProperties.isEnableCustomFeedbackname();
HelpUtil emHelp = HelpUtil.getHelpUtil();
String helpURL ="";
if (gskFeedback) {
	helpURL = emHelp.getHelpURLString(FeedbackConstants.GSK_FEEDBACK_ADD_NODE_HELP, null);
} else {
	helpURL = emHelp.getHelpURLString(FeedbackConstants.FEEDBACK_ADD_NODE_HELP, locale);
}
%>
<HTML>
<HEAD>
<TITLE><bean:message key="ui.feedback.page.add.title" /></TITLE>
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">

<STYLE TYPE="text/css">
	<!--
	.belowMast 	{ margin: 0 8 0 8 }
	.ResultsHeader { font-family:Arial; font-size:12px; color:#FFFFFF}
	.ResultsHeader1 { font-family:Arial; font-size:12px; color:#003366}
	.HeaderMessage { font-family:Arial; font-size:11px; color:#003366}
	.TREENODE{ font-family: Arial, Helvetica, sans-serif; font-size: 11px; color: #000063; text-align:center; background-color: A5B6DE; }
	.tableData { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#0C209B; text-decoration:none; text-align:left}
	.tableData1 { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#0C209B; text-decoration:none; text-align:left; valign:center;}
	.tableData2 { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:normal; color:#FFFFE0; valign:center; text-decoration:none; text-align:left}
	.columnHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; valign:center; text-align:left; background-color: #DEE2EA;}
	.columnHeadingStyle1{ font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; valign:center; text-align:left; background-color: #DEE2EA;}
	.columnHeadingStyleRight{ font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; valign:center; text-align:right; background-color: #DEE2EA;}
	.rowHeadingStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left; background-color: #DEE2EA;}
	.rowHeadingStyleNew { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:left;  background-color: #FFFFCC;}
	.cellStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #000000; text-align:right; }
	.checkStyle { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #DEE2EA;}
	.checkStyleNew { font-family: Arial, Helvetica, sans-serif; font-size: 12px; color: #003366; text-align:center; background-color: #FFFFCC;}
	.checkBoxStyle { HEIGHT: 12px; WIDTH: 12px; }
	A {color:#0000FF; text-decoration:none}
	A:LINK {color:#0000FF; text-decoration:none}
	A:ACTIVE {color:#0000FF; text-decoration:underline}
	A:VISITED {color:#0000FF; text-decoration:none}
	A:HOVER {color:#0000FF; text-decoration:underline}
	.dimTitle { font-family:sans-serif, Tahoma, Verdana, Geneva, Arial, Helvetica; font-size:12px; color:#003366; }
	.hand{cursor="hand"}
.errmsg { font-family:Arial,Helvetica,sans-serif; font-size:11px; font-weight:bold; color:red; text-decoration:none; text-align:left}
textarea{ resize:none;}
	-->
</STYLE>
</HEAD>
<BODY onLoad="checkTopLevel()" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0">
<DIV ALIGN=CENTER>
<html:form action="/SuggestNodeAddAction" styleId="FeedbackCreateForm">
<script type="text/javascript"> 
sourceDimensionDesc='<bean:write name="feedbackCreateForm" property="sourceDimension"/>';
sourceDimensionDisplayName='<bean:write name="feedbackCreateForm" property="hidselectedNodeName"/>';
	
	//For PR#42769 : If Top level node selected, check the "isToplevel" checkbox by default.
	function checkTopLevel()
    {
	    document.getElementById("newNodeName").focus();
    	if(document.forms[0].targetNodeLevel.value ==0)
		{
			document.forms[0].isTopLevel.checked=true;
		}
    }
    function setOperation(operation)
    {
     document.getElementById('operation').value=operation;
	 var theForm = document.getElementById('FeedbackCreateForm');
     theForm.action = "/expensemap/feedback/SuggestNodeAddAction.do";

     if (operation=='submit') {
     
	 if(!document.forms[0].isTopLevel.checked && document.getElementById('targetNodeId').value=='')
	 {
		//document.getElementById("selectedNodeName").innerHTML='&nbsp;<b><font size="2px" color="red"><bean:message key="ui.feedback.validate.destination.empty"/></font></b>';
		document.getElementById('errmsgplace').innerHTML="<bean:message key='ui.feedback.error.msg'/>";
		return false;
	 }
        if(!validate())
		{
		 return false;
		}
		/*
			This will validate user input with allowedChar inputs
		*/
		var iChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz_0123456789~`!@#$%^&*()_-+=|}]{[\"':;?/>.<, ";
		if(!validateAllowedCharacter(document.getElementById('newNodeName'),iChars)){
			document.getElementById('errmsgplace').innerHTML="<bean:message key='ui.feedback.no.special.char.error.msg'/>";
			return false;
		}
	 document.getElementById('btnSubmitadd').disabled=true;
}
    
     document.getElementById('errmsgplace').innerHTML="";
     theForm.submit();
    }
function trim(str)
	{
		var trimmed = str.replace(/^\s+|\s+$/g, '') ;
		return trimmed;
	}
function validate()
	{
		if(trim(document.getElementById('newNodeName').value)=='')
		{
			document.getElementById('errmsgplace').innerHTML="<bean:message key='ui.feedback.error.msg'/>";
			document.getElementById('newNodeName').focus();
			return false;
		}
		
		if(trim(document.getElementById('comment').value)=='')
		{
			document.getElementById('errmsgplace').innerHTML="<bean:message key='ui.feedback.error.msg'/>";
			document.getElementById('comment').focus();
			return false;
		}
		return true;

	}
	function reloadMe(nodeInfo)
	{
	    var idNameLevelList = nodeInfo.split('nodeselector=');
		document.getElementById('targetNodeId').value= idNameLevelList[0];
		document.getElementById('targetNodeName').value=idNameLevelList[1];
		document.getElementById('targetNodeLevel').value=idNameLevelList[2];
  		document.getElementById('hidselectedNodeName').value=idNameLevelList[3];
  		document.getElementById('anchorNode').value=idNameLevelList[4];
  		document.getElementById('isNodeSpendZero').value=idNameLevelList[5];
  		setValue();
	}
	function setValue()
	{
		var value = document.getElementById('hidselectedNodeName').value;
		if(value=='' || value==null || value=='null')value=' ';
		value = unEscapeBracket(value);
		document.getElementById('selectedNodeName').innerHTML='&nbsp;'+ '<span>' + value + '</span>';
		
		value = document.getElementById('anchorNode').value;
		if(value=='' || value==null || value=='null')value=' ';
		document.getElementById('anchorNode').value=value;
	}
	
	function checkIsTopSelected(feedbackType,sourceDimension,sourceDimensionDisplayName)
	{
		var url='/expensemap/feedback/DimensionTreeSearchAction.do?feedbackType='+feedbackType+' />&sourceDimension='+sourceDimension+'&prefix=/feedback&sourceDimensionDisplayName='+sourceDimensionDisplayName;
		if(document.forms[0].isTopLevel)
		{
			if(document.forms[0].isTopLevel.checked)
			{
				document.forms[0].isTopLevel.checked=false;
				document.getElementById("selectedNodeName").innerText="<bean:message key='ui.feedback.tree.icon.message'/>";
			}
		}
		var midOfthescreen=screen.width/7;  		// modified for larger window size needed based on updates for PR 42498
		var midbotOfthescreen=screen.height/7;  	// modified for larger window size needed based on updates for PR 42498

		window.open(url,"",'width=720,height=600,scrollbars=yes,toolbar=no,status=no,resizable=yes,top='+midOfthescreen+',left='+midbotOfthescreen);
		return true;
		
	}
	function handleHiddenFields()
	{
		if(document.forms[0].isTopLevel)
		{
			if(document.forms[0].isTopLevel.checked)
			{
				document.forms[0].targetNodeName.value=sourceDimensionDesc;
				document.forms[0].targetNodeId.value=0;
				document.forms[0].targetNodeLevel.value=0;
				document.getElementById("selectedNodeName").innerHTML='&nbsp;'+document.forms[0].dimensionDisplayName.value;

			}else
			{
				document.forms[0].targetNodeName.value=sourceDimensionDesc;
				document.forms[0].targetNodeId.value="";
				document.forms[0].targetNodeLevel.value="";
				document.getElementById("selectedNodeName").innerHTML="<bean:message key='ui.feedback.tree.icon.message'/>";
			}
		}
	}

	function unEscapeBracket( str) {
	    var from = "<";
	    var to = "&lt;";
	    var idx = str.indexOf( from );
	    while ( idx > -1 ) {
	        str = str.replace( from, to ); 
	        idx = str.indexOf( from );
	    }
	    return str;
	}
	
	/*
		This metthod will validate user input with allowedChar inputs
	*/
	function validateAllowedCharacter(userInput, allowedChar){	
	if( typeof userInput != "undefined"){
		var userInputValue = userInput.value;
		for (var i = 0; i < userInputValue.length; i++) {
			if (allowedChar.indexOf(userInputValue.charAt(i)) == -1){
				userInput.focus();
				return false;
			}
		}
	}
	return true;
}

</script>
<html:hidden property="operation" styleId="operation"/>
<html:hidden property="sourceDimension" styleId="sourceDimension"/>
<html:hidden property="feedbackType" styleId="feedbackType"/>
<html:hidden property="searchColor" styleId="searchColor"/>
<html:hidden property="dimensionDisplayName" styleId="dimensionDisplayName"/>
<TABLE width=570 CELLSPACING="0" CELLPADDING="0" border="0" >
    <TR><td colspan="3"><img src="/expensemap/jsp/images/transparent.gif" height=10 border=0></td></TR>
    <TR>
	   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
	   <td class="error" colspan="2">
	  	<html:messages id="msg" message="true">
		<b><bean:write name="msg" />
		</html:messages>
	  </td>
	</TR>
<TR><td colspan="3" nowrap id="errmsgplace" class="errmsg" style="padding-left: 10px"></td></TR>
	<TR>
	   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
	   <td nowrap>
   		<table border=0 cellpadding=2 cellspacing=0  WIDTH="100%"
                  bgcolor="<bean:write name="feedbackCreateForm" property="searchColor"/>" >
    		<TR CLASS="ResultsHeader">
				<td style="font-family:Arial; color:#003366;align:center" height="25" nowrap id="dispname"></td>
	  			<td style="font-family:Arial; color:#003366;align:center" height="25" nowrap>&nbsp;&nbsp;
	  			<!--  42508 if enable custom names for feedback options is true display custom name else display localized default name -->
	  			<%if(!ExpenseMapAppProperties.isEnableCustomFeedbackname()) {%>
	  				<b><bean:message key="ui.feedback.page.add.title"/></b>
	  			<%}else{ %>
	  				<b><%=ExpenseMapAppProperties.getFeedbackTypeAdd() + " "%><bean:message key="ui.feedback.page.feedbackRequest"/></b>
	  			<%} %>	
					<A TARGET="_blank" HREF="<%=helpURL%>">
					<IMG SRC="/expensemap/jsp/images/help.gif" WIDTH="16" HEIGHT="16" BORDER="0" title="<bean:message key='ui.label.Help'/>"></A>
			   </td>
	        </tr>
	     </table>
	   </td>
	   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
	</TR>
    <TR>
       <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
	   <TD>
		<TABLE WIDTH="100%" CELLSPACING="1" CELLPADDING="1" border="0" >
		  <tr>
			<td colspan="2">
			<TABLE border=0 WIDTH="100%" CELLSPACING="0" CELLPADDING="0" BGCOLOR="#000063">	
				<TR CLASS="ResultsHeader">
					<td CLASS="ResultsHeader" align="left" height="25" nowrap>
					    <b>&nbsp;&nbsp;<bean:message key="ui.feedback.new.node.label"/>&nbsp;&nbsp;
					    </b>
					</td>
				</TR>
		    </TABLE>
			</td>
		  </tr>
		  <tr>
				<td height="25" CLASS="columnHeadingStyleRight" nowrap><bean:message key="ui.feedback.processing.newnode"/>&nbsp;<FONT COLOR="red">*</FONT></td>
				<td height="25" CLASS="tabledata">&nbsp;<html:text size="50" name="feedbackCreateForm" styleId="newNodeName" property="newNodeName" maxlength="50"/></td>
		  </tr>
		  <tr>
				<td rowspan="2" height="25" CLASS="columnHeadingStyleRight" nowrap><bean:message key="ui.feedback.processing.parent"/>&nbsp;<FONT COLOR="red">*</FONT></td>
				<td height="25" CLASS="tabledata1"><html:checkbox onclick="handleHiddenFields()" name="feedbackCreateForm" property="isTopLevel" />&nbsp;<bean:message key="ui.feedback.processing.toplevel"/>&nbsp;<U><bean:message key="ui.feedback.processing.or"/></U></td>
		  </tr>
		  <bean:define id="hierarchyDisplay" name="feedbackCreateForm" property="hidselectedNodeName"/>
		  <tr>
				<td CLASS="tabledata1" height="25">&nbsp;<img style="cursor:pointer" onclick="checkIsTopSelected('<bean:write name="feedbackCreateForm" property="feedbackType" />','<bean:write name="feedbackCreateForm" property="sourceDimension"/>','<bean:write name="feedbackCreateForm" property="sourceDimensionDisplayName"/>')" src="/expensemap/jsp/feedback/images/dimension_tree.gif" title="<bean:message key='ui.feedback.tree.icon.message'/>" />&nbsp;<span id="selectedNodeName" CLASS="tableData1">&nbsp;<%=ESAPI.encoder().encodeForHTML(EncodeUtil.htmlDecode(hierarchyDisplay.toString()))%></span></td>
			</tr>
		  		<html:hidden property="targetNodeName" styleId="targetNodeName"/>
				<html:hidden property="targetNodeId" styleId="targetNodeId"/>
				<html:hidden property="targetNodeLevel" styleId="targetNodeLevel"/>
				<html:hidden property="hidselectedNodeName" styleId="hidselectedNodeName"/>
				<html:hidden property="anchorNode" styleId="anchorNode"/>
				<html:hidden property="isNodeSpendZero" styleId="isNodeSpendZero"/>
				
			<tr>
			    <td CLASS="columnHeadingStyleRight" nowrap><bean:message key="ui.feedback.processing.comment"/>&nbsp;<FONT COLOR="red">*</FONT></td>
			  	<td CLASS="tabledata">&nbsp;<html:textarea rows="3" cols="50" name="feedbackCreateForm" property="comment" styleId="comment"/></td>
			</tr>
		</TABLE>	
	   </TD>
   	   <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
   </TR>	
	<TR><td colspan="3"><img src="/expensemap/jsp/images/transparent.gif" height=10 border=0></td></TR>
	<TR>
	    <td nowrap><img src="/expensemap/jsp/images/transparent.gif" width=10 height=1 border=0></td>
	    <td colspan="2" class="tableData">
	    <center>
		    	<input type="button" id="btnSubmitadd" onclick="setOperation('submit');" value="<bean:message key="button.submit"/>" /> &nbsp;
			<input type="button" onclick="setOperation('cancel');" value="<bean:message key="ui.label.Cancel"/>" />
		</center>
		</td>
	</TR>
</TABLE>
	<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</html:form>
</DIV>
</BODY>
<SCRIPT LANGUAGE="JavaScript">
<!--
		var dispName = ('<bean:write name="feedbackCreateForm" property="dimensionDisplayName"/>');
		document.getElementById("dispname").innerHTML='<b>&nbsp;'+dispName+'&nbsp;&nbsp;</b>'
//-->
</SCRIPT>
</HTML>