<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8"%>
<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ page import="org.apache.struts.util.MessageResources"%>
<%@ page import="org.apache.struts.config.ModuleConfig"%>
<%@ page import="org.apache.struts.util.ModuleUtils"%>
<%@page import="java.text.MessageFormat"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>


<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<%
	int totalRec = Integer.parseInt(request.getAttribute("totalRec").toString());
	int pageSize = Integer.parseInt(request.getAttribute("pageSize").toString());
	int startRec = Integer.parseInt(request.getAttribute("startRec").toString());
	int limitRec = Integer.parseInt(request.getAttribute("limitRec").toString());
	
	MessageFormat formatter = new MessageFormat("");	   
	
	ServletContext context = pageContext.getServletContext();
	ModuleConfig moduleConfig = ModuleUtils.getInstance().getModuleConfig(request, context);
	MessageResources resources = (MessageResources) context.getAttribute("emMessages" + moduleConfig.getPrefix());
	Object[] messageArguments = {startRec, limitRec, totalRec};
	formatter.applyPattern(resources.getMessage(ZSessionUtil.getFromSession(pageContext).getUser().getLocale(),"ui.label.pagination.text"));
	String message = formatter.format(messageArguments);
%>
<script type="text/javascript">

	function getMaxRows(action,applied){
		var prevPageSize = <%=pageSize%>;
		var currPageSize = document.getElementById("maxRowsList").value;	
		
		//if user click on any pagination icon before appling the new page limit then show alert 
		if(prevPageSize!=currPageSize && applied=="false"){
			alert("<bean:message key='ui.analytics.Navigate' bundle='emMessages'/>");
			return false;	
		} else {
			if(isValidNumber() && currPageSize == 0 ){					
				paginate(action, prevPageSize);
			} else if(isValidNumber() ){
				paginate(action,currPageSize);
			}else{
				alert("<bean:message key='ui.alertmsg.rowsPerPage' bundle='emMessages'/>");
				return false;
			}	
		}
	}
	//validate the number
	function isValidNumber(){
   		var ValidChars = "0123456789";
	   	var IsNumber=true;
   		var maxRows = document.getElementById("maxRowsList").value;
	   	var Char; 
   		for (i = 0; i < maxRows.length && IsNumber == true; i++){    
	      Char = maxRows.charAt(i); 
		  if (ValidChars.indexOf(Char) == -1){         
			 IsNumber = false;
	      } 
		}
	   return IsNumber;   
	}

</script>

<table width="100%" border="0">
<tr align="left">
	<td width="34%">&nbsp;</td>  	
	<td class="tabledata" align="center">
	<table><tr><td>
		<%if(startRec==1){%>
			<img src="/expensemap/jsp/images/beginning_disabled.gif"
			 border="0" class="tabledata" title="<bean:message key='tooltip.you.are.at.top' bundle='emMessages'/>" style="cursor: pointer">
			<img src="/expensemap/jsp/images/back_disabled.gif"
			border="0" class="tabledata" title="<bean:message key='tooltip.you.are.at.top' bundle='emMessages'/>" style="cursor: pointer">
		<%}else{%>
			<img onclick="return getMaxRows('getFirst','false');" src="/expensemap/jsp/images/beginning_enabled.gif"
				border="0" class="tabledata" title="<bean:message key='tooltip.go.top' bundle='emMessages'/>" style="cursor: pointer">
			<img onclick="return getMaxRows('getPrev','false');" src="/expensemap/jsp/images/back_enabled.gif" 
	 			border="0" class="tabledata" title="<bean:message key='ui.image.tooltip.movePrevious' bundle='emMessages' arg0='<%=String.valueOf(pageSize)%>' />"  style="cursor: pointer">
		<%}%>
		<%if(limitRec==totalRec){%>
			<img src="/expensemap/jsp/images/forward_disabled.gif" 
				border="0" class="tabledata" title="<bean:message key='tooltip.you.are.at.bottom' bundle='emMessages'/>" style="cursor: pointer">
			<img src="/expensemap/jsp/images/end_disabled.gif" 
				border="0" class="tabledata" title="<bean:message key='tooltip.you.are.at.bottom' bundle='emMessages'/>" style="cursor: pointer">
		<%}else{%>
			<img onclick="return getMaxRows('getNext','false');" src="/expensemap/jsp/images/forward_enabled.gif"
	 			border="0" 	class="tabledata" 
	 			title="<bean:message key='ui.image.tooltip.moveNext' bundle='emMessages' arg0='<%=String.valueOf(pageSize)%>' />"
	 			style="cursor: pointer">
			<img onclick="return getMaxRows('getLast','false');" src="/expensemap/jsp/images/end_enabled.gif" border="0" width="16" height="16"
	 			class="tabledata" title="<bean:message key='tooltip.go.bottom' bundle='emMessages'/>" style="cursor: pointer">
		<%}%>
		
		</td>
		<td class="tabledata">
   		&nbsp;&nbsp;<font face="Arial, Helvetica, sans-serif" size="2"><%= message%></font>
   		</td></tr>
   	</table>
   </td>
  <td class="tabledata" align="right" >    
   		<table>
			<tr>
				<td class="tabledata">
			   		<font face="Arial, Helvetica, sans-serif" size="2"><bean:message key='ui.label.recordsPerPage' bundle='emMessages'/></font>
				</td>
			  	<td>
					<input type="text" name="maxRowsList" id="maxRowsList" size="2" font="Arial, Helvetica, sans-serif" class="tabledata" value="<c:out value='${pageSize}'/>" />
				</td>
	   			<td>
					<html:button onclick="return getMaxRows('getCurrent','true');" property="apply"><bean:message key='button.apply' bundle='emMessages'/></html:button>
   				</td>
   			</tr>
   		</table>
   </td>	
</tr>
<input type="hidden" name="limitRec"   id="limitRec"   value="<c:out value='${limitRec}'/>"/>
<input type="hidden" name="startRec"   id="startRec"   value="<c:out value='${startRec}'/>"/>
<input type="hidden" name="pageSize"   id="pageSize"   value="<c:out value='${pageSize}'/>"/>
</table>