<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page import ="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import ="com.zeborg.expensemap.view2.ZSession"%>
<%@ page import ="com.emptoris.spendmanager.knowledgebaseui.util.KnowledgeBaseMenuBuilder"%>
<%@ page import="com.zeborg.expensemap.il8n.EmResourceBundle"%>
<%@ page import="com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>

<%@page import="com.emptoris.spendmanager.knowledgebaseui.util.KnowledgeBaseMenuBuilder"%>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/animation/animation.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/utilities/utilities.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/yahoo/yahoo.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/dom/dom-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/event/event-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/menu/menu.js"></script>
<jsp:include page="/jsp/includes/mainPageHeader.jsp"/>

<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/menu/assets/skins/sam/menu.css"> 
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/fonts/fonts.css" />
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/yui-menu-override.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/topmenu.css">

<% 
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
	EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_BASE_RESOURCE_BUNDLE, zs.getUser().getLocale());
	KnowledgeBaseMenuBuilder builder = new KnowledgeBaseMenuBuilder();
	
	//default polling interval is 10 sec. 1000 ms = 1 sec
	long pollingInterval = 10000L;
	if(ExpenseMapAppProperties.getServerPollingRequestTimeInSecond()>0){
		pollingInterval = 1000 *  ExpenseMapAppProperties.getServerPollingRequestTimeInSecond();
	}
%>

<style type="text/css">
	li.menuIcon {
		width: 28px;
		height: 24px;
		margin: 0px;
		padding: 0px;				
		border: 0px;
		float: right;				
		overflow: hidden;
	}
	
	.helpMenuIcon a {
		background: url('/expensemap/jsp/cap_area/btn_help_up.gif') center center no-repeat;				
	}
	
	li.printIcon {
		width: 28px;
		height: 24px;
		margin: 0px;
		padding: 0px;				
		border: 0px;
		float: right;				
		overflow: hidden;
	}
	
	.printMenuIcon a {
		background: url('/expensemap/jsp/images/sdm/btn_print_up.gif') center center no-repeat;				
	}
	
	

</style>
<script type="text/javascript">
//menu bar code starts
YAHOO.util.Event.onContentReady("topMenu", function () {
	var oMenuBar = new YAHOO.widget.MenuBar("topMenu", {autosubmenudisplay: true,hidedelay: 750,lazyload: true});
	var aSubmenuData = <%=builder.buildMenu(request,response)%>;
	oMenuBar.addItems(aSubmenuData);
	oMenuBar.clickEvent.subscribe(bringMenuToTop);
	oMenuBar.render();
	var contextHelp = document.getElementById("contextHelp");
	if ( contextHelp != null ) {
		contextHelp.title = '<%=bundle.getValue("ui.label.Help")%>';
	}
	var printMenu = document.getElementById("printMenu");
	if ( printMenu != null ) {
		printMenu.title = '<%=bundle.getValue("ui.print.image.tooltip")%>';
	}
	topMenuReference = oMenuBar;
});

function alertUnderConstruction(){
		alert('Under Construction');	
}

function loadKB(){
	var url = '/expensemap/knowledgebase/LoadKbAction.do?parameter=loadKbDetails';
	window.open(url, "LoadKB_Window",'resizable=no,width=650,height=360');	
}

function showAll(){
	var url = "/expensemap/knowledgebase/KBListAction.do?operation=loadKBList";
	window.location.href = url;
}

setInterval(pollOnlineFeedbackJob, <%=pollingInterval%>);

/**
* Polls for the submission of OLF
*/

function pollOnlineFeedbackJob(){ 
  try {        
		var url = "/expensemap/PollOnlineFeedbackJob.do";
		var ajaxResponse = eval(jQuery.ajax({
			url: url,
			type: "POST",
			async: false
		}).responseText);
         //session handling 
        if ( checkIfSessionActive(ajaxResponse) == false ) {
			return;
		}	 
		//Notification of OLF job submission
        if(ajaxResponse[1]=='true' && ajaxResponse[2]=='false'){        
			alert(ajaxResponse[3]);
        }
	} catch(e) { 
		//alert(e);
	}	   
}


/** 
* Checks if session is  active
*/
function checkIfSessionActive(data) {
	if (data[0] == "Error"){
		var errorCode = data[1];
		var isForceLogOut = false;
		var jobStartTime = "";
		if(errorCode == "force.timeout"){
			isForceLogOut = true;
			jobStartTime = data[4];			
		}
		
		if(errorCode == "session.timeout" || errorCode == "force.timeout") {

			var timeoutURL = data[3];			
			var submitForm = createNewSubmitForm();
				
			if(isForceLogOut){				
				createNewFormElementWithTime(submitForm, "forceLogout", isForceLogOut, "jobStartTime", jobStartTime );
			}else{				
				createNewFormElement(submitForm, "forceLogout", isForceLogOut);
			}
				
			submitForm.action = timeoutURL;
			submitForm.submit();
			return false;
				 
		}
	}
	return true;
}

function createNewSubmitForm(){
	var submitForm = document.createElement("FORM");
	document.body.appendChild(submitForm);
	submitForm.method = "POST";
	return submitForm;
}

function createNewFormElement(inputForm, forceLogoutElementName, forceLogoutElementValue){
	var forceLogoutElement = document.createElement("input");
	forceLogoutElement.setAttribute('name', forceLogoutElementName);
	forceLogoutElement.setAttribute('type', 'hidden');
	inputForm.appendChild(forceLogoutElement);
	forceLogoutElement.value = forceLogoutElementValue;
	
	return forceLogoutElement;
}

function createNewFormElementWithTime(inputForm, forceLogoutElementName, forceLogoutElementValue, jobStartTimeElementName, jobStartTimeElementValue ){
	var forceLogoutElement = document.createElement('input');
	forceLogoutElement.setAttribute('name', forceLogoutElementName);
	forceLogoutElement.setAttribute('type', 'hidden');
	
	var jobStartTimeElement = document.createElement('input');
	jobStartTimeElement.setAttribute('name', jobStartTimeElementName);
	jobStartTimeElement.setAttribute('type', 'hidden');
	
	inputForm.appendChild(forceLogoutElement);
	inputForm.appendChild(jobStartTimeElement);
	forceLogoutElement.value = forceLogoutElementValue;
	jobStartTimeElement.value = jobStartTimeElementValue;
	
	return forceLogoutElement;
}

/**
* End - polling online feedback job
*/

/* Function to set top menu to higher zindex */
	function bringMenuToTop(menu){
		topMenuReference.bringToTop();
		var topZindex = topMenuReference.cfg.getProperty("zindex");
		var subMenus = topMenuReference.getSubmenus();
		for (var i = 0; i < subMenus.length; i++) {
			subMenus[i].cfg.setProperty("zindex", topZindex);
		}
	}
</script>

<div class="yui-skin-sam">
	<div id="topMenu" class="yuimenubar yuimenubarnav">
		
	</div>
</div>