<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@include file="../includes/tlib.jspf"%>
<%@ page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@ page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@ page import="java.util.List"%>
<%@ page import="com.zeborg.util.WebUtil,java.util.Locale, com.emptoris.viewer.util.CSRFHelper"%>
<%@ page import="java.net.URLEncoder,com.zeborg.expensemap.il8n.EmResourceBundle, com.zeborg.expensemap.il8n.EmLocalizationManager"%>
<%@ page import="com.zeborg.expensemap.util.ExpenseMapAppProperties,org.apache.struts.util.LabelValueBean"%>
<%@page import="com.zeborg.expensemap.view2.ZSession,com.zeborg.acl.util.LocaleUtil"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil, java.util.Date,java.text.SimpleDateFormat"%>
<%
    //call addtype so that UTF-8 will be set as the encoding for all jsp pages
    WebUtil.addType(response, request);
	WebUtil.addNoCache(response);
	String charSet = WebUtil.getEncoding();
    String encoding = ((null == charSet)?"UTF-8":charSet); 
    ZSession zs = ZSessionUtil.getFromSession(pageContext);
	Locale locale = zs.getUser().getLocale();
    EmResourceBundle bundle = EmLocalizationManager.getBundle(EmLocalizationManager.EM_Topn_RESOURCE_BUNDLE, locale);
   	
%>

<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	

<HTML>
<HEAD>
<TITLE><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.topn.chart.title"/></TITLE>
<SCRIPT LANGUAGE="javascript" SRC="/expensemap/jsp/javascript/header.js"></SCRIPT>
<SCRIPT LANGUAGE="javascript" SRC="/expensemap/jsp/reports/javascript/reportutil.js"></SCRIPT>
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/macromap.css">
<LINK REL="stylesheet" TYPE="text/css" HREF="/expensemap/jsp/stylesheets/reports.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/stylesheets/export.css">
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/javascript/yui/build/container/assets/skins/sam/container.css" />

<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/dragdrop/dragdrop-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/container/container-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/element/element-min.js"></script>
<script type="text/javascript"	src="/expensemap/jsp/javascript/yui/build/menu/menu-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/button/button-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/yui/build/connection/connection-min.js"></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/export_pdf.js" ></script>
<script type="text/javascript" src="/expensemap/jsp/javascript/commons.js" ></script>

<SCRIPT LANGUAGE="javascript">

// 42149 report title sent as hidden field
function exportTopnCrossTabExcel(){
	var theForm = document.getElementById('editTopnForm');	
	var fileName = document.getElementById("fileName");
	var numFormatObject = document.getElementById("exportNumberFormat");
	var numFormat = numFormatObject.options[numFormatObject.selectedIndex].value;
	theForm.numberFormat.value = numFormat;	
	var fName = trim(fileName.value);
	//method in commons.js
	if (validateFileName(fileName, "<bean:message key='ui.error.file.name.required'/>", "<bean:message key='ui.pdf.create.page.error.message.supported.special.characters' />" + '\n  _   -')) {
		theForm.action = '/expensemap/Export.do?operation=exportCrossTabExcel&type=CrossTab&includeConstraints=true&ctId=<bean:write name="editTopnForm" property="exportChartMeta.remoteId"/>&bkmrkId=<bean:write name="editTopnForm" property="exportChartMeta.bookmarkId"/>' + "&userInputFileName=" + fName ;
		theForm.submit();
		closeExportBox();
	}
}

// Returns the function name and its params as a string for calling export functionality from common export UI in commonExportUI.jsp
function getParamString(name, id, status, reportTypeId, remoteId, bookmarkId,analyticId) {
	return "javascript:exportTopnCrossTabExcel()";
}

// Show/hide divs upon selection of csv/excel type. called from commonExportUI.jsp
function toggleOptionDiv(fileType) {
}

// Returns header string for export ui called from commonExportUI.jsp. It depends upon module its called for.
function getHeader() {
	return "<bean:message key='ui.title.exporting.tabulation'/>";
}

// Initialize the export UI. show/hide divs. It depends upon each module which div to show/hide. called from commonExportUI.jsp
function initDiv() {
	var dimensionOptionsDiv = document.getElementById("dimensionOptionsDiv");
	var dimensionNoOfRowsOptionsDiv = document.getElementById("dimensionNoOfRowsOptionsDiv");
	dimensionOptionsDiv.style.visibility = 'hidden';
	dimensionNoOfRowsOptionsDiv.style.visibility = 'hidden';
	document.getElementById("fileTypeCsv").disabled=true;
}

// Returns level by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
function getLevelsBydimId(dimId) {
	return 0;
}

//Returns no of rows by dim id. Used only for Dimension export, but as its called from common export UI, its returning 0.
function getNoOfRowsBydimId(dimId) {
	return 0;
}

/*
 * Added for fix of EXP-8174. This page is opened from topn list page. the window target is constructed using current time. As the page is not refreshed, the time captured
 remain as it and the next request opens in same page. So, just refreshing underlying page, while unloading window.
 */

function refreshParentWindow() {
	if(window.opener) {
		window.opener.location.href = "/expensemap/reports/ManageTopnReportAction.do?prefix=/reports";
	}
	
}
</SCRIPT>

</HEAD>
<BODY LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onunload="refreshParentWindow();" class="yui-skin-sam">
<html:form action="/ManageTopnReportAction" styleId="editTopnForm" >
<jsp:include page="/jsp/includes/commonExportUI.jsp"/>
<html:hidden property="operation" />
<html:hidden property="exportChartType" />
<html:hidden property="exportChartId" />
<input type="hidden" name="numberFormat" value="" />
<table width="100%" border="0" cellpadding="0" cellspacing="0">
<tr>
<td width="100%" colspan="3">
<jsp:include page="/jsp/includes/simplePageHeader.jsp"/>
	
</td>
</tr>
<tr>
      <td width="8%"><img src="/expensemap/jsp/images/transparent.gif" height=25 width="75" border="0"></td>
	  <td><img src="/expensemap/jsp/images/transparent.gif" height=25 border="0"><html:errors/></td>
	  <td width="8%"><img src="/expensemap/jsp/images/transparent.gif" height=25 width="75" border="0"></td>
</tr>
<logic:present name="editTopnForm" property="exportChartMeta">
<bean:define id="reportMeta" name="editTopnForm" property="exportChartMeta" type="com.emptoris.viewer.reports.TopnReportMeta"/>
<bean:define id="chartId" name="editTopnForm" property="exportChartMeta.remoteId"/>
<bean:define id="bkId" name="editTopnForm" property="exportChartMeta.bookmarkId"/>
<bean:define id="categoryDisplayName" name="editTopnForm" property="exportCategoryMeta.displayName"/>

<input type="hidden" name="exportTitle" value="<%=reportMeta.getName()%>">	        
<tr>
    <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
    <td><table width="100%" height="31"  border="0" cellpadding="0" cellspacing="0">
	    <tr>
	    <td width="100%"><table width="100%"  border="0" cellspacing="0" cellpadding="0">
	      <tr>
	        <td height="30" nowrap class="reportTitle">&nbsp;&nbsp;&nbsp;<bean:message key="ui.topn.Top.Report"/>:<%=categoryDisplayName%>&nbsp;-&nbsp;<bean:write name="editTopnForm" property="exportChartMeta.name"/></td>
	      </tr>
	      <tr>
	        <td height="1" bgcolor="#000066"><img src="/expensemap/jsp/images/transparent.gif" width="200" height="1"></td>
	      </tr>
	    </table></td>
	    <td width="42" height="31"><img src="/expensemap/jsp/images/report/popup_report_topbar.gif" width="42" height="31"></td>
	    <td width="200"><table width="160" height="31"  border="0" cellpadding="0" cellspacing="0">
	      <tr>
	        <td width="100%" height="1" bgcolor="#000066"><img src="/expensemap/jsp/images/transparent.gif" width="1" height="1"></td>
	      </tr>
	      <tr>
	        <td width="100%" height="30" align="right" valign="middle" nowrap>
	        <span class="reportOptions"><bean:message key="ui.topn.Export.Options"/></span><A HREF="#"><img src="/expensemap/jsp/images/icon_print.gif" width="16" height="16" border="0" hspace="7" vspace="2" title="<bean:message key='ui.topn.tooltip.send.to.printer'/>" align="absmiddle" onClick="window.print()"></A>	        
	        <A HREF="#" onclick="openExportBox('${editTopnForm.exportChartMeta.name}');"><img src="/expensemap/jsp/images/icon_export_to_excel.gif" width="16" height="16" border="0" hspace="7" vspace="2" title="<bean:message key='ui.label.export.to.excel'/>" align="absmiddle"></A>&nbsp;&nbsp;</td>	        
	      </tr>
	    </table></td>
	    </tr>
	    </table>
   </td>
   <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
</tr>
<tr>
      <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
	  <td><img src="/expensemap/jsp/images/transparent.gif" height=15 border="0"></td>
	  <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
</tr>
<tr>
   <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
   <td align="center">
   <DIV ID="chartDisplayDiv" 
        style="overflow:auto; 
               width:100%;
               height:100%;
               margin-top:5;
               margin-bottom:5;
               margin-left:5;
               margin-right:5;
               position:relative;">
	   <table width="100%" border="0" cellpadding="0" cellspacing="0">
	    <tr><td>
		   <%
		     pageContext.include("chartCrossTabRender.jsp?ctId="+chartId+"&bkid="+bkId);
		   %>
		</td></tr>
	   </table>
   </DIV>
   </td>
   <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
</tr>
<tr>
      <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
      <td><table width="100%"  border="0" cellspacing="0" cellpadding="0">
	      <tr>
	        <td height="1" bgcolor="#000066"><img src="/expensemap/jsp/images/transparent.gif" width="200" height="1"></td>
	      </tr>
	      <tr>
	        <td nowrap><span class="reportOptions"><bean:message key="ui.topn.Report.Run"/></span>:&nbsp;
	        <span class="reportDate"><fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" value="${reportMeta.lastUpdatedDate}"/></span></td>
	      </tr>
	    </table>
      </td>
      <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" width="75" border="0"></td>
</tr>
</logic:present>
<tr>
     <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
     <td align="center" nowrap>&nbsp;<input type="button" name="CloseWindowBtn" value="<%=bundle.getValue("ui.topn.button.Close.Window")%>" onclick="javascript:return window.close();">&nbsp;</td>
     <td width="5%"><img src="/expensemap/jsp/images/transparent.gif" border="0"></td>
</tr>
</table>
<input type="hidden" name="exportTitle" id="exportTitle">	        
<input type ='hidden' name="AuthCode" id="AuthCode" value='<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>'/>
</html:form>
</BODY>
</HTML>