<%--
 (C) COPYRIGHT International Business Machines Corp. 2012,2013. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib uri="http://struts.apache.org/tags-bean" prefix="bean"%>
<%@ taglib uri="http://struts.apache.org/tags-html"  prefix="html"%>
<%@ taglib uri="http://struts.apache.org/tags-logic" prefix="logic"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt"%>

<%@page import="com.zeborg.util.WebUtil"%>
<%@page import="com.zeborg.expensemap.view2.ZSession"%>
<%@page import="com.zeborg.expensemap.view.ZSessionUtil"%>
<%@page import="com.zeborg.expensemap.view.HelpUtil"%>
<%@page import="com.zeborg.expensemap.util.ExpenseMapAppProperties"%>
<%@page import="com.zeborg.expensemap.view.CubeUtil"%>
<%@page import="com.emptoris.spendmanager.components.dataenrichment.services.rules.RulesConstant" %>
<%@ page import="java.util.Locale"%>
<%@page import="com.emptoris.viewer.util.CSRFHelper"%>

<%
	//No client side caching
    WebUtil.addNoCache(response);
    WebUtil.addType(response,request);
	// get the ZSession
	
	ZSession zs = ZSessionUtil.getFromSession(pageContext);
    Locale locale = WebUtil.getAppLocale(pageContext);
    
 // Sorting on Rules Page
	String sortColumn = request.getAttribute("sortColumn")!=null?(String)request.getAttribute("sortColumn"):"rule_conditions";
	String sortOrder =  request.getAttribute("sortOrder")!=null?(String)request.getAttribute("sortOrder"):"asc";

%>
<html>
<head>
<link rel="stylesheet" type="text/css" href="/expensemap/jsp/css/dataenrichmentui.css">
<LINK rel="stylesheet" type="text/css" href="/expensemap/jsp/css/listPage.css"/>
<link rel='shortcut icon' href='/expensemap/jsp/images/favicon.ico' type='image/x-icon'>
<script type="text/javascript">
function loadRule(obj){
	document.getElementById("sortColumn").value = "rule_conditions";
	document.getElementById("sortOrder").value = "asc";
	document.getElementById("isFromSearch").value = "false";
	document.getElementById("clearSearch").value = "true";
	if(${!empty rules }){
		document.getElementById("limitRec").value = "0";
		document.getElementById("startRec").value = "0";
		document.getElementById("pageSize").value = "15";
	}
	if(obj==4){
		document.getElementById("ruleType").value = "4";
		var frm = document.getElementById("ruleForm");
		var url = "/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		frm.action = url;
		frm.method = "post";
		frm.submit();
	}
	if(obj==2){
		document.getElementById("ruleType").value = "2";
		var frm = document.getElementById("ruleForm");
		var url = "/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		frm.action = url;
		frm.method = "post";
		frm.submit();
	}
	if(obj==3){
		document.getElementById("ruleType").value = "3";
		var frm = document.getElementById("ruleForm");
		var url = "/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		frm.action = url;
		frm.method = "post";
		frm.submit();
	}
	if(obj==1){
		document.getElementById("ruleType").value = "1";
		var frm = document.getElementById("ruleForm");
		var url = "/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		frm.action = url;
		frm.method = "post";
		frm.submit();
	}
	if(obj==5){
		document.getElementById("ruleType").value = "5";
		var frm = document.getElementById("ruleForm");
		var url = "/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		frm.action = url;
		frm.method = "post";
		frm.submit();
	}
}
	function selectTab(obj){
		var leftEdge_1 = document.getElementById("leftEdge_1");
		var leftEdge_2 = document.getElementById("leftEdge_2");
		var leftEdge_3 = document.getElementById("leftEdge_3");
		var leftEdge_4 = document.getElementById("leftEdge_4");
		var leftEdge_5 = document.getElementById("leftEdge_5");
		var leftEdge_6 = document.getElementById("leftEdge_6");
		var tab_4 = document.getElementById("tab_4");
		var tab_2 = document.getElementById("tab_2");
		var tab_3 = document.getElementById("tab_3");
		var tab_1 = document.getElementById("tab_1");
		var tab_5 = document.getElementById("tab_5");
		if(obj==1){
			leftEdge_1.src = "/expensemap/jsp/images/left_sel_edge.gif";
			leftEdge_2.src = "/expensemap/jsp/images/right_overlap_sel_edge.gif";
			tab_4.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_selected.gif')";
			tab_2.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_3.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_1.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_5.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			leftEdge_3.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_4.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_5.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_6.src = "/expensemap/jsp/images/right_unsel_edge.gif";
		}
		if(obj==2){
			leftEdge_1.src = "/expensemap/jsp/images/left_unsel_edge.gif";
			leftEdge_2.src = "/expensemap/jsp/images/left_overlap_sel_edge.gif";
			tab_2.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_selected.gif')";
			tab_4.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_3.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_1.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_5.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			leftEdge_3.src = "/expensemap/jsp/images/right_overlap_sel_edge.gif";
			leftEdge_4.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_5.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_6.src = "/expensemap/jsp/images/right_unsel_edge.gif";
		}
		if(obj==3){
			leftEdge_1.src = "/expensemap/jsp/images/left_unsel_edge.gif";
			leftEdge_2.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			tab_4.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_2.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_3.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_selected.gif')";
			tab_1.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_5.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			leftEdge_3.src = "/expensemap/jsp/images/left_overlap_sel_edge.gif";
			leftEdge_4.src = "/expensemap/jsp/images/right_overlap_sel_edge.gif";
			leftEdge_5.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_6.src = "/expensemap/jsp/images/right_unsel_edge.gif";
		}
		if(obj==4){
			leftEdge_1.src = "/expensemap/jsp/images/left_unsel_edge.gif";
			leftEdge_2.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			tab_4.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_2.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_3.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_1.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_selected.gif')";
			tab_5.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			leftEdge_3.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_4.src = "/expensemap/jsp/images/left_overlap_sel_edge.gif";
			leftEdge_5.src = "/expensemap/jsp/images/right_overlap_sel_edge.gif";
			leftEdge_6.src = "/expensemap/jsp/images/right_unsel_edge.gif";
		}
		if(obj==5){
			leftEdge_1.src = "/expensemap/jsp/images/left_unsel_edge.gif";
			leftEdge_2.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			tab_4.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_2.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_3.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_1.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')";
			tab_5.style.backgroundImage = "url('/expensemap/jsp/images/tab_tile_bk_selected.gif')";
			leftEdge_3.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_4.src = "/expensemap/jsp/images/left_overlap_unsel_edge.gif";
			leftEdge_5.src = "/expensemap/jsp/images/left_overlap_sel_edge.gif";
			leftEdge_6.src = "/expensemap/jsp/images/right_sel_edge.gif";
		}
	}
	
	function selectAll(selectAllControl) {
		var theForm =  document.getElementById("ruleForm");
	   	if ( theForm.ruleId == null ) {
	   	  return false;	
	   	} 
	   	
	   	if ( theForm.ruleId.length ) {
	   		// There are more than one rows on this form.
			for( var i=0; i< theForm.ruleId.length; i++ ) {
				theForm.ruleId[i].checked = selectAllControl.checked;
			}
			return true;
	   	}
	   	// There is just a single row on this form.
	   	theForm.ruleId.checked = selectAllControl.checked;
	}
	
	function updateSelectAll(checkboxSelected) {
		var theForm = document.getElementById("ruleForm");
		var selectAllControl = document.getElementById("selectAllRules");
		var allSelected = true;
		if ( ! theForm.ruleId.length ) {
			allSelected = checkboxSelected.checked;
		} else {
			for( var i=0; i< theForm.ruleId.length; i++ ) {
				if ( theForm.ruleId[i].checked == false ) {
					allSelected = false;
					break;
				}	
			}
		}
		selectAllControl.checked = allSelected;
	}
	
	function paginate(action, pageSize) {
		var frm = document.getElementById("ruleForm");
		frm.method="post";
		frm.action="/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&ruleType=<c:out value='${param.ruleType}'/>&theAction=" 
					+ action + +"&pageSize=" + pageSize + "&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		frm.submit();
	}
	
	function sort(sortColumn){
		
		var sortOrder = document.getElementById("sortOrder");
		if(sortOrder.value=='asc') {
			sortOrder.value='desc';
		} else if(sortOrder.value=='desc') {
			sortOrder.value='asc';
		}		
		var theForm =  document.getElementById("ruleForm");		
		var url="/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&ruleType=<c:out value='${param.ruleType}'/>" + "&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		document.getElementById("sortColumn").value = sortColumn;
		document.getElementById("sortOrder").value = sortOrder.value;
		theForm.method = "post";		
		theForm.action = url;
		theForm.submit();
	}
	
	function inActivateRules(){
		if(isSelected() && confirm("<bean:message key='feedback.rule.inactivate.confirm.msg' bundle='ruleMessage'/>")){
			var theForm =  document.getElementById("ruleForm");
			var url="/expensemap/rulemanagement/ManageRulesAction.do?operation=inactivateRules&ruleType=<c:out value='${param.ruleType}'/>" + "&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
			theForm.method = "post";		
			theForm.action = url;
			theForm.submit();
		}
	}
	
	function inActivateAllRules(){
		if(confirm("<bean:message key='feedback.rule.inactivate.confirm.msg' bundle='ruleMessage'/>")){
			var theForm =  document.getElementById("ruleForm");
			var url="/expensemap/rulemanagement/ManageRulesAction.do?operation=inactivateAllRules&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
			theForm.method = "post";		
			theForm.action = url;
			theForm.submit();
		}
	}
	
	function restoreRules(){
		if(isSelected() && confirm("<bean:message key='feedback.rule.restore.confirm.msg' bundle='ruleMessage'/>")){
			var theForm =  document.getElementById("ruleForm");
			var url="/expensemap/rulemanagement/ManageRulesAction.do?operation=restoreRules&ruleType=<c:out value='${param.ruleType}'/>" + "&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
			theForm.method = "post";
			theForm.action = url;
			theForm.submit();
		}
	}
	
	function restoreAllRules(){
		var theForm =  document.getElementById("ruleForm");
		var url="/expensemap/rulemanagement/ManageRulesAction.do?operation=restoreAllRules&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		theForm.method = "post";		
		theForm.action = url;
		theForm.submit();
	}
		
	function isSelected(){
		var frm = document.getElementById("ruleForm");
		var flag = false;
		var noOfRows;
		if(  typeof frm.ruleId != "undefined" ){
			noOfRows = frm.ruleId.length;	
			if ( noOfRows > 1 ) { // if the checkbox group is an array (one check box is not an array)
				for (i = 0; i < noOfRows; i++) {
					if (frm.ruleId[i].checked == true) {
							flag = true;
						}
					}
			}else { // There is only one check box (it's not an array)
			 if (frm.ruleId.checked) { // if the one check box is checked
			         flag = true;
			      }
			 }			 
		}
		if(!flag){
			alert("<bean:message key='ui.label.no.record.selected' bundle='sdmMessages'/>");
		}
		return flag;
	}
	
	function loadSearchScreen(){
		var ruleType = document.getElementById('ruleType');
		var url = '/expensemap/rulemanagement/ManageRulesAction.do?operation=loadSearchScreen&ruleType='+ruleType.value + "&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		var ht = 650;
        var wt = 700;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);    
		window.open(url, 'Load_Rule_Search_Screen','resizable=yes,width='+wt+',height='+ht+',left='+left+',top='+top);
	}
	
	function clearRuleSearch(){
		var theForm =  document.getElementById("ruleForm");
		var url="/expensemap/rulemanagement/ManageRulesAction.do?operation=showRules&ruleType=${param.ruleType}&isFromSearch=false&clearSearch=true&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		theForm.method = "post";		
		theForm.action = url;
		theForm.submit();
	}
	
	function ShowRuleDetail(ruleId,isTarget){
		var url = '/expensemap/rulemanagement/ManageRulesAction.do?operation=showDetials&ruleType=${param.ruleType}&ruleId='+ruleId+'&target='+isTarget + "&AuthCode=" + encodeURIComponent(document.getElementById('AuthCode').value);
		var ht = 250;
        var wt = 700;
        var left = (screen.width/2)-(wt/2);
        var top = (screen.height/2)-(ht/2);    
		window.open(url, 'Rule_Details','resizable=yes,width='+wt+',height='+ht+',left='+left+',top='+top);
	
	}
	
</script>
<title><%= ExpenseMapAppProperties.getExpensemapTitle()%> - <bean:message key="ui.datamanager.menu.enrichment.manage.rules" bundle="sdmMessages"  /></title>
</head>
<form id="ruleForm" >
<c:set var="userDatePattern" value="<%=zs.getUser().getDateFormat()%>" />	
<c:set var="userTimeZone" value="<%=zs.getUser().getTimeZone().getID()%>" />
<c:set var="timeFormat" value="<%=ExpenseMapAppProperties.getTimeFormat()%>" />	
<body bgcolor="#FFFFFF" LEFTMARGIN="0" RIGHTMARGIN="0" TOPMARGIN="0" MARGINWIDTH="0" MARGINHEIGHT="0" onload="selectTab('${param.ruleType}')">
	<%		
		CubeUtil.buildExpMapMastHead(out,"dataManager_cubeSelect.jsp",zs,true,null,locale,null);
	%>
<jsp:include page="/jsp/cubemanagementui/dataManagerTopMenu.jsp"></jsp:include>
<br>
<logic:messagesPresent message="true">
	<font color="red" face="Arial, Helvetica, sans-serif" size="2">
		<b>
		<html:messages id="msg" message="true" bundle="ruleMessage">
			&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<%=pageContext.findAttribute("msg")%>
		</html:messages>
		</b>
	</font>
</logic:messagesPresent>
<br>
<table width="100%" height="25" border="1" cellspacing="0" cellpadding="0" class="tableWithBorder">
	<tr>
		<td valign="bottom" nowrap class="actiontitleborder">
			<table width="100%" height="25" border="0" cellpadding="0" cellspacing="0">
				<tr class="actiontitlerow">
					<td valign="middle" nowrap>
						<table border="0" cellpadding="0" cellspacing="2">
							<tr>
								<td class="actiontitlecell" nowrap>
									<div id="tabs" style="visibility: visible;">
										<table height=21 border=0 cellspacing=0 cellpadding=0>
											<tr>
												<td><img id="leftEdge_1" src="/expensemap/jsp/images/left_sel_edge.gif"
													width="35" height="21"></td>
												<td id="tab_4"  style="background-image:url('/expensemap/jsp/images/tab_tile_bk_selected.gif')"><nobr><a
													href="#" class="TAB" style="font-weight: bold;"
													onclick="loadRule(1)"><font
													class="TAB"><bean:message key="apply.rule.list.col.add" bundle="ruleMessage"/></font></a></nobr></td>
												<td><img  id="leftEdge_2"
													src="/expensemap/jsp/images/right_overlap_sel_edge.gif"
													width="35" height="21"></td>
												<td id="tab_2"
													style="background-image:url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')"><nobr><a
													href="#" class="TAB" style="font-weight: bold;"
													onclick="loadRule(2)"><font
													class="TAB"><bean:message key="apply.rule.list.col.rename" bundle="ruleMessage"/></font></a></nobr></td>
												<td><img id="leftEdge_3"
													src="/expensemap/jsp/images/left_overlap_unsel_edge.gif"
													width="35" height="21"></td>
												<td id="tab_3"
													style="background-image:url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')"><nobr><a
													href="#" class="TAB" style="font-weight: bold;"
													onclick="loadRule(3)"><font
													class="TAB"><bean:message key="apply.rule.list.col.move" bundle="ruleMessage"/></font></a></nobr></td>
												<td><img id="leftEdge_4"
													src="/expensemap/jsp/images/left_overlap_unsel_edge.gif"
													width="35" height="21"></td>
												<td id="tab_1"
													style="background-image:url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')"><nobr><a
													href="#" class="TAB" style="font-weight: bold;"
													onclick="loadRule(4)"><font
													class="TAB"><bean:message key="apply.rule.list.col.map" bundle="ruleMessage"/></font></a></nobr></td>
												<td><img id="leftEdge_5"
													src="/expensemap/jsp/images/left_overlap_unsel_edge.gif"
													width="35" height="21"></td>
												<td id="tab_5"
													style="background-image:url('/expensemap/jsp/images/tab_tile_bk_unselected.gif')"><nobr><a
													href="#" class="TAB" style="font-weight: bold;"
													onclick="loadRule(5)"><font
													class="TAB"><bean:message key="feedback.rule.reset" bundle="ruleMessage"/></font></a></nobr></td>
												<td><img id="leftEdge_6" src="/expensemap/jsp/images/right_unsel_edge.gif"
													width="20" height="21"></td>
												<td>&nbsp;</td>
											</tr>
									 </table>
								</div>
							</td>
						</tr>
					</table>
				</td>
				<td align="right" class="vmiddle" nowrap>
					<table cellpadding="0" cellspacing="0" border="0">
						<tr>
							<td>
								<table cellpadding="0" cellspacing="0" border="0">
									<tr>
										<td><button type="button"  onclick="inActivateAllRules();" title="<bean:message key='feedback.rule.inactivate.all' bundle='ruleMessage'/>" > <bean:message key="feedback.rule.inactivate.all" bundle="sdmMessages" /> </button>
											</td>
										<td><button type="button"  onclick="restoreAllRules();" title="<bean:message key='feedback.rule.restore.all' bundle='ruleMessage'/>" ><bean:message key="feedback.rule.restore.all" bundle="ruleMessage" /> </button>
											</td>									
										<td><button type="button"  onclick="inActivateRules();" title="<bean:message key='feedback.rule.inactivate' bundle='ruleMessage'/>" > <bean:message key="feedback.rule.inactivate" bundle="ruleMessage" />  </button>
											</td>
										<td><button type="button"  onclick="restoreRules();" title="<bean:message key='feedback.rule.restore' bundle='ruleMessage'/>" > <bean:message key="feedback.rule.restore" bundle="ruleMessage" />  </button>
											</td>
										<td><img src="/expensemap/jsp/images/btn_s_up.gif"
											title="<bean:message key='feedback.rule.search' bundle='ruleMessage'/>" onclick="loadSearchScreen();"
											onMouseOver="this.src='/expensemap/jsp/images/btn_s_ovr.gif'"
											onMouseOut="this.src='/expensemap/jsp/images/btn_s_up.gif'"
											name="IMG1353" style="cursor: pointer" border="0"></td>
										<c:if test="${param.isFromSearch == 'true'}">
											<td><img src="/expensemap/jsp/images/btn_cancel_search_up.gif"
											title="<bean:message key='ui.feedback.rule.clear.search' bundle='ruleMessage'/>" onclick="clearRuleSearch();"
											onMouseOver="this.src='/expensemap/jsp/images/btn_cancel_search_ovr.gif'"
											onMouseOut="this.src='/expensemap/jsp/images/btn_cancel_search_up.gif'"
											name="IMG1353" style="cursor: pointer" border="0"></td>
										</c:if>
									</tr>
								</table>
							</td>
						</tr>
					</table>
				</td>
			</tr>
		</table>
	</td>
</tr>
	<tr>
		<table width="100%" class="InnerTableWithBorder">
			<tr>
				<c:choose>
					<c:when test="${param.ruleType == 4}" >
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_conditions');">
								<bean:message key="feedback.rule.condition" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:when>
					<c:when test="${param.ruleType == 2}" >
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_conditions');" >
								<bean:message key="feedback.rule.rename.node" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:when>
					<c:when test="${param.ruleType == 3}" >
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_conditions');" >
								<bean:message key="feedback.rule.move.node" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:when>
					<c:when test="${param.ruleType == 1}" >
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_conditions');" >
								<bean:message key="feedback.rule.add.node" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:when>
					<c:when test="${param.ruleType == 5}" >
						
					</c:when>
					<c:otherwise>
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_conditions');" >
								<bean:message key="feedback.rule.condition" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
				
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_conditions')}"> 
									<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:otherwise>
				</c:choose>				
				<c:choose>
					<c:when test="${param.ruleType == 4}" >
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_consequence');" >
								<bean:message key="feedback.rule.target" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
									<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
									<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:when>
					<c:when test="${param.ruleType == 2}" >
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_consequence');" >
								<bean:message key="feedback.rule.to.target" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
									<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
									<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:when>
					<c:when test="${param.ruleType == 3}" >
						<td class="thead" align="center">
						<a class="TITLELINK" href="#" onClick="sort('rule_consequence');" >
							<bean:message key="feedback.rule.to.target" bundle="ruleMessage"/>
							<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
								<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
							</c:if>
							<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
								<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
							</c:if>
						</a>
					</td>
					</c:when>
					<c:when test="${param.ruleType == 1}" >
						<td class="thead" align="center">
						<a class="TITLELINK" href="#" onClick="sort('rule_consequence');" >
							<bean:message key="feedback.rule.to.perent.node" bundle="ruleMessage"/>
							<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
								<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
							</c:if>
							<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
								<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
							</c:if>
					</a></td>
					</c:when>
					<c:otherwise>
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_consequence');" >
								<bean:message key="feedback.rule.target" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
										<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
				
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_consequence')}"> 
										<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:otherwise>
				</c:choose>
				<td class="thead" align="center">
					<a class="TITLELINK" href="#" onClick="sort('description');" >
						<bean:message key="feedback.rule.description" bundle="ruleMessage"/>
						<c:if test="${('desc' == sortOrder) && (sortColumn=='description')}"> 
								<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
						</c:if>
						<c:if test="${('asc' == sortOrder) && (sortColumn=='description')}"> 
								<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
						</c:if>
					</a>
				</td>
				<c:choose>
				<c:when test="${param.ruleType == 5}" >
						
					</c:when>
					<c:otherwise>
						<td class="thead" align="center">
							<a class="TITLELINK" href="#" onClick="sort('rule_source');" >
								<bean:message key="feedback.rule.source" bundle="ruleMessage"/>
								<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_source')}"> 
									<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
								</c:if>
								<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_source')}"> 
									<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
								</c:if>
							</a>
						</td>
					</c:otherwise>
				</c:choose>
				<td class="thead" align="center">
					<a class="TITLELINK" href="#" onClick="sort('rule_author');" >
						<bean:message key="feedback.rule.author" bundle="ruleMessage"/>
						<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_author')}"> 
							<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
						</c:if>
						<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_author')}"> 
							<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
						</c:if>
					</a>
				</td>
				<td class="thead" align="center">
					<a class="TITLELINK" href="#" onClick="sort('rule_creation_date');" >
						<bean:message key="apply.rule.list.col.date" bundle="ruleMessage"/>
						<c:if test="${('desc' == sortOrder) && (sortColumn=='rule_creation_date')}"> 
							<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
						</c:if>
						<c:if test="${('asc' == sortOrder) && (sortColumn=='rule_creation_date')}"> 
							<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
						</c:if>
					</a>
				</td>
				<td class="thead" align="center">
					<a class="TITLELINK" href="#" onClick="sort('status');" >
						<bean:message key="apply.rule.list.col.status" bundle="ruleMessage"/>
						<c:if test="${('desc' == sortOrder) && (sortColumn=='status')}"> 
							<img src="<bean:message key='ui.down.image' bundle='jobMessages'/> " border="0">
						</c:if>
						<c:if test="${('asc' == sortOrder) && (sortColumn=='status')}"> 
							<img src="<bean:message key='ui.up.image' bundle='jobMessages'/>" border="0">
						</c:if>
					</a>
				</td>
				<td class="thead" align="center"><input type="checkbox" name="selectAllRules" id="selectAllRules" onClick="selectAll(this);"></td>
			</tr>
			<logic:iterate name="rules" type="com.emptoris.spendmanager.rulemanagement.bean.RuleBean" id ="rule" indexId="ctr">
				<c:choose>
					<c:when test="${ctr % 2 == 0}" >
						<c:set var="rowClass" value="trEven" scope="page" />
					</c:when>
					<c:otherwise>
						<c:set var="rowClass" value="trOdd" scope="page" />
					</c:otherwise>
				</c:choose>
				<tr class="${rowClass}">
				<c:choose>
					<c:when test="${param.ruleType == 5}" >
							
					</c:when>
					<c:when test="${param.ruleType == 1}" >
							<td><bean:write name="rule" property="condition" filter="true"/></td>
					</c:when>
					<c:when test="${param.ruleType == 2}" >
							<td><bean:write name="rule" property="condition" filter="true"/></td>
					</c:when>
					<c:otherwise>
						<td><a onclick="ShowRuleDetail('${rule.ruleId}',false);" href="javascript:void(0);"><bean:write name="rule" property="condition" filter="true"/></a></td>
					</c:otherwise>
				</c:choose>
				<c:choose>
					<c:when test="${param.ruleType == 1}" >
							<td><bean:write name="rule" property="target" filter="true"/></td>
					</c:when>
					<c:when test="${param.ruleType == 2}" >
							<td><bean:write name="rule" property="target" filter="true"/></td>
					</c:when>
					<c:when test="${param.ruleType == 3}" >
							<td><bean:write name="rule" property="target" filter="true"/></td>
					</c:when>
					<c:otherwise>
						<td><a onclick="ShowRuleDetail('${rule.ruleId}',true);" href="javascript:void(0);"><bean:write name="rule" property="target" filter="true"/></a></td>
					</c:otherwise>
				</c:choose>
					<td><bean:write name="rule" property="description" filter="true"/></td>
				<c:choose>
					<c:when test="${param.ruleType == 5}" >
							
					</c:when>
					<c:otherwise>
						<td><bean:write name="rule" property="sourceFilename" filter="true"/></td>
					</c:otherwise>
				</c:choose>
					<td><bean:write name="rule" property="author" filter="true"/></td>
					<td><fmt:formatDate timeZone="${userTimeZone}" type="both" pattern="${userDatePattern} ${timeFormat}" value="${ rule.date }" /></td>
					<td><bean:write name="rule" property="status" filter="true"/></td>
					<td align="center"><input type="checkbox" name="ruleId" id="ruleId" value="${rule.ruleId}" onclick="javascript:updateSelectAll(this);" /></td>
				</tr>
			</logic:iterate>
		</table>
	</tr>
</table>
<br>
	<table class="tableWithoutBorder" width="98%" >
	<tr>
		<td>
		<c:if test="${!empty rules }" >
			<jsp:include flush="true" page="/jsp/jobcontrollerui/paginateListPage.jsp"/>
		</c:if>
		</td>
	</tr>
</table>
</body>
<input id="isFromSearch" type="hidden" name="isFromSearch" value="<c:out value='${param.isFromSearch}'/>"/>
<input id="clearSearch" type="hidden" name="clearSearch" value="<c:out value='${param.clearSearch}'/>"/>
<input id="ruleType" type="hidden" name="ruleType" value="<c:out value='${param.ruleType}'/>"/>
<input type="hidden" name="sortColumn" id="sortColumn" value="<c:out value='${sortColumn }'/>">
<input type="hidden" name="sortOrder"  id="sortOrder"    value="<c:out value='${ sortOrder }'/>">
<input type ="hidden" name="AuthCode" id="AuthCode" value="<%=CSRFHelper.getCsrfToken(request, CSRFHelper.ACTION)%>"/>
</form>
</html>